(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   2823689,      50461]
NotebookOptionsPosition[   2815469,      50199]
NotebookOutlinePosition[   2816134,      50222]
CellTagsIndexPosition[   2816091,      50219]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "\"\<Global`*\>\"", "]"}], ";"}]], "Input"],

Cell["Run this first to set the correct working directory", "Text",
 CellChangeTimes->{{3.7530216362804117`*^9, 3.753021646187702*^9}}],

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["FIG 6. Available work", "Title"]], "Title",
 CellChangeTimes->{
  3.752283630003894*^9, {3.7530084239735084`*^9, 3.753008427192375*^9}}],

Cell["Compile \[OpenCurlyQuote]avaliablework.c\[CloseCurlyQuote]", "Text",
 CellChangeTimes->{{3.7558742983873234`*^9, 3.7558743053565836`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Run", "[", 
  "\"\<START /B  gcc c\\\\functions.c c\\\\avaliablework.c -o \
c\\\\avaliablework\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7530058796406336`*^9, 3.7530058892043753`*^9}, {
  3.753005923395511*^9, 3.753005978119892*^9}, {3.753023544676735*^9, 
  3.753023588790835*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7530060049664445`*^9, 3.753006047345986*^9, 3.7530222000988255`*^9, 
   3.753023488842669*^9, {3.753023547833312*^9, 3.753023589978416*^9}, 
   3.7530252570659323`*^9}]
}, Open  ]],

Cell["\<\
Create a function that runs \[OpenCurlyQuote]avaliablework.exe\
\[CloseCurlyQuote] for a set of inputs and sends the output to an \
appropriately named .dat file\
\>", "Text",
 CellChangeTimes->{{3.755874583020319*^9, 3.755874658466021*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"avaliablework", "[", 
   RowBox[{"asteps_", ",", "ksteps_", ",", "maxn_"}], "]"}], ":=", 
  RowBox[{"Run", "[", 
   RowBox[{"\"\<START /B c\\\\avaliablework \>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", 
    "\"\< > data\\\\avaliablework-asteps\>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\<-ksteps\>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\<-maxn\>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\<.dat\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7429167618798914`*^9, 3.74291678811688*^9}, 
   3.7530060679262705`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"avaliablework", "[", 
  RowBox[{"101", ",", "101", ",", "20"}], "]"}]], "Input",
 CellChangeTimes->{{3.7530061856262674`*^9, 3.7530061940336256`*^9}, {
  3.7530084000959377`*^9, 3.7530084065495377`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530061954710593`*^9, 3.753006333798256*^9, 
  3.7530083975173216`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"availableworkplot", "=", 
  RowBox[{"ListContourPlot", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<data\\\\avaliablework-asteps101-ksteps101-maxn20.dat\>\"", "]"}], 
     "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", "\"\<\[Alpha]\>\""}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.7"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"BarLegend", "[", "\[IndentingNewLine]", 
      RowBox[{"Automatic", ",", "\[IndentingNewLine]", 
       RowBox[{"Ticks", "\[Rule]", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "}"}], "&"}], "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "0.05", ",", "0.1", ",", "0.15", ",", "0.2", ",", "0.25", ",", 
              "0.3", ",", "0.35", ",", "0.4", ",", "0.45", ",", "0.5", ",", 
              "0.55", ",", "0.6", ",", "0.65", ",", "0.7"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<\>\"", ",", "0.1", ",", "\"\<\>\"", ",", "0.2", ",", 
              "\"\<\>\"", ",", "0.3", ",", "\"\<\>\"", ",", "0.4", ",", 
              "\"\<\>\"", ",", "0.5", ",", "\"\<\>\"", ",", "0.6", ",", 
              "\"\<\>\"", ",", "0.7"}], "}"}]}], "}"}], "]"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
       "LegendLabel", "\[Rule]", 
        "\"\<Avaliable work\\n(\!\(\*SubscriptBox[\(k\), \(B\)]\)T)\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Contours", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "0.05", ",", "0.1", ",", "0.15", ",", "0.2", ",", "0.25", ",", "0.3", 
       ",", "0.35", ",", "0.4", ",", "0.45", ",", "0.5", ",", "0.55", ",", 
       "0.6", ",", "0.65", ",", "0.7"}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.745170437409727*^9, 3.745170469288349*^9}, {
  3.745170502838661*^9, 3.7451705114177127`*^9}, {3.7522416415608087`*^9, 
  3.75224164857718*^9}, {3.752241710443138*^9, 3.7522417530883503`*^9}, {
  3.7522417838571777`*^9, 3.7522419569068394`*^9}, {3.7522421392519627`*^9, 
  3.7522421484560685`*^9}, {3.7522424805052614`*^9, 3.7522424819272833`*^9}, {
  3.7522820612890315`*^9, 3.752282098902404*^9}, {3.752282130718321*^9, 
  3.752282197756653*^9}, {3.75228288055737*^9, 3.7522829368133497`*^9}, {
  3.7522829753064556`*^9, 3.752283034453365*^9}, {3.752284261383704*^9, 
  3.7522842637743244`*^9}, {3.7522843567844424`*^9, 3.7522843945540047`*^9}, {
  3.753006354737986*^9, 3.7530063912418747`*^9}, {3.753006439309471*^9, 
  3.7530064700315294`*^9}, {3.7530065249904566`*^9, 3.753006598060711*^9}, {
  3.75300838587551*^9, 3.7530083872975283`*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[
    GraphicsComplexBox[CompressedData["
1:eJx83W2M7W171/WxBYkEbRNqYnsrKSqUWFoerGiAdNIXNCQFW2tqKrG2lqeW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     "], {{{
        EdgeForm[], 
        RGBColor[0.148, 0.33, 0.54], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxMnXfc1+P3x+/uu7rHZ9Q9isLn/qwm3dmbZG9fI8kmO3uXPROJSpIkK3tn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           "]], 
          PolygonBox[CompressedData["
1:eJwtlmmUl2MYxp+ZqalMs0/TZG9azPzn/3/ft8XaVGRJZa1pQiQiznEsk0OK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           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.29574876948418094`, 0.40764333751840226`, 0.6452147808783091], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNnHe4VcXVxs/t7Vxuo1hIMRZuOefsA6KAYAc1thhjifRiF0UldtTYu1QR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           "]], 
          PolygonBox[CompressedData["
1:eJwlmHd4VVUWxS+BJIRQQiAgxVFEvyHvvXvPU0AFVCwIqDAKFhQLBBvOjMLI
CDZEEYQEUZo0UdSxK1jG6Soo6kivAgJSJTRpCgEUcH5r1h/re+udsu8+++yz
z96nRb8BPe/LiaKof7UoqsHvwgReJ4pm1I6i+fAucRS9UjOK7iuIorHwXako
ep0JA6tH0Q/ww4yZxfhtjJ8H7wMWFSII7GD8EjCLuUNqRVEt+vqGKNpej/Hg
NvjpYDbzH6wbRWfAW4AhdS3zCON3Mb8QWR2Zvxnej7Z1/N8AUvBu4BJ4Id+/
Br4MPMjch8Hb8G9L0UFrA5fDa2SjaE7DKPoM5MGvo60vff3AtlZR1Jvvr0a3
WuBG+A9gU4Mo2gKOwZsjs06hdZJuj2OD49jjJBiErC3ImBRZpmQ3Z87drOds
5J0G/545J1nLcXCz1sL/C+EdwPTYNpPtNOZW+m9gTk3m5oE0/AbaetA/iv4e
8MsZP5H96YONx8Dvpe1tbPEumCH7oUOMbmXo0xu+OxNFU/NYbz5rgxfKXsia
zfylzC/lG+3R93xwFnwE/bWRdSnf7A6/BhkVqDgabGKtW1tZdh9wLX3VmXM5
cx/C/isZX0ZbyLEO0kV7pL0qACMlO7FvaA+7wj8FLzJ3Ff2fwF9C3p/rR9Gb
RdgaXkRbOePnoG9d+Gzanqd/Of1Tg20oWw6gfyJ8Pfp1Rtci9LuS7x9lzmD0
uxh7Xs34LbStq2afvp+9fAebrMI2L2HTk/DJjJ+GLs+Dr+FXy8bIfpn+rvDy
lPd+AefhCLyTbIC8xaAL/EJklGLvw2BcxjIk627WuAB+UD6Gb50pHws+czp7
0zUmsU1l24msYTNr2QhGwcvB1fS9lHiv5fPy/VMS+1YWlMCbysbYti74DXwu
2M74ZuAZ+BXIqKezgbx1yN5Qat2nsKZN8C7oFLDVMXAlfD3Yia67wQH4Tcho
jqxK8Bl8BzYowxZpgslu+B5kJMjKgt3whoyJ0S2A9dhvJ21n0ncj36yEVwv2
vT+ynl8Z+2piXxoCliZes9Z+PeN7wD+n7fvajiFVic+szq7OTAa+im9U8K3R
oGdiGZL1DnNmwq9P7Gu1QDn8jMS2UoxRrFnTyrGjPd/8Bj6RPayOf1QDl2Vs
Y9k6AY3gK2L75mH8Yxl8dGJfXwkq4D3R+YZqPkM6Sz8mtp3WoLX8CZu9hj2+
Zcxm+qfzjRp8axl4Ef4ia3oNX38DDIO3AY1Y61ZwK/xR8Cp9a/n/MPy+4L2b
R9tA/U95b7VHg+CP0faXIsucAZ/JN1bk+wwczXiNWmtb/Pci+GuMeZzzNhxU
6GyCfOYWgInwb9L4bW4U3QkGw9eCm+G/Zf75zD8X3JTrNvX1UUxEv0pQFhzT
FNt0xovhbYPvii3gFng9+XCB97Q+/J+KN8Vw/HE5fCm4rNht6ssB5+FP7UAr
eGXw2AZgp/yDPW0X+cyuhp9E5h/qeE5E/xrQlLHNwbpgn5Rv/h4sgnen7QvW
/jP6DYDP05ng2y0Z/zm8nPUuyXXMHQPfRtsd9Cf0b4efSCxLd+4r8I2ljlWK
SYpNJxnzPnfVbFDIfbUem/VHXhvkjUrbp//v2/hrL3g7vtGKvlsYM0S2156g
2xrwEHwlbXflWsYaeMz4ufAqzuvX/F8BevP/Gf4vTXuO5spHHoG3Zvxi+quD
s+H/Zcxhxs7hfybjO1J35Sz0PR6sg3SRzPPo/zdtnVl/J7AseE+1tyWgdbBP
y7cH4V8vwxem/a12fGM+/F4wtoZ9aDn8DsZ8UOScoh+8gm9MybOOo+HtM/bd
1mCT5vI/lWcbPQu/InjvsqArfExiWyqmjdVdq/sX+SvAlGCby/bngg7MfyZj
31aMV6yfAHLyfWYnwycpHhVZhmRJB+miM7JOZ4W2D+n7CAyHJxnbspwxw+Ed
M/6WZEr2CFCR5z0L8NXMaYK9u2PPj+FL0PmeOvZh+fJ5xKBmxKLtYKjiERhf
0zmDcod9zNnF/B1gLfwwOAKPwU/BZ0RnRTnQHo0FDeHFmgN/khiyn3hyUEg5
Zil26U65qtQxQLFgGns2EP5x4lj4AvrNgY9Ahwy6VIGn4Mtjc53xlfD8tOdO
Af3TviN0VyiGboO/gw7j6vsMjlcukDi2vwX6w48x5gS6/QKGod/k4FxBMUux
qxnoX9c5xz7G3x8cyzriD9fAfxfMH2BMS/jTie9O5WA3Kv8K9p1zwCHF7+Dc
Qns+SLFYPo1+f+X/CPgTwVw+K9+tJfsyvgvy83VWY+dyZWA8fCF4r8A59HD4
C4x5vcgxfmhwTqTcSG0z4bOCfXUG33wPvjexrZWDHtBdRFtXeEO+WTs4Jio2
5urOhG/Hp67F13qAUfCRGfui2tTXBh2asz89+b+T//9gziXFjrmL5T+0raRv
OXgF/n2wL91O/1b4HtrK8n1GdymWJM6F5LPHlQ9lPHepcjB4FfgK/gW4OHab
+nQHT8u45lDtoZzmIHwYYyprWsfz4ang3Fk5rXLb3GBbK0dVrroqca3Qmf81
+N8pdm43E+TEzgGVC6oG6hy7TX1a47GM52iubJoHnx+81mnY/0t4CI5t2mPt
9aXMn1DTa9LaRsbOFdLgSXi34FpIOapy1XLaJtX0nAr4VNrerO0cfzr8CDK+
zPeZvoT+KbS9Qd96/PMu+AWxZcvm7VVfZLy3igmt+f806Fvgb+hbH/H9wfWd
c38YvAatRTn2+7rruYMqSqhtGpG3wU/Q9h6x/hHa6vL/zsS1mXSUrmWqwQpd
M7WA38EZnkPuMYbzfBe8NnMeLfEdp7tuAW3t6atBzFgET9HftDHnkO+dDj8U
fHceBVU6S+CB+vbBv+k+KXUtp5xTuWdH1jQv3zaSrXKR8TnfmguqwZekrYvu
FN0t+4Nz233gR3hfdF6I7ovBhMR3ou7Gp8EyeENklJe4plRteU7GuuvObwOP
stZV36yedY6mXE05TzvJT/tuG4BN9qac4ynXUw52CH4gY98/ynnpBJ8WfLan
g6/gZybea9lYtpaO0lU1y6TEMVOxcyHyTyK/Q+zaTzH3otgyJbsK7IM/l7j2
WIKMiaoVsGEv7NkSe+6An8UaTmc/doL28P8E3z1PoM9bipeSX2CfWg1fGzs3
Vpv6JoGB8Atomxx7T7W33UAaPgUdjuR5z/bDx8Wu5VRzqfbSHM29CGyAT4vN
LwYb4YvA+wWOAU/EfrPQ24W+OUH1euy7UDFVsfXC2LWv5mju3oxrNekgXVqg
07WNvMclWfuMfEdnoJH+Y99F2HYqNr4H3pS2x0rs06fA24LKxvbhDPxssLux
2y6QP5e6NtIbgt4ScrJ+m9Ad/KtyE/kLfDPYC+9A/3bm7gLnwNuBHfDTQAJv
mTWXztK9HhiKLsNAM/ipWdv6cf7/Bn5l4tpebwB14K1oa9LY32gtWaB7I7fF
8FGJayW9CehtYJPumAbOIVbC/64YV+wYolgyNmXfmw8Ow7+L/ZajN48XYteA
qgV/AY2R911wrq0aU7Wm7kDdhaoZ18T2efm+cugF8MZZxx6tsYlsG2wr5SjK
Vb7VHd/AOZJyJdlAtriKNTXP2gayhfasPrw06z6tWWu/Pbg2UY6mXO0T+Xix
awLVBqqxVGvpzWgwvG3Gd+N1oFK1VHCupJxXue9zoHexcxblLrqDdRerhssq
vww+S8oZlDsoJ1NupjVsCI65ir06g2fA3wiuxaTTp/C3wbP1XYO8q9idOBfS
naC74YPg3FoxU7Fzc3CtsgdshH8W/BYhHb+Ab4p9tvSGoLeECcG1pL6hb/VS
vlTPNcZN8CXBub184F/wU5nzay3H0NsS20S2UQ77VMZnRmdnOnge/3g45bdF
3QFl9D3I/wy8H207U87BlIvpjfAq5U9Z1xq6g3QXKQdVLvoJ43+C/yjw/wDY
r3o3Za43h0fhP6c8VneS7qZBaeuiGkm1Uu/EvnkCNIPfkphrTVpbr1K/RShG
KlbqDUhvQYoJVfA7kTEX/ilowv/xGcda1SCqRfQmqLdBvbFcBr8t7bcT1VRf
pn1mdHaUwz6l95SU7wq9ETwEP5SybK1Ra1WOq1xXb24H0eeRlGO3cvSh8G60
Tc3xm+h38K0p21ZtAzQ3uNZUzFHsUU6r3FY58qm6e5UD1POea+9HBtcuehPQ
28Ddad+NWrPWHgfnlppzPfyrtGtN7WmftO8Y3TV6Mx4H/x8oc4f8
           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.4145812824746829, 0.44940556253103875`, 0.5753579681298989], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNWgeUFVW2rU7vddPddDcZxoCKDi9UlQpIMAAqQcKgTtAZRAREQXIc/4gS
JBlwVCQjooIIqP/7VRTFgDqGAYERAYEmS8aAYkb5e7t3r/XXenedqrrppHvS
fWf1HnLt4NwgCObnBQF+wU3Vg+BGtHRZEJQXB0H7akFwJdozRUGwtzAIdrvt
RFuGb4vyg+AJtMEFQfB0kb5Xum1De6pI4/id/WdEQXA51msQ6b3SY1aHWAew
JeBIwKfxfTjgaM4v1Ldu6HsSzw8C3o735/D8DNrn2H8l9n8Z7Us8v1ag9zfQ
vsb7KsCFgAvQbsPzFdkgaJ4IgulZrU98uN6d+PYC+scCHsfY1wu01njs9xn2
WQt4V1bjxgF2xrza4NFVgK+BnumlQXA40vyXOA9wMPoWFYm2hzF/EdaZBngR
mH5bThA0BVwPxv8HbR72/EeR+E2+v1oeBK+gTawIgrI4CK6BXKoDfp4JgrZY
uw1wyKC9iL1SgIsxdyvW314omr/Ceq8C3h9rrfsA3wT8BrL9Fm03cL0Wa1bg
+2GMPRPtqOVJfg3E3FFYcynWW442Lh0EFwLfE6kg+HuRvj2LNgLPSwo1bhie
FxfqfXg1yZjyHVlNesD3McB/MdYfCTi0mvrJI+JAvlEGozPix6aMcKJs2Tcp
IZlMSUj+lBt5Nsw4EJfzQFd9yOUcwHPRGuC5MeA14FFZEusC1sO3Lti7DuAg
rPck9hgCuDMp3aPO/YBxhXh/DHBESrSTB8MKNJY0XB6LnwMBSzG2OCnZUC+o
H3UBu4bCtUaoPo5pDXgz5H8L2lycu96RztvZgNvQ/2lSuvJUod75PAvj5qD1
wZwTwCmB7wuyWq/Iay7zmdiN961oW5LCa0kofA6ForHSdE4FPYXQvQcBZ6Pv
DvBvBmAZcLkC49uhVRQLdkBri/0uxz6HM9Jj4tUBcBPWeBz8eAxtFt7HYJ15
oc4AZXc3YGWoMz0zFL/Jd86hLo2yPrVH32bg9iv22WlbMCfUHM59JNRaK60L
OSVBcAr4NUOrjnkl5h15Vt3PNYuFO89pY+tDJhJvNllmuykb9B8GDELxLx+w
3OtwPerOdvOV+1RLClfystxj9jUGrljiTyntXeIxi6171MF7oSsrcA4Xx+Ij
+dk5q7P5ms/nBPQdArwV8CT6dmDuT4Cn0Hbh+Vme+6zwJL4jgHtr0HVpsXjH
PZcDFoQaz3lDC2SvaasHYPzj4Ocg23aezdF4blgzCK6vAfzRLiT9kEkU6mwT
B671L+Ccwjo3ZqS//dDmBzp/5A/HvQQ6jgL/l8vVT1u3IJBt2Go+VgtlP7qE
4scxjD+C1tF2nvb+KOTUAzaqXqz1uO7hMvVvsSwmwT6+ju/3VMhO1yuUr+qH
ubvAj3mAy0HfLnzbY99Vwz7q3Hz5jHPQNmLcHbDhebHG1kSrjfYYvj8LPVsf
aU65fds+tLpo9W0H/6tIusy969hP0r/QRvFM3hWK528B3oK1dgC3WYC9sd9B
0HRzrDm1jOMu8Lc/ZNUqK5k9YZs8GXM+BD6vAG5FmwicdwB2xxn8fb5oog8o
Q6tAm4u+ndhrNuCXkfx7fey1w/2k87D1/zT0n4m+vhhzGuCaUHSOC3Weea4X
htJ56jvt08UJ2cRLE7JBhCMK5Hu+AC6vFMifjbGt/n1WNj6dlcxX2M9x3DGM
XwF4JJR9fgZwL8a1p14BTg9l6+cCnmV/Rb91d4V0bWW5bMPnlmsWc74BfB+8
vA027gHY8I4p+RD208/z3E2p0Nl7F+OO4NtbgJMyomMH4PpQ56Q4kq5wfe5/
mWMJxhTUQeoicVhaJP5Sjx7Nyj7Mzyqm4J7feF/64dXlpjlfvny+xy8C/Gue
5HmOfeBR7009aJGQXtBHXZKQP6BNuiyhb5QF/QLl0TIhn0VZsRUk9Y240w7z
eWZWaz4M+DZkfx1swDux3vm9dVZrJZNag35kmX1NbihbemUoHNokhAdtJ+0b
7SD9PM8NfT19+WHLbzzWvQtjxgJuw35XY98tsfwl/eY1tPnoa0dbm9VaXJ/7
tDIPWngP7tXG9HP/Kr4QcmzHrHwwY6iLTUuBfWGl9TlpnpF3S4p0lijLKx0n
Ml7cBR1aA5tWmRK+16JNhuy/g44xkP4e8M/4dk0N2SXy8j7AaRWyrfcDTq3Q
mNNrahwb9YfjuRbXvBfwVFr+dSbgJcWKqxg3XYznIYDD0DpCL0cBlgDmwzYk
0Fp5LPnO8S3wPhDwIsAA/bkleibkHPbfE0t/pwK2jnU++8WyEVclZQ/pY7gn
fQ7j1kfzFavR99Ne8b2ubS3H82ySrm6gp3NSfbVtN7vivZu/sY/vox0rMmak
nebZp80dCNoOYe/Bkewm7eccwDdixchLAJuEWu8g5Pw0+laArtsj8YnxMfGu
bVq4H+nqkNT7xjzRQPz5vMnvnEM9IL3bbTOpD8ux3wPYd0YsWf3F8tpl+va4
1bWveDeWb11t21vT9oE01/e4XyHjj7BvP+jn6FDx/B2GZY7t/1hD+nQm9GYI
aDsIPgyIJPPCEunIt1jnFGzdNMA3Mzpr72SUD52Xr9yArVG+bPRS7NEJ9B0I
FffRl1XFfISMCx+3HlIfR2Gtp5ivZKR3tHfLHU+0xP7Ni2W7acOPhrLrDfNl
47jf2fn61h/z12HNHMA03hujnUBrUyz5Xwb4kPlMfreJFOu1j9RH/Sa9I4DT
DNA7OK29iUMeeHHMcS/jX+rqRutrVVzLOJexUHPHkD2Nx3v0A1irJ8YfTAsf
6iVxYszZzDSmnGucZ3zYT5y2wy5MAz7908pzmCvUyigfZC7Ic1gaac1OkXhf
q1j5yMRYcc4iwCkZ5azbM4oPGCeMj6WT1Gfq5Y14r4/vN8WKAamnlElN56bM
RSZEOvN3OhbgXjWKZSMG2zaQj7QT/DYEa/2ANbvGypU+K1bcvBttr/Ec6tyW
88eCzgtA74+gO+1chjkN/T736VhNOkpdzQJWc0y2LlS8uNQ5I2Ofjkmd+wZo
f0gqnnsiK7v8LeDPWfmeX7LKh+ah9c0RD+s4r+PZZh7O/GOCYxjGMjznzN/Z
x3mPot2KuQOci9AXLszKJxwH7A56BqD/QGPFmqXOA/ZnlYNOyioOLXbfWNcQ
6N8+A0+uh/7sSMtm0H91sL1jDsP8ZaRzZOoM7QDxZR9xIU60P50ggxCy6BDL
vj7mvkdD5bs7QtVTfvNLjJlTyi1vSMlfct89WcmhlmWxyTljse0g9+1qO0ga
+K0okp7mR7ID1CeemZ3QxZHYvzIjWbW3vOaYb+Rf50h52fhIdoJ5B/OPoaDh
e9AyONZ+pJX82FesXJlnaVhG+WEFYIdIPqot4BTznLynXpVbh69OSk+oL9SB
jj5LXfCtU1Kx+KGsxjUFf1qEGjs2lDyoD6S70nkBfQ3nkbZaziXqOab/zHpZ
zzF6Lc8hjytso+tZb7n/Yud6k2K9j0tobdqcQbY7fGf809ExLvl5PuDEhGLi
CQnlgcwH+9iH0B4yhhjvWlNVjv2ya1+tfD55NseEirv+HsoP0jZy7w9cc2Pt
bXJC8Tr3pC87o6b8GWnpYh6uiuXDNwNmQ9F6Qai+TuYVYxnGNGcB7ozlo3YD
Tk2oJsV9FrjOwHrDj1npIuPHiZHs7BTA3ThvM3A2/5jSOVnpWtwEx9BRVrxk
vEzesb7FmOmNcsVYjLUYVzPWut7x1krH54xHJjrG4jzGXd0cex3ICtdmgJP9
zG/LYq37cCwayCfqEyHlQ3mPsB+k7V1kGz4F8BnP5Rr3ORakD5/iWhbpaWE7
zPPG9ZgPjPO6fK/SnbusP1V7s59rMn950zy413zgvHGee5/7V3sM6Wfcyhj0
LXxbhXZxVr6GPufOUDFJ81CxMPM75kJ3I9fshtywK1oJ6OkEWMSYvbry0D+4
Rsla5fZIdeTv0LJoJRnZgeGMvakb+FYjFu7Ejzw5He+3YO4JzP0YtnMD2nzM
qYbvV+F7DNi5up7HYr8u1bXnBDxf4byV+esneZq/wHaH8f/wAo0b53m/KxOe
p5epBspaaLlp4ZoNynTO3i6X/vwbNvVX6OQHOcothnvdtXgPctQ/33Vm7r3Q
tdTNpAF7fgz/uwEtVaaaRk+0m9Hmom822uuRxrwBmHGNlmMvBU4NAWvFio0Y
IzGOK3cMxliMOJ0EGu/lqFbC9RsAHk/JL9M/R2Xarzfa+FLJknLchjHvYt7G
lHLic50XE+9PTEdzrNESLQ/vp2GdM8rEL8qKtJGGqbZJ1CfS1qu66OhlWmeU
6rlPdfmzKcApifWSaeFEHswslX/gvND09/Q691sWXP8C0NoE7ZdA/DjPPKna
j3MXuI5NGh4C7v9E+1eO4uRLHPtQhpQl/dkQ51RVsWMBaz6OqS9zfPQ/JYqF
nivR3h9ivffR1jmfWlsinaDOMd+kX2PtaA/gRyWKHbn2IdB8E/C6PS2ZJ6wb
+c7baA+ujhTPdYm0fv7/24PwtxzOukcd5F770f4b32/ME18Yy27w+vmey3n/
Rvs5EO7kCeMv1vZYg036rPHMzY8U8w2KZJOOOYafZNyI4zTzlrUKxkrUlWa5
wuEG40Fa+V6FD3EhTYyPznYeQv39yTrMc3bSZ+2eSDL4cyQ5N3LucgX09R30
f5rSea1XpjMbeD7PI/f/W57mEXK/Rn5uZL25wf3Es3+OcG+SqzrCSOvHzynp
/9eA03OVF/QgfRnlNSPTutNpgTYwR/rGftbkDqdUs++VkqwLLY/cPM1hvYAx
KPfkWZ1gO0p72i4lGW8F3ASf2ALDtwD2SGmfm1O65zph/efZoL09UaZ+1l25
x9W2Zzy7HWPZgqti5XqsWTLfu821XN5JfWTdnwMc8vOEK/O01a5Z8Yy+7b24
ZyJP42iveZ+QsP393naM53JNieqWjAu/8/wf7B/Sxpnnf631kzV01tL3gN6+
rv9eEks+OXnKb1/1PRdzSu7zjW3G/lC5z6JQPpw8Yvwxq1R4kD7mUrT9rCd/
gb1aYb1vUvKFpIn4MGcsyJOdog8j32irqAv8TnsYZ7X+xKxitCO2j81tL4kr
71WzntvI+S9xXu81uFYf28xZ9gfrfF5X+R6TdK63XfpPiWzuBp+jht6X9Zq+
trGUHelcY7tDe9kM7VQgH07/x7xxUCxa2wK2jHWOesSaR5tNmdWyD2oTi5a0
ffrGjHzeiIzOHXX1Ijx+GisW/CKWL6efaBerbsv67bZQvp8xQKtYtTTilZOj
Ots/XDf/wTznXvRZne33E5gzhroZywb/YrqaGPKdsQl9/V2lOlvUG+pMh5T3
SYkfOd6b/c2tW7RBtEX0iwW22fQLH2R01kLmo5YFfcb+tOrQ3TPKzVkj4/fr
MvrO/nauqzD2vS5P9pJ13b/aTtDvMt5l3Lu3seI3xv8rHJdT1/ne3baHtf7e
jiGoL+2d+7DOzjsM3mUUxLLxP5sn/XznyLvM9T4HpO0V1+pp37+2rRuQUi0q
xzpKnZtXqnmTXV9inenntGKFALR+ESke+J3j5FW+B2CsQBtE+3MMYx7BmFcj
+XHiRfwYi1Af65bJJ/3o7+fbF1zoRtveNJCPurNU+jDOMTPzgc3gXXP0f9JY
tuUH6w/nBNZPNuoq7SlQ/Q0P7pVvvfok0nd+Ix4fNxZsnVL94znHATk+X7Rp
XZ2/MI85aTyJ7wHXTxg7sO631HWbmbnyUY/QTkTKCQsBX8C4l0pE16/GmbjT
hz5iv/pVJFl8Dvhiieqi/1uivO7JIsUyrC2yxsL91vo/DJeG+p8CzzXjqudL
pCeMGdqmpPMbG2strkncqctJ6/mDuToTvEfhe4HPxdJYedVrsdbkeoxFFrt+
Tnp/shwpT9JB3/5wrs7COb5PoW2hD6B+3Btp36mR7l54N8a6MOVA/aDvp+2m
DaFvoD2jXWNM38XxAP0o7WJD22T6Z/rDKt/b1P73TPsB+oOvYuW/2wH/6RiV
seoW2zraPOrxIa/5ZqSzsSoSvUMsg4PGiWvm2j9y/xti6XizWD6H39iX8r0Q
z3UP2+GmsfroTzl2T6w72uOAvWL59J6xcCXOOzx+nX1x0r6CcmINmfgRtybG
gbhQ3ygz1uYoD9q+Bx2/9DRevCdizYn1sWt9b1vN9ZOaronzDoX3J8Mtqzqu
j/SxT6M/Whbp7GyIFBPzfpb1ScZj1CnGZ7OcJ1BHl3ld/g+AsfpTzue2ZVQL
4x0p75JZO1zs+1betXIe/xvBu5+5WfXxzpg1vL0Z5bK831sZKdboFuk+iHdk
w/y/lxH+70sDn1+ehUrXvvZlJKfjzpda+h6N81nHYixO+mjTyGf6rQsjnSne
YzDmJI9J90D/P4m5N/ep5xor+cUzTn8+Ly2Zsl5ex/0cd7vvOJYDDo1kN5YA
9opU224UiY/T7ccH+d7/SduFEb7boA7QllIPeD/Mc8gzWMc1Q+YAs2w3aO94
f8xxRyLdK7Om3DdS/W6/6V9qfIjXW777fj+UzHl3w3riPOsFfcqnkXLSzZFs
HHWRfGL/LMcyO40LcUpYxxlnDvF/eFhn72GdpXxY32VMf6tj8unW6w3Ww4WR
/D7HMHd5xDkodYL7P2gcGGMwRuEdA/+vc4v/8/CO8yfmP8+bh7Sn/K8A875F
kew4+cD4hTafto+2vJPtFGMUzu/umID+mvsRV8Z48x3nHWysmL6Hc/q+pmum
40XGitOch9GmDklrv71pxbW0HydT2ush78daHmtfW2Pd/zMXYE7AfIZ5zfUZ
1di5Vx/XOD6wz5odqM4813nae7bnWyLlLvxvAsc9bJ813/EH/wdC/8K4jL6L
8961zRma0V0i///1vH0I7dIMy+5D5yf9HMMcca2bNW/mxMybWS9ea1xJf6X1
ivr1N+dizMlmu26xznJ7wT53uvlDOexIaa0uKZ0zymqC5UVeU/68q2OclMwo
lmJMwLou+TnK/wk5bn2kfe/s+gttwxjHp+THUftA3u9/73vke9LSr/etv5WO
qxlf846cNbzXY82hD2X9ptBngnWPF40zcWes29zxboH/c1iVfxCSho2xare7
Yt2PUL8o+8GuZ9D2Jn2Pxvm7fI5pw3vbd9N2vGj5cu/zY+k664Vn2S7RPu3w
fQLnMxZhzYp2in7sbNefz/a9IePS2r4j2ONYaoz5lpcWzfwvG3nazXHkAY/j
mD6+x+F9DmP9NT5jzAtIY3/r3wO2yTy7+1xLGZTWedoH+HUs3L6MpSczXAtg
7MsYuCCjXId6xbj8/wA41/2/
           "]], 
          PolygonBox[CompressedData["
1:eJwtmHl0VdUZxS8JIQkhJGDXUmgZ267y3rvvXkYZLEMYw1SQtSzUWlAZloRJ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           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.5334137954651849, 0.4911677875436752, 0.5055011553814888], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNWGeUldUV/WaGmXkzzAwWVFRsMch87yvPmsQKMyBVehezkqWighEUhl4E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           "]], 
          PolygonBox[CompressedData["
1:eJwtl2eQ1dUZxs/2Brs0BUksxBH23n+5xJQZC2UBKQKiFIVgmRFNAkoVpC0I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           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.6522463084556869, 0.5329300125563117, 0.43564434263307866`], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxFV3dsV1UUvvQ32lKUUWgVF6UFf+/d9x4aV8HxhyhQBAeogAMENDiiDFEB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           "]], 
          PolygonBox[CompressedData["
1:eJwtlneMlUUUxWd3gfeWB6x0C0qHfV8Do0gVEzoIglQRkK7RKHXp7FJFRSRR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           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.771078821446189, 0.5746922375689483, 0.36578752988466845`], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJw1V2dsllUUvqX9OimKDKWLVej3rmqF4sCJIxoXAqKWUihKoVpBBS20KMaB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           "]], 
          PolygonBox[CompressedData["
1:eJwtlmdsV1UYxk+hg1IgEhTpoEyx/ztAZEiMJoojGkURULBAGY5WyzCCQgTF
oKKAgKiIGjRxfoMCUmhZCg4QNDKaMPSrMjQyBDUBxN+T5354c59zzrvOu87t
MXn6iGmtQgifQvnQnlwIJ/keh74Dj4xDaM/Bba1D+CUKYV0awldtQtgOPQZ+
jfPfOdsEz1LwWqgF3BYaAR6bhDCqEL6CEMaAm5F5uziEcW1DaNU3hKvhOY58
BbQa/QtYn2ztvfngLtn6D/GAL0MPom8h+i6CN6GzZ1EID7HXCN7E3kFsf8B5
M3gj1IH1YWgb+IvE8j2QaQJvZu9Qvu/YCJ7NnV/MC+FegtIWf76pCqGcWPyq
eIAXw9Oc7/v2AR9Bx2B0BeKR4279cuZtQMdg8EDuOJ675kpCuAlcy14D53M4
nw4ewt61nI2FJw+8ItP/Cv6fBf+JzdXBMpIVj3jfIoZbsLeTvbXo+o3z/uB9
0DrWx1gPAR/hDncQuzncZxJ4LTKvFzuHymVP/P+owDEoBfeIHesm1v3Ae9Gx
Gn2zkD8AromsSzZaWK9HxxL0PYxPAd/mIXMM+RPQy7F9kC8noN3gbal9/x77
M8AdU+eiF9SM/fLEuaslR5XgrlAd+EP2KsDvoHNrvuvpH/AqaHO+/T0DnqqY
oHspNjbqrrHPdKeF4MH4WIOv1dAN4FOxc6mYK/YPQMX5rqEGcD06lhf7jhvA
f7P3Kra3cL4SvKvKsa+AvgU3pratGP8H7hU7FuoR9cqGLF478HFK6hqSfZ1X
gqezt5uzi8TjydQ9ol6pokZuBJdm/SadV0kWnjeKLSPZi9DizF/lZmGWT/VQ
DF5MDu4jf8OhjpFjrtifgjrDf4j1IHA9Mf8JPC712RmoBjwN2oWtZeh/Anwl
dJqz3tBO+Idj405s3Q7Vo39lZHvqp96R93SmnhwFb5S6d/ZAM1PPAM2CMqgT
5wNzrp1umk3Edxw2Rha6h9XLB+C/Fd4S9B0Fd0CmlHU59BnrUnSexbdzUCW4
KPGsGAPVgC/n3IvPQ3PBNxPjqMQ1olrZmvhufaBp4Eupa0c5Vq7roAtFjoli
U4fNdvgyFPsHwXsi49ncfyz4a2ysyXPPqnej2LWk+lsGviJyrDSD2oAvsbeo
wD7L96eQmSt54lEHngq9kGf+88Rnc5bP0fA/Ap6S893WwX+a85cyfukIkWec
7ClH7cDXpc6FZvR28Blk1gfLyNboxPWvHFQnrgnVxjZkJoMnZvFWTYwHt0fn
/egeBs1H/hz65mXxlm/vRs6VeLqAq9B5fZF7fha4LPHs/hibvcH7dadCz9zD
4GcSz4r+rJ8Fj098d9WH3opu2XulmVCb+g3S7FgAjQJ/gs3KrD/01mxPnGvd
QbXzY+JelE8t4POxZTVzNHuqY88mvXlN4F7o65rVn+42VDNS8eZ+EyLPJNXO
m1AT+LnEvaYZPAPcJYvnNdAO1o8nrlXVoGpxQF/PWr0pelv6ZfNN/iwBv5/1
j+6UgB9NPWu+hMrAk1LnSus14H9jv6XKqWbbXvLTPfgfYFDONajaUv4LIs9c
xU81eQH8XuReVf2o10cmfrukT7VSwd49Wf5XRJ4Ruove7E7YL87OVROzsFcS
mVd7OiuMfKZ1B/Ddsf8t1GPqtSp0XC7yzDqa+J9F/y6K+X7whNT/KsqnanNF
pl8zYhV4efZ+6E0ZAC6LPBsVQ8Wya+rZoRpSLekfSP9CelOHwV/O3l/ZfFTu
nk79tsmnOHWPqlfXQKeqPKM0q/TG3IX8zMS1rZqek3hmqXb0hnaOnTPlSja6
gycnrg31uHq9MZtn+seqBVdHfqs1EyeCDybuDc2ofYnfDL0dqtHPOc+L3IuK
sWJ9S86zSjPqh5xrRPb1pjSk/qfRv43+CXbofyNybWvm/wz+H345g8E=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.8899113344366908, 0.6164544625815847, 0.29593071713625846`], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJw1lVlsV1UQxk93RH0wRvtvC91wuefc29Ql4QUXHjUaSetKRWNaRMC2hEKL
S6JxfbCi8UEF6hYxGooRAo3gAljpEgUsLT75oqivLhhB4hL9fZnxYfLNuWfm
O3PmzMxt6V7X2V8eQtiNVCBfFCGsrA5hAFyP9KBPg+vaQpiYF8I+sEghdOK0
DSyxt60qhNvzEE5nIYzB0RdD+Iv1wcoQ/gArsNmMTTk4yvoF9Cr0v9GH0f8F
98M7Bf+H4AL2XuP7wsLW+t4HvojdLwSZwI2cP4Bcx/qaaHoH8TyJ/lRZCOej
D5Wb3VJsquG6m7usKSxuxV+v+JEO9C3gefLHd777jpaZ/1bO+4y7vAG+hRxC
HwFfRQ6gnwFH8VnEOXmytb6fBZexXg/HsWhxbPSYL2PvJ3AY/BW8BPkZ2Zwb
toPfk8vvkPeJ42PiXk783YXfGZnHGQfg/w298NyIU3HU4vcDcjLY2YrhzmR5
1XutgutKvv/I/ufgHLKTc46Ag9juKLP1DfBeD983yc5VnnW2/MWjWrkqmv0k
eLXf56Xc8qW8vQ5+G4xPduPRYlsM3pWcM9pa39vBGu75PPz/4LszWX4+SPZO
eq9F4L1uI9td2NVwVgc4hmzley3fO3PL025wknWqCeFoYbazSBWylvUK7jEf
XFJhe/o+5LU0APZ4/vUOvdTiJDU5Bvaz7uL7p+DF3i/qm3OI7wl8zwU3FZav
DGxERoitwfH+aou13HvkTeLcixzn/Fty6w31yD3sz1Saj+wfI6Zn4H8EfI8z
Woj7bXA2Wew34TcdrYY/AY/gH7n7HYX1tt7tQnA/dnPYd+XGP+tnvAtPE5wX
8X2X17ZqfCbZ+y8HP8rNfp/Hq3pQfc14/rS3zHn3uI32dd47+LfCswPMcqth
1fLN6NXsdyd7N+lzLtLF0eM5U+40RzRPKtXf3rdfgou9ZlQ7Y/5eD4LX+vsu
8ZpWbc+Bq5P1542cv9ZnnWben8y0Z8nho9FmmWbaK+A4511OPkvOqf7agNyX
rH+6wHr2TmOzEhzPrJdbo9WZ6q0PrGMvw+YgehP6GfSFbdbzstf7NcF1K5zP
4Xscu3ZsThRWc6q9VYW9q953AnzAecQXifUU8e3xuDZ4b2u2qPdLyKZotaqa
bfR4FJdmSJ3PkWa/i+4kDuVN986jxan7jfhs3JLb/NIcawF7sdmLze+Z/Rv0
jziVWe2qhs9mxjnovMqluPVGFxDT09gMR5vLms8PoX/NPa8gnmOFvYHeogFs
9Ln6/3xt8Xm4IhnfV8nmne5+GDwaLddLo+VIuboU38ZoM+sQsa2B9zD10N9m
b6C3qE3mp/dRzZU8n/XIVGZ5mwBLcDXDuT2Zv3hWt1luVJ+tPstV26r3ocLq
ehBswOc2uF+O9uaqe+2pJ9WbdZq1meVWOT7hNaxanswslmlwMFoOHwYXeDwl
n8knfS73+v+x2meV5oPyO+UzU7NTcSie5mR5kX+M1hvqkcfB/wAU5i8g
           "]], 
          PolygonBox[CompressedData["
1:eJwtlUlsllUYhe9f/pYm6MIJCoXaifB/k4okunBiqdFIWjVoQYOlVkSoAW3R
jUbUbioajVFRCcYxIAGVOsXQFgutAhYoJi4dt04oUOsQn+O5i5Oc+93hnc77
fk2d97X3VIUQ+kEZfJmHcMnMEKbAwiKEgSSEx0shbAZnpSFkoGVGCE3gbfgc
zm+tDmF1TQiz4bfx7Ur2NvLorfBzwRPcbWNdB58AV7BfjbHj8KYshJ9ZN4NB
1vfyRgXbKRiDT4CL4WfA5/ABzv/E2V/A0/Bevt2F7ZfxoQF+CPzJ2VPgPfhc
zlwY/d3F+9vATVX+9hZ8KNpbyRvDuX2QL41gPnevA0vhV4Pu1BCvxf929t7N
zCfBx5ltyJZ8bGDdybqm7Jwc1duFc6scT2LvSO5YT4Mm9jqVQ3xZAfbBF6f2
RT69Ift862DvKeK9E16fO/bj2PgEez3U6wPq+Cg53wRPwDesd7C+FL4eG2O1
IUxjr7vwG3rrSXAH/ETMt3LalzuHymUCDsNXgS3V9nE1vLVwbXTnmO5i4wfs
zQVjFXLLt+4ax/sVfB4xtJP/fvw5Hz4a41cNGnhrITH8FuvbDH8t5lP1WgQf
ye2LfGosnCPlahHr/fB74lr+dUkbMV+q71r4KD59j291YKTinCv3ykcL/Gxs
PFayZqXdNXwbrXWMivVAtC97a+CzCuvtIGfWwbsK+6Zv2luf27bik7YVg2L5
X4Pwr8FVrK8B1xLv9sz5HQD/wl8Ew9R2H7gIXspdK9VsJ+vx3L2n/KtXTldc
e2ngJLyD93ux9Q7fJqnNjdw5VrYmb4C3gZll+yBfzlTc6+r5Xs5/xvq7YA01
JM6pcisfZ+TW0HTU792FfZbv8vlV+O251zov7fyT2f8R9t+ET2WOTedfygxx
3fkbvi3zWd1R7IcTxyKflsCfY/8kvv8KlmTuKWmtCx+/gF+fedYcBcsy10y1
k0bWwTcmrrdyptyNg3m8/SNYzN5uctIa32/lfjPfvg3WkLQkjUqrmol7Us8Q
1Vua64F/yvmdJd/J4OXYb9qXNi/n/lDZMW7NHJNiUw/thx/izb4qz6AT8IOJ
e/l+vk3ARxP7Kn+G4fWF45NG1SsXpJ690vPD7D8U57n6b7riGa95dAD9roW3
xPPSp2alerQ/6uEczfs4P3VGb2/gvQ+xPQhO8d4zmXOlmb4FPit1bpXjzZx9
Pc6zm7m/PbUGFLty8Be8MfWezmj2LeXOrpJzsIL1ZOpekaZXwR9J7J9myuzU
ENcb9eot9h+ocg3G4UP4OCc4x9K2cqhcbgDLOL88Ndc/amXqnpM+NZOSzD7r
bdnI4c/H+kmD0uL7mbWmf+IgfEf8n0hDl8E7Mv8rXmF/PvXJo371hrTwUeZZ
rp7cA18Q55NmpGblLeqRavfwXvjvFedfPavePS+39nWmDr4gty3N4E3wZ+N8
VUwvwP/gzt7geaF/hzQkLSnnR+Bp1Lfu6G5b6n+7cqrcTlWsLdW3L3GPqP6K
qQJ/MLFv8lFa+Q8hSTu0
           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.9173712216337369, 0.6634280540843422, 0.34385078706458433`], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtlN1Pz3EUxz8/v5+HhpmibDb008Pv+/l+f201ijZ3zIZpHkqZXDQ2JJmN
zYWnrQk3ebjAzBiRXERCeWqpCOVn3IY/QsRcmNfZORdn78/nfM7zOZ+T39C8
+cAU51wLFIfmRs5dmOpcFvgOCqc7lwEHU87N570fnJJwbgzKQMcD51pjvHnn
SkLnJjByBfwHveb9BngV+gm/AtyNrfPYT4CL0anGeTF4BDvPsP8npXIiH4Ed
0DB2KsEB3nKRGQJPI38Wv6fAVdA9zpuwM857B+c7UCc6Q+iWh/r+lbe74Cfk
KrHfALagew5eK5hErhB+IZjL2xn4J+Dvs5gl9j1Q/TRiArtDrcNqsB35GnIp
Bau8xpBB9z5vg8jEIs1T8r0FjnJPU9tucCt3aUIF8rncL+MrD6xCN47u+lBt
ic03YB/yxcTZ49Wf+F0CfhQ/CdUZslolkZ+JrYvYzAbjUBvnXeBvZPqQmQBv
Wr+kb83Yu201lJp9h7KN5DzPaT6S13XkPb7r0LmEry7uo/Bn836b+3b4aa95
Sr4fpA6B2n2F37fcd1LPRrAGuQryGgXDQH29AGdZ/JJHj+X+0GTjlvNfbD1H
/ijyB/HZHtOaNkEr4ypbabN0N9QaS5xSs2vo1CJXiM0xr/bWIjMn0v5Knxdw
voJODnjSZkZmpxv5FLafgvttNmRGym322kOttdR8L/gypTNaiG4ioXO4QnoZ
aM0jsAydX/BKwQKoiHMX9pPQNuJsQyawvyZ/bqHNqszsEDQJfzn8ufj55tRf
T6j/tRr8QhwRvUimnVsKlXDOT2ssUjup2+NQa/PI+hmzWjVav5oi3QuyH0Yi
3QmSj+SyIdTzRvCz1/pnwB1eZ2sbuC5UnXrjNdnMlVruvV7jz7EcZL/InskD
Dwc6tzK/8p+l1xL3A6//V/6x9Cpje6rW63ud17pIfZaBayw3mdmyQP0EgdZC
ajJGXh1W89BrbyTG/kBnXWa+yOsMynxJnimvMy+zPxxoXlvgLQp0f8oe/QH1
cp4E31svpCflXuewE/SB5vUEHLCz8KS+0ifp0YjtPdl/Wba3Z0Q6izKTTwRt
fgqs3hnr0zfbk+MWh8RzCDsfvfqo9rpbZcces78of1b8SU7N9q/+A9u43T4=

           "]], 
          PolygonBox[CompressedData["
1:eJwtldlLVVEUxrf3OkQ0pxYEloJ67j7HEIkmoqciqEiabKD5LcksoaCi4SnL
FyuIimi2TIVm0dJmS0Item74G4IsGqHf19oPC7591jye4m31K3amnHO1UDZ0
JXbuOeBb2rkqcE3i3NZc5yrynBsAP/bORfDKoAj+9Ixz17OcuwbdB9cjswX5
sznOFYCfZIxXh5M+cCn0wZmOdJdgI42/Odh7j+1xwd9GaFixRM7lI/8ZipFf
xrds5N9C98Gn+daErWPQFPRz0O+D9wJqhz8LvhJsgf8MPINv39PGvwpu4ttx
eKuRmYr+4YzZ6sXfAXAu9k7mWDw7wA/4dgP+R/jl4DXo1KcsnyHer6BW8Cf4
VeCz+PiatnqeB/clZks5qrYp6CWxNOMjDd6HziN0u6E94M5Q72GoEv17vMvT
ZjPDewE0iH4KWgyuw8YmbJ/C3khwAza6sPUQ2gv+HVluyvEvuCdjtb3Jux98
y1tv15NTh7caSF4x/UL+cWS5T4B6wLvxsRl/Z/BXCC5GpwbdtdB59dsblr0I
XAmVYn8dbw9uVg1TVv8ibySsnhyFt473Lt5z0XkHzmSsthOhp/i/GuRloxXc
mbFeq0fqlXJUrpqRI7wnIdOYZfbV+7feZk893ACeFuKXvGarMcyXvim3Mm+x
y18JeD/8Hmc2D4FXepv1WdisUWzQ7LTN4CpvO6HdUM/Ggge8yWbxHvTWY/Va
M/qSdwk2C53tgHahy9ssqf8VyP6JzLdi+Ale7q2Xyn8euv34iPOsR+rVj8hm
QfKKfXVsu6SYJiemI13VfC228hPrrfTHgNtCP1WPFvBGb7OnHIfU29j6qxnV
rE5IbBY1k19ii/lr4HfDvxHbvp5A5qbmGxrKtptQDV4UW20GoIXgEWEftS/X
Ytsp1UM363JsPuRrG7QL2YNhv1Uj1arC2yxqxueDRydmWzkq10khX8XwAFsX
YrsV6sfF2HZK+Sje2sRiFta3UYnFpNi00226VYnxlaNu06VwX8XX7neEeFTT
md58fA/7fg78iJjHO7uZvZHdLMUje63gV4nlqpxfC3vbFd3IpbHl+P9WQ3fB
d8L9UI+0iw3hXifMyBvw9sTiV411+1pii1Ux69+QhPmUPf0LtIPaxQKoiFq3
h/2Q/dvgQWxMz7MYFevEMP/yKd+68bqH8jdes+ptt2RDtobC/0U3tZr3P1gW
88E=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9363540511849353, 0.7108851279623383, 0.4026975586732994], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtk8tvzFEUxw9DYqHTEl16FGXu/U3bSR9aUcQrEhKRohuthV1L1D8gsSKi
SuKxYEFb8YgN0UbVzCAeIVijf0UXTahH+Hxz7uLke+553+89t+H4UM+phWbW
h+SQV8FsbIFZJ9gSzY7iDKBxvoT9AlhG7qCvBr/g20RiP9jM+TuhjeB8wayC
/ge8xXmY+AZiDiBtxH8AX+CrI6YCDtCnI+e+00WzG4vNZjOzGvOaX5Fd5BTx
V8ESvog+iX4f/Sf6GFhP7jVyh8ClyPtFZg+wr0C/ir0G3ML5F/E7M7+D7rIO
fMj5HfHjmeco9x54Fl+V/n+ZcwJ9Bn0y+Hyaczk1c5xHqHMFfJp4EB/L8F0n
Zo7Y7Ug7fT8ycw8yyJ1LxPxL99b9RxLP4ls5yq0rOsfKNWZ6Qm4fudvAHcTM
Y98M7svcvzvzWTXzb3Bt9JobwNrEj3haT4/behcwn/gRT92JH/F0mJyT9DoS
/S31pmeIL6XdeBx9Ds3TFH0OzdMFPiLuGPau6G+vHTifeo4iJ/CVqVlLzemC
v4N6af+GE5/iVTZxJQ6+mfOfR0bp8QPbXbCb+hl6GXwbvH41eA/xOpDm0Dyd
0e+sOaaD11V98VuI3rcx+o7qXbZSvzd6rUPR59X7ajc3pn2YSL3UR3Vfpl3V
zq5CLmK7TExz4qo1+n3VV/eLiU/x2oH0o7eB54LnqkY+3V1/Zk1wLp7D257M
d2gv2Jo4ETeV4PMcjF5LNW9ie524EmfjaeeXFP3/6B+1g5+j8/YJbOIc0J+h
v4n+7/T/tMfibD84VfA/upL6U9Hjlfcf/QyYgA==
           "]], 
          PolygonBox[CompressedData["
1:eJwtk0drVVEUhXdeAUVjNHPB7jvnXtDEvETEXiIoiMQyMXHgzIL+AkHBilEH
loEOLIgiUTGElBffSyL2Njb6RywD47fYZ7C465yzy7q7LD5yqudkwcy6QQnE
YDbN92GT2RS8LTPLima/QDv8PHdXeJvE5l/FbAZMwfu5u8TbeCQGtjmYhC/E
5x2B/3DeAn8GPpY8WTe8Hj1+ADX4AHfvefsMnsP3cXccgQ+I/5b454LnmwBn
4LNzs0/Y3iqbLYCf5q5hru8svDPz3NLwFP4o83/Rnd4Gk56b+Lfgv5PzDG9V
8JXcWzn/LbomaXsBPpTcZge8FZ/bZdc7J3eIy34ufCka7jd5PVfAJ4L/y3f0
5foXcvwueo71xHsVXZ9q8ho+BPoKXp8xeEfm9qpvFb4BrCm6nm3wdUmvbJ7A
9+JztOA2e+Cj0WMpvnq7NtVHOZW7QT/no+0nWIm+zZnXV/VTL79Er416chD+
EhwquEZpHcG/2fz/xuDDaR4O8z4Cr6T/vweWwWflHls51EvVRL4/wFBwH/n2
gkF4reLzOQ+MwrvSu3Jo9h6n+VENVIta+l/pq8KbyXGj7D1ULzWDmsUObDZl
3iP1SjkWwa+neb8KluB/AJwgVif23+Dbk79mSLO0O3qsY9j0wLtSPPns5zwc
vLbTaddWB7fVjNSD91C9lL6N8PHgtVIPG/DLwbVIk3axL7oWadiV+UxoNlSP
N9q/VE/VXLXXjmpXr4F++MV01k5pt9qj11o1HeC8PCZbcFfzGz2+5kuzqx3T
rknPBdkH710LqNOfO8FrrxlZhf1/IbKnog==
           "]], 
          
          PolygonBox[{{10793, 603, 10794, 10643, 10644}, {10644, 10643, 10790,
            397, 10638}, {10640, 398, 10792, 10659, 10660}, {10660, 10659, 
           10797, 604, 10798}}]}]}, {
        EdgeForm[], 
        RGBColor[
        0.9553368807361338, 0.7583422018403343, 0.46154433028201447`], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtkdsqxFEUhzeKC17A4V9Emj3TDCmZnGZQbhzSvAC54YqnUJTTSERGKTca
E27MwTjMxBM4vAyGb7XWxer77bXXXqfdtbyeWqt3zsWxBuw57NwSjhJMYavo
GVjEFtFlOB1x7ofga3gTcu6Dd3cwy7mGfxJueOcq+LdgL/aF7oaX2H4dBgNy
RYmvwjmrFcU/xftv/GMwT94W3hbhhdcehomthTS/1JnnvIJ/AXZaLan5xjlG
nleYsJ6l913u9ujh0KuJ9sRceZ09gW73OpfMV7E+H+At53f8ORgL6ywyU85m
lx1MYL/oIKJ7lJxD8MX6eYJl3pzztt9rXskfJ340ojESm7ZdHcEC9Zqpew9P
OKfxH8MsdoAeIP4RnUGXvPYnfbZ6jZP4RtgXVn2KHrQ/lb8dMS07Hrf9yz/k
ve52lvukzSJ72sSq5P+jzrZp8XVYDwUYwj7xB7DJ+szAHvPLfWC7SsKi7aTN
a5zEnwntj3bgP/zwacg=
           "]], 
          PolygonBox[CompressedData["
1:eJwtkcsuw0EUxg8VFvoCLo02uvjPNL3oiiDCRpoi0kewYcWjoAs7nqFu0Qo7
cVkXL4PG78uZxZf8zpzbNzOlg5PO8biZFdEEegxml2NmQ7gE91N8SNEDfJ+Z
fZPLozv4Fn2Z1/fgrYrZKGfWRKvwIPNa9RTpvyGeNu9RbyuaLVFbRQV4J/qu
OvE2vFzxnGpW4P2Ul6dn5jWJu/AZqsFVzo7IXxEPgnuQlxpagwM1p+TOUR2e
Ce5d8+bhQnBv8tjPfKd2/6FNeDH4XT7RAtyOvq9B/gNuBN+ts070GtXq7Am+
CO5VnqfgyeBe5Kkb0gxm/aIN9r1E9647vMHXmc+TB/3Fa6rXvl34Pfrb6Y32
ov/hML13GZ5N/jRjDl5nx0/Oe9T7D2F6Rw0=
           "]], 
          
          PolygonBox[{{10501, 194, 10636, 10499, 10500}, {10809, 10808, 10807,
            608, 10816}, {10497, 10496, 10633, 193, 10498}, {10820, 10819, 
           10942, 814, 10949}, {10946, 813, 10945, 10812, 10813}, {10815, 608,
            10943, 10819, 10820}, {10500, 10499, 10640, 400, 10641}, {10804, 
           10803, 10650, 401, 10649}, {10810, 607, 10805, 10803, 10804}, {
           10813, 10812, 10940, 607, 10811}, {10652, 402, 10667, 10808, 
           10809}, {10637, 399, 10638, 10496, 10497}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9743197102873321, 0.8057992757183303, 0.5203911018907295], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtkLtOQlEQRQcEQSsSEhXRwsTi3pPQ2aAxCvERE2j8AxEt5UssRGNiJNFG
jZ0CKrbysNYvYk1mip21z9w9c8+ZtUbr+CIpIutoBiVjkSFMwGd0kxDJwS90
jx/ADJqQuYV36Jr6RhDZDZYvwyo6YXAl2DfNbMJtr//AFXr/mFOAY84N6nvw
0WdmYVu/kZmN7U56t0v4jTpkSrH1aO8OPHC/Dw/RKb4WbJbOfIC/nM+pj+AV
5xEzU7FJfRr2IpE5fBf20Tz+I7K36Rs7ZN48o9mc7+oJLqF/6q/U6+Sb/GsS
rF/nvMNPv38ebvlOdDdF712GC77zLnyJbFeL+FVyZ+SP4BTaMjsz
           "]], 
          PolygonBox[CompressedData["
1:eJwtjzkKAmEMRqMILq3ibmE3/4CXEAQRbbyBa6knsdDCRnsRdFwKl9at1xP5
QqZ48JLJlz9T7U+7k6iIZCAGL19kTKMPb7wNA3wVEbk6kSV8dA7meMO3Wc20
8By9r9h8Fk/DGv/Ry+NNZoZR612oT55Iim8JOOAzek/8DQv87GyX3hDgRWe7
NH93ltGs9krUO+q42A0bfB/WSTjitfAevaHDLQ/o4SOo4LfwPc2X8UL4P7pD
d209e0vfDPCjs6zuqJP/A0xeLrk=
           "]], 
          
          PolygonBox[{{10654, 10653, 10652, 404, 10662}, {10817, 609, 10811, 
           10657, 10658}, {10655, 403, 10649, 10647, 10648}, {10666, 10665, 
           10815, 610, 10822}, {10658, 10657, 10810, 403, 10656}, {10507, 198,
            10503, 10653, 10654}, {10648, 10647, 10502, 197, 10506}, {10661, 
           404, 10816, 10665, 10666}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9933025398385306, 0.8532563495963263, 0.5792378734994446], 
        GraphicsGroupBox[{
          
          PolygonBox[{{10648, 199, 10655}, {10520, 208, 10515}, {10518, 207, 
           10519}, {10662, 200, 10654}, {10664, 405, 10663}, {10822, 406, 
           10666}, {10666, 406, 10661}, {10818, 409, 10672}, {10656, 405, 
           10658}, {10517, 208, 10403}, {10414, 6, 10409}, {10407, 5, 
           10412}, {10670, 407, 10674}, {10654, 200, 10507}, {10678, 408, 
           10824}, {10506, 199, 10648}, {10826, 410, 10821}, {10669, 406, 
           10668}, {10658, 405, 10817}, {10404, 207, 10516}}], 
          
          PolygonBox[{{10515, 208, 408, 10678}, {10671, 408, 208, 10517}, {
           10519, 207, 5, 10407}, {10821, 410, 406, 10822}, {10674, 407, 207, 
           10518}, {10516, 207, 407, 10511}, {10817, 405, 409, 10818}, {10410,
            5, 207, 10404}, {10403, 208, 6, 10411}, {10668, 406, 410, 
           10673}, {10409, 6, 208, 10520}, {10514, 409, 405, 10664}}], 
          
          PolygonBox[{{10513, 10512, 10661, 406, 10669}, {10505, 10504, 10655,
            199, 10508}, {10663, 405, 10656, 10504, 10505}, {10509, 200, 
           10662, 10512, 10513}}]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.9093131820471325, 0.6737122163383736], 
        GraphicsGroupBox[{
          PolygonBox[{{10505, 201, 10663}, {10513, 202, 10509}, {10508, 201, 
           10505}, {10664, 205, 10514}, {10411, 4, 10403}, {10404, 3, 
           10410}, {10511, 203, 10516}, {10673, 206, 10668}, {10669, 202, 
           10513}, {10517, 204, 10671}}], 
          
          PolygonBox[{{10668, 206, 202, 10669}, {10405, 204, 4, 10408}, {
           10406, 3, 203, 10510}, {10403, 4, 204, 10517}, {10516, 203, 3, 
           10404}, {10663, 201, 205, 10664}}]}]}, {
        EdgeForm[], 
        RGBColor[0.939622454812373, 0.7190561370309326, 0.41282960991835643`], 
        GraphicsGroupBox[{
          PolygonBox[{{10408, 2, 10405}, {10510, 1, 10406}}]}]}}, {{}, 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[{10405, 10408}], 
          LineBox[{10406, 10510}]}, "0.65`"], 
        Annotation[#, 0.65, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[{10410, 10404, 10516, 10511}], 
          LineBox[{10411, 10403, 10517, 10671}], 
          LineBox[{10508, 10505, 10663, 10664, 10514}], 
          LineBox[{10509, 10513, 10669, 10668, 10673}]}, "0.6`"], 
        Annotation[#, 0.6, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[{10412, 10407, 10519, 10518, 10674, 10670}], 
          LineBox[{10414, 10409, 10520, 10515, 10678, 10824}], 
          
          LineBox[{10506, 10648, 10655, 10504, 10656, 10658, 10817, 10818, 
           10672}], 
          
          LineBox[{10507, 10654, 10662, 10512, 10661, 10666, 10822, 10821, 
           10826}]}, "0.55`"], Annotation[#, 0.55, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{10418, 10419, 10416, 10413, 10521, 10524, 10680, 10679, 
           10828, 10823}], 
          
          LineBox[{10420, 10421, 10417, 10415, 10523, 10522, 10681, 10541, 
           10829, 10950}], 
          
          LineBox[{10498, 10497, 10637, 10642, 10502, 10647, 10649, 10804, 
           10810, 10657, 10811, 10813, 10946, 10781, 10825}], 
          
          LineBox[{10501, 10500, 10641, 10646, 10503, 10653, 10652, 10809, 
           10816, 10665, 10815, 10820, 10949, 10948, 10951}]}, "0.5`"], 
        Annotation[#, 0.5, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{10422, 10424, 10525, 10536, 10532, 10529, 10682, 10685, 
           10832, 10830, 10952, 11069, 11075, 11070}], 
          
          LineBox[{10423, 10425, 10528, 10534, 10531, 10527, 10684, 10544, 
           10834, 10827, 10953, 11071, 11078, 11180}], 
          
          LineBox[{10494, 10629, 10633, 10496, 10638, 10644, 10793, 10799, 
           10650, 10803, 10805, 10937, 10940, 10812, 10945, 10939, 11064, 
           11065, 11073, 11037, 11072}], 
          
          LineBox[{10495, 10632, 10636, 10499, 10640, 10660, 10798, 10802, 
           10667, 10808, 10807, 10938, 10943, 10819, 10942, 10944, 11068, 
           11067, 11074, 11179, 11181}]}, "0.45`"], 
        Annotation[#, 0.45, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{10426, 10428, 10533, 10542, 10675, 10540, 10686, 10692, 
           10835, 10838, 10955, 10956, 11079, 11077, 11182, 11277, 11284, 
           11278}], 
          
          LineBox[{10427, 10429, 10535, 10676, 10677, 10538, 10688, 10551, 
           10836, 10837, 10957, 10845, 11082, 11076, 11185, 11279, 11285, 
           11375}], 
          
          LineBox[{10489, 10492, 10621, 10625, 10630, 10782, 10639, 10786, 
           10790, 10643, 10794, 10800, 10928, 10931, 10936, 11053, 10935, 
           11057, 11058, 11169, 11172, 11062, 11177, 11171, 11272, 11273, 
           11281, 11252, 11280}], 
          
          LineBox[{10491, 10493, 10624, 10628, 10631, 10785, 10651, 10789, 
           10792, 10659, 10797, 10814, 10929, 10934, 10933, 11056, 10947, 
           11061, 11060, 11170, 11175, 11066, 11174, 11176, 11276, 11275, 
           11282, 11248, 11376}]}, "0.4`"], Annotation[#, 0.4, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{10430, 10434, 10526, 10431, 10537, 10546, 10693, 10702, 
           10831, 10701, 10839, 10844, 10958, 10961, 11083, 11087, 11186, 
           11188, 11287, 11286, 11377, 11463, 11470, 11464}], 
          
          LineBox[{10432, 10435, 10530, 10433, 10539, 10683, 10695, 10557, 
           10833, 10556, 10840, 10841, 10959, 10850, 11084, 11086, 11187, 
           11093, 11288, 11283, 11378, 11465, 11474, 11554}], 
          
          LineBox[{10482, 10486, 10610, 10614, 10488, 10618, 10622, 10773, 
           10775, 10634, 10783, 10791, 10914, 10919, 10795, 10922, 10927, 
           11042, 11045, 10930, 11049, 11054, 11160, 11163, 11168, 11262, 
           11167, 11266, 11267, 11364, 11369, 11270, 11372, 11368, 11460, 
           11350, 11467, 11441, 11466}], 
          
          LineBox[{10483, 10487, 10613, 10617, 10490, 10619, 10623, 10774, 
           10779, 10645, 10784, 10801, 10916, 10921, 10806, 10923, 10926, 
           11044, 11048, 10941, 11052, 11063, 11161, 11166, 11165, 11265, 
           11178, 11269, 11268, 11365, 11370, 11274, 11373, 11371, 11462, 
           11461, 11468, 11553, 11555}]}, "0.35`"], 
        Annotation[#, 0.35, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{10436, 10438, 10543, 10550, 10689, 10547, 10699, 10706, 
           10842, 10848, 10962, 10970, 11080, 10967, 11089, 11183, 11191, 
           11193, 11291, 11294, 11381, 11382, 11475, 11472, 11556, 11624, 
           11630, 11625}], 
          
          LineBox[{10437, 10439, 10545, 10690, 10691, 10687, 10700, 10560, 
           10843, 10954, 10963, 10856, 11081, 10854, 11090, 11184, 11192, 
           11098, 11292, 11293, 11383, 11304, 11476, 11469, 11557, 11626, 
           11631, 11703}], 
          
          LineBox[{10480, 10604, 10484, 10606, 10615, 10761, 10763, 10626, 
           10765, 10770, 10776, 10904, 10787, 10909, 10918, 11029, 11033, 
           10924, 11038, 11046, 11147, 11151, 11050, 11154, 11159, 11254, 
           11256, 11162, 11260, 11263, 11357, 11360, 11363, 11450, 11362, 
           11453, 11457, 11544, 11547, 11456, 11552, 11546, 11620, 11531, 
           11628, 11700, 11627}], 
          
          LineBox[{10481, 10605, 10485, 10609, 10616, 10762, 10764, 10635, 
           10769, 10772, 10778, 10906, 10796, 10911, 10915, 11032, 11036, 
           10932, 11041, 11055, 11149, 11153, 11059, 11156, 11158, 11255, 
           11259, 11173, 11261, 11271, 11358, 11361, 11366, 11452, 11374, 
           11455, 11454, 11545, 11550, 11459, 11549, 11551, 11623, 11622, 
           11629, 11702, 11704}]}, "0.3`"], Annotation[#, 0.3, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{10440, 10442, 10548, 10555, 10696, 10552, 10704, 10708, 
           10846, 10849, 10969, 10975, 11085, 10972, 11091, 11189, 11194, 
           11289, 11298, 11379, 11386, 11471, 11479, 11482, 11560, 11563, 
           11634, 11635, 11709, 11707, 11777, 11832, 11838, 11833}], 
          
          LineBox[{10441, 10443, 10549, 10697, 10698, 10694, 10705, 10562, 
           10847, 10960, 10971, 10860, 11088, 10859, 11092, 11190, 11197, 
           11290, 11300, 11380, 11387, 11473, 11480, 11481, 11561, 11562, 
           11636, 11568, 11710, 11705, 11778, 11834, 11839, 11899}], 
          
          LineBox[{10476, 10597, 10478, 10599, 10607, 10749, 10751, 10620, 
           10753, 10758, 10766, 10897, 10780, 10901, 10908, 11019, 11022, 
           10917, 11030, 11039, 11135, 11140, 11043, 11144, 11150, 11244, 
           11247, 11157, 11250, 11257, 11347, 11351, 11354, 11440, 11356, 
           11443, 11448, 11534, 11537, 11449, 11542, 11541, 11612, 11614, 
           11618, 11690, 11617, 11694, 11695, 11769, 11772, 11698, 11776, 
           11771, 11827, 11828, 11836, 11815, 11835}], 
          
          LineBox[{10477, 10598, 10479, 10600, 10608, 10750, 10752, 10627, 
           10757, 10760, 10768, 10899, 10788, 10903, 10905, 11021, 11027, 
           10925, 11031, 11047, 11138, 11142, 11051, 11145, 11148, 11246, 
           11249, 11164, 11253, 11264, 11348, 11352, 11355, 11442, 11367, 
           11445, 11447, 11535, 11539, 11458, 11540, 11548, 11613, 11616, 
           11615, 11693, 11621, 11697, 11696, 11770, 11774, 11701, 11773, 
           11775, 11831, 11830, 11837, 11898, 11900}]}, "0.25`"], 
        Annotation[#, 0.25, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{10444, 10446, 10553, 10558, 10709, 10711, 10851, 10855, 
           10966, 10853, 10974, 10977, 11094, 11195, 11198, 11297, 11202, 
           11295, 11301, 11384, 11388, 11477, 11483, 11558, 11565, 11632, 
           11637, 11706, 11642, 11641, 11711, 11718, 11781, 11783, 11842, 
           11845, 11903, 11902, 11958, 12001, 12007, 12002}], 
          
          LineBox[{10445, 10447, 10554, 10703, 10710, 10566, 10852, 10965, 
           10968, 10964, 10976, 10864, 11097, 11196, 11201, 11299, 11101, 
           11296, 11302, 11385, 11389, 11478, 11486, 11559, 11567, 11633, 
           11640, 11708, 11574, 11573, 11714, 11717, 11782, 11725, 11844, 
           11843, 11904, 11849, 11959, 12003, 12008, 12054}], 
          
          LineBox[{10472, 10590, 10474, 10592, 10601, 10742, 10612, 10744, 
           10754, 10890, 10771, 10892, 10900, 11011, 10910, 11014, 11017, 
           10912, 11023, 11034, 11129, 11133, 11139, 11233, 11146, 11237, 
           11240, 11334, 11337, 11251, 11340, 11342, 11346, 11430, 11353, 
           11433, 11439, 11526, 11528, 11446, 11533, 11536, 11603, 11606, 
           11609, 11681, 11611, 11683, 11686, 11757, 11760, 11691, 11762, 
           11764, 11768, 11821, 11822, 11889, 11825, 11891, 11895, 11949, 
           11951, 11894, 11952, 11953, 11998, 11941, 12005, 12051, 12004}], 
          
          LineBox[{10473, 10591, 10475, 10594, 10602, 10743, 10741, 10746, 
           10756, 10891, 10767, 10894, 10898, 11012, 11010, 11016, 11018, 
           10920, 11026, 11040, 11131, 11134, 11137, 11236, 11155, 11238, 
           11243, 11335, 11338, 11258, 11341, 11343, 11349, 11431, 11359, 
           11434, 11438, 11527, 11529, 11451, 11532, 11543, 11604, 11607, 
           11608, 11682, 11619, 11685, 11688, 11758, 11761, 11699, 11763, 
           11767, 11766, 11824, 11823, 11890, 11829, 11893, 11892, 11950, 
           11956, 11897, 11955, 11957, 11999, 11937, 12006, 12053, 12055}]}, 
         "0.2`"], Annotation[#, 0.2, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{10448, 10450, 10559, 10563, 10712, 10715, 10857, 10861, 
           10979, 10982, 11095, 10981, 11099, 11199, 11203, 11303, 11306, 
           11390, 11392, 11487, 11395, 11484, 11489, 11564, 11569, 11638, 
           11643, 11715, 11646, 11712, 11719, 11779, 11784, 11840, 11846, 
           11851, 11905, 11910, 11960, 11963, 12009, 12011, 12056, 12058, 
           12100, 12098, 12140, 12138}], 
          
          LineBox[{10449, 10451, 10561, 10707, 10714, 10568, 10858, 10973, 
           10980, 10869, 11096, 10868, 11100, 11200, 11204, 11305, 11307, 
           11391, 11393, 11488, 11312, 11485, 11490, 11566, 11570, 11639, 
           11644, 11716, 11577, 11713, 11720, 11780, 11785, 11841, 11847, 
           11901, 11906, 11855, 11961, 11962, 12012, 12010, 12057, 12015, 
           12102, 12097, 12141, 12173}], 
          LineBox[CompressedData["
1:eJwNxUErwwEcANCfgxRF5AtIyRiOCgdHKwdWK+VGlP61UY4ODtbm5DQppbRp
qfk6UuOykDStHGc17/B6U3uFbH4gInK8z0bspCI+vet9OiT88sfFXMQQJa7o
cU2fe/LzEeOcMMkpZ5zzRpEW36ynI3684S1u2eaBBl16PNFncCEiwybDZMlR
4YY7WtT44Is6bTpML0bMkOKINAkFqtQ55pEGz7zwyshSRNOjHmOZFSZYZY0D
DilzScI/sAc9rA==
           "]], 
          LineBox[CompressedData["
1:eJwNxT8rBAAAB9CfsFFHvoBBHedPmSzCSgbKQFlkQLorpWRXimSjUAbpxCTf
RVdICaGkZDrKG16vc6EyXW5IMsNzMZntTl4970W++OSbX7Z6kka22eePOikl
zVRoYY0C62xS44E7nnhlrDd584QPOeGYM6rU+eOG9CVNjDNJO1PMccARpzxx
wQvvXPHBD139SZESKwyySplzqmxwyTW31LindSB5dJsLDDFMB6OMsMQyu+yw
xz+eCD3Z
           "]]}, "0.15`"], Annotation[#, 0.15, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{10452, 10454, 10564, 10567, 10716, 10719, 10862, 10867, 
           10983, 10986, 11102, 11205, 11207, 11308, 11310, 11394, 11397, 
           11493, 11399, 11491, 11495, 11571, 11575, 11645, 11648, 11723, 
           11650, 11721, 11726, 11786, 11788, 11848, 11852, 11856, 11909, 
           11854, 11912, 11914, 11964, 11967, 12013, 12016, 12060, 12063, 
           12099, 12062, 12103, 12106, 12142, 12144, 12175, 12178, 12202, 
           12204, 12227, 12226, 12256, 12254}], 
          
          LineBox[{10453, 10455, 10565, 10713, 10717, 10572, 10863, 10978, 
           10984, 10872, 11103, 11206, 11208, 11309, 11311, 11396, 11398, 
           11494, 11317, 11492, 11496, 11572, 11576, 11647, 11649, 11724, 
           11581, 11722, 11727, 11787, 11789, 11850, 11853, 11908, 11911, 
           11907, 11913, 11861, 11965, 11966, 12014, 12059, 12061, 12020, 
           12101, 12019, 12104, 12105, 12143, 12109, 12176, 12177, 12203, 
           12181, 12228, 12225, 12257, 12273}], 
          LineBox[CompressedData["
1:eJwNzT8rBAAcxvEfl668BqUrg/+XxGCwoGxEFknuiMuASTZdxKTUDToScSmv
gfISpOvERWS7kjIot8hn+PR9tieVXZ9aa4iIFd7bI6Y7Ij50RmepkeGTb7Y7
I+qa1z1+OOCXP3JdEUlW2WCTCltUeWOo25cO6wgFxihyzjcX/HBJncaeiFES
jDPBIZMUOKbKKa+c8U6Nlt6IVlJkaGORZY4okuOEU864p8QDZRLpiCYqdlKb
SdNHP3MMMM8Cg2RZIs8Ou5TY54prbrjlkWfueOGJL8q88Q9JiUx+
           "]], 
          LineBox[CompressedData["
1:eJwVzcsqBAAUx+EzJaU8gYWwcifZSLFjL1mRDJqUy8ILaApRomkSQy4LEc9A
HkFMTRmXZEciyWUjn8XX7786pzo50zediIgUD7UR/XURjzqggzzzxAsfzNVH
zGpal/jikx8SDRETbNmTOssVBfIUWaSzMWJNuzXDOlly7PDBLt/sc8IvPU1+
0MsKGVbJss4Nm9yxzT0VzRGVVFFDknrGGGeDHFNss8MeFxxzSZ6SlohSru0y
LaeVNtoZooNhRuhilBRpFpjngGWOOOSMUwr/tznnliJvvPLOH/UETis=
           "]]}, "0.1`"], Annotation[#, 0.1, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{10456, 10458, 10569, 10571, 10720, 10865, 10870, 10873, 
           10987, 10989, 11104, 11209, 11211, 11313, 11315, 11400, 11402, 
           11497, 11499, 11578, 11580, 11651, 11653, 11728, 11730, 11790, 
           11792, 11859, 11794, 11857, 11862, 11864, 11916, 11918, 11968, 
           11973, 12017, 11971, 12021, 12023, 12065, 12068, 12107, 12067, 
           12110, 12112, 12146, 12149, 12179, 12148, 12182, 12184, 12206, 
           12231, 12208, 12229, 12233, 12258, 12260, 12275, 12277, 12287, 
           12290, 12306, 12294, 12292, 12308, 12309, 12321, 12323, 12335, 
           12334, 12345, 12343}], 
          
          LineBox[{10457, 10459, 10570, 10718, 10721, 10866, 10871, 10985, 
           10988, 10874, 11105, 11210, 11212, 11314, 11316, 11401, 11403, 
           11498, 11500, 11579, 11582, 11652, 11654, 11729, 11731, 11791, 
           11793, 11860, 11732, 11858, 11863, 11915, 11917, 11865, 11969, 
           11972, 12018, 11970, 12022, 12064, 12066, 12025, 12108, 12024, 
           12111, 12145, 12147, 12114, 12180, 12113, 12183, 12205, 12207, 
           12232, 12185, 12230, 12234, 12259, 12261, 12276, 12278, 12288, 
           12291, 12307, 12293, 12289, 12310, 12295, 12324, 12322, 12336, 
           12325, 12346, 12349}], 
          LineBox[CompressedData["
1:eJwVzs0rHwAcx/GvnbTaXJTEkot+Hn4stBSSlqOEloyWtHYRjpJGclHqx5ZR
kuI/kMRfIE1IeVpbDspDzazlIDLttcOr9+f4ye/ub+lLi4hRfiQiGgsjTrRJ
mzmljTMuGCqK+Mg1Y/zhhu7iiHt9rx/oYYde9jjkVUnEsVZpDSlqmeILv5jl
NzfUJSNutV5fM04DE6Q44BNHfCOzNOK7Zmk2b8mhkxe8Y5IuPjPNBjNs8pV7
tnlgh0eiLKKAJyRIp5UkbyiljXYG6GCQIeYYZp4FRlhkiWVWWGWLNbbZZZ09
9jnnkp/ccsUdD/+/vIx4yl/7uT4ji2wyyCGXAgrJI0mCCiqpppwq/gEhR1uX

           "]], 
          LineBox[CompressedData["
1:eJwVyc8rHgAcx/Gvo+YwaWKLOOjheR4zB7SS1nJTT5KWrKUsuc3NJMRJFiHt
pEX8B1or/gGtMVK0y5JoWA1J0uTHy+HV+9vnW9rZ0/IhKyJG+F0ekamI2NVm
beGAff5wxEAyYogzTjnngvepiELt0m7W2WSDLZ5Rl474qC91nEkmmOY1JzRy
xjmvKiMuH346yifGGKeJHTL8Iu95RD5PKGDP9lYP9J0eaodOM8UMn1mlm+/8
4JoFbljjjqyqiARlVJCklRRvSNNGO3300s8AswzyhTmGmWeRJb7yjTWW+ckm
K2yxzSHH/OWKf/znmuwXEY+4defoYwp4Si7FFJEgRQlJ0tRQSz3VNHAPRWtc
tw==
           "]]}, "0.05`"], Annotation[#, 0.05, "Tooltip"]& ], {}, {}}}], {
    DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
     Identity, Frame -> True, FrameLabel -> {{
        FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}, {{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], Method -> {"DefaultBoundaryStyle" -> Automatic}, 
     PlotRange -> {{0, 1}, {0, 1}}, PlotRangeClipping -> True, 
     PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               
               "\"Avaliable work\\n(\\!\\(\\*SubscriptBox[\\(k\\), \
\\(B\\)]\\)T)\"", {FontFamily -> "Arial"}, Background -> Automatic, 
                StripOnInput -> False]}, {
               GraphicsBox[{{}, {}, 
                 RasterBox[CompressedData["
1:eJwBZQGa/iFib1JlAwAAAA4AAAABAAAAAwAAAIts5/up8cI/H4XrUbge1T9I
4XoUrkfhP0ATMT+M7dI/l7nEFNQW2j+ilNh3maXkP9HMcO5/iNo/2YVtjA/D
3D+1jBMdVWniPzFD2M65EeE/GlIWBEtv3z/IhE7CEC3gP/ofeKYz3+Q/Lo/f
PcMN4T+3+RLPmOHbP8T8F36trOg/UPWz+eBj4j/c6YgZEGnXP4vZt1Uneuw/
cFuItf654z8F2v5jh/DSP8SrZuQaW+0/Q1FxeM065T8pXEm7pgHWPwIgasWc
9u0/3PP5KpK/5j8/kyv7y8XZP0CUbaYeku4/dpaC3VZE6D9Wyg078YndP30I
cYegLe8/EDkLkBvJ6T+2AHg9C6fgP7t8dGgiye8/q9uTQuBN6z9DHGndHYni
PwAAAAAAAPA/JNpW9RcZ7T8F2QLsDI/lP0Q0QBxjEe4/gSYRBIIC5z+l3Vri
zGvaPw2LqM8=
                  "], {{
                    Rational[-15, 2], 
                    Rational[-225, 2]}, {
                    Rational[15, 2], 
                    Rational[225, 2]}}], {Antialiasing -> False, 
                  AbsoluteThickness[0.1], 
                  Directive[
                   Opacity[0.3], 
                   GrayLevel[0]], 
                  LineBox[
                   NCache[{{
                    Rational[15, 2], 
                    Rational[-225, 2]}, {
                    Rational[-15, 2], 
                    Rational[-225, 2]}, {
                    Rational[-15, 2], 
                    Rational[225, 2]}, {
                    Rational[15, 2], 
                    Rational[225, 2]}, {
                    Rational[15, 2], 
                    Rational[-225, 2]}}, {{
                    7.5, -112.5}, {-7.5, -112.5}, {-7.5, 112.5}, {7.5, 
                    112.5}, {7.5, -112.5}}]]}, {
                  CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -96.42857142857142}, {
                    Rational[
                    15, 2], -96.42857142857142}}, {{-7.5, \
-96.42857142857142}, {7.5, -96.42857142857142}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -80.35714285714286}, {
                    Rational[
                    15, 2], -80.35714285714286}}, {{-7.5, \
-80.35714285714286}, {7.5, -80.35714285714286}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -64.28571428571428}, {
                    Rational[
                    15, 2], -64.28571428571428}}, {{-7.5, \
-64.28571428571428}, {7.5, -64.28571428571428}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -48.21428571428571}, {
                    Rational[
                    15, 2], -48.21428571428571}}, {{-7.5, \
-48.21428571428571}, {7.5, -48.21428571428571}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -32.14285714285714}, {
                    Rational[
                    15, 2], -32.14285714285714}}, {{-7.5, -32.14285714285714},
                     {7.5, -32.14285714285714}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -16.071428571428555`}, {
                    Rational[
                    15, 2], -16.071428571428555`}}, {{-7.5, \
-16.071428571428555`}, {7.5, -16.071428571428555`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 0.}, {
                    Rational[15, 2], 0.}}, {{-7.5, 0.}, {7.5, 0.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 16.071428571428598`}, {
                    Rational[15, 2], 16.071428571428598`}}, {{-7.5, 
                    16.071428571428598`}, {7.5, 16.071428571428598`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 32.14285714285715}, {
                    Rational[15, 2], 32.14285714285715}}, {{-7.5, 
                    32.14285714285715}, {7.5, 32.14285714285715}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 48.21428571428571}, {
                    Rational[15, 2], 48.21428571428571}}, {{-7.5, 
                    48.21428571428571}, {7.5, 48.21428571428571}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 64.28571428571429}, {
                    Rational[15, 2], 64.28571428571429}}, {{-7.5, 
                    64.28571428571429}, {7.5, 64.28571428571429}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 80.35714285714285}, {
                    Rational[15, 2], 80.35714285714285}}, {{-7.5, 
                    80.35714285714285}, {7.5, 80.35714285714285}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 96.4285714285714}, {
                    Rational[15, 2], 96.4285714285714}}, {{-7.5, 
                    96.4285714285714}, {7.5, 96.4285714285714}}]]}}}, {
                 Antialiasing -> False, 
                  StyleBox[
                   
                   LineBox[{{7.5, -112.49999999999999`}, {7.5, 
                    112.49999999999999`}}], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -96.42857142857143}, 
                    Offset[{4., 0}, {7.5, -96.42857142857143}]}, {{
                    7.5, -80.35714285714285}, 
                    Offset[{4., 0}, {7.5, -80.35714285714285}]}, {{
                    7.5, -64.28571428571429}, 
                    Offset[{4., 0}, {7.5, -64.28571428571429}]}, {{
                    7.5, -48.214285714285715`}, 
                    Offset[{4., 0}, {7.5, -48.214285714285715`}]}, {{
                    7.5, -32.142857142857146`}, 
                    Offset[{4., 0}, {7.5, -32.142857142857146`}]}, {{
                    7.5, -16.07142857142857}, 
                    Offset[{4., 0}, {7.5, -16.07142857142857}]}, {{7.5, 0.}, 
                    Offset[{4., 0}, {7.5, 0.}]}, {{7.5, 16.07142857142858}, 
                    Offset[{4., 0}, {7.5, 16.07142857142858}]}, {{7.5, 
                    32.14285714285714}, 
                    Offset[{4., 0}, {7.5, 32.14285714285714}]}, {{7.5, 
                    48.214285714285715`}, 
                    Offset[{4., 0}, {7.5, 48.214285714285715`}]}, {{7.5, 
                    64.28571428571428}, 
                    Offset[{4., 0}, {7.5, 64.28571428571428}]}, {{7.5, 
                    80.35714285714283}, 
                    Offset[{4., 0}, {7.5, 80.35714285714283}]}, {{7.5, 
                    96.42857142857139}, 
                    Offset[{4., 0}, {7.5, 96.42857142857139}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -96.42857142857143}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.1`", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -80.35714285714285}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -64.28571428571429}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.2`", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -48.214285714285715`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -32.142857142857146`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.3`", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -16.07142857142857}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 0.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.4`", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 16.07142857142858}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 32.14285714285714}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.5`", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 48.214285714285715`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 64.28571428571428}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.6`", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 80.35714285714283}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 96.42857142857139}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                Scaled[0.02], PlotRange -> All, Frame -> True, 
                FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                Opacity[0], FrameTicksStyle -> Opacity[0], 
                ImageSize -> {Automatic, 225}, BaseStyle -> {}]}}, 
             GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{"6.615`*^-13", ",", "0.6584898192494922`"}], "}"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"0.05`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.1`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.15`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.2`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.25`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.3`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.35`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.4`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.45`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.5`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.55`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.6`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.65`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.7`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           
           RowBox[{"LegendLabel", "\[Rule]", 
             "\"Avaliable work\\n(\\!\\(\\*SubscriptBox[\\(k\\), \
\\(B\\)]\\)T)\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"Ticks", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"0.05`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.1`", ",", "0.1`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.15`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.2`", ",", "0.2`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.25`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.3`", ",", "0.3`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.35`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.4`", ",", "0.4`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.45`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.5`", ",", "0.5`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.55`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.6`", ",", "0.6`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.65`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.7`", ",", "0.7`"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.752284369769966*^9, 3.752284395522696*^9}, 
   3.752322775215019*^9, {3.753006363832711*^9, 3.753006392898286*^9}, 
   3.753006472688013*^9, 3.753006528115777*^9, {3.7530065762458906`*^9, 
   3.753006600982894*^9}, 3.7530083890945535`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<availableworkplot.pdf\>\"", ",", "availableworkplot"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7451705202936316`*^9, 3.74517052893519*^9}}],

Cell[BoxData["\<\"availableworkplot.pdf\"\>"], "Output",
 CellChangeTimes->{3.745170554797353*^9, 3.7522825476844535`*^9, 
  3.752284434183053*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FIG 7. Markov and binary batch machines", "Title",
 CellChangeTimes->{
  3.7522836216748543`*^9, {3.7523395676611757`*^9, 3.75233956996831*^9}, {
   3.7530084632118373`*^9, 3.7530084654152536`*^9}}],

Cell[CellGroupData[{

Cell["(a)", "Chapter",
 CellChangeTimes->{{3.7530089918628435`*^9, 3.7530089935817947`*^9}}],

Cell["\<\
We have a simple equation for the work extracted by the Markov machine so we \
create a function to calculate it in pure Mathematica code.\
\>", "Text",
 CellChangeTimes->{{3.7558749692175117`*^9, 3.755875001642808*^9}, {
  3.7558751817396975`*^9, 3.755875193991211*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"markovwork", "[", 
   RowBox[{"a_", ",", "k_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Log", "[", "2", "]"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "k"}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["a", "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", "a"}], ")"}], "2"]}], ")"}]}], "+", 
      RowBox[{"2", "k", " ", "a", 
       RowBox[{"(", 
        RowBox[{"1", "-", "a"}], ")"}]}]}], ")"}], 
    RowBox[{"Log", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "k"}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["a", "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", "a"}], ")"}], "2"]}], ")"}]}], "+", 
      RowBox[{"2", "k", " ", "a", 
       RowBox[{"(", 
        RowBox[{"1", "-", "a"}], ")"}]}]}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"k", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["a", "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", "a"}], ")"}], "2"]}], ")"}]}], "+", 
      RowBox[{"2", 
       RowBox[{"(", 
        RowBox[{"1", "-", "k"}], ")"}], "a", 
       RowBox[{"(", 
        RowBox[{"1", "-", "a"}], ")"}]}]}], ")"}], 
    RowBox[{"Log", "[", 
     RowBox[{
      RowBox[{"k", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["a", "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", "a"}], ")"}], "2"]}], ")"}]}], "+", 
      RowBox[{"2", 
       RowBox[{"(", 
        RowBox[{"1", "-", "k"}], ")"}], "a", 
       RowBox[{"(", 
        RowBox[{"1", "-", "a"}], ")"}]}]}], "]"}]}]}]}]], "Input"],

Cell[TextData[{
 "Create a function that takes in a data file that contains the available \
work for various values of ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " and \[Alpha] and outputs a file containing the Markov efficiency at the \
same points."
}], "Text",
 CellChangeTimes->{{3.7558750200978775`*^9, 3.755875103059738*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"markovefficiency", "[", "avaliableworkdatafilename_", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Export", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"StringReplace", "[", 
     RowBox[{"avaliableworkdatafilename", ",", 
      RowBox[{
      "\"\<avaliablework\>\"", "\[Rule]", "\"\<markovefficiency\>\""}]}], 
     "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{"#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
           "#", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
           "\[Equal]", "0"}], ",", "1", ",", 
          RowBox[{
           RowBox[{"markovwork", "[", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "]"}], "/", 
           RowBox[{
           "#", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}]}], 
         "]"}]}], "}"}], "&"}], "/@", 
     RowBox[{"Import", "[", "avaliableworkdatafilename", "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.7530069499420757`*^9, 3.7530069603805*^9}}],

Cell["First calculate the available work", "Text",
 CellChangeTimes->{{3.755875210727351*^9, 3.7558752419647894`*^9}}],

Cell[BoxData[
 RowBox[{"avaliablework", "[", 
  RowBox[{"51", ",", "51", ",", "20"}], "]"}]], "Input",
 CellChangeTimes->{{3.7558748632375975`*^9, 3.7558748645656266`*^9}}],

Cell["then calculate the Markov efficiency.", "Text",
 CellChangeTimes->{{3.7558752256505723`*^9, 3.755875245949892*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"markovefficiency", "[", 
  "\"\<data\\\\avaliablework-asteps51-ksteps51-maxn20.dat\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.7530067967537007`*^9, 3.753006834257907*^9}, {
  3.7530071532759967`*^9, 3.7530071565732203`*^9}}],

Cell[BoxData["\<\"data\\\\markovefficiency-asteps51-ksteps51-maxn20.dat\"\>"],\
 "Output",
 CellChangeTimes->{3.7530069839298587`*^9, 3.753007157291997*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"markovefficiencyplot", "=", 
  RowBox[{"ListContourPlot", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<data\\\\markovefficiency-asteps51-ksteps51-maxn20.dat\>\"", "]"}], 
     "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", "\"\<\[Alpha]\>\""}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<(a)\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"BarLegend", "[", "\[IndentingNewLine]", 
      RowBox[{"Automatic", ",", "\[IndentingNewLine]", 
       RowBox[{"Ticks", "\[Rule]", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "}"}], "&"}], "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "0", ",", "0.1", ",", "0.2", ",", "0.3", ",", "0.4", ",", "0.5", 
              ",", "0.6", ",", "0.7", ",", "0.8", ",", "0.9", ",", "1"}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "0", ",", "\"\<\>\"", ",", "0.2", ",", "\"\<\>\"", ",", "0.4", 
              ",", "\"\<\>\"", ",", "0.6", ",", "\"\<\>\"", ",", "0.8", ",", 
              "\"\<\>\"", ",", "1"}], "}"}]}], "}"}], "]"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
       "LegendLabel", "\[Rule]", "\"\<Markov\\nmachine \[Eta]\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Contours", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0.1", ",", "0.2", ",", "0.3", ",", "0.4", ",", "0.5", ",", 
       "0.6", ",", "0.7", ",", "0.8", ",", "0.9"}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7446275752939463`*^9, 3.744627578387804*^9}, {
   3.744627636737894*^9, 3.7446276555682373`*^9}, {3.7446277655486164`*^9, 
   3.7446278318841295`*^9}, {3.744627866997075*^9, 3.744627869153597*^9}, {
   3.7446279724459853`*^9, 3.7446279738835974`*^9}, {3.7446280627838573`*^9, 
   3.7446280683471403`*^9}, {3.7446281285411344`*^9, 
   3.7446282668527145`*^9}, {3.7446283366258535`*^9, 3.744628408696357*^9}, {
   3.7446284418090754`*^9, 3.744628442074767*^9}, {3.7446285529551563`*^9, 
   3.744628591115526*^9}, {3.7446286495903616`*^9, 3.7446286763434677`*^9}, {
   3.7446287437723975`*^9, 3.7446287941371927`*^9}, {3.744628898679736*^9, 
   3.7446289020863533`*^9}, {3.7449809719466133`*^9, 3.744980995199128*^9}, {
   3.7450775321957626`*^9, 3.7450775353054953`*^9}, 3.7487867949512854`*^9, {
   3.752283658350656*^9, 3.7522837242639093`*^9}, {3.752283841495116*^9, 
   3.7522839487408867`*^9}, {3.752283991323502*^9, 3.7522840324372454`*^9}, {
   3.7522842159880266`*^9, 3.752284231161483*^9}, {3.7522844017889905`*^9, 
   3.7522844105711727`*^9}, {3.7522845930283127`*^9, 3.752284621999892*^9}, {
   3.7523040217835484`*^9, 3.7523040248622265`*^9}, {3.7523144805801845`*^9, 
   3.7523144871277137`*^9}, {3.752315138689542*^9, 3.752315158316897*^9}, {
   3.752325680274936*^9, 3.75232568366615*^9}, {3.752327782460043*^9, 
   3.7523277856947303`*^9}, {3.752931254945799*^9, 3.7529312670720863`*^9}, {
   3.7529313121725817`*^9, 3.752931332440273*^9}, 3.7529315869382825`*^9, 
   3.75300698966483*^9, {3.753007161855032*^9, 3.7530071651522565`*^9}, {
   3.753007203265689*^9, 3.753007222908394*^9}, {3.7530075243874893`*^9, 
   3.753007572397727*^9}, {3.753007614652266*^9, 3.7530076537189136`*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[
    GraphicsComplexBox[CompressedData["
1:eJx1XXVYVcvXtvXait3deu3WsfXaiu21uxtbMa9x7cRGsbtBBVFABRUJBVE4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     "], {{{}, {}, {
        EdgeForm[], 
        RGBColor[
        0.20688222567667713`, 0.36271234759815396`, 0.5951436716654596], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtk0tOVGEQhSs6sO81/f8dmWlEjLQIUVE3wIAh8hDBFoYuADfAAB8ISs+M
GgWXoZjgA3sHDuShjFA0BFR0BX6VU4OTc2/9VadO1f3v6Vu3R6cOmdlVcBh0
lmZNcA7MVswegl9gNpmdhO/Ax2tmC5xvZLNe3pePmNXhfc7HCrMD+Ab8D/4N
hrLig1larvm3Io0zoAt8znpeg0/U5GOd52tgktrxLE8LkX8sS2MzqYf3ehS6
44X69CXF+uEX5LeIL4WXm+HzI1xH7x38tlDf1UK9mtHvGTUrxB5n5axG/ftC
3nzW/ui1Aa8nzdhMymlF3s+q2Qi7+gHXsvaVs/y674nQmozdjYUn7/WhkIcG
SFHrGrtoDaK5XdWZ51wHF+n9mvgVeDgrNgAvZs38HD6f5Md9/UFvD8xVpO27
mY/v53M9AF+o6WEfW/Bolt8R+Bv1Q+jsw2WWzlH4aezrCbzD2TA53fS8C9pd
F74HTvH8CV5LmruN/JeRvxPeGjGXe/dv5b0vk/+KnAtJd2cl9tSM/c/D3aW+
r9dthf8GPMPZG2ovJcXOlsr9HrP4TNWYpYy74zme637ci59tx/4Xqzqvh840
uh2c30+Kt+K+dMa/5Xfoa1buZtyBiZitK/4Ln+U/fRqAGQ==
           "]], 
          PolygonBox[CompressedData["
1:eJwlkUsuA1AUhk9E0ov0HmFGvRlUUGzAAqRaRYShBbABA696tGaCeGzDI2HC
DjzaKisQnbAC38kZ/Ml37nncc/87sLZRWG8SkUHUjGoqMtwq8tgicgano0gu
IXKHMvAyZ6Pk0+gLPlWvXURz8DQ1t9T2BpEduIIO4X60CTeS1CW8ZoL4De2T
K6EZWJnRCN5jvR/Rc3+oajH5Mncfo1Q7dZwdkSuiV3gS3TM7j8bgJepX2e0Z
XcJ19d2fiK/UZ9gse3M3vE1PD7Nu6J+CZ6lZoPYBncMX6r0rqACfqOeG6K/A
pehvtzfZ26rqOdu5i/nX6ruYh59wG/oJfkcOzqp7aR5EeDz6Lln0jXfvxAfB
e5LkX4j7gp9Zro5+g3tSg/Pqu9pZBzwS/S+tZxfei/435tkW3KnutXk2r+6p
eWueFOF/MA9LAg==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.35591182715545927`, 0.42878690411214226`, 0.6098473603942348], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtlElPVEEQgDsaBUbe6xFhhsgkOrgr4HYxevBiwAjKorggGGPiVa4eXEBR
B5fgbtwT9OqSaKJwdYmJUVlmWAXR2xCNMfoD/CpVh8rXr7q6uqq66iUPtTYc
meGcO4rMRN7mOXcAaUYC79zpXOfSoXNbWb9CdxV2oDuFTCOD7JXC8/Assoj1
JrgDu17sb8Avodp/hhOBczU5zn2HdUjxbOficCdyknUNHMbuAvajcIrvauy/
BRqHxNMPY3zHsa8NNJ6ExXSGvSQcgEPIRdYjsIE49hPPba++xOcYfMj3O/T3
YVuofjpgKkJOSCkyzt4quMds3yAtyFLsXuBnmfjn+3We5nzHa/0a4Xr2erD5
zV3HQo01A8ctxy5YIeex+YnNbq++4xZvi9232u5aAeNR5xYSTxqbkXznns+i
ZrCK823UZBcc4Psp+nHYyZnF3LVR3gHpxc862BroegPrT0g7Nh9hhjPPOPsh
X+so9UzBK6aX/Uv21vLmTRazxJ7FZz0+y9GHXuuyHe711ldwKtS16DZb/0gf
Se+9t/6TOkvNJfdf5vMRrPRa5y1eY5WYc1inLV/Juwi7GHVIwAbkBOt9cIy9
J9j0wURU33eEs5NIBesfsMp6ZhLe9Pr+w7Ae+Yd+Hpxr6xg8HOjb/YF3vcY7
CkvMv9wjMUrfZpFG7KaJpxnewq4H+2r4wGvu3V5nTGatD+Z6PVcFCwJ9a3nz
Yvyew/+g1B59Fp9NcAG6ZET3pJ5lEfVbKznAOV51FaZfSZ4viX95qPmL/qBX
PxKb+MrzOlsyx9dtrzCqMyL1kV4sRP8Xm682o5JzCbLW+r8dltlda2y+JMbO
iPal9OdlWGB+6qz2Mk/iv9xiLrP8Ou38lNe9CflXhXrnklBrnzK7Zqv5Y7jN
638rX97d/kXyT8p49XvNZr3c7hrzWsd7XuPotTnvtz6stLpKreTNMjbj3muf
Sb91wW57I3kr8S13SI8X812EvlBmHznOuh7Oj2rsQ9YL4l/q/h+NysGu
           "]], 
          PolygonBox[CompressedData["
1:eJwtlFlLlkEYhoco/T5z3jFzK4WyfV8pgg46KLDSUj+zyEwi6DT/QPtC2UJB
G2kaVKctUFB62kInRVJpaYktakoRUT+g6+aZgxuueWd75p77nfK9zZn945xz
TWg8GkicO5dy7h+aFJy7gZ6lnWtErfCUPOdO5zg3HRXDBxlfxthH2c4tgG8x
5gVjl9A/oPneueEs58ZQPfwFVTH2B+2b8A7GLGTsIvQJ/oiepu1bP5yLxlj/
GErDi9mjlvmdaDl8Ec1KWc0VcH2wWlV/LXwi1ncCHYDb+fac/t2oAb7jrbYM
6+2D/3jjLtQM7wl2lsVoEO5BLXA5eg9/QGdy7NtU/PjKnNEsq3EULkYltB9M
cC4frmR8J3vXomq4OFgtu1AdXIP+pqydgYuCnUVn2gb35zp3j7WKWLOQ9VrR
EHwQbYcnBlt7lDk58CaUSZuHm+GKYH0aUwWvxZOZtMvRavh6sL11B23wBvQk
bWtorZ/RH3n2DV7FnBkpu4MW+FIwb3TGa3AHY0YYW8mcQbgAj6bRfwqVwK8T
u1vdkbKkGlSL7nclvCyxbKn/CPwh5lP7rYdv++g1e9yCz8XznEW98Fz0kP5S
2ocSy5iypkz3wQ3xvuShvBz2lk1ldMTbGXVWZfg73MucGTl256XUfyGxvbTn
ebgbHU/ZfscTq1G1yqN1cFu8L+2prKxILGvydAm8Jd5XF9oKH03MC3lyEp6d
2No601J4TZyv9XUXfd68Vv8c2leCraWarwbLmO5XGSuA50V/dd4B5p6O/us8
8rIq5ukx2hjsn5U/R1CFt4wpTzqzh/Pi/6ozJPD86L9qGmL8S/J7n/wWM7/I
W6aV7SY0yNi3wbKhN0ZvzVA8jzLUrrcDHc6ytrJV6y37hagEPhPzKE+Owb+9
+aeM/PKWAfl3FL2CG4PtrTerQ+9PvE/5k0/7c7B/X2/GTXhy/B+VwR7lKbGx
mtOfWGbkpTxdRHun9oz50Vv4JpiX+gcuw++CvaX6x7rhbd681ZtRA2cHq1Ue
p+ACb2e9i4d9eBmCvW3yXN5Xe/NWHtXBZd7eCtWQgf8DEdrHBA==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.5211881914664742, 0.4868712493971635, 0.5126880919174721], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtlUdMlUEQgFdUeMj//n3IQ0pE7BpNLLEmxkRjQYiK5SFij4lXPdkLdmMM
YAOJUWyYmHhQSPRiuepF7DGiPMBKYk9sN/0mM4fJt//uzO7M7sz8A9ZuWLQ+
xTl3BumOZEeda+7p3KvAue2hczkR57bB9965Mb2ca4cvMpzb3MO5EJ2JrN1K
c24KbGBtTbpzK+A7ZDT6nbCUuRvIPKQKmw5sy+EJbI6yf2eoOrL+ke/dyAek
C7nJ3AJkPlLidVzs9bvL9CJe7dJgGb7cSVOfUvh+z3wqrOC8Ns5NBOq3+P+P
ODIYb2Ich0Pxowm7Vu6gNxJPJX64EvvVnFcBN/CdQOcHLMMmie0KuJTv/eiv
hR0W+xr41u5N7u84ekXcbQu8zh65+NYMy7HZh+1g+Jq1JnROwyxkI/unwwbW
3qIzF75E3jCuh5eRT4zPw0z0tqAfg0e93vkD+Bjphw/PYC16nei/gA/Rm8NZ
JwL1Q/zJRyojep9yd8e4kyHwCFyCzR5sT8O/EX2738hq81/i2IVeHnPDYD7n
/WH8hnFlqPtvhZ8CvSu5s1/M1URUbxHf+cz3hbO85kM1TPf61gGMsZaFTmC2
VWa/mO/tzJfC9lDn6mC2V18LYEeo/iYYL7M3PQt3hhp3C7yA/Wf2uRJVPdHv
4zXnJPdmes0RiVFqY7nl/CpYY3k5w+vZ4kMr7Ok1T7tbnkpccrdzrTaK4KtQ
Y3kNp5m+2FXZ/deY73Ln1RKv1/hzYKbXuSQ646wepS7jpiO6D+xd5H3KiG0v
MZ6BSdbu48NFGLVakJr4wtpi9vkGL5hOI/zO9xLmf8F37LEjVXNxaqh1Nx4m
o5pPwxmnWE5KbubEnDtIHubF9GzxocLeTXJb8vIcZ9zjrDZ40XL7EuzPXtfY
czDsYzlwnz0LbV7WT2JTwP6PYC5nHGAch95qOYSH0buN/oRQ/RB/nqI/MNSa
HBSqL8Vp6k8uNnlwIazlvFnUS3WgNSm1+TxDcyfX+lad1ZfU2QQ7a7LUDvrt
6BdLHwo0zwvRKWJtqLxrqPcpd1mCzSGbr4UF5kMSu4cWY++Y9gjpFXVS78hs
xqfgz6j2wa+wxWsPPQazYtoHnjA+Z+/XGdW8lvqS3JW3FZ/vIl321vLmbdar
pWdPCnV9OuywviT9qZv1W+m79dajTsGxgf5T2uE6q69GmG1vVO+1p0hvWQZH
mb7YlVkvl1zMtHeXHtBqscejGqfoXZX7tLgkvkuWS+e9vr3kQJbEG9W8TcAR
VvvSA0ZaDkguyBvIWPJY7iBh9yK5JrnRZCI9QOYqrR9Ijc2xupb6/g+8Q/kO

           "]], 
          PolygonBox[CompressedData["
1:eJwtlVlsTlEQx4/S9mt991501aglKOGBhIQQCaFKUVtbSi2ReFUv1krsREQ3
64udROLBkvBieSW22hK1fN/X1q5EJLY3fv/MeZjkd87MmTtnzszcQavqFqxJ
c86tRXogxyPnVmQ5dwc5CS+KO9eOYiOSBq9kb1S2c6ORTnhC6NztTOduIvvg
2sC5XRnO7UCq4GJs/sY4h7+l8B5sbmE7lL0DofmQr7vok3Are9vQfUKyWE/x
/ktY74WfyQf2u5HCXs51sNcUs2/koTsWmU42+ejvo9+Kri/yED5FTF3EthNZ
AU/FvoJvf0A/GW5GrmfZXiM8izMNMftGAn7KXv9ss3kExyOLdR7rcrgmsLsX
IQsCi0Gx6EwO/AgfRTG7o+7awplrnJ2LzICHsHeJ+xagr4f/9XRuA7lPIdXk
f3NoOt3pnu4T2VvpzZbBD3z+CmWj3ISWO+VQbzXd30/xPIHLIvv2R2xicCc2
f+BGJAV/jtt99KZdcAE2v2JmUw0f9v6VI+Uqg7338Bx8lsIJH59qph0uICe5
+NqCzIOPIp1+XQHPRerhHCQfHohsh/sixfCQwN5Oe9IN5puXuVs50sZ6jj/f
gRyBLyBf4Ur0XfBB7jAj3Wr6ANzh61kxnoVnY/M2w3wshBOB+b6KJOHKwGJ9
h5TBfXjTYl+PefAv9qozLd/jiG2Zj1c1dwY+F1mtq+bfwmd9PS7E/hu8yveP
Yj6tXBHjemJNIlXw98BsbyBj8B8PLFeKV3dPYXM13eovAdfG7ex09prgL/68
vnkenhm32ipD3wL3C+ysfOTBr5Ar2M9EUoHlULnUHT/Bz30/qMYLuP8Pr1f8
q+El/v2UA+ViWGi9KJ8l8OvAfKvmB7C+yLoq02JUrONDmy3yWcd6rJ8fsvnJ
en5gtaFvVMONoZ8tyGv4oe8vvVErnPT9rJotg3N72dtJfwh9ru6bbj4Ldf/Q
ekH+DsE1fj6q/ovgxX6+/UbaQ+sJ6WSzBG6IrBcUQxN8xr+/5uGJyHzKt2Ju
hh9HFovsNRsqfL2pZyL4jbdXD+aiXx6ZL/k8Ddf6tWJSbN0jm22aCZoN+ZHF
qhz0hlN+/qoH3sEdgdW2al61/yKwXtIb6a2Gh9YLmmEj4EpqJkH9rENy4lYj
slUPtcMTQ6tVvZlmf5vvJ/X8SzgZt1wr52/gc75f1QP6lwzw9agZpFk0LbJZ
qxmmWXbPz3fNnG6sMyObZdrT7N8U2izUjBgJ7/f1oXgmqRbwWZpud6iB/wPH
b/aB
           "]], 
          
          PolygonBox[{{3347, 1556, 3346, 3288, 3289}, {3281, 3280, 3215, 1349,
            3221}, {3289, 3288, 3287, 1352, 3279}, {3283, 3282, 3291, 1458, 
           3118}, {3278, 1351, 3217, 3285, 3286}, {3223, 1350, 3284, 3282, 
           3283}, {3222, 1457, 3290, 3280, 3281}, {3286, 3285, 3272, 1555, 
           3345}}]}]}, {
        EdgeForm[], 
        RGBColor[0.6864645557774894, 0.5449555946821848, 0.4155288234407091], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtlllsllUQho8gbX///3ynUEDbgsWIgpiYCCReQUAEKQVRXJAoYguiV3qj
lk2NC0pECpRStkBKkEURo9AL71Qu1LYsERHZ2lIgyBLUuCWgiT6Tdy4m73xz
5szMmZkz57ut7qUZL/YKIRyHekN7ikOYCD0IrUwhtOZCWA0+BV0vCWEw+A9Y
i/waeCxK/0fwlSyE/shezbRvKrQXqspk7xQ6qTSEiptCOICdN8G3obegyazV
F4VQHSWztUon48uhd1zX1lcVQjh7YwhPgwNLtbYem4vxNYAYhoIDwU+LFdNe
j2cKNAa9anA8WML+UuycyIfQBv9RnxByUTZegxZDd7utheDLUBl8vcvM9hJo
XJL9CeDuPrIzoY90Ladm7yQ+Ir6Ognl8fMx6Oz5HQFPhtxSUJ8tnN7noSDp3
xvmGsf9L5F9DW5HX4esZ8E/szEQ2mng6oeHo1YDlrP0LPwScmGnfWLA9KRcr
knJpeRsEzUXWllNdKz3f+3Ii4z/PqW6tXtNmzrCdhpkPzsvJl8VU57z1ymR8
nuEck8A1xNkJ3xjVB3bOn8ATUXrHwdNRukfBccS6H74afAEfO/G1CWzgewS2
N4D1UTqmu8l1GvKSfVWsXFj9zb7ZbfGYLfYGj8fimkguaoi7CLxCDQYhvwRu
Z+0q/GXwe76rqVEzuAzZu9Av0HvQr0XSO8zaJ+icAPdEyXeAG6Au+CZwJ/Qb
/GdgbVLungMr+L4V+Z3gOc6zmtg3ZtJd5r6q/O5dQL4D/gB7d4EXo9avgKWl
ui8RHFCqu9IP7CSmVmLrBvuhuwBaVKS4Jnmdtkadqy7qzHam3VG9aLmq9z22
1/S3JfVMD9iM3kJk0yx+vtuRf5i0p2+R1n7A9xRiWGcYZacmqvZWo9s5V7ef
/Sw4O6kfW8D7k+7uWHB+VN6fBQd5n1u/X/E87AIHQ5XwQ8A50FL4FquJ168W
viJphs1K0jP9oR5Xl59xqdf4qtfP5CvBh6JysS4qDtMZHlV764GyqB6yXqqC
X8d57sJXY6b7ab25NlMcFs/zZiNT34633vdZajO13mfOgkz5tVwWouaXzbH3
wftYe5K9f3m9bIZYzZLHafGeJp59xNYFHk665weT7n+Fz1az3e217oXeaebV
zIL8nCvRPfkm01xssxnoc3gOeIDv15H3xuYAqBG+B9k9Xner/7GC5uMh8Aj3
cBf3cUtePWIz09a+zTRTv8vkc7HP4ifYcwpf/6H/iPMPg40Fzdrqgu6E3Snr
v1He8z0F6Zn+VHAF9ADyNeD5EsVs/mbz3YNOOXhDks/2TPW0WW335nHWFqHT
H+zw98LeDdMz/UWZ3gGza/16xnO+FSyDFrL3sYLsmV2LY3Wm+d4E/hFVx2vg
BfQG47McfnqmfJ7PdP9tDlQS49m8bHaDa31G2ayq9Hlic2WWn6sBfNRrOgM8
zp4EXwx/R5Qv83mzx2m2p7u+7WvyOE9myu88n/dWH+tPe+P25ZWfL8C57Kkh
ntqCvk1+C/wHSe9JG9g3qubWF9ZbJrdeO4Z+hn5XXv3Z6u/PSOheaBTUkRNv
M2iUy022kT076Kv14PkkeTdY5v8J9r8w0m2MhnYm7dsODvO32N7kzR6/neOQ
35MjSe/Pfn9fOvzdtPdzvfvdllcfWo7Mz8UkP5eT8mdvsc2Cke7fdC8lxXMB
/Nvf9N+j/jGWeI+2e98cLMifzUbrg1VJ73QD+IbfQbuLy31m2uwc6/8A17FZ
l7R/TlJMFsPPSffQ7uPmvOxZLawmYzL9eywH/wc5d2Q0
           "]], 
          PolygonBox[CompressedData["
1:eJwtlltsVUUUhkc4Pe1u9+x9Si1S2lJUFNTEBCExJmI0WKWXhMSgLUFoWm9v
+mKEFi/xghgKB1rSFkg0baAXRYgK7yoPaqmAMYqirdALijEK8ZYUffD7XfPw
J9/Zs9aamTVr1pzr25556Ok5zrkdKIN+Sp1bWezcCvQzHHvn2rPOlaIc/BV6
oNC5H/i9Hx7B5vPIfC7BzyXOXVvk3FFsFsE3JMbz+XYbvBibf+HH8WmF96HX
8H0Vleecq+T3P4zPoovYL+D31SLzqYK9t7VsRmvg07FzhwucW4264S34lGG7
FX0CN2CzBdt5qBju5NuHrGcp411we2JrexG9BPdgcz5re+6Fd8YW+200Bvfx
rYOxC2gfvBifI8R7ENXAQ3y7zNh29CTczbdbiP0x47WJ5UT5UA7HGV9AzA4S
P4Xmw5vYY1tke94A34zNImK9jjbBX6PaQpuzmlh78bmftb2LzsAHUAN8DI3D
peT0FXK7EKXwYfx/zdoaf/MmcRPx/oQnmXOU+ZdjPwN/iaqK7YzK8K/Bpgr7
48SfIH4X48cjszkNX0R3wCf5Ng3Py9nZVqIz/J6MzVcxpuBHY9u7cvAwnGBf
ge3LKAfXeTvrCZSHv/GWa52Rzmo5Po3Eq0e3w9WhXrpROVyAZuBG1nMvPDe1
s9Y3jU3jU5m1fF2AR/n2fmRrGIPvQfWR2WdSO3Od/RrWcE61klqutGft3eds
7cq5cp8n5iR7qyN+D/wXPs34XiHGFXg0sVqdRl/Ab4X9KEcr4JWJnY1qdhX8
FD5vZM1/GL7qrbY0fhfjM4ntXTnQ3RlEY6z/MdQG98a2FtWIauVQamelmhuA
9+J/K77L0AR8H/qo0NZ8J7w/jGuOtfA6YrRnbI/r4VPonQKryU54mbe7sA1t
gCtQddZyrtw3ofGM2e9S/Yf1Kd5GeBdr+iCyM+iEz5VQF4yNzKU2S+xO6G4o
J5exbwu/dWea4b7YakM1tie2NWkuzbkWzhKzIbL8z4FvTOxsdUfVu97zlmvt
/w+4JbVcqkfVwHXYnCi0nOTh9an1rlZsNsItob61hiWxSawzXqrf+JQX2X1W
L5kN9aGc352YxJpjs/ove/bEG2T//fBBNAQnfDsL79CaIqvhnfBAbLWt834T
zvPtWGR7roXz+Azjn+L/LTwZ6kf7US10e7t76jlnvfUcrVU99tnEala505yr
iNfIHN9nrGeqd46ox4T+NQDv9vZ2qCfXw3Whv8rnEd1/b71aPTb1dkeUf8W4
BPd7qyX1sEG4zFvvk498K8J9U01eF1uPqQr1UMn4Em+1pxpsgr9L7C1Qj+6F
P0PPF9kbdgI+gLrCeF9iPUC9QDafJlYz2v8L6Bq4J7G7ozPbntgc1aH+W+Cp
EE81shD7jsR8VQNb4dbQv3UHdBdy4b3TG1eqfhP6p+pHvS/y9jbJRm9jc3gv
tOdfGO9PrRbV0w+mdge3hf3fpLMI9fF/Try9kcql7nCJt5xo71rzefiJ1N5u
vflD8KnUertqao/+C6T21ujOnoR/TO2/hHrQMLw6tV6sN2N3am/8bIg/nVgP
Uy9Tz/ub+X/3xnqjjsD/ARszJFU=
           "]], 
          
          PolygonBox[{{3039, 1145, 3091, 3081, 3082}, {3154, 1244, 3074, 3089,
            3090}, {3090, 3089, 3088, 1040, 3080}, {3038, 1038, 3085, 3083, 
           3084}, {3084, 3083, 3092, 1146, 2995}, {3082, 3081, 3029, 1037, 
           3034}, {3079, 1039, 3031, 3086, 3087}, {3087, 3086, 3071, 1243, 
           3153}}]}]}, {
        EdgeForm[], 
        RGBColor[0.8517409200885045, 0.6030399399672061, 0.3183695549639462], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxFlmlsl0UQxl+l9/892qqlpgi04A0aUQ5R7kNOQb6ooBDKUS6RSxAU8JOK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           "]], 
          PolygonBox[CompressedData["
1:eJwtlllsVlUQx0+0X/u133fvLai1UEJbccXlxSgEpRtVNqG1PhhBg11oqRqM
tlDE9UlldaEudcG40NJSFONGYoyJpS1bhUSpgEaW1raAxgDGNRR//8x5mOR3
zpwzc87MnLk3v+rhiqUXOOfeQ1KQ0cC5e9Oc24GUhs61Jpwbg6L9Quc2wQ+i
X53q3BmkE96YdG5+zLkh1kyGS9jTxd6FyH/oZ4dmSzaLQtujvX8g7fCngbH0
f8PHsPF5zGzeCK9hrgH9j8g6+BBnSOKrEYmjv5+5fHSrkFp4HHOPoxtA7oMr
8NmD7Rvizr0O97GmhPFPrH8RTmNNA2sTyEFsv8t4Hr4/Q47CqcijKeZzH/oP
GJej245MgR9grojYHCSI1fA2fz/FqA3+DulIM5/Z+L+dcSO6EEkLTMSt2Nub
tDPpbFqzFq4O7G664zVws4+3zvAm/DM+x3K2Ds7Qn7AcKBeDyFVwNfJLit3p
bXgpNs5i6zTSAZdzpuuJTTfnmwdfzVyu96fYNjE3Bv0W9I1wCzbKYmavFs5G
nsD+xcj2hM1JJ59V8DTm+olNAeerg1cxV4h+E9IFt2DzurjVyHp4Nj6X4TtC
ZsFzWPMItg7pDnCNv59ioFhUJi3X8qe7lvp6U85Xsr+VuS9idub34ZGk5S4P
+xPRz2d8OMVyPBc+zhkvSrEaupTx80hRzNZo7fjA9qtGc2Tf50fx3ApXsf8H
7lvIfevhDYHVru60Ht6Njc3szWScYFyJXJZq5/kdXZ1/X5qTrjxpd1eN3gkX
hPa29MZug19gzfJUq5lm+B9kQZrV4Fm9Df8+lNOT7F/g60Exy4N3YmMl8T+O
9MKDCculcvql6t3Xl+ba4fGsacd+xPoJoeVcOq35JGE2B3z8cuBxkXOvsrZZ
6+Ew07mnM4gtsofx3MBioTvMUb0ztzjduXOsz4ffwMe18AZkAG5LWK3Ln87W
p54Ts5gqtt2sWcHaTOQr+A7mimMWQ8WyImm9Q/m8C16Nj4/wNxMphgPO90yG
nTEz02okz+djEpyFzeI0i4FioTd02vef+sBqVL5U48/CG1nzStze2FvwOnxs
w1c29nfDQ0gf45sYn4C7ka2ML2HcC6dzhifhp5AkvDeyvTpjxDieaWu1JgF3
ot/P/qmMf4VX4POxuL1hveVFkcVWMa6CS5BZ6XamNfAmH3+dqQ2uR5akm80O
OM4dg1TryTPgXZHlUjFcC78TWq9Vzu9WrTC3D10dsgQeCU03ikxkPMH3D/Wr
XPj7hH1r9M05DA/5+OnMuTobc9PRH+CNTYWHI4vdzchJ+NbIcqkY3gJfHplv
3Um1dcR/z/TG9db3J6z3q8fE8P9QZLGbgvwG72KuLWY1tCdpNaPaUc2VwecD
6516j/r2nYpsr+68BT4QWO+cgfQHdkad9Vv0I3BeZLFQTPRWdiJZ6D9E3wMX
RPY2lSPl6kRosVBMhuHzyJG43Vl3fzkwX+o56j1Dvv/p/V8RWIwVa/XQhfCV
vr7V09TbOnz/U4z07VfP0F7ZGNR7DuzbqLFsn/H1fw8+/4R7k9bbVSOqleGE
9QLZHIB7kvatU099TvlmTSl7O/VNhhf586kmspL2z6B/A/W0JvTpgX0blBPl
Jiey3qB4qFb+Cqw/6hv3MbyDuaa4xegcvDw0X2MZLwvtTeltKeYZ8GLs1aZb
Tioj++dQLPXmX4In+XxpTU1kNmRLPfSb0HqwerHu1AIPhtb79I0rC22P9upN
nWK8ObJa0Fyr8uf/n9TzXoML/fs8ynia6pG5Y3F70z3wZP/90DejBv43sFwo
BvpWjIa2Vz2xIbQep1qRjenw16H1csWoC3aR1Z58yndOaL1U/zD6l/kfr2Ja
Tw==
           "]], 
          
          PolygonBox[{{2924, 937, 2976, 2966, 2967}, {3027, 1036, 3026, 2974, 
           2975}, {2972, 2971, 2958, 1035, 3025}, {2967, 2966, 2918, 829, 
           2923}, {2964, 831, 2920, 2971, 2972}, {2969, 2968, 2979, 938, 
           2891}, {2925, 830, 2970, 2968, 2969}, {2975, 2974, 2973, 832, 
           2965}}]}]}, {
        EdgeForm[], 
        RGBColor[
        0.9186928569328305, 0.6667321423320764, 0.34794785649177473`], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJw1l32Ql1UVx5+F3+7v99vnjcKkQdMYBNNxRuyPFFhAYMUmRybIqaamJKAS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           "]], 
          PolygonBox[CompressedData["
1:eJwtlmdsl1UUxi/0P3kXyjSgSZlCTAQ/iNIyWqAxgAlUokaiEEShlFKGkIiK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           "]], 
          
          PolygonBox[{{2831, 729, 2872, 2861, 2862}, {2870, 2869, 2868, 624, 
           2810}, {2862, 2861, 2824, 621, 2829}, {2811, 623, 2826, 2866, 
           2867}, {2864, 2863, 2874, 730, 2770}, {2916, 828, 2915, 2869, 
           2870}, {2830, 622, 2865, 2863, 2864}, {2867, 2866, 2914, 827, 
           2913}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9450948320623858, 0.7327370801559643, 0.4297939793933957], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNmGmU12UVx3/Mf5n/zG+bSk5p+oI6xhoZw6wwbKUZx86xTBP1nMQVZmdY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           "]], 
          PolygonBox[CompressedData["
1:eJwtl2eMVGUUhu/u7Myyc+/ci0piQUyIoS4GFdgCUkVBEk1QwUIsIBqBZZdd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           "]], 
          
          PolygonBox[{{2758, 414, 2790, 2788, 2789}, {2787, 2786, 2751, 413, 
           2757}, {2795, 2794, 2793, 416, 2785}, {2792, 2791, 2820, 619, 
           2819}, {2744, 415, 2753, 2791, 2792}, {2759, 521, 2796, 2786, 
           2787}, {2821, 620, 2776, 2794, 2795}, {2789, 2788, 2798, 522, 
           2756}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9714968071919409, 0.7987420179798521, 0.5116401022950166], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNWHlw1dUZfXkv6+/+Fux0b0XUTmuLmJAEkEVbldZuakdra1WsAgkhqOyI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           "]], 
          PolygonBox[CompressedData["
1:eJwtl2lwVeUZx0/ukuSe95xzo1O1H9xwabXsmwgoU0U7jlXb0dq64IYLIA4g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           "]], 
          
          PolygonBox[{{2731, 2730, 2723, 411, 2747}, {2734, 2733, 2732, 208, 
           2703}, {2726, 2725, 2705, 205, 2712}, {2715, 206, 2729, 2727, 
           2728}, {2749, 412, 2748, 2733, 2734}, {2728, 2727, 2736, 314, 
           2713}, {2714, 313, 2735, 2725, 2726}, {2724, 207, 2708, 2730, 
           2731}}]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.95, 0.75], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNnXW4VlX2x88bt+FesQtBxcDuHBMdFBOkVFBUjLEdA1CREkURCbtn/Dl2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           "]], 
          PolygonBox[CompressedData["
1:eJwtlUlsVWUYhv9SbgvnnHuvOGB0oaIR3bRUaatGoN2hG40Vh5iodELUUDYM
VahUnNgoxqKMRTEmIIlKK23pZBxoq6WSOOKsO4doopaOdPB587p4k+f84/d/
01lUtb6ibk4IYQeaixriEP5g4DdUD3eiVbkhVKBVcCYTwp58Fs4LoRY+kQ3h
l/msRe3wY6gZLkHXwatZ8zXr69D98Bg6zd5S5ouY7+fMCc5uQjvgd5mvZX6W
9Wvhk4xdi2GLUVESQpTxWXloHjwehbAAWy9AF7H2LGNH2F+OquFu9jSlQihA
nfDmrG09D22EyxPP9XH+CnhJ1nM6owDO54wUd61D8+EP0yEczAvhAOqBG9B+
uBl9AP+DDe/xlh70J/wWe86wt4zz3oGnsbcaW6dzQpiCf0L74D3oe3g0Y999
yvoR+CbOrOLsQdQIH2fNzaxdjtrgfsaWcP4nzG+HY/bszveY5o7y/U2+Y/A2
3MGeMvYeRoNwa8axXIOOw20Z360YKBZ/RV77JjodWWL5fBS+lTc2wk+gM3xf
HpsXokvhNny4mff8jDrgaXw8kXJMzsEjrLka31+DCvguQS/OdcwVe41pbicq
ThwjxepBNK67OLOOe9ehGcUWrYRvQefg0sR7x9CGxG/UW5WDj8I/RI7FbvQt
3MmeVOQc3gJfzB0X8pbz0QL49ti1oTfr7TOcOZlyjG7A37N8V+b5jXqrfCBf
6IyF8GBs25XzA/Awdx3l7iNoCD7Bnmr2nkLj8gVjDxOiz9AeeDljq9nfj8rg
k2nXgnJSuTmeta/lg0n4b+7ozbWPh+FNrFma55zdAvfGzlXVuGp9N/uGuKsY
e3bCU1n7Vj7phrey5nfecgfrG+H9jH/O+kfQS/AVjDUwvw2thJ9nrDb4DXrL
y+gU/BB6Ae7hzLzIMZyGK9jz6xzfobvOxq591ZRqqy/tWijizQNwi/yvXECt
qm/lF1yJ/9rg67PuNQfR4/DGxGuVY+vhpzmzkLN3oWdj2yzbZcNtsWtata0e
8BG8Le1aU4xvTLtmVbsz6Dt4a9q9oRjVw5OJYymfl6Sdk8pN9cwJuD1yLasm
VZutaBn8Jf45ENmn8u0a1AS/gZbm2IfypXJWubsX/Qj3Ro6dekon3BV5Tnu6
4Yno/16JLuF9o2gy1zk1FvtO3a2Y7oXfZ6w71zmkXGpm7IvgHtQCDyf2tXJW
uTsWuVaU08pt5ahytZD5eviZ2L2+AD0V2wbZopy5DL4v4177FXoAbsm4l6uH
qZfVZPxvUI9Lw1UZr1WPVa99jTtX5NiHr8Kvo/Icjx2Ct8fO3TtRBzwbOXY1
+gnyfSpyLWqP9l7F2ABzlWhG7+WOw9iTJX6FxO/J2P9G/TP175zijbtS7gnq
DaVp58KQcgDOYU0Vaz9Gi+ENWZ+lHrlJ9ZV1rqomurK2UbYqBj2xbZAt+ocs
4rudO6pSrgHVQldiX8uGnsQ1olrRPzvB9itjv1U2yJZXOG9tcM2r9p+LXQvK
iT74ntixkg/ugo8l7qWqMdXaMlSTsg0j8LGM/3Xy0b/w3bHfqhq7V//6xL7Q
Hu3dF7m3KaeUW/8Bfb48cw==
           "]]}]}}, {{}, 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwV0TtPk1EAgOHjhAIqmAjRAXV0AEzULrgZYlwkaZxMVAI7LJTWCIm4kxBd
wAtVByMk1bb6tSWpItAJxdUfAQ1oq7aw+DA8eYdzcq4XRsbjY0dCCGlmW0OY
Y563POMlOT7yiYgCRTbZosoP/tLRFkJDT2tTz2gP1znPDW6RJM4Uj8jzmCJl
tvnKHjUutofwR3v1CjEmmCRLkogiNUo02OfqcfN4yBemWWODlhMhHOMO91hi
hAwfyPKbGn0n7ckkEUUa7JPigCYlCiRJ0E8vdWuMkmOZ99xnmLu0cpSKc61T
ZpUpUsS4TNOdrh2+BwMUyJEnQ4Lxw3tT8WaXdEPr/GKHKp9Z4TYRM0yT4gFD
3OSnfxzUc5yli246OcU/4zW+s8s33vCaV6RZJM8LFnjHc57wlP+cOWRM
           "]], 
          LineBox[CompressedData["
1:eJwN0LkuBAAQBuDZ1h6eYV01GhSOZ5A4anElgpYlrnVVVHgBnUThKHaXcm3i
Ddxewq7EHr7iy0z155/JzqyOryQiYpmTtogzLrmiRJEvPnjhnToNupIRWZr2
TnOCKfIccMwTFZ75ZSQVMcY6BUr80aDFYDpim132eCKZiUgzyzyL3HLPD1X6
2mWyQYESdZps0aLBA0U2ydFPLzUZS9xxwwJzZEhR0aNMnh2GGKCpc50HiuRY
Y5Rham6uUuaIQ/aZZpIeEnTQTdDyz1fe+OSbAo9cc8oF5/wDnXFHKQ==
           "]]}, "0.9`"], Annotation[#, 0.9, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwV0UsrJWAcwOGXhgVjbCyUoTQbdVxKSmbKelI2ToqyoaRJcS4spPgI8g00
dRzXXI5bJkKuKxTzBSYWFjg62M5j8fR7F2//3kt133DHUF4IYYrpohBSrLDP
Cf8444JnXsjxSllxCBV8pZlKfvCTYdpJMs4ckyyzxR0PVH02U6s1QgO/aCRG
gnmSrLBBlhx1JSG8fezVGCNsM8Yue+R/CaGAKF38ZpYe5ljkiSyRUucmzhoZ
cryR5J1XNlgnQYxaang2o5clUqSZoZtOCvnEgXP9YZMdRknQRD0NRHhxt+9k
SLNAijgDDNJPLUfe8Jse6iP37LJKlEUmGGGIOG208tdftuit3lBufa1XXJLl
nGPuOOWAVdLM8x85RVg3
           "]], 
          LineBox[CompressedData["
1:eJwN0LsuAwAUBuBTDYNbyxuYXDcshMTlCWyug8RAqAegaNK6SwzewCas7r2E
pfUWNokX0DL4hi/nn07+c3pWt+cyiYhY46o14oZr3njki2RbRBP99LFML/Ms
cMIpF9So88tUe8QMO+xRpECF6IgYY4I8hxxRI9UZ0cU6m9zzxDM/NBhJRWQ5
oEiZSOtJXk6aCSpyiRz7jDJM3Y4MLzywxQbdpPnQo8oxBSYZJ0lZ/xwlsuwy
yzR/7m5Q5ZIzzllkiSFWGGSAFpr59udP3nnljlv+Adk8N8M=
           "]]}, "0.8`"], Annotation[#, 0.8, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwN0TsrBVAAwPFzM8jzDrIoA+WZxEaRRzJIQrJYZNLlXiEGAx8EeQ7K+5Gy
uN+BEYW843oNFspv+PU/p06n8ygaGutNREIIcyQzQ7jllfSsEHKoJkoejTTT
SjsTTDPDCltccMQ1T+Rnh/CuBVpCOcPEWSbBBlvcs8MbH1TlWEsto4xzwDG/
hNwQOkijiz4WWWGNF14piYaQ0gqNEWebXT744p1vPtljhwQjVFJKGcW82WuA
debpp4dZZ+rUCH/GJxwySZwfd4ppDWWkzOt5pI5NllhlgVEGKSXpDQv1VJ+5
4ZIr9lmlh26maKOFBpo496dn1BjnkkHK/I4H/gG1uEn0
           "]], 
          LineBox[CompressedData["
1:eJwV0L1KgmEYBuDH+CxI+4GMcPQYAisI+oG0ua2pkubsDAq1KJeoTqYhpE/b
NKOtM4g6hCzpari47+l5ud9Srb53komIfdLpiA+SXESOkb4sjzjgjhv6DPll
zE4+osoZLZqkZGYiskyywTbX9BmyMBuxyBJ1HunwxIjyXMQqDS5I6ZHMu8mV
PiWzPOtdLmmyxgo/7pRIeeCUN28XZYFXfUCbTbZYJ2GCrh1tGpyzS4X438fA
/hduueeQY8p8+7+8fJdffPIHXm0wBA==
           "]]}, "0.7`"], Annotation[#, 0.7, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwV0E8rA2AcwPHHTfn3Amhsc6EkJ3KUpFhpF+I2s5nN5ux1KFvEwUybtaXc
vByrDeNKKXwcPn176unX8/yiqVKyOBBCKDE4FMIcSxyQ55wCJ9xSo0GbZ7qM
D4cwxS4xUmSocMQNNTq8Eh0Joa8zuk+OBkVaPPDJNyujIfzqmibY4pIrurwQ
HTOHaTIcUueeN94p8EGfJg1yZP/vmJHWOBF6zttcUybJOqfesao/+sUjbeo0
yZNmlhhxIvT8dZEqZS44I80Oe0wywZN9dmhRp8odm2xQ4Zgsy8yzwB/YpkAt

           "]], 
          LineBox[CompressedData["
1:eJwN0LFKggEUBtArZZlaOUVYi68QtVTQUDoUCvkINtVQWO+QSQUFugk+iTTo
rw1Fls+TdYbDB3f47uWWGjf161REnJPNRezQ4JIOPb6Zks5HLHBKlXvaDBkx
IbMaccwJjzzzyg8baxFFtmnyxpARv/xxuB5xQIuECZlCRI4V8mR5Nx/TJjhi
n7mOOxIG3LLFzP5NOZWfvPBEmQrLfLg/YUyLB2qcscgSX/4wo0+XKy7YY5d/
tnErGQ==
           "]]}, "0.6`"], Annotation[#, 0.6, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwV0EsrhFEYwPHHlsGOGaNQbtlaKcnGwkrZitc7MnYsfQsLC5cpIs2MjVI2
PogsLFxm3DeKUmPl9y5+/U9Pp9M5Z6i0tbjZFhEJ5Y6IPU644Y72XMSDNui1
LrDMCilrHHHKI81sT2fEq47oEuOsUqbGBd/8MtUV8aczOscu+1Ro8kKx23k6
oAklqtSzOR+88ck759RYJ2WQAv3keXbWAofsMM8s2+4xrS394ZI6G6R8Ze/W
Ufoo0jB7YpJjJhhjmIQe8lz7vyty1vd6yxkHVPgHYRw3qw==
           "]], 
          
          LineBox[{2920, 2971, 2958, 3032, 3079, 3087, 3153, 3152, 3148, 3212,
            3275, 3273, 3337, 3341, 3400, 3401, 3470, 3475, 3474, 3542, 3541, 
           3613, 3700, 3703, 3704, 3782, 3785, 3792, 3901, 3905, 3978, 3980, 
           4041, 4043, 4110, 4112, 4109, 4113, 4111, 4044, 4042, 3981, 3979, 
           3906, 3902, 3844, 3783, 3784, 3778, 3701, 3702, 3614, 3548, 3540, 
           3481, 3476, 3471, 3402, 3403, 3338, 3339, 3274, 3277, 3211, 3151, 
           3155, 3154, 3090, 3080, 3033, 3026, 2974, 2973}]}, "0.5`"], 
        Annotation[#, 0.5, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwVz7tKggEUAODTGGYN2RJIBs2BIDg1NDcEUZR0Ax8gH6NBEMU0cFIqCHwa
CZdIf7pBJkSD7X0OH+dwOJzLZrlycLUQEfsMUxGLSxGrHFKiRosBbTq8MCab
jsixxTGXdHngmz4/zCgsR+xQpcENz7RJeGN9xU7O6XLHKx8kfPLOPT0uOCXL
2rzXjCYj9mhxzS5F/tzxyxdTHulR5mRe89OEDflITMizzRO31DnjiAwp0vwD
VGQxPA==
           "]], 
          
          LineBox[{3031, 3086, 3071, 3158, 3145, 3218, 3278, 3286, 3345, 3344,
            3340, 3405, 3478, 3477, 3543, 3547, 3615, 3616, 3620, 3707, 3706, 
           3786, 3841, 3842, 3846, 3909, 3982, 3984, 4045, 4047, 4114, 4117, 
           3992, 4118, 4115, 4050, 4046, 3985, 3983, 3907, 3904, 3845, 3843, 
           3788, 3711, 3705, 3627, 3618, 3619, 3544, 3545, 3480, 3479, 3406, 
           3343, 3342, 3347, 3289, 3279, 3219, 3213, 3159, 3074, 3089, 
           3088}]}, "0.4`"], Annotation[#, 0.4, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{3215, 3280, 3290, 3348, 3352, 3409, 3414, 3482, 3418, 3421,
            3490, 3491, 3565, 3567, 3635, 3638, 3643, 3718, 3725, 3727, 3803, 
           3804, 3860, 3923, 3863, 3926, 3930, 3997, 3999, 4061, 4064, 3936, 
           4066, 4062, 4002, 3998, 3932, 3928, 3808, 3924, 3862, 3857, 3806, 
           3655, 3728, 3642, 3721, 3637, 3640, 3439, 3569, 3429, 3492, 3420, 
           3413, 3484, 3417, 3410, 3356, 3349, 3291, 3282, 3284}], 
          
          LineBox[{3217, 3285, 3272, 3350, 3407, 3411, 3404, 3486, 3552, 3551,
            3546, 3622, 3623, 3710, 3789, 3787, 3847, 3848, 3911, 3916, 3912, 
           3986, 4048, 3988, 4116, 4120, 4051, 4121, 4119, 4052, 4049, 3910, 
           3908, 3913, 3914, 3852, 3849, 3791, 3790, 3709, 3626, 3624, 3550, 
           3549, 3553, 3487, 3399, 3412, 3408, 3351, 3346, 3288, 3287}]}, 
         "0.3`"], Annotation[#, 0.3, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{3483, 3554, 3561, 3629, 3633, 3713, 3717, 3794, 3720, 3724,
            3799, 3801, 3858, 3920, 3922, 3993, 3995, 4057, 4059, 3927, 4060, 
           4058, 3996, 3994, 3925, 3921, 3859, 3798, 3800, 3651, 3647, 3795, 
           3722, 3714, 3634, 3630, 3564, 3555, 3556}], 
          
          LineBox[{3485, 3557, 3625, 3631, 3621, 3715, 3793, 3796, 3853, 3850,
            3851, 3919, 3915, 3991, 3987, 4053, 4054, 4122, 4056, 4124, 4123, 
           4055, 3990, 3989, 3918, 3917, 3854, 3856, 3855, 3797, 3708, 3716, 
           3712, 3632, 3628, 3559, 3558}]}, "0.2`"], 
        Annotation[#, 0.2, "Tooltip"]& ], {}, {}, {}, {}}}], {
    DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
     Identity, Frame -> True, FrameLabel -> {{
        FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}, {{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 300, 
     Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
     FormBox["\"(a)\"", TraditionalForm], PlotRange -> {{0, 1}, {0, 1}}, 
     PlotRangeClipping -> True, PlotRangePadding -> {Automatic, Automatic}, 
     RotateLabel -> False, Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               "\"Markov\\nmachine \[Eta]\"", {FontFamily -> "Arial"}, 
                Background -> Automatic, StripOnInput -> False]}, {
               GraphicsBox[{{}, {}, 
                 
                 RasterBox[{{{0.20688222567667713`, 0.36271234759815396`, 
                  0.5951436716654596}}, {{0.35591182715545927`, 
                  0.42878690411214226`, 0.6098473603942348}}, {{
                  0.5211881914664742, 0.4868712493971635, 
                  0.5126880919174721}}, {{0.6864645557774894, 
                  0.5449555946821848, 0.4155288234407091}}, {{
                  0.8517409200885045, 0.6030399399672061, 
                  0.3183695549639462}}, {{0.9186928569328305, 
                  0.6667321423320764, 0.34794785649177473`}}, {{
                  0.9450948320623858, 0.7327370801559643, 
                  0.4297939793933957}}, {{0.9714968071919409, 
                  0.7987420179798521, 0.5116401022950166}}, {{1., 0.95, 
                  0.75}}}, {{
                    Rational[-15, 2], -150}, {
                    Rational[15, 2], 150}}], {Antialiasing -> False, 
                  AbsoluteThickness[0.1], 
                  Directive[
                   Opacity[0.3], 
                   GrayLevel[0]], 
                  LineBox[
                   NCache[{{
                    Rational[15, 2], -150}, {
                    Rational[-15, 2], -150}, {
                    Rational[-15, 2], 150}, {
                    Rational[15, 2], 150}, {
                    Rational[15, 2], -150}}, {{
                    7.5, -150}, {-7.5, -150}, {-7.5, 150}, {7.5, 150}, {
                    7.5, -150}}]]}, {
                  CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -116.66666666666666`}, {
                    Rational[
                    15, 2], -116.66666666666666`}}, {{-7.5, \
-116.66666666666666`}, {7.5, -116.66666666666666`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -83.33333333333334}, {
                    Rational[
                    15, 2], -83.33333333333334}}, {{-7.5, \
-83.33333333333334}, {7.5, -83.33333333333334}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -50.}, {
                    Rational[15, 2], -50.}}, {{-7.5, -50.}, {7.5, -50.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -16.666666666666686`}, {
                    Rational[
                    15, 2], -16.666666666666686`}}, {{-7.5, \
-16.666666666666686`}, {7.5, -16.666666666666686`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 16.666666666666657`}, {
                    Rational[15, 2], 16.666666666666657`}}, {{-7.5, 
                    16.666666666666657`}, {7.5, 16.666666666666657`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 50.}, {
                    Rational[15, 2], 50.}}, {{-7.5, 50.}, {7.5, 50.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 83.33333333333331}, {
                    Rational[15, 2], 83.33333333333331}}, {{-7.5, 
                    83.33333333333331}, {7.5, 83.33333333333331}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 116.66666666666663`}, {
                    Rational[15, 2], 116.66666666666663`}}, {{-7.5, 
                    116.66666666666663`}, {7.5, 116.66666666666663`}}]]}}}, {
                 Antialiasing -> False, 
                  StyleBox[
                   
                   LineBox[{{7.499999999999999, -149.99999999999997`}, {
                    7.499999999999999, 149.99999999999997`}}], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.499999999999999, -116.66666666666666`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -116.66666666666666`}]}, {{
                    7.499999999999999, -83.33333333333333}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -83.33333333333333}]}, {{
                    7.499999999999999, -49.999999999999986`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -49.999999999999986`}]}, {{
                    7.499999999999999, -16.666666666666647`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -16.666666666666647`}]}, {{
                    7.499999999999999, 16.66666666666668}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    16.66666666666668}]}, {{7.499999999999999, 50.}, 
                    Offset[{4., 0}, {7.499999999999999, 50.}]}, {{
                    7.499999999999999, 83.33333333333333}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    83.33333333333333}]}, {{7.499999999999999, 
                    116.66666666666669`}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    116.66666666666669`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["0.2`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -116.66666666666666`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.499999999999999, -83.33333333333333}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.4`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -49.999999999999986`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -16.666666666666647`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.6`", TraditionalForm], 
                    Offset[{7., 0.}, {7.499999999999999, 16.66666666666668}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.499999999999999, 50.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.8`", TraditionalForm], 
                    Offset[{7., 0.}, {7.499999999999999, 83.33333333333333}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.499999999999999, 
                    116.66666666666669`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                Scaled[0.02], PlotRange -> All, Frame -> True, 
                FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                Opacity[0], FrameTicksStyle -> Opacity[0], 
                ImageSize -> {Automatic, 300}, BaseStyle -> {}]}}, 
             GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.10574959362802852`", ",", "1.0526484478737583`"}],
                  "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"0", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.1`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.2`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.3`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.4`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.5`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.6`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.7`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.8`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.9`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", "\"Markov\\nmachine \[Eta]\""}], 
           ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "300"}], ",", 
           RowBox[{"Ticks", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.1`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.2`", ",", "0.2`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.3`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.4`", ",", "0.4`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.5`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.6`", ",", "0.6`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.7`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.8`", ",", "0.8`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.9`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.744627580966202*^9, {3.744627642722864*^9, 3.744627656099311*^9}, {
   3.7446278217109256`*^9, 3.7446278334153614`*^9}, 3.7446278697317333`*^9, 
   3.7446279747899466`*^9, 3.7446280691907806`*^9, {3.7446281301035757`*^9, 
   3.744628222066619*^9}, {3.74462825899251*^9, 3.744628267118354*^9}, {
   3.744628353627688*^9, 3.7446284093837347`*^9}, 3.7446284429029737`*^9, {
   3.7446285598306656`*^9, 3.744628591881029*^9}, {3.744628650668621*^9, 
   3.744628677108943*^9}, {3.7446287446474795`*^9, 3.744628795027913*^9}, 
   3.7446289029614334`*^9, 3.7449809959804587`*^9, 3.7450775476661873`*^9, 
   3.7451468611491294`*^9, 3.7487866516081266`*^9, 3.7487866834137173`*^9, 
   3.748786796614718*^9, 3.7522836715864067`*^9, {3.7522838438703365`*^9, 
   3.752283877920828*^9}, 3.7522839107211895`*^9, 3.752283951209866*^9, 
   3.752283996042759*^9, 3.75228403404679*^9, 3.7522842321459627`*^9, {
   3.752284402929739*^9, 3.7522844111024804`*^9}, 3.752284623609459*^9, 
   3.752304026487203*^9, 3.7523118985977807`*^9, 3.752312711829281*^9, 
   3.7523137836274347`*^9, 3.752314493644038*^9, 3.7523147975811205`*^9, {
   3.7523151414867115`*^9, 3.7523151595042834`*^9}, 3.752322810296859*^9, 
   3.7523256853536386`*^9, 3.7523258514580956`*^9, 3.752326476963775*^9, 
   3.7523277864916916`*^9, 3.7523325944976435`*^9, 3.7529312689316845`*^9, 
   3.7529313332528887`*^9, 3.7529315875633326`*^9, 3.753006995571727*^9, 
   3.753007165886692*^9, {3.7530072155638156`*^9, 3.7530072235803204`*^9}, {
   3.7530075437384586`*^9, 3.753007573054043*^9}, 3.7530076558284917`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["(b)", "Chapter",
 CellChangeTimes->{{3.7530090014422073`*^9, 3.7530090021142435`*^9}}],

Cell["Compile \[OpenCurlyQuote]simulatebatchefficiency.c\[CloseCurlyQuote]", \
"Text",
 CellChangeTimes->{{3.7558742983873234`*^9, 3.7558743053565836`*^9}, 
   3.7558743383446693`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Run", "[", 
  "\"\<START /B gcc c\\\\functions.c c\\\\simulatebatchefficiency.c -o \
c\\\\simulatebatchefficiency\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7530078554746957`*^9, 3.7530078569592595`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530078598032565`*^9, 3.7530252632071977`*^9}]
}, Open  ]],

Cell["\<\
Create a function that runs \[OpenCurlyQuote]simulatebatchefficiency.exe\
\[CloseCurlyQuote] for a set of inputs and sends the output to an \
appropriately named .dat file\
\>", "Text",
 CellChangeTimes->{{3.755874583020319*^9, 3.755874658466021*^9}, 
   3.7558747932456183`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"simulatebatchefficiency", "[", 
   RowBox[{
   "asteps_", ",", "ksteps_", ",", "maxn_", ",", "length_", ",", 
    "entropyn_"}], "]"}], ":=", 
  RowBox[{"Run", "[", 
   RowBox[{"\"\<START /B c\\\\simulatebatchefficiency \>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "length", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "entropyn", "]"}], "<>", 
    "\"\< > data\\\\simulatebatchefficiency-asteps\>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\<-ksteps\>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\<-maxn\>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\<-length\>\"", "<>", 
    RowBox[{"ToString", "[", "length", "]"}], "<>", "\"\<-entropyn\>\"", "<>", 
    RowBox[{"ToString", "[", "entropyn", "]"}], "<>", "\"\<.dat\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.753007804063181*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"simulatebatchefficiency", "[", 
  RowBox[{"21", ",", "21", ",", "25", ",", "10000000", ",", "20"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.753007879055349*^9, 3.753007890384869*^9}, {
  3.753007980487962*^9, 3.753007991504749*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.753007891056577*^9}]
}, Open  ]],

Cell[TextData[{
 "For ",
 Cell[BoxData[
  FormBox[
   RowBox[{"k", ">", "0.08"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " the binary batch efficiency is equal to the Markov efficiency so the \
previously calculated Markov efficiency is used."
}], "Text",
 CellChangeTimes->{{3.7558754196556273`*^9, 3.7558754771929426`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"batchefficiencyplot", "=", 
  RowBox[{"ListContourPlot", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
      "Import", "[", 
       "\"\<data\\\\simulatebatchefficiency-asteps21-ksteps21-maxn25-\
length10000000-entropyn20.dat\>\"", "]"}], "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}],
      "~", "Join", "~", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
        "Import", "[", 
         "\"\<data\\\\markovefficiency-asteps51-ksteps51-maxn20.dat\>\"", 
         "]"}], "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], 
        "\[RightDoubleBracket]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
         ">", "0.08"}], "&"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", "\"\<\[Alpha]\>\""}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<(b)\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"BarLegend", "[", "\[IndentingNewLine]", 
      RowBox[{"Automatic", ",", "\[IndentingNewLine]", 
       RowBox[{"Ticks", "\[Rule]", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "}"}], "&"}], "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "0.2", ",", "0.3", ",", "0.4", ",", "0.5", ",", "0.6", ",", 
              "0.7", ",", "0.8", ",", "0.9", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "0.2", ",", "\"\<\>\"", ",", "0.4", ",", "\"\<\>\"", ",", "0.6", 
              ",", "\"\<\>\"", ",", "0.8", ",", "\"\<\>\"", ",", "1"}], 
             "}"}]}], "}"}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
       "LegendLabel", "\[Rule]", "\"\<Binary batch\\nmachine \[Eta]\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Contours", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "0.2", ",", "0.3", ",", "0.4", ",", "0.5", ",", "0.6", ",", "0.7", ",", 
       "0.8", ",", "0.9"}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7523237780911984`*^9, 3.7523238486924505`*^9}, {
   3.7523239552460375`*^9, 3.7523239910458374`*^9}, {3.7523252804585705`*^9, 
   3.7523252809898763`*^9}, 3.7523256763997464`*^9, 3.7523264909027643`*^9, {
   3.752327836981428*^9, 3.7523278407162313`*^9}, {3.752337785675407*^9, 
   3.752337789972703*^9}, {3.752930937302685*^9, 3.7529309489914613`*^9}, {
   3.7529309846045775`*^9, 3.7529310059662313`*^9}, 3.752931349598358*^9, 
   3.752931583125333*^9, 3.7530079256540513`*^9, {3.7530083188370934`*^9, 
   3.7530083569505606`*^9}, {3.75300904949397*^9, 3.7530090677147293`*^9}, {
   3.7530091080626965`*^9, 3.7530091085002303`*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[
    GraphicsComplexBox[CompressedData["
1:eJx0vXVc1Mv3P24HdjcWYnvt1hE7rsi164qK3d2BiY0tJoIrWIiEioC0CqgL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     "], {{{
        EdgeForm[], 
        RGBColor[0.148, 0.33, 0.54], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtkz1PlFEQhS/auJgrXCypKLBRotLYCNqQGA2gxohWGo0aLbQ1EdnVRfA3
uLCAxsUVC4yoEGwsZFdNJMYPbMz6ERMTQ6EJBWjhM5lTnJyZ+847d+bM3JZT
lw5fXBdCOAnWg9kYwrO6EB7DV+G74AoYxc/DY/ATMI89DZfh++CeYu2fSXCE
b0NwH/wlE8I3MAgq+E85X4Bfy34E70ge1w734F/j/ED0XNk6v2dS95SsnvoQ
CmAPeNEYQnVDCDfhDP8M8L0Z7uTbCNirOIvvAO/Uo/X6Esxiz8Bz0Xt5GL1/
i1lSDSX1txm/Hx6OnnsNFMX/ZC9QRyu9hOQxRdUwIk1uR+/T+t0JHyT+AvX3
wsOggp2FTxB3g/jj8FHpfwjeF12T3dHrszrfwr9BFbsGTyTvdxR+ox6r0bU2
zR/AXzOui2lidg3kwV/81XrXeFW6mV2W/qbHonbgFfwdVLA/R89r+W3O04pZ
1CxMA9uDdu1WC9wFrmPvh88lr+V08rOcduuX8v9UzRZjtRbxBzm/Fb0ui7fZ
b0v+vQ1uaPLZLEnvTtXQg77n0Tnf6HVXdI/N8NhG9hZMSP878IfkWnxMns9i
LPZs8pxn4BXpv6w8lsO03NTk9qfkuSxnIfqZ5bSY7arZai8oxuY/pN2wHXkv
Pe39Nah+62NG852SrlnNKBf97V7Wm+jXHk8p3vaippp/RN9L28/x6L6dr+gt
lpX3j7SymT/n7i32puGt0fXfBXdrLr3R37/ltN0vaX8GNNec/HG9kzH4P6xQ
t5o=
           "]], 
          PolygonBox[CompressedData["
1:eJwtkr0vg1EUh8/bGPqSy/taTR2IRMTHYsEmEYIQ8bEShIE/wEfRav0HBNV2
ZDOVsBi0xSQ+N0aLgY3Jc3I6PMnTe88993fu29jMythyRESaoQrigUgpKtLo
ixTxrBNJeCI7kMcbYAPfhBa8RE0TtWXO3OADrG2zl4QhfDewvSVI4S+hyG+1
yGSNSG29yIGzWj2zh+/Dlmd3ZvRuzixGLVM6sBqtPYUL/C20XlMQ0M/jd4I8
79CGdznLqmf68G6I4+vQic9S00OeQ8jjEUj6NtM192VC29PMz3gHfPhWo7WD
lbzasx//gjJegh982tnb6TwTeGto2fTOBbzA2olnPXR2Ce3tdQadJc3ammdv
7uMPcIVfwhNehAJ+Drf4aOV7ab9hfKTyvikYxz+dZdOM35rV2VntcY/fOeut
dzzir2T4I+sR5EJ7Y31rXavDz5x9C51BZ8mGVtsL8/hcaK5v1o7nnGXRTMd4
zNm3WNX/FP4PWbVb7w==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.3100051463403675, 0.41265356580651896`, 0.6368340353781865], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtldlLllEQxs9XYGrvye/1P4i6qWi7rstoscwWFdrMpe1KbyLqqrJIM1PT
Fv0wF4hQykpKxcK0XCotytI2W6gu8ipIsI2SfsPMxcMz7zkzc+bMzJl3dm7B
pvxpzrkKMB289s71R5wbhS+Aq8gx+HKScxNxzh2Ca/g+y3ozfC2iOi3gJCgC
O8G5wLkt8Ap0KsEZ5Ap4ivVdyFnIWaFz1YnObYdPRJ0biHeuGF7C93LWd8On
0L1pvk+Dtoiu5RjLehy+8uCI17U80230Gle9xSnydVAKckEJSGdvO5wGbzM/
4q8b7gF3RZc4PiQ4twi+yN4V1qrtrDaLrxhky71MLrHvXGP5TsVmK5wCfwV9
yE+8ntEV0TNzLH7xvcr0D5CzQs6fC44kaP7kDmVgHfnaS97WwuesLlKfaLJz
mTOpJzEPUrNrM6gpfAS9fvSPwkmmI7qF5lvuOYJeC/pP4QH05rB2GF7N93d6
4ECSQuT8JD1bYlgJN/Gdhu1zuM9rDj/B2cRxgZrWwv1RvcsDuMjiOQb3mL7Y
vcB+A36a4T3YxLCth1+yN4DOWzgFm33YroED7rCZu7xAZybyD/RHkCfhn4m6
J3dNBxmg03pbevy49V4h/AccJrZ52NZZ3zR4tdtstiL/StQzjiaovuSoIdT1
V6HGJLGlwn/Np/g+j68qfJ71GleG+a1g7TaoBO+s/3q99o/UWmoeCfU8B/8O
tFcmAu0P6ZNS+DM2vchj8D1wA/kOvNhsxUeTxSCxdGGzDbkVbrezboG96C0j
voXwl0Dj+BboPcTPe1Ab6Nu5Co+CHchDgb4NeSMdFovME+n1jkDfR3+g71ve
vtQ13WojuWu38+VdzUrW/Ly0OtZYLeeHev5O6ylZl/0OO7dV5o3XXFbBdWYf
j7/HFpPk6ZLNKJlVtebrGfzdemzc69tus5iGbV7J3Bpir5O1h17zJDGIfZnl
sN3mYI7NqF6rabfX9yB9/sZrD8UsF5lea7FF+t9rPwzC9y2OLq8+ZcZKrqei
+mb/weOB7n0MNNZSmznTQn3bS+F7UZVlbb3Xu2/0OoOkPs/h8ojOarlbgde+
LIdHvM6oYXjSZrjM8is2V+UtlZn9fvhZoHNvLNC6xuy9jIZaw4uh5rjP+kPm
svSqvLcFod5L7tcYam7zQv33yD/oIPzIa44H5CyrqdT2P6nADOc=
           "]], 
          PolygonBox[CompressedData["
1:eJwtlUlsVlUUx+8zBOj3vUu/B+xgU3HDoCAsNKEuJYJAmQnzVMAFARYuYCMF
jS1GyqRRkVksEMsUKFCQma9MiRTbggYZEhBJCCZCipBAwu+fcxa/5P/uPXc4
wz2vbPaiMQvfCCF8Bh3gQiGEt0pCWAFn0LOyEMpzIdzmezb699IQKjqFsAda
0dcZG58P4X9s2tBnfX1T5xC+QK8omP4EhqHPQS/ml8FLdAWkPj8KPRLmo/NQ
il7m9kW+q9GfF0zLRrYDM7ub7jgAvTuG8E0Swkn4Ff1uZr7IRrYjCnaWzszQ
P2GzD9s9sA09B5sf2GswzEcfZmw9cyegFT2DsVslNl+p84jBKGLxpGMIdeg/
GJuQt5h06Wo+6TzF4Et0C/NjmRsHkfln7NkOj+FfR/oJPIVNmcVWd9qGHuLx
UQyq0L9hc4y7rYFf0J3Zsz1nZ6To3pnFWnfug36ITRO2RXiEfgB/+x10l37u
33Loj77J2Dlsz8M/6Ltwx9c88DvqrvfgPsz1etkA89BHGVuX2B1b0K+4c1WJ
1YhqZTRjk5ibAhOUO4/3Wljne2rvW3Bb8UmpQ+YqoR29g7Ea9H44gw6Z3V01
08T+b2eWK/kk3zZgU4/tXtiMHgQDoQzehEQ1wNwseMH+dXx/ldgZOqsf9IX3
4H0YCh9BOXyg+oBp2FbDj+jV0XKjGKxVrFLbewY8RBdhOnomNKOPRas1xWCX
7srY1MRsjqC3R/NV99mI/lRnoFfBYvTEaLZaMw7d4O9B5ysX+6PFVvurtm8Q
k+c5q9lS6qXI2KHEfK5zH+XrhzBEvvh6nVmL3pJZrrXHVvSV1PxXPk+gh2Pz
scdIsbqZmq/K4T30csaqYAksjVbDilctHPKclLmNbCui+TYZRkTzWb4rZ1Oi
xaTG46VYfJ2ardZsVKyj1Y72X+A5K/caUC284/1ENdo3M5taf1+LlBs4mFiM
FKsclEAP6Km3kVpuFYM29EHPTyNc0duDw+gGuIBu5YxnxO57uJaZzzpPNpfQ
f8Jp9Cn4K1pPU2/T2Gl0M2u+y9mb34xui/a29Wab0aeirVVNqbaOe/2o552M
xj6v15/RbfSwvZ2sp7Wga7x/670W0TuxWZlYDM4qJ96P9d7U2w8oh4m9sUb0
1VL7V6ifF5i/4fdXTao2p2bmu3qG/jV6M9V+P/VmxajB67s+2h557//D0eu9
v2i/b5V7rfecKDf1Xh/KgXKhnqveq5jn0QdSq1X1oB2pxUDny0f52h26+Z41
nuMe3gPUCyZFW6986+1fjtbrlO+r6IX4/19H+2fuQm+J9q9RjDZFs2n0fqe3
uTVab1KO9NYv+rz2VK+/5v1BMVQsK72/qQZm6v8crVerx1+P9o/Tv045vcz5
rwFM8ytR
           "]], 
          
          PolygonBox[{{3398, 3397, 3402, 346, 3399}, {3546, 454, 3569, 3551, 
           3552}, {3550, 3549, 3563, 453, 3544}, {3396, 345, 3406, 3403, 
           3404}}]}]}, {
        EdgeForm[], 
        RGBColor[0.4291915714254163, 0.4545401688715521, 0.5667691720694039], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJw1lUtslVUQx8/VSG/be7znc6kLrY/4IHGngolUUUtKQCOGSASE1t4+KL23
VCDRQKNGXbjwAZSW1lYslEc0Gli4QKW0xYVNECyglBLiRlHDwkQXPhN/k/+4
mPzON985c2bOmZlT11xZUb4mhPApci1yMIZwJBfCGNyEfMD4qxRCTT6EPNKK
rM1CeKAmhAH4Mv+m0DXAn64P4cJ1IVyBVTeE8DtzZpjzeNLaCAvon6rlG0Zk
BeOzzNleHcLNSB1S7XNG0Z9GfsPOPHT9rD+FP/vQfY3sRj8EZ+0b/d9Rfn5U
pf0uuz/m14PMvYTtBfBF7Ezw/yVnKa8YdhRCWIydq3C/2zTbt7LuFqQXKfGv
Hv3qgtaYz2bjRNJ4HHb4WrPxT1JMU3APugmkH/kVX/fCX+DGnPbdgFzgexhe
hlvhSE7zTLcFed/nPuzz7b/N22w+saYEu+FKpMz4WfgQbMvpn61r97XvIT3I
oI9H3E4XUnE/O5EO5BGLB1tH4YEoe/X+by3f3bApan2P2+t0W33IUE7xb0K+
j9rrIuyJiqsr6n/F57S5rY6o/WzfL6N8qritxmIIO+cxD85VKydn4TR3s4j/
DfDNgnzvhZN53ePJvHLacvtjbDYgqxgviPLD/NkAn4+KpQSXsMf97HUTXM+9
LmSvFjg/U17da7XAHs/Y+Re0t/nwpO2blEP/wqaC7qALnkzy5zh8Pcm/bUk1
ZmPzs7Gg+1sMp4vK7yzpn601uysL8r/NYvVYTFfDvCrmPQprvdas5ixv67ze
3vCct9zfgv1dxLi0qPj6anSm7Znq7q+o+rF4LyJH+R5F/6ftmUl3Jxxl/RPU
4EE4hixnvL+oGrd7sjuy2rWaNHt7MnE1bM6kb/Iztv3n3K7ZvyNTHdrY/PgQ
29V5xdnia9Zl0pVcP5gpllOZeofFYjE1+V5rYK2flZ3Zjfh6H+dQhLdn8veu
TDFYLHvhuaL2noH3ZPLxbjji/eoM/CZTDzwHl/i9WK7d5jbN9pDn+wvIce+9
n8F9foZ2lgPoJr1OT/BvN/w8KicsN6ZgY1TuLfN6r/eaP1tUPzwPlyWdS4IH
3P5h2BLlQzOc8FqzWq8grYw3RomNn4vqs9bfrM+95b3gHdgeFUcrXB9Vp2ui
8tXydnnSG2C9uZDUO+q9t6yK6hVPR8VgsTwGf47qeVd9f+tdi1zavZ8d8nsp
F9UjzP8v4A/0/e/o/3Nw3Mem6/Y6XcicP/yNs7dum9fgdtgX1SN3wh+9h1gv
GfM7sruaTsp/q4PkZ3saHz7xurD/S71WX02qH8s9e8cm3Y69t2Xv9Vuj3gmr
zVeS7tju+jB8Nyret+Fr3k+sr3R7z98Mv43quzPejwe9F9t4wL8vRb1Bs37e
/d6fz0Tl4nl4JSrf5qLW2Xp7S3ZE3dku75HDnrfHomyMw06Ppezvj71tFsMh
n3PMYxpwm/+/wb1Jtob9rfgP7X8k8g==
           "]], 
          PolygonBox[CompressedData["
1:eJwtlVlsVVUUhvclQHtv7/ae0+gLahQaEwf0xdkEFCdSEIcSEyKgUC0IAhXE
Gkgg0qjRRJygFykFFTQBpRh4kcQUaIs+IMOtUATaICphSAg1MmhR0e/PWg9f
8p89rLP22mutPbS2vmbOgBBCIwyEvhjCWTgH52EqvJwJYR48j54E9ejZMAG9
Oh9CC2yEVniHsbchBxVwFVzpY5rrZU0P/AbH4SJcgMvwHyyFd92mbO+GH6AN
tsEZbHzCvz+Dv9BdBf5dFsLjsA69D7LlIXzF9wF0qWC6jLGKJIRf2dPO3pWw
G/2jz4+D9egxsHxwCHfBaPQy1sxk7YvwIXoxNtqxdV02hB2JnUFnOQt9cC1r
roHhcCscgTXsbYGD6G3suZ69Hdh4E72TsY+ZK8IO9IZoepZ8RA+ADPRj+xLc
gb4dhkGV/GFsFGvvhzp0AZ/vxPdlUI2ez5o65qbDe+hfoCNj/9S/96ch1FSE
8BTkK+2f+rfO3IRego9D8bcTf19HN8pn9DDG3kB/zz+/gxJ0wWjG6sotRguk
o+XOfPmA3g5N6BXQid7Knm/chmxtgc3wOXwB2xOL9SLoRz+amC/6x1j0k9h4
KWMxOMH6Y/AzdMNB+CDa2WfAR+gaP98ceBq9KVouKae+VN6z5w84BaeVb/Cg
34f29vldX/DcHcjYNOZGwi6+n8ibfgCmok8w/2nGcuAYenbe5mTzLXQ/Y2sz
tuZ39PJovupMRXQtzM1YzU2JVmMbPWZbPeYlrynV1trU7lJ3muM+W/huyoVw
L0xJrSZznqPK1UbdMSyAhdDj+aEaUa2UwWDPQeXiosRydxo8jJ7J2KusfUU1
gv6bscVZy/Gd6NfwqcFreqnncL/HWLEe6/mimn0ssZif8jvUXXZ7feeY34W+
umC1eWhQCEevsBxRrjRBEW7gjEey5oN8uZRY7iiH/0FXJ+a7cngMeo/H5xzs
Q//JGS56D1Qv7OEfPw2ymhpSsBxRrujM89AH2HM+Z/GuIN7djK1ibjUcUuwq
zbbuJIueEa0WGnTH6H8TqyX5ezmxnqTeJBsl9adovaMZ9qCPRrMtH45Hq6EV
fl+96IZotpVPrdrv/hVhL7qUmj86s3Kj1fNTOfi1ehFjd/t8M/rZ1PbKRhe6
vNLOIhtrUssxnV3zZejbGOvlLPfxXZvamXQ2jd2SWs4o/uXwiHS03FGOv4B+
KLFerZxQL5nInntydqcT0G2s2cLazdARrca7/Y3QW7HK/dWelehOxkZkrAcm
0XqI8uEwVDG/oWBvh3JsP3oka0Z4j1WvvYk1Pd5/lEvjo719qk/1nqL3H/W0
9eh8YmeTPb1NVd6rl3itPZdaLcrmzehJqcVKPivW70d7a9RT6tGH/b1STap3
T8xbr9eZqv1NbPOeqd45LrFaUYyV689E63V6wydHy6Fmt3dSd1+wt09voN7K
G1OLjXJgMvrbaLFWzNvR/wP1yDWu
           "]], 
          
          PolygonBox[{{3572, 3571, 3556, 415, 3561}, {3962, 3961, 3960, 1684, 
           3957}, {3327, 3326, 3422, 358, 3332}, {3385, 343, 3401, 3389, 
           3390}, {3959, 3958, 3950, 1869, 4005}, {3344, 357, 3419, 3334, 
           3335}, {3175, 344, 3399, 3190, 3191}, {3956, 1683, 3912, 3958, 
           3959}, {3373, 3372, 3384, 344, 3393}, {3562, 416, 3558, 3574, 
           3575}, {4007, 1870, 4006, 3961, 3962}, {3222, 3221, 3396, 343, 
           3200}}]}]}, {
        EdgeForm[], 
        RGBColor[
        0.5483779965104651, 0.4964267719365852, 0.49670430876062116`], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJw1VltsVVUQ3Zf7vpxzz9lXLUKLxiih31AQoyZCq+VV2kDQipJIqS8w1ndp
ffxBgtEPsL7RFhALTdRvFaQ+PmxvqY+YlIf2p1ijgm2JCkQLrpU1fkzW7Nkz
s2fPzJ5zrmtpW/voDOfcMCgJmpt37llQB6in4FwdaBloVuTcwoxzFcAjReeq
0s51A0c9jGY6dwqYLDk3Cd0h8JcKku8DHoDNBGzbgauyzp3NaP0HaBK0G/RY
pPWTwN2wWQyqAT0eSb8NuB5+F0J2N/AycBq0F/STrU/auZRzfcmQcfxocTLe
04i7E/F/XpR9N6gW1Ou1PuDlg/ZDCcmmTa8JPtaAGkFTWDcAJwrKBXPyblGy
RtMrlGSzz0vWYHbtlpOnIuWox86btLysziomnrm0IJ0601sEXz+jPmkvH8zP
roz0KKfdF4FztyD2BcDTkL2XUB1ToeSXIW8FvwL8A8CzgfhfgFuxXg3+YeBG
0B3gNwCbQLXg1wGzoJvBx6HO5NljwEXAXQXV6VWvGm4Afot7HsKdeoDNXvW9
B9htdWf9GSdjHM/rruO27rJ+YF+86bV+G/iKncUzh7E+B/zekDrsxde8dAaA
b5nNG8AnEHc74u8D5rzOWsy64/6rIL8A7EctO1DTMeCg1/mve+lRf4mXjw7Q
dqw/gK9t4J8BDgIHQGX6CpWfM6Huw70hO5v2HwLLsXPV8NEcy4b71PvIfNJ3
BjFVgk8Ap6BXBf1PgC+BBnLO7QRu9MpHNXB+XnExvl9DxfMn/XjJk8Br4asK
8iQwX1KPZoAFk88LtEeespsC1b0GeIPFw7hutJ5kb57Euh7yHwK9VfZCF7AO
8bUizudj3YG2VcAU9nbANuvVK+yZO4Flr7c1g3PFcncxVH6m7W1eCV+NwJFI
9e6yPtkO+TXw+RkwB5s10FmCszz4BvBp4Pte7+qg9cWE9dOU8ZRl7f3yHa+I
9M6iSG+bcvbaOes1yr7xsj8G3OrVx23AB3HeSpx7P7AZdDv4e4H3hcpVC/D3
QDpTgd4Z80O9h0L15JZQdahL6E0ext0qcccjwHGz4Rv9N9D7dexDmwN89+tD
2a4NReTPYH8z+OXgNwFTJc2oREk9W7Y+XmB+bgU+4jVjtnj1H/vwU2A9aDPq
Wwu8CjmqQa5mR5JtAqVBnZFmXG+kXqTvCebDeoM9ssPmFefB31h3As8Dz9u7
+g34FdbPQf6P1ZkxUG+nvYU55i8DaslJh/u0iW12fcnehl4S+zngX7G+exeA
3yG+PsyrAPzFWN/Eo5bvozl9J6nLNfmc+cnGmt0Hs7Lfb7OBs5Ex9OcUawX0
mrA3C1gEpSDPG7ZY3BX2zS1FyklnQrNgtuX26kjfRc7/d4CjRckrI53Tar5e
hN9B4MvAZbFqsTTWPcizPttgW4lZt4czz+rIeu4xeVdReZ1v86Q+0nd7ZaTZ
fDyvd8s4qy3WMfsuMAc8nzLuHbc6sB5PWz+wL45FytswcI7d/VRRfcM4md/l
se50W6za08889OFcuyPvelesOL8G7rc6sp5lUC/4IeD1XjVlbdPmm3v/1yAF
PBHoXYwGmnfsmcOB9Pgfw+9Zf6z6vwD82PqD7/JEpPqyztRLm3/eL2X1nWl7
/DZeYXOM84zzcsS+pX1mQ/0R6znG/R+9MT/4
           "]], 
          PolygonBox[CompressedData["
1:eJwtlllslkUUhqd7+//f1//7atCEFowBhBu9oSh4odLSAoUCYsBGIJGygy2g
Yhe0igaMKCYUBJewlkWJYgI3EgPUhKBdwNgYEQSjETSg2FaUVhDxeXPm4kne
mTkzc2bOmeWe6uXTa9Odcx9BJiyPnRuXcG437EM3Rc4NynPueK5zjehhgXNF
ac6VQxt6Z8q5D3OcmwR70MPo8wL238FwdAV1zdnO9cAq9KOMUc1YmZCPbsNm
I3N1Qwd6oOpoa2D8x9At1O2g7RZsVRusZewW2leGzoWUs7GfD2WR9VHfOkH7
WMpzc83/OvT3jOeSzt1mvAvobfh0Ndv834X+ILa1y+Y8+hT0Ut4E72ltjNHK
WIPxYS26k7oe2pqhHT0UztC2Goagq7AZgV4HmZQX4FMFvk2AeejtzDmZuf/A
hx3o56AbvREmopdiMwnbSqhBZzHGJcb6GUbKV5iGr1Mhr8C5Lsp/Jqwuh/L7
lDcnrO40OrvAbLWmryh3Msd+5s9gTRn4+rv2jLY25ruMPovNf5R3wh704tja
FRPF5i76TMN2CqzC/h8okS3lQ+hjke2VcuIE+mBosVEMFcslsdl3UneTtjP4
M9WvN6bcHtne1VP+hPJpxSjH9kx7VxBaWyNMx3YW4z2QsDW/G5sP8kVjaKzb
kcVnJO0zaN9AuT3XYtSBPgqF6Ab4O7I1aW2aQ3P1UddIWxH0opcyRmnCYvIg
ejT8kmdnaFlsOafc05hH0KUwj3IWJNA5sfl2EYrRv3KmJjLXeDgX2JlTf/Vp
QGcRvylJy7kMdL3PR52pCeg06iqTZiPbrbHlZjG8jf4sMt/VR317A8vHyfAv
egQ2oxK2R8rlK4pBmsWoJzSf5bvOfBKdXmBnV3Nmom9g05FmOaJc+RKb4Xl2
pt9EZ0Z29hXDU8RvZmy+6b64F30AH8al2R1zNzojtlzRGE8o16ibCnOhGo5H
dtZ0R7Winw0td5RDd8hXX9YZuoX96MDiqZw9y/w9lLvhOvTBYOwHwX1wP/xE
3Y/wLZyBHwI7u9qz39BLQts7lRf5Puo7VucALmFz0c+huR6h7mEohlFwgbrz
3ka2j1NXylhlUIXuD8x35cRV9EpYAWNoeyi0O1Z7p5yvQt9J3QB4HdZ7pJMQ
wGH6HoK9sC8wH+TLEBgKW6nbAi/DmsD6JP2eaG+cX6/2MBf9TWC5Kn9PoBfD
IqiDenjen0/Z16JnUjfD28i2xO+V6tTWBV/7PdHevAbroBk2wU24AdfgLx8T
xaYTTskXKPc5olw5Dsf8mg/7nFHu1ECtp8bPoblq/XnXGpehr1B32eeAcqE6
tPUqHvNDm7PTz6G5XqXuFWiE1aG9QXX+PlNuPhna26kcn4HOgPTQ1nTTr+ma
n1NzLwxtLuXAYvTc0PJPY8zxMRvi59Tc+3xsFUPFUjFRbAphaGA5M8bnoHKx
zL/PxTAAXaH7R3GB0sDeRL2NeiM60JvzGSuLuwha8+3O1t2tN0JvxUL6LIBZ
MBs+x6YR2yI4mm93nO463ZG56PKUvXV6g1ei36DPemiClwJ741v8fdKP7g7t
bdKd1Ifeyxi7EnYHPx3bH0F/Bd1Buov0Juht0B0/KLI7RudFd/h13Rcpe3u1
B9qLFyP7S+h+1Fuf8v6NhIF6b1KmVSff1/izssKfzcKU7aXGG5+yP5H2T2/6
XnRRYLHQGW/R+WKOAzn2h9Ffpt6fnQ3wVmBvrt5e3b96Kw9S9zF8Ckc80ifh
C89Jf4a6/Bgaaxts93va5GOkWM0OLT+U00+h96fsr6b3dXfKYjjL54Ry453Y
/kJ6I+agcyL7O+iPVRLZH6XS/7+eCW0MjaU1tqD7I3tb9b7oLdYfRn8Z3fHZ
+qvE9jbrT7gFfS62v5pivD+2NWzze6C90B+03P+nzqL/B77UcSw=
           "]], 
          
          PolygonBox[{{3139, 3138, 3267, 315, 3129}, {3133, 316, 3274, 3142, 
           3143}, {3319, 3318, 3327, 316, 3266}, {3811, 1401, 3775, 3813, 
           3814}, {3864, 1588, 3806, 3816, 3817}, {3219, 3218, 3308, 324, 
           3242}, {3817, 3816, 3815, 1402, 3812}, {3260, 315, 3335, 3330, 
           3331}, {3814, 3813, 3803, 1587, 3863}, {3235, 323, 3302, 3210, 
           3211}}]}]}, {
        EdgeForm[], 
        RGBColor[0.667564421595514, 0.5383133750016184, 0.42663944545183846`], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtlllsVlUQx2/39vtuv3tu1bRUkFKBBDEqaMIiMYARCuIDRZBoBOKDiSxl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           "]], 
          PolygonBox[CompressedData["
1:eJwtlllsV0UUh6fbf2nvv/fespSirAIRcaPKUhSBVm1ZTKRsakQIvojsRaEI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           "]], 
          
          PolygonBox[{{3083, 3082, 3109, 286, 3086}, {3171, 3170, 3182, 280, 
           3092}, {3738, 1213, 3704, 3740, 3741}, {3088, 279, 3174, 3164, 
           3165}, {3085, 285, 3108, 3078, 3079}, {3125, 3124, 3260, 313, 
           3121}, {3118, 314, 3266, 3122, 3123}, {3074, 3073, 3100, 281, 
           3068}, {3071, 282, 3103, 3075, 3076}, {3774, 1400, 3773, 3743, 
           3744}, {3744, 3743, 3742, 1214, 3739}, {3234, 311, 3306, 3297, 
           3298}, {3741, 3740, 3732, 1399, 3772}, {3283, 3282, 3293, 312, 
           3243}}]}]}, {
        EdgeForm[], 
        RGBColor[0.7867508466805627, 0.5801999780666514, 0.3565745821430558], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNl2uwV2UVxjcnz4Wz//z3foED3gowxy4Ih6ZRAgTkIlpSyrXJsA/1oZpJ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           "]], 
          PolygonBox[CompressedData["
1:eJwtl1dwVVUUhjdobnJzb865h45SEhxxFDSZcRwgFAUFURCkqsCTLwpKSQIo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           "]], 
          PolygonBox[CompressedData["
1:eJwt0M9uQUEUx/FDalVXEBVJo1i0SWmFhbuopa1VE//Fog9AUtU+g70nsPUG
eABJG40GQdq0T0BVsfWdmMUnv5M5c8/M3NBD7b5qFREvbGjaRRIWkRk5xDtC
CKKte+ekwEUdJyO4gQ8max3SjwtcGyIZ1kzyElcIq3VE4aZnIz9ORUb4xJbx
b2Sa9Sz9FN/kqPNwUBsIGMdejJywd4xvLHjEjKyz9xFJfX6F+sUh0j8ReSZL
KKOAPBro0Xsih3y/4w4/eq6a/48N9vil90pOMee8L3139Yaynl2ElXm35B/r
azi5wxl3WVKv4KX22I9z1fwedRcD/R9bqlZ7OW+nZ6hZUWZamH2n767ecADV
/Dw+
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9009484459689475, 0.6223711149223689, 0.2929401825037374], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtWHeUV8UZfTHs7m/39/O9N4sisVCihnKI51joZRFIOYcIhCIiJTnpibAL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           "]], 
          PolygonBox[CompressedData["
1:eJwtl3mQVtURxV9UZpj5hnvfw9KoUYSgDFDGilFcUBaVLFUuIGAYFTCVXVEU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           "]], 
          
          PolygonBox[{{3064, 269, 3099, 3093, 3094}, {3595, 837, 3601, 3616, 
           3617}, {3094, 3093, 3209, 307, 3087}, {3084, 308, 3220, 3090, 
           3091}, {3620, 3619, 3618, 838, 3615}, {3006, 233, 3046, 3043, 
           3044}, {3035, 3034, 3047, 234, 3009}, {3640, 1024, 3606, 3619, 
           3620}, {3091, 3090, 3096, 270, 3067}, {3617, 3616, 3639, 1023, 
           3638}, {3233, 3232, 3248, 308, 3208}, {3197, 307, 3265, 3253, 
           3254}, {3044, 3043, 3072, 271, 3038}, {3031, 272, 3077, 3034, 
           3035}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9199878109985081, 0.6699695274962701, 0.351962214095375], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNWXecFdUZfcCysG9278xgF6J0iR2UjhEFe6WqKB2WpgIaC22BBcGK0oso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           "]], 
          PolygonBox[CompressedData["
1:eJwtmGeYVdUVhjfOcJmZM5xzD5YYG6KCGE0oCmIgAQRLoqh0G23oRbBgImVg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           "]], 
          
          PolygonBox[{{3172, 305, 3241, 3226, 3227}, {3156, 3155, 3370, 339, 
           3141}, {3131, 340, 3377, 3136, 3137}, {3600, 836, 3599, 3591, 
           3592}, {3354, 3353, 3469, 340, 3368}, {3360, 339, 3462, 3454, 
           3455}, {3592, 3591, 3590, 650, 3581}, {3587, 649, 3582, 3588, 
           3589}, {3589, 3588, 3586, 835, 3598}, {3196, 3195, 3217, 306, 
           3183}}]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.95, 0.75], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxdnXWY1dXWgGfmzJk4gxMqICLYorSgiC0iigJ2IkgJJmF3oyIg2B1Xvaio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           "]], 
          PolygonBox[CompressedData["
1:eJwllmlsVkUUhqf069fllvvdG0HAHROlUKCFEhMXUNCWsmobEwVEoKWUHfcl
siO0rAqYGAOJBsPWBEQTyvqHauISE9dEjbK4+0OkEBE3wOf1/fHme765M2dm
zpw5Z3o3LKif3yWE8BrKoAFJCG8XhtC7KIQK+OkohLm0v4QWwaPTEG4oCWEx
eh5+irY5fJuHnoGfRfODx2hsiEPozwStKA8eXxrCwDza0HB4Nn3G020smgGv
p09JAYz2wd2ZY0txCH+hGngVbe+x0NloNPwYY+oZex96BD6CTsFF2D8PT2eO
CrgQXeL/Zcb8gu016CKcj35kbS3octcQpmqPjK9FD8PLIu99E1oMb0CH4I1o
OdwlF8KubAg70CD4LOrAf9PRGXgCGsm37WgSvIUxB4JtbItsQ7Y2o1Xwp7H3
3oE+gys5gxs5i3ewNxBeh40CuBEdhF9EX2J7CP83wSfpM7TYPuuWeozGak19
4Dz67Mzaxlq4Mue1qU3fttPnBPMtRdvgQaiTvmP5XwXfjz/L8eUANBVez5hs
oX0gX0xEtXANeoP1z6VPZZ7PfCI8le8Ls15zA3wOHSt0zCn2DuXsO9ncAHdG
PruT+KcDbmVPt/F7KzoHv8zvweAzb4ebsLGbtY5BgxP75H/foMOynXhv8mkD
fDpnX2oNnfBM2tr4VoT/2uDvUCNciPbAv9PnDH03oiPwk6X2hWJsJTyBNVSz
lpFoErw5575VGgMvoO1evtWhR+Fpie/aEtQIv0Lb4eA9aW9N+PB9Yr0P8bAn
tg3Z+gL/vQAPpm1rfgh/oip4LSpWX8ashj9Brfzvhz6CH4oc2zVoou5H5Lun
mG+Ah9JnO7Z2omHwEPQHXI+9OvgoPv+mxGdwFp7D77jgPc2Dv2IPp4ocQ8fh
MYxpYe7V6B+4GhVhqw2b/eBvE/t6OvpeY9GwYtuQreH02UXfHWgEvDvxWeiM
mxPvSXsrQ62xbcq2xpTBBfjouqxjbjA8iLbzfLuAxsKBtuqs76juahN7GBO8
p5nw5MhnOQpN0XlFZvVphK/CxhZs3Yl6wHcQA33zfEeq4VtQP7gelZFfbi91
7lObvmWZ8znmvhZl4EP49Gv8uwithPdj8xh7a0Jvwfsj3wXlEOWSi5Fzne7Y
AuwtTp0rH2D8UuVq5qzL85q0thWpbV+PRqW+I7oriukLzN+NOUbmOwZugvvK
53AhZ3aPchP6IOMc3AavQXszztnr4J6pbR9jDT3gXrTdle8Y7ancjmrznbOf
kG/p8zd9t6JqeFrOsS2fTIH3xj5bzam5J+eca5VjlGtWpa5FisnD8G76vJvx
ndHd6a85M465GrhP7NjWnrS3ytixoDOs0FzY/LnAMTEAvoa2Efneg/aiGFYs
q88l+EP5qMAx/jF8c+xY1R67xz5Tna3O8HP+vxn7LHVHN8DLWfMV+KEbOpM6
hhRLw9HV8K+KgRL3+S11zVLt0p1uhpsj117lHOWe+ZFroWrqXLgldu7QGrVW
1WDV4p/QRWLjh8RnpRynXKcaqFpYjv6FH4+cqxQTxYx9NXGuOo5eT1yDVYtn
ouVwufIP3IymwQsj1za9EfRWOJpzLlZNOQ9X5FwrVJPLlYtj29KZ6exGoVkZ
n+kKxX/q2JZPDsCdqWuB7swR5SbWdLLINfAEvCz2WmRDtu6OHctao9baizEd
xX7T1KbOQcpFatsHj4udW5UDlQuT2L5TTJTCV6aOXeWsXYlzqnKr3kCz9H7g
+4MljvElcNfYZ6s3R6z3R861XjlKuWpW7FyrOzVHsZrY19qT9qYarFqsGjUD
nh0719fpDOCDzNFe4jnbU8eUYkttp+HxsfsqByoX6k2jt41qzkb4P0tWQFo=

           "]]}]}}, {{}, 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwV07tLFVAcB/BjW+8CbXCqobxmpi0tWmClUUFDROE1877USvPa+2XavaZp
D6EpwkHQoqc2aYZbc2BtCb3+gEwLCiS0Pg4fvpzlxzk/vmdDIn2oJSeEMEn+
yhAibF8RQhkVHCRKM22kmV8ewm8mGOMBDxngPu1k6OQ6l7jCNU4S5RjHiZEg
RQOnaKaFVs5ynmWrQshjE7uoIMJmKolRxRaSpMiyn266eE4DI7ykh0k+MEcj
8/yjaHUIJRzllXNU1nKbbSzhHn28YYafFK0JoYCtlJIgxSCPecRnpvjGU9at
9Qb20kGGMcaZZoYsP/jOa0a5QTtV5JHLV/O+8IknfGSIAZLEKaGYX+5bKGfl
NOPc5Q45lNJLDdUEjlBMhAV7+csB/vCed9ziBcPU84ybdLKPDAnii3tmN3Xs
oZACdrKDjeSylHN6cIY0p2niBPUkiVNHLTVU08hVLnORNnrpJksfQwzSzyhv
mWVhsZf63k8XF4hxmErKWe+/dPAftUJvyQ==
           "]], 
          LineBox[CompressedData["
1:eJwV0UkuA2AYBuC/qYqFVq3amhInoMMhEPMF0ARFcAhDzOMpTElJLLQ9BS5g
OICZBeGxePLuvrxvvs7i4uhCJIQwz3c8hF+iiRBiJIjTTispWuiimyH6yTJI
iVnW2WSHcy645Ja6phDqyTPGBLvsc0iVNz74JJcMYZJpjjjhjHseSTWHkKaX
JVa4osoTL6zxyjM1KqyyTB89ZCi798AdpxxTYoo8Wb50eqdGhQP2KDJO4b8z
MaLc2HxNmW222GCOGUYoMMAweXKkydBGB40kaeDHjyIy8AfEJzn2
           "]]}, "0.9`"], Annotation[#, 0.9, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwV0EkuAwAUBuBHxBhq2CERiSNoVSwcAJua9qgE1XIKQWIOtyDUtlWHMFyA
YG2IMb4uvt2fl/9//XOFTL4mIrL8tUbUtUXU0kkL/aRIMsUka2TIscouexxy
yQ13NCQimkiSZp5RFjmiRIVPvvmpZtsjlljhlHMeeOKZ7o6IXsbZYIsSV7zy
zg4fvFGhzDabTDBGD0X3XnjkgjNyLJNikF+dvrimzAlZRlhgiBTNNHJv9y1F
jtnngDwFZllnhmmGSTNAH10kqr+jnn92KThw
           "]], 
          LineBox[CompressedData["
1:eJwN0stLFFAUwOHrLtGcTAjaBGVmiQj9BQoFtnGTBQU5RtugNrqw0RScVELJ
NykmTakV2UMdFTeCUPkIM+khJbSSKI0iEhRr0bf4+O0uh3PPwUtXT19JCSFM
sX93CC1EOE5RegglnOcyMdpI0MQu0snib1oIsyzylhVWmWGYpzxnlCQJWmil
gy5u08ddmqijkUqKMkKIUkctpxjgPkM85CVzzPOb12zyhuxICNt6RP/pGc3j
HAU0EifKOJN8ZYPsPSH81BzNJ8pFeuhniY+8Z5Uh9maamZNco5pRknxngxrW
+cYYI8So4gRZZPLZeysk+MAyfXRTThlHOcwPcx7QdV1jgiQXqKeBfM5yjFJ2
7CNHt/SQLuofFvjFK2Z5wQMGuUeCYqqJUUYhN/3XDWqJ008v3XTSzi2aucMY
IzzjCY+ZZo0vfOIdS2yzz71FSKWGCR7RS5wKyiklzx3n0sB1/gOYJXM5
           "]]}, "0.8`"], Annotation[#, 0.8, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwNz7suAwAYhuHfjNLFRqi5XUsPJrNDtyamLrpoQyUGt1AhklbrOhwn6cFF
aJgNIowOCX2GZ33zfUuVeqk2ERFlkomIRbLkyVDmkAM6tLjhnidGTM5ETLPK
GkV2adHlkj6P/JGdjcixR519rnjjnQ/mkxEbbNHklB4DvvjhnF++GdLnjBO2
2WSBY71PXrmmSIMaeVb4t2vAkAc6tKmyToEcCaZ49vuFW+64oEuDI3ZIU2CO
ZVKMAU3cNFQ=
           "]], 
          LineBox[CompressedData["
1:eJwV0jtIFVAcwOHT4KRdLQgEH3kplKTBOSixNdG8Uy8cHBty0DCEa1kISg0F
CtrkYKVFdTUiH0VZGqX2wDDEQcGbXvNViO5+d/j4wYFzOOfPidbVx64dCCE8
I/dgCPeIUEZ5VgiVXOAqzdynlwRjdHKYXAo5RikZLGSGkOIvG2zxj12mGWaU
d3xggs9M8Z055nnCI+7SEgnhqX7SLTb5T0F2CEVUEWXPWo22EKOEVm7ziiGW
aCfFSnpfjrvqFb1MJ6U8pItf9JJ9KIRTlHOGs1znBi9IsEKKJKv84SXPaaKR
CnI4TYQsZp3/k290U8wDLnKJtfQ7dVmTtLHIIAlucovjnCdONTvmUajnOEo+
29Y2WOcj/eYa1wHt4zG/mWWGr0ymZ8973jLCG76wwzabrLPGKkmC/3CSEqLk
cYQOfjDOa/rp4Q4N1BLjhP9YTBtx9gE0H2rA
           "]]}, "0.7`"], Annotation[#, 0.7, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwNz71KAgAYBdDPIMfSbC97C0My7QmywKitLcsSSSHfQty0oKeo0HBL7Sn6
maPBGu3nDIe7Xe7NHl+UzxMRscvmUsQBTa7occMjQ954IbUckWGbHU6oUuOa
MRMiFbFAki3qXNLijk9mfLGWjsiyzx4dnpgw548fYiXiV04Z02WDCmXWedD3
zQf3NCnQIE+ORRJM7XymT4NTzihSYpU0r36/M2DELX3atDjikH+AIi9A
           "]], 
          LineBox[CompressedData["
1:eJwN0s9L02EcB/BHEUTnN7cw1rKwhKIQWxEWNpGgDkJ1SPtx6lKnDk1dEIg7
RbeBE3cJQoIu0TbbxZOnjh1CiCJGbbgN/ANiUBRBvQ4v3h/eDzwPfHhOPFic
z/aEEEokoxAKRIyR5ir3hkJ4xApFXlFjhw98psIxxjnDWS4wyxy3eMgI3VgI
v/jDP/p0MQ6Q5Agt/Rf26DCpO8e++eZwCHm2qFKjToND8RCaMiWP0jbfkWvc
ZZwNSuzyksFECJsyI7NELPOEMlVadHhKmz0qvCXHEjM8ZpoYA3S9/9HdRdYZ
Y4ECt2k5H5WH+WY+KL/Lr7yjTIVVbnDJDtKcpm0XTT7RIKVLENFPL3/1v/nJ
D+K6+1znGpeZ4jwTnOI4r+lQZ5f3bPOGFzwjR8b/uMJFTvKcPP8BQ1pPHQ==

           "]]}, "0.6`"], Annotation[#, 0.6, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{3704, 3740, 3732, 3776, 3811, 3814, 3863, 3862, 3858, 3910,
            3953, 3951, 3997, 4001, 4043, 4044, 4099, 4104, 4103, 4162, 4161, 
           4215, 4281, 4284, 4285, 4341, 4344, 4351, 4437, 4441, 4500, 4502, 
           4553, 4555, 4610, 4612, 4609, 4613, 4611, 4556, 4554, 4503, 4501, 
           4442, 4438, 4390, 4342, 4343, 4337, 4282, 4283, 4216, 4168, 4160, 
           4110, 4105, 4100, 4045, 4046, 3998, 3999, 3952, 3955, 3909, 3861, 
           3865, 3864, 3817, 3812, 3777, 3773, 3743, 3742}], 
          LineBox[CompressedData["
1:eJwV0DsoB0AcB/CTZyLPKHmkWA34e5UUgzJhwGAySIgkUQbJIM/FYLPII4PF
pJSSQrJIybMMUqQoRaF8DJ/ud3fd7753hV2DrQNRIYQpspJDmCWJfEqopy0p
hB7GWGSFbXY54pw7HnnjkwNKqaWRZroYYJoltiggmkSKOeGKe15454cgRwJV
//spsqaGkM2ItXRa1XnMssApHcSkhRBPOQlUUEUfg6yzyS333HDHNRus0U8v
lUSIpYw4oml3zzHzzJBDC6NyDZOhzuRS7jTzWH6944tXnrjmgkOKiCOKXFaZ
Y4JuOmmigWrK2fv/R32/jR8888AlZ+yzwzrLTDJEjTN1RChiinH+AJ2ERgE=

           "]]}, "0.5`"], Annotation[#, 0.5, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{3775, 3813, 3803, 3866, 3855, 3913, 3956, 3959, 4005, 4004,
            4000, 4048, 4107, 4106, 4163, 4167, 4217, 4218, 4222, 4288, 4287, 
           4345, 4387, 4388, 4392, 4445, 4504, 4506, 4557, 4559, 4614, 4617, 
           4514, 4618, 4615, 4562, 4558, 4507, 4505, 4443, 4440, 4391, 4389, 
           4347, 4292, 4286, 4229, 4220, 4221, 4164, 4165, 4109, 4108, 4049, 
           4003, 4002, 4007, 3962, 3957, 3914, 3911, 3867, 3806, 3816, 3815}], 
          LineBox[CompressedData["
1:eJwVzj0oBAAUB/BHyoC6xWiQ2XaLRTEoE52UcOXunPPRnY+BMkgGRVkMNqNF
HXWTyaIUWSwmg0HqdHWKfC38bvj179X/vV53djlVaoqIHJ0dEXu00UUvA4y3
RxTY4IBjylxwzT2PPFPnkz9a7N7KIUbIUGSXQ2qkGveZJE2GHHkKLLBEiXXK
nDfuJiIq8oc3XvmizgdVanyzyo3+mTxljSKLzDPHLFlmmGaCMUZ58ec+W+SZ
YphBrkjotNLMr/mdKk88cMclFU44YpsV+uz0k6SHHTb5B84SPFA=
           "]], 
          LineBox[{4457, 3579, 4569, 4516, 4457}], 
          LineBox[{4247, 3578, 4456, 4515, 4247}]}, "0.4`"], 
        Annotation[#, 0.4, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{3912, 3958, 3950, 4008, 4050, 4052, 4047, 4112, 4172, 4171,
            4166, 4224, 4225, 4291, 4348, 4346, 4393, 4394, 4447, 4452, 4448, 
           4508, 4560, 4510, 4616, 4620, 4563, 4621, 4619, 4564, 4561, 4446, 
           4444, 4449, 4450, 4398, 4395, 4350, 4349, 4290, 4228, 4226, 4170, 
           4169, 4173, 4113, 4042, 4053, 4051, 4009, 4006, 3961, 3960}], 
          
          LineBox[{3348, 3464, 3338, 3356, 3372, 3384, 3398, 3399, 3190, 3212,
            3228, 3244, 3255, 3269, 3280, 3291, 3299, 3310, 3317, 3326, 3422, 
           3436, 3439, 3471, 3473, 3475, 3477, 3481, 3497, 3516, 3520, 3524, 
           3553, 3545, 3548, 3523, 3519, 3514, 3496, 3478, 3476, 3474, 3472, 
           3470, 3444, 3440, 3419, 3334, 3329, 3321, 3314, 3304, 3295, 3285, 
           3275, 3261, 3249, 3236, 3221, 3396, 3404, 3401, 3389, 3379, 3362, 
           3457, 3449}], 
          
          LineBox[{3493, 3495, 3522, 3517, 3525, 3494, 3492, 3521, 3515, 3518,
            3493}], 
          
          LineBox[{3536, 3532, 3554, 3547, 3559, 3533, 3538, 3542, 3546, 3552,
            3558, 3574, 3566, 3571, 3556, 3550, 3544, 3541, 3536}]}, "0.3`"], 
        Annotation[#, 0.3, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{3448, 3456, 3361, 3378, 3388, 3400, 3403, 3406, 3409, 3414,
            3417, 3423, 3483, 3491, 3489, 3487, 3485, 3480, 3511, 3505, 3513, 
           3479, 3482, 3486, 3488, 3490, 3484, 3415, 3412, 3407, 3405, 3402, 
           3397, 3383, 3371, 3355, 3337, 3463, 3347}], 
          
          LineBox[{4111, 4174, 4227, 4231, 4223, 4294, 4352, 4353, 4399, 4396,
            4397, 4455, 4451, 4513, 4509, 4565, 4566, 4622, 4568, 4624, 4623, 
           4567, 4512, 4511, 4454, 4453, 4400, 4402, 4401, 4354, 4289, 4295, 
           4293, 4232, 4230, 4176, 4175}], 
          
          LineBox[{3507, 3500, 3527, 3526, 3529, 3508, 3499, 3534, 3528, 3531,
            3507}], 
          LineBox[{3504, 3510, 3540, 3537, 3543, 3509, 3512, 3539, 3530, 3535,
            3504}], 
          
          LineBox[{3555, 3549, 3563, 3560, 3569, 3551, 3557, 3573, 3565, 3570,
            3555}]}, "0.2`"], Annotation[#, 0.2, "Tooltip"]& ], {}, {}}}], {
    DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
     Identity, Frame -> True, FrameLabel -> {{
        FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}, {{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 300, 
     Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
     FormBox["\"(b)\"", TraditionalForm], PlotRange -> {{0, 1}, {0, 1}}, 
     PlotRangeClipping -> True, PlotRangePadding -> {Automatic, Automatic}, 
     RotateLabel -> False, Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               "\"Binary batch\\nmachine \[Eta]\"", {FontFamily -> "Arial"}, 
                Background -> Automatic, StripOnInput -> False]}, {
               GraphicsBox[{{}, {}, 
                 
                 RasterBox[{{{0.148, 0.33, 0.54}}, {{0.3100051463403675, 
                  0.41265356580651896`, 0.6368340353781865}}, {{
                  0.4291915714254163, 0.4545401688715521, 
                  0.5667691720694039}}, {{0.5483779965104651, 
                  0.4964267719365852, 0.49670430876062116`}}, {{
                  0.667564421595514, 0.5383133750016184, 
                  0.42663944545183846`}}, {{0.7867508466805627, 
                  0.5801999780666514, 0.3565745821430558}}, {{
                  0.9009484459689475, 0.6223711149223689, 
                  0.2929401825037374}}, {{0.9199878109985081, 
                  0.6699695274962701, 0.351962214095375}}, {{1., 0.95, 
                  0.75}}}, {{
                    Rational[-15, 2], -150}, {
                    Rational[15, 2], 150}}], {Antialiasing -> False, 
                  AbsoluteThickness[0.1], 
                  Directive[
                   Opacity[0.3], 
                   GrayLevel[0]], 
                  LineBox[
                   NCache[{{
                    Rational[15, 2], -150}, {
                    Rational[-15, 2], -150}, {
                    Rational[-15, 2], 150}, {
                    Rational[15, 2], 150}, {
                    Rational[15, 2], -150}}, {{
                    7.5, -150}, {-7.5, -150}, {-7.5, 150}, {7.5, 150}, {
                    7.5, -150}}]]}, {
                  CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -116.66666666666669`}, {
                    Rational[
                    15, 2], -116.66666666666669`}}, {{-7.5, \
-116.66666666666669`}, {7.5, -116.66666666666669`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -83.33333333333336}, {
                    Rational[
                    15, 2], -83.33333333333336}}, {{-7.5, \
-83.33333333333336}, {7.5, -83.33333333333336}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -50.000000000000014`}, {
                    Rational[
                    15, 2], -50.000000000000014`}}, {{-7.5, \
-50.000000000000014`}, {7.5, -50.000000000000014`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -16.666666666666714`}, {
                    Rational[
                    15, 2], -16.666666666666714`}}, {{-7.5, \
-16.666666666666714`}, {7.5, -16.666666666666714`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 16.66666666666663}, {
                    Rational[15, 2], 16.66666666666663}}, {{-7.5, 
                    16.66666666666663}, {7.5, 16.66666666666663}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 49.99999999999997}, {
                    Rational[15, 2], 49.99999999999997}}, {{-7.5, 
                    49.99999999999997}, {7.5, 49.99999999999997}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 83.33333333333331}, {
                    Rational[15, 2], 83.33333333333331}}, {{-7.5, 
                    83.33333333333331}, {7.5, 83.33333333333331}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 116.66666666666663`}, {
                    Rational[15, 2], 116.66666666666663`}}, {{-7.5, 
                    116.66666666666663`}, {7.5, 116.66666666666663`}}]]}}}, {
                 Antialiasing -> False, 
                  StyleBox[
                   
                   LineBox[{{7.500000000000001, -150.00000000000003`}, {
                    7.500000000000001, 150.}}], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.500000000000001, -116.66666666666669`}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -116.66666666666669`}]}, {{
                    7.500000000000001, -83.33333333333336}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -83.33333333333336}]}, {{
                    7.500000000000001, -50.000000000000014`}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -50.000000000000014`}]}, {{
                    7.500000000000001, -16.6666666666667}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -16.6666666666667}]}, {{
                    7.500000000000001, 16.666666666666636`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    16.666666666666636`}]}, {{7.500000000000001, 
                    49.99999999999997}, 
                    Offset[{4., 0}, {7.500000000000001, 
                    49.99999999999997}]}, {{7.500000000000001, 
                    83.33333333333333}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    83.33333333333333}]}, {{7.500000000000001, 
                    116.66666666666664`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    116.66666666666664`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["0.2`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -116.66666666666669`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -83.33333333333336}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.4`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -50.000000000000014`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -16.6666666666667}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.6`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    16.666666666666636`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 49.99999999999997}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.8`", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 83.33333333333333}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    116.66666666666664`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                Scaled[0.02], PlotRange -> All, Frame -> True, 
                FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                Opacity[0], FrameTicksStyle -> Opacity[0], 
                ImageSize -> {Automatic, 300}, BaseStyle -> {}]}}, 
             GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.088484`", ",", "1.401553`"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"0.2`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.3`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.4`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.5`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.6`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.7`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.8`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.9`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{
            "LegendLabel", "\[Rule]", "\"Binary batch\\nmachine \[Eta]\""}], 
           ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "300"}], ",", 
           RowBox[{"Ticks", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"0.2`", ",", "0.2`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.3`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.4`", ",", "0.4`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.5`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.6`", ",", "0.6`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.7`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.8`", ",", "0.8`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.9`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.7523238134543314`*^9, 3.752323849926956*^9}, {
   3.752323960347685*^9, 3.752323993311671*^9}, 3.7523252830105333`*^9, 
   3.752325677618402*^9, 3.752326493528036*^9, 3.7523278417788143`*^9, 
   3.752337790941555*^9, 3.7523378457442536`*^9, {3.752930941521903*^9, 
   3.7529309501946664`*^9}, {3.7529309856984377`*^9, 3.752931007060091*^9}, 
   3.752931351395417*^9, 3.7529315838129025`*^9, {3.7530083118519707`*^9, 
   3.7530083586538486`*^9}, 3.7530090692929363`*^9, 3.753009110531722*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["(c)", "Chapter",
 CellChangeTimes->{{3.7530090069581933`*^9, 3.7530090075678625`*^9}}],

Cell["Compile \[OpenCurlyQuote]simulatebatch.c\[CloseCurlyQuote]", "Text",
 CellChangeTimes->{{3.7558742983873234`*^9, 3.7558743053565836`*^9}, {
  3.7558743383446693`*^9, 3.7558743546212473`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Run", "[", 
  "\"\<START /B gcc c\\\\functions.c c\\\\simulatebatch.c -o \
c\\\\simulatebatch\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.753010170199547*^9, 3.7530101714342165`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530101758094606`*^9, 3.7530252663481636`*^9}]
}, Open  ]],

Cell["\<\
Create a function that runs \[OpenCurlyQuote]simulatebatch.exe\
\[CloseCurlyQuote] for a set of inputs and sends the output to an \
appropriately named .dat file\
\>", "Text",
 CellChangeTimes->{{3.755874583020319*^9, 3.755874658466021*^9}, 
   3.7558747932456183`*^9, 3.7558756357563515`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"simulatebatch", "[", 
   RowBox[{"asteps_", ",", "ksteps_", ",", "maxn_", ",", "length_"}], "]"}], ":=", 
  RowBox[{"Run", "[", 
   RowBox[{"\"\<START /B c\\\\simulatebatch \>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "length", "]"}], "<>", 
    "\"\< > data\\\\simulatebatch-asteps\>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\<-ksteps\>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\<-maxn\>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\<-length\>\"", "<>", 
    RowBox[{"ToString", "[", "length", "]"}], "<>", "\"\<.dat\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7530100897691164`*^9, 3.7530100900349426`*^9}}],

Cell[BoxData[
 RowBox[{"simulatebatch", "[", 
  RowBox[{"21", ",", "21", ",", "25", ",", "10000000"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"simulatebatch", "[", 
  RowBox[{"5", ",", "5", ",", "10", ",", "1000"}], "]"}]], "Input",
 CellChangeTimes->{{3.7530101900299573`*^9, 3.7530101997963934`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530102007964892`*^9}]
}, Open  ]],

Cell[TextData[{
 "Create a function that takes in a data file that contains the binary batch \
machine work for various values of ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " and \[Alpha] and outputs a file containing the ratio of the binary batch \
machine work to the Markov machine work at the same points."
}], "Text",
 CellChangeTimes->{{3.7558750200978775`*^9, 3.755875103059738*^9}, {
  3.755876018296636*^9, 3.7558760405335674`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"machineratio", "[", "batchworkdatafilename_", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Export", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"StringReplace", "[", 
     RowBox[{"batchworkdatafilename", ",", 
      RowBox[{"\"\<simulatebatch\>\"", "\[Rule]", "\"\<machineratio\>\""}]}], 
     "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{"#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{
         RowBox[{"#", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
         "/", 
         RowBox[{"markovwork", "[", 
          RowBox[{
           RowBox[{
           "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
           RowBox[{
           "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
          "]"}]}]}], "}"}], "&"}], "/@", 
     RowBox[{"Import", "[", "batchworkdatafilename", "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.753010098395232*^9, 3.7530101265700855`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"machineratio", "[", 
  "\"\<data\\\\simulatebatch-asteps21-ksteps21-maxn25-length10000000.dat\>\"",
   "]"}]], "Input",
 CellChangeTimes->{{3.753010241957123*^9, 3.753010242613491*^9}}],

Cell[BoxData["\<\"data\\\\machineratio-asteps21-ksteps21-maxn25-\
length10000000.dat\"\>"], "Output",
 CellChangeTimes->{3.7530102509424744`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"machineratioplot", "=", 
  RowBox[{"ListContourPlot", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
      "Import", "[", 
       "\"\<data\\\\machineratio-asteps21-ksteps21-maxn25-length10000000.dat\>\
\"", "]"}], "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}],
      "~", "Join", "~", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"k", ",", "a", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", "0.1", ",", "1", ",", "0.1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"a", ",", "0", ",", "1", ",", "0.1"}], "}"}]}], "]"}], ",", 
       "1"}], "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", "\"\<\[Alpha]\>\""}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<(c)\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "10"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.05", ",", "0.1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"BarLegend", "[", "\[IndentingNewLine]", 
      RowBox[{"Automatic", ",", "\[IndentingNewLine]", 
       RowBox[{"Ticks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], 
         "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"LegendLabel", "\[Rule]", "\"\<Ratio of\\nmachines\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Contours", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ImageSize", "\[Rule]", "305"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7450784391041975`*^9, 3.745078480983724*^9}, {
   3.7450785901986246`*^9, 3.745078657205884*^9}, {3.7450786954599824`*^9, 
   3.745078729057355*^9}, 3.7487868052797966`*^9, {3.752325340266614*^9, 
   3.752325413955638*^9}, {3.752325444417282*^9, 3.752325444807949*^9}, 
   3.7523256709927073`*^9, {3.752325729233263*^9, 3.752325746313202*^9}, {
   3.752327873826356*^9, 3.7523278820928288`*^9}, {3.7523856083800917`*^9, 
   3.7523856165997143`*^9}, {3.752385700740011*^9, 3.7523857524090133`*^9}, {
   3.75238589939907*^9, 3.7523859510843515`*^9}, {3.752386038779814*^9, 
   3.752386038857947*^9}, {3.752931207081382*^9, 3.7529312248801007`*^9}, 
   3.752931352942499*^9, 3.7529315794374876`*^9, {3.752931772127632*^9, 
   3.752931781956809*^9}, {3.7530102611622925`*^9, 3.7530102917124023`*^9}, {
   3.7530103539377785`*^9, 3.7530104126784115`*^9}, {3.7530149936152987`*^9, 
   3.753015020852521*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[
    GraphicsComplexBox[CompressedData["
1:eJx1mnl4zFf7h1NqafpKmtpeS2lqbXkt1RBBTwgN2oit2hexRcQeGsQSIWqJ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     "], {{{
        EdgeForm[], 
        RGBColor[0.14800000000000002`, 0.33, 0.54], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNmgd0VlUSx997QVCKYANDCSShhNCDxgACCtIsoBQFKSIIKF1qpAgBFUWK
oCAgkiC9Kbq6IlKki/SmoLu6yuoqVdAAUnTnf+b3HXNO/ue2aXfmlrnfS2K3
Aa37R0EQrIsLAvsLqhkeM1Qx9LKBiVb2sHKylVMNnxgGGuYaBgXe/6rhScN6
wzTD60D1XoYh0M4zZBveNgw2dDS5L1k5wModVr7F2KfomgbfXHg7G14xTDDM
oX8g+mXHx4ZMwzuGhYbXDFMMa6UD+bMNw6ARbQ72zUOm5PWH7k1DP+ri3Wbo
jm2Tkb0G+SOQJ70zDBvxgWh7MJcc9Er/Z4bNhpmGsYbnDcuxeZ1humExciVz
vmEX/pMtz+KrtdC/Bv0oeBYY9sCn+iLDPtrD6RPtUnSPNCyBbgP6JXcnerIZ
E80B6pLxnOGIYZlhBeOjaWtubzDXQ4wtQ99S5ruCvjHQboB+O/HYaliJj5Yj
U36bZVhl+AoZ7xrGQbuS+lh8spS55uD7IcR2E7FKM3Qx3GGoZKhsaGN4xFCB
PtHUNHSifJz6nYa7Al//hairr6ThPkNT6PMb8jFW23CD4XZoStKnsScMRQ03
GeqhNz8ybjHUZ0x7tqqhOrwFkHkDdkjW3YabDcUMRbCtELbXhLdG4Pv+OmRW
x87r0ZuG7FrQ1EFWUWhrQt8Q+27Dp33wcXf01sFfXZDZiPkXR3YB5iF0pk/n
kM6jDtipvo7I647PB+Jj+fEZdGvfhfDqHNMe1V6dFPh60trZjH3a21vwiebT
Hl3V8MuthnuwsxF6bscXtaAtTQxlRw/mWg/UwVd34Te1GxAXxednM/QXQzvk
F0dfGPx9Ht8KfQPqDaDpYkTHDf8NPV7yq9aw9pD2kvawzkutKZ2RBSzA1xuu
Gf2vhiuGc6EH/oKVuYZboLnZcNHakZWXQkec1f+w8i/Dn4YbrB3CKxmXkXvW
cB7ZVw0FbexWw23IkkzJEu1l7JAuyYrQe4F2bxP9NPPRGaU9qfOlFW2dP8Mp
Y2eazpfWgdt6GXuqGWoYOoQu62n8cxU7ZcMo+B4OnPY6Qy3Za6huyGeYYehj
6Bc6v+T0DFzHmdB1SuY1fFDU5lDMcJ2hhKGwoThQvRBj+SKnLYifCsGXn/H8
tG8iNgWoF4X3RkMRw+3Udc/sDfzuSIg8rmUij510BOgqRD0fsVVcTuF/xeEU
5WnqJxn7KfQz9xz+U13x/J31kUu/fPAosTjDOhLNb6whjf8Pmr9YUwWxU3bl
ovsS/EMDv8N0H6n+APFXzFoGfvfN4Czow57vZuga+L2pPEB351OB35k92bfK
M5oHnq/0YO/q7u5OW+fWy4HnQ4OR0YzxOtAMRE5T6DvBI11T0Pdg4HlCS2RI
lu7XYYzdD203bJe9TaBV3vNi4Geg9CoHeRLdsls5RmN4+iFT8oZQz0RHH8Zj
+Y3a98I3m76nsCFm93R8dT9+GoIvJuFb5Ux9Az9bdSa9bHgpdHs7YPO/Qz/v
dNbNgUf02uPak7rblSNoX48mzkOJr9ZH28Dv9Nief4jxbPw4inWgNTAGGW2Q
Owv7sgLPF8YQo4nY3wJZg5nfIOaoddQQH6n+Or6uT7sXscxEr2x8HjtbU2+L
/eobh13Sv4y5z8Q29bXDRp3nOssLGm40ZBjqGhINycxd94ZyoG+tzG/4OvAz
qrTOYauX5AyLMxyz9vnA+zVeTvvQ6gmU56mXNbQwlIHmQuDjFXWuWXkZWskQ
/b+k1/AD9EnwLLS9e9LKxZHziq+8lcMjz9OfszJeZ7PVS4Uu8/PA8z7ll8oX
rxkewKZEytzA65cC11Ue2ZeQXwrbm2FHErS/Bc6vsSah647RqjyH7rmszb8M
Vay/cuhlO+r58PNRw5+GFGunGioYWhmS8XkN/C560UbM9RzzvYQvdUarX/ac
DlzOFSsrYZPslo07qJ+DR7z7DUoUZIds+AP+ZGKVwphsqYY9jzGfasxHeuTn
qqHbGDAeQlMJujah01SH7hHmXInYSOdD0AT4pB1rM4v1k4JdyfBcJCaal+K6
O/B7KyfwnP1w4Dm/zmG9CfX2VK62DZ9tZ83MhXcv/FnoXcV6V853JvA9oPeC
+jW/I7S1dj9gLc9D5hfo2YHPj0Mj2u3I/BWbtJ4nY/c8eOciR+2nIj+7e0Zu
g+IgvXoj6s38OutJd2js/aJ5f8k+0DkhW08xD+WuA3g7d4v8XtuBvefxy6/Q
ncHWo8iVzCXIPcD8JVtn4kH8vhhZ8vVsbDkM71/wHsHnOcz3IDTiHxp5zj0k
8rhNY5770Kn1rbes3pbZ9GlMb8pNgZ8bG7H/M+a9kPjuR9di6sPQJZ26L/Yg
ezE8ovkN/+xkfAH6xkWeK4+NvP0H47LhTeav9kVkSsbbyJkBnex8PvK38qjI
eU4zlgvtLuzQntX613o6i483Qa85622hN4DuRe0dvUN1Z+o9pPWjO1S5/JOB
5/MD4RG91oLyjccZF53egLonlCMlBv5e0L18nL3ZBh16I3SGR/rvCfw+0r2t
94feOHoX6X2kN2ct6GWP7qX0wHOFewO/K/UGLBd4rqB8Q3mF8hLlMSWoi1a5
s+6/Bsjoihzdb62wvRG29IdHvP3QXxub9Y7qiTzdy7qTlb8lYEO54O/3vN7y
I5Gv9h3oLoh98YZS9BWmPx69JZhvYcZvpJ7BnEtgo/p1VxdDVpnAc8UK6E0m
JmWJS13mUIy+FvC8TEwVW+Ukemc2RUYF7O9LvOTH0fRprhUDz4Va49+78U8K
Y7H+3vArP0kNPFdpju9KE+PY+7st/K2pp9LWWhqD3ub4PIFY6DeBhuAZ+uK4
X3T26K7RmRJyT+qM0f2iM0b91yiPBH/fSSF3WWysMveczoWr8OiM0bmiPZ3M
XaPzSXeTdOhM0N7MRWfAvabzUnmTzs9E8g3x6lxVHhS7G1S/QPt3+rSPtf/P
wiPeXdiwD5tGRn5njI48B9CZthvb92P/buRJfjZ51ELod9M/PvIz9cXI534Y
GdJRgVzgCr7QHd2TNaC1prWlNaY12ZJ1Uh48zPrQ+tT+U57dEz69CfQOaQKv
xrUWlY93DXwvKadOCnzPae/fRMzrsQa0P/pAnw5PEd7Ceh83Q34pbCuPPOVk
yuF1l2n/LkLvHvwrf/9JHOWLdyK/N+ZHPpehzFl3v+66LNqDmUs35pdBf1l8
oH0fj00tseVB6J7CL/l5ixfgDV6Cd3gcb3G9rZU3tTc8bviOHFG5QCvypmRy
M61v/UbR3zDQ0NQwnr6OoAP5ZWfDi/QNDT1XlqxOhproqknO9jiyJLO5YRCl
2veHnrsnUH+QdlNolOvrfZEPeZdsPr20NyLvV19a6L+VdMS2fOiticwEZJVD
fhK51DeG97XfTFYPK09F7p9jxCoB/c2Zb0f0DEHuIOabhi7db7rnXgJdGFf+
qhx+tGEufHOQpVj8x3DEsMKwChqNbzVsplT7UeJYFXu+N0ww3BFnb0krG1j5
DytfMbwKXXt80Y4Yjwn93HuMvuHErRXyxZPKmOyuzDzSmEsWvB2gU17dNvSc
/DnkXNRvZ1b+Efl58Ege+anQS/ZIxrR2ErFD7UqMJxGvloaHQ39jqd4CnsHY
pPX1QujrdqZhFvMczTy0TscTv1XUXyRGneD9nr4J8Gqey0Jfo/2RmcW8x9M/
h1jOoj4QW8YhcwU84/FZFrI1p2HM5TZ+jyvEGtTanhr6GhOd1lnBOI9papzH
cxx6WiIn01DUxiZZWTLO/SwfP2943fBM6L8bZoe+V4ejR/3ToB0F/bzQ1992
4jmc2I0lfqLR+3ZA6G/Zn8zunlaeiDxGrUN/b2msFLQP01eetuL3LH2iT6FP
Y2WgS2J+KdDIxrLEXbRnTN/TVv4WuY9i54riqL2tfV0+zvdBGSvnMxfNSetu
AfXphjdCX6+9qffFTw/BM5q4LcEP7fHFTNZGX+p94Zf8NvAJi+gbS+zE/wh9
suEUsU8yO78KfY2+Z/jYsMbwT8Nkw0ehz2cIMVKsdHboDPkOGsmZSlynEucP
Q18bE5E5mTGdLVq7nyFzEHKlc63htdDX1xB0zTZsMrzJOljKnL7H37I5Bx7R
T8H2NfDo92v9dr0+9HU5A5o16BpheMewMPT1NRu+TPpH0Ke181bo+0H7okbc
33P+BLni24j+SfhgEfFYQn0P62Asc1lu2IIOyX+bcjD+mI6dWhvZjK+jX+OL
8cso6ktpi1braD79o5ij+ncgZydt0byBzHV57NiGrRp/DhkjkDOOOcj+fcxN
c9xAbGcicwP1kdAsIF6ZxEw8OvMOGFYidzm86+DXGbYCuvnI2EVb/GPQOQtd
ivOnxEb1PnniPon46Bx+17A69PWpvo/AZPp0Hn0e+rqaSpw/xpZD6N+Lfxfi
1234TrRroN9KjLdRvkU9dtduwQ793qK3qta21rXuBt2tr2JXDvZ8EfrazKG+
FVvn0jcPuo+Y14fYuR9bP8W+adB8iJ4X8Eksl1iNPXPw7WbsWoVtK6EX3zHG
3mdu27FrG37ZTowUz43UVW7Cd5rP7tD3wRb610OzAfsXQiP/j8eOHHgzoRet
1s0zxH4adspGra0J2N6Z8fX4Yy3x+gR5X6BrKX47GPp+0frbhX930Pc581M7
m74d+Ho/MjYxr83oiOmU/hl5fLEZ36yDZj39Gn+T/rWMReRgBeL8N1r9nqY3
pe6+lvhE+aq+l/5IqXYa89c5rrV2grrOc/3Grm9VvzOm/pPwS770XE/ufzP5
sMbUfwIZymNPwnsCvdLZhbbGY9+AVX4LjdaavnnpLj1NW+M/Y5PGzkL7Czae
oP84POrLpV/2yjZ9p9P7JJ73yTF0fM0cZesp6PWdT98s9CbWe0C5eNfIv+v0
s7IO+W5jK++2dj1DU8MdhtqGBqIx3Geoy1izyGmbQt8E1M1D14QxfQTXefUn
siSzvvKOyH+36h353aizU7naYL4v6DuD5q5vjPqWKH1phlrY0xhdDZHbgrrK
+yPP4yeypspZO9VQxdA98t9lnoBWvM2xqXme+WagI4251qdeP88cmsHTjLbo
rkSew1yL3O/yv36bOUU8fyCeJ4np2Txr+Ufaiq/OoS8NR0P/pl6E9+hqxtSv
c0NvnkOUX8FzOE+f6gfztGPjWu/6zq23r751X6VPuXTZyH2mb+qxb9f6pqtv
u/o/AH2T1/dgvYuvg059yr/1zT/g94CQnDxGJ5o45qJ1q/W6mrlcwZarzLcw
dBFyCkOv3/h1rxxjvR+l/ABZOp90tuoOP8Dc99NeQt8hymV5xtT+hvhIts4T
vS215y8Ru4v4Tj5cSVz17Vu/o10gprnswVPIepQ1oG/pe9Al+xZR38McviR+
RymPAdXfI3araMfmcBCbRfc+Nn3J+tBZvwv5hxlbTv8Xecb20reHPuUiFeP8
PaJ3ST/OiicjP3OSDMmGkoZSkf9Pg1CUvttYI2WJcTxj4tPvKomGdMM9hnvZ
k9qbd0b+G4xklkZXCfhKIiOedSkZxdFVjnop6CoYqsFX1VAReRovb6gBTQXG
1K//rdDZXwYbStNORlZ1xm5mLBHbYnpvwgelkVkJ3iT405nrXZSNqOsc0Tlb
OfKzsmbkZ2c6/rgHe+syVhrZZeCvxhzVp3MxDVrx1GEsCXsT4EuJ/IxriO5a
8FekXhNbUqCvxPzrILc2Y2mMpdGuTFkb+gx4qmNnBj6pThwy6L+LGFbBzorE
RnbonaD3qdbiiMj/VzIz8pxd71nlBWMi/0aVFfl7R+/fZ4HeHMpNX0PGFPqV
k4l2J3tB+c7VyHOsy5HL1tugLXTKU/TmupW3kn5LGIF+5SRV8LXs19t6KLqf
Rvd02upXLt2bsVi/bNJ7fG/k35EPR/72H4DeEdgju+Lxn9b67fg0npjdnSeG
tfClfKu9mApfPDxVWGPp+Lsk47FYar0cijxv2Ad9OvOsAa1iqTNlKWfRYc4Y
1dOJbVXsqQDfgsh/132HfZABXWPq6tvJWaTY/B83OGVJ
           "]], 
          PolygonBox[CompressedData["
1:eJwlkslKnUEQRvuvX3CZjRsvCBpCcHc3blyL4tqNQ6LGa/Q6u1DEKZo4xHgd
XkEkJD6AgvPwBLrQp3C4iAPOw/moxYHT3dXV1dVdlOqt6rEQQhJyoDAOYTEK
oRU+44MsbjG/AQP4L9jGd2ESb4JpfAa+47nsybB3Hj7g0+ax+/Abv4U0ay1w
iU/BAWt7MIHfQAVrCTjGl+E8eIxih2Ad34QR/Kf53h0Yw0fNXTUP4z/MY1Xz
OH5knjvL+B+epMZZxqtQil8xV453QxQ78k4I+MfYa1+AYvyN+J7Ia1btidjv
rh6qlyfM5UeeU7kfoAPvgif81Tx3Ozzj19AWecwd/mIeqzN0lnqoXp7BEv7f
3C9gBW+EP+o1fMFPzd9SObN4PdSxVgMNeAE1zkXegzw8Zb5XMYrVHXVXxXzC
O5mbC/4GfXhZ7L1bg0q8jrlq1mrhqzly/ZFv5jWqVvXk0PwN9BZ647/qDcwG
P0NntUAm+J2a8XaYDz6XNj9TZ+vPleCt5n9ROdrwfvO/qz3a+2jea/3Be/wd
pQVmcQ==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.4200512493561599, 0.45132791510919357`, 0.5721423965446217], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtk8cuhlEQhr9/XIFu60r4ERdgqfceIkT0TiQiQXRCRLBWL4GFmrDX6xKJ
Xp7JzOLNM+f758x5Z875EwtrM2okCIJ0FIFu0T2KDAXBA4yBT3CapEs4C59R
Kt/P4DJKIF6B2aiXnEw4ha6IJ+AwuiAeh2PonHgSzqNr4gX4itKo8wffURLx
p9hav//AFnRHfhvsEfPVJ2Zc/YQizLPmRLEu4rct4hJYhnaIK+CuWH8HYvu1
zpLYnhjvO8771vWI+9c+dDbRIduvHjWORSkhm4Pu2yRnO7A+T92/9lcl9r0S
doid0+XfLj1f6z0GVjPNa6b4GfEojHLUNzmF8NB978Nkz43zWehM9K5GfeY6
+yy0QZznM471ml9iez/gkdhZa7AR3ZDfJOZN+1d/5WJ9lsJBtE5cB6u9/pDY
fHVOJz4/fQ96B/n+TvS97Lv/Pdjq76EZ1vtcdGZv3tuLv7uwz0Jr6f1e+L3q
ugEuinkcgLk+K53ZnPcyI3avyT6rYvdfADvF/gPtYv3rOavq1+++W6yu1u8X
e/d6R8fwW8zbL/wHO/Rzlw==
           "]], 
          PolygonBox[CompressedData["
1:eJwtk8lvj1EUhr/fqYSwMBYhmpYaWgsWtaiFqY3o1tYCNUZQ8zyXRMKCxDxP
sVXjn8DKVPbmamvsAjHG8+a8iyd5v3vPec/9zj23qrll7uooimI29IIuPmaU
imIIPEX3wFf4CJ9gD3QS1w370FvgLboDtqFldgN9Ew6i/0IjXrPgN3o+3GLv
DixCn4/MlcdZ9F54j34Hu9FXYCi5w+EqepX9W2FB5Bl11kHwEL0zMvcNbEeP
LyuKcdAhXzgDr7x/Dr0RXrv+JvQ/mIlXAxTkXed7GLocrqE3O/8urEf3IaY3
9IcB8J21b+5Zj3um3o1mbwxsjawtD3lNZ20aBJTZQ14jYKTXwjVUa2Fkb9UD
9WJF5Fluw3L0MXjp/q5Br3W89tehd7jfusNd6BPwwuc5FRmjWK0dRR/yfbXB
YfQGuFdkz9S7JZG1tLYMvdT5qrkY/Uv/WMqe/kE3w377tUSeUfmqsTJyrc3f
89DtMLiUHp2RPVQvJ0CNe6ReVUIVHCCmq8gZakWf9nzqvCfRlyNnVzOl2dKd
6m6VcxH9OHLWNLPP0Mc9H+rpEfQTGFjKM7V7pjRb3fABfkbOut7QD69p7zN8
gUueT3ncR1/wPGhNew8iZ1l3pLdR43+thrHQBHOgDqZABYyCIVDuHlR65jX7
jdDgnCbn1HnmNHuTYRLUw1TXqLZnhT3l3Rf6OabenvJ+HvlW9EYeRcYothYm
mlrXUK3/J/uOiQ==
           "]], 
          
          PolygonBox[{{751, 750, 755, 320, 745}, {744, 319, 760, 757, 
           758}}]}]}, {
        EdgeForm[], 
        RGBColor[0.5883777494420052, 0.5104841930946344, 0.4731900770053388], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtkMtKglEUhY//P7S0qdREUsSH0IfwEbShlPUSCgUl5CVvNBQcCypERFRO
hGyaOhCExEE0aey3+ddg8a1zW/vsHc9f5M4951wC+WjDohByLsbiD5/B/8Mf
+S94gxbcvYbvKMr+I2yjI3wXpv0g59QP3tjbTzhBYfwz7KMlObfwSv4SNnWn
DofoAD+Gc5TFb2EHHeJbME6NM/wxrLD+JseaqirTsktohb+HT8q07KL27Xym
fKvzK7/zgt6sxx48Ua21F8zF+rLZvKEI/gUm1bvNoKuZfMCG7jzAsuoOYEqZ
1sed/laDr+pxCkeaic1vq7/ZH/eVyzrK
           "]], 
          PolygonBox[CompressedData["
1:eJwtkbsuRFEUhrd1piBnMArKESFRUIzCFI5hCopRegSUQrwFUYtr1BLxCCIi
7iR6l8IlClF4A9+ftYov+ffe/17XgYXV+RVLKQ1BCfY4dLallMMO+hYq6C64
RG/CC743WEafmXv15wJ9bu4twyn6HZbQk/CJvjfXU/BofqezcihXX5ZSL+RQ
hlEYgRqMQR3GYRqa4cnDI+8dMbqJVcAHuuBuAmZgFg7jXfUeoH/NvQ34Q99E
//Io1m70o/r2LWKiF+EL/R31q8dh4j/Eu/5foQcz9+pOuX7Me9cf/X0yz613
/d2AZ2b7CkfmNav2FsxBP1RjRppVB7RDBXrgOval+Jr1mnksxVxHH5vvTjs8
QW+Z70o9bpvPVLPNoBQ5WzHzeuygFjMtwpNFDarlH9YlOio=
           "]], 
          
          PolygonBox[{{697, 268, 656, 653, 654}, {655, 221, 657, 658, 659}, {
           654, 653, 660, 222, 647}, {659, 658, 662, 267, 696}, {785, 784, 
           795, 356, 796}, {793, 355, 805, 798, 799}}]}]}, {
        EdgeForm[], 
        RGBColor[0.7567042495278505, 0.5696404710800753, 0.3742377574660559], 
        GraphicsGroupBox[{
          
          PolygonBox[{{785, 354, 777}, {696, 265, 659}, {714, 313, 712}, {741,
            313, 739}, {796, 354, 785}, {740, 314, 738}, {647, 266, 654}, {
           739, 313, 714}, {725, 265, 691}, {689, 265, 725}, {659, 265, 
           655}, {713, 314, 740}, {654, 266, 697}, {727, 266, 690}, {791, 354,
            731}, {799, 353, 793}, {709, 314, 713}, {687, 266, 727}, {790, 
           353, 799}, {737, 353, 786}}], 
          
          PolygonBox[{{833, 832, 772, 773}, {843, 842, 822, 823}, {699, 698, 
           703, 704}, {650, 649, 680, 681}, {813, 812, 817, 818}, {731, 354, 
           314, 736}, {704, 703, 707, 708}, {702, 701, 693, 694}, {735, 313, 
           353, 737}, {828, 827, 837, 838}, {684, 683, 685, 686}, {706, 705, 
           701, 702}, {793, 353, 313, 741}, {738, 314, 354, 796}, {823, 822, 
           832, 833}, {818, 817, 827, 828}, {781, 780, 812, 813}, {838, 837, 
           842, 843}}], 
          
          PolygonBox[{{708, 707, 712, 313, 735}, {786, 353, 790, 780, 781}, {
           691, 265, 696, 698, 699}, {773, 772, 777, 354, 791}, {681, 680, 
           655, 265, 689}, {694, 693, 697, 266, 687}, {690, 266, 647, 683, 
           684}, {736, 314, 709, 705, 706}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9039985223025073, 0.6299963057562684, 0.3023954191377728], 
        GraphicsGroupBox[{
          
          PolygonBox[{{735, 311, 708}, {702, 312, 706}, {708, 311, 704}, {706,
            312, 736}, {730, 312, 734}, {681, 263, 650}, {736, 312, 731}, {
           689, 263, 681}, {732, 311, 733}, {737, 311, 735}, {684, 264, 
           690}, {686, 264, 684}}], 
          
          PolygonBox[{{692, 691, 699, 700}, {726, 725, 691, 692}, {824, 823, 
           833, 834}, {834, 833, 773, 774}, {819, 818, 828, 829}, {844, 843, 
           823, 824}, {814, 813, 818, 819}, {787, 786, 781, 782}, {829, 828, 
           838, 839}, {695, 694, 687, 688}, {688, 687, 727, 728}, {782, 781, 
           813, 814}, {839, 838, 843, 844}, {774, 773, 791, 792}}], 
          
          PolygonBox[{{792, 791, 731, 312, 730}, {682, 263, 689, 725, 726}, {
           700, 699, 704, 311, 732}, {734, 312, 702, 694, 695}, {733, 311, 
           737, 786, 787}, {728, 727, 690, 264, 729}}]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.95, 0.75], 
        GraphicsGroupBox[{
          
          PolygonBox[{{594, 352, 592}, {688, 310, 695}, {700, 309, 692}, {732,
            309, 700}, {726, 307, 682}, {730, 352, 792}, {695, 310, 734}, {
           591, 351, 593}, {787, 351, 733}, {792, 352, 774}, {729, 308, 
           728}, {782, 351, 787}}], 
          
          PolygonBox[{{589, 310, 308, 590}, {733, 351, 309, 732}, {728, 308, 
           310, 688}, {734, 310, 352, 730}, {592, 352, 310, 589}, {839, 597, 
           600, 829}, {829, 600, 598, 819}, {692, 309, 307, 726}, {834, 596, 
           599, 824}, {824, 599, 601, 844}, {844, 601, 597, 839}, {587, 307, 
           309, 588}, {588, 309, 351, 591}, {819, 598, 595, 814}}], 
          
          PolygonBox[{{814, 595, 593, 351, 782}, {774, 352, 594, 596, 
           834}}]}]}}, {{}, 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{682, 726, 692, 700, 732, 733, 787, 782, 814, 819, 829, 839,
            844, 824, 834, 774, 792, 730, 734, 695, 688, 728, 729}]}, "6"], 
        Annotation[#, 6, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{650, 681, 689, 725, 691, 699, 704, 708, 735, 737, 786, 781,
            813, 818, 828, 838, 843, 823, 833, 773, 791, 731, 736, 706, 702, 
           694, 687, 727, 690, 684, 686}]}, "5"], 
        Annotation[#, 5, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{685, 683, 647, 654, 697, 693, 701, 705, 709, 713, 740, 738,
            796, 785, 777, 772, 832, 822, 842, 837, 827, 817, 812, 780, 790, 
           799, 793, 741, 739, 714, 712, 707, 703, 698, 696, 659, 655, 680, 
           649}]}, "4"], Annotation[#, 4, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{622, 648, 625, 626, 657, 658, 662, 664, 666, 668, 670, 672,
            710, 716, 720, 722, 744, 758, 753, 749, 803, 809, 805, 798, 789, 
           779, 811, 816, 826, 836, 841, 821, 831, 771, 776, 784, 795, 801, 
           807, 743, 747, 751, 745, 721, 717, 715, 711, 669, 667, 665, 663, 
           661, 656, 653, 660, 624, 620, 651, 652}]}, "3"], 
        Annotation[#, 3, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[CompressedData["
1:eJwNzbsuA2AABeC/7SCxWExNJCUiYrF0sVgsZqO61qUtoQOta6m2vIag2rdh
4BkMIiJoUIpv+JKTnOSc/nR+ajMSQkgxHQ1hhgU2WGSZVbKssc4WO+xxQIlj
Tqhyyhnn1GnQ5IZ7XonEHPIr/9DmkxYvPDGgH2aQPnrpZoRRxphgkiTjROmi
hzgJhniw98gzb3zwxTcd/njnjluuueKSC2pUKHPEIfvsUqTANjkyrLDEPCny
pJlljn8TJjCo
           "]]}, "2"], Annotation[#, 2, "Tooltip"]& ], {}, {}}}], {
    DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
     Identity, Frame -> True, FrameLabel -> {{
        FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}, {{{0, 
          FormBox["0", TraditionalForm]}, {0.05, 
          FormBox["0.05`", TraditionalForm]}, {0.1, 
          FormBox["0.1`", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.05, 
          FormBox["0.05`", TraditionalForm]}, {0.1, 
          FormBox["0.1`", TraditionalForm]}}}}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 305, 
     Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
     FormBox["\"(c)\"", TraditionalForm], PlotRange -> {{0, 0.1}, {0, 1}}, 
     PlotRangeClipping -> True, PlotRangePadding -> {Automatic, Automatic}, 
     RotateLabel -> False, Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               "\"Ratio of\\nmachines\"", {FontFamily -> "Arial"}, Background -> 
                Automatic, StripOnInput -> False]}, {
               GraphicsBox[{{}, {}, 
                 
                 RasterBox[{{{0.148, 0.33, 0.54}}, {{0.4200512493561599, 
                  0.45132791510919357`, 0.5721423965446217}}, {{
                  0.5883777494420052, 0.5104841930946344, 
                  0.4731900770053388}}, {{0.7567042495278506, 
                  0.5696404710800753, 0.37423775746605586`}}, {{
                  0.9039985223025073, 0.6299963057562684, 
                  0.3023954191377728}}, {{1., 0.95, 0.75}}}, {{
                    Rational[-15, 2], 
                    Rational[-305, 2]}, {
                    Rational[15, 2], 
                    Rational[305, 2]}}], {Antialiasing -> False, 
                  AbsoluteThickness[0.1], 
                  Directive[
                   Opacity[0.3], 
                   GrayLevel[0]], 
                  LineBox[
                   NCache[{{
                    Rational[15, 2], 
                    Rational[-305, 2]}, {
                    Rational[-15, 2], 
                    Rational[-305, 2]}, {
                    Rational[-15, 2], 
                    Rational[305, 2]}, {
                    Rational[15, 2], 
                    Rational[305, 2]}, {
                    Rational[15, 2], 
                    Rational[-305, 2]}}, {{
                    7.5, -152.5}, {-7.5, -152.5}, {-7.5, 152.5}, {7.5, 
                    152.5}, {7.5, -152.5}}]]}, {
                  CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -101.66666666666664`}, {
                    Rational[
                    15, 2], -101.66666666666664`}}, {{-7.5, \
-101.66666666666664`}, {7.5, -101.66666666666664`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -50.833333333333314`}, {
                    Rational[
                    15, 2], -50.833333333333314`}}, {{-7.5, \
-50.833333333333314`}, {7.5, -50.833333333333314`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 0.}, {
                    Rational[15, 2], 0.}}, {{-7.5, 0.}, {7.5, 0.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 50.83333333333334}, {
                    Rational[15, 2], 50.83333333333334}}, {{-7.5, 
                    50.83333333333334}, {7.5, 50.83333333333334}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 101.6666666666666}, {
                    Rational[15, 2], 101.6666666666666}}, {{-7.5, 
                    101.6666666666666}, {7.5, 101.6666666666666}}]]}}}, {
                 Antialiasing -> False, 
                  StyleBox[
                   
                   LineBox[{{7.499999999999999, -152.5}, {7.499999999999999, 
                    152.5}}], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.499999999999999, -101.66666666666666`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -101.66666666666666`}]}, {{
                    7.499999999999999, -50.833333333333314`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -50.833333333333314`}]}, {{
                    7.499999999999999, 2.4455600638347716`*^-14}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    2.4455600638347716`*^-14}]}, {{7.499999999999999, 
                    50.833333333333364`}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    50.833333333333364`}]}, {{7.499999999999999, 
                    101.66666666666663`}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    101.66666666666663`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["2", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -101.66666666666666`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["3", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -50.833333333333314`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.499999999999999, 
                    2.4455600638347716`*^-14}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["5", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.499999999999999, 
                    50.833333333333364`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.499999999999999, 
                    101.66666666666663`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                Scaled[0.02], PlotRange -> All, Frame -> True, 
                FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                Opacity[0], FrameTicksStyle -> Opacity[0], 
                ImageSize -> {Automatic, 305}, BaseStyle -> {}]}}, 
             GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.702592882274266`", ",", "10.`"}], "}"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"3", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"4", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"5", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"6", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", "\"Ratio of\\nmachines\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "305"}], ",", 
           RowBox[{"Ticks", "\[Rule]", 
             RowBox[{"{", 
               
               RowBox[{
                "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], 
               "}"}]}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.745078444198498*^9, 3.7450784813743844`*^9}, {
   3.7450785904486513`*^9, 3.745078595636711*^9}, 3.745078627983951*^9, {
   3.745078703632738*^9, 3.7450787297449293`*^9}, 3.7451468704782915`*^9, 
   3.7487866567949023`*^9, 3.7487866963310366`*^9, 3.7487868068609533`*^9, {
   3.7523253275152597`*^9, 3.752325376676732*^9}, 3.752325415601722*^9, 
   3.752325447155611*^9, 3.7523256732273464`*^9, 3.752325748485364*^9, {
   3.7523278745607777`*^9, 3.752327883030428*^9}, 3.7523856175216875`*^9, {
   3.7523857056780357`*^9, 3.7523857530624895`*^9}, {3.7523859006492023`*^9, 
   3.7523859520219517`*^9}, 3.7523860398736806`*^9, 3.7529312271147428`*^9, 
   3.7529313540675707`*^9, 3.752931579890641*^9, {3.752931779018977*^9, 
   3.7529317825350056`*^9}, {3.7530102637719316`*^9, 
   3.7530102845397663`*^9}, {3.7530103287475853`*^9, 3.753010355125388*^9}, {
   3.753010388410174*^9, 3.753010413194086*^9}, {3.7530150028662324`*^9, 
   3.7530150214463315`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["(d)", "Chapter",
 CellChangeTimes->{{3.7530090133494925`*^9, 3.753009014896766*^9}}],

Cell["Compile \[OpenCurlyQuote]simulatebatchworkoptimumcontour.c\
\[CloseCurlyQuote]", "Text",
 CellChangeTimes->{{3.7558742983873234`*^9, 3.7558743053565836`*^9}, {
  3.7558743383446693`*^9, 3.75587436688839*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Run", "[", 
  "\"\<START /B gcc c\\\\functions.c c\\\\simulatebatchworkoptimumcontour.c \
-o c\\\\simulatebatchworkoptimumcontour\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.753015413706769*^9, 3.7530154150662813`*^9}, {
  3.753015742147933*^9, 3.7530157433199058`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530154195667562`*^9, 3.753015748320442*^9, 
  3.7530252698485394`*^9}]
}, Open  ]],

Cell["\<\
Create a function that runs \
\[OpenCurlyQuote]simulatebatchworkoptimumcontour.exe\[CloseCurlyQuote] for a \
set of inputs and sends the output to an appropriately named .dat file\
\>", "Text",
 CellChangeTimes->{{3.755874583020319*^9, 3.755874658466021*^9}, 
   3.7558747932456183`*^9, 3.7558760846632338`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"binarybatchoptimumn", "[", 
   RowBox[{"asteps_", ",", "ksteps_", ",", "maxn_", ",", "length_"}], "]"}], ":=", 
  RowBox[{"Run", "[", 
   RowBox[{"\"\<START /B c\\\\simulatebatchworkoptimumcontour \>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "length", "]"}], "<>", 
    "\"\< > data\\\\simulatebatchworkoptimumcontour-asteps\>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\<-ksteps\>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\<-maxn\>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\<-length\>\"", "<>", 
    RowBox[{"ToString", "[", "length", "]"}], "<>", "\"\<.dat\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.753015351794161*^9, 3.7530153749213905`*^9}, {
  3.7530157597904563`*^9, 3.7530157709166203`*^9}, {3.7530158152026415`*^9, 
  3.7530158371113443`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"binarybatchoptimumn", "[", 
  RowBox[{"5", ",", "5", ",", "10", ",", "1000"}], "]"}]], "Input",
 CellChangeTimes->{{3.7530154320056257`*^9, 3.753015436209386*^9}, {
  3.75301585015961*^9, 3.7530158518627586`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530158575507894`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"batchnplot", "=", 
  RowBox[{"ListContourPlot", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<data\\\\simulatebatchworkoptimumcontour-asteps100-ksteps100-maxn50-\
length10000000.dat\>\"", "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"InterpolationOrder", "\[Rule]", "0"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Contours", "\[Rule]", 
     RowBox[{"Range", "[", "49", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.08"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", "\"\<\[Alpha]\>\""}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<(d)\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.04", ",", "0.08"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"SwatchLegend", "[", "\[IndentingNewLine]", 
      RowBox[{"\"\<M10DefaultDensityGradient\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{"1", ",", "45", ",", "4"}], "]"}], "~", "Join", "~", 
        RowBox[{"{", "\"\<\[GreaterEqual]49\>\"", "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"LegendLayout", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Grid", "[", 
           RowBox[{"Reverse", "[", "#", "]"}], "]"}], "&"}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"LegendLabel", "\[Rule]", "\"\<N\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"ImageSize", "\[Rule]", "310"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.745146263694048*^9, 3.745146327763507*^9}, {
   3.7451464057721043`*^9, 3.745146473607318*^9}, {3.7451465055951815`*^9, 
   3.74514652870706*^9}, {3.745146608621932*^9, 3.74514664520401*^9}, {
   3.7487867398948803`*^9, 3.7487867755126286`*^9}, {3.752325497598467*^9, 
   3.7523255065933485`*^9}, {3.752325621456184*^9, 3.75232566442959*^9}, {
   3.7523859029150677`*^9, 3.7523859188698883`*^9}, {3.7529311509191513`*^9, 
   3.7529311589983187`*^9}, 3.7529313565678434`*^9, 3.752931572186717*^9, {
   3.752931614628682*^9, 3.752931624926694*^9}, {3.753015925870705*^9, 
   3.7530159806241264`*^9}, {3.7530160155026126`*^9, 3.7530160644296913`*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[
    GraphicsComplexBox[CompressedData["
1:eJyM3Xm4tlddn30cwBAEZ0StKK1SBrFKQgcwCb7VmmAVEepAbYtttT1Kq1Yc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     "], {{{}, {
        EdgeForm[], 
        RGBColor[
        0.16085714285714287`, 0.33714285714285713`, 0.5520408163265307], 
        GraphicsGroupBox[{
          
          PolygonBox[{{59203, 1, 58807, 59599}, {59600, 58808, 2, 59204}, {
           59202, 58805, 58806, 59201}}], 
          PolygonBox[CompressedData["
1:eJwl2AXUFGUbBuAPBBGQbpTuEKQ7le4wQAVERUDp7pZQOgREEZQ0CFFCkVAa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           "]], 
          PolygonBox[CompressedData["
1:eJwU3WO8HFcDB+A0tm3btp00tm3btm3btm07Kd8maaOmsZqk7zMfnt9273/P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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[0.2122857142857143, 0.3657142857142857, 0.600204081632653], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58814, 598, 599, 600, 58813}, {58811, 595, 596, 597, 
           58812}}], 
          PolygonBox[CompressedData["
1:eJwl2mW4VcUaAGBAuru7u5FUEOkG6e7u7pbu7m6RLpHuBunuLilR+r7ruT/e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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[
        0.26371428571428573`, 0.3942857142857143, 0.6483673469387755], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58838, 4162, 4163, 4164, 58837}, {58830, 2974, 2975, 
           2976, 58829}, {58827, 2971, 2972, 2973, 58828}, {58819, 1783, 1784,
            1785, 58820}, {58835, 4159, 4160, 4161, 58836}, {58822, 1786, 
           1787, 1788, 58821}}], 
          PolygonBox[CompressedData["
1:eJwV3HP4lXcfAOCWvWzby7Zt2/bysrVWrVXLtmvVWq71pmXbtt17P3/c17nO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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[0.3251020408163265, 0.4179591836734694, 0.6279591836734695], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58846, 5350, 5351, 5352, 58845}, {58851, 6535, 6536, 
           6537, 58852}, {58862, 7726, 7727, 7728, 58861}, {58843, 5347, 5348,
            5349, 58844}, {58859, 7723, 7724, 7725, 58860}, {58854, 6538, 
           6539, 6540, 58853}}], 
          PolygonBox[CompressedData["
1:eJwV2mO0XdcWAOAb27Zts7FtO2mb9jVo2gZFmsa2bdu2bdu2+b794xt3nDPP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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[
        0.3889795918367347, 0.44040816326530613`, 0.5904081632653062], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58875, 10099, 10100, 10101, 58876}, {58867, 8911, 8912,
            8913, 58868}, {58886, 11290, 11291, 11292, 58885}, {58878, 10102, 
           10103, 10104, 58877}, {58870, 8914, 8915, 8916, 58869}, {58883, 
           11287, 11288, 11289, 58884}}], 
          PolygonBox[CompressedData["
1:eJwV2mO0XFcYANAXNjYbo7Ftu3Ha2LZt27bd2LZtO2kaN3bS7vmxM+vNd7+D
e3TvrCRp2K5y2+BBQUHp/BPaZ41yQUE1qUVt6lCX2MQhLr8Sj/j8WSooqCrV
qE4NapJALCGJSEwSklJUrBjFKUFJSlGaMvxOWcpRnmRykvMbKUhJKqrwR6B+
qlKN6pSkFKUpw++UpRzlqUBFKlE58Lc6KlKJylThD1KLpSEt6UhPBjKSicxk
ISvZyE4OcpKL3ORhVNOgoNGMYSzjGM+fVKUa1alBTWpRmzrUpR71aUBDGtGY
JjRlCEMZxnBGMJJmNKcFLWlFazrRmS50pRvdaUNb2tGeDnSkH/0ZwEAGMZi8
+paP/BSgIIUoTJHAOFOM4pSgFa1pQ1va0Z53zYKC3vOBj3ziM3ubBAXtYz8H
OMgheqi7J73oTR/68o+cJzzlGc95QQd1dKQTnelC10C7jXEBClKIwhShiVhT
mtGcFrQMrAex2tShLvWoTxva0o72dKAjDWhIIxoHyqUp4ZUVgYhEIjJReFk2
KOgV//KaN7ylmZzmtKAlrWhNNznd6UFPetGbPvSlH/0ZwEBmtQoKms0c5jKP
+UxhKtOYzgxmMo7xTGAik5jMCEYyitGMYSyD1DGYIQxlGMP5Tx+CfAYjOCEI
ST3q04CGNKIxX1z/lW985wc/6aTPnelC10D/6c4oRjOGsYxjPBOYyCQmM4Wp
hFJHaH4hDGEJxwRzaCKTmMwUphJVLBrRiUFMYjFNWdOZwUxmMZs5zGUe81nA
QhaxmCUsZRnL6UFPetGbPvSlH/0ZwEAGMZgVrOQvVrGaNaxlHevZwEY2MYSh
DGM4IxjJO/f0PR/4yCc+c9+aecBDHvE3j9nvXhzgIIc4zBGOcozjnOAkp7gs
5wpXucZ1bvAXq1jNGtayjpvc4jZ3uMs9znKO81zgIpdYzwY2sonNbGEJS1nG
clawknnMZwELWcRietGbPvSlH/0Zw1jGMZ4JTGQAAxnEYIYwlEY0pglNaUZz
2tE+sA/RkU50pgtd6UZ3etCT45zgJKc4zRkOcojDHOEox9jNnsB+yb7AOHGA
rWxjOzvYya7AeBqbx4H9kic85RnPecFLXvEvr3nDW97xng98JKayYhGbOMTl
V+IRnwQkJBGJqUZ1alCTWtRmGMMZwUhGMZpP6vjMF77yje/84Cf/EeS6YASn
BS1pRWva0JY61KUe9WlAw8D8kn+P+zzgIY8IKxaO8EQgIpGITBSiEo3oxCAE
IQlFaH4hDDOYySxmM4e5TGIyU5jKNKZzXd03uMktbnOHohSjOCUoSanAuDkL
n/GcF7zkFf/ymje85R3vuc0d7nKP+zzgIY/4m8f8wxNKq6MMv1OWcpTnqtg1
rnODm9yiglhFKlGZKvzBIhazhKUsYzmb2cJWtrGdHexkF7vZw172sZZ1rGcD
G9nENKYzg5nMYjZzmMs85rOAhaxgJX+xitWsCXw6w9awlnWsZwP5xQpQkEIU
pkhgn9PnU5zmDGc5RyKxxCQhKclITnRiBNYNsYhNHCISichEISrROM0ZznKO
81zgIpe4zJXAeHCN30hBSlKRmjQc1qYjHOUYxzlBWrF0pCcDGclETnKRmzzk
JV+gfjkXuMglLnOFD3zkE5/5wle+8Z0f/OQ/gpQTjOCEICShCE1mspCVbGQn
B78QhrCEIzwRAtc1cB3ZyUFOctEjpX2UXvSmD33ZaCw3sZktbGUbN+Xc4jZ3
uMs9LnOFq1zjOjdo0Mj+QSMa04SmRC9ofIlJLGITh6sN5XOdG9zkFmeVdY7z
XOAilzjOCU5yitOc4T4PeMgj/uYxBznEYY5wlGO84z0f+MgnPvOFr3zjOz/4
yT884SnPeM4LXvKKf3nNG94STJ+DE4KQhCI0u8X2sJd97OdAoB36/JFPfOYL
X3nKM57zgpe8YhzjmcBEJjGZEYxkFKMZw1huc4e73OM+D9jODnayi93sYSOb
2MwWtrKNQQxmCEMZxnCi61sMYhKL2MQhLr8Sj/gkICHf5HznBz/5jyDf/0IY
whKO8EQgLelITwYykomIRCIyUYhKNBKRmCQkJRnJ+Vc9r3nDW97xPtA/Y7CN
7exgJ7tYYF0uZBGLWcJSlrGcFazkL1ZRWFlFKEoxilOC2MQhLr8Sj/iUozwV
qEglKlODmtSiNnWoy172sZ8DHOQQzfStOS1oSStakzqdfY60pCM9GTgv5wIX
ucRlrhCVaIHxJAYxiUUCOQlJRGKSkJSTYqc4zZnAuuUchznCUY5xnBOEJwIR
iURkolCSUpSmDL9TlrzkIz8FKEihQHtISCISk4SkZCcHOclFbvLQx9j0pR/9
GcBAxjGeCUxkEpOZwlSmMZ0ZzGQWs5nDXOYxn1rudW3qUJd61GeQ2GCGMJRh
DGcjm9jMFrayjRGMZBSjGcNYQulDaH4hDGEJRzKS8xspSEkqUpOGtKQjPRnI
SCYyk4WsZKMKf/AnValGddZbAxvYyCY2s4X/CBIPRnBCEJKnzoxnPOcFL3nF
arE1rGVdoFw2sICFLGIxS1jKS898r/iX17zhbeB5vqj9ib3sYz8HuMktbnOH
u9zjOCc4ySlOc4aDHOIwRzjKMdazgY1sYjNbGMNYxjGeCUxkGMMZwUhGMZoZ
zGQWs5nDXOYxnwUsZBGLmcRkpjCVaUxnK9vYzg52sosBDGQQgxnCUM5yjvNc
4CKX+ItVrGYNa1nHZa5wlWtc5wYxK1v3xCYOcfmVJcZ9KctYzgpWBuaDsQlq
bj4QnBCEpJWxb00b2tKO9iRxfVKSkZzfSEE/zyL9GcBABjGYL2Jf+cZ3fvAz
MD+U9Zo3vOUd70lNGtKSjvRkIGJr+w6RiUJUolFPrD4NaEgjGtOEpjSjOS1o
SUYykZksZCUbNahJLWpTh7pEV0cMYhKL2MRhiXu9lGUsZwUrA+Ntze9gJ7vY
zR7iGYP4JCAhiUjM+QLGm4tc4jJXuMo1rnODm9ziIY/4m8f8wxNy2rNykZs8
5CVf4NwUe80b3vKO99zmDne5x30e8JRnPOcFL3lFRM98kYhMFKISjYfW/CP+
5jH/8IQpTGUa05nBTGYxmznMZR7zA/ugtqYgJakC5x9pyEwWspKN7OTggzZ9
5BOf+cJXftGmMIQlHOGJQDCCE4KQhCI03+R85wc/+Y8g3/fRpr70oz8DGEgr
WtOGtrSjPR3oSCc604WudKM7PehJL3qz2pxYw1rWsZ4N/KlvValGdWpQk2Vy
lrOClfzFKiqIVaQSlanCHxSlGMUpQUlKcVL/TnGaM5zlHPWUVZ8GNKQRjWlC
U5rRnBa05LCcIxzlGMc5QWl1lOF3ylKO8uSnAAUpRGGKBK6zF5SlHOWpQEUq
UZkq/MGfVCUlqUhNGtKSjodVzUP+5jH/8ITb3OEu97jPA57yjOe84CWviFvN
fkk84pOAhEQnBjGJRWzisF3ODnayi93sYVZ285w5zGUe85nCVKYxnRnM5Kqc
a1znBje5xWGOcJRjHOcEJznFac5wlnPsZR/7OcBBDpFIWxOThKQkIzn/ir3m
DW95x3siikUiMlGISjR+IQxhCUd4IhCM4IQgJKEITTtnTHs60JFOdKYLXelG
98D7LT2pRnVqUJNa1KYSlanCH/xJVX6nLOUoTwUq0oKWtKI1bWgbeC/Vtwtc
5BKXuUIjscY0oSnNaE5YwhGeCEQkUuA9U853fvCT/wjS3w8+P/KJz3zhK5nr
2MfISjayk4NBxn4wQxjKMIaTX6wABSlEYYpQR911qUf9wHs7DSlY13UUpghF
KcZv2pSClKQiNWnITBayko3s5GCEukcyitGMYWxgnqpjJrOYzRzmBsZHTm3q
UJd61KcCFalEZarwBw1oSCMa04Sm9FFHX/rRnwEMpIszsivd6E4PetKO9nSg
I53ozAAGMojBDGEowxjOCEYyitH0ojd96Es/+tOIxjShKc1oTgta0orWtKEt
f+pDVapRnRrUpDRl+J2ylKM8bWgbWB+0pwMdyUkucpOHvORjAhOZxGSmMJUe
9KQXvQP3kb70oz8DGMggBjOEoQxjeGC8GckoRjOGsYxjPHOYyzzms4CFpCUd
6clARjIxjenMYCazmM0iFrOEpSxjOfkpQEEKUZgiFKUYxSlBSUrRjOa0oCWt
aE0nOtOFrnSje6Af5tB4JjCRSUzmbiXnAfd5wEMeUdCcLkRhilCUYuS2lvKQ
l3zkpwDFxUpQklKUpkxgP6tvXOhFb/rQl370ZwADGcRghjCUYQxnBCMZxWjG
MJZxjGcCE5nEZKYwlU50pgtd6UZ3pjGdGcxkFrNZxGKWsJRlLGct61jPBjay
iRWs5C9WsZo1bGYLW9nGdnYwh7nMYz4LWMhOdrGbPexlHyHcu5CEIjS/EIZe
9KYPfelHfyIThahEIzoxAvuivbIhjWhME5qSUiwVqUlDWtIRj/gkICGJSEwS
kpKM5PxGCtKTgYxkIjNZAvOEPOQlH/kpwGl1n+Es5zjPBfbr8wEOcojDHCGm
nFjEJg5x+ZWdcnaxmz3sZR896EkvetOHvhSlGMUpQUlK0YzmtKAlrWhNP/oz
gIGB84nBbGYLW9nGdnZwkUtc5gpXuUYbfWhLO9rTgY40oCGNaEwTmgbmsbU0
mSlMZRrT+VvsMf/whKc84zo3uMktbnOHsHLCEZ4IRCQSY9y7sYxjPBOYyDCG
M4KRjGI0P5T1k/8I8ncwgjOJyUxhKtOYzl3X3eM+D3jII57zgpe84l9eE0+b
4pOAhCQiMQOUNZBBDGYIQ4kpFovYxCEuvxKZKEQlGtGJwRt1vOUd7/nARz7x
mS985RvfA/fNGRaO8EQgIpG4KHaJy1zhKteoo4661KM+DWhIM7HmtKAlrWgd
mAdi7elARzrRmRa0pBWtaUPbwHgxlnGMZwITmcFMZjGbOcxlHvNZwEIWsZjT
6j7DWc5xnguB9SZ2iMMc4SjH2M0e9rKP/RygEY1pQtNAP2keyFPWMY5zgpOc
oijFKE4JSlKK/BSgIIUoTBH+pCrVqE4NalKL2oH7TV3qUZ+M6ew7ZCYLWclG
ZGMWhahEIzoxqENd6lGfBjRkay3rme3sYCe7OMghDnOEoxxjN3vYyz72c4D1
bGAjm9jMFv5iFatZw1rWMYzhjGAkoxhNL3rTh770o3+gPGfzFrayje3soIVY
S1rRmja0pQ51qUd9GtCQAQxkEIMZwtBAP5R1gIMc4jBH2MkudrOHvexjiZyl
LGM5K1jJGMYyjvFMYCKTmMwUpjKN6cxgJrOYzRzm8m9t+wRveMs73rOdHexk
F7vZw172sZ8DHOQQhznCUY5xnBM85RnPecFLXnGSU5zmDGc5RyNtakwTmtKM
5lwVu8Z1bnCTWzzkEX/zmH94wjw581nAQhaxmNx5nJvkJR/5KUBBClGYIhSl
GMUpQUlKUZoy3FbHHe5yj/s84DwXuMglLnOFD3zkE5/5wle6aFNXutGdHvTk
tLE/w1nOcZ4LhJITml8IQ1jC8Z+cIJ/BCE4IQgbG0/fv+cBHPvGZl7wKjD+v
ecNbvvCVb3znBz+Z52yYzwIWsojFgeeFps4H4hGfBCQM/P8AsVWsZg1rWUfx
Zu4nJSlFacpQkEIUpghFKUZu8pCXfOSnAFnJRnZykJNcpCcDGclEZrIE/t+J
exGN6MQgJrEC80jfbnGbO9zlHvd5wEMe8TeP+YcnPOUZz3lBMmUl5zdSkJJU
pCYNaUlHejIE6jeHYhGbOMTlVy4r60pgvnON69zgOCc4yanA/OAMCZSVkEQk
JglJaSfWng50pBOdiaeO+CQgIYlITBKSkozk/EYKwisrAhGJRGSiEJs4xOVX
4hE/sI7VcY7zXOAil0ivrAxkJBOZyUJWspGdHOQkFylJRWrSkJZ0/E5ZylGe
ClQMtNezYIrAczepSE0a0pKO9GQgI5no4N2sI53oHHj/pyufrLHPfOEr3/hO
N7Hu9KAnvehNK1rThra0oz1NaEozmtOCloHf5aral5nGdGYwkxGMZBSjGcPY
wO+JmcxH7vOAhzziNGc4yznOc4Hr3OAmt7jNHcYpazwTmMgkJgd+l9S3F7zk
Ff/ymr95zD884SnP2ChnE5vZwla2BX6HZDZzmMs85rOAhSxiMUtYyjKWs4KV
/MUqqnlWqE4NalKL2iQhKclIzm+kICWpSE0a0pKO9GQgI5nITBYqUZkq/BH4
PYWqZCUb2clBTnIFnkvdu0tc5gpXuUZBsUIUpghFKcbvlKUc5alARVbr2xrW
so71bAj8HuqevuUd7/nAR37wk/8Ikh+M4Fz39w1ucovb3KG4WAlKUorSlCE3
echLPvJTgP36cICDHOIwRzjKMY5zgpOcIqc1k4vc5CEv+VhmzS9nBSv5i1VU
4Q/+pCrVqE4NalKL2tShLiUpRWnK8DtlKUd5KlCRSlRmNWtYyzrWs4HCFKEo
xShOCTayic1sYSvbAueoPoQhLOEITwTi8ivxiE8CEpKIxCQhKclITnRiEJNY
xCYO39TxnR/8DJzTBPk+GMEJQUhCEZqIRCIyUYhKtMB1xiwkoQjNL4RhgfIW
sojFLGEp2clBTnKRmzwMYjBDGMowhtOHvvSjPwMYSDe604Oe9KI3R825Yxzn
BCc5xUUucZkrXOUaI+SMZBSjGcNYMpKJzGQhK9kYx3gmMJFJTGYWs5nDXOYx
n7zkIz8FKEgh6lGfBjSkEY1pQlOa0ZwWtKQVrWlDW9rRnilMZRrTmcFMOtCR
TnSmC11J5h0pOb+RgpSk4n+erRWy
           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[
        0.45285714285714285`, 0.46285714285714286`, 0.5528571428571429], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58899, 13663, 13664, 13665, 58900}, {58902, 13666, 
           13667, 13668, 58901}, {58894, 12478, 12479, 12480, 58893}, {58891, 
           12475, 12476, 12477, 58892}}], 
          PolygonBox[CompressedData["
1:eJwV2GPUHtcWAOA3tm3bdho1jW3bttU4jVP3to3Npo1t2zYbq+F95sez3jVr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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[0.516734693877551, 0.4853061224489796, 0.5153061224489797], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58926, 17230, 17231, 17232, 58925}, {58915, 16039, 
           16040, 16041, 58916}, {58923, 17227, 17228, 17229, 58924}, {58907, 
           14851, 14852, 14853, 58908}, {58918, 16042, 16043, 16044, 58917}, {
           58910, 14854, 14855, 14856, 58909}}], 
          PolygonBox[CompressedData["
1:eJwV2GPYHUcDBuAT27Ztp7FtNWpsN06+xk2auk1j27aNxjbbOI3tfPf+uK/3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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[0.5806122448979592, 0.5077551020408163, 0.4777551020408164], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58931, 18415, 18416, 18417, 58932}, {58934, 18418, 
           18419, 18420, 58933}}], 
          PolygonBox[CompressedData["
1:eJwV12V0FUcYANBHgBCceoHiUtzd3TV4kOBOAkGCBHd3d3cpdagLUApVoIVS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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[0.6444897959183673, 0.530204081632653, 0.4402040816326531], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58950, 20794, 20795, 20796, 58949}, {58942, 19606, 
           19607, 19608, 58941}, {58939, 19603, 19604, 19605, 58940}, {58947, 
           20791, 20792, 20793, 58948}}], 
          PolygonBox[CompressedData["
1:eJwV1WW0VVUQAOArICjdrQLSndLdIIKtGEg3KG0LSHd3d/OSBzy6u7u7U6Qk
/M6Pb5217qw9s8/sOftmbdLxkw5xQqFQLPG59FcodJkrXOUa1xnGcEYwklGM
ZgYzmcVs5jCXG9zkFre5w10mMZkpTGUa0xnAQAYxmCEM5QxnOcd5LnCRe9zn
AQ/5h0eMYSzjGM8EJtKbv+lDX/rRn5/oRGe60JVurGQVq4llDWvZxW72sJd9
7OcABznEYY5wlFPdQqHTnOEs5zjPErGlLGM5YYQzj/ksYCGLWMwKa2JYySpW
E0t3sR78zC/8ym/8zh/8yV/0pBdVe4ZC1ahODWpSi/JUoCKVqEwVjqhxlGMc
5wQnucBFLnGZK1xlQi/9ZhKTmcJUksiVlGQkJwUpeaNTKBSHuMTjTeJzTa7r
3OAmt7hNDmtykovc5CEvqUhNGtKSjvRBnb7qkIrUpCEtt5rKxx3uco/7HNOj
45zgZHB+nA7mV+273OM+D3jIf2IveMkrXhNSd5PYZrawlW1sZwc72cVu9rCX
feznAAc5xGH+le8xT3jKM57TUo1WtKYNbWlHSUpRmjKUpRyNaUJTmtGcFuQj
PwUoSCEKU4SiFKM4JfiABM7mLd4mIYlITCpSk4a0pCM9JfT6A0pSitKU4cSv
+sspTnOGs+SwJie5yE0e8nJI7DBHOMoxjrOkle+IZSwnjHCqm7ka1KQWtalD
hFgkUUSzghjmMZ8FLGQRi6lrzYfU4yPq04Bzap/nAhe5xGWiiGYFMaxkFauJ
ZQ1rWcd6xjGeCUxkEpMZwUhGMZoxjGUKU5nGdGYwM4jb61jGMZ4JTCSf3uWn
AAUpRGEGWTOYIQxlGMNZxnLCCCeCSBawkEUsDvrOUvrQl370ZwADg/dQezJT
mMo0pjODmcxiNnOYyx5r9rKP/RzgYNAv38Ba1rGeDWwkjHAiiCSKaJ7xPPgu
ecFLXvGaUHf3DXGISzze04ssZCUb75OdDGQkE5l5h3eJ8O1FEkV0cC8TwzrW
s4GNbGIzW9jKNrazg50kkSspyUhOClIGT3tKSSpSk4a0pCM9GchIJjJTt735
pB4fUZ8GbNC7jWxiM1vYyja2s4Od7GI3/+jPo+C+4TFPeMqXcn3F1zTkG76l
Kc1oTgta0orv+J5G/EBjmlCdGtSkFrWpw8d8wqd8xud8QVl3RDnKU4GKVGJN
H/PAOtazgY3M8g6zmcNc5jE/mCff6n4OcJBDHKZ9v1CoAx35kZ/oxDu9nTPv
kYWsZCNMjXAiiCSKaEo0cr9RklKUpgzT1JjODGYyi9ksUGMhi1jMEpbSmS50
pRvd6cEV/0lXucZ1bnCTMLnCg/uMSKKIJo+95iUf+SlAQcraUznKU4GKVGKT
d9jMFrayje0s0eulLGM5YYQTQSRRRLOCGNKpkZ4MZCQTmVkhVwwrWcVqYmns
3ZrQlGY0pwWpSE0a0pKO9KSQKyWpSE0a0tJSrBWtaUNb2rHSnlaxmthgbljL
Dj3ayS52s4e9rGEt61jPBjYyzV6nM4OZwZwxmz4N3Xv0oz8DGEg+tfNTgIIU
ojA5yEkucpOHvMyRay7zmM8CFrJMbDlhhBNBJFWpRnVqUJNaDFJ7MEMYyjCG
s0iuxcF5sjTIy3I2ebfNbGEr29hOa7E2tKUd7elAETWKUozilOAD3ncG2clB
TnKRm0IUpghFKUbxYB7UiGElq1hNLEPUGMowhjOCkSRRIynJSB7MASkpTwUq
UonKVKEkpShNGcpSjglyTWQSk5nCVEYxmjGMZRzjKWRWClOEohSjOPOYzwIW
sojFzGAms5jNHOYG8ybXTnaxmz3sZR/7OcBBDnGYIxzlGMc5wUkucJFLXOYK
VznFac5wlnOc502145OAt3ibhFwTu84NbnKL27wmJP4GcYhLPO74/S73uM8D
HvKM5/zHC17yikTWJCYJSUlG8uB+ID0ZyEgmMlOTWtSmDnX5kMpUoSrVqE4N
8pCXfOSnAAV5zxlnISvZgrkkO/XEPqI+DfiYT2hOC1rSita04VM+43O+4Eu+
4msa8g3f8h3f04gfaEwTmtKMdaxnAxvZxGb+0aNH/MtjnvCUn8Q60ZkudKUb
v/MHf/IXPenFFrayje3BnLGTAxzkEIc5wtHgXPUiDnGJx5vEZ5LYZKYwlWlM
ZwADGcRghjCUYQxnBCMZxWjGMJZxjGcCE+nN3/ShL/3oT1va0Z4OdOTHYD7s
KSOZyBz8H/Mu/4m94CWveE3I75c8L3OFq1zjOve4zwMeBn3nEd3pwc/8wq/8
RgK53uJtEpKIxJwRO8s5znOBi9zgJre4zR3ucozjnOAkpzjNLnazh73sYz//
8pgnPOUZz4N+mIkfg7mgE53pwv/yAovL
           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[0.7083673469387753, 0.5526530612244898, 0.4026530612244899], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58955, 21979, 21980, 21981, 58956}, {58966, 23170, 
           23171, 23172, 58965}, {58958, 21982, 21983, 21984, 58957}, {58963, 
           23167, 23168, 23169, 58964}}], 
          PolygonBox[CompressedData["
1:eJwl1nVwVWcaB+C7tKW6UnfcQlwITilQwy0hnhAjWIK7JMQFQkJwd+q+7u5u
xaHUleK+z5n945lzZ37z+T3v+drnlowtbhUKhepoTW2R39TTwEpWsbgyFFrC
UpaxnFLKWEE5FVRSRTU11FJHPQ08XhUKtaEt7WhPBzrSic50oSvdmKvNPOaz
gIUs4rnqUGgowxjOCEaSRDITSCGVNBayiMUsYSnLSCeDTLLIJofllFLGCsqp
YBSjGcNYxjGeSqqopoZa6ghrCIW6E04EkUTRJGtmDS2sZR0r59lvGllNE810
LLU/dKYLXenGxMWhUC555FNAIUkkM4EUUkljOsWUMIOZzKKHvhLpSS9604dJ
siImM4WpTCOdDDLJIpscNprrJjazha1sY7ZsDnOZx3wW8Lgx2tCWdrSnA2F0
J5wIIonibu7hXu7jfh4gmhhiiSOeBB7kIR7mER7lMdaYUwtrWcd6NtB7unXT
l370ZwB5/nP5FFDIJIroq69+9GcATzCQKzNDoatc4zo3CM2S62sgTzKIwQzh
nPw8F7jIJS5zhKMc4zgnOMkXfMlpvuIMZwnLtm+EE0EkUUQTQyxxxJMQ5MaO
IpoYYomj0Tu/miaaWUML8bIEepBIT3pRLqugkiqqqWEpy1hOKWWs4Fie9XCC
k7zLqeBpDad4j/f5gA+ZYK9TSCWNdDL4SPYxn/Apn/E5TQpaM2toYS3ruF+b
B3iQh3iYR8gki2xymEgupyvsL2c4yznO01XWjTC6E04Ej/JYUOdoQ1vaEUkU
0cQQSxy96RP8j+hHfwYwhrGMYzxJJAft1Y4YYokjngSekj3NMzwb1EeG8gQD
eZJBDGYIwxjOCEYyitHEk0APEulJL95xNgc5xGGOcJT2sg50pBOd6RKM5x0Y
xGCG8BRPs9A7v4jFLGEpyzjtbL7iDGc5x3nG1NsHxjGeJJLJJItscphILv/i
3/yH//IOB6mmhlrqqKeB9nSgI53oTBeOGfs4JzjJu5yiq6wbYXQnnAi+ybe4
m3u4l/v4RJtP+YzP+YIveY/3+YAP+YiPidQmimhiiCUuWIfsIIc4zBGO8jvZ
7/kDf+RP/Jlf8Et+xa/5Db/lEIc5wtFgnRzna/pqxU3czC20Zrdv0h72so/9
HAi+W9q0sJZ1rGcD29nBTnaxmz18h+/yPb7PD/gheeRTQCGTKGIyU5jKNKZT
zFZjb2M7O9jJLl6XvcGbvMXbfJu/8Ff+xt/5B//kSq36zDWuc6P2/5egc57n
ucBFLnGZMm1WUE4FlVRRwgxmMovZzOFH/Jif8FN+xs9ZySoaWU0TzVww9kUu
cZkrXOUa17kRXNCCc6IVN3Ezt9CaW7mNVO9YGulkkEkW9faoIbhfsIpGVnNB
LbvIJS5zhausl21gI5vYzBZ2m8ce9rKP/RxgnDHGk0QyE0hhuqyYEmYwk1mM
kI1kFKMZw1gKKAzuHRQxmSns9W3ex34O8Dwv8IzsWZ5jKMMYznbZDnayi93s
4UVe4mVe4VVeY6o204L5UkwJM8gmJ7hnkUse+SxXs0opYwXlVDDb2uYwl3nM
ZwH1NLCSVTSymq1sYzs72MkunucFXuQlXuYVJjjjlOCcSSOdDF6VvcbrvMGb
vMXtsju4k7v4Ot+gp6wXvelDX/pRSRXV1FBLHUkkB+OTQippxOsrgR4kBv3S
K6gHsg1sZBOb2cIkipjMFKYyjYnkkkc+BRSSTgaZZJFNDrdyW7A+7uBO7iKW
uGBeJNCDxGAe5rSJzWwJ6gjb+B9doibD
           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[
        0.7722448979591836, 0.5751020408163265, 0.36510204081632663`], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58971, 24355, 24356, 24357, 58972}, {58974, 24358, 
           24359, 24360, 58973}}], 
          PolygonBox[CompressedData["
1:eJwV1lV4VVcWAOCDu5NAPIFAcJdBg4XgVsa9nYd5mZmPtgQCwaEtMm1npu4j
9SIVnOCEIBFiJBCKu0sFn/88/A/3rm/ttffacm/Sk3+b8teqQRC8Qk1avxQE
ybShLSm0I454EkgkiVaUvhgEZRymnAqOkPdUEORTQCGHKGKX2G72kMNechlq
rGEMZwRpjGR2RhBkMYe5zGM+axcHwTrWs4GNbKKJnKY0ozkRRDKAgQxiMKkM
oSvd6E4PetKLFrQkimhiiOWuud7jPg94yCPai3WgI53oTBfqUZ8GNKQRjTkw
LQgOkkc+BRSywNoWsojFLOE5nucFlrKM5awg5S/2h/Z0oCOduL08CO7wHd/z
Az+yR+0c9pLLPvZzXuwCF7nEZa5QZ0kQ1KUe9WlAQ6pRnRrUpBa1mfHnIJhJ
JrOYTRZXjXWN69zgJreIMNdIWtCSKKLJ1tOtbGM7O9gZnhs9ymEvuexjP9P1
IoMZzCSTWSQZqxWtSaYNbYkhljjiSSCRYme0hFLKOEw506zhaZ7hWaaTwVFz
quQY33KcE/TW0z705Sf0oz/zljm/LGAhi1jME2JT+Sk/4+f8gl/yK37Nb/gt
v+P3/IE/8iRP8SfmMDesw3wWsJBFLGYJz/E8LzCeCUxkEpOZwlKWsZwV/J0X
OazX5VRwhKNU0ne2ddKP/gxgIIMYTCpDGMowhjOCNEaSzihGM4axjGM8E5jI
JCYzhSeYygxzmkkms8L3giym8TTP8CzTyeAlXuYf/JN/8Up4T1c43zSgIY1o
TA1qUova1KEuG+VsYjNbyGYr6YxiNGMYyzgO6VERxZRQShmPnZVAvApVqUb1
8D76/gIXucRlrtBa7WTa0JYU2vG1nG9YyzrWs4FXeY3XeYM3eYur89xHrnOD
m9zisTsZGK8KValGdd6W8w7v8h7v8wEnzekUpznDWc5x1zj3uM8DHvKIFsZq
SRTRxBBLHPEkkEgSrWhCU5rRnAgiw/3x1jSmCU1pRnMy3aVZzCaLOcxlLetY
zwY2somx5jSO8UxgIpPo+7LzTD/6M4CBdKcHPelFb/qwUi9WsZo1fMlX1Jjv
/FCL2tShLh3ldKIzXehKN9rQlhTa0Z4OJJBIEq1oTTKzzTWLOcxlHvPJ81uY
TwGFHKKIs5zjPBe4yCVS5QxhKMMYzgh2iO1kF7vZQw5RakcTQyxxxDNdTgYz
mEkms6hnzfVpQEMa0ZhjS72bHOcEJznFY2cxEK9CVapRnQN6epA88imgkAg1
IsPzRUuiiCaGWOKIJ4FEBpnrYFIZwlCGMZwRpDGSdEax2Zq3kM1WtrE97J/a
l7jMlfBecS1879XozwAGhvUYTBojSWcUoxkT/i7KucFNbnGbO2xjOzvYyS52
h+8w5VRwhKNUhu8MRRRTQill4Xj6eYfv+J4f+JEP1f6Ij/mET/mMz/mClaxi
NWu4K+ce93nAQx7R3Vvcg570ojd9OG0vz3CWc5znAte5wU1ucZs7XNbTK1zl
Gte5wQ53dSe72M0ecthLLvvYzwEOkkc+BRRyiCKKKaGUMg5TznE1TnCSU5zm
TPjZmk9xmjOc5RzFYiWUUsZhyqngCEep5BjfMlyNEaQxknRGMZox4TvEOMYz
gUEMJpUhDGUYE5nEZKaE/xuYyma2kM1WtrE97I/auexjPwc4yEMe8ZjAu1mF
qly0B5fCfeAKV7lGR2N1ojNd6Eq38B0V28RmtpDNVg5RRDEllFJGMznNiSCS
FrQkimhiiCWO+HB/5JRTwRGOUkkDsYY0ojFNaBruv9hB8singEL2kMNectnH
fv7Nf/gv/+NDPuJt3uFd3uN9PmAb29nBTnaxm5WsYjVr+JKvaGNObUmhHe3p
wNdi37CWdaxnAwliiSTRitYk86rYa7zOG7zJW3zMJ3zKZ3zOF9Rw52tSi9rU
oS7/B7RWkqA=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.8041836734693877, 0.5863265306122449, 0.34632653061224494`], 
        GraphicsGroupBox[{
          
          PolygonBox[{{37027, 37028, 37029, 37030, 37031, 37032}, {37021, 
           37022, 37023, 37024, 37025, 37026}}]}]}, {
        EdgeForm[], 
        RGBColor[0.8361224489795918, 0.5975510204081632, 0.3275510204081633], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58979, 25543, 25544, 25545, 58980}, {58982, 25546, 
           25547, 25548, 58981}}], 
          PolygonBox[CompressedData["
1:eJwV1GV0VUcUBtCLU1fc3aXu7hR3d4gQkhAnDgR3EhyKRoDgLpW/FVwruNYV
qQDd78ded731rXNnzpm5r87gmM7RJYMg6EtZRk0OgjjiSSCRJJJJYTSppJHO
+awguMBFLnGZK4yQRTGSaGKI5YFZQfAgD/Ewj/AofehLP/ozgIFMVjOFqUxj
OjNC75VFE0Mso4hjmGw4YYQTQSTdZN3pQU960ZswwokgkhFE8dSMIHiaZ3iW
53iecd6Vw3gmMJFJDJENZRjDCSOcP/mL69zgJrcYZI3BDGFoaN8MpwMd6URn
utCVD9W0pR3t6UBH3uFd3uN9PqBN6KmmTaiOtrSjfWheslhGEUc8CfzML/zK
b/zOH6F+ZtoXYYQTQSSbZVvYyja2s4OJTGIyU5jKNBJJIpkURpNKGulkkEkW
2UxnBjOZxWzmUE4P5bmHe7mP+1koW8RilrCUj1jGclawklWsJp8CCiliDWs5
yCEOc4SjHGMMY0PnTw7jmcBOdrGbPexlHyPMKIqRRBNDLDPdlVnMZg655PG5
mi/4kq/YzwHWUcx6NrCRTXSiM13oSje6h/q0xkpWsZp8Csgyo2zGMJZx5BBP
AokkkUwKo0kljXQyyKSFNVrSitY8wZNEEBnqmyhGEk0uecxlHvNZEDqfXOfD
MpazgpVsZwc72cVu9rCXfXzMJ3zKZ6xiNfkUUEgRDdKCoCGNaEwTmnJUdozj
nOAkp6giq0o1qlODmtSiNnWoSz3qM1/NAhayiMUsYTZzyCWPucxjPwc4yCEO
c4TX8oLgdd7gTd7iba76D73G9/zAj/zE0hxzYxnLWcFK0tSkk0EmWWTzrZrv
OM0ZznKOVWpWk08BhRRxXHaCk5zia74h3l4TSCSJZFJoZhbNaUFLWtGaRGsn
kUwKo0klnwIKKWINa+lBT3rRmz705V939z9uc4e7BO7hdc8b3OQWf/MPhRSx
hrWsozj0HdprNDHEMoo4eriLPelFb/rQlxLWKEkpSlOGslz0rktc5gpXuUY/
Nf0ZwEAGMZjTsjOc5RznuUCGbz6TLLIZw1hK6bk0ZShLOcqz0dlsYjNb2Mo2
Osk604WudKM7jWhME5rSjObUoS71qE8DGnLbLO5wl8DvEpTkBV7kJV7mFV6l
AhWpRGWqUJV1FLOeDaF9s4lqVKcGNalF7dD562Et6yhmPRt4zKwfpwIVqURl
/gfOK0Nz
           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[0.8999999999999999, 0.6199999999999999, 0.2900000000000001], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58998, 27922, 27923, 27924, 58997}, {58987, 26731, 
           26732, 26733, 58988}, {58996, 27921, 27919, 27920, 58995}, {58990, 
           26734, 26735, 26736, 58989}}], 
          PolygonBox[CompressedData["
1:eJwV1XV4V1UYB/ArKEqvGCkqKgrSYACKCighYwMpgY0VSMMAMRCpJa6UNSjY
hZ1gt4SC8Y8tDZIbAyWMz/3j8+z57fu85z3n3HPPvSR1zsjZdYIgmEs9zlkV
BHWoy7mcRz3O5wLq04CGNCJxYRAkMYlkUkilQ14QdOQqOtGZLjyn5nleYD0v
8hItaUVr2nAhbbmc9lzBlXSgI41pQlMiiCSKi7iYS2jHpVxGNDE0I5bmtCDO
nIYTTwIjGMk0a5jODGYyi9m8rOYVXuU1XucNJqlJJoVU0khniWwpy1jOCjLJ
IpsccsljJXeoGc8EJpJIUjiuLJU00pnMFG6W9WcAA7mFW8N9l3WiM13oSjd+
fTgIfuN3/mAHO5ljbXPJYB7zWcAu2W72sJd97KerHt3oTg960itct5p0JjOF
O5nKvXrfxyLuZzEPcEuJ+TKIwQxhKA/K8imgkCKKGaTHYIYwlNsYRrWshuPU
coKT7GEv+9jPAf4Mz7EeDWhIIxrThL9kf3OK05zhLAc5xGGOcJRj4fzUFFJE
MQ/xMD/KfuJnfgn3nd+4sTAIbuJm+jOAgWzICIKNvMt7vM8HNDVWBJFEEU0M
nelCV7rRnR5cYawr6UBHrqITy2TLWUEmWWTzoR4f8TGf8Cmfhb/N9RM+5TM+
5wtuUzOMOIYTTwK99ehDX67nBvrRU9aLq7mGa7mORJKYRDIppDKN6cxgJrOY
TQ655LEyPB/k86U5fcUmNrOFreH7r3c7LuUyLqc9c9TMJYN5zGcBaaQzmSnc
ydTwr7GmMo3pzGAmlbIqVrOGR3iU32V/sIOd7GI3DxU7F6yihFLK+E9NUOre
pQ51OZdT/n+aM5zlH/4Nz1emcVhFCaWUUW6sCiqpYjVreJB8CiikiGIOVHgP
OMghDnOEbUuCYDvf8h3f8wOPyR7nCZ7kKZ7mKMeopobj1PIMz/Icz/MC61nN
Gh7hUdayjkhrjiKaGJoRy3FrruUEJ8P3k7/ZxGa2sJWv+YZtbOdbvuN7fgjr
CtRxitOc4Sw7ZDvZxW72sJfmeregJa1oTRvqO0MNaEgjGtOEV9W8xuu8wZu8
xWGOcJRjVFPDPvZzgD85yCGaGiuCSKKIJoa3Ze+wgY28y3vh+2PvkkkhlTTS
iWM48SQwgpHczihGM4axjKO1Hm24kLZcxMWs1WMdj/E4T/AkS5y5pSxjOSvI
pLuz3oOe9OJqrmG+bAF3sZC7uYd4WQIjGMntjGIAA8PvA7eG9z6DGc0YxjIu
/F4ynmu5jt70oS/XcwP9wnuXm8LvJf0ZwtDwPmMYcQxnljnNZg5zyWAejRd5
zjQlgkiiuFd2H4u4n8U8QLWzVcNxajnBSUrtdRnlVFBJFXcwnglMJJEkNnn3
NrOFrXzNN0TrHUMzYmlOi/C3ZxZLc1rQklaUm1MFlVSxmjVkkU0OueSxkgn2
YiKJJDGJ5PD5+NaOYjRjGMs4stwp2eSQSx4rw/vHWPkUUEgRxeH95QyVUEoZ
5VTwP8sUtXI=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.9051020408163265, 0.6327551020408163, 0.30581632653061214`], 
        GraphicsGroupBox[{
          
          PolygonBox[{{38179, 38180, 38181, 38182, 38183, 38184}, {39139, 
           39140, 39141, 39142, 39143, 39144}, {39133, 39134, 39135, 39136, 
           39137, 39138}, {38173, 38174, 38175, 38176, 38177, 38178}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9102040816326531, 0.6455102040816326, 0.3216326530612244], 
        GraphicsGroupBox[{
          
          PolygonBox[{{59006, 29110, 29111, 29112, 59005}, {59004, 29109, 
           29107, 29108, 59003}}], 
          PolygonBox[CompressedData["
1:eJwV0+V711UUAPAruKCxpVasQMqgYRs4wnjln+Dz2ArYLbaibsA2wj+CGKx7
Y4VNLJnxxiAWxILY5uf34vPifs9zvueee+5NfHr7U9smhBCyiWb3wRD2sJc8
8imgIy+ETrro5hw99DPAZa5wlWvMl5NMCqmkkc5xsSKKKaGUMqbsC2Eq05jO
DGZSLlZBJVVUU0POgRBy2c0e9pLHPDXiiCeBRJL4Uc5P/Mwv/MpvNNFMC62c
5AdOcZoznKWNdmqpo54GTtBIvtoF7GM/BzjI22q/w7u8x/t8wHk5F7jIJXrp
4ya3GGWMcUJ+CFFyookhlklM5pwaPfzOH/zJX7TRTgeddNHN2l0hrGM9GWSS
xRT/mso0pjODmVyVc41BhhhmhCiziSaGWCYxmV6xPvoZ4DJXWK7GClayitWs
YVB/QwwzwnVuROZcYM7UUkc9DRwSO8wRjlLIscgcxBppopkWWrlPD/czi9nM
YS53cCd3cTf3cC8LWMgDLGIxSyLr761ZzBKWsoz5ekgmhVTSSOdDOR+xk4/5
hE9ZyzrWk0EmWbzKa7zOG7zJWyxlGQ/yEA/zSOQdUUQxJZRSxnJWsJJVrGYN
z/Asz/E8L/Aiu/iGb/mOHHJ5iZd5hW1sZwef8Tlf8CVf8TUb2MijZLOJzWxh
K4/xOE/wJIc4zBGOUsgxaqmjngZO0MjfOSH8w7/8x3kuULhTHscpopgSSimj
nAoqqeKUf53mDGdpoz2yb7PMZhOb2cJWbordYpQxxgm+x5NAIkmRe0Ays5jN
HOYyjzg65HXSRXfk3dJDilgqaaSzgIUMig0xzAjXuRE5Dz000kQzLbRSTQ21
1FFPAxed0SV66aOfAUYZY5yQG8JtTGAitxNFNDHEUq52BZVUUU1N5B7bawaZ
ZLGBjZG+vYE44kkgkST+B2Umwek=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9153061224489796, 0.6582653061224489, 0.3374489795918367], 
        GraphicsGroupBox[{
          
          PolygonBox[{{38905, 38906, 38907, 38908, 38909, 38910}, {39109, 
           39110, 39111, 39112, 39113, 39114}, {39115, 39116, 39117, 39118, 
           39119, 39120}, {38911, 38912, 38913, 38914, 38915, 38916}, {39271, 
           39272, 39273, 39274, 39275, 39276}, {39265, 39266, 39267, 39268, 
           39269, 39270}}]}]}, {
        EdgeForm[], 
        RGBColor[
        0.9204081632653062, 0.6710204081632652, 0.35326530612244894`], 
        GraphicsGroupBox[{
          
          PolygonBox[{{59012, 30297, 30295, 30296, 59011}, {59014, 30298, 
           30299, 30300, 59013}}], 
          PolygonBox[CompressedData["
1:eJwV1NV7F1QYAODDuoixJKw/wKBTReVGbPTWWLJipImKwFRGiIzBGIxS1yPs
LrobQbrbwFas93fxXpzne873nfjOuSF31PDyqBDCUOJIXBRCEsmk0J4OtKsN
IYpoYogljgd4kIcYzsM8wqiaEEYzhrGMYzzFlFBKGSMp51Ee43GeIIdc7pZr
GPdwL/dxP7PrQqhiDtXMZR6tE0NoYzkrWMkqRlSEUEQxJZRSxiQ1JjOFCl7m
FZZVhfAGb/IW9TQQPyGEBBJJIpkU2hFFNDHEEsexmSEc5wQnOcVp4u0hgUSS
SCaFfvRnAAMZxGDetqZ3eJf3eJ8PaKWN5axgJauop4FGmmimhR3sZBe72cNe
PucLvuQrvmY1H/IRH/MJn/IZadaUTgaZZJHNGrG1rGM9G9hIHvkUUMgIimhv
Tgc60olUOtODnvSiN33oyzjG8yRP8TTPMJLySN8xmjGM5VU1plLJNKYzgxOc
5BSnOcPZyL7dzWrWsJZ1rGcPe9nHN+znAOfMOc8FLnKJy5H96cUiiimhlDKe
5Tkm8Dwv8CI55JJHPgUUUsN8alnAQuqYyEtMYjJTqOAf/uU/QuTdEsUZ47Oc
4zwXuEgvsd70oS/96E9HOpFKZ9JIZwADGcRgbuU2utGda7iW67ieG7mJm7mF
HvQkg0yyyKYLXbmdIdzBndzFUH631j/4k7+4yt9c4Sd+5hd+5TcucZnv+J4f
+JF91e6P/RzgWw6y0NuuYxGLWcJS5jKPGuZTywIOmXOYIxzlGMcj+fTEQQ5x
mCMcJbXSOZJGOhlksk1sOzvYyS52kyWWTRe60o3uVKo9jenMYCavEe2MYogl
jngSaBRropkWWmkjx9+XSx75FFDIBrU3sonNbGEr9f7QBhppopkWZsn1OrOp
Yg7VbPIGNrOFrWxjO/8DdxS47w==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9255102040816326, 0.6837755102040816, 0.3690816326530611], 
        GraphicsGroupBox[{
          
          PolygonBox[{{39253, 39254, 39255, 39256, 39257, 39258}, {39259, 
           39260, 39261, 39262, 39263, 39264}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9306122448979591, 0.6965306122448979, 0.38489795918367337`]
        , 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwV1NdXkHUYB/D3dE5W2rpN00LFVFC7LRNFQcGtiOA2LTVTcLE3MlVGLkQB
cdy4wIE7R9PKlqvShgpUjv6IPu/F5+p7nvN7nvf5/d6IJekz054JgiCGHuQ0
BkEueeRTQCHTyoJgOjOYSRKz+KEpCH7kJ37mBje5yz1+5w/+5C+u8Q3f8h3X
+Z5kZpNCKnOYSzkVVFJFNZt4qzkIBjOEoUQRzYdbg2AZy1nBR6wkUa8TmcRk
pjCVBWoWsojFvM8SVjsjjXTWsJZ1vEZv+vA6fenHLW5zh1/4ld/4jM/5gi/5
iq/ZzBZqqKWOeto5zglOcooOxhFHPOOZQAKnOcNZznGeC0SYoT8DGEgkgzgk
O8wRjnKMtnA+32gd69lABpnclz3gIZ100c0bvBmeQ38GMJD1bCCDTLLIZh7z
WcBCFrGYi3zKJS5zhatEMijcM4MZwlCiiGYYwxnB2yw12wfh/lnGclYwo8F9
JYlZJDObArMVUkQxJZSSpyafAgopopiLNfrkEpe5wlX+lT3iMU94yn9sYzs7
2EkDu8ggkyyyySGXzd7YFmqopY56GmW72UMTzbTwkE666OZv/gn7VVNMCaVs
pIy9slb2sZ8DHKRcVkElVVSzidNmO8NZznGeC7RznBOc5BQdjLKDGEYzhljG
hvfbGbXUUc8nbGW0HYwhlrGMI46NdlBGORVUUsU7sncZyXuMIoYsWTY55Ib7
I59JsslMYSrTmE4845lAAolM5GM1q1hNGumsYa+slX3s5wAHebba/5LneJ4X
6EmGLDPsi2xyyKWX7EVe4mVe4VXyZPnhfaSQIoppZDd7aKKZFlJIZQ5zmcd8
DtnBYY5wlGO08T91t5L6
           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.9357142857142857, 0.7092857142857143, 0.40071428571428563`], 
        GraphicsGroupBox[{
          
          PolygonBox[{{40363, 40364, 40365, 40366, 40367, 40368}, {40381, 
           40382, 40383, 40384, 40385, 40386}, {40357, 40358, 40359, 40360, 
           40361, 40362}, {40387, 40388, 40389, 40390, 40391, 40392}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9408163265306122, 0.7220408163265306, 0.4165306122448979], 
        GraphicsGroupBox[{
          
          PolygonBox[{{59020, 31484, 31485, 31483, 59019}, {59022, 31486, 
           31487, 31488, 59021}}], 
          PolygonBox[CompressedData["
1:eJwV0bdWlUEUBtBDEDCRgxFBTI0BJIm0imS4IOFyCaKNCUyPYKGtjY0omF9I
suBrqAjuv9jFrG+ddWa+qZ2dT81lR0Q1eUy/iZjhDrPc5R73FyIe8JBHPGaO
UcYYJ80EGeZ5wlOe8ZwXXHwbcYnLXKGeBjZkm/xki21+cftlxAijjDFOmpZ3
Ea1co43rtPOJz3zhK9/4zlU7GmmimRZaKZOVU0ElVRzhht036eAWnXTxg2VW
WGWNdX6/ivjDX3b4xy57xOuILLLJIZduMz300kc/A0mPuk4zQYZJppKzN2eY
ZIppZqhacl+OcozjnOAk1ZyihlpOU8cZznKO81xg0O4UQwwnvTNCiayUMsqp
oJIFHb3nA4ss8ZFOuuimh1762Gcmj3wK2M8BDssKKaKYEko5KDuU5BRSRDH9
sgEGSTHEMPU0JP9MI0008x8vKKiA
           "]]}]}, {
        EdgeForm[], 
        RGBColor[
        0.9459183673469388, 0.7347959183673468, 0.43234693877551006`], 
        GraphicsGroupBox[{
          
          PolygonBox[{{40327, 40328, 40329, 40330, 40331, 40332}, {40321, 
           40322, 40323, 40324, 40325, 40326}, {40369, 40370, 40371, 40372, 
           40373, 40374}, {40393, 40394, 40395, 40396, 40397, 40398}, {40399, 
           40400, 40401, 40402, 40403, 40404}, {40375, 40376, 40377, 40378, 
           40379, 40380}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9510204081632653, 0.7475510204081632, 0.4481632653061223], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwV1MVyFkEYBdAmCe4a3F2DvADuFnRNFa4vgLtrFQukCG6vgEOUBI3gTtC4
G5x/cWoWd+Z2f10z02vJ+vh1USGEOBqwMSGETWxmC1vZxt8zIeSRTwGFFPHz
VAi/+M0f/pLHk3MhPOUZz3nBS1JIJY3HpJNBsa4SSimjnIrIeroKKKSIYkoo
pYxyKqikine85wMf+cTnSK6rimpqqKWObFkOr3jNG97yz56CuesRRTQxjCCO
kYxiNGP4pyucdT9RRBPDJz2f+cJXvvGdXH7wk1/85g+DdA1mCEMZxnAqZVVU
U0MtdcyUzWI2c5hLPJmyLLLJ4RWvI/sw21e+8Z1cfjDZM1OYyjSmM4NqWQ21
1EXOhXA6hEeuiSSRTAqpPLDGQx6RSBLJdDkZQle60Z0e9KQ9HYilI53ozFJr
L2M5K1jJKnrJetOHvvSjP4dlRzjKMY5zgu3sYCe72M0eBnhmIIMYzBCGslq2
hrWsYz0bIu+BmaOIJob6NKD5+RBa0JJWtKYNbWlHezoQS0cSdJ3nAhe5xGXS
nN1j0smIfD885RnPecFLMsniljO9zR3uco/7zNM1nwUsZBGLKZaVUEoZ5VQw
VjaO8UxgIpO4wlWucZ0b3KShmRvRmCY0pRl7ZfvYzwEOcijy37BGHvkUUEgR
b3jLO97zgY/8B3hHW6U=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9561224489795919, 0.7603061224489795, 0.4639795918367346], 
        GraphicsGroupBox[{
          
          PolygonBox[{{40459, 40460, 40461, 40462, 40463, 40464}, {41371, 
           41372, 41373, 41374, 41375, 41376}, {41365, 41366, 41367, 41368, 
           41369, 41370}, {40453, 40454, 40455, 40456, 40457, 40458}}]}]}, {
        EdgeForm[], 
        RGBColor[
        0.9612244897959183, 0.7730612244897959, 0.47979591836734686`], 
        GraphicsGroupBox[{
          
          PolygonBox[{{59028, 32673, 32671, 32672, 59027}, {59030, 32674, 
           32675, 32676, 59029}}], 
          PolygonBox[CompressedData["
1:eJwV0kVTUGEUBuArKkoIEn/ArXtbwnZjYbeiax07f4AbDAwsOg1QKVHs7u5u
3Vh0GQ+LZ+7inTPne8/cPqlLU5aEBEHQl1Ay04Igi2xyyCWP+blBsICFpLKI
xRzPCYIaTnCSWk4xUzaL2cxhLvOooJIqqjvnqWEZy1nBSlaxmiEMJYFEkkjm
LOc4zwUucok1rGUd69nARk5wklpOcZozHPLWw5RSxhGO0ihropkWWmmjnQ7+
8Jd/BHlB0IUQutKN7oTSg56EEU4EkfQz158BDGQQg8m2O4dc8singGOUU0El
VVSznR3sZBcZ7GYPe9nHfjLJ4qMdn/jMF77yjTTZZrawlW2kMzk9CKYwlWlM
Zwb5/okCCimimBJG6DaSUYxmDGM7+2foTwSR9CKKaHoTQyxxxNNc6O600kY7
HXzfFAQ/+MkvflPX+ZXVUU8DjTRxWbcrXOUa17lBdJG9xBBLHPGM0208E5jI
JFJ4beYNb3nHez5wnwc85BGPeUKh2xVRTAkHOMhN2S1uc4e73KOUMo5wlGOU
E+ZN4UQQSS+iSHDTRJJIZhjDeWrmGc95wUteUe9GDTTSRDMt/AfmLypz
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9663265306122449, 0.7858163265306122, 0.4956122448979591], 
        GraphicsGroupBox[{
          
          PolygonBox[{{41503, 41504, 41505, 41506, 41507, 41508}, {41497, 
           41498, 41499, 41500, 41501, 41502}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9714285714285714, 0.7985714285714285, 0.5114285714285713], 
        GraphicsGroupBox[{
          
          PolygonBox[{{59036, 33861, 33859, 33860, 59035}, {59038, 33862, 
           33863, 33864, 59037}}], 
          PolygonBox[CompressedData["
1:eJwN0sVWFVAUBuAjKvoarmUr0mFMbC/3UheewLmgKGF360BUUDEABZ3Yga2E
7WsYdNqIfoNv9K99/r3OOdPWlsVLE0II00nkxPEQajjJKU5Ty4v6EF7SRjsd
dBJpCiGXKDHyyGeoNoRhRhjlG98pkBVSRJxiSpjHfJJYQDIp/DDzk1/85g9j
RJr1EiVGHvlMrAthEpNJZApTuSy7QjMtXOUa2TpyWMgiFrOEdZRSxno2UE5X
Ywjd9NBLH/3UuaMznOUc9Zznr13H+UewxwQSuKD7IpdooJEmNurYRAWVVFHN
G9lb3vGeD3ykgEKKiFNMCY+8zWOe8JRnPOc6N7jJLW5zh09mPvOFr3TRzV3Z
Pe7zgFYecrAhhEMc5ghHOUaPmV766GeAQbbKtrGdHexkF6trQlhDhFyixEhq
8Q9IJoVU0mhzVjsddPKK16S6ozTSySCTLGYwk1nMZg5zWapjGctZwUpWsdtO
e9jLPvZzgHTdGWSSRTY5VMgqqaKazWxhwJ8YZIhhRhjlPynF+LQ=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9765306122448979, 0.8113265306122448, 0.5272448979591835], 
        GraphicsGroupBox[{
          
          PolygonBox[{{41557, 41558, 41559, 41560, 41561, 41562}, {41575, 
           41576, 41577, 41578, 41579, 41580}, {41569, 41570, 41571, 41572, 
           41573, 41574}, {41563, 41564, 41565, 41566, 41567, 41568}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9816326530612245, 0.8240816326530611, 0.5430612244897959], 
        GraphicsGroupBox[{
          
          PolygonBox[{{59046, 35050, 35051, 35052, 59045}, {59044, 35049, 
           35047, 35048, 59043}}], 
          PolygonBox[CompressedData["
1:eJwV0bdNA1AYhdEnCiZgAUYgxymQyFF0OBu8AMFggslJoiHZYGwyy5DjIBwX
p/p031+8+slkT6ImhFBHLZ+FEL745odf/pg6DiFClBhxErRp7XTQSRfdJLUU
aaaZIUO+GMI6G2yyxTYnRyGccsY5BYoktRRpppkhw4V2SYkrylTodbuPfgYY
ZIhhRhhljHEmyLLIEjmWWWHHjV322OeAQxq0RppopoXW6l7LscwKq6xR0q4o
U+GaG265454HHnli1maOeRbIslh9T1sjzzobbPLMC6+88c5H9b9sIkSJESfB
P6rojdM=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.986734693877551, 0.8368367346938775, 0.558877551020408], 
        GraphicsGroupBox[{
          
          PolygonBox[{{42445, 42446, 42447, 42448, 42449, 42450}, {42451, 
           42452, 42453, 42454, 42455, 42456}, {42619, 42620, 42621, 42622, 
           42623, 42624}, {42613, 42614, 42615, 42616, 42617, 42618}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9918367346938776, 0.8495918367346937, 0.5746938775510202], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwV0cVe1FEUAOArKvIagCBlbFRAJ4gJQEJsUWDGKVHB7sYXEBVz4UbewM6X
sYsXML7/4lvc370n7jm1+ZnR6aoQQh3VtD4JoY3VrGEt61i1EEITzbTQShsn
3J3kFKc5w1mucJVrXGeWG+TIc4ACRUocYZoZjnKM45SpcJApDnGYc5znAhe5
xOUor54KFClRpsIudrOHvYyxjw462cRmYsRJkKSLbnroZSujbGM7O9jJAFsY
ZIhhRmjQU2M0P5popoXv8yH84Ce/+M0iMXdxEiTpopseekmRJkOWgcfqMsgQ
w4ywn3EmmCRHnqdinvGcF7zkFa95w1ve8Z4P0TzFFChSokyFFGkyZOmjP6rr
z+NMMEmOPLXUUc/KaC408keNv/wjOC+hKtrHnH0QI06CJDe9m+MWt7nDPHe5
x30e8JBHfDTTT3zmC1/5xnq5NrCRdjroZKnay1hONSuoIUWaDFn66Oc/7UfS
bA==
           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[1., 0.8765306122448978, 0.6122448979591835], 
        GraphicsGroupBox[{
          
          PolygonBox[{{59054, 36238, 36239, 36240, 59053}, {59052, 36236, 
           36237, 36235, 59051}}], 
          PolygonBox[CompressedData["
1:eJwV0EVSA0AUBNAB4gmywd25AK5XwHXFAeAEuF4Ad0kICXZEXhZvMfWra7q6
c3N7bqs8hFBHjGIuhC+++eGXP2afQ5hjngUWWeKlEMIrb7yTJUezTAuttNFO
Bx9ueT4pUOSLsmII5VQQIUqMHbdd9tjngEOOOOaEU844Z1mnFVZZY50NLu5C
uOSKa264ZVxmgkmmmGaGQYYYZoRRxko9s3pSQYQoMeK6JkiSIk2Gbpkeeumj
nwFaaaOdDjrpIk2GSqqopoYoMeIkSJIqvf2dIEmKNBmyts6V9ibPJwVqqaOe
Bhpp4s4W9zzwyBPP/AMZ1H+n
           "]]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.8928571428571428, 0.6428571428571427], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwVzjc6AwAYgOH/MZhdwUh0OYlNJ8xyGl0wGZh0KVq4gJIqyiX0+hre6Vu+
1lR6YKYpIlpoZnsjYodd9tjngBJlKlSpUWd2M2KOeRZYZIlD7YgsOfIUGNcm
mCTFFNPcaQ3ueeCRJ5a1FTKsssY6WXLkKXDMCaeccU6RCy5po50EHXTSRTc9
9NJHP0muuOaGW0qUqVClRv3/mwbPvPDKG+98MMgQw4wwyhiffPHND7/EVsQf
6Xd/jA==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.9091836734693877, 0.6734693877551019], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwV0klXCFAUB/CrnHbN80AD21BEXyIRydoHqM9BKtRp06ZFFjikZPgKSnMb
hUYKGYoGjX4tfued8/7n3vPuPa/0VlNdY0JEFJBEeXfEGc5yjgoqqXkccZla
rnCVOq5xnXpu0MBNXjDAS17xmjc85Rm9PKePfnZ7IvbY54BD4mHE20cRgwzx
jmFGaOuKuMd9HtBOB7OdEXPMs8AiS2zot8kW2/xj5+jUa4dd9tjngOQnESmk
kkY6GWSSRTY55JLHoZowxzESSOQ48+4XWGSJz3xhmRW+8o3vrPLeW6eZ4QMf
+cQP2U9+8Zs11rlt5js0c5cWWhmVjTHOBJNMkWmnWWSTQy55/JH9ZYNNttg+
2oMshVTSSCeDYkoopYxTnCafAgop4gQnOe8PXaCKi1yimv+OWbrZ
           "]]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.9255102040816325, 0.704081632653061], 
        GraphicsGroupBox[{
          
          PolygonBox[{{43717, 43718, 43719, 43720, 43721, 43722}, {43825, 
           43826, 43827, 43828, 43829, 43830}, {43585, 43586, 43587, 43588, 
           43589, 43590}, {42649, 42650, 42651, 42652, 42653, 42654}, {43723, 
           43724, 43725, 43726, 43727, 43728}, {42655, 42656, 42657, 42658, 
           42659, 42660}, {43591, 43592, 43593, 43594, 43595, 43596}, {43831, 
           43832, 43833, 43834, 43835, 43836}}]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.95, 0.75], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwV0csywnEYh/HvoNDBuhmnXIFDdoQ7QFyB84ql0FVYOGXRwsYgxnERFZWN
wyZhhmyQRbHpwAw1nhafmfd5m3nn959aRmZc0xWSbDDgLyXlA1IWOfzSVR/S
alhaxgoq6Rz7wROpHwPI0kb2a/zuxToMdIb9zr60hW2k6Tr2PTGpF32w0gX2
Lu4MYRh5OgWTXzLDgnf6DTXMtajGK/2CiU1pElNI0s8YYx7HKJ7oazT6pHo0
4Iq+x8WGFEEUCfoO58whhBGnLbzRyVu70A0zfcu+iTvNsOOG/oKf79zFHj7p
S8x7pQV4EKOP0bEoOdCJIzpYfs+S9IBHnNGn5fcwJxBHgC6hwH/zjR8U6Sjm
uD0LNyL0Idq53Yo2HND/vp+g2A==
           "]], 
          PolygonBox[CompressedData["
1:eJwV1mPYHUcYBuATp2matFFjm00aNY1tO2nTxrZt27aTxrZt27aN3ufHfe31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           "]]}]}}}], {
    DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
     Identity, Frame -> True, FrameLabel -> {{
        FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}, {{{0, 
          FormBox["0", TraditionalForm]}, {0.04, 
          FormBox["0.04`", TraditionalForm]}, {0.08, 
          FormBox["0.08`", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.04, 
          FormBox["0.04`", TraditionalForm]}, {0.08, 
          FormBox["0.08`", TraditionalForm]}}}}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 310, 
     Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
     FormBox["\"(d)\"", TraditionalForm], PlotRange -> {{0, 0.08}, {0, 1}}, 
     PlotRangeClipping -> True, PlotRangePadding -> {Automatic, Automatic}, 
     RotateLabel -> False, Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
      "1", "5", "9", "13", "17", "21", "25", "29", "33", "37", "41", "45", 
       "\"\[GreaterEqual]49\""}, "SwatchLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               "\"N\"", {FontFamily -> "Arial"}, Background -> Automatic, 
                StripOnInput -> False]}, {
               TagBox[
                GridBox[{{
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0.95, 0.75]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #13}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1., 0.8833333333333333, 0.6249999999999999]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #12}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.9833333333333334, 0.8283333333333334, 
                    0.5483333333333333]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #11}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.9625, 0.77625, 0.48374999999999996`]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #10}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.9416666666666667, 0.7241666666666666, 
                    0.4191666666666666]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #9}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.9208333333333334, 0.6720833333333334, 
                    0.35458333333333336`]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #8}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.9, 0.62, 0.29]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #7}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.7695833333333333, 0.5741666666666667, 
                    0.3666666666666667]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #6}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.6391666666666667, 0.5283333333333333, 
                    0.44333333333333336`]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #5}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.50875, 0.48250000000000004`, 0.52]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #4}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.3783333333333333, 0.43666666666666665`, 
                    0.5966666666666667]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #3}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.253, 0.38833333333333336`, 0.6383333333333334]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.148, 0.33, 0.54]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 AutoDelete -> False, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"]}}, GridBoxAlignment -> {"Columns" -> {{Center}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"SwatchLegend", "[", 
         RowBox[{"\"M10DefaultDensityGradient\"", ",", 
           RowBox[{"{", 
             
             RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7, 
               ",", #8, ",", #9, ",", #10, ",", #11, ",", #12, ",", #13}], 
             "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", "\"N\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", 
             RowBox[{"(", 
               RowBox[{
                 RowBox[{"Grid", "[", 
                   RowBox[{"Reverse", "[", "#1", "]"}], "]"}], "&"}], 
               ")"}]}]}], "]"}]& ), Editable -> True], TraditionalForm], 
    TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.7451462926815557`*^9, 3.745146329029219*^9}, {
   3.7451464281649156`*^9, 3.7451465300196533`*^9}, {3.745146625592494*^9, 
   3.745146645922782*^9}, 3.748786660421547*^9, 3.748786700584346*^9, {
   3.74878674552485*^9, 3.7487867765282946`*^9}, {3.752325505874521*^9, 
   3.7523255077497215`*^9}, {3.7523256272536764`*^9, 
   3.7523256652889977`*^9}, {3.752385904024565*^9, 3.752385919823115*^9}, 
   3.752931112165023*^9, 3.752931165764444*^9, 3.7529313590368776`*^9, 
   3.752931574515073*^9, {3.752931616832061*^9, 3.752931627192511*^9}, {
   3.753015929933479*^9, 3.753015983139789*^9}, {3.753016059866689*^9, 
   3.7530160666017804`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Whole figure", "Chapter",
 CellChangeTimes->{{3.7530090215537195`*^9, 3.7530090235693283`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"machineworkplots", "=", 
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"markovefficiencyplot", ",", "batchefficiencyplot"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"machineratioplot", ",", "batchnplot"}], "}"}]}], 
     "\[IndentingNewLine]", "}"}], ",", 
    RowBox[{"Alignment", "\[Rule]", "Left"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.745078027012864*^9, 3.745078041623846*^9}, {
  3.7450787596231523`*^9, 3.7450788085659356`*^9}, {3.745146876885262*^9, 
  3.745146878510397*^9}, {3.748786717723925*^9, 3.7487867190644894`*^9}, {
  3.7523859787890654`*^9, 3.7523859813362103`*^9}, {3.752931529760518*^9, 
  3.752931533026493*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{GraphicsBox[
        GraphicsComplexBox[CompressedData["
1:eJx1XXVYVcvXtvXait3deu3WsfXaiu21uxtbMa9x7cRGsbtBBVFABRUJBVE4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         "], {{{}, {}, {
            EdgeForm[], 
            RGBColor[
            0.20688222567667713`, 0.36271234759815396`, 0.5951436716654596], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtk0tOVGEQhSs6sO81/f8dmWlEjLQIUVE3wIAh8hDBFoYuADfAAB8ISs+M
GgWXoZjgA3sHDuShjFA0BFR0BX6VU4OTc2/9VadO1f3v6Vu3R6cOmdlVcBh0
lmZNcA7MVswegl9gNpmdhO/Ax2tmC5xvZLNe3pePmNXhfc7HCrMD+Ab8D/4N
hrLig1larvm3Io0zoAt8znpeg0/U5GOd52tgktrxLE8LkX8sS2MzqYf3ehS6
44X69CXF+uEX5LeIL4WXm+HzI1xH7x38tlDf1UK9mtHvGTUrxB5n5axG/ftC
3nzW/ui1Aa8nzdhMymlF3s+q2Qi7+gHXsvaVs/y674nQmozdjYUn7/WhkIcG
SFHrGrtoDaK5XdWZ51wHF+n9mvgVeDgrNgAvZs38HD6f5Md9/UFvD8xVpO27
mY/v53M9AF+o6WEfW/Bolt8R+Bv1Q+jsw2WWzlH4aezrCbzD2TA53fS8C9pd
F74HTvH8CV5LmruN/JeRvxPeGjGXe/dv5b0vk/+KnAtJd2cl9tSM/c/D3aW+
r9dthf8GPMPZG2ovJcXOlsr9HrP4TNWYpYy74zme637ci59tx/4Xqzqvh840
uh2c30+Kt+K+dMa/5Xfoa1buZtyBiZitK/4Ln+U/fRqAGQ==
               "]], 
              PolygonBox[CompressedData["
1:eJwlkUsuA1AUhk9E0ov0HmFGvRlUUGzAAqRaRYShBbABA696tGaCeGzDI2HC
DjzaKisQnbAC38kZ/Ml37nncc/87sLZRWG8SkUHUjGoqMtwq8tgicgano0gu
IXKHMvAyZ6Pk0+gLPlWvXURz8DQ1t9T2BpEduIIO4X60CTeS1CW8ZoL4De2T
K6EZWJnRCN5jvR/Rc3+oajH5Mncfo1Q7dZwdkSuiV3gS3TM7j8bgJepX2e0Z
XcJ19d2fiK/UZ9gse3M3vE1PD7Nu6J+CZ6lZoPYBncMX6r0rqACfqOeG6K/A
pehvtzfZ26rqOdu5i/nX6ruYh59wG/oJfkcOzqp7aR5EeDz6Lln0jXfvxAfB
e5LkX4j7gp9Zro5+g3tSg/Pqu9pZBzwS/S+tZxfei/435tkW3KnutXk2r+6p
eWueFOF/MA9LAg==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.35591182715545927`, 0.42878690411214226`, 0.6098473603942348], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtlElPVEEQgDsaBUbe6xFhhsgkOrgr4HYxevBiwAjKorggGGPiVa4eXEBR
B5fgbtwT9OqSaKJwdYmJUVlmWAXR2xCNMfoD/CpVh8rXr7q6uqq66iUPtTYc
meGcO4rMRN7mOXcAaUYC79zpXOfSoXNbWb9CdxV2oDuFTCOD7JXC8/Assoj1
JrgDu17sb8Avodp/hhOBczU5zn2HdUjxbOficCdyknUNHMbuAvajcIrvauy/
BRqHxNMPY3zHsa8NNJ6ExXSGvSQcgEPIRdYjsIE49hPPba++xOcYfMj3O/T3
YVuofjpgKkJOSCkyzt4quMds3yAtyFLsXuBnmfjn+3We5nzHa/0a4Xr2erD5
zV3HQo01A8ctxy5YIeex+YnNbq++4xZvi9232u5aAeNR5xYSTxqbkXznns+i
ZrCK823UZBcc4Psp+nHYyZnF3LVR3gHpxc862BroegPrT0g7Nh9hhjPPOPsh
X+so9UzBK6aX/Uv21vLmTRazxJ7FZz0+y9GHXuuyHe711ldwKtS16DZb/0gf
Se+9t/6TOkvNJfdf5vMRrPRa5y1eY5WYc1inLV/Juwi7GHVIwAbkBOt9cIy9
J9j0wURU33eEs5NIBesfsMp6ZhLe9Pr+w7Ae+Yd+Hpxr6xg8HOjb/YF3vcY7
CkvMv9wjMUrfZpFG7KaJpxnewq4H+2r4wGvu3V5nTGatD+Z6PVcFCwJ9a3nz
Yvyew/+g1B59Fp9NcAG6ZET3pJ5lEfVbKznAOV51FaZfSZ4viX95qPmL/qBX
PxKb+MrzOlsyx9dtrzCqMyL1kV4sRP8Xm682o5JzCbLW+r8dltlda2y+JMbO
iPal9OdlWGB+6qz2Mk/iv9xiLrP8Ou38lNe9CflXhXrnklBrnzK7Zqv5Y7jN
638rX97d/kXyT8p49XvNZr3c7hrzWsd7XuPotTnvtz6stLpKreTNMjbj3muf
Sb91wW57I3kr8S13SI8X812EvlBmHznOuh7Oj2rsQ9YL4l/q/h+NysGu
               "]], 
              PolygonBox[CompressedData["
1:eJwtlFlLlkEYhoco/T5z3jFzK4WyfV8pgg46KLDSUj+zyEwi6DT/QPtC2UJB
G2kaVKctUFB62kInRVJpaYktakoRUT+g6+aZgxuueWd75p77nfK9zZn945xz
TWg8GkicO5dy7h+aFJy7gZ6lnWtErfCUPOdO5zg3HRXDBxlfxthH2c4tgG8x
5gVjl9A/oPneueEs58ZQPfwFVTH2B+2b8A7GLGTsIvQJ/oiepu1bP5yLxlj/
GErDi9mjlvmdaDl8Ec1KWc0VcH2wWlV/LXwi1ncCHYDb+fac/t2oAb7jrbYM
6+2D/3jjLtQM7wl2lsVoEO5BLXA5eg9/QGdy7NtU/PjKnNEsq3EULkYltB9M
cC4frmR8J3vXomq4OFgtu1AdXIP+pqydgYuCnUVn2gb35zp3j7WKWLOQ9VrR
EHwQbYcnBlt7lDk58CaUSZuHm+GKYH0aUwWvxZOZtMvRavh6sL11B23wBvQk
bWtorZ/RH3n2DV7FnBkpu4MW+FIwb3TGa3AHY0YYW8mcQbgAj6bRfwqVwK8T
u1vdkbKkGlSL7nclvCyxbKn/CPwh5lP7rYdv++g1e9yCz8XznEW98Fz0kP5S
2ocSy5iypkz3wQ3xvuShvBz2lk1ldMTbGXVWZfg73MucGTl256XUfyGxvbTn
ebgbHU/ZfscTq1G1yqN1cFu8L+2prKxILGvydAm8Jd5XF9oKH03MC3lyEp6d
2No601J4TZyv9XUXfd68Vv8c2leCraWarwbLmO5XGSuA50V/dd4B5p6O/us8
8rIq5ukx2hjsn5U/R1CFt4wpTzqzh/Pi/6ozJPD86L9qGmL8S/J7n/wWM7/I
W6aV7SY0yNi3wbKhN0ZvzVA8jzLUrrcDHc6ytrJV6y37hagEPhPzKE+Owb+9
+aeM/PKWAfl3FL2CG4PtrTerQ+9PvE/5k0/7c7B/X2/GTXhy/B+VwR7lKbGx
mtOfWGbkpTxdRHun9oz50Vv4JpiX+gcuw++CvaX6x7rhbd681ZtRA2cHq1Ue
p+ACb2e9i4d9eBmCvW3yXN5Xe/NWHtXBZd7eCtWQgf8DEdrHBA==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.5211881914664742, 0.4868712493971635, 0.5126880919174721], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtlUdMlUEQgFdUeMj//n3IQ0pE7BpNLLEmxkRjQYiK5SFij4lXPdkLdmMM
YAOJUWyYmHhQSPRiuepF7DGiPMBKYk9sN/0mM4fJt//uzO7M7sz8A9ZuWLQ+
xTl3BumOZEeda+7p3KvAue2hczkR57bB9965Mb2ca4cvMpzb3MO5EJ2JrN1K
c24KbGBtTbpzK+A7ZDT6nbCUuRvIPKQKmw5sy+EJbI6yf2eoOrL+ke/dyAek
C7nJ3AJkPlLidVzs9bvL9CJe7dJgGb7cSVOfUvh+z3wqrOC8Ns5NBOq3+P+P
ODIYb2Ich0Pxowm7Vu6gNxJPJX64EvvVnFcBN/CdQOcHLMMmie0KuJTv/eiv
hR0W+xr41u5N7u84ekXcbQu8zh65+NYMy7HZh+1g+Jq1JnROwyxkI/unwwbW
3qIzF75E3jCuh5eRT4zPw0z0tqAfg0e93vkD+Bjphw/PYC16nei/gA/Rm8NZ
JwL1Q/zJRyojep9yd8e4kyHwCFyCzR5sT8O/EX2738hq81/i2IVeHnPDYD7n
/WH8hnFlqPtvhZ8CvSu5s1/M1URUbxHf+cz3hbO85kM1TPf61gGMsZaFTmC2
VWa/mO/tzJfC9lDn6mC2V18LYEeo/iYYL7M3PQt3hhp3C7yA/Wf2uRJVPdHv
4zXnJPdmes0RiVFqY7nl/CpYY3k5w+vZ4kMr7Ok1T7tbnkpccrdzrTaK4KtQ
Y3kNp5m+2FXZ/deY73Ln1RKv1/hzYKbXuSQ646wepS7jpiO6D+xd5H3KiG0v
MZ6BSdbu48NFGLVakJr4wtpi9vkGL5hOI/zO9xLmf8F37LEjVXNxaqh1Nx4m
o5pPwxmnWE5KbubEnDtIHubF9GzxocLeTXJb8vIcZ9zjrDZ40XL7EuzPXtfY
czDsYzlwnz0LbV7WT2JTwP6PYC5nHGAch95qOYSH0buN/oRQ/RB/nqI/MNSa
HBSqL8Vp6k8uNnlwIazlvFnUS3WgNSm1+TxDcyfX+lad1ZfU2QQ7a7LUDvrt
6BdLHwo0zwvRKWJtqLxrqPcpd1mCzSGbr4UF5kMSu4cWY++Y9gjpFXVS78hs
xqfgz6j2wa+wxWsPPQazYtoHnjA+Z+/XGdW8lvqS3JW3FZ/vIl321vLmbdar
pWdPCnV9OuywviT9qZv1W+m79dajTsGxgf5T2uE6q69GmG1vVO+1p0hvWQZH
mb7YlVkvl1zMtHeXHtBqscejGqfoXZX7tLgkvkuWS+e9vr3kQJbEG9W8TcAR
VvvSA0ZaDkguyBvIWPJY7iBh9yK5JrnRZCI9QOYqrR9Ijc2xupb6/g+8Q/kO

               "]], 
              PolygonBox[CompressedData["
1:eJwtlVlsTlEQx4/S9mt991501aglKOGBhIQQCaFKUVtbSi2ReFUv1krsREQ3
64udROLBkvBieSW22hK1fN/X1q5EJLY3fv/MeZjkd87MmTtnzszcQavqFqxJ
c86tRXogxyPnVmQ5dwc5CS+KO9eOYiOSBq9kb1S2c6ORTnhC6NztTOduIvvg
2sC5XRnO7UCq4GJs/sY4h7+l8B5sbmE7lL0DofmQr7vok3Are9vQfUKyWE/x
/ktY74WfyQf2u5HCXs51sNcUs2/koTsWmU42+ejvo9+Kri/yED5FTF3EthNZ
AU/FvoJvf0A/GW5GrmfZXiM8izMNMftGAn7KXv9ss3kExyOLdR7rcrgmsLsX
IQsCi0Gx6EwO/AgfRTG7o+7awplrnJ2LzICHsHeJ+xagr4f/9XRuA7lPIdXk
f3NoOt3pnu4T2VvpzZbBD3z+CmWj3ISWO+VQbzXd30/xPIHLIvv2R2xicCc2
f+BGJAV/jtt99KZdcAE2v2JmUw0f9v6VI+Uqg7338Bx8lsIJH59qph0uICe5
+NqCzIOPIp1+XQHPRerhHCQfHohsh/sixfCQwN5Oe9IN5puXuVs50sZ6jj/f
gRyBLyBf4Ur0XfBB7jAj3Wr6ANzh61kxnoVnY/M2w3wshBOB+b6KJOHKwGJ9
h5TBfXjTYl+PefAv9qozLd/jiG2Zj1c1dwY+F1mtq+bfwmd9PS7E/hu8yveP
Yj6tXBHjemJNIlXw98BsbyBj8B8PLFeKV3dPYXM13eovAdfG7ex09prgL/68
vnkenhm32ipD3wL3C+ysfOTBr5Ar2M9EUoHlULnUHT/Bz30/qMYLuP8Pr1f8
q+El/v2UA+ViWGi9KJ8l8OvAfKvmB7C+yLoq02JUrONDmy3yWcd6rJ8fsvnJ
en5gtaFvVMONoZ8tyGv4oe8vvVErnPT9rJotg3N72dtJfwh9ru6bbj4Ldf/Q
ekH+DsE1fj6q/ovgxX6+/UbaQ+sJ6WSzBG6IrBcUQxN8xr+/5uGJyHzKt2Ju
hh9HFovsNRsqfL2pZyL4jbdXD+aiXx6ZL/k8Ddf6tWJSbN0jm22aCZoN+ZHF
qhz0hlN+/qoH3sEdgdW2al61/yKwXtIb6a2Gh9YLmmEj4EpqJkH9rENy4lYj
slUPtcMTQ6tVvZlmf5vvJ/X8SzgZt1wr52/gc75f1QP6lwzw9agZpFk0LbJZ
qxmmWXbPz3fNnG6sMyObZdrT7N8U2izUjBgJ7/f1oXgmqRbwWZpud6iB/wPH
b/aB
               "]], 
              
              PolygonBox[{{3347, 1556, 3346, 3288, 3289}, {3281, 3280, 3215, 
               1349, 3221}, {3289, 3288, 3287, 1352, 3279}, {3283, 3282, 3291,
                1458, 3118}, {3278, 1351, 3217, 3285, 3286}, {3223, 1350, 
               3284, 3282, 3283}, {3222, 1457, 3290, 3280, 3281}, {3286, 3285,
                3272, 1555, 3345}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.6864645557774894, 0.5449555946821848, 0.4155288234407091], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtlllsllUQho8gbX///3ynUEDbgsWIgpiYCCReQUAEKQVRXJAoYguiV3qj
lk2NC0pECpRStkBKkEURo9AL71Qu1LYsERHZ2lIgyBLUuCWgiT6Tdy4m73xz
5szMmZkz57ut7qUZL/YKIRyHekN7ikOYCD0IrUwhtOZCWA0+BV0vCWEw+A9Y
i/waeCxK/0fwlSyE/shezbRvKrQXqspk7xQ6qTSEiptCOICdN8G3obegyazV
F4VQHSWztUon48uhd1zX1lcVQjh7YwhPgwNLtbYem4vxNYAYhoIDwU+LFdNe
j2cKNAa9anA8WML+UuycyIfQBv9RnxByUTZegxZDd7utheDLUBl8vcvM9hJo
XJL9CeDuPrIzoY90Ladm7yQ+Ir6Ognl8fMx6Oz5HQFPhtxSUJ8tnN7noSDp3
xvmGsf9L5F9DW5HX4esZ8E/szEQ2mng6oeHo1YDlrP0LPwScmGnfWLA9KRcr
knJpeRsEzUXWllNdKz3f+3Ii4z/PqW6tXtNmzrCdhpkPzsvJl8VU57z1ymR8
nuEck8A1xNkJ3xjVB3bOn8ATUXrHwdNRukfBccS6H74afAEfO/G1CWzgewS2
N4D1UTqmu8l1GvKSfVWsXFj9zb7ZbfGYLfYGj8fimkguaoi7CLxCDQYhvwRu
Z+0q/GXwe76rqVEzuAzZu9Av0HvQr0XSO8zaJ+icAPdEyXeAG6Au+CZwJ/Qb
/GdgbVLungMr+L4V+Z3gOc6zmtg3ZtJd5r6q/O5dQL4D/gB7d4EXo9avgKWl
ui8RHFCqu9IP7CSmVmLrBvuhuwBaVKS4Jnmdtkadqy7qzHam3VG9aLmq9z22
1/S3JfVMD9iM3kJk0yx+vtuRf5i0p2+R1n7A9xRiWGcYZacmqvZWo9s5V7ef
/Sw4O6kfW8D7k+7uWHB+VN6fBQd5n1u/X/E87AIHQ5XwQ8A50FL4FquJ168W
viJphs1K0jP9oR5Xl59xqdf4qtfP5CvBh6JysS4qDtMZHlV764GyqB6yXqqC
X8d57sJXY6b7ab25NlMcFs/zZiNT34633vdZajO13mfOgkz5tVwWouaXzbH3
wftYe5K9f3m9bIZYzZLHafGeJp59xNYFHk665weT7n+Fz1az3e217oXeaebV
zIL8nCvRPfkm01xssxnoc3gOeIDv15H3xuYAqBG+B9k9Xner/7GC5uMh8Aj3
cBf3cUtePWIz09a+zTRTv8vkc7HP4ifYcwpf/6H/iPMPg40Fzdrqgu6E3Snr
v1He8z0F6Zn+VHAF9ADyNeD5EsVs/mbz3YNOOXhDks/2TPW0WW335nHWFqHT
H+zw98LeDdMz/UWZ3gGza/16xnO+FSyDFrL3sYLsmV2LY3Wm+d4E/hFVx2vg
BfQG47McfnqmfJ7PdP9tDlQS49m8bHaDa31G2ayq9Hlic2WWn6sBfNRrOgM8
zp4EXwx/R5Qv83mzx2m2p7u+7WvyOE9myu88n/dWH+tPe+P25ZWfL8C57Kkh
ntqCvk1+C/wHSe9JG9g3qubWF9ZbJrdeO4Z+hn5XXv3Z6u/PSOheaBTUkRNv
M2iUy022kT076Kv14PkkeTdY5v8J9r8w0m2MhnYm7dsODvO32N7kzR6/neOQ
35MjSe/Pfn9fOvzdtPdzvfvdllcfWo7Mz8UkP5eT8mdvsc2Cke7fdC8lxXMB
/Nvf9N+j/jGWeI+2e98cLMifzUbrg1VJ73QD+IbfQbuLy31m2uwc6/8A17FZ
l7R/TlJMFsPPSffQ7uPmvOxZLawmYzL9eywH/wc5d2Q0
               "]], 
              PolygonBox[CompressedData["
1:eJwtlltsVUUUhkc4Pe1u9+x9Si1S2lJUFNTEBCExJmI0WKWXhMSgLUFoWm9v
+mKEFi/xghgKB1rSFkg0baAXRYgK7yoPaqmAMYqirdALijEK8ZYUffD7XfPw
J9/Zs9aamTVr1pzr25556Ok5zrkdKIN+Sp1bWezcCvQzHHvn2rPOlaIc/BV6
oNC5H/i9Hx7B5vPIfC7BzyXOXVvk3FFsFsE3JMbz+XYbvBibf+HH8WmF96HX
8H0Vleecq+T3P4zPoovYL+D31SLzqYK9t7VsRmvg07FzhwucW4264S34lGG7
FX0CN2CzBdt5qBju5NuHrGcp411we2JrexG9BPdgcz5re+6Fd8YW+200Bvfx
rYOxC2gfvBifI8R7ENXAQ3y7zNh29CTczbdbiP0x47WJ5UT5UA7HGV9AzA4S
P4Xmw5vYY1tke94A34zNImK9jjbBX6PaQpuzmlh78bmftb2LzsAHUAN8DI3D
peT0FXK7EKXwYfx/zdoaf/MmcRPx/oQnmXOU+ZdjPwN/iaqK7YzK8K/Bpgr7
48SfIH4X48cjszkNX0R3wCf5Ng3Py9nZVqIz/J6MzVcxpuBHY9u7cvAwnGBf
ge3LKAfXeTvrCZSHv/GWa52Rzmo5Po3Eq0e3w9WhXrpROVyAZuBG1nMvPDe1
s9Y3jU3jU5m1fF2AR/n2fmRrGIPvQfWR2WdSO3Od/RrWcE61klqutGft3eds
7cq5cp8n5iR7qyN+D/wXPs34XiHGFXg0sVqdRl/Ab4X9KEcr4JWJnY1qdhX8
FD5vZM1/GL7qrbY0fhfjM4ntXTnQ3RlEY6z/MdQG98a2FtWIauVQamelmhuA
9+J/K77L0AR8H/qo0NZ8J7w/jGuOtfA6YrRnbI/r4VPonQKryU54mbe7sA1t
gCtQddZyrtw3ofGM2e9S/Yf1Kd5GeBdr+iCyM+iEz5VQF4yNzKU2S+xO6G4o
J5exbwu/dWea4b7YakM1tie2NWkuzbkWzhKzIbL8z4FvTOxsdUfVu97zlmvt
/w+4JbVcqkfVwHXYnCi0nOTh9an1rlZsNsItob61hiWxSawzXqrf+JQX2X1W
L5kN9aGc352YxJpjs/ove/bEG2T//fBBNAQnfDsL79CaIqvhnfBAbLWt834T
zvPtWGR7roXz+Azjn+L/LTwZ6kf7US10e7t76jlnvfUcrVU99tnEala505yr
iNfIHN9nrGeqd46ox4T+NQDv9vZ2qCfXw3Whv8rnEd1/b71aPTb1dkeUf8W4
BPd7qyX1sEG4zFvvk498K8J9U01eF1uPqQr1UMn4Em+1pxpsgr9L7C1Qj+6F
P0PPF9kbdgI+gLrCeF9iPUC9QDafJlYz2v8L6Bq4J7G7ozPbntgc1aH+W+Cp
EE81shD7jsR8VQNb4dbQv3UHdBdy4b3TG1eqfhP6p+pHvS/y9jbJRm9jc3gv
tOdfGO9PrRbV0w+mdge3hf3fpLMI9fF/Try9kcql7nCJt5xo71rzefiJ1N5u
vflD8KnUertqao/+C6T21ujOnoR/TO2/hHrQMLw6tV6sN2N3am/8bIg/nVgP
Uy9Tz/ub+X/3xnqjjsD/ARszJFU=
               "]], 
              
              PolygonBox[{{3039, 1145, 3091, 3081, 3082}, {3154, 1244, 3074, 
               3089, 3090}, {3090, 3089, 3088, 1040, 3080}, {3038, 1038, 3085,
                3083, 3084}, {3084, 3083, 3092, 1146, 2995}, {3082, 3081, 
               3029, 1037, 3034}, {3079, 1039, 3031, 3086, 3087}, {3087, 3086,
                3071, 1243, 3153}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.8517409200885045, 0.6030399399672061, 0.3183695549639462], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxFlmlsl0UQxl+l9/892qqlpgi04A0aUQ5R7kNOQb6ooBDKUS6RSxAU8JOK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               "]], 
              PolygonBox[CompressedData["
1:eJwtlllsVlUQx0+0X/u133fvLai1UEJbccXlxSgEpRtVNqG1PhhBg11oqRqM
tlDE9UlldaEudcG40NJSFONGYoyJpS1bhUSpgEaW1raAxgDGNRR//8x5mOR3
zpwzc87MnLk3v+rhiqUXOOfeQ1KQ0cC5e9Oc24GUhs61Jpwbg6L9Quc2wQ+i
X53q3BmkE96YdG5+zLkh1kyGS9jTxd6FyH/oZ4dmSzaLQtujvX8g7fCngbH0
f8PHsPF5zGzeCK9hrgH9j8g6+BBnSOKrEYmjv5+5fHSrkFp4HHOPoxtA7oMr
8NmD7Rvizr0O97GmhPFPrH8RTmNNA2sTyEFsv8t4Hr4/Q47CqcijKeZzH/oP
GJej245MgR9grojYHCSI1fA2fz/FqA3+DulIM5/Z+L+dcSO6EEkLTMSt2Nub
tDPpbFqzFq4O7G664zVws4+3zvAm/DM+x3K2Ds7Qn7AcKBeDyFVwNfJLit3p
bXgpNs5i6zTSAZdzpuuJTTfnmwdfzVyu96fYNjE3Bv0W9I1wCzbKYmavFs5G
nsD+xcj2hM1JJ59V8DTm+olNAeerg1cxV4h+E9IFt2DzurjVyHp4Nj6X4TtC
ZsFzWPMItg7pDnCNv59ioFhUJi3X8qe7lvp6U85Xsr+VuS9idub34ZGk5S4P
+xPRz2d8OMVyPBc+zhkvSrEaupTx80hRzNZo7fjA9qtGc2Tf50fx3ApXsf8H
7lvIfevhDYHVru60Ht6Njc3szWScYFyJXJZq5/kdXZ1/X5qTrjxpd1eN3gkX
hPa29MZug19gzfJUq5lm+B9kQZrV4Fm9Df8+lNOT7F/g60Exy4N3YmMl8T+O
9MKDCculcvql6t3Xl+ba4fGsacd+xPoJoeVcOq35JGE2B3z8cuBxkXOvsrZZ
6+Ew07mnM4gtsofx3MBioTvMUb0ztzjduXOsz4ffwMe18AZkAG5LWK3Ln87W
p54Ts5gqtt2sWcHaTOQr+A7mimMWQ8WyImm9Q/m8C16Nj4/wNxMphgPO90yG
nTEz02okz+djEpyFzeI0i4FioTd02vef+sBqVL5U48/CG1nzStze2FvwOnxs
w1c29nfDQ0gf45sYn4C7ka2ML2HcC6dzhifhp5AkvDeyvTpjxDieaWu1JgF3
ot/P/qmMf4VX4POxuL1hveVFkcVWMa6CS5BZ6XamNfAmH3+dqQ2uR5akm80O
OM4dg1TryTPgXZHlUjFcC78TWq9Vzu9WrTC3D10dsgQeCU03ikxkPMH3D/Wr
XPj7hH1r9M05DA/5+OnMuTobc9PRH+CNTYWHI4vdzchJ+NbIcqkY3gJfHplv
3Um1dcR/z/TG9db3J6z3q8fE8P9QZLGbgvwG72KuLWY1tCdpNaPaUc2VwecD
6516j/r2nYpsr+68BT4QWO+cgfQHdkad9Vv0I3BeZLFQTPRWdiJZ6D9E3wMX
RPY2lSPl6kRosVBMhuHzyJG43Vl3fzkwX+o56j1Dvv/p/V8RWIwVa/XQhfCV
vr7V09TbOnz/U4z07VfP0F7ZGNR7DuzbqLFsn/H1fw8+/4R7k9bbVSOqleGE
9QLZHIB7kvatU099TvlmTSl7O/VNhhf586kmspL2z6B/A/W0JvTpgX0blBPl
Jiey3qB4qFb+Cqw/6hv3MbyDuaa4xegcvDw0X2MZLwvtTeltKeYZ8GLs1aZb
Tioj++dQLPXmX4In+XxpTU1kNmRLPfSb0HqwerHu1AIPhtb79I0rC22P9upN
nWK8ObJa0Fyr8uf/n9TzXoML/fs8ynia6pG5Y3F70z3wZP/90DejBv43sFwo
BvpWjIa2Vz2xIbQep1qRjenw16H1csWoC3aR1Z58yndOaL1U/zD6l/kfr2Ja
Tw==
               "]], 
              
              PolygonBox[{{2924, 937, 2976, 2966, 2967}, {3027, 1036, 3026, 
               2974, 2975}, {2972, 2971, 2958, 1035, 3025}, {2967, 2966, 2918,
                829, 2923}, {2964, 831, 2920, 2971, 2972}, {2969, 2968, 2979, 
               938, 2891}, {2925, 830, 2970, 2968, 2969}, {2975, 2974, 2973, 
               832, 2965}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9186928569328305, 0.6667321423320764, 0.34794785649177473`], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJw1l32Ql1UVx5+F3+7v99vnjcKkQdMYBNNxRuyPFFhAYMUmRybIqaamJKAS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               "]], 
              PolygonBox[CompressedData["
1:eJwtlmdsl1UUxi/0P3kXyjSgSZlCTAQ/iNIyWqAxgAlUokaiEEShlFKGkIiK
CsoQFEGNIDhoy2wposTIVDbKHirTL2LKKEMThYShvyfn/fAkz13nnnPuGTd3
RHnxuIbOuU0gAQZ6zvXNca4QDID/EDo3OeNcACaEBvGVaedawwsC58annMuA
fHgOcz+xthf0h6+NnDueda4UlMGrfeeGJJ3bAh6DN2PPcvZ6yGwBb83cNBRp
DjZz/+RYnxowCH6V9W2c7cB9Hbkv29i51xs59xrw4BdY38R6MegGP8oeH9kr
uOM+5I9h7iKyB7NeCU9zZipn7wVJ+J/MbWVtM6iBl3nmi9M4aRR8NzKmIO93
MAk+KDRbH2a8FL6LM5Wc7QF2wqdwpprzfcBE+Hb2vJIxnb4PzSbZVgsGw4uY
Gxb770n456Brxnw6BD4ae97H9vbgIXibwHwpm9vKVmSMR9cMOIlNW0Lz7SSw
Df4l6ALfh7xF8gf787m7CnwCXxnrI58rFlqxZxV7Q85MhBfpDu6eCPrBB4Ym
62cwjfF133STD6/AeyOjAFmn0KcH/CNQkWN3DvcsRmSrbHbw3sj4NWUxpdia
BD6E3wTfwnPBxvh96pF/DRlv855vgmaMP2Zciew8UAKfQ8zVEHtN8cUe+H+c
fz6+T75uAIanzQbZcpj1nmnT4QB8OzKXcVeacQPGT4dm6yP4Ywl8Met1CYsp
xdYicAl+ASyB3w0tVorQoTv390XGBGR5oA/8Ofa8EevfBj6OPWPZewLUwp9l
7q2E5cRQeGfOtEvZm+vt28km5Ddg/8vwziCRNRml8NWgBH4UVEcW0/LdU2CV
cskz+dPB/YwPIvM08ntj45HAfCrdWsgm9o5FxuP4sju4Ct/Ann/Z/wFYB9/N
/qqkxcgB+CHOpDlbBu7A23LGocsidH4Avoc9PZN2RmfrQ7NlMeuX4Os4s5a3
bMb5PzzzkfSRz0col9nzacZ8kIu87bKZ8/eg3054KrC3Kwe94CN9exvZLN/u
9e0tlLPK3TrP7tKbtGK8Js5f6SBddnHfuYzVxJ3wy5H5Vj65At8NmsCrmZsV
2ZvIHr3BaHhVaLHzGRgKr/Us95Vzqz3LMeWaasxW+G1wNmM1Ixe+Pt6v+ngO
nkDH8fCTYAD8i9BqkXxSB68MzZeqIcvkW8UYezPgAOd/DK02nAG34EeYyyYs
h47Cr4Sma0P0b4P+5z27WzpI9wuhvaVqyjPwg57JVo4vgD8Y11vlaHvffCLf
9AN58FGRyVZMXA7NJslvCc7CN3gWe3qTM4q/OL9U35fCd0VWu9dwfge8GyjM
ms/ku6lx/OgNVYvHRNaLckAn9SbPal8jZB5W7fSsVmv/cvh09hRkLabejUwH
6SKZNfBhntWaZWCh9IvrnWRIVgffcks6D/etZqp2KsfmwS96ZqviUblYyty8
lOX4SPg7nMlLWg2aAZ/t21srZ2apf3GmjNqaBPX4oT9zv7FeDnJ0N8hn7wnd
odwBxxMmU7LVg1VL1FPr4MVxPVdNfEL9IbDcVg2+wfoxxr1YO8V4AfwaPsnn
3jzwN7wrc/NT1qPUq5ogo0faerx6/RzfeqN0nOlbTio3fwGF8DLferNiZjS8
YWB/iwrmdjD+hvGNlN0xIbCaI/3ks9XwlzzrNXqDUvi+yGq//giN6O8J1SPW
y4Gn/GlsteJVkIJvDKzXyP478KuaZ68+SVn2z45sr/4M+jvUxv34H7Ae/p5v
usrn8v3cwHylmq/ar5hV7OoPVKFcZG5u7C/JUs1V7VXPbRlajVWtPUb81cNX
xP5RDzwPvx6Z7/XHWhdZjiqf1AM6RhYDigXldBJe5FssqAY433Jeua8Yf5T9
mcb2l1IN28u4fWS5ohqm2vx1ZL1Jb/6X6qtvuaMapFp017Narxjrx9hF1vvU
g9WLZ0aWq8rRGZH1cPWjttjfCdtLmBuTNRtUG2ois11za9TrQqsdqsF34PM9
yz31mP3wr3zrbfKRYul2YL1eMfNdYDGtt30BTGVcFb+H8lO9uzDOf8WP/i69
PPv76Q+Y79kfUn9J/RGawvcHFruK8UOKzcBiQX+MW/C7gd2lHnkzMBmF8f+q
AP5iYLYrBkrgXQL72yqmlXvNQ/trK+eUe/8D+WmEJw==
               "]], 
              
              PolygonBox[{{2831, 729, 2872, 2861, 2862}, {2870, 2869, 2868, 
               624, 2810}, {2862, 2861, 2824, 621, 2829}, {2811, 623, 2826, 
               2866, 2867}, {2864, 2863, 2874, 730, 2770}, {2916, 828, 2915, 
               2869, 2870}, {2830, 622, 2865, 2863, 2864}, {2867, 2866, 2914, 
               827, 2913}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9450948320623858, 0.7327370801559643, 0.4297939793933957], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNmGmU12UVx3/Mf5n/zG+bSk5p+oI6xhoZw6wwbKUZx86xTBP1nMQVZmdY
tExwASqrowjvZlVkUSHWSFGGGbSCQBAERTGrF7YYy8BxCRg4fb7nXo+9uOd7
/8/vPve59z733ud5/sPuaPlBc1EQBGuHBEEGLE+D4M1CEJxNgqAMqi4Ogj/H
QXAbfBXjq8EvQisZHwqeh95mvA+cDs1kPAPmyoLg/tIgKAY3oPNISRAMgB9B
Uxj/BNwJxfABMqe1LjIbwSH8Thjvg69HVw86Pw+2Q/vgbwLX8L0SmzeCe6AS
nPgT+BE0F/5D8DmoCpmVYCYMggbGi8Bd/O5m/AXwdWge4wfBl9DbjC+/B0ez
djH2nIbfDH8Ufiu4CrkK5i4Db+XbeOSf0TyfKx2tyLUi3waOhHLw9eB4qA7+
QfACMT2XD4IXwT+gqxOdveBuqBR7ToPPuo/ydT1UDb8O3OA2yJbj7nsxft0H
Px9KoZddXvPqWWMEa10FboGehJ8LLoHq4SeBKzxWitlDURDU5oLgEXAW9J9s
EDSB1+HbHcR/CLgEH9bgyyNgkwh+PbgWuRuZuw5cArXD94EDbqf2qpb1ZrNu
Hfh3fvew7ivgYuRqkF8EXgk9yrojwH9CNzFeDT4NHWe8A5zG/Cb0TAb7mN+F
nj+CMbGYw1pjwX9AlyN/ElwG9ZDkr4FPQjXwPwa3QVvg14Mboa3w20PLCeXG
l+DnQt9l/Huh5bRy+xfKZX4fQ2YaeC30V/gJ4FVQG3wC/gu6FBuGYvP18Neg
Z35ovzV+Cn4S9Dfkp4PDoQpkZoAP+Lpafyr0LjITwVuhSsZv83nSea0KGJ2N
6LwG3MW3pfBj4K/m21+KzL7b+b2Y8a+BHyDzZfj3wWHaM/gz8Efw7z1ka0Jb
Q2uN8Rp6Q/VSZHU8CZoMfZwafphabevbXB+rg94iP0Yz/xDzRoXmm3y8Bazz
GCqWR5FthI/gi8osnxej55LQ6lr1nQ9NJgeWh2bPecZf9dpRDal/LIDK3EbV
r/rLm6UWL8X7cJHZU5sxvtF/jwzNvxFgvszqKltm+mTPfa6zzn1/JbWa609N
5n5fd4HL6veZ1ORPpRYL8eqJ81hjOusvDM3mtYytLjGc4vxq5ydBv0SuHfnH
wO6C9ZZOsDK1Pqx+/J7ng/z8CuMdjJ9QLwe7oJ6C6TtaMJ0HfU9VDzMT+z6g
fp+xbxpX3VRDXRnL2U0Zq5nfor8ZHc3eD1ZBk6G30NECzYH2KY7MGRLZmq0F
O2MUM/V/zVOvVQ+RP2UeB8WjpcTipG/Kl86M+a+9VI/V2q3oPYX+ccr51Oa/
mlpcdGYpTtpX2a+91niFf2t3XmNd7qNyPYO+HNSQNZukQzbeHpqO5eBlWest
6heypeD2PJqa/UvBRanFuAI8lZie5xPzO/V8eld9R/XpuDljOZFFdxFUnzV7
ZiuG0IXQbNsPPoWucnSuTMyXcvfn6shsvxjafPUE6fsvckf4fg4chN5RHLBt
T2i6z4LnQlt3d/jZXiq3elPLxYf9HJMefTtXavVTGVpua7+0b6qRKV57x92+
K5k73HNSufkr5nTg669Di3+H+73F62RTarnT47m3ILRe9lPwRXQ2oWd7YrbK
5ifAddAGZI6F1tOVp4tC648bPbaKp3JJcfy+9+TrXYfWlx1aR/3yO+BvPD6K
k+a2ey7qm/qz1pOdXW5/l+dRh6/V4PvXnbG6Uk0NcT36/oHHR3GS3gqXU4yb
vJb2hjb/ccec+9DrufhvP2fkr3r6Ua8R1cpXIzsLdvmeqk61hyeydr6r7x/1
ulS+Kgcv89yek9p+toA3+Pmoc7LF9182HvOYbw0/y+NNodX/2y7XoL1Ezyj1
DO976n/NXjt5R/Uf8dXed2o9Ft0e8xGpyY1JbU3FX/3oodT82pFaXrcVzCeN
qceo5lQHed/jFu8rquuxfmdIQ4uL7FWcstwvurh7dOSstl4rtvoaw51jON9m
gc8R21v4vgZc4312FVgJ7i+2O+I+5CbCHwA7kc0xN+O6tUY+b9jo/ApoTN7u
arXqa8idAU9m7S40AP4oZ3ct9b6GvN2ppPMl1rgI9oGDrkt3zXtY/65iu0Pf
XWy+7IXaYpOZH9tvjcvXmxPjbwBnsM7OnK35OfUxxmcndvfSHSwPjsxbTPqR
6XYf5etTyJaofxbs3qb7WyO4jTlnkRl0PJ+390MNdBD+jbzpHA0tUxyK7S3w
NDTB5SSzP7bfe2PTcQG6U/fU2Ozojyw+kpXeXfzuYbyI759EdjfWHXmW7+k3
wbGxxX88OC42Gz6ObGyU78uNie3vjMTirVgrvjfrzpuznPg2c17H32mR7avW
1Z4P+p7oPh34u0nvpx8mtgedid2/dQ9/LLLcqXXfn3EsLVgMFF/txz2+t7JJ
8oc9Zg8wvwI9C8Fq8FDWbOpNrD5fTkxfoWA62xx1TiuWypU7fZ2VvpdzI8uJ
Z8Hlvj+K0QH0HoSq/L6uXH0+Mpv2eS0MeA4rTgtji8F1nlNaQ3kiu6t9vw/l
ja91O+72vJ0X29qt4M7IavRhf3PIX+We4q0Yyu9Kj32116r2Zwu4wX2RTy8k
5n9/YjU3wvdbb2DZsDu2t5B6Zg+4w9db4nFQ/imXu319xWGbn1M6r5SHTZ6L
df4OWgzuiC3W22Ozr8tt1x5oX/S2/J3Xteq7weOsM+XSxHLiYGzxr3L/hZLR
m0p9QfXY4DWp3+1emzVeT8pv7eHXY3u/qbe8H9l7RufgFX6XUO4oh4bHlucn
PZbiFbOpjDejZwp4IrK+MRDZPh72HjfT7+3l/kbRe0R94bzXruphiZ9NegcO
eq2ovtRfVKfSezqy31v1XvT3o96RJX731Bl1RWRnmc7JKt+XCs+DWq8H5e9y
37tmt/FTW/VGPuR7oz36SWw50urny1r/b0T/kYz2N5TeUm1+V9GdpdX3UOfr
Cu8fqv9hfgfTXWyiv+8mgxM9hoql7uw6S3RnKgntjXOy1PpJo9tbFdr77vLQ
zpF6/3ao1N6heo+u8rNpHRj6Wy4bWl40eW70ec5rHzt8XdWsestF72+5xGqw
KLE7n+5+d4Wmu9LfGC3e7z/t+y1+j7k3svqfE9kb5B2P4R78rEJnis6fO68x
9YQqz9GlniM6Ay/xnFfuD/X/o76Q2H8Z8n0CmE3M7jz4De/n6uvj/L0wO7K8
X+l9R2dDja93wGtL9dPq/VB12O/noPpF3u8q8rfGz7wq70HqRb06d9zfe733
qnYq/cxWfen+NSe2/Nvs/aDBz6lKv3eoFzwY2e+fgVMjs+9bkfXtHu/d9V6X
uuNM/L+z4rDnr/rn/wBpOIv2
               "]], 
              PolygonBox[CompressedData["
1:eJwtl2eMVGUUhu/u7Myyc+/ci0piQUyIoS4GFdgCUkVBEk1QwUIsIBqBZZdd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               "]], 
              
              PolygonBox[{{2758, 414, 2790, 2788, 2789}, {2787, 2786, 2751, 
               413, 2757}, {2795, 2794, 2793, 416, 2785}, {2792, 2791, 2820, 
               619, 2819}, {2744, 415, 2753, 2791, 2792}, {2759, 521, 2796, 
               2786, 2787}, {2821, 620, 2776, 2794, 2795}, {2789, 2788, 2798, 
               522, 2756}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9714968071919409, 0.7987420179798521, 0.5116401022950166], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNWHlw1dUZfXkv6+/+Fux0b0XUTmuLmJAEkEVbldZuakdra1WsAgkhqOyI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               "]], 
              PolygonBox[CompressedData["
1:eJwtl2lwVeUZx0/ukuSe95xzo1O1H9xwabXsmwgoU0U7jlXb0dq64IYLIA4g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               "]], 
              
              PolygonBox[{{2731, 2730, 2723, 411, 2747}, {2734, 2733, 2732, 
               208, 2703}, {2726, 2725, 2705, 205, 2712}, {2715, 206, 2729, 
               2727, 2728}, {2749, 412, 2748, 2733, 2734}, {2728, 2727, 2736, 
               314, 2713}, {2714, 313, 2735, 2725, 2726}, {2724, 207, 2708, 
               2730, 2731}}]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.95, 0.75], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNnXW4VlX2x88bt+FesQtBxcDuHBMdFBOkVFBUjLEdA1CREkURCbtn/Dl2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               "]], 
              PolygonBox[CompressedData["
1:eJwtlUlsVWUYhv9SbgvnnHuvOGB0oaIR3bRUaatGoN2hG40Vh5iodELUUDYM
VahUnNgoxqKMRTEmIIlKK23pZBxoq6WSOOKsO4doopaOdPB587p4k+f84/d/
01lUtb6ibk4IYQeaixriEP5g4DdUD3eiVbkhVKBVcCYTwp58Fs4LoRY+kQ3h
l/msRe3wY6gZLkHXwatZ8zXr69D98Bg6zd5S5ouY7+fMCc5uQjvgd5mvZX6W
9Wvhk4xdi2GLUVESQpTxWXloHjwehbAAWy9AF7H2LGNH2F+OquFu9jSlQihA
nfDmrG09D22EyxPP9XH+CnhJ1nM6owDO54wUd61D8+EP0yEczAvhAOqBG9B+
uBl9AP+DDe/xlh70J/wWe86wt4zz3oGnsbcaW6dzQpiCf0L74D3oe3g0Y999
yvoR+CbOrOLsQdQIH2fNzaxdjtrgfsaWcP4nzG+HY/bszveY5o7y/U2+Y/A2
3MGeMvYeRoNwa8axXIOOw20Z360YKBZ/RV77JjodWWL5fBS+lTc2wk+gM3xf
HpsXokvhNny4mff8jDrgaXw8kXJMzsEjrLka31+DCvguQS/OdcwVe41pbicq
ThwjxepBNK67OLOOe9ehGcUWrYRvQefg0sR7x9CGxG/UW5WDj8I/RI7FbvQt
3MmeVOQc3gJfzB0X8pbz0QL49ti1oTfr7TOcOZlyjG7A37N8V+b5jXqrfCBf
6IyF8GBs25XzA/Awdx3l7iNoCD7Bnmr2nkLj8gVjDxOiz9AeeDljq9nfj8rg
k2nXgnJSuTmeta/lg0n4b+7ozbWPh+FNrFma55zdAvfGzlXVuGp9N/uGuKsY
e3bCU1n7Vj7phrey5nfecgfrG+H9jH/O+kfQS/AVjDUwvw2thJ9nrDb4DXrL
y+gU/BB6Ae7hzLzIMZyGK9jz6xzfobvOxq591ZRqqy/tWijizQNwi/yvXECt
qm/lF1yJ/9rg67PuNQfR4/DGxGuVY+vhpzmzkLN3oWdj2yzbZcNtsWtata0e
8BG8Le1aU4xvTLtmVbsz6Dt4a9q9oRjVw5OJYymfl6Sdk8pN9cwJuD1yLasm
VZutaBn8Jf45ENmn8u0a1AS/gZbm2IfypXJWubsX/Qj3Ro6dekon3BV5Tnu6
4Yno/16JLuF9o2gy1zk1FvtO3a2Y7oXfZ6w71zmkXGpm7IvgHtQCDyf2tXJW
uTsWuVaU08pt5ahytZD5eviZ2L2+AD0V2wbZopy5DL4v4177FXoAbsm4l6uH
qZfVZPxvUI9Lw1UZr1WPVa99jTtX5NiHr8Kvo/Icjx2Ct8fO3TtRBzwbOXY1
+gnyfSpyLWqP9l7F2ABzlWhG7+WOw9iTJX6FxO/J2P9G/TP175zijbtS7gnq
DaVp58KQcgDOYU0Vaz9Gi+ENWZ+lHrlJ9ZV1rqomurK2UbYqBj2xbZAt+ocs
4rudO6pSrgHVQldiX8uGnsQ1olrRPzvB9itjv1U2yJZXOG9tcM2r9p+LXQvK
iT74ntixkg/ugo8l7qWqMdXaMlSTsg0j8LGM/3Xy0b/w3bHfqhq7V//6xL7Q
Hu3dF7m3KaeUW/8Bfb48cw==
               "]]}]}}, {{}, 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwV0TtPk1EAgOHjhAIqmAjRAXV0AEzULrgZYlwkaZxMVAI7LJTWCIm4kxBd
wAtVByMk1bb6tSWpItAJxdUfAQ1oq7aw+DA8eYdzcq4XRsbjY0dCCGlmW0OY
Y563POMlOT7yiYgCRTbZosoP/tLRFkJDT2tTz2gP1znPDW6RJM4Uj8jzmCJl
tvnKHjUutofwR3v1CjEmmCRLkogiNUo02OfqcfN4yBemWWODlhMhHOMO91hi
hAwfyPKbGn0n7ckkEUUa7JPigCYlCiRJ0E8vdWuMkmOZ99xnmLu0cpSKc61T
ZpUpUsS4TNOdrh2+BwMUyJEnQ4Lxw3tT8WaXdEPr/GKHKp9Z4TYRM0yT4gFD
3OSnfxzUc5yli246OcU/4zW+s8s33vCaV6RZJM8LFnjHc57wlP+cOWRM
               "]], 
              LineBox[CompressedData["
1:eJwN0LkuBAAQBuDZ1h6eYV01GhSOZ5A4anElgpYlrnVVVHgBnUThKHaXcm3i
Ddxewq7EHr7iy0z155/JzqyOryQiYpmTtogzLrmiRJEvPnjhnToNupIRWZr2
TnOCKfIccMwTFZ75ZSQVMcY6BUr80aDFYDpim132eCKZiUgzyzyL3HLPD1X6
2mWyQYESdZps0aLBA0U2ydFPLzUZS9xxwwJzZEhR0aNMnh2GGKCpc50HiuRY
Y5Rham6uUuaIQ/aZZpIeEnTQTdDyz1fe+OSbAo9cc8oF5/wDnXFHKQ==
               "]]}, "0.9`"], Annotation[#, 0.9, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwV0UsrJWAcwOGXhgVjbCyUoTQbdVxKSmbKelI2ToqyoaRJcS4spPgI8g00
dRzXXI5bJkKuKxTzBSYWFjg62M5j8fR7F2//3kt133DHUF4IYYrpohBSrLDP
Cf8444JnXsjxSllxCBV8pZlKfvCTYdpJMs4ckyyzxR0PVH02U6s1QgO/aCRG
gnmSrLBBlhx1JSG8fezVGCNsM8Yue+R/CaGAKF38ZpYe5ljkiSyRUucmzhoZ
cryR5J1XNlgnQYxaang2o5clUqSZoZtOCvnEgXP9YZMdRknQRD0NRHhxt+9k
SLNAijgDDNJPLUfe8Jse6iP37LJKlEUmGGGIOG208tdftuit3lBufa1XXJLl
nGPuOOWAVdLM8x85RVg3
               "]], 
              LineBox[CompressedData["
1:eJwN0LsuAwAUBuBTDYNbyxuYXDcshMTlCWyug8RAqAegaNK6SwzewCas7r2E
pfUWNokX0DL4hi/nn07+c3pWt+cyiYhY46o14oZr3njki2RbRBP99LFML/Ms
cMIpF9So88tUe8QMO+xRpECF6IgYY4I8hxxRI9UZ0cU6m9zzxDM/NBhJRWQ5
oEiZSOtJXk6aCSpyiRz7jDJM3Y4MLzywxQbdpPnQo8oxBSYZJ0lZ/xwlsuwy
yzR/7m5Q5ZIzzllkiSFWGGSAFpr59udP3nnljlv+Adk8N8M=
               "]]}, "0.8`"], Annotation[#, 0.8, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwN0TsrBVAAwPFzM8jzDrIoA+WZxEaRRzJIQrJYZNLlXiEGAx8EeQ7K+5Gy
uN+BEYW843oNFspv+PU/p06n8ygaGutNREIIcyQzQ7jllfSsEHKoJkoejTTT
SjsTTDPDCltccMQ1T+Rnh/CuBVpCOcPEWSbBBlvcs8MbH1TlWEsto4xzwDG/
hNwQOkijiz4WWWGNF14piYaQ0gqNEWebXT744p1vPtljhwQjVFJKGcW82WuA
debpp4dZZ+rUCH/GJxwySZwfd4ppDWWkzOt5pI5NllhlgVEGKSXpDQv1VJ+5
4ZIr9lmlh26maKOFBpo496dn1BjnkkHK/I4H/gG1uEn0
               "]], 
              LineBox[CompressedData["
1:eJwV0L1KgmEYBuDH+CxI+4GMcPQYAisI+oG0ua2pkubsDAq1KJeoTqYhpE/b
NKOtM4g6hCzpari47+l5ud9Srb53komIfdLpiA+SXESOkb4sjzjgjhv6DPll
zE4+osoZLZqkZGYiskyywTbX9BmyMBuxyBJ1HunwxIjyXMQqDS5I6ZHMu8mV
PiWzPOtdLmmyxgo/7pRIeeCUN28XZYFXfUCbTbZYJ2GCrh1tGpyzS4X438fA
/hduueeQY8p8+7+8fJdffPIHXm0wBA==
               "]]}, "0.7`"], Annotation[#, 0.7, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwV0E8rA2AcwPHHTfn3Amhsc6EkJ3KUpFhpF+I2s5nN5ux1KFvEwUybtaXc
vByrDeNKKXwcPn176unX8/yiqVKyOBBCKDE4FMIcSxyQ55wCJ9xSo0GbZ7qM
D4cwxS4xUmSocMQNNTq8Eh0Joa8zuk+OBkVaPPDJNyujIfzqmibY4pIrurwQ
HTOHaTIcUueeN94p8EGfJg1yZP/vmJHWOBF6zttcUybJOqfesao/+sUjbeo0
yZNmlhhxIvT8dZEqZS44I80Oe0wywZN9dmhRp8odm2xQ4Zgsy8yzwB/YpkAt

               "]], 
              LineBox[CompressedData["
1:eJwN0LFKggEUBtArZZlaOUVYi68QtVTQUDoUCvkINtVQWO+QSQUFugk+iTTo
rw1Fls+TdYbDB3f47uWWGjf161REnJPNRezQ4JIOPb6Zks5HLHBKlXvaDBkx
IbMaccwJjzzzyg8baxFFtmnyxpARv/xxuB5xQIuECZlCRI4V8mR5Nx/TJjhi
n7mOOxIG3LLFzP5NOZWfvPBEmQrLfLg/YUyLB2qcscgSX/4wo0+XKy7YY5d/
tnErGQ==
               "]]}, "0.6`"], Annotation[#, 0.6, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwV0EsrhFEYwPHHlsGOGaNQbtlaKcnGwkrZitc7MnYsfQsLC5cpIs2MjVI2
PogsLFxm3DeKUmPl9y5+/U9Pp9M5Z6i0tbjZFhEJ5Y6IPU644Y72XMSDNui1
LrDMCilrHHHKI81sT2fEq47oEuOsUqbGBd/8MtUV8aczOscu+1Ro8kKx23k6
oAklqtSzOR+88ck759RYJ2WQAv3keXbWAofsMM8s2+4xrS394ZI6G6R8Ze/W
Ufoo0jB7YpJjJhhjmIQe8lz7vyty1vd6yxkHVPgHYRw3qw==
               "]], 
              
              LineBox[{2920, 2971, 2958, 3032, 3079, 3087, 3153, 3152, 3148, 
               3212, 3275, 3273, 3337, 3341, 3400, 3401, 3470, 3475, 3474, 
               3542, 3541, 3613, 3700, 3703, 3704, 3782, 3785, 3792, 3901, 
               3905, 3978, 3980, 4041, 4043, 4110, 4112, 4109, 4113, 4111, 
               4044, 4042, 3981, 3979, 3906, 3902, 3844, 3783, 3784, 3778, 
               3701, 3702, 3614, 3548, 3540, 3481, 3476, 3471, 3402, 3403, 
               3338, 3339, 3274, 3277, 3211, 3151, 3155, 3154, 3090, 3080, 
               3033, 3026, 2974, 2973}]}, "0.5`"], 
            Annotation[#, 0.5, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwVz7tKggEUAODTGGYN2RJIBs2BIDg1NDcEUZR0Ax8gH6NBEMU0cFIqCHwa
CZdIf7pBJkSD7X0OH+dwOJzLZrlycLUQEfsMUxGLSxGrHFKiRosBbTq8MCab
jsixxTGXdHngmz4/zCgsR+xQpcENz7RJeGN9xU7O6XLHKx8kfPLOPT0uOCXL
2rzXjCYj9mhxzS5F/tzxyxdTHulR5mRe89OEDflITMizzRO31DnjiAwp0vwD
VGQxPA==
               "]], 
              LineBox[{3031, 3086, 3071, 3158, 3145, 3218, 3278, 3286, 3345, 
               3344, 3340, 3405, 3478, 3477, 3543, 3547, 3615, 3616, 3620, 
               3707, 3706, 3786, 3841, 3842, 3846, 3909, 3982, 3984, 4045, 
               4047, 4114, 4117, 3992, 4118, 4115, 4050, 4046, 3985, 3983, 
               3907, 3904, 3845, 3843, 3788, 3711, 3705, 3627, 3618, 3619, 
               3544, 3545, 3480, 3479, 3406, 3343, 3342, 3347, 3289, 3279, 
               3219, 3213, 3159, 3074, 3089, 3088}]}, "0.4`"], 
            Annotation[#, 0.4, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{3215, 3280, 3290, 3348, 3352, 3409, 3414, 3482, 3418, 
               3421, 3490, 3491, 3565, 3567, 3635, 3638, 3643, 3718, 3725, 
               3727, 3803, 3804, 3860, 3923, 3863, 3926, 3930, 3997, 3999, 
               4061, 4064, 3936, 4066, 4062, 4002, 3998, 3932, 3928, 3808, 
               3924, 3862, 3857, 3806, 3655, 3728, 3642, 3721, 3637, 3640, 
               3439, 3569, 3429, 3492, 3420, 3413, 3484, 3417, 3410, 3356, 
               3349, 3291, 3282, 3284}], 
              
              LineBox[{3217, 3285, 3272, 3350, 3407, 3411, 3404, 3486, 3552, 
               3551, 3546, 3622, 3623, 3710, 3789, 3787, 3847, 3848, 3911, 
               3916, 3912, 3986, 4048, 3988, 4116, 4120, 4051, 4121, 4119, 
               4052, 4049, 3910, 3908, 3913, 3914, 3852, 3849, 3791, 3790, 
               3709, 3626, 3624, 3550, 3549, 3553, 3487, 3399, 3412, 3408, 
               3351, 3346, 3288, 3287}]}, "0.3`"], 
            Annotation[#, 0.3, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{3483, 3554, 3561, 3629, 3633, 3713, 3717, 3794, 3720, 
               3724, 3799, 3801, 3858, 3920, 3922, 3993, 3995, 4057, 4059, 
               3927, 4060, 4058, 3996, 3994, 3925, 3921, 3859, 3798, 3800, 
               3651, 3647, 3795, 3722, 3714, 3634, 3630, 3564, 3555, 3556}], 
              LineBox[{3485, 3557, 3625, 3631, 3621, 3715, 3793, 3796, 3853, 
               3850, 3851, 3919, 3915, 3991, 3987, 4053, 4054, 4122, 4056, 
               4124, 4123, 4055, 3990, 3989, 3918, 3917, 3854, 3856, 3855, 
               3797, 3708, 3716, 3712, 3632, 3628, 3559, 3558}]}, "0.2`"], 
            Annotation[#, 0.2, "Tooltip"]& ], {}, {}, {}, {}}}], {
        DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
         Identity, Frame -> True, FrameLabel -> {{
            FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
            FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}}, {{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}}}, GridLinesStyle -> Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 300, 
         Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
         FormBox["\"(a)\"", TraditionalForm], PlotRange -> {{0, 1}, {0, 1}}, 
         PlotRangeClipping -> True, 
         PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
         Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"Markov\\nmachine \[Eta]\"", {FontFamily -> "Arial"}, 
                    Background -> Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0.20688222567667713`, 0.36271234759815396`, 
                    0.5951436716654596}}, {{0.35591182715545927`, 
                    0.42878690411214226`, 0.6098473603942348}}, {{
                    0.5211881914664742, 0.4868712493971635, 
                    0.5126880919174721}}, {{0.6864645557774894, 
                    0.5449555946821848, 0.4155288234407091}}, {{
                    0.8517409200885045, 0.6030399399672061, 
                    0.3183695549639462}}, {{0.9186928569328305, 
                    0.6667321423320764, 0.34794785649177473`}}, {{
                    0.9450948320623858, 0.7327370801559643, 
                    0.4297939793933957}}, {{0.9714968071919409, 
                    0.7987420179798521, 0.5116401022950166}}, {{1., 0.95, 
                    0.75}}}, {{
                    Rational[-15, 2], -150}, {
                    Rational[15, 2], 150}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], -150}, {
                    Rational[-15, 2], -150}, {
                    Rational[-15, 2], 150}, {
                    Rational[15, 2], 150}, {
                    Rational[15, 2], -150}}, {{
                    7.5, -150}, {-7.5, -150}, {-7.5, 150}, {7.5, 150}, {
                    7.5, -150}}]]}, {
                    CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -116.66666666666666`}, {
                    Rational[
                    15, 2], -116.66666666666666`}}, {{-7.5, \
-116.66666666666666`}, {7.5, -116.66666666666666`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -83.33333333333334}, {
                    Rational[
                    15, 2], -83.33333333333334}}, {{-7.5, \
-83.33333333333334}, {7.5, -83.33333333333334}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -50.}, {
                    Rational[15, 2], -50.}}, {{-7.5, -50.}, {7.5, -50.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -16.666666666666686`}, {
                    Rational[
                    15, 2], -16.666666666666686`}}, {{-7.5, \
-16.666666666666686`}, {7.5, -16.666666666666686`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 16.666666666666657`}, {
                    Rational[15, 2], 16.666666666666657`}}, {{-7.5, 
                    16.666666666666657`}, {7.5, 16.666666666666657`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 50.}, {
                    Rational[15, 2], 50.}}, {{-7.5, 50.}, {7.5, 50.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 83.33333333333331}, {
                    Rational[15, 2], 83.33333333333331}}, {{-7.5, 
                    83.33333333333331}, {7.5, 83.33333333333331}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 116.66666666666663`}, {
                    Rational[15, 2], 116.66666666666663`}}, {{-7.5, 
                    116.66666666666663`}, {7.5, 116.66666666666663`}}]]}}}, {
                    Antialiasing -> False, 
                    StyleBox[
                    
                    LineBox[{{7.499999999999999, -149.99999999999997`}, {
                    7.499999999999999, 149.99999999999997`}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.499999999999999, -116.66666666666666`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -116.66666666666666`}]}, {{
                    7.499999999999999, -83.33333333333333}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -83.33333333333333}]}, {{
                    7.499999999999999, -49.999999999999986`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -49.999999999999986`}]}, {{
                    7.499999999999999, -16.666666666666647`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -16.666666666666647`}]}, {{
                    7.499999999999999, 16.66666666666668}, 
                    Offset[{4., 0}, {7.499999999999999, 
                    16.66666666666668}]}, {{7.499999999999999, 50.}, 
                    Offset[{4., 0}, {7.499999999999999, 50.}]}, {{
                    7.499999999999999, 83.33333333333333}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    83.33333333333333}]}, {{7.499999999999999, 
                    116.66666666666669`}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    116.66666666666669`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["0.2`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -116.66666666666666`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.499999999999999, -83.33333333333333}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.4`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -49.999999999999986`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -16.666666666666647`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.6`", TraditionalForm], 
                    Offset[{7., 0.}, {7.499999999999999, 16.66666666666668}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.499999999999999, 50.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.8`", TraditionalForm], 
                    Offset[{7., 0.}, {7.499999999999999, 83.33333333333333}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.499999999999999, 
                    116.66666666666669`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 300}, BaseStyle -> {}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ),
           InterpretationFunction :> (RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"Blend", "[", 
                    RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                    "]"}], "&"}], ",", 
                   RowBox[{"{", 
                    
                    RowBox[{
                    "0.10574959362802852`", ",", "1.0526484478737583`"}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.1`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.2`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.3`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.4`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.5`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.6`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.7`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.8`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.9`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               
               RowBox[{
                "LegendLabel", "\[Rule]", "\"Markov\\nmachine \[Eta]\""}], 
               ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", "300"}], ",", 
               RowBox[{"Ticks", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.1`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.2`", ",", "0.2`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.3`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.4`", ",", "0.4`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.5`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.6`", ",", "0.6`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.7`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.8`", ",", "0.8`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.9`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )], 
     TemplateBox[{GraphicsBox[
        GraphicsComplexBox[CompressedData["
1:eJx0vXVc1Mv3P24HdjcWYnvt1hE7rsi164qK3d2BiY0tJoIrWIiEioC0CqgL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         "], {{{
            EdgeForm[], 
            RGBColor[0.148, 0.33, 0.54], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtkz1PlFEQhS/auJgrXCypKLBRotLYCNqQGA2gxohWGo0aLbQ1EdnVRfA3
uLCAxsUVC4yoEGwsZFdNJMYPbMz6ERMTQ6EJBWjhM5lTnJyZ+847d+bM3JZT
lw5fXBdCOAnWg9kYwrO6EB7DV+G74AoYxc/DY/ATMI89DZfh++CeYu2fSXCE
b0NwH/wlE8I3MAgq+E85X4Bfy34E70ge1w734F/j/ED0XNk6v2dS95SsnvoQ
CmAPeNEYQnVDCDfhDP8M8L0Z7uTbCNirOIvvAO/Uo/X6Esxiz8Bz0Xt5GL1/
i1lSDSX1txm/Hx6OnnsNFMX/ZC9QRyu9hOQxRdUwIk1uR+/T+t0JHyT+AvX3
wsOggp2FTxB3g/jj8FHpfwjeF12T3dHrszrfwr9BFbsGTyTvdxR+ox6r0bU2
zR/AXzOui2lidg3kwV/81XrXeFW6mV2W/qbHonbgFfwdVLA/R89r+W3O04pZ
1CxMA9uDdu1WC9wFrmPvh88lr+V08rOcduuX8v9UzRZjtRbxBzm/Fb0ui7fZ
b0v+vQ1uaPLZLEnvTtXQg77n0Tnf6HVXdI/N8NhG9hZMSP878IfkWnxMns9i
LPZs8pxn4BXpv6w8lsO03NTk9qfkuSxnIfqZ5bSY7arZai8oxuY/pN2wHXkv
Pe39Nah+62NG852SrlnNKBf97V7Wm+jXHk8p3vaippp/RN9L28/x6L6dr+gt
lpX3j7SymT/n7i32puGt0fXfBXdrLr3R37/ltN0vaX8GNNec/HG9kzH4P6xQ
t5o=
               "]], 
              PolygonBox[CompressedData["
1:eJwtkr0vg1EUh8/bGPqSy/taTR2IRMTHYsEmEYIQ8bEShIE/wEfRav0HBNV2
ZDOVsBi0xSQ+N0aLgY3Jc3I6PMnTe88993fu29jMythyRESaoQrigUgpKtLo
ixTxrBNJeCI7kMcbYAPfhBa8RE0TtWXO3OADrG2zl4QhfDewvSVI4S+hyG+1
yGSNSG29yIGzWj2zh+/Dlmd3ZvRuzixGLVM6sBqtPYUL/C20XlMQ0M/jd4I8
79CGdznLqmf68G6I4+vQic9S00OeQ8jjEUj6NtM192VC29PMz3gHfPhWo7WD
lbzasx//gjJegh982tnb6TwTeGto2fTOBbzA2olnPXR2Ce3tdQadJc3ammdv
7uMPcIVfwhNehAJ+Drf4aOV7ab9hfKTyvikYxz+dZdOM35rV2VntcY/fOeut
dzzir2T4I+sR5EJ7Y31rXavDz5x9C51BZ8mGVtsL8/hcaK5v1o7nnGXRTMd4
zNm3WNX/FP4PWbVb7w==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.3100051463403675, 0.41265356580651896`, 0.6368340353781865], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtldlLllEQxs9XYGrvye/1P4i6qWi7rstoscwWFdrMpe1KbyLqqrJIM1PT
Fv0wF4hQykpKxcK0XCotytI2W6gu8ipIsI2SfsPMxcMz7zkzc+bMzJl3dm7B
pvxpzrkKMB289s71R5wbhS+Aq8gx+HKScxNxzh2Ca/g+y3ozfC2iOi3gJCgC
O8G5wLkt8Ap0KsEZ5Ap4ivVdyFnIWaFz1YnObYdPRJ0biHeuGF7C93LWd8On
0L1pvk+Dtoiu5RjLehy+8uCI17U80230Gle9xSnydVAKckEJSGdvO5wGbzM/
4q8b7gF3RZc4PiQ4twi+yN4V1qrtrDaLrxhky71MLrHvXGP5TsVmK5wCfwV9
yE+8ntEV0TNzLH7xvcr0D5CzQs6fC44kaP7kDmVgHfnaS97WwuesLlKfaLJz
mTOpJzEPUrNrM6gpfAS9fvSPwkmmI7qF5lvuOYJeC/pP4QH05rB2GF7N93d6
4ECSQuT8JD1bYlgJN/Gdhu1zuM9rDj/B2cRxgZrWwv1RvcsDuMjiOQb3mL7Y
vcB+A36a4T3YxLCth1+yN4DOWzgFm33YroED7rCZu7xAZybyD/RHkCfhn4m6
J3dNBxmg03pbevy49V4h/AccJrZ52NZZ3zR4tdtstiL/StQzjiaovuSoIdT1
V6HGJLGlwn/Np/g+j68qfJ71GleG+a1g7TaoBO+s/3q99o/UWmoeCfU8B/8O
tFcmAu0P6ZNS+DM2vchj8D1wA/kOvNhsxUeTxSCxdGGzDbkVbrezboG96C0j
voXwl0Dj+BboPcTPe1Ab6Nu5Co+CHchDgb4NeSMdFovME+n1jkDfR3+g71ve
vtQ13WojuWu38+VdzUrW/Ly0OtZYLeeHev5O6ylZl/0OO7dV5o3XXFbBdWYf
j7/HFpPk6ZLNKJlVtebrGfzdemzc69tus5iGbV7J3Bpir5O1h17zJDGIfZnl
sN3mYI7NqF6rabfX9yB9/sZrD8UsF5lea7FF+t9rPwzC9y2OLq8+ZcZKrqei
+mb/weOB7n0MNNZSmznTQn3bS+F7UZVlbb3Xu2/0OoOkPs/h8ojOarlbgde+
LIdHvM6oYXjSZrjM8is2V+UtlZn9fvhZoHNvLNC6xuy9jIZaw4uh5rjP+kPm
svSqvLcFod5L7tcYam7zQv33yD/oIPzIa44H5CyrqdT2P6nADOc=
               "]], 
              PolygonBox[CompressedData["
1:eJwtlUlsVlUUx+8zBOj3vUu/B+xgU3HDoCAsNKEuJYJAmQnzVMAFARYuYCMF
jS1GyqRRkVksEMsUKFCQma9MiRTbggYZEhBJCCZCipBAwu+fcxa/5P/uPXc4
wz2vbPaiMQvfCCF8Bh3gQiGEt0pCWAFn0LOyEMpzIdzmezb699IQKjqFsAda
0dcZG58P4X9s2tBnfX1T5xC+QK8omP4EhqHPQS/ml8FLdAWkPj8KPRLmo/NQ
il7m9kW+q9GfF0zLRrYDM7ub7jgAvTuG8E0Swkn4Ff1uZr7IRrYjCnaWzszQ
P2GzD9s9sA09B5sf2GswzEcfZmw9cyegFT2DsVslNl+p84jBKGLxpGMIdeg/
GJuQt5h06Wo+6TzF4Et0C/NjmRsHkfln7NkOj+FfR/oJPIVNmcVWd9qGHuLx
UQyq0L9hc4y7rYFf0J3Zsz1nZ6To3pnFWnfug36ITRO2RXiEfgB/+x10l37u
33Loj77J2Dlsz8M/6Ltwx9c88DvqrvfgPsz1etkA89BHGVuX2B1b0K+4c1WJ
1YhqZTRjk5ibAhOUO4/3Wljne2rvW3Bb8UmpQ+YqoR29g7Ea9H44gw6Z3V01
08T+b2eWK/kk3zZgU4/tXtiMHgQDoQzehEQ1wNwseMH+dXx/ldgZOqsf9IX3
4H0YCh9BOXyg+oBp2FbDj+jV0XKjGKxVrFLbewY8RBdhOnomNKOPRas1xWCX
7srY1MRsjqC3R/NV99mI/lRnoFfBYvTEaLZaMw7d4O9B5ysX+6PFVvurtm8Q
k+c5q9lS6qXI2KHEfK5zH+XrhzBEvvh6nVmL3pJZrrXHVvSV1PxXPk+gh2Pz
scdIsbqZmq/K4T30csaqYAksjVbDilctHPKclLmNbCui+TYZRkTzWb4rZ1Oi
xaTG46VYfJ2ardZsVKyj1Y72X+A5K/caUC284/1ENdo3M5taf1+LlBs4mFiM
FKsclEAP6Km3kVpuFYM29EHPTyNc0duDw+gGuIBu5YxnxO57uJaZzzpPNpfQ
f8Jp9Cn4K1pPU2/T2Gl0M2u+y9mb34xui/a29Wab0aeirVVNqbaOe/2o552M
xj6v15/RbfSwvZ2sp7Wga7x/670W0TuxWZlYDM4qJ96P9d7U2w8oh4m9sUb0
1VL7V6ifF5i/4fdXTao2p2bmu3qG/jV6M9V+P/VmxajB67s+2h557//D0eu9
v2i/b5V7rfecKDf1Xh/KgXKhnqveq5jn0QdSq1X1oB2pxUDny0f52h26+Z41
nuMe3gPUCyZFW6986+1fjtbrlO+r6IX4/19H+2fuQm+J9q9RjDZFs2n0fqe3
uTVab1KO9NYv+rz2VK+/5v1BMVQsK72/qQZm6v8crVerx1+P9o/Tv045vcz5
rwFM8ytR
               "]], 
              
              PolygonBox[{{3398, 3397, 3402, 346, 3399}, {3546, 454, 3569, 
               3551, 3552}, {3550, 3549, 3563, 453, 3544}, {3396, 345, 3406, 
               3403, 3404}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.4291915714254163, 0.4545401688715521, 0.5667691720694039], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJw1lUtslVUQx8/VSG/be7znc6kLrY/4IHGngolUUUtKQCOGSASE1t4+KL23
VCDRQKNGXbjwAZSW1lYslEc0Gli4QKW0xYVNECyglBLiRlHDwkQXPhN/k/+4
mPzON985c2bOmZlT11xZUb4mhPApci1yMIZwJBfCGNyEfMD4qxRCTT6EPNKK
rM1CeKAmhAH4Mv+m0DXAn64P4cJ1IVyBVTeE8DtzZpjzeNLaCAvon6rlG0Zk
BeOzzNleHcLNSB1S7XNG0Z9GfsPOPHT9rD+FP/vQfY3sRj8EZ+0b/d9Rfn5U
pf0uuz/m14PMvYTtBfBF7Ezw/yVnKa8YdhRCWIydq3C/2zTbt7LuFqQXKfGv
Hv3qgtaYz2bjRNJ4HHb4WrPxT1JMU3APugmkH/kVX/fCX+DGnPbdgFzgexhe
hlvhSE7zTLcFed/nPuzz7b/N22w+saYEu+FKpMz4WfgQbMvpn61r97XvIT3I
oI9H3E4XUnE/O5EO5BGLB1tH4YEoe/X+by3f3bApan2P2+t0W33IUE7xb0K+
j9rrIuyJiqsr6n/F57S5rY6o/WzfL6N8qritxmIIO+cxD85VKydn4TR3s4j/
DfDNgnzvhZN53ePJvHLacvtjbDYgqxgviPLD/NkAn4+KpQSXsMf97HUTXM+9
LmSvFjg/U17da7XAHs/Y+Re0t/nwpO2blEP/wqaC7qALnkzy5zh8Pcm/bUk1
ZmPzs7Gg+1sMp4vK7yzpn601uysL8r/NYvVYTFfDvCrmPQprvdas5ixv67ze
3vCct9zfgv1dxLi0qPj6anSm7Znq7q+o+rF4LyJH+R5F/6ftmUl3Jxxl/RPU
4EE4hixnvL+oGrd7sjuy2rWaNHt7MnE1bM6kb/Iztv3n3K7ZvyNTHdrY/PgQ
29V5xdnia9Zl0pVcP5gpllOZeofFYjE1+V5rYK2flZ3Zjfh6H+dQhLdn8veu
TDFYLHvhuaL2noH3ZPLxbjji/eoM/CZTDzwHl/i9WK7d5jbN9pDn+wvIce+9
n8F9foZ2lgPoJr1OT/BvN/w8KicsN6ZgY1TuLfN6r/eaP1tUPzwPlyWdS4IH
3P5h2BLlQzOc8FqzWq8grYw3RomNn4vqs9bfrM+95b3gHdgeFUcrXB9Vp2ui
8tXydnnSG2C9uZDUO+q9t6yK6hVPR8VgsTwGf47qeVd9f+tdi1zavZ8d8nsp
F9UjzP8v4A/0/e/o/3Nw3Mem6/Y6XcicP/yNs7dum9fgdtgX1SN3wh+9h1gv
GfM7sruaTsp/q4PkZ3saHz7xurD/S71WX02qH8s9e8cm3Y69t2Xv9Vuj3gmr
zVeS7tju+jB8Nyret+Fr3k+sr3R7z98Mv43quzPejwe9F9t4wL8vRb1Bs37e
/d6fz0Tl4nl4JSrf5qLW2Xp7S3ZE3dku75HDnrfHomyMw06Ppezvj71tFsMh
n3PMYxpwm/+/wb1Jtob9rfgP7X8k8g==
               "]], 
              PolygonBox[CompressedData["
1:eJwtlVlsVVUUhvclQHtv7/ae0+gLahQaEwf0xdkEFCdSEIcSEyKgUC0IAhXE
Gkgg0qjRRJygFykFFTQBpRh4kcQUaIs+IMOtUATaICphSAg1MmhR0e/PWg9f
8p89rLP22mutPbS2vmbOgBBCIwyEvhjCWTgH52EqvJwJYR48j54E9ejZMAG9
Oh9CC2yEVniHsbchBxVwFVzpY5rrZU0P/AbH4SJcgMvwHyyFd92mbO+GH6AN
tsEZbHzCvz+Dv9BdBf5dFsLjsA69D7LlIXzF9wF0qWC6jLGKJIRf2dPO3pWw
G/2jz4+D9egxsHxwCHfBaPQy1sxk7YvwIXoxNtqxdV02hB2JnUFnOQt9cC1r
roHhcCscgTXsbYGD6G3suZ69Hdh4E72TsY+ZK8IO9IZoepZ8RA+ADPRj+xLc
gb4dhkGV/GFsFGvvhzp0AZ/vxPdlUI2ez5o65qbDe+hfoCNj/9S/96ch1FSE
8BTkK+2f+rfO3IRego9D8bcTf19HN8pn9DDG3kB/zz+/gxJ0wWjG6sotRguk
o+XOfPmA3g5N6BXQid7Knm/chmxtgc3wOXwB2xOL9SLoRz+amC/6x1j0k9h4
KWMxOMH6Y/AzdMNB+CDa2WfAR+gaP98ceBq9KVouKae+VN6z5w84BaeVb/Cg
34f29vldX/DcHcjYNOZGwi6+n8ibfgCmok8w/2nGcuAYenbe5mTzLXQ/Y2sz
tuZ39PJovupMRXQtzM1YzU2JVmMbPWZbPeYlrynV1trU7lJ3muM+W/huyoVw
L0xJrSZznqPK1UbdMSyAhdDj+aEaUa2UwWDPQeXiosRydxo8jJ7J2KusfUU1
gv6bscVZy/Gd6NfwqcFreqnncL/HWLEe6/mimn0ssZif8jvUXXZ7feeY34W+
umC1eWhQCEevsBxRrjRBEW7gjEey5oN8uZRY7iiH/0FXJ+a7cngMeo/H5xzs
Q//JGS56D1Qv7OEfPw2ymhpSsBxRrujM89AH2HM+Z/GuIN7djK1ibjUcUuwq
zbbuJIueEa0WGnTH6H8TqyX5ezmxnqTeJBsl9adovaMZ9qCPRrMtH45Hq6EV
fl+96IZotpVPrdrv/hVhL7qUmj86s3Kj1fNTOfi1ehFjd/t8M/rZ1PbKRhe6
vNLOIhtrUssxnV3zZejbGOvlLPfxXZvamXQ2jd2SWs4o/uXwiHS03FGOv4B+
KLFerZxQL5nInntydqcT0G2s2cLazdARrca7/Y3QW7HK/dWelehOxkZkrAcm
0XqI8uEwVDG/oWBvh3JsP3oka0Z4j1WvvYk1Pd5/lEvjo719qk/1nqL3H/W0
9eh8YmeTPb1NVd6rl3itPZdaLcrmzehJqcVKPivW70d7a9RT6tGH/b1STap3
T8xbr9eZqv1NbPOeqd45LrFaUYyV689E63V6wydHy6Fmt3dSd1+wt09voN7K
G1OLjXJgMvrbaLFWzNvR/wP1yDWu
               "]], 
              
              PolygonBox[{{3572, 3571, 3556, 415, 3561}, {3962, 3961, 3960, 
               1684, 3957}, {3327, 3326, 3422, 358, 3332}, {3385, 343, 3401, 
               3389, 3390}, {3959, 3958, 3950, 1869, 4005}, {3344, 357, 3419, 
               3334, 3335}, {3175, 344, 3399, 3190, 3191}, {3956, 1683, 3912, 
               3958, 3959}, {3373, 3372, 3384, 344, 3393}, {3562, 416, 3558, 
               3574, 3575}, {4007, 1870, 4006, 3961, 3962}, {3222, 3221, 3396,
                343, 3200}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.5483779965104651, 0.4964267719365852, 0.49670430876062116`], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJw1VltsVVUQ3Zf7vpxzz9lXLUKLxiih31AQoyZCq+VV2kDQipJIqS8w1ndp
ffxBgtEPsL7RFhALTdRvFaQ+PmxvqY+YlIf2p1ijgm2JCkQLrpU1fkzW7Nkz
s2fPzJ5zrmtpW/voDOfcMCgJmpt37llQB6in4FwdaBloVuTcwoxzFcAjReeq
0s51A0c9jGY6dwqYLDk3Cd0h8JcKku8DHoDNBGzbgauyzp3NaP0HaBK0G/RY
pPWTwN2wWQyqAT0eSb8NuB5+F0J2N/AycBq0F/STrU/auZRzfcmQcfxocTLe
04i7E/F/XpR9N6gW1Ou1PuDlg/ZDCcmmTa8JPtaAGkFTWDcAJwrKBXPyblGy
RtMrlGSzz0vWYHbtlpOnIuWox86btLysziomnrm0IJ0601sEXz+jPmkvH8zP
roz0KKfdF4FztyD2BcDTkL2XUB1ToeSXIW8FvwL8A8CzgfhfgFuxXg3+YeBG
0B3gNwCbQLXg1wGzoJvBx6HO5NljwEXAXQXV6VWvGm4Afot7HsKdeoDNXvW9
B9htdWf9GSdjHM/rruO27rJ+YF+86bV+G/iKncUzh7E+B/zekDrsxde8dAaA
b5nNG8AnEHc74u8D5rzOWsy64/6rIL8A7EctO1DTMeCg1/mve+lRf4mXjw7Q
dqw/gK9t4J8BDgIHQGX6CpWfM6Huw70hO5v2HwLLsXPV8NEcy4b71PvIfNJ3
BjFVgk8Ap6BXBf1PgC+BBnLO7QRu9MpHNXB+XnExvl9DxfMn/XjJk8Br4asK
8iQwX1KPZoAFk88LtEeespsC1b0GeIPFw7hutJ5kb57Euh7yHwK9VfZCF7AO
8bUizudj3YG2VcAU9nbANuvVK+yZO4Flr7c1g3PFcncxVH6m7W1eCV+NwJFI
9e6yPtkO+TXw+RkwB5s10FmCszz4BvBp4Pte7+qg9cWE9dOU8ZRl7f3yHa+I
9M6iSG+bcvbaOes1yr7xsj8G3OrVx23AB3HeSpx7P7AZdDv4e4H3hcpVC/D3
QDpTgd4Z80O9h0L15JZQdahL6E0ext0qcccjwHGz4Rv9N9D7dexDmwN89+tD
2a4NReTPYH8z+OXgNwFTJc2oREk9W7Y+XmB+bgU+4jVjtnj1H/vwU2A9aDPq
Wwu8CjmqQa5mR5JtAqVBnZFmXG+kXqTvCebDeoM9ssPmFefB31h3As8Dz9u7
+g34FdbPQf6P1ZkxUG+nvYU55i8DaslJh/u0iW12fcnehl4S+zngX7G+exeA
3yG+PsyrAPzFWN/Eo5bvozl9J6nLNfmc+cnGmt0Hs7Lfb7OBs5Ex9OcUawX0
mrA3C1gEpSDPG7ZY3BX2zS1FyklnQrNgtuX26kjfRc7/d4CjRckrI53Tar5e
hN9B4MvAZbFqsTTWPcizPttgW4lZt4czz+rIeu4xeVdReZ1v86Q+0nd7ZaTZ
fDyvd8s4qy3WMfsuMAc8nzLuHbc6sB5PWz+wL45FytswcI7d/VRRfcM4md/l
se50W6za08889OFcuyPvelesOL8G7rc6sp5lUC/4IeD1XjVlbdPmm3v/1yAF
PBHoXYwGmnfsmcOB9Pgfw+9Zf6z6vwD82PqD7/JEpPqyztRLm3/eL2X1nWl7
/DZeYXOM84zzcsS+pX1mQ/0R6znG/R+9MT/4
               "]], 
              PolygonBox[CompressedData["
1:eJwtlllslkUUhqd7+//f1//7atCEFowBhBu9oSh4odLSAoUCYsBGIJGygy2g
Yhe0igaMKCYUBJewlkWJYgI3EgPUhKBdwNgYEQSjETSg2FaUVhDxeXPm4kne
mTkzc2bOmeWe6uXTa9Odcx9BJiyPnRuXcG437EM3Rc4NynPueK5zjehhgXNF
ac6VQxt6Z8q5D3OcmwR70MPo8wL238FwdAV1zdnO9cAq9KOMUc1YmZCPbsNm
I3N1Qwd6oOpoa2D8x9At1O2g7RZsVRusZewW2leGzoWUs7GfD2WR9VHfOkH7
WMpzc83/OvT3jOeSzt1mvAvobfh0Ndv834X+ILa1y+Y8+hT0Ut4E72ltjNHK
WIPxYS26k7oe2pqhHT0UztC2Goagq7AZgV4HmZQX4FMFvk2AeejtzDmZuf/A
hx3o56AbvREmopdiMwnbSqhBZzHGJcb6GUbKV5iGr1Mhr8C5Lsp/Jqwuh/L7
lDcnrO40OrvAbLWmryh3Msd+5s9gTRn4+rv2jLY25ruMPovNf5R3wh704tja
FRPF5i76TMN2CqzC/h8okS3lQ+hjke2VcuIE+mBosVEMFcslsdl3UneTtjP4
M9WvN6bcHtne1VP+hPJpxSjH9kx7VxBaWyNMx3YW4z2QsDW/G5sP8kVjaKzb
kcVnJO0zaN9AuT3XYtSBPgqF6Ab4O7I1aW2aQ3P1UddIWxH0opcyRmnCYvIg
ejT8kmdnaFlsOafc05hH0KUwj3IWJNA5sfl2EYrRv3KmJjLXeDgX2JlTf/Vp
QGcRvylJy7kMdL3PR52pCeg06iqTZiPbrbHlZjG8jf4sMt/VR317A8vHyfAv
egQ2oxK2R8rlK4pBmsWoJzSf5bvOfBKdXmBnV3Nmom9g05FmOaJc+RKb4Xl2
pt9EZ0Z29hXDU8RvZmy+6b64F30AH8al2R1zNzojtlzRGE8o16ibCnOhGo5H
dtZ0R7Winw0td5RDd8hXX9YZuoX96MDiqZw9y/w9lLvhOvTBYOwHwX1wP/xE
3Y/wLZyBHwI7u9qz39BLQts7lRf5Puo7VucALmFz0c+huR6h7mEohlFwgbrz
3ka2j1NXylhlUIXuD8x35cRV9EpYAWNoeyi0O1Z7p5yvQt9J3QB4HdZ7pJMQ
wGH6HoK9sC8wH+TLEBgKW6nbAi/DmsD6JP2eaG+cX6/2MBf9TWC5Kn9PoBfD
IqiDenjen0/Z16JnUjfD28i2xO+V6tTWBV/7PdHevAbroBk2wU24AdfgLx8T
xaYTTskXKPc5olw5Dsf8mg/7nFHu1ECtp8bPoblq/XnXGpehr1B32eeAcqE6
tPUqHvNDm7PTz6G5XqXuFWiE1aG9QXX+PlNuPhna26kcn4HOgPTQ1nTTr+ma
n1NzLwxtLuXAYvTc0PJPY8zxMRvi59Tc+3xsFUPFUjFRbAphaGA5M8bnoHKx
zL/PxTAAXaH7R3GB0sDeRL2NeiM60JvzGSuLuwha8+3O1t2tN0JvxUL6LIBZ
MBs+x6YR2yI4mm93nO463ZG56PKUvXV6g1ei36DPemiClwJ741v8fdKP7g7t
bdKd1Ifeyxi7EnYHPx3bH0F/Bd1Buov0Juht0B0/KLI7RudFd/h13Rcpe3u1
B9qLFyP7S+h+1Fuf8v6NhIF6b1KmVSff1/izssKfzcKU7aXGG5+yP5H2T2/6
XnRRYLHQGW/R+WKOAzn2h9Ffpt6fnQ3wVmBvrt5e3b96Kw9S9zF8Ckc80ifh
C89Jf4a6/Bgaaxts93va5GOkWM0OLT+U00+h96fsr6b3dXfKYjjL54Ry453Y
/kJ6I+agcyL7O+iPVRLZH6XS/7+eCW0MjaU1tqD7I3tb9b7oLdYfRn8Z3fHZ
+qvE9jbrT7gFfS62v5pivD+2NWzze6C90B+03P+nzqL/B77UcSw=
               "]], 
              
              PolygonBox[{{3139, 3138, 3267, 315, 3129}, {3133, 316, 3274, 
               3142, 3143}, {3319, 3318, 3327, 316, 3266}, {3811, 1401, 3775, 
               3813, 3814}, {3864, 1588, 3806, 3816, 3817}, {3219, 3218, 3308,
                324, 3242}, {3817, 3816, 3815, 1402, 3812}, {3260, 315, 3335, 
               3330, 3331}, {3814, 3813, 3803, 1587, 3863}, {3235, 323, 3302, 
               3210, 3211}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.667564421595514, 0.5383133750016184, 0.42663944545183846`], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtlllsVlUQx2/39vtuv3tu1bRUkFKBBDEqaMIiMYARCuIDRZBoBOKDiSxl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               "]], 
              PolygonBox[CompressedData["
1:eJwtlllsV0UUh6fbf2nvv/fespSirAIRcaPKUhSBVm1ZTKRsakQIvojsRaEI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               "]], 
              
              PolygonBox[{{3083, 3082, 3109, 286, 3086}, {3171, 3170, 3182, 
               280, 3092}, {3738, 1213, 3704, 3740, 3741}, {3088, 279, 3174, 
               3164, 3165}, {3085, 285, 3108, 3078, 3079}, {3125, 3124, 3260, 
               313, 3121}, {3118, 314, 3266, 3122, 3123}, {3074, 3073, 3100, 
               281, 3068}, {3071, 282, 3103, 3075, 3076}, {3774, 1400, 3773, 
               3743, 3744}, {3744, 3743, 3742, 1214, 3739}, {3234, 311, 3306, 
               3297, 3298}, {3741, 3740, 3732, 1399, 3772}, {3283, 3282, 3293,
                312, 3243}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.7867508466805627, 0.5801999780666514, 0.3565745821430558], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNl2uwV2UVxjcnz4Wz//z3foED3gowxy4Ih6ZRAgTkIlpSyrXJsA/1oZpJ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               "]], 
              PolygonBox[CompressedData["
1:eJwtl1dwVVUUhjdobnJzb865h45SEhxxFDSZcRwgFAUFURCkqsCTLwpKSQIo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               "]], 
              PolygonBox[CompressedData["
1:eJwt0M9uQUEUx/FDalVXEBVJo1i0SWmFhbuopa1VE//Fog9AUtU+g70nsPUG
eABJG40GQdq0T0BVsfWdmMUnv5M5c8/M3NBD7b5qFREvbGjaRRIWkRk5xDtC
CKKte+ekwEUdJyO4gQ8max3SjwtcGyIZ1kzyElcIq3VE4aZnIz9ORUb4xJbx
b2Sa9Sz9FN/kqPNwUBsIGMdejJywd4xvLHjEjKyz9xFJfX6F+sUh0j8ReSZL
KKOAPBro0Xsih3y/4w4/eq6a/48N9vil90pOMee8L3139Yaynl2ElXm35B/r
azi5wxl3WVKv4KX22I9z1fwedRcD/R9bqlZ7OW+nZ6hZUWZamH2n767ecADV
/Dw+
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9009484459689475, 0.6223711149223689, 0.2929401825037374], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtWHeUV8UZfTHs7m/39/O9N4sisVCihnKI51joZRFIOYcIhCIiJTnpibAL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               "]], 
              PolygonBox[CompressedData["
1:eJwtl3mQVtURxV9UZpj5hnvfw9KoUYSgDFDGilFcUBaVLFUuIGAYFTCVXVEU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               "]], 
              
              PolygonBox[{{3064, 269, 3099, 3093, 3094}, {3595, 837, 3601, 
               3616, 3617}, {3094, 3093, 3209, 307, 3087}, {3084, 308, 3220, 
               3090, 3091}, {3620, 3619, 3618, 838, 3615}, {3006, 233, 3046, 
               3043, 3044}, {3035, 3034, 3047, 234, 3009}, {3640, 1024, 3606, 
               3619, 3620}, {3091, 3090, 3096, 270, 3067}, {3617, 3616, 3639, 
               1023, 3638}, {3233, 3232, 3248, 308, 3208}, {3197, 307, 3265, 
               3253, 3254}, {3044, 3043, 3072, 271, 3038}, {3031, 272, 3077, 
               3034, 3035}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9199878109985081, 0.6699695274962701, 0.351962214095375], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNWXecFdUZfcCysG9278xgF6J0iR2UjhEFe6WqKB2WpgIaC22BBcGK0oso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               "]], 
              PolygonBox[CompressedData["
1:eJwtmGeYVdUVhjfOcJmZM5xzD5YYG6KCGE0oCmIgAQRLoqh0G23oRbBgImVg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               "]], 
              
              PolygonBox[{{3172, 305, 3241, 3226, 3227}, {3156, 3155, 3370, 
               339, 3141}, {3131, 340, 3377, 3136, 3137}, {3600, 836, 3599, 
               3591, 3592}, {3354, 3353, 3469, 340, 3368}, {3360, 339, 3462, 
               3454, 3455}, {3592, 3591, 3590, 650, 3581}, {3587, 649, 3582, 
               3588, 3589}, {3589, 3588, 3586, 835, 3598}, {3196, 3195, 3217, 
               306, 3183}}]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.95, 0.75], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxdnXWY1dXWgGfmzJk4gxMqICLYorSgiC0iigJ2IkgJJmF3oyIg2B1Xvaio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               "]], 
              PolygonBox[CompressedData["
1:eJwllmlsVkUUhqf069fllvvdG0HAHROlUKCFEhMXUNCWsmobEwVEoKWUHfcl
siO0rAqYGAOJBsPWBEQTyvqHauISE9dEjbK4+0OkEBE3wOf1/fHme765M2dm
zpw5Z3o3LKif3yWE8BrKoAFJCG8XhtC7KIQK+OkohLm0v4QWwaPTEG4oCWEx
eh5+irY5fJuHnoGfRfODx2hsiEPozwStKA8eXxrCwDza0HB4Nn3G020smgGv
p09JAYz2wd2ZY0txCH+hGngVbe+x0NloNPwYY+oZex96BD6CTsFF2D8PT2eO
CrgQXeL/Zcb8gu016CKcj35kbS3octcQpmqPjK9FD8PLIu99E1oMb0CH4I1o
OdwlF8KubAg70CD4LOrAf9PRGXgCGsm37WgSvIUxB4JtbItsQ7Y2o1Xwp7H3
3oE+gys5gxs5i3ewNxBeh40CuBEdhF9EX2J7CP83wSfpM7TYPuuWeozGak19
4Dz67Mzaxlq4Mue1qU3fttPnBPMtRdvgQaiTvmP5XwXfjz/L8eUANBVez5hs
oX0gX0xEtXANeoP1z6VPZZ7PfCI8le8Ls15zA3wOHSt0zCn2DuXsO9ncAHdG
PruT+KcDbmVPt/F7KzoHv8zvweAzb4ebsLGbtY5BgxP75H/foMOynXhv8mkD
fDpnX2oNnfBM2tr4VoT/2uDvUCNciPbAv9PnDH03oiPwk6X2hWJsJTyBNVSz
lpFoErw5575VGgMvoO1evtWhR+Fpie/aEtQIv0Lb4eA9aW9N+PB9Yr0P8bAn
tg3Z+gL/vQAPpm1rfgh/oip4LSpWX8ashj9Brfzvhz6CH4oc2zVoou5H5Lun
mG+Ah9JnO7Z2omHwEPQHXI+9OvgoPv+mxGdwFp7D77jgPc2Dv2IPp4ocQ8fh
MYxpYe7V6B+4GhVhqw2b/eBvE/t6OvpeY9GwYtuQreH02UXfHWgEvDvxWeiM
mxPvSXsrQ62xbcq2xpTBBfjouqxjbjA8iLbzfLuAxsKBtuqs76juahN7GBO8
p5nw5MhnOQpN0XlFZvVphK/CxhZs3Yl6wHcQA33zfEeq4VtQP7gelZFfbi91
7lObvmWZ8znmvhZl4EP49Gv8uwithPdj8xh7a0Jvwfsj3wXlEOWSi5Fzne7Y
AuwtTp0rH2D8UuVq5qzL85q0thWpbV+PRqW+I7oriukLzN+NOUbmOwZugvvK
53AhZ3aPchP6IOMc3AavQXszztnr4J6pbR9jDT3gXrTdle8Y7ancjmrznbOf
kG/p8zd9t6JqeFrOsS2fTIH3xj5bzam5J+eca5VjlGtWpa5FisnD8G76vJvx
ndHd6a85M465GrhP7NjWnrS3ytixoDOs0FzY/LnAMTEAvoa2Efneg/aiGFYs
q88l+EP5qMAx/jF8c+xY1R67xz5Tna3O8HP+vxn7LHVHN8DLWfMV+KEbOpM6
hhRLw9HV8K+KgRL3+S11zVLt0p1uhpsj117lHOWe+ZFroWrqXLgldu7QGrVW
1WDV4p/QRWLjh8RnpRynXKcaqFpYjv6FH4+cqxQTxYx9NXGuOo5eT1yDVYtn
ouVwufIP3IymwQsj1za9EfRWOJpzLlZNOQ9X5FwrVJPLlYtj29KZ6exGoVkZ
n+kKxX/q2JZPDsCdqWuB7swR5SbWdLLINfAEvCz2WmRDtu6OHctao9baizEd
xX7T1KbOQcpFatsHj4udW5UDlQuT2L5TTJTCV6aOXeWsXYlzqnKr3kCz9H7g
+4MljvElcNfYZ6s3R6z3R861XjlKuWpW7FyrOzVHsZrY19qT9qYarFqsGjUD
nh0719fpDOCDzNFe4jnbU8eUYkttp+HxsfsqByoX6k2jt41qzkb4P0tWQFo=

               "]]}]}}, {{}, 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwV07tLFVAcB/BjW+8CbXCqobxmpi0tWmClUUFDROE1877USvPa+2XavaZp
D6EpwkHQoqc2aYZbc2BtCb3+gEwLCiS0Pg4fvpzlxzk/vmdDIn2oJSeEMEn+
yhAibF8RQhkVHCRKM22kmV8ewm8mGOMBDxngPu1k6OQ6l7jCNU4S5RjHiZEg
RQOnaKaFVs5ynmWrQshjE7uoIMJmKolRxRaSpMiyn266eE4DI7ykh0k+MEcj
8/yjaHUIJRzllXNU1nKbbSzhHn28YYafFK0JoYCtlJIgxSCPecRnpvjGU9at
9Qb20kGGMcaZZoYsP/jOa0a5QTtV5JHLV/O+8IknfGSIAZLEKaGYX+5bKGfl
NOPc5Q45lNJLDdUEjlBMhAV7+csB/vCed9ziBcPU84ybdLKPDAnii3tmN3Xs
oZACdrKDjeSylHN6cIY0p2niBPUkiVNHLTVU08hVLnORNnrpJksfQwzSzyhv
mWVhsZf63k8XF4hxmErKWe+/dPAftUJvyQ==
               "]], 
              LineBox[CompressedData["
1:eJwV0UkuA2AYBuC/qYqFVq3amhInoMMhEPMF0ARFcAhDzOMpTElJLLQ9BS5g
OICZBeGxePLuvrxvvs7i4uhCJIQwz3c8hF+iiRBiJIjTTispWuiimyH6yTJI
iVnW2WSHcy645Ja6phDqyTPGBLvsc0iVNz74JJcMYZJpjjjhjHseSTWHkKaX
JVa4osoTL6zxyjM1KqyyTB89ZCi798AdpxxTYoo8Wb50eqdGhQP2KDJO4b8z
MaLc2HxNmW222GCOGUYoMMAweXKkydBGB40kaeDHjyIy8AfEJzn2
               "]]}, "0.9`"], Annotation[#, 0.9, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwV0EkuAwAUBuBHxBhq2CERiSNoVSwcAJua9qgE1XIKQWIOtyDUtlWHMFyA
YG2IMb4uvt2fl/9//XOFTL4mIrL8tUbUtUXU0kkL/aRIMsUka2TIscouexxy
yQ13NCQimkiSZp5RFjmiRIVPvvmpZtsjlljhlHMeeOKZ7o6IXsbZYIsSV7zy
zg4fvFGhzDabTDBGD0X3XnjkgjNyLJNikF+dvrimzAlZRlhgiBTNNHJv9y1F
jtnngDwFZllnhmmGSTNAH10kqr+jnn92KThw
               "]], 
              LineBox[CompressedData["
1:eJwN0stLFFAUwOHrLtGcTAjaBGVmiQj9BQoFtnGTBQU5RtugNrqw0RScVELJ
NykmTakV2UMdFTeCUPkIM+khJbSSKI0iEhRr0bf4+O0uh3PPwUtXT19JCSFM
sX93CC1EOE5RegglnOcyMdpI0MQu0snib1oIsyzylhVWmWGYpzxnlCQJWmil
gy5u08ddmqijkUqKMkKIUkctpxjgPkM85CVzzPOb12zyhuxICNt6RP/pGc3j
HAU0EifKOJN8ZYPsPSH81BzNJ8pFeuhniY+8Z5Uh9maamZNco5pRknxngxrW
+cYYI8So4gRZZPLZeysk+MAyfXRTThlHOcwPcx7QdV1jgiQXqKeBfM5yjFJ2
7CNHt/SQLuofFvjFK2Z5wQMGuUeCYqqJUUYhN/3XDWqJ008v3XTSzi2aucMY
IzzjCY+ZZo0vfOIdS2yzz71FSKWGCR7RS5wKyiklzx3n0sB1/gOYJXM5
               "]]}, "0.8`"], Annotation[#, 0.8, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwNz7suAwAYhuHfjNLFRqi5XUsPJrNDtyamLrpoQyUGt1AhklbrOhwn6cFF
aJgNIowOCX2GZ33zfUuVeqk2ERFlkomIRbLkyVDmkAM6tLjhnidGTM5ETLPK
GkV2adHlkj6P/JGdjcixR519rnjjnQ/mkxEbbNHklB4DvvjhnF++GdLnjBO2
2WSBY71PXrmmSIMaeVb4t2vAkAc6tKmyToEcCaZ49vuFW+64oEuDI3ZIU2CO
ZVKMAU3cNFQ=
               "]], 
              LineBox[CompressedData["
1:eJwV0jtIFVAcwOHT4KRdLQgEH3kplKTBOSixNdG8Uy8cHBty0DCEa1kISg0F
CtrkYKVFdTUiH0VZGqX2wDDEQcGbXvNViO5+d/j4wYFzOOfPidbVx64dCCE8
I/dgCPeIUEZ5VgiVXOAqzdynlwRjdHKYXAo5RikZLGSGkOIvG2zxj12mGWaU
d3xggs9M8Z055nnCI+7SEgnhqX7SLTb5T0F2CEVUEWXPWo22EKOEVm7ziiGW
aCfFSnpfjrvqFb1MJ6U8pItf9JJ9KIRTlHOGs1znBi9IsEKKJKv84SXPaaKR
CnI4TYQsZp3/k290U8wDLnKJtfQ7dVmTtLHIIAlucovjnCdONTvmUajnOEo+
29Y2WOcj/eYa1wHt4zG/mWWGr0ymZ8973jLCG76wwzabrLPGKkmC/3CSEqLk
cYQOfjDOa/rp4Q4N1BLjhP9YTBtx9gE0H2rA
               "]]}, "0.7`"], Annotation[#, 0.7, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwNz71KAgAYBdDPIMfSbC97C0My7QmywKitLcsSSSHfQty0oKeo0HBL7Sn6
maPBGu3nDIe7Xe7NHl+UzxMRscvmUsQBTa7occMjQ954IbUckWGbHU6oUuOa
MRMiFbFAki3qXNLijk9mfLGWjsiyzx4dnpgw548fYiXiV04Z02WDCmXWedD3
zQf3NCnQIE+ORRJM7XymT4NTzihSYpU0r36/M2DELX3atDjikH+AIi9A
               "]], 
              LineBox[CompressedData["
1:eJwN0s9L02EcB/BHEUTnN7cw1rKwhKIQWxEWNpGgDkJ1SPtx6lKnDk1dEIg7
RbeBE3cJQoIu0TbbxZOnjh1CiCJGbbgN/ANiUBRBvQ4v3h/eDzwPfHhOPFic
z/aEEEokoxAKRIyR5ir3hkJ4xApFXlFjhw98psIxxjnDWS4wyxy3eMgI3VgI
v/jDP/p0MQ6Q5Agt/Rf26DCpO8e++eZwCHm2qFKjToND8RCaMiWP0jbfkWvc
ZZwNSuzyksFECJsyI7NELPOEMlVadHhKmz0qvCXHEjM8ZpoYA3S9/9HdRdYZ
Y4ECt2k5H5WH+WY+KL/Lr7yjTIVVbnDJDtKcpm0XTT7RIKVLENFPL3/1v/nJ
D+K6+1znGpeZ4jwTnOI4r+lQZ5f3bPOGFzwjR8b/uMJFTvKcPP8BQ1pPHQ==

               "]]}, "0.6`"], Annotation[#, 0.6, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{3704, 3740, 3732, 3776, 3811, 3814, 3863, 3862, 3858, 
               3910, 3953, 3951, 3997, 4001, 4043, 4044, 4099, 4104, 4103, 
               4162, 4161, 4215, 4281, 4284, 4285, 4341, 4344, 4351, 4437, 
               4441, 4500, 4502, 4553, 4555, 4610, 4612, 4609, 4613, 4611, 
               4556, 4554, 4503, 4501, 4442, 4438, 4390, 4342, 4343, 4337, 
               4282, 4283, 4216, 4168, 4160, 4110, 4105, 4100, 4045, 4046, 
               3998, 3999, 3952, 3955, 3909, 3861, 3865, 3864, 3817, 3812, 
               3777, 3773, 3743, 3742}], 
              LineBox[CompressedData["
1:eJwV0DsoB0AcB/CTZyLPKHmkWA34e5UUgzJhwGAySIgkUQbJIM/FYLPII4PF
pJSSQrJIybMMUqQoRaF8DJ/ud3fd7753hV2DrQNRIYQpspJDmCWJfEqopy0p
hB7GWGSFbXY54pw7HnnjkwNKqaWRZroYYJoltiggmkSKOeGKe15454cgRwJV
//spsqaGkM2ItXRa1XnMssApHcSkhRBPOQlUUEUfg6yzyS333HDHNRus0U8v
lUSIpYw4oml3zzHzzJBDC6NyDZOhzuRS7jTzWH6944tXnrjmgkOKiCOKXFaZ
Y4JuOmmigWrK2fv/R32/jR8888AlZ+yzwzrLTDJEjTN1RChiinH+AJ2ERgE=

               "]]}, "0.5`"], Annotation[#, 0.5, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{3775, 3813, 3803, 3866, 3855, 3913, 3956, 3959, 4005, 
               4004, 4000, 4048, 4107, 4106, 4163, 4167, 4217, 4218, 4222, 
               4288, 4287, 4345, 4387, 4388, 4392, 4445, 4504, 4506, 4557, 
               4559, 4614, 4617, 4514, 4618, 4615, 4562, 4558, 4507, 4505, 
               4443, 4440, 4391, 4389, 4347, 4292, 4286, 4229, 4220, 4221, 
               4164, 4165, 4109, 4108, 4049, 4003, 4002, 4007, 3962, 3957, 
               3914, 3911, 3867, 3806, 3816, 3815}], 
              LineBox[CompressedData["
1:eJwVzj0oBAAUB/BHyoC6xWiQ2XaLRTEoE52UcOXunPPRnY+BMkgGRVkMNqNF
HXWTyaIUWSwmg0HqdHWKfC38bvj179X/vV53djlVaoqIHJ0dEXu00UUvA4y3
RxTY4IBjylxwzT2PPFPnkz9a7N7KIUbIUGSXQ2qkGveZJE2GHHkKLLBEiXXK
nDfuJiIq8oc3XvmizgdVanyzyo3+mTxljSKLzDPHLFlmmGaCMUZ58ec+W+SZ
YphBrkjotNLMr/mdKk88cMclFU44YpsV+uz0k6SHHTb5B84SPFA=
               "]], 
              LineBox[{4457, 3579, 4569, 4516, 4457}], 
              LineBox[{4247, 3578, 4456, 4515, 4247}]}, "0.4`"], 
            Annotation[#, 0.4, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{3912, 3958, 3950, 4008, 4050, 4052, 4047, 4112, 4172, 
               4171, 4166, 4224, 4225, 4291, 4348, 4346, 4393, 4394, 4447, 
               4452, 4448, 4508, 4560, 4510, 4616, 4620, 4563, 4621, 4619, 
               4564, 4561, 4446, 4444, 4449, 4450, 4398, 4395, 4350, 4349, 
               4290, 4228, 4226, 4170, 4169, 4173, 4113, 4042, 4053, 4051, 
               4009, 4006, 3961, 3960}], 
              
              LineBox[{3348, 3464, 3338, 3356, 3372, 3384, 3398, 3399, 3190, 
               3212, 3228, 3244, 3255, 3269, 3280, 3291, 3299, 3310, 3317, 
               3326, 3422, 3436, 3439, 3471, 3473, 3475, 3477, 3481, 3497, 
               3516, 3520, 3524, 3553, 3545, 3548, 3523, 3519, 3514, 3496, 
               3478, 3476, 3474, 3472, 3470, 3444, 3440, 3419, 3334, 3329, 
               3321, 3314, 3304, 3295, 3285, 3275, 3261, 3249, 3236, 3221, 
               3396, 3404, 3401, 3389, 3379, 3362, 3457, 3449}], 
              
              LineBox[{3493, 3495, 3522, 3517, 3525, 3494, 3492, 3521, 3515, 
               3518, 3493}], 
              
              LineBox[{3536, 3532, 3554, 3547, 3559, 3533, 3538, 3542, 3546, 
               3552, 3558, 3574, 3566, 3571, 3556, 3550, 3544, 3541, 3536}]}, 
             "0.3`"], Annotation[#, 0.3, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{3448, 3456, 3361, 3378, 3388, 3400, 3403, 3406, 3409, 
               3414, 3417, 3423, 3483, 3491, 3489, 3487, 3485, 3480, 3511, 
               3505, 3513, 3479, 3482, 3486, 3488, 3490, 3484, 3415, 3412, 
               3407, 3405, 3402, 3397, 3383, 3371, 3355, 3337, 3463, 3347}], 
              
              LineBox[{4111, 4174, 4227, 4231, 4223, 4294, 4352, 4353, 4399, 
               4396, 4397, 4455, 4451, 4513, 4509, 4565, 4566, 4622, 4568, 
               4624, 4623, 4567, 4512, 4511, 4454, 4453, 4400, 4402, 4401, 
               4354, 4289, 4295, 4293, 4232, 4230, 4176, 4175}], 
              
              LineBox[{3507, 3500, 3527, 3526, 3529, 3508, 3499, 3534, 3528, 
               3531, 3507}], 
              
              LineBox[{3504, 3510, 3540, 3537, 3543, 3509, 3512, 3539, 3530, 
               3535, 3504}], 
              
              LineBox[{3555, 3549, 3563, 3560, 3569, 3551, 3557, 3573, 3565, 
               3570, 3555}]}, "0.2`"], 
            Annotation[#, 0.2, "Tooltip"]& ], {}, {}}}], {
        DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
         Identity, Frame -> True, FrameLabel -> {{
            FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
            FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}}, {{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}}}, GridLinesStyle -> Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 300, 
         Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
         FormBox["\"(b)\"", TraditionalForm], PlotRange -> {{0, 1}, {0, 1}}, 
         PlotRangeClipping -> True, 
         PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
         Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"Binary batch\\nmachine \[Eta]\"", {
                    FontFamily -> "Arial"}, Background -> Automatic, 
                    StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0.148, 0.33, 0.54}}, {{0.3100051463403675, 
                    0.41265356580651896`, 0.6368340353781865}}, {{
                    0.4291915714254163, 0.4545401688715521, 
                    0.5667691720694039}}, {{0.5483779965104651, 
                    0.4964267719365852, 0.49670430876062116`}}, {{
                    0.667564421595514, 0.5383133750016184, 
                    0.42663944545183846`}}, {{0.7867508466805627, 
                    0.5801999780666514, 0.3565745821430558}}, {{
                    0.9009484459689475, 0.6223711149223689, 
                    0.2929401825037374}}, {{0.9199878109985081, 
                    0.6699695274962701, 0.351962214095375}}, {{1., 0.95, 
                    0.75}}}, {{
                    Rational[-15, 2], -150}, {
                    Rational[15, 2], 150}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], -150}, {
                    Rational[-15, 2], -150}, {
                    Rational[-15, 2], 150}, {
                    Rational[15, 2], 150}, {
                    Rational[15, 2], -150}}, {{
                    7.5, -150}, {-7.5, -150}, {-7.5, 150}, {7.5, 150}, {
                    7.5, -150}}]]}, {
                    CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -116.66666666666669`}, {
                    Rational[
                    15, 2], -116.66666666666669`}}, {{-7.5, \
-116.66666666666669`}, {7.5, -116.66666666666669`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -83.33333333333336}, {
                    Rational[
                    15, 2], -83.33333333333336}}, {{-7.5, \
-83.33333333333336}, {7.5, -83.33333333333336}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -50.000000000000014`}, {
                    Rational[
                    15, 2], -50.000000000000014`}}, {{-7.5, \
-50.000000000000014`}, {7.5, -50.000000000000014`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -16.666666666666714`}, {
                    Rational[
                    15, 2], -16.666666666666714`}}, {{-7.5, \
-16.666666666666714`}, {7.5, -16.666666666666714`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 16.66666666666663}, {
                    Rational[15, 2], 16.66666666666663}}, {{-7.5, 
                    16.66666666666663}, {7.5, 16.66666666666663}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 49.99999999999997}, {
                    Rational[15, 2], 49.99999999999997}}, {{-7.5, 
                    49.99999999999997}, {7.5, 49.99999999999997}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 83.33333333333331}, {
                    Rational[15, 2], 83.33333333333331}}, {{-7.5, 
                    83.33333333333331}, {7.5, 83.33333333333331}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 116.66666666666663`}, {
                    Rational[15, 2], 116.66666666666663`}}, {{-7.5, 
                    116.66666666666663`}, {7.5, 116.66666666666663`}}]]}}}, {
                    Antialiasing -> False, 
                    StyleBox[
                    
                    LineBox[{{7.500000000000001, -150.00000000000003`}, {
                    7.500000000000001, 150.}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.500000000000001, -116.66666666666669`}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -116.66666666666669`}]}, {{
                    7.500000000000001, -83.33333333333336}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -83.33333333333336}]}, {{
                    7.500000000000001, -50.000000000000014`}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -50.000000000000014`}]}, {{
                    7.500000000000001, -16.6666666666667}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -16.6666666666667}]}, {{
                    7.500000000000001, 16.666666666666636`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    16.666666666666636`}]}, {{7.500000000000001, 
                    49.99999999999997}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    49.99999999999997}]}, {{7.500000000000001, 
                    83.33333333333333}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    83.33333333333333}]}, {{7.500000000000001, 
                    116.66666666666664`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    116.66666666666664`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["0.2`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -116.66666666666669`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -83.33333333333336}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.4`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -50.000000000000014`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -16.6666666666667}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.6`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    16.666666666666636`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 49.99999999999997}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.8`", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 83.33333333333333}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    116.66666666666664`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 300}, BaseStyle -> {}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ),
           InterpretationFunction :> (RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"Blend", "[", 
                    RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                    "]"}], "&"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.088484`", ",", "1.401553`"}], "}"}]}], "}"}], 
               ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0.2`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.3`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.4`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.5`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.6`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.7`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.8`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.9`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               
               RowBox[{
                "LegendLabel", "\[Rule]", 
                 "\"Binary batch\\nmachine \[Eta]\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", "300"}], ",", 
               RowBox[{"Ticks", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.2`", ",", "0.2`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.3`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.4`", ",", "0.4`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.5`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.6`", ",", "0.6`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.7`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.8`", ",", "0.8`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.9`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]},
    {
     TemplateBox[{GraphicsBox[
        GraphicsComplexBox[CompressedData["
1:eJx1mnl4zFf7h1NqafpKmtpeS2lqbXkt1RBBTwgN2oit2hexRcQeGsQSIWqJ
raMkRZGJdbSWCYMO1dqCGUskI8skYRozSUYSYqJVSvHTy3yecz3H780/ue7e
55zvc8585ptznPqOixocUcXDw+Ozqh4e//xuF32ibcvOUcLD/cPZJa5FBv7S
wG8Rec4uYchIn1Rv4grynNFfo/TXkA9Z0mXXoPgN5Dm7REGIK+R65EbynF2i
59YVtTcN2EKeM56vVZ6vJd+wYErPe2u3k+fsErcC+9brEL+TPGeXqHO79rz1
s3aT54z6dUr9OvJeD35O9RvxA3nOLpE9fNOyOQP2kefsEjWrjL9t7XmAPGfM
X6/MX08+vkb1tz5OTCXP2SXGB8yab1t7iDxnl3hWK3+fZsVh8pyxfgZl/Qzk
F9Q5GHxr/hHynF3032f7Dlu0dOxe4tJtnkbnvAqBvMKD4ZFXeDA88goP5v01
Sn8NeeQVHgyPvMKD4ZFXeDB/vlZ5vpY88goPhkde4cHwyCs8mNevU+rXkUde
4cHwyCs8GB55hQfz+euV+evJI6/wYHjkFR4Mj7zCg/n6GZT1M5BHXuHB8Dy/
RuLMbnVnXPv9jpJfIzE8z6+RGJ7n10jM+2uU/hryPL9GYnieXyMxPM+vkZg/
X6s8X0ue59dIDM/zaySG5/k1EvP6dUr9OvI8v0ZieJ5fIzE8z6+RmM9fr8xf
T57n10gMz/NrJIbn+TUS8/UzKOtnIM/zaySGR17/vXnx6Gb9zhKfyGva+qdp
5ZRXeDA88goPhkde4cG8v0bpryGPvMKD4ZFXeDA88goP5s/XKs/Xkkde4cHw
yCs8GB55hQfz+nVK/TryyCs8GB55hQfDI6/wYD5/vTJ/PXnkFR4Mj7zCg+GR
V3gwXz+Dsn4G8sgrPBiev39NxDtjPihMdpYq718TMTx//5qI4fn710TM+2uU
/hry/P1rIobn718TMTx//5qI+fO1yvO15Pn710QMz9+/JmJ4/v41EfP6dUr9
OvL8/WsihufvXxMxPH//moj5/PXK/PXk+fvXRAzP378mYnj+/jUR8/UzKOtn
IM/fvyZieOTV8kMbbfG8dOI1df02LR97m/IKD4ZHXuHB8MgrPJj31yj9NeSR
V3gwPPIKD4ZHXuHB/Pla5fla8sgrPBgeeYUHwyOv8GBev06pX0ceeYUHwyOv
8GB45BUezOevV+avJ4+8woPhkVd4MDzyCg/m62dQ1s9AHnmFB8Pz/YOFeJZB
DJxeUKLsHyzE8Hz/YCGG5/sHCzHvr1H6a8jz/YOFGJ7vHyzE8Hz/YCHmz9cq
z9eS5/sHCzE83z9YiOH5/sFCzOvXKfXryPP9g4UYnu8fLMTwfP9gIebz1yvz
15Pn+wcLMTzfP1iI4fn+wULM18+grJ+BPN8/WIjhkddPwqbcG/J5NnHYoP41
h31eTHmFB8Mjr/BgeOQVHsz7a5T+GvLIKzwYHnmFB8Mjr/Bg/nyt8nwteeQV
HgyPvMKD4ZFXeDCvX6fUryOPvMKD4ZFXeDA88goP5vPXK/PXk0de4cHwyCs8
GB55hQfz9TMo62cgj7zCg9V8vtxfWGVe7w093eOaQ9nfWmVe3Z7vb60yr6y/
RumvIc/3t1aZV7fn+1urzKvb8/2tVeaVPV+rPF9Lnu9vrTKvbs/3t1aZV7fn
+1urzCurX6fUryPP97dWmVe35/tbq8yr2/P9rVXmlc1fr8xfT57vb60yr27P
97dWmVe35/tbq8wrWz+Dsn4G8nx/a5V5dXs6bxUHeh+dVkDcbu3ouS362eV5
y+3B8HTecnsw769R+mvI03nL7cHwdN5yezA8nbfcHsyfr1WeryVP5y23B8PT
ecvtwfB03nJ7MK9fp9SvI0/nLbcHw9N5y+3B8HTecnswn79emb+ePJ233B4M
T+cttwfD03nL7cF8/QzK+hnI03nL7cHw/HxlI67fZnKHWucKlfOVjRien69s
xLy/RumvIc/PVzZieH6+shHD8/OVjZg/X6s8X0uen69sxPD8fGUjhufnKxsx
r1+n1K8jz89XNmJ4fr6yEcPz85WNmM9fr8xfT56fr2zE8Px8ZSOG5+crGzFf
P4Oyfgby/HxlI4b/fvM/P8dpXwr+/3+biT/q9M/PdcXnKeMVKu0dxJET/vkp
UfqXEl+98s/PHWU8F9XB6zX/jzrlb16vWanXrNRrVuo1K/WalXrNSr1mqhfP
Rb3quql1gdXfqJePV6i0cxCjXt6/lBj18vFc9By+vnn/43M2v1IX93nKeIVK
ewcxX988ZX3zlPXNU+53C6leNXfq56qum1oXH69Qae8gRr28fykx6uXjuEQn
No6HRye2DscFZzMx6u2krFsnpS7e3kGMenn/UmLUy8dzKfP08FC/t+r3Qs2d
+rmq68bbyzrV36gXjHr5eC7lc0B+S5X8lir5LX3le6LmUP2cP1LWUa1T/c3z
W0r18px4eKjvPfW9on5v1e+Fmjve3vHKuql1gdXf/PvmUr5vLuX7pr6n1feg
+p5Rv8cu5fum5lD9nNV1fLXOeg8PJ3XdkS0m7By92dYqQnwU1yYzdWCO2LDr
JT8InLxRl1sk/z+SpS39HO2KxaGU8BaffB9B5w/r9peM80dQyg790INTxexN
XcrOp1iJL3Qq8tymd4iVbf7Y8E74JNofgrE/PNXqwPS/tk0Xi0MWbDyTYBNj
mz+L671+uljiUzfp6MICYhEz269FT9kef8/B+HtO8+3ounR2wBnabyaYnvq0
bl0uxkzoqwv9MlD8mnXy7fzYM2KkmzMuDVxgTpH3XSd+DwoJ3V8uzGM8pv7Z
c77Iu/nWuD8qy0TzpPPNa5YOf+W+tvBmTePo0efIq/e3v7Tr2Gzf6TIaLznh
ZEw7/zTRb5fzh9j+X4uobw+ce6Ato/Y1+3SLHvI0jfa7M2oc27tzWJkY6G7/
8Yl+la0XnxfLc3P97wavFAHH6jca3qeM2gfZW4XN3H2BfMNW2zdsLLtA9WYU
1HYuzLotdu6v+2XT7VNEpHePCv+/5f10WPmdfbfLzCLZ7VuenJFWGVgu+sT+
dH3/sGhxdHCKreBXeX9ydl1qeM2DV0Rft297NG7Zutevismjduec+eMbup8B
437meWKu3fm+RnSud987qlje961oXeW9+CLp39d1OR002SRi50WavzCvF4u9
am06p5Xti8IexjyZJu//vrsQ1j/y61JqX+XCZW3lYrMYE9vtst/NJOF7/K8H
0SHy/nBvcULOuPtm2v8fCDa3f+hRSu0XNmrQusOlS2LIl7PXHDm0SZRsM0wd
ZZf3M6G38gOb/X2ZzgexU4Za0yfepvaTEjqGLJ9zRQQceOP2w5FbxMezZ3Vt
Hinvb3wGH0xOG5lO3rNNu4ZR4fI+qvOSTWErY5zCf8/Gt1e+P07MnTa6Wcnd
S/R5Hf+xjzXY/xpxRODsNyr6ZVL7Hc1bxyzvLf8utD7/enafZaWi5OKBduNn
x4lOP5n8rg64Lb4PDpk4ZPssEf307b+9/uuk5yc+Se99961MymfCUM9hhl63
RRvzrg/aj15A9xcYr0uzm60vp6XTeA2r5dewh2RSe9xvnD6T3cIndJnI8q64
v+eRk8Z3HMjRffhA3qdFPGx3w3bCSe2HFzZreNgrQ4gzidos1yrhOfLkzvfX
OKl9Z58dwb1WZVA+HlWW5oTWd1L7O8ErjPudGWJo9LYlnnXWiRnH5t245emk
9j6N2w4ek5kpZiSPy/aKlfdraO+74V/B3cukx3xen5fY76euyaL+1TlHBj53
0nlwkDkkzWebk3xWxNsbR72WIfSlz3bF90wRgbb+w/LCZPtR08bH3Dgv/eKg
yUNCemeKU4GZu0tqR4gBDatZewVkiIGPzx0ZOSlUdJ5WvWPu0kz6fAPWf3hr
+A4Ltc//6ukGm91J7SPMsZGJPZzUfnBSxRsVHeV9U/roPk9qjpCff+awpNA6
M+R9k6NiebPoxGLx3Zxu17Y0GUv//g9W76dGDc4ek9v0OnHAe/eNDXKzxNaz
b/Y9OT9OJFgfrQkwl4jn9lv2uo9jhNigS97VskSMq2pcGDVvpvgzZFiq19Ji
4bn54nJNZCw9D4znYbx7A7xKVk2z0HhL8lLPHjt8ncarO36I1v4wS/77w6OK
+14/y/uyi9pPvynZLO8fRnq919C+Ut6fzTw90fHhlSzROfbSR5UPl4quF8Mf
rxpbIvzDdxwzb18snJuf9Pw1oZj82pn+b5Z1v06+45WasV9XZFFeGy84pNtY
pURonuWneWavo/mB1fs60xvbUjMeXxcXKhJ7Vj5bKRqn/PxZZk4x8cVTCRPC
BmeJ3OqFg/YdWi+mJl5+MGRVCXGr3Il1viyX93Urmsxde/k/JaJR/vzilvYU
ej5Yve+7f9a7eOKu62L8jXc67ClPFKH/7fFakb2YeFzIsqddArJE/XNduv92
PkWEL/oxp6UoIQ54bd/gw/Ev9vMHTlcuLp8ixo3IyZ+8xSJMgxPqrG4fIVYf
mxR1Okj6UEvi+v6HS8j/3PxTU9NRcl/uODZBYzlYIj5Zefe9zY9mi+DJAyIj
phfR5zW23VC79XyROPnB05XO36Lp3/vR/qs24R39muWSp/sJv365R36Pl/cT
blbvp5J3fNFtwKwc+nyKZh75LD27SARMzu8QfHYN9Qer91f+jTdOCB+aQ++f
tICRNXzvyvuBwxG+SQVHi8TwqAtNZx5MovHAGC9vS9dajV5fJ3Z7NPgz5pFD
tNxV3av6i79/zoNVsobXkvdh81cFV/7SQt43bPvol+y+iTn0+Y5ffarMZ14R
cdMoz3WOVnL8Y8+u1n7L20rjd9zx+Iv+xdkiuevrAf9qnkL1TalW881f9ySJ
+id+2OTYXURevX/rWrr4gxu1conP+Zb/5p8q79vOT5t476iuiMa7vnp/uv+R
HLF0QpfDAS2/F/f3Ne6fdKuI2kc0b++bmJpDf1+/uzfwbK8X/jt3e6+9F6Zk
d88R4bNSctsWJYtTZ9LCjX7yPu/Cu6MWzO+RQ+/jvgtGmh+88JPc7eNi5/hr
EuV93ow3gqfVSZT3l6PfjDiY+q3898/OF/rXKMiVXCu+w5hqTeS/3xd1q3e8
/XjJJ/584jP8R4dInZkRdKnWLNH96YmPw4x2MeddzxZtR8wVSZHV191r5hDd
rwVV/2ZvrKjIHHQrXiP79yz125l8I1/+/Y6eXNlvoGTn02Tx4FyefB8nXF+b
0kXymrdr3vh0n7zP+rvF+trJenmfsPmduY3XNZH3X53rjmqxZK1D3A5sMLx9
+QI6L3y7tWlBj7xo4ne/ejmfr6qtWtJHky+G+L6cz/4Ov//2rjFPLM94OZ/i
ESN7/F1oFR8GvRwP540R216OR/crQaccK/YsofGTPiz23eL3tbg46tmMiU/t
QuPVfNnzxiuE5/izpzecdoimfV62V+/vfjcUWM+l5BPvSPO++NvZPOJB2UFH
nxTJ+7tWq+r1/ndVeb+3xrtG3F8vxi/55cjNtr2+oXp+9l59fJ99xSv1fdWr
apP21fKpvoouC+KscVbqj/rQX71PPFxuibn2Vx5xWWFl1Vov+qenBcyNXz2d
zlu7Kw89mVUyjTi2yfuLJvaUPPTTlCojt04lbjO3/vLQh1OID82PPzG+WZS4
49WvaGVUgXB6+xgCfaKE0IwbHjqzQLyzO2Vf4+fTxXrv2Iw60QViSECHXY/u
TBfFmqRP8me9OO9dO7U1K3+68H9Lf1I7R463am5BrW597TTeWGP64C+D7TSe
/6MzG2d/YqfxvPyP3ljfx07jFcfs9U3tbRfG5a/1GNRe3i/kPe4c1PIdyY+n
T+33xFNyI8f20IxH8vzY/Yvcz3eXSMb64XyK9QNj/cBYPzDWD4z6FiY9jVg3
X9a38LP/rBkWK+tbWDXscOM4WV/ciTVW+yJZX9zMk8/2xttoPJx3MR4Y44Ex
Hhjjgf8PocFYwg==
         "], {{{
            EdgeForm[], 
            RGBColor[0.14800000000000002`, 0.33, 0.54], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNmgd0VlUSx997QVCKYANDCSShhNCDxgACCtIsoBQFKSIIKF1qpAgBFUWK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               "]], 
              PolygonBox[CompressedData["
1:eJwlkslKnUEQRvuvX3CZjRsvCBpCcHc3blyL4tqNQ6LGa/Q6u1DEKZo4xHgd
XkEkJD6AgvPwBLrQp3C4iAPOw/moxYHT3dXV1dVdlOqt6rEQQhJyoDAOYTEK
oRU+44MsbjG/AQP4L9jGd2ESb4JpfAa+47nsybB3Hj7g0+ax+/Abv4U0ay1w
iU/BAWt7MIHfQAVrCTjGl+E8eIxih2Ad34QR/Kf53h0Yw0fNXTUP4z/MY1Xz
OH5knjvL+B+epMZZxqtQil8xV453QxQ78k4I+MfYa1+AYvyN+J7Ia1btidjv
rh6qlyfM5UeeU7kfoAPvgif81Tx3Ozzj19AWecwd/mIeqzN0lnqoXp7BEv7f
3C9gBW+EP+o1fMFPzd9SObN4PdSxVgMNeAE1zkXegzw8Zb5XMYrVHXVXxXzC
O5mbC/4GfXhZ7L1bg0q8jrlq1mrhqzly/ZFv5jWqVvXk0PwN9BZ647/qDcwG
P0NntUAm+J2a8XaYDz6XNj9TZ+vPleCt5n9ROdrwfvO/qz3a+2jea/3Be/wd
pQVmcQ==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.4200512493561599, 0.45132791510919357`, 0.5721423965446217], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtk8cuhlEQhr9/XIFu60r4ERdgqfceIkT0TiQiQXRCRLBWL4GFmrDX6xKJ
Xp7JzOLNM+f758x5Z875EwtrM2okCIJ0FIFu0T2KDAXBA4yBT3CapEs4C59R
Kt/P4DJKIF6B2aiXnEw4ha6IJ+AwuiAeh2PonHgSzqNr4gX4itKo8wffURLx
p9hav//AFnRHfhvsEfPVJ2Zc/YQizLPmRLEu4rct4hJYhnaIK+CuWH8HYvu1
zpLYnhjvO8771vWI+9c+dDbRIduvHjWORSkhm4Pu2yRnO7A+T92/9lcl9r0S
doid0+XfLj1f6z0GVjPNa6b4GfEojHLUNzmF8NB978Nkz43zWehM9K5GfeY6
+yy0QZznM471ml9iez/gkdhZa7AR3ZDfJOZN+1d/5WJ9lsJBtE5cB6u9/pDY
fHVOJz4/fQ96B/n+TvS97Lv/Pdjq76EZ1vtcdGZv3tuLv7uwz0Jr6f1e+L3q
ugEuinkcgLk+K53ZnPcyI3avyT6rYvdfADvF/gPtYv3rOavq1+++W6yu1u8X
e/d6R8fwW8zbL/wHO/Rzlw==
               "]], 
              PolygonBox[CompressedData["
1:eJwtk8lvj1EUhr/fqYSwMBYhmpYaWgsWtaiFqY3o1tYCNUZQ8zyXRMKCxDxP
sVXjn8DKVPbmamvsAjHG8+a8iyd5v3vPec/9zj23qrll7uooimI29IIuPmaU
imIIPEX3wFf4CJ9gD3QS1w370FvgLboDtqFldgN9Ew6i/0IjXrPgN3o+3GLv
DixCn4/MlcdZ9F54j34Hu9FXYCi5w+EqepX9W2FB5Bl11kHwEL0zMvcNbEeP
LyuKcdAhXzgDr7x/Dr0RXrv+JvQ/mIlXAxTkXed7GLocrqE3O/8urEf3IaY3
9IcB8J21b+5Zj3um3o1mbwxsjawtD3lNZ20aBJTZQ14jYKTXwjVUa2Fkb9UD
9WJF5Fluw3L0MXjp/q5Br3W89tehd7jfusNd6BPwwuc5FRmjWK0dRR/yfbXB
YfQGuFdkz9S7JZG1tLYMvdT5qrkY/Uv/WMqe/kE3w377tUSeUfmqsTJyrc3f
89DtMLiUHp2RPVQvJ0CNe6ReVUIVHCCmq8gZakWf9nzqvCfRlyNnVzOl2dKd
6m6VcxH9OHLWNLPP0Mc9H+rpEfQTGFjKM7V7pjRb3fABfkbOut7QD69p7zN8
gUueT3ncR1/wPGhNew8iZ1l3pLdR43+thrHQBHOgDqZABYyCIVDuHlR65jX7
jdDgnCbn1HnmNHuTYRLUw1TXqLZnhT3l3Rf6OabenvJ+HvlW9EYeRcYothYm
mlrXUK3/J/uOiQ==
               "]], 
              
              PolygonBox[{{751, 750, 755, 320, 745}, {744, 319, 760, 757, 758}
               }]}]}, {
            EdgeForm[], 
            RGBColor[
            0.5883777494420052, 0.5104841930946344, 0.4731900770053388], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtkMtKglEUhY//P7S0qdREUsSH0IfwEbShlPUSCgUl5CVvNBQcCypERFRO
hGyaOhCExEE0aey3+ddg8a1zW/vsHc9f5M4951wC+WjDohByLsbiD5/B/8Mf
+S94gxbcvYbvKMr+I2yjI3wXpv0g59QP3tjbTzhBYfwz7KMlObfwSv4SNnWn
DofoAD+Gc5TFb2EHHeJbME6NM/wxrLD+JseaqirTsktohb+HT8q07KL27Xym
fKvzK7/zgt6sxx48Ua21F8zF+rLZvKEI/gUm1bvNoKuZfMCG7jzAsuoOYEqZ
1sed/laDr+pxCkeaic1vq7/ZH/eVyzrK
               "]], 
              PolygonBox[CompressedData["
1:eJwtkbsuRFEUhrd1piBnMArKESFRUIzCFI5hCopRegSUQrwFUYtr1BLxCCIi
7iR6l8IlClF4A9+ftYov+ffe/17XgYXV+RVLKQ1BCfY4dLallMMO+hYq6C64
RG/CC743WEafmXv15wJ9bu4twyn6HZbQk/CJvjfXU/BofqezcihXX5ZSL+RQ
hlEYgRqMQR3GYRqa4cnDI+8dMbqJVcAHuuBuAmZgFg7jXfUeoH/NvQ34Q99E
//Io1m70o/r2LWKiF+EL/R31q8dh4j/Eu/5foQcz9+pOuX7Me9cf/X0yz613
/d2AZ2b7CkfmNav2FsxBP1RjRppVB7RDBXrgOval+Jr1mnksxVxHH5vvTjs8
QW+Z70o9bpvPVLPNoBQ5WzHzeuygFjMtwpNFDarlH9YlOio=
               "]], 
              
              PolygonBox[{{697, 268, 656, 653, 654}, {655, 221, 657, 658, 
               659}, {654, 653, 660, 222, 647}, {659, 658, 662, 267, 696}, {
               785, 784, 795, 356, 796}, {793, 355, 805, 798, 799}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.7567042495278505, 0.5696404710800753, 0.3742377574660559], 
            GraphicsGroupBox[{
              
              PolygonBox[{{785, 354, 777}, {696, 265, 659}, {714, 313, 712}, {
               741, 313, 739}, {796, 354, 785}, {740, 314, 738}, {647, 266, 
               654}, {739, 313, 714}, {725, 265, 691}, {689, 265, 725}, {659, 
               265, 655}, {713, 314, 740}, {654, 266, 697}, {727, 266, 690}, {
               791, 354, 731}, {799, 353, 793}, {709, 314, 713}, {687, 266, 
               727}, {790, 353, 799}, {737, 353, 786}}], 
              
              PolygonBox[{{833, 832, 772, 773}, {843, 842, 822, 823}, {699, 
               698, 703, 704}, {650, 649, 680, 681}, {813, 812, 817, 818}, {
               731, 354, 314, 736}, {704, 703, 707, 708}, {702, 701, 693, 
               694}, {735, 313, 353, 737}, {828, 827, 837, 838}, {684, 683, 
               685, 686}, {706, 705, 701, 702}, {793, 353, 313, 741}, {738, 
               314, 354, 796}, {823, 822, 832, 833}, {818, 817, 827, 828}, {
               781, 780, 812, 813}, {838, 837, 842, 843}}], 
              
              PolygonBox[{{708, 707, 712, 313, 735}, {786, 353, 790, 780, 
               781}, {691, 265, 696, 698, 699}, {773, 772, 777, 354, 791}, {
               681, 680, 655, 265, 689}, {694, 693, 697, 266, 687}, {690, 266,
                647, 683, 684}, {736, 314, 709, 705, 706}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9039985223025073, 0.6299963057562684, 0.3023954191377728], 
            GraphicsGroupBox[{
              
              PolygonBox[{{735, 311, 708}, {702, 312, 706}, {708, 311, 704}, {
               706, 312, 736}, {730, 312, 734}, {681, 263, 650}, {736, 312, 
               731}, {689, 263, 681}, {732, 311, 733}, {737, 311, 735}, {684, 
               264, 690}, {686, 264, 684}}], 
              
              PolygonBox[{{692, 691, 699, 700}, {726, 725, 691, 692}, {824, 
               823, 833, 834}, {834, 833, 773, 774}, {819, 818, 828, 829}, {
               844, 843, 823, 824}, {814, 813, 818, 819}, {787, 786, 781, 
               782}, {829, 828, 838, 839}, {695, 694, 687, 688}, {688, 687, 
               727, 728}, {782, 781, 813, 814}, {839, 838, 843, 844}, {774, 
               773, 791, 792}}], 
              
              PolygonBox[{{792, 791, 731, 312, 730}, {682, 263, 689, 725, 
               726}, {700, 699, 704, 311, 732}, {734, 312, 702, 694, 695}, {
               733, 311, 737, 786, 787}, {728, 727, 690, 264, 729}}]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.95, 0.75], 
            GraphicsGroupBox[{
              
              PolygonBox[{{594, 352, 592}, {688, 310, 695}, {700, 309, 692}, {
               732, 309, 700}, {726, 307, 682}, {730, 352, 792}, {695, 310, 
               734}, {591, 351, 593}, {787, 351, 733}, {792, 352, 774}, {729, 
               308, 728}, {782, 351, 787}}], 
              
              PolygonBox[{{589, 310, 308, 590}, {733, 351, 309, 732}, {728, 
               308, 310, 688}, {734, 310, 352, 730}, {592, 352, 310, 589}, {
               839, 597, 600, 829}, {829, 600, 598, 819}, {692, 309, 307, 
               726}, {834, 596, 599, 824}, {824, 599, 601, 844}, {844, 601, 
               597, 839}, {587, 307, 309, 588}, {588, 309, 351, 591}, {819, 
               598, 595, 814}}], 
              
              PolygonBox[{{814, 595, 593, 351, 782}, {774, 352, 594, 596, 
               834}}]}]}}, {{}, 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{682, 726, 692, 700, 732, 733, 787, 782, 814, 819, 829, 
               839, 844, 824, 834, 774, 792, 730, 734, 695, 688, 728, 729}]}, 
             "6"], Annotation[#, 6, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{650, 681, 689, 725, 691, 699, 704, 708, 735, 737, 786, 
               781, 813, 818, 828, 838, 843, 823, 833, 773, 791, 731, 736, 
               706, 702, 694, 687, 727, 690, 684, 686}]}, "5"], 
            Annotation[#, 5, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{685, 683, 647, 654, 697, 693, 701, 705, 709, 713, 740, 
               738, 796, 785, 777, 772, 832, 822, 842, 837, 827, 817, 812, 
               780, 790, 799, 793, 741, 739, 714, 712, 707, 703, 698, 696, 
               659, 655, 680, 649}]}, "4"], Annotation[#, 4, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{622, 648, 625, 626, 657, 658, 662, 664, 666, 668, 670, 
               672, 710, 716, 720, 722, 744, 758, 753, 749, 803, 809, 805, 
               798, 789, 779, 811, 816, 826, 836, 841, 821, 831, 771, 776, 
               784, 795, 801, 807, 743, 747, 751, 745, 721, 717, 715, 711, 
               669, 667, 665, 663, 661, 656, 653, 660, 624, 620, 651, 652}]}, 
             "3"], Annotation[#, 3, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[CompressedData["
1:eJwNzbsuA2AABeC/7SCxWExNJCUiYrF0sVgsZqO61qUtoQOta6m2vIag2rdh
4BkMIiJoUIpv+JKTnOSc/nR+ajMSQkgxHQ1hhgU2WGSZVbKssc4WO+xxQIlj
Tqhyyhnn1GnQ5IZ7XonEHPIr/9DmkxYvPDGgH2aQPnrpZoRRxphgkiTjROmi
hzgJhniw98gzb3zwxTcd/njnjluuueKSC2pUKHPEIfvsUqTANjkyrLDEPCny
pJlljn8TJjCo
               "]]}, "2"], Annotation[#, 2, "Tooltip"]& ], {}, {}}}], {
        DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
         Identity, Frame -> True, FrameLabel -> {{
            FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
            FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}}, {{{0, 
              FormBox["0", TraditionalForm]}, {0.05, 
              FormBox["0.05`", TraditionalForm]}, {0.1, 
              FormBox["0.1`", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.05, 
              FormBox["0.05`", TraditionalForm]}, {0.1, 
              FormBox["0.1`", TraditionalForm]}}}}, GridLinesStyle -> 
         Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 305, 
         Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
         FormBox["\"(c)\"", TraditionalForm], PlotRange -> {{0, 0.1}, {0, 1}},
          PlotRangeClipping -> True, 
         PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
         Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"Ratio of\\nmachines\"", {FontFamily -> "Arial"}, 
                    Background -> Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0.148, 0.33, 0.54}}, {{0.4200512493561599, 
                    0.45132791510919357`, 0.5721423965446217}}, {{
                    0.5883777494420052, 0.5104841930946344, 
                    0.4731900770053388}}, {{0.7567042495278506, 
                    0.5696404710800753, 0.37423775746605586`}}, {{
                    0.9039985223025073, 0.6299963057562684, 
                    0.3023954191377728}}, {{1., 0.95, 0.75}}}, {{
                    Rational[-15, 2], 
                    Rational[-305, 2]}, {
                    Rational[15, 2], 
                    Rational[305, 2]}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], 
                    Rational[-305, 2]}, {
                    Rational[-15, 2], 
                    Rational[-305, 2]}, {
                    Rational[-15, 2], 
                    Rational[305, 2]}, {
                    Rational[15, 2], 
                    Rational[305, 2]}, {
                    Rational[15, 2], 
                    Rational[-305, 2]}}, {{
                    7.5, -152.5}, {-7.5, -152.5}, {-7.5, 152.5}, {7.5, 
                    152.5}, {7.5, -152.5}}]]}, {
                    CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -101.66666666666664`}, {
                    Rational[
                    15, 2], -101.66666666666664`}}, {{-7.5, \
-101.66666666666664`}, {7.5, -101.66666666666664`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -50.833333333333314`}, {
                    Rational[
                    15, 2], -50.833333333333314`}}, {{-7.5, \
-50.833333333333314`}, {7.5, -50.833333333333314`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 0.}, {
                    Rational[15, 2], 0.}}, {{-7.5, 0.}, {7.5, 0.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 50.83333333333334}, {
                    Rational[15, 2], 50.83333333333334}}, {{-7.5, 
                    50.83333333333334}, {7.5, 50.83333333333334}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 101.6666666666666}, {
                    Rational[15, 2], 101.6666666666666}}, {{-7.5, 
                    101.6666666666666}, {7.5, 101.6666666666666}}]]}}}, {
                    Antialiasing -> False, 
                    StyleBox[
                    
                    LineBox[{{7.499999999999999, -152.5}, {7.499999999999999, 
                    152.5}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.499999999999999, -101.66666666666666`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -101.66666666666666`}]}, {{
                    7.499999999999999, -50.833333333333314`}, 
                    
                    Offset[{4., 0}, {
                    7.499999999999999, -50.833333333333314`}]}, {{
                    7.499999999999999, 2.4455600638347716`*^-14}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    2.4455600638347716`*^-14}]}, {{7.499999999999999, 
                    50.833333333333364`}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    50.833333333333364`}]}, {{7.499999999999999, 
                    101.66666666666663`}, 
                    
                    Offset[{4., 0}, {7.499999999999999, 
                    101.66666666666663`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["2", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -101.66666666666666`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["3", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.499999999999999, -50.833333333333314`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.499999999999999, 
                    2.4455600638347716`*^-14}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["5", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.499999999999999, 
                    50.833333333333364`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.499999999999999, 
                    101.66666666666663`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 305}, BaseStyle -> {}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ),
           InterpretationFunction :> (RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"Blend", "[", 
                    RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                    "]"}], "&"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.702592882274266`", ",", "10.`"}], "}"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"3", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"4", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"5", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"6", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"Ratio of\\nmachines\""}], 
               ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", "305"}], ",", 
               RowBox[{"Ticks", "\[Rule]", 
                 RowBox[{"{", 
                   
                   RowBox[{
                    "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], 
                   "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )], 
     TemplateBox[{GraphicsBox[
        GraphicsComplexBox[CompressedData["
1:eJyM3Xm4tlddn30cwBAEZ0StKK1SBrFKQgcwCb7VmmAVEepAbYtttT1Kq1Yc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         "], {{{}, {
            EdgeForm[], 
            RGBColor[
            0.16085714285714287`, 0.33714285714285713`, 0.5520408163265307], 
            GraphicsGroupBox[{
              
              PolygonBox[{{59203, 1, 58807, 59599}, {59600, 58808, 2, 
               59204}, {59202, 58805, 58806, 59201}}], 
              PolygonBox[CompressedData["
1:eJwl2AXUFGUbBuAPBBGQbpTuEKQ7le4wQAVERUDp7pZQOgREEZQ0CFFCkVAa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               "]], 
              PolygonBox[CompressedData["
1:eJwU3WO8HFcDB+A0tm3btp00tm3btm3btm07Kd8maaOmsZqk7zMfnt9273/P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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.2122857142857143, 0.3657142857142857, 0.600204081632653], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58814, 598, 599, 600, 58813}, {58811, 595, 596, 
               597, 58812}}], 
              PolygonBox[CompressedData["
1:eJwl2mW4VcUaAGBAuru7u5FUEOkG6e7u7pbu7m6RLpHuBunuLilR+r7ruT/e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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.26371428571428573`, 0.3942857142857143, 0.6483673469387755], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58838, 4162, 4163, 4164, 58837}, {58830, 2974, 
               2975, 2976, 58829}, {58827, 2971, 2972, 2973, 58828}, {58819, 
               1783, 1784, 1785, 58820}, {58835, 4159, 4160, 4161, 58836}, {
               58822, 1786, 1787, 1788, 58821}}], 
              PolygonBox[CompressedData["
1:eJwV3HP4lXcfAOCWvWzby7Zt2/bysrVWrVXLtmvVWq71pmXbtt17P3/c17nO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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.3251020408163265, 0.4179591836734694, 0.6279591836734695], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58846, 5350, 5351, 5352, 58845}, {58851, 6535, 
               6536, 6537, 58852}, {58862, 7726, 7727, 7728, 58861}, {58843, 
               5347, 5348, 5349, 58844}, {58859, 7723, 7724, 7725, 58860}, {
               58854, 6538, 6539, 6540, 58853}}], 
              PolygonBox[CompressedData["
1:eJwV2mO0XdcWAOAb27Zts7FtO2mb9jVo2gZFmsa2bdu2bdu2+b794xt3nDPP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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.3889795918367347, 0.44040816326530613`, 0.5904081632653062], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58875, 10099, 10100, 10101, 58876}, {58867, 8911, 
               8912, 8913, 58868}, {58886, 11290, 11291, 11292, 58885}, {
               58878, 10102, 10103, 10104, 58877}, {58870, 8914, 8915, 8916, 
               58869}, {58883, 11287, 11288, 11289, 58884}}], 
              PolygonBox[CompressedData["
1:eJwV2mO0XFcYANAXNjYbo7Ftu3Ha2LZt27bd2LZtO2kaN3bS7vmxM+vNd7+D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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.45285714285714285`, 0.46285714285714286`, 0.5528571428571429], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58899, 13663, 13664, 13665, 58900}, {58902, 13666, 
               13667, 13668, 58901}, {58894, 12478, 12479, 12480, 58893}, {
               58891, 12475, 12476, 12477, 58892}}], 
              PolygonBox[CompressedData["
1:eJwV2GPUHtcWAOA3tm3bdho1jW3bttU4jVP3to3Npo1t2zYbq+F95sez3jVr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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.516734693877551, 0.4853061224489796, 0.5153061224489797], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58926, 17230, 17231, 17232, 58925}, {58915, 16039, 
               16040, 16041, 58916}, {58923, 17227, 17228, 17229, 58924}, {
               58907, 14851, 14852, 14853, 58908}, {58918, 16042, 16043, 
               16044, 58917}, {58910, 14854, 14855, 14856, 58909}}], 
              PolygonBox[CompressedData["
1:eJwV2GPYHUcDBuAT27Ztp7FtNWpsN06+xk2auk1j27aNxjbbOI3tfPf+uK/3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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.5806122448979592, 0.5077551020408163, 0.4777551020408164], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58931, 18415, 18416, 18417, 58932}, {58934, 18418, 
               18419, 18420, 58933}}], 
              PolygonBox[CompressedData["
1:eJwV12V0FUcYANBHgBCceoHiUtzd3TV4kOBOAkGCBHd3d3cpdagLUApVoIVS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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.6444897959183673, 0.530204081632653, 0.4402040816326531], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58950, 20794, 20795, 20796, 58949}, {58942, 19606, 
               19607, 19608, 58941}, {58939, 19603, 19604, 19605, 58940}, {
               58947, 20791, 20792, 20793, 58948}}], 
              PolygonBox[CompressedData["
1:eJwV1WW0VVUQAOArICjdrQLSndLdIIKtGEg3KG0LSHd3d/OSBzy6u7u7U6Qk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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.7083673469387753, 0.5526530612244898, 0.4026530612244899], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58955, 21979, 21980, 21981, 58956}, {58966, 23170, 
               23171, 23172, 58965}, {58958, 21982, 21983, 21984, 58957}, {
               58963, 23167, 23168, 23169, 58964}}], 
              PolygonBox[CompressedData["
1:eJwl1nVwVWcaB+C7tKW6UnfcQlwITilQwy0hnhAjWIK7JMQFQkJwd+q+7u5u
xaHUleK+z5n945lzZ37z+T3v+drnlowtbhUKhepoTW2R39TTwEpWsbgyFFrC
UpaxnFLKWEE5FVRSRTU11FJHPQ08XhUKtaEt7WhPBzrSic50oSvdmKvNPOaz
gIUs4rnqUGgowxjOCEaSRDITSCGVNBayiMUsYSnLSCeDTLLIJofllFLGCsqp
YBSjGcNYxjGeSqqopoZa6ghrCIW6E04EkUTRJGtmDS2sZR0r59lvGllNE810
LLU/dKYLXenGxMWhUC555FNAIUkkM4EUUkljOsWUMIOZzKKHvhLpSS9604dJ
siImM4WpTCOdDDLJIpscNprrJjazha1sY7ZsDnOZx3wW8Lgx2tCWdrSnA2F0
J5wIIonibu7hXu7jfh4gmhhiiSOeBB7kIR7mER7lMdaYUwtrWcd6NtB7unXT
l370ZwB5/nP5FFDIJIroq69+9GcATzCQKzNDoatc4zo3CM2S62sgTzKIwQzh
nPw8F7jIJS5zhKMc4zgnOMkXfMlpvuIMZwnLtm+EE0EkUUQTQyxxxJMQ5MaO
IpoYYomj0Tu/miaaWUML8bIEepBIT3pRLqugkiqqqWEpy1hOKWWs4Fie9XCC
k7zLqeBpDad4j/f5gA+ZYK9TSCWNdDL4SPYxn/Apn/E5TQpaM2toYS3ruF+b
B3iQh3iYR8gki2xymEgupyvsL2c4yznO01XWjTC6E04Ej/JYUOdoQ1vaEUkU
0cQQSxy96RP8j+hHfwYwhrGMYzxJJAft1Y4YYokjngSekj3NMzwb1EeG8gQD
eZJBDGYIwxjOCEYyitHEk0APEulJL95xNgc5xGGOcJT2sg50pBOd6RKM5x0Y
xGCG8BRPs9A7v4jFLGEpyzjtbL7iDGc5x3nG1NsHxjGeJJLJJItscphILv/i
3/yH//IOB6mmhlrqqKeB9nSgI53oTBeOGfs4JzjJu5yiq6wbYXQnnAi+ybe4
m3u4l/v4RJtP+YzP+YIveY/3+YAP+YiPidQmimhiiCUuWIfsIIc4zBGO8jvZ
7/kDf+RP/Jlf8Et+xa/5Db/lEIc5wtFgnRzna/pqxU3czC20Zrdv0h72so/9
HAi+W9q0sJZ1rGcD29nBTnaxmz18h+/yPb7PD/gheeRTQCGTKGIyU5jKNKZT
zFZjb2M7O9jJLl6XvcGbvMXbfJu/8Ff+xt/5B//kSq36zDWuc6P2/5egc57n
ucBFLnGZMm1WUE4FlVRRwgxmMovZzOFH/Jif8FN+xs9ZySoaWU0TzVww9kUu
cZkrXOUa17kRXNCCc6IVN3Ezt9CaW7mNVO9YGulkkEkW9faoIbhfsIpGVnNB
LbvIJS5zhausl21gI5vYzBZ2m8ce9rKP/RxgnDHGk0QyE0hhuqyYEmYwk1mM
kI1kFKMZw1gKKAzuHRQxmSns9W3ex34O8Dwv8IzsWZ5jKMMYznbZDnayi93s
4UVe4mVe4VVeY6o204L5UkwJM8gmJ7hnkUse+SxXs0opYwXlVDDb2uYwl3nM
ZwH1NLCSVTSymq1sYzs72MkunucFXuQlXuYVJjjjlOCcSSOdDF6VvcbrvMGb
vMXtsju4k7v4Ot+gp6wXvelDX/pRSRXV1FBLHUkkB+OTQippxOsrgR4kBv3S
K6gHsg1sZBOb2cIkipjMFKYyjYnkkkc+BRSSTgaZZJFNDrdyW7A+7uBO7iKW
uGBeJNCDxGAe5rSJzWwJ6gjb+B9doibD
               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.7722448979591836, 0.5751020408163265, 0.36510204081632663`], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58971, 24355, 24356, 24357, 58972}, {58974, 24358, 
               24359, 24360, 58973}}], 
              PolygonBox[CompressedData["
1:eJwV1lV4VVcWAOCDu5NAPIFAcJdBg4XgVsa9nYd5mZmPtgQCwaEtMm1npu4j
9SIVnOCEIBFiJBCKu0sFn/88/A/3rm/ttffacm/Sk3+b8teqQRC8Qk1avxQE
ybShLSm0I454EkgkiVaUvhgEZRymnAqOkPdUEORTQCGHKGKX2G72kMNechlq
rGEMZwRpjGR2RhBkMYe5zGM+axcHwTrWs4GNbKKJnKY0ozkRRDKAgQxiMKkM
oSvd6E4PetKLFrQkimhiiOWuud7jPg94yCPai3WgI53oTBfqUZ8GNKQRjTkw
LQgOkkc+BRSywNoWsojFLOE5nucFlrKM5awg5S/2h/Z0oCOduL08CO7wHd/z
Az+yR+0c9pLLPvZzXuwCF7nEZa5QZ0kQ1KUe9WlAQ6pRnRrUpBa1mfHnIJhJ
JrOYTRZXjXWN69zgJreIMNdIWtCSKKLJ1tOtbGM7O9gZnhs9ymEvuexjP9P1
IoMZzCSTWSQZqxWtSaYNbYkhljjiSSCRYme0hFLKOEw506zhaZ7hWaaTwVFz
quQY33KcE/TW0z705Sf0oz/zljm/LGAhi1jME2JT+Sk/4+f8gl/yK37Nb/gt
v+P3/IE/8iRP8SfmMDesw3wWsJBFLGYJz/E8LzCeCUxkEpOZwlKWsZwV/J0X
OazX5VRwhKNU0ne2ddKP/gxgIIMYTCpDGMowhjOCNEaSzihGM4axjGM8E5jI
JCYzhSeYygxzmkkms8L3giym8TTP8CzTyeAlXuYf/JN/8Up4T1c43zSgIY1o
TA1qUova1KEuG+VsYjNbyGYr6YxiNGMYyzgO6VERxZRQShmPnZVAvApVqUb1
8D76/gIXucRlrtBa7WTa0JYU2vG1nG9YyzrWs4FXeY3XeYM3eYur89xHrnOD
m9zisTsZGK8KValGdd6W8w7v8h7v8wEnzekUpznDWc5x1zj3uM8DHvKIFsZq
SRTRxBBLHPEkkEgSrWhCU5rRnAgiw/3x1jSmCU1pRnMy3aVZzCaLOcxlLetY
zwY2somx5jSO8UxgIpPo+7LzTD/6M4CBdKcHPelFb/qwUi9WsZo1fMlX1Jjv
/FCL2tShLh3ldKIzXehKN9rQlhTa0Z4OJJBIEq1oTTKzzTWLOcxlHvPJ81uY
TwGFHKKIs5zjPBe4yCVS5QxhKMMYzgh2iO1kF7vZQw5RakcTQyxxxDNdTgYz
mEkms6hnzfVpQEMa0ZhjS72bHOcEJznFY2cxEK9CVapRnQN6epA88imgkAg1
IsPzRUuiiCaGWOKIJ4FEBpnrYFIZwlCGMZwRpDGSdEax2Zq3kM1WtrE97J/a
l7jMlfBecS1879XozwAGhvUYTBojSWcUoxkT/i7KucFNbnGbO2xjOzvYyS52
h+8w5VRwhKNUhu8MRRRTQill4Xj6eYfv+J4f+JEP1f6Ij/mET/mMz/mClaxi
NWu4K+ce93nAQx7R3Vvcg570ojd9OG0vz3CWc5znAte5wU1ucZs7XNbTK1zl
Gte5wQ53dSe72M0ecthLLvvYzwEOkkc+BRRyiCKKKaGUMg5TznE1TnCSU5zm
TPjZmk9xmjOc5RzFYiWUUsZhyqngCEep5BjfMlyNEaQxknRGMZox4TvEOMYz
gUEMJpUhDGUYE5nEZKaE/xuYyma2kM1WtrE97I/auexjPwc4yEMe8ZjAu1mF
qly0B5fCfeAKV7lGR2N1ojNd6Eq38B0V28RmtpDNVg5RRDEllFJGMznNiSCS
FrQkimhiiCWO+HB/5JRTwRGOUkkDsYY0ojFNaBruv9hB8singEL2kMNectnH
fv7Nf/gv/+NDPuJt3uFd3uN9PmAb29nBTnaxm5WsYjVr+JKvaGNObUmhHe3p
wNdi37CWdaxnAwliiSTRitYk86rYa7zOG7zJW3zMJ3zKZ3zOF9Rw52tSi9rU
oS7/B7RWkqA=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.8041836734693877, 0.5863265306122449, 0.34632653061224494`], 
            GraphicsGroupBox[{
              
              PolygonBox[{{37027, 37028, 37029, 37030, 37031, 37032}, {37021, 
               37022, 37023, 37024, 37025, 37026}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.8361224489795918, 0.5975510204081632, 0.3275510204081633], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58979, 25543, 25544, 25545, 58980}, {58982, 25546, 
               25547, 25548, 58981}}], 
              PolygonBox[CompressedData["
1:eJwV1GV0VUcUBtCLU1fc3aXu7hR3d4gQkhAnDgR3EhyKRoDgLpW/FVwruNYV
qQDd78ded731rXNnzpm5r87gmM7RJYMg6EtZRk0OgjjiSSCRJJJJYTSppJHO
+awguMBFLnGZK4yQRTGSaGKI5YFZQfAgD/Ewj/AofehLP/ozgIFMVjOFqUxj
OjNC75VFE0Mso4hjmGw4YYQTQSTdZN3pQU960ZswwokgkhFE8dSMIHiaZ3iW
53iecd6Vw3gmMJFJDJENZRjDCSOcP/mL69zgJrcYZI3BDGFoaN8MpwMd6URn
utCVD9W0pR3t6UBH3uFd3uN9PqBN6KmmTaiOtrSjfWheslhGEUc8CfzML/zK
b/zOH6F+ZtoXYYQTQSSbZVvYyja2s4OJTGIyU5jKNBJJIpkURpNKGulkkEkW
2UxnBjOZxWzmUE4P5bmHe7mP+1koW8RilrCUj1jGclawklWsJp8CCiliDWs5
yCEOc4SjHGMMY0PnTw7jmcBOdrGbPexlHyPMKIqRRBNDLDPdlVnMZg655PG5
mi/4kq/YzwHWUcx6NrCRTXSiM13oSje6h/q0xkpWsZp8Csgyo2zGMJZx5BBP
AokkkUwKo0kljXQyyKSFNVrSitY8wZNEEBnqmyhGEk0uecxlHvNZEDqfXOfD
MpazgpVsZwc72cVu9rCXfXzMJ3zKZ6xiNfkUUEgRDdKCoCGNaEwTmnJUdozj
nOAkp6giq0o1qlODmtSiNnWoSz3qM1/NAhayiMUsYTZzyCWPucxjPwc4yCEO
c4TX8oLgdd7gTd7iba76D73G9/zAj/zE0hxzYxnLWcFK0tSkk0EmWWTzrZrv
OM0ZznKOVWpWk08BhRRxXHaCk5zia74h3l4TSCSJZFJoZhbNaUFLWtGaRGsn
kUwKo0klnwIKKWINa+lBT3rRmz705V939z9uc4e7BO7hdc8b3OQWf/MPhRSx
hrWsozj0HdprNDHEMoo4eriLPelFb/rQlxLWKEkpSlOGslz0rktc5gpXuUY/
Nf0ZwEAGMZjTsjOc5RznuUCGbz6TLLIZw1hK6bk0ZShLOcqz0dlsYjNb2Mo2
Osk604WudKM7jWhME5rSjObUoS71qE8DGnLbLO5wl8DvEpTkBV7kJV7mFV6l
AhWpRGWqUJV1FLOeDaF9s4lqVKcGNalF7dD562Et6yhmPRt4zKwfpwIVqURl
/gfOK0Nz
               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[
            0.8999999999999999, 0.6199999999999999, 0.2900000000000001], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58998, 27922, 27923, 27924, 58997}, {58987, 26731, 
               26732, 26733, 58988}, {58996, 27921, 27919, 27920, 58995}, {
               58990, 26734, 26735, 26736, 58989}}], 
              PolygonBox[CompressedData["
1:eJwV1XV4V1UYB/ArKEqvGCkqKgrSYACKCighYwMpgY0VSMMAMRCpJa6UNSjY
hZ1gt4SC8Y8tDZIbAyWMz/3j8+z57fu85z3n3HPPvSR1zsjZdYIgmEs9zlkV
BHWoy7mcRz3O5wLq04CGNCJxYRAkMYlkUkilQ14QdOQqOtGZLjyn5nleYD0v
8hItaUVr2nAhbbmc9lzBlXSgI41pQlMiiCSKi7iYS2jHpVxGNDE0I5bmtCDO
nIYTTwIjGMk0a5jODGYyi9m8rOYVXuU1XucNJqlJJoVU0khniWwpy1jOCjLJ
IpsccsljJXeoGc8EJpJIUjiuLJU00pnMFG6W9WcAA7mFW8N9l3WiM13oSjd+
fTgIfuN3/mAHO5ljbXPJYB7zWcAu2W72sJd97KerHt3oTg960itct5p0JjOF
O5nKvXrfxyLuZzEPcEuJ+TKIwQxhKA/K8imgkCKKGaTHYIYwlNsYRrWshuPU
coKT7GEv+9jPAf4Mz7EeDWhIIxrThL9kf3OK05zhLAc5xGGOcJRj4fzUFFJE
MQ/xMD/KfuJnfgn3nd+4sTAIbuJm+jOAgWzICIKNvMt7vM8HNDVWBJFEEU0M
nelCV7rRnR5cYawr6UBHrqITy2TLWUEmWWTzoR4f8TGf8Cmfhb/N9RM+5TM+
5wtuUzOMOIYTTwK99ehDX67nBvrRU9aLq7mGa7mORJKYRDIppDKN6cxgJrOY
TQ655LEyPB/k86U5fcUmNrOFreH7r3c7LuUyLqc9c9TMJYN5zGcBaaQzmSnc
ydTwr7GmMo3pzGAmlbIqVrOGR3iU32V/sIOd7GI3DxU7F6yihFLK+E9NUOre
pQ51OZdT/n+aM5zlH/4Nz1emcVhFCaWUUW6sCiqpYjVreJB8CiikiGIOVHgP
OMghDnOEbUuCYDvf8h3f8wOPyR7nCZ7kKZ7mKMeopobj1PIMz/Icz/MC61nN
Gh7hUdayjkhrjiKaGJoRy3FrruUEJ8P3k7/ZxGa2sJWv+YZtbOdbvuN7fgjr
CtRxitOc4Sw7ZDvZxW72sJfmeregJa1oTRvqO0MNaEgjGtOEV9W8xuu8wZu8
xWGOcJRjVFPDPvZzgD85yCGaGiuCSKKIJoa3Ze+wgY28y3vh+2PvkkkhlTTS
iWM48SQwgpHczihGM4axjKO1Hm24kLZcxMWs1WMdj/E4T/AkS5y5pSxjOSvI
pLuz3oOe9OJqrmG+bAF3sZC7uYd4WQIjGMntjGIAA8PvA7eG9z6DGc0YxjIu
/F4ynmu5jt70oS/XcwP9wnuXm8LvJf0ZwtDwPmMYcQxnljnNZg5zyWAejRd5
zjQlgkiiuFd2H4u4n8U8QLWzVcNxajnBSUrtdRnlVFBJFXcwnglMJJEkNnn3
NrOFrXzNN0TrHUMzYmlOi/C3ZxZLc1rQklaUm1MFlVSxmjVkkU0OueSxkgn2
YiKJJDGJ5PD5+NaOYjRjGMs4stwp2eSQSx4rw/vHWPkUUEgRxeH95QyVUEoZ
5VTwP8sUtXI=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9051020408163265, 0.6327551020408163, 0.30581632653061214`], 
            GraphicsGroupBox[{
              
              PolygonBox[{{38179, 38180, 38181, 38182, 38183, 38184}, {39139, 
               39140, 39141, 39142, 39143, 39144}, {39133, 39134, 39135, 
               39136, 39137, 39138}, {38173, 38174, 38175, 38176, 38177, 
               38178}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9102040816326531, 0.6455102040816326, 0.3216326530612244], 
            GraphicsGroupBox[{
              
              PolygonBox[{{59006, 29110, 29111, 29112, 59005}, {59004, 29109, 
               29107, 29108, 59003}}], 
              PolygonBox[CompressedData["
1:eJwV0+V711UUAPAruKCxpVasQMqgYRs4wnjln+Dz2ArYLbaibsA2wj+CGKx7
Y4VNLJnxxiAWxILY5uf34vPifs9zvueee+5NfHr7U9smhBCyiWb3wRD2sJc8
8imgIy+ETrro5hw99DPAZa5wlWvMl5NMCqmkkc5xsSKKKaGUMqbsC2Eq05jO
DGZSLlZBJVVUU0POgRBy2c0e9pLHPDXiiCeBRJL4Uc5P/Mwv/MpvNNFMC62c
5AdOcZoznKWNdmqpo54GTtBIvtoF7GM/BzjI22q/w7u8x/t8wHk5F7jIJXrp
4ya3GGWMcUJ+CFFyookhlklM5pwaPfzOH/zJX7TRTgeddNHN2l0hrGM9GWSS
xRT/mso0pjODmVyVc41BhhhmhCiziSaGWCYxmV6xPvoZ4DJXWK7GClayitWs
YVB/QwwzwnVuROZcYM7UUkc9DRwSO8wRjlLIscgcxBppopkWWrlPD/czi9nM
YS53cCd3cTf3cC8LWMgDLGIxSyLr761ZzBKWsoz5ekgmhVTSSOdDOR+xk4/5
hE9ZyzrWk0EmWbzKa7zOG7zJWyxlGQ/yEA/zSOQdUUQxJZRSxnJWsJJVrGYN
z/Asz/E8L/Aiu/iGb/mOHHJ5iZd5hW1sZwef8Tlf8CVf8TUb2MijZLOJzWxh
K4/xOE/wJIc4zBGOUsgxaqmjngZO0MjfOSH8w7/8x3kuULhTHscpopgSSimj
nAoqqeKUf53mDGdpoz2yb7PMZhOb2cJWbordYpQxxgm+x5NAIkmRe0Ays5jN
HOYyjzg65HXSRXfk3dJDilgqaaSzgIUMig0xzAjXuRE5Dz000kQzLbRSTQ21
1FFPAxed0SV66aOfAUYZY5yQG8JtTGAitxNFNDHEUq52BZVUUU1N5B7bawaZ
ZLGBjZG+vYE44kkgkST+B2Umwek=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9153061224489796, 0.6582653061224489, 0.3374489795918367], 
            GraphicsGroupBox[{
              
              PolygonBox[{{38905, 38906, 38907, 38908, 38909, 38910}, {39109, 
               39110, 39111, 39112, 39113, 39114}, {39115, 39116, 39117, 
               39118, 39119, 39120}, {38911, 38912, 38913, 38914, 38915, 
               38916}, {39271, 39272, 39273, 39274, 39275, 39276}, {39265, 
               39266, 39267, 39268, 39269, 39270}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9204081632653062, 0.6710204081632652, 0.35326530612244894`], 
            GraphicsGroupBox[{
              
              PolygonBox[{{59012, 30297, 30295, 30296, 59011}, {59014, 30298, 
               30299, 30300, 59013}}], 
              PolygonBox[CompressedData["
1:eJwV1NV7F1QYAODDuoixJKw/wKBTReVGbPTWWLJipImKwFRGiIzBGIxS1yPs
LrobQbrbwFas93fxXpzne873nfjOuSF31PDyqBDCUOJIXBRCEsmk0J4OtKsN
IYpoYogljgd4kIcYzsM8wqiaEEYzhrGMYzzFlFBKGSMp51Ee43GeIIdc7pZr
GPdwL/dxP7PrQqhiDtXMZR6tE0NoYzkrWMkqRlSEUEQxJZRSxiQ1JjOFCl7m
FZZVhfAGb/IW9TQQPyGEBBJJIpkU2hFFNDHEEsexmSEc5wQnOcVp4u0hgUSS
SCaFfvRnAAMZxGDetqZ3eJf3eJ8PaKWN5axgJauop4FGmmimhR3sZBe72cNe
PucLvuQrvmY1H/IRH/MJn/IZadaUTgaZZJHNGrG1rGM9G9hIHvkUUMgIimhv
Tgc60olUOtODnvSiN33oyzjG8yRP8TTPMJLySN8xmjGM5VU1plLJNKYzgxOc
5BSnOcPZyL7dzWrWsJZ1rGcPe9nHN+znAOfMOc8FLnKJy5H96cUiiimhlDKe
5Tkm8Dwv8CI55JJHPgUUUsN8alnAQuqYyEtMYjJTqOAf/uU/QuTdEsUZ47Oc
4zwXuEgvsd70oS/96E9HOpFKZ9JIZwADGcRgbuU2utGda7iW67ieG7mJm7mF
HvQkg0yyyKYLXbmdIdzBndzFUH631j/4k7+4yt9c4Sd+5hd+5TcucZnv+J4f
+JF91e6P/RzgWw6y0NuuYxGLWcJS5jKPGuZTywIOmXOYIxzlGMcj+fTEQQ5x
mCMcJbXSOZJGOhlksk1sOzvYyS52kyWWTRe60o3uVKo9jenMYCavEe2MYogl
jngSaBRropkWWmkjx9+XSx75FFDIBrU3sonNbGEr9f7QBhppopkWZsn1OrOp
Yg7VbPIGNrOFrWxjO/8DdxS47w==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9255102040816326, 0.6837755102040816, 0.3690816326530611], 
            GraphicsGroupBox[{
              
              PolygonBox[{{39253, 39254, 39255, 39256, 39257, 39258}, {39259, 
               39260, 39261, 39262, 39263, 39264}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9306122448979591, 0.6965306122448979, 0.38489795918367337`], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwV1NdXkHUYB/D3dE5W2rpN00LFVFC7LRNFQcGtiOA2LTVTcLE3MlVGLkQB
cdy4wIE7R9PKlqvShgpUjv6IPu/F5+p7nvN7nvf5/d6IJekz054JgiCGHuQ0
BkEueeRTQCHTyoJgOjOYSRKz+KEpCH7kJ37mBje5yz1+5w/+5C+u8Q3f8h3X
+Z5kZpNCKnOYSzkVVFJFNZt4qzkIBjOEoUQRzYdbg2AZy1nBR6wkUa8TmcRk
pjCVBWoWsojFvM8SVjsjjXTWsJZ1vEZv+vA6fenHLW5zh1/4ld/4jM/5gi/5
iq/ZzBZqqKWOeto5zglOcooOxhFHPOOZQAKnOcNZznGeC0SYoT8DGEgkgzgk
O8wRjnKMtnA+32gd69lABpnclz3gIZ100c0bvBmeQ38GMJD1bCCDTLLIZh7z
WcBCFrGYi3zKJS5zhatEMijcM4MZwlCiiGYYwxnB2yw12wfh/lnGclYwo8F9
JYlZJDObArMVUkQxJZSSpyafAgopopiLNfrkEpe5wlX+lT3iMU94yn9sYzs7
2EkDu8ggkyyyySGXzd7YFmqopY56GmW72UMTzbTwkE666OZv/gn7VVNMCaVs
pIy9slb2sZ8DHKRcVkElVVSzidNmO8NZznGeC7RznBOc5BQdjLKDGEYzhljG
hvfbGbXUUc8nbGW0HYwhlrGMI46NdlBGORVUUsU7sncZyXuMIoYsWTY55Ib7
I59JsslMYSrTmE4845lAAolM5GM1q1hNGumsYa+slX3s5wAHebba/5LneJ4X
6EmGLDPsi2xyyKWX7EVe4mVe4VXyZPnhfaSQIoppZDd7aKKZFlJIZQ5zmcd8
DtnBYY5wlGO08T91t5L6
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9357142857142857, 0.7092857142857143, 0.40071428571428563`], 
            GraphicsGroupBox[{
              
              PolygonBox[{{40363, 40364, 40365, 40366, 40367, 40368}, {40381, 
               40382, 40383, 40384, 40385, 40386}, {40357, 40358, 40359, 
               40360, 40361, 40362}, {40387, 40388, 40389, 40390, 40391, 
               40392}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9408163265306122, 0.7220408163265306, 0.4165306122448979], 
            GraphicsGroupBox[{
              
              PolygonBox[{{59020, 31484, 31485, 31483, 59019}, {59022, 31486, 
               31487, 31488, 59021}}], 
              PolygonBox[CompressedData["
1:eJwV0bdWlUEUBtBDEDCRgxFBTI0BJIm0imS4IOFyCaKNCUyPYKGtjY0omF9I
suBrqAjuv9jFrG+ddWa+qZ2dT81lR0Q1eUy/iZjhDrPc5R73FyIe8JBHPGaO
UcYYJ80EGeZ5wlOe8ZwXXHwbcYnLXKGeBjZkm/xki21+cftlxAijjDFOmpZ3
Ea1co43rtPOJz3zhK9/4zlU7GmmimRZaKZOVU0ElVRzhht036eAWnXTxg2VW
WGWNdX6/ivjDX3b4xy57xOuILLLJIZduMz300kc/A0mPuk4zQYZJppKzN2eY
ZIppZqhacl+OcozjnOAk1ZyihlpOU8cZznKO81xg0O4UQwwnvTNCiayUMsqp
oJIFHb3nA4ss8ZFOuuimh1762Gcmj3wK2M8BDssKKaKYEko5KDuU5BRSRDH9
sgEGSTHEMPU0JP9MI0008x8vKKiA
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9459183673469388, 0.7347959183673468, 0.43234693877551006`], 
            GraphicsGroupBox[{
              
              PolygonBox[{{40327, 40328, 40329, 40330, 40331, 40332}, {40321, 
               40322, 40323, 40324, 40325, 40326}, {40369, 40370, 40371, 
               40372, 40373, 40374}, {40393, 40394, 40395, 40396, 40397, 
               40398}, {40399, 40400, 40401, 40402, 40403, 40404}, {40375, 
               40376, 40377, 40378, 40379, 40380}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9510204081632653, 0.7475510204081632, 0.4481632653061223], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwV1MVyFkEYBdAmCe4a3F2DvADuFnRNFa4vgLtrFQukCG6vgEOUBI3gTtC4
G5x/cWoWd+Z2f10z02vJ+vh1USGEOBqwMSGETWxmC1vZxt8zIeSRTwGFFPHz
VAi/+M0f/pLHk3MhPOUZz3nBS1JIJY3HpJNBsa4SSimjnIrIeroKKKSIYkoo
pYxyKqikine85wMf+cTnSK6rimpqqKWObFkOr3jNG97yz56CuesRRTQxjCCO
kYxiNGP4pyucdT9RRBPDJz2f+cJXvvGdXH7wk1/85g+DdA1mCEMZxnAqZVVU
U0MtdcyUzWI2c5hLPJmyLLLJ4RWvI/sw21e+8Z1cfjDZM1OYyjSmM4NqWQ21
1EXOhXA6hEeuiSSRTAqpPLDGQx6RSBLJdDkZQle60Z0e9KQ9HYilI53ozFJr
L2M5K1jJKnrJetOHvvSjP4dlRzjKMY5zgu3sYCe72M0eBnhmIIMYzBCGslq2
hrWsYz0bIu+BmaOIJob6NKD5+RBa0JJWtKYNbWlHezoQS0cSdJ3nAhe5xGXS
nN1j0smIfD885RnPecFLMsniljO9zR3uco/7zNM1nwUsZBGLKZaVUEoZ5VQw
VjaO8UxgIpO4wlWucZ0b3KShmRvRmCY0pRl7ZfvYzwEOcijy37BGHvkUUEgR
b3jLO97zgY/8B3hHW6U=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9561224489795919, 0.7603061224489795, 0.4639795918367346], 
            GraphicsGroupBox[{
              
              PolygonBox[{{40459, 40460, 40461, 40462, 40463, 40464}, {41371, 
               41372, 41373, 41374, 41375, 41376}, {41365, 41366, 41367, 
               41368, 41369, 41370}, {40453, 40454, 40455, 40456, 40457, 
               40458}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9612244897959183, 0.7730612244897959, 0.47979591836734686`], 
            GraphicsGroupBox[{
              
              PolygonBox[{{59028, 32673, 32671, 32672, 59027}, {59030, 32674, 
               32675, 32676, 59029}}], 
              PolygonBox[CompressedData["
1:eJwV0kVTUGEUBuArKkoIEn/ArXtbwnZjYbeiax07f4AbDAwsOg1QKVHs7u5u
3Vh0GQ+LZ+7inTPne8/cPqlLU5aEBEHQl1Ay04Igi2xyyCWP+blBsICFpLKI
xRzPCYIaTnCSWk4xUzaL2cxhLvOooJIqqjvnqWEZy1nBSlaxmiEMJYFEkkjm
LOc4zwUucok1rGUd69nARk5wklpOcZozHPLWw5RSxhGO0ihropkWWmmjnQ7+
8Jd/BHlB0IUQutKN7oTSg56EEU4EkfQz158BDGQQg8m2O4dc8singGOUU0El
VVSznR3sZBcZ7GYPe9nHfjLJ4qMdn/jMF77yjTTZZrawlW2kMzk9CKYwlWlM
Zwb5/okCCimimBJG6DaSUYxmDGM7+2foTwSR9CKKaHoTQyxxxNNc6O600kY7
HXzfFAQ/+MkvflPX+ZXVUU8DjTRxWbcrXOUa17lBdJG9xBBLHPGM0208E5jI
JFJ4beYNb3nHez5wnwc85BGPeUKh2xVRTAkHOMhN2S1uc4e73KOUMo5wlGOU
E+ZN4UQQSS+iSHDTRJJIZhjDeWrmGc95wUteUe9GDTTSRDMt/AfmLypz
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9663265306122449, 0.7858163265306122, 0.4956122448979591], 
            GraphicsGroupBox[{
              
              PolygonBox[{{41503, 41504, 41505, 41506, 41507, 41508}, {41497, 
               41498, 41499, 41500, 41501, 41502}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9714285714285714, 0.7985714285714285, 0.5114285714285713], 
            GraphicsGroupBox[{
              PolygonBox[{{59036, 33861, 33859, 33860, 59035}, {59038, 33862, 
               33863, 33864, 59037}}], 
              PolygonBox[CompressedData["
1:eJwN0sVWFVAUBuAjKvoarmUr0mFMbC/3UheewLmgKGF360BUUDEABZ3Yga2E
7WsYdNqIfoNv9K99/r3OOdPWlsVLE0II00nkxPEQajjJKU5Ty4v6EF7SRjsd
dBJpCiGXKDHyyGeoNoRhRhjlG98pkBVSRJxiSpjHfJJYQDIp/DDzk1/85g9j
RJr1EiVGHvlMrAthEpNJZApTuSy7QjMtXOUa2TpyWMgiFrOEdZRSxno2UE5X
Ywjd9NBLH/3UuaMznOUc9Zznr13H+UewxwQSuKD7IpdooJEmNurYRAWVVFHN
G9lb3vGeD3ykgEKKiFNMCY+8zWOe8JRnPOc6N7jJLW5zh09mPvOFr3TRzV3Z
Pe7zgFYecrAhhEMc5ghHOUaPmV766GeAQbbKtrGdHexkF6trQlhDhFyixEhq
8Q9IJoVU0mhzVjsddPKK16S6ozTSySCTLGYwk1nMZg5zWapjGctZwUpWsdtO
e9jLPvZzgHTdGWSSRTY5VMgqqaKazWxhwJ8YZIhhRhjlPynF+LQ=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9765306122448979, 0.8113265306122448, 0.5272448979591835], 
            GraphicsGroupBox[{
              
              PolygonBox[{{41557, 41558, 41559, 41560, 41561, 41562}, {41575, 
               41576, 41577, 41578, 41579, 41580}, {41569, 41570, 41571, 
               41572, 41573, 41574}, {41563, 41564, 41565, 41566, 41567, 
               41568}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9816326530612245, 0.8240816326530611, 0.5430612244897959], 
            GraphicsGroupBox[{
              
              PolygonBox[{{59046, 35050, 35051, 35052, 59045}, {59044, 35049, 
               35047, 35048, 59043}}], 
              PolygonBox[CompressedData["
1:eJwV0bdNA1AYhdEnCiZgAUYgxymQyFF0OBu8AMFggslJoiHZYGwyy5DjIBwX
p/p031+8+slkT6ImhFBHLZ+FEL745odf/pg6DiFClBhxErRp7XTQSRfdJLUU
aaaZIUO+GMI6G2yyxTYnRyGccsY5BYoktRRpppkhw4V2SYkrylTodbuPfgYY
ZIhhRhhljHEmyLLIEjmWWWHHjV322OeAQxq0RppopoXW6l7LscwKq6xR0q4o
U+GaG265454HHnli1maOeRbIslh9T1sjzzobbPLMC6+88c5H9b9sIkSJESfB
P6rojdM=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.986734693877551, 0.8368367346938775, 0.558877551020408], 
            GraphicsGroupBox[{
              PolygonBox[{{42445, 42446, 42447, 42448, 42449, 42450}, {42451, 
               42452, 42453, 42454, 42455, 42456}, {42619, 42620, 42621, 
               42622, 42623, 42624}, {42613, 42614, 42615, 42616, 42617, 
               42618}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9918367346938776, 0.8495918367346937, 0.5746938775510202], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwV0cVe1FEUAOArKvIagCBlbFRAJ4gJQEJsUWDGKVHB7sYXEBVz4UbewM6X
sYsXML7/4lvc370n7jm1+ZnR6aoQQh3VtD4JoY3VrGEt61i1EEITzbTQShsn
3J3kFKc5w1mucJVrXGeWG+TIc4ACRUocYZoZjnKM45SpcJApDnGYc5znAhe5
xOUor54KFClRpsIudrOHvYyxjw462cRmYsRJkKSLbnroZSujbGM7O9jJAFsY
ZIhhRmjQU2M0P5popoXv8yH84Ce/+M0iMXdxEiTpopseekmRJkOWgcfqMsgQ
w4ywn3EmmCRHnqdinvGcF7zkFa95w1ve8Z4P0TzFFChSokyFFGkyZOmjP6rr
z+NMMEmOPLXUUc/KaC408keNv/wjOC+hKtrHnH0QI06CJDe9m+MWt7nDPHe5
x30e8JBHfDTTT3zmC1/5xnq5NrCRdjroZKnay1hONSuoIUWaDFn66Oc/7UfS
bA==
               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[1., 0.8765306122448978, 0.6122448979591835], 
            GraphicsGroupBox[{
              
              PolygonBox[{{59054, 36238, 36239, 36240, 59053}, {59052, 36236, 
               36237, 36235, 59051}}], 
              PolygonBox[CompressedData["
1:eJwV0EVSA0AUBNAB4gmywd25AK5XwHXFAeAEuF4Ad0kICXZEXhZvMfWra7q6
c3N7bqs8hFBHjGIuhC+++eGXP2afQ5hjngUWWeKlEMIrb7yTJUezTAuttNFO
Bx9ueT4pUOSLsmII5VQQIUqMHbdd9tjngEOOOOaEU844Z1mnFVZZY50NLu5C
uOSKa264ZVxmgkmmmGaGQYYYZoRRxko9s3pSQYQoMeK6JkiSIk2Gbpkeeumj
nwFaaaOdDjrpIk2GSqqopoYoMeIkSJIqvf2dIEmKNBmyts6V9ibPJwVqqaOe
Bhpp4s4W9zzwyBPP/AMZ1H+n
               "]]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.8928571428571428, 0.6428571428571427], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwVzjc6AwAYgOH/MZhdwUh0OYlNJ8xyGl0wGZh0KVq4gJIqyiX0+hre6Vu+
1lR6YKYpIlpoZnsjYodd9tjngBJlKlSpUWd2M2KOeRZYZIlD7YgsOfIUGNcm
mCTFFNPcaQ3ueeCRJ5a1FTKsssY6WXLkKXDMCaeccU6RCy5po50EHXTSRTc9
9NJHP0muuOaGW0qUqVClRv3/mwbPvPDKG+98MMgQw4wwyhiffPHND7/EVsQf
6Xd/jA==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.9091836734693877, 0.6734693877551019], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwV0klXCFAUB/CrnHbN80AD21BEXyIRydoHqM9BKtRp06ZFFjikZPgKSnMb
hUYKGYoGjX4tfued8/7n3vPuPa/0VlNdY0JEFJBEeXfEGc5yjgoqqXkccZla
rnCVOq5xnXpu0MBNXjDAS17xmjc85Rm9PKePfnZ7IvbY54BD4mHE20cRgwzx
jmFGaOuKuMd9HtBOB7OdEXPMs8AiS2zot8kW2/xj5+jUa4dd9tjngOQnESmk
kkY6GWSSRTY55JLHoZowxzESSOQ48+4XWGSJz3xhmRW+8o3vrPLeW6eZ4QMf
+cQP2U9+8Zs11rlt5js0c5cWWhmVjTHOBJNMkWmnWWSTQy55/JH9ZYNNttg+
2oMshVTSSCeDYkoopYxTnCafAgop4gQnOe8PXaCKi1yimv+OWbrZ
               "]]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.9255102040816325, 0.704081632653061], 
            GraphicsGroupBox[{
              
              PolygonBox[{{43717, 43718, 43719, 43720, 43721, 43722}, {43825, 
               43826, 43827, 43828, 43829, 43830}, {43585, 43586, 43587, 
               43588, 43589, 43590}, {42649, 42650, 42651, 42652, 42653, 
               42654}, {43723, 43724, 43725, 43726, 43727, 43728}, {42655, 
               42656, 42657, 42658, 42659, 42660}, {43591, 43592, 43593, 
               43594, 43595, 43596}, {43831, 43832, 43833, 43834, 43835, 
               43836}}]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.95, 0.75], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwV0csywnEYh/HvoNDBuhmnXIFDdoQ7QFyB84ql0FVYOGXRwsYgxnERFZWN
wyZhhmyQRbHpwAw1nhafmfd5m3nn959aRmZc0xWSbDDgLyXlA1IWOfzSVR/S
alhaxgoq6Rz7wROpHwPI0kb2a/zuxToMdIb9zr60hW2k6Tr2PTGpF32w0gX2
Lu4MYRh5OgWTXzLDgnf6DTXMtajGK/2CiU1pElNI0s8YYx7HKJ7oazT6pHo0
4Iq+x8WGFEEUCfoO58whhBGnLbzRyVu70A0zfcu+iTvNsOOG/oKf79zFHj7p
S8x7pQV4EKOP0bEoOdCJIzpYfs+S9IBHnNGn5fcwJxBHgC6hwH/zjR8U6Sjm
uD0LNyL0Idq53Yo2HND/vp+g2A==
               "]], 
              PolygonBox[CompressedData["
1:eJwV1mPYHUcYBuATp2matFFjm00aNY1tO2nTxrZt27aTxrZt27aN3ufHfe31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               "]]}]}}}], {
        DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
         Identity, Frame -> True, FrameLabel -> {{
            FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
            FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}}, {{{0, 
              FormBox["0", TraditionalForm]}, {0.04, 
              FormBox["0.04`", TraditionalForm]}, {0.08, 
              FormBox["0.08`", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.04, 
              FormBox["0.04`", TraditionalForm]}, {0.08, 
              FormBox["0.08`", TraditionalForm]}}}}, GridLinesStyle -> 
         Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 310, 
         Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
         FormBox["\"(d)\"", TraditionalForm], 
         PlotRange -> {{0, 0.08}, {0, 1}}, PlotRangeClipping -> True, 
         PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
         Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
          "1", "5", "9", "13", "17", "21", "25", "29", "33", "37", "41", "45",
            "\"\[GreaterEqual]49\""}, "SwatchLegend", 
          DisplayFunction -> (FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"N\"", {FontFamily -> "Arial"}, Background -> Automatic, 
                    StripOnInput -> False]}, {
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0.95, 0.75]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #13}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1., 0.8833333333333333, 0.6249999999999999]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #12}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.9833333333333334, 0.8283333333333334, 
                    0.5483333333333333]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #11}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.9625, 0.77625, 0.48374999999999996`]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #10}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.9416666666666667, 0.7241666666666666, 
                    0.4191666666666666]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #9}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.9208333333333334, 0.6720833333333334, 
                    0.35458333333333336`]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #8}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.9, 0.62, 0.29]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #7}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.7695833333333333, 0.5741666666666667, 
                    0.3666666666666667]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #6}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.6391666666666667, 0.5283333333333333, 
                    0.44333333333333336`]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #5}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.50875, 0.48250000000000004`, 0.52]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #4}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.3783333333333333, 0.43666666666666665`, 
                    0.5966666666666667]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #3}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[
                    0.253, 0.38833333333333336`, 0.6383333333333334]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.148, 0.33, 0.54]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"]}}, GridBoxAlignment -> {"Columns" -> {{Center}}}, 
                 AutoDelete -> False, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]& ), 
          InterpretationFunction :> (RowBox[{"SwatchLegend", "[", 
             RowBox[{"\"M10DefaultDensityGradient\"", ",", 
               RowBox[{"{", 
                 
                 RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, 
                   ",", #7, ",", #8, ",", #9, ",", #10, ",", #11, ",", #12, 
                   ",", #13}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"N\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Grid", "[", 
                    RowBox[{"Reverse", "[", "#1", "]"}], "]"}], "&"}], 
                   ")"}]}]}], "]"}]& ), Editable -> True], TraditionalForm], 
        TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.745078043655285*^9, 3.745078762732864*^9, 3.745078810784926*^9, 
   3.745146880479369*^9, {3.748786704264166*^9, 3.748786779537334*^9}, 
   3.7487868102128983`*^9, 3.752325515524439*^9, {3.752325631238474*^9, 
   3.75232564019255*^9}, 3.752325691213631*^9, 3.752325763049354*^9, 
   3.752332571715067*^9, 3.7523326019671874`*^9, 3.7523378508854256`*^9, 
   3.752385774252241*^9, {3.752385905915389*^9, 3.752385955241044*^9}, {
   3.752386028481845*^9, 3.752386043217786*^9}, 3.7529310182956796`*^9, 
   3.752931117493722*^9, 3.7529311687335095`*^9, 3.752931282309947*^9, 
   3.7529313596619444`*^9, 3.752931533870098*^9, {3.7529315952359934`*^9, 
   3.752931630036563*^9}, 3.7529317865354*^9, 3.753016075321458*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<machineworkplots.pdf\>\"", ",", "machineworkplots"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.745078815004195*^9, 3.745078822989397*^9}, {
  3.75238624415862*^9, 3.7523862448618193`*^9}, {3.7529316752913985`*^9, 
  3.7529316754632797`*^9}}],

Cell[BoxData["\<\"machineworkplots.pdf\"\>"], "Output",
 CellChangeTimes->{3.745078824895819*^9, 3.745146907701025*^9, 
  3.748786817578452*^9, 3.7523858235856075`*^9, 3.752385932849225*^9, 
  3.7523862493891425`*^9, 3.752931682113561*^9, 3.7529317947393985`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FIG 10. Full batch machine", "Title",
 CellChangeTimes->{
  3.7522836134864845`*^9, {3.752339558512771*^9, 3.752339561035277*^9}, {
   3.753008474431975*^9, 3.7530084771976786`*^9}}],

Cell[CellGroupData[{

Cell["(a)", "Chapter",
 CellChangeTimes->{{3.7530162348230095`*^9, 3.753016235432449*^9}}],

Cell["Compile \[OpenCurlyQuote]fullbatchmachinen.c\[CloseCurlyQuote]", "Text",
 CellChangeTimes->{{3.7558742983873234`*^9, 3.7558743053565836`*^9}, {
  3.7558743383446693`*^9, 3.755874382796315*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Run", "[", 
  "\"\<START /B gcc c\\\\functions.c c\\\\fullbatchmachinen.c -o \
c\\\\fullbatchmachinen\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7530169132081594`*^9, 3.753016914255336*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530169199588213`*^9, 3.7530252742239943`*^9}]
}, Open  ]],

Cell["\<\
Create a function that runs \[OpenCurlyQuote]fullbatchmachinen.exe\
\[CloseCurlyQuote] for a set of inputs and sends the output to an \
appropriately named .dat file\
\>", "Text",
 CellChangeTimes->{{3.755874583020319*^9, 3.755874658466021*^9}, 
   3.7558747932456183`*^9, 3.7558760846632338`*^9, 3.755876146997937*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fullbatchmachinen", "[", 
   RowBox[{"asteps_", ",", "ksteps_", ",", "maxn_"}], "]"}], ":=", 
  RowBox[{"Run", "[", 
   RowBox[{"\"\<START /B c\\\\fullbatchmachinen \>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", 
    "\"\< > data\\\\fullbatchmachinen-asteps\>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\<-ksteps\>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\<-maxn\>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\<.dat\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.753016891705823*^9, 3.7530169001757*^9}, 
   3.753016941836197*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fullbatchmachinen", "[", 
  RowBox[{"100", ",", "100", ",", "9"}], "]"}]], "Input",
 CellChangeTimes->{{3.7530169263345037`*^9, 3.753016950040373*^9}, {
  3.753017232824337*^9, 3.75301724032518*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.753016950555823*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ncontourplotfullextract", "=", 
  RowBox[{"ListContourPlot", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<data\\\\fullbatchmachinen-asteps100-ksteps100-maxn9.dat\>\"", 
      "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"InterpolationOrder", "\[Rule]", "0"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", "\"\<\[Alpha]\>\""}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<(a)\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.25"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.25"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"SwatchLegend", "[", "\[IndentingNewLine]", 
      RowBox[{"\"\<M10DefaultDensityGradient\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{"1", ",", "7", ",", "2"}], "]"}], "~", "Join", "~", 
        RowBox[{"{", "\"\<\[GreaterEqual]9\>\"", "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"LegendLayout", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Grid", "[", 
           RowBox[{"Reverse", "[", "#", "]"}], "]"}], "&"}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"LegendLabel", "\[Rule]", "\"\<N\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7410758889846563`*^9, 3.7410759187219954`*^9}, {
  3.741076001949724*^9, 3.741076016842185*^9}, {3.741076082005471*^9, 
  3.7410761203218794`*^9}, {3.7487871530285006`*^9, 3.748787160231657*^9}, {
  3.752339633189804*^9, 3.7523396700988064`*^9}, {3.7523405661495175`*^9, 
  3.75234056898989*^9}, {3.752340666387139*^9, 3.7523406674750834`*^9}, {
  3.75301701843804*^9, 3.753017022500972*^9}, {3.7530172465289574`*^9, 
  3.7530172730004854`*^9}, {3.753017320690082*^9, 3.753017336613599*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[
    GraphicsComplexBox[CompressedData["
1:eJyMvX2sZdd53kcFSVteFQ4i0kU/5KHdJu4wRuFYo/SPOkMGbmNd5qPxjNKg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     "], {{{}, {
        EdgeForm[], 
        RGBColor[0.22675, 0.37375, 0.61375], 
        GraphicsGroupBox[{
          
          PolygonBox[{{59203, 1, 58807, 59599}, {59201, 58805, 58806, 
           59202}, {59600, 58808, 2, 59204}}], 
          PolygonBox[CompressedData["
1:eJwl2Hf8VfMfB/DT0N7SoklTNGhrknZaoqRFpaSUVWjvjBKlRUPTaBAtqbTT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           "]], 
          PolygonBox[CompressedData["
1:eJwk3WW0VdUaAFCkuxukpLu7pUFKurtERKQFpLtLuqW7u1tauru7mzf3eD/m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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[0.6065625, 0.516875, 0.4625], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58814, 598, 599, 600, 58813}, {58820, 1785, 1783, 1784,
            58819}, {58822, 1786, 1787, 1788, 58821}, {58812, 597, 595, 596, 
           58811}}], 
          PolygonBox[CompressedData["
1:eJwU3HPYV+cbAPBcy7Zdy1xYtm3btralpV9atWrZtm3bWta2bPf7nD8+19n3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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[0.915625, 0.6590625, 0.33843749999999995`], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58836, 4161, 4159, 4160, 58835}, {58838, 4162, 4163, 
           4164, 58837}, {58854, 6538, 6539, 6540, 58853}, {58844, 5349, 5347,
            5348, 58843}, {58830, 2974, 2975, 2976, 58829}, {58852, 6537, 
           6535, 6536, 58851}, {58828, 2973, 2971, 2972, 58827}, {58846, 5350,
            5351, 5352, 58845}}], 
          PolygonBox[CompressedData["
1:eJwU3WW4VdUWAFAe0t0lIZ0iDdLd3SAC0t0d0t3dKSUt0t0t3d3d3byxf4zv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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[0.978125, 0.8153125, 0.5321874999999999], 
        GraphicsGroupBox[{
          
          PolygonBox[{{58878, 10102, 10103, 10104, 58877}, {58884, 11289, 
           11287, 11288, 58883}, {58886, 11290, 11291, 11292, 58885}, {58860, 
           7725, 7723, 7724, 58859}, {58868, 8913, 8911, 8912, 58867}, {58862,
            7726, 7727, 7728, 58861}, {58870, 8914, 8915, 8916, 58869}, {
           58876, 10101, 10099, 10100, 58875}}], 
          PolygonBox[CompressedData["
1:eJwV22O4XccaAODT2LZt27ZtNcltmzZqGtu2rcZWGdu2bdvNfdePN/s5+9uj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           "]]}]}, {}, {
        EdgeForm[], 
        RGBColor[1., 0.95, 0.75], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwV1HtMVmUcwPHfUsxCuwH+o1hNUUssC7ESpDY024S8d1HLEjS3RDTNSiwr
0NyUankPKyu6mGitNNvQotTKRGpDs00sTdMudhWrzUt9zh+f8X6fc97zPs9z
DufyieUjp50TEcWkMPtoxCVlEWmk86BuZcTmiGEM54T+jQ3vRrzNO/yq/2ak
46MYzUl9nPWOr6OOX/QFxyIKdkTcyE101P2Y0RJRznRydDueb4ioYTUpOpvd
+yJ20Uhvfdo1T9abF62c0m2Nr/KdFaykjW4xPmltRAml7NdHOG9DxLm057Du
4NyB5pVHPqnJ/Iz/OSTid/4gR/c3/oC5zmQWufpssg/m8A//ckbnG884ZE9J
J09PNv5FiXXQyCR9lfEma/qSr+ije3Bls3WSTZbu6tx2A8yZ9mQmc2Zr34h6
tpCqu5DieBva0ln34K0C94M6snQ2xYURQymit36dnxe6XxznNd2dtb7zBm/S
Taebz6GdEd9xkDTdyfjEXPtMKRnJPedD8/qIBjom13PuFdbUk150S9bGgqaI
p1hIpk537r2uM4F7SEvWZny+45VU0Vn3N/6Xe3OCVnKTPeVWaxrGcProTs79
3lwPc4QMPdV42ZSI+5ma/NVHOd8zkUoHftCzuNj/xYVcxMxkXXy9PGIf37BV
b+eRmoiHeJht+lPm+FzBXHbopzk7J+I/oiKiWi9g7OyIcYxnvv6WyZ7Z+5jC
gWRdyfgYe89BivXNDBjhGSOfwbqRzDX2iC7s0kUc8J39tDBUj+aJsRHzeJxR
ejxZE9wbujNOD+IG176O6ynUTXR17Uu5jN16WsJeljOdMl3LT56nY/zIq3oj
1zwXcTV9eU/XUV0dsYjFrNMvJuurihjCLbygVzPY50IGUaOX88o816aWZXop
L/v8EmtYovfwca1nkgaa9Rb2uofN7KFeL+aM+3OK0yxK3n3JvTOvZ3iW9fp9
rjX/HPqxSRck8ynyHmIlA5NnhU/83ja2s1ffxpP2vJIqxui5bJphP9hIhS5l
p/fFZ3xOiX4s+W3HN/MBjybvHJb5vSUsJU/fnfz/u4c96cVduoo7PWO3cweV
+n/lqL6L
           "]], 
          PolygonBox[CompressedData["
1:eJwU3FPUXFcYANDYtu2kQWOnsW3btm3btm3bdtK4cds4aZzuedhr1sw3x7jn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           "]]}]}}}], {
    DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
     Identity, Frame -> True, FrameLabel -> {{
        FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}, {{{0, 
          FormBox["0", TraditionalForm]}, {0.25, 
          FormBox["0.25`", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.25, 
          FormBox["0.25`", TraditionalForm]}}}}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 300, 
     Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
     FormBox["\"(a)\"", TraditionalForm], PlotRange -> {{0, 0.25}, {0, 1}}, 
     PlotRangeClipping -> True, PlotRangePadding -> {Automatic, Automatic}, 
     RotateLabel -> False, Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"1", "3", "5", "7", "\"\[GreaterEqual]9\""}, "SwatchLegend",
       DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               "\"N\"", {FontFamily -> "Arial"}, Background -> Automatic, 
                StripOnInput -> False]}, {
               TagBox[
                GridBox[{{
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0.95, 0.75]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #5}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.9625, 0.77625, 0.48374999999999996`]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #4}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.9, 0.62, 0.29]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #3}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.50875, 0.48250000000000004`, 0.52]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}, {
                   GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.148, 0.33, 0.54]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 AutoDelete -> False, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"]}}, GridBoxAlignment -> {"Columns" -> {{Center}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"SwatchLegend", "[", 
         RowBox[{"\"M10DefaultDensityGradient\"", ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", "\"N\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", 
             RowBox[{"(", 
               RowBox[{
                 RowBox[{"Grid", "[", 
                   RowBox[{"Reverse", "[", "#1", "]"}], "]"}], "&"}], 
               ")"}]}]}], "]"}]& ), Editable -> True], TraditionalForm], 
    TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.741075946349972*^9, 3.741076053127118*^9, 3.741076148387395*^9, 
   3.7451646000924253`*^9, 3.745313131609625*^9, 3.7487871899005194`*^9, 
   3.752339609919464*^9, 3.7523397025635138`*^9, 3.7523405957670956`*^9, 
   3.752340628597574*^9, 3.752340699328203*^9, 3.7530170549262877`*^9, 
   3.7530172968594074`*^9, {3.753017350583832*^9, 3.7530173731487293`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["(b)", "Chapter",
 CellChangeTimes->{{3.753016239104486*^9, 3.7530162426050873`*^9}}],

Cell["Compile \[OpenCurlyQuote]fullbatchmachinework.c\[CloseCurlyQuote]", \
"Text",
 CellChangeTimes->{{3.7558742983873234`*^9, 3.7558743053565836`*^9}, {
  3.7558743383446693`*^9, 3.7558744011107473`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Run", "[", 
  "\"\<START /B gcc c\\\\functions.c c\\\\fullbatchmachinework.c -o \
c\\\\fullbatchmachinework\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7530179781260586`*^9, 3.7530179795637455`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.753018016489506*^9, 3.7530252770211744`*^9}]
}, Open  ]],

Cell["\<\
Create a function that runs \[OpenCurlyQuote]fullbatchmachinework.exe\
\[CloseCurlyQuote] for a set of inputs and sends the output to an \
appropriately named .dat file\
\>", "Text",
 CellChangeTimes->{{3.755874583020319*^9, 3.755874658466021*^9}, 
   3.7558747932456183`*^9, 3.7558760846632338`*^9, 3.755876146997937*^9, 
   3.755876391554963*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fullbatchmachinework", "[", 
   RowBox[{"asteps_", ",", "ksteps_", ",", "maxn_"}], "]"}], ":=", 
  RowBox[{"Run", "[", 
   RowBox[{"\"\<START /B c\\\\fullbatchmachinework \>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", 
    "\"\< > data\\\\fullbatchmachinework-asteps\>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\<-ksteps\>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\<-maxn\>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\<.dat\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.753017982767383*^9, 3.753017987705364*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fullbatchmachinework", "[", 
  RowBox[{"20", ",", "20", ",", "9"}], "]"}]], "Input",
 CellChangeTimes->{{3.7530180267562504`*^9, 3.753018071401813*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530180431329556`*^9}]
}, Open  ]],

Cell[TextData[{
 "Create a function that takes in a data file that contains the full batch \
machine work for various values of ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " and \[Alpha] and outputs a file containing the ratio of the full batch \
machine work to the Markov machine work at the same points."
}], "Text",
 CellChangeTimes->{{3.7558750200978775`*^9, 3.755875103059738*^9}, {
  3.755876018296636*^9, 3.7558760405335674`*^9}, {3.756036924204828*^9, 
  3.756036930048951*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fullbatchmachineratio", "[", "fullbatchworkdatafilename_", "]"}], ":=",
   "\[IndentingNewLine]", 
  RowBox[{"Export", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"StringReplace", "[", 
     RowBox[{"fullbatchworkdatafilename", ",", 
      RowBox[{
      "\"\<fullbatchmachinework\>\"", "\[Rule]", 
       "\"\<fullbatchmachineratio\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{"#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{
         RowBox[{"#", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
         "/", 
         RowBox[{"markovwork", "[", 
          RowBox[{
           RowBox[{
           "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
           RowBox[{
           "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
          "]"}]}]}], "}"}], "&"}], "/@", 
     RowBox[{"Import", "[", "fullbatchworkdatafilename", "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.7530179940339875`*^9, 3.7530180090514355`*^9}, {
  3.75301815339467*^9, 3.7530182065878315`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fullbatchmachineratio", "[", 
  "\"\<data\\\\fullbatchmachinework-asteps20-ksteps20-maxn9.dat\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.7530182316373663`*^9, 3.753018240075983*^9}}],

Cell[BoxData[
 TemplateBox[{
  "Power","infy",
   "\"Infinite expression \\!\\(\\*FractionBox[\\\"1\\\", \\\"0.`\\\"]\\) \
encountered.\"",2,846,186,32812289312203059463,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7530182440449247`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Infinity","indet",
   "\"Indeterminate expression \\!\\(\\*RowBox[{\\\"0.`\\\", \\\" \\\", \
\\\"ComplexInfinity\\\"}]\\) encountered.\"",2,846,187,32812289312203059463,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.753018244123059*^9}],

Cell[BoxData[
 TemplateBox[{
  "Power","infy",
   "\"Infinite expression \\!\\(\\*FractionBox[\\\"1\\\", \\\"0.`\\\"]\\) \
encountered.\"",2,846,188,32812289312203059463,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.753018244185562*^9}],

Cell[BoxData[
 TemplateBox[{
  "Infinity","indet",
   "\"Indeterminate expression \\!\\(\\*RowBox[{\\\"0.`\\\", \\\" \\\", \
\\\"ComplexInfinity\\\"}]\\) encountered.\"",2,846,189,32812289312203059463,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7530182442636952`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Power","infy",
   "\"Infinite expression \\!\\(\\*FractionBox[\\\"1\\\", \\\"0.`\\\"]\\) \
encountered.\"",2,846,190,32812289312203059463,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7530182443262043`*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Power\\\", \\\"::\\\", \
\\\"infy\\\"}], \\\"MessageName\\\"]\\) will be suppressed during this \
calculation.\"",2,846,191,32812289312203059463,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7530182443887177`*^9}],

Cell[BoxData[
 TemplateBox[{
  "Infinity","indet",
   "\"Indeterminate expression \\!\\(\\*RowBox[{\\\"0.`\\\", \\\" \\\", \
\\\"ComplexInfinity\\\"}]\\) encountered.\"",2,846,192,32812289312203059463,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7530182444512157`*^9}],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"Infinity\\\", \
\\\"::\\\", \\\"indet\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,846,193,32812289312203059463,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.753018244513722*^9}],

Cell[BoxData["\<\"data\\\\fullbatchmachineratio-asteps20-ksteps20-maxn9.dat\"\
\>"], "Output",
 CellChangeTimes->{3.753018244591855*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"workcontourplotfullextract", "=", 
  RowBox[{"ListContourPlot", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<data\\\\fullbatchmachineratio-asteps20-ksteps20-maxn9.dat\>\"", 
      "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", "\"\<\[Alpha]\>\""}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<(b)\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.25"}], "}"}], ",", "All", ",", "All"}], "}"}]}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.25"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"BarLegend", "[", "\[IndentingNewLine]", 
      RowBox[{"Automatic", ",", "\[IndentingNewLine]", 
       RowBox[{"Ticks", "\[Rule]", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "}"}], "&"}], "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], 
             "}"}]}], "}"}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"LegendLabel", "\[Rule]", "\"\<Ratio of\\nmachines\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Contours", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7451679107308626`*^9, 3.7451679575796556`*^9}, {
   3.7451680176799326`*^9, 3.745168021695979*^9}, 3.748787168934767*^9, {
   3.7523396786920357`*^9, 3.752339682679639*^9}, {3.7523397549662886`*^9, 
   3.7523397582105584`*^9}, {3.7523397954361143`*^9, 3.752339843118128*^9}, {
   3.752340560497373*^9, 3.752340560957061*^9}, {3.752386292995122*^9, 
   3.752386293078343*^9}, {3.7530182674226456`*^9, 3.753018347555934*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[
    GraphicsComplexBox[CompressedData["
1:eJx13HuUG9V9wHHTHrscIG1oSUkIgcPDDlBsniUkFCaF0BBKCoHyKIGelIcP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     "], {{{
        EdgeForm[], 
        RGBColor[0.148, 0.33, 0.54], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNnXXcFtXTh++tW1AUA1RUUBEUCztRUGwUu7u725+F3d3diK3YrYhiBwai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           "]], 
          PolygonBox[CompressedData["
1:eJwlkEtOAlEQRQu6qU2oGBeg+EVloAnCBiAkKKiJE2c60giiUaeYuABlIGxD
YR2iS/F3bmpwkvP6Vd9XVQsn57WzrJnNQApFN+vy4Stjto6fwkvObAAj/AqO
KPyGPn4H7TS+6W4NPvm3Q8aGR4ayprCIr8JHJmpUW4BeNt5cwndhLjG75byC
78Mb5zG08E2P7GvYwhvwzt08VPAS3HA3y3kHf4QfejuGe3zg0fsvPOFVyCfx
Rh0/gEkSmU18zyNLNap9hb80Mp89MpV9CA8emcrWzob4tkev6km9aQbNop1d
eOxUu1Wmsi89stSDetEOtAvtaNljRs2qHZXxf+iENh4=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.7677411263491078, 0.5735192456817951, 0.3677496254049973], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtUsdKREEQHHS3vsFw8gPMazwoGC7mgLABBPeggqBgPrpejODNiIj6D8b/
WtPFKqoPRb3u6Z6urnlN5Y259ZqUUi9RS3QipT0mOsiHxF8mpQr5KpvSTdbx
L3HN70vinU2NxCvxxfwPUcq4/i/iC/bfMr6Ha+ujPs+zIlElmnm2z7k5MTzj
IPo0V/Ne2FNHNBAz8OwpOK/cGzEe8Srco15pqcasb6I9dAySB+DefvIOXFMi
zxMfzI/GPVexbylqCuRCxjtr32fGdzxfIT+Fbu19BM8+IU/DGmfJbaFBWvLw
HcXYW3OkU3fcxQ6VeItz8hDxyd4RWJ90DpN7YX96yGVY2xJ5E/Z6m/wA378M
n6nmmDwGv8ka+Sx06B0WY88tcgv8dq1wneonYe/kYR/su/yfgPfRXrvyJvx5
hHVL/wK5K/43/Xe5+Ae6Yb/k2ynco155/A/NE1eY
           "]], 
          PolygonBox[CompressedData["
1:eJwtkTdOA0AQRVcOcwRiRUeFaUgig4QwwYAJNiCB5AI6kEimRDRGpBIwFkEc
gngvYsP7mi2e9DbNzM60lLbzW4kQQiukoGwhfCMrsI+PQ2MyhHrI4sPwijfB
AH4Ht+kQbuASz8T7zdCOj8J70t/obb95LN1pwzehlvYYT/geFMn9CRW8Cxq4
Wwe95sjLFN2B5+CN9QtM4HOxPuVcwDvhMOE5lXsKnmM9M/hQfP8BI/gJfJF7
GdbwR7imth/WVfwAVlO+XsfHYn2KOYkvmsfS+yV819y1lzdHrpyzeI95LxWj
Gz+HP+Ui5715DuXS3jE+bf5X9U+zuYjzuuL+g3KZz049LOAb5mf6g/6iGWlW
v5yf4UfmrhiafTXmUw9KeF/st+rTXwfNZ6v61TvVqFo1wxp+aj47xVNthThP
zWPevCfqh3pYNJ+RznRnB/8H8ORPAQ==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9204213381611424, 0.6710533454028558, 0.3533061482995412], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtj7kKAlEMRYNLPsLO/7AW92VwaURE0HJG1EawdEOwcSm00Y/QP9PeE16K
y8lkbpL78uMkilMikkNpNFKRX0ZkC1eoQz2Da9SlTmDF6wa8ZkVu6IJi99vc
Bn2pd+6x/2c057tHvwOr6M3RIoxQn/4CltGHfgk+ff4Eh57toGHGZgsafOav
a9hr+9uw6Xlq8KUh5xSOvb7Dgb/F3rf3zEsN9+zuUYPP/Laj5Tkt70PDmybw
DwevKHY=
           "]], 
          
          PolygonBox[{{1649, 1110, 1268, 1668}, {1638, 1429, 1428, 1695}, {
           1652, 1268, 1110, 1650}, {1674, 1428, 1426, 1673}, {1637, 1426, 
           1427, 1692}, {1672, 1269, 1427, 1633}, {1673, 1426, 1268, 1671}, {
           1670, 1268, 1426, 1690}, {1633, 1427, 1429, 1634}, {1692, 1427, 
           1269, 1632}, {1617, 1110, 1108, 1615}, {1669, 1269, 1111, 1629}, {
           1629, 1111, 1109, 1628}, {1614, 1109, 1111, 1616}, {1651, 1111, 
           1269, 1630}, {1648, 1108, 1110, 1649}}], 
          
          PolygonBox[{{1607, 948, 1611, 1640, 1641}, {1641, 1640, 1612, 1108, 
           1646}, {1644, 1643, 1613, 949, 1645}, {1647, 1109, 1610, 1643, 
           1644}}]}]}, {
        EdgeForm[], 
        RGBColor[
        0.9619702919214687, 0.7749257298036717, 0.48210790495655287`], 
        GraphicsGroupBox[{
          
          PolygonBox[{{1629, 1267, 1669}, {1646, 1106, 1641}, {1649, 1266, 
           1648}, {1663, 1266, 1680}, {1690, 1424, 1670}, {1641, 1106, 
           1607}, {1644, 1107, 1647}, {1668, 1266, 1649}, {1692, 1425, 
           1637}, {1682, 1267, 1667}, {1628, 1267, 1629}, {1645, 1107, 
           1644}, {1632, 1425, 1692}, {1685, 1424, 1635}}], 
          
          PolygonBox[{{1670, 1424, 1266, 1668}, {1637, 1425, 1424, 1690}, {
           1687, 1425, 1267, 1682}, {1669, 1267, 1425, 1632}, {1680, 1266, 
           1424, 1685}, {1635, 1424, 1425, 1687}}], 
          
          PolygonBox[{{1667, 1267, 1628, 1660, 1661}, {1642, 1106, 1646, 1657,
            1658}, {1658, 1657, 1648, 1266, 1663}, {1661, 1660, 1647, 1107, 
           1662}}]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.8812615861817442, 0.6211154740907704], 
        GraphicsGroupBox[{
          
          PolygonBox[{{1662, 1265, 1661}, {1658, 1264, 1642}, {1661, 1265, 
           1667}, {1663, 1264, 1658}}], 
          
          PolygonBox[{{1686, 1685, 1635, 1636}, {1636, 1635, 1687, 1688}, {
           1688, 1687, 1682, 1683}, {1681, 1680, 1685, 1686}}], 
          
          PolygonBox[{{1659, 1264, 1663, 1680, 1681}, {1683, 1682, 1667, 1265,
            1684}}]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.95, 0.75], 
        GraphicsGroupBox[{
          
          PolygonBox[{{1686, 1422, 1681}, {1684, 1423, 1683}, {1683, 1423, 
           1688}, {1688, 1423, 1636}, {1681, 1422, 1659}}], 
          PolygonBox[{{1636, 1423, 1422, 1686}}]}]}}, {{}, 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[{1659, 1681, 1686, 1636, 1688, 1683, 1684}]}, "6"], 
        Annotation[#, 6, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{1642, 1658, 1663, 1680, 1685, 1635, 1687, 1682, 1667, 1661,
            1662}]}, "5"], Annotation[#, 5, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{1607, 1641, 1646, 1657, 1648, 1649, 1668, 1670, 1690, 1637,
            1692, 1632, 1669, 1629, 1628, 1660, 1647, 1644, 1645}]}, "4"], 
        Annotation[#, 4, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{1596, 1606, 1611, 1640, 1612, 1615, 1617, 1620, 1650, 1652,
            1671, 1673, 1674, 1677, 1695, 1638, 1696, 1689, 1634, 1633, 1672, 
           1630, 1651, 1618, 1616, 1614, 1610, 1643, 1613, 1608, 1609}]}, 
         "3"], Annotation[#, 3, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{1581, 1588, 1590, 1597, 1582, 1583, 1584, 1585, 1599, 1600,
            1602, 1604, 1621, 1622, 1624, 1626, 1654, 1631, 1666, 1665, 1676, 
           1694, 1691, 1697, 1699, 1639, 1698, 1679, 1693, 1678, 1675, 1656, 
           1664, 1655, 1653, 1627, 1625, 1623, 1619, 1605, 1603, 1601, 1598, 
           1594, 1593, 1592, 1591, 1595, 1589, 1587, 1586}]}, "2"], 
        Annotation[#, 2, "Tooltip"]& ], {}, {}}}], {
    DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
     Identity, Frame -> True, FrameLabel -> {{
        FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}, {{{0, 
          FormBox["0", TraditionalForm]}, {0.25, 
          FormBox["0.25`", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.25, 
          FormBox["0.25`", TraditionalForm]}}}}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 300, 
     Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
     FormBox["\"(b)\"", TraditionalForm], PlotRange -> {{0, 0.25}, All}, 
     PlotRangeClipping -> True, PlotRangePadding -> {Automatic, Automatic}, 
     RotateLabel -> False, Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               "\"Ratio of\\nmachines\"", {FontFamily -> "Arial"}, Background -> 
                Automatic, StripOnInput -> False]}, {
               GraphicsBox[{{}, {}, 
                 
                 RasterBox[{{{0.148, 0.33, 0.54}}, {{0.7677411263491078, 
                  0.5735192456817951, 0.3677496254049973}}, {{
                  0.9204213381611424, 0.6710533454028558, 
                  0.3533061482995412}}, {{0.9619702919214687, 
                  0.7749257298036718, 0.4821079049565529}}, {{1., 
                  0.8812615861817442, 0.6211154740907704}}, {{1., 0.95, 
                  0.75}}}, {{
                    Rational[-15, 2], -150}, {
                    Rational[15, 2], 150}}], {Antialiasing -> False, 
                  AbsoluteThickness[0.1], 
                  Directive[
                   Opacity[0.3], 
                   GrayLevel[0]], 
                  LineBox[
                   NCache[{{
                    Rational[15, 2], -150}, {
                    Rational[-15, 2], -150}, {
                    Rational[-15, 2], 150}, {
                    Rational[15, 2], 150}, {
                    Rational[15, 2], -150}}, {{
                    7.5, -150}, {-7.5, -150}, {-7.5, 150}, {7.5, 150}, {
                    7.5, -150}}]]}, {
                  CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -100.}, {
                    Rational[15, 2], -100.}}, {{-7.5, -100.}, {
                    7.5, -100.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -50.000000000000014`}, {
                    Rational[
                    15, 2], -50.000000000000014`}}, {{-7.5, \
-50.000000000000014`}, {7.5, -50.000000000000014`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -2.842170943040401*^-14}, {
                    Rational[
                    15, 2], -2.842170943040401*^-14}}, {{-7.5, \
-2.842170943040401*^-14}, {7.5, -2.842170943040401*^-14}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 49.99999999999997}, {
                    Rational[15, 2], 49.99999999999997}}, {{-7.5, 
                    49.99999999999997}, {7.5, 49.99999999999997}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 99.99999999999994}, {
                    Rational[15, 2], 99.99999999999994}}, {{-7.5, 
                    99.99999999999994}, {7.5, 99.99999999999994}}]]}}}, {
                 Antialiasing -> False, 
                  StyleBox[
                   LineBox[{{7.5, -150.}, {7.5, 150.}}], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -100.00000000000001`}, 
                    Offset[{4., 0}, {7.5, -100.00000000000001`}]}, {{
                    7.5, -50.00000000000001}, 
                    Offset[{4., 0}, {7.5, -50.00000000000001}]}, {{
                    7.5, -1.8894276654612612`*^-14}, 
                    Offset[{4., 0}, {7.5, -1.8894276654612612`*^-14}]}, {{7.5,
                     49.999999999999986`}, 
                    Offset[{4., 0}, {7.5, 49.999999999999986`}]}, {{7.5, 
                    99.99999999999996}, 
                    Offset[{4., 0}, {7.5, 99.99999999999996}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["2", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -100.00000000000001`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["3", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -50.00000000000001}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -1.8894276654612612`*^-14}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["5", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 49.999999999999986`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 99.99999999999996}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                Scaled[0.02], PlotRange -> All, Frame -> True, 
                FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                Opacity[0], FrameTicksStyle -> Opacity[0], 
                ImageSize -> {Automatic, 300}, BaseStyle -> {}]}}, 
             GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.`", ",", "6.016998681654317`"}], "}"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"3", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"4", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"5", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"6", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLabel", "\[Rule]", "\"Ratio of\\nmachines\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "300"}], ",", 
           RowBox[{"Ticks", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"5", ",", "5"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"6", ",", "6"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.745167898198277*^9, 3.7451679581422105`*^9}, 
   3.745168105017469*^9, 3.7453131320940514`*^9, 3.7487871902624807`*^9, 
   3.752339610604286*^9, 3.7523397051714497`*^9, 3.7523397660394535`*^9, {
   3.75233979858243*^9, 3.7523398441383796`*^9}, 3.75234056182621*^9, 
   3.7523406291781187`*^9, 3.7523862944240465`*^9, 3.75301827967371*^9, {
   3.7530183390081367`*^9, 3.7530183482903724`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["(c)", "Chapter",
 CellChangeTimes->{{3.7530162470584917`*^9, 3.7530162499027414`*^9}}],

Cell["Compile \[OpenCurlyQuote]fullbatchefficiency.c\[CloseCurlyQuote]", \
"Text",
 CellChangeTimes->{{3.7558742983873234`*^9, 3.7558743053565836`*^9}, {
  3.7558743383446693`*^9, 3.755874413783957*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Run", "[", 
  "\"\<START /B gcc c\\\\functions.c c\\\\fullbatchefficiency.c -o \
c\\\\fullbatchefficiency\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.753019266981736*^9, 3.75301926810707*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530192715447235`*^9, 3.753025280302765*^9}]
}, Open  ]],

Cell["\<\
Create a function that runs \[OpenCurlyQuote]fullbatchefficiency.exe\
\[CloseCurlyQuote] for a set of inputs and sends the output to an \
appropriately named .dat file\
\>", "Text",
 CellChangeTimes->{{3.755874583020319*^9, 3.755874658466021*^9}, 
   3.7558747932456183`*^9, 3.7558760846632338`*^9, 3.755876146997937*^9, 
   3.755876391554963*^9, 3.7560370385447683`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fullbatchefficiency", "[", 
   RowBox[{
   "asteps_", ",", "ksteps_", ",", "maxn_", ",", "maxk_", ",", "entropyn_"}], 
   "]"}], ":=", 
  RowBox[{"Run", "[", 
   RowBox[{"\"\<START /B c\\\\fullbatchefficiency \>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "maxk", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "entropyn", "]"}], "<>", 
    "\"\< > data\\\\fullbatchefficiency-asteps\>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\<-ksteps\>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\<-maxn\>\"", "<>", 
    RowBox[{"ToString", "[", "maxn", "]"}], "<>", "\"\<-maxk\>\"", "<>", 
    RowBox[{"ToString", "[", "maxk", "]"}], "<>", "\"\<-entropyn\>\"", "<>", 
    RowBox[{"ToString", "[", "entropyn", "]"}], "<>", "\"\<.dat\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7530192781860995`*^9, 3.7530192831710043`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fullbatchefficiency", "[", 
  RowBox[{"5", ",", "5", ",", "10", ",", "1", ",", "10"}], "]"}]], "Input",
 CellChangeTimes->{{3.7530192863119226`*^9, 3.753019312939745*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530193134710436`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"efficiencycontourplotfullextract", "=", 
  RowBox[{"ListContourPlot", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<data\\\\fullbatchefficiency-asteps31-ksteps31-maxn9-maxk1-\
entropyn20.dat\>\"", "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "\[RightDoubleBracket]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", "\"\<\[Alpha]\>\""}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<(c)\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0.5", ",", "1"}], "}"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"BarLegend", "[", "\[IndentingNewLine]", 
      RowBox[{"Automatic", ",", "\[IndentingNewLine]", 
       RowBox[{"Ticks", "\[Rule]", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "}"}], "&"}], "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "0", ",", "0.1", ",", "0.2", ",", "0.3", ",", "0.4", ",", "0.5", 
              ",", "0.6", ",", "0.7", ",", "0.8", ",", "0.9", ",", "1"}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "0", ",", "\"\<\>\"", ",", "0.2", ",", "\"\<\>\"", ",", "0.4", 
              ",", "\"\<\>\"", ",", "0.6", ",", "\"\<\>\"", ",", "0.8", ",", 
              "\"\<\>\"", ",", "1"}], "}"}]}], "}"}], "]"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
       "LegendLabel", "\[Rule]", "\"\<Full batch\\nmachine \[Eta]\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Contours", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0.1", ",", "0.2", ",", "0.3", ",", "0.4", ",", "0.5", ",", 
       "0.6", ",", "0.7", ",", "0.8", ",", "0.9"}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7453131476738715`*^9, 3.745313152440027*^9}, {
   3.7453131947416673`*^9, 3.7453132250886927`*^9}, 3.748787172741892*^9, {
   3.752339687599723*^9, 3.752339694797863*^9}, {3.752340514178073*^9, 
   3.7523405507338886`*^9}, {3.7530193713678246`*^9, 3.7530194273737803`*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[
    GraphicsComplexBox[CompressedData["
1:eJx1m3dYVFe3xjGxl9g7KjasscZetmKJNRq7RrFrbEkssWMkWKJJrFiCJcYW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     "], {{{}, {}, {
        EdgeForm[], 
        RGBColor[
        0.2058505584687798, 0.36213919914932213`, 0.5941775071374287], 
        GraphicsGroupBox[{
          
          PolygonBox[{{1375, 867, 1478}, {1334, 744, 1280}, {1527, 930, 
           1484}, {1483, 929, 1525}, {1528, 991, 1479}, {1378, 805, 1428}, {
           1481, 868, 1433}, {1430, 806, 1379}, {1376, 744, 1334}, {1332, 743,
            1374}, {1333, 743, 1332}}], 
          
          PolygonBox[{{1525, 929, 991, 1528}, {1484, 930, 868, 1481}, {1433, 
           868, 806, 1430}, {1428, 805, 867, 1375}, {1374, 743, 805, 1378}, {
           1478, 867, 929, 1483}, {1379, 806, 744, 1376}, {1529, 992, 930, 
           1527}, {1479, 991, 992, 1529}}]}]}, {
        EdgeForm[], 
        RGBColor[
        0.35477540485947645`, 0.4283875224745764, 0.6105154169516177], 
        GraphicsGroupBox[{
          
          PolygonBox[{{1426, 804, 1377}, {1378, 803, 1374}, {1483, 927, 
           1478}, {1427, 865, 1475}, {1528, 989, 1525}, {1239, 620, 1188}, {
           1430, 866, 1433}, {1237, 619, 1274}, {1367, 742, 1329}, {1329, 742,
            1326}, {1481, 928, 1484}, {1325, 741, 1327}, {1480, 927, 1521}, {
           1529, 990, 1479}, {1527, 990, 1529}, {1523, 928, 1482}, {1327, 741,
            1331}, {1238, 619, 1237}, {1524, 989, 1432}, {1373, 803, 1423}, {
           1375, 865, 1428}, {1476, 866, 1431}, {1376, 804, 1379}, {1275, 620,
            1239}}], 
          PolygonBox[CompressedData["
1:eJwtkLtOQlEQRU/uZf7B1kCrDVc/hIZK1GsJkU8xUcKjkhZ+Q+MLfkE66Iny
CCbq2pkpdrLOPPec47LbuM1SSkeogj4spXGeUome4V+CEwqW6IT3yDynmne4
bp6r8r6A1+gR/kTf8DzmLdAOvkG1mN+Hz9Eq89gV/Gpeq/49/ISuc5/5BrfM
d2lnAZ9G/xT94fUu8up5UG/sU00THoR/xe7hAz3tzG/UrZqhWR30Aw/NvcjT
1lyLuP8L3kRe/mbwS9yv/ZdwL/zLUwkn8/nyo9uL+D/tP4P/AUgvPRg=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.520196743049397, 0.486522817046114, 0.513270924213773], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtj89KAlEUxo828x6Ouxa68U1cGKJD2U4XtpZ8AyXRiNxY0EbfwigDESSi
dvUKMSPJgPZn+h3uWXz8zv3uufd8Jzg9K7ezIpJDB2jniUwxfmHoiwSYJfiF
PqgT+M3djJ4U1jnn8atwiSbUj/COuzgj0oXnKKLuwFfU4u0zfLD+T9/1aX8I
7zmf4A/hyOpr2LdZOjOxPGN4gY6p57BmmXvwhb+azHqDBd/t9ec5ab2HFevX
d1vLphlT27GIH6N3eq7goe/8H8/to3vdwkvLMNB/rH8DjyxzAy7QDfUKri2b
ZozMf4L/n4s/nw==
           "]], 
          PolygonBox[CompressedData["
1:eJwtkLFOAkEURQd35x9sl375GHuD2EmhpR8hkSgh0qCJksBfYAQTY2JoFAr4
BbOr0KAUnJv3ipucvLn3zpvJTi+Ozg9CCIcoReMYQj0JoY9e4D+GQwxn6Av+
TI0128JXeLLEMtfwglmTsxH6hyfRunTegX/Q0vvf4Fd0D5+gZ/jb/fKU8C61
LnVuUttB9+doDv/iWSXWUcA30bqqqAW3/T3a8Rju+v3KKNuI5lXmFn6gs6hY
/yV8533qn8JPzGqclXge4XffX33raJnc/+sDnvl/KKPswPOa6a96vr922sB7
LF0+8w==
           "]], 
          
          PolygonBox[{{1330, 1329, 1326, 680, 1321}, {1369, 802, 1367, 1329, 
           1330}, {1277, 679, 1325, 1327, 1328}, {1328, 1327, 1331, 801, 
           1366}}]}]}, {
        EdgeForm[], 
        RGBColor[0.6856180812393177, 0.5446581116176515, 0.4160264314759283], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtkb0vw2EQx4/+7u+gg4i2g5j7TzAI9TJYmGqj/0CThhIGi4rX1M5KUElN
XjpY2NDJSwgWCYnP5W745nPP3T3P3XOXnpodKnaKSAal0FgictAhUoBtAvvo
ES2oyAQJR7AHPeDLwHXystibsCvl/idUIdbNuQCP0ST2EuxTf3cAjnPnkFp5
+MH5jpw3uBy1FuEesRz5N/CEcw3/M/zhXMd/m3jNetR9J3ZPzif8IjaDrwVf
4/0VeIY2sJvqfVg/o3BE/Q9l2K/+3h93q9H/KnyJuw14SWyanGu4E7b5dqNn
6/078Rn+wvmY1Ra8Ctt8pZiDzWNQfd45dZndq74P28scPI85nKr/0/67Brej
bg0OR//2j1bM4SLxndm8srGfduz3H5a3Tdk=
           "]], 
          PolygonBox[CompressedData["
1:eJwtkctKglEURg96zmt0GURIvkwOxOwyaJKjeoogSkMHjRKxQb1EUSbUrEJq
UrPKUWYFBiUUuD72Hnw/6+z73v/s+lZhMxNCmEIRtfgsYNhAR+IUwjM8nQ2h
BA/RI3yIuvBttNhj9APXsK3hm0E78Eoylq0KX6Em/IQ+4Ut/y38GfyTzyTaA
D/ytnl/wQ7Re6tmD6z6PYpS7nGzWV/xF+J6YCnyCvuHfaCzbCP6PFqua42g7
iLXzHPl7aDVrNVX7Itnusu3DS6ifsR2167X3y6M2fBeNZdMsf95fOTni59GL
z6fZen5P/YMb+M37acd3+NTnke0cLvt9VWMRbvj9db8OvO33UM4uPAFtHEvG

           "]], 
          
          PolygonBox[{{1149, 1148, 1117, 434, 1144}, {1142, 433, 1147, 1145, 
           1146}, {1146, 1145, 1183, 555, 1178}, {1179, 556, 1186, 1148, 
           1149}}]}]}, {
        EdgeForm[], 
        RGBColor[0.8510394194292384, 0.6027934061891892, 0.3187819387380835], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtks0rhFEUxq/x3r9CM6HBYIv4K2QaGR8rxXJskNSskI9SFiy8ImJvdoiU
kkLZGXZs5GuMhQVLv9N9Fk+/c+45c869zzsNoxPZQsI514Fq0W/k3D4Hd7DX
O/dMnIFlivfoAVXJH+EaPEMx8QWs+FD/gJP8/rPGuXU4T57ivB8uomHiI1ik
VqVnC96icXZdwg1U4XwKrqh/Ac6Sf3E+Df/QAf0tPvRZfwHmyJP0z8E0eqKn
GWapHdIzYPfS/e0ddeSdnHfDFOoidrDJBx/Mj6R6rLdPbxmC9Zqf1ryy/OnR
HJuXkYeNcAmNUF+VT+bnJnr1IX6BM/KkKP/sva2JQMvtDbF22c5Ynpg3J5q/
DM99mH0Kd6m1MeMKvmmX7fyW5+b9Nhojvobv+t7HcC8K+3eiULOeG/gj/+07
DKISd8jBvPxv9+Ed9l1st8Ul5Xm9zf4j/4J9X4I=
           "]], 
          PolygonBox[CompressedData["
1:eJwtkssrhFEYxg9zzv9gQyhkzJaI/0GmkTFjpViOBckeuZSyYDHjErFn566U
LCTZuOzYKMxgIdZ+T+ddPF+/732/816e8zUMj6UL1c65FPLoj8cugVH0Ddeg
8Srn9lAabgvO1SaceyafhNeJJeEK+VU45+O3OpOHV1AZbuWbInzBmRLnn1AZ
TqEXcnW898GXPvZWTdW+RiPwDvqF7yyvGX/gJc4MJWLNUzGxffp9oSn4gFie
XBEdwzdWT/Nsw80h7qKdMiH2UC/F6nm/sv3UU70bbV71l1eqqdr36A3uJNZu
+8u7BZtP+82E6IF6a4YNeNbmU/8sfGv9ldesh8QebL8zuOCj19pxEJ62+1CN
OThj+0+gbrglxFk1s7xWTLkO1AV/EHs0f87hHsurhrxMmj+aqQl+DXFXzfQO
94e4m+r3wssh3q1qVuAT80fzLYa4g3aRJ0fwmo93JY+34E3z55NYCR6w/0n/
UBae9DGnmP61nPVXvXn4H60YY00=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9186039548912395, 0.6665098872280986, 0.3476722601628422], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtkkkvhEEQhntmvu8/2BKGBH/AnvgF9swY44irEeMXWELcJIwlIZY7B2JN
HCSEOOJKIkissSSWo+dN16HyVHdXvV1dXfGegY5M1DnXiMWwbODcU8S5KTgc
OpdicxPmsR5kvxa2YOv47bABy+InYIfFKHYO60X4BI6R343OJNzGcvi3cAvr
wh+BB9gc/i58NF97SfI30GyGa+j1YStYMWfXMA5nY15fWoes5+EefIG/vOkV
LpJfSfwx/Aq8xhv8wJbxP+ESVoG/AIewZ+7thwXYHzpRmEC3EL1yWGXvrYH1
1odqmLaaM3DadKTXRM4N+mXSCH0NquXMalAt7/bOn8DXrfrz8etMX/1uJbeI
syR8wq7wH0Jft+qfCXwv1BPFRa3+CJwgLs3eqPVJMerfN2er5J4H/j+Uf4Gf
s76pf8rT32kmSkIf/2372lNfOm1+NEeXFq+/vA/9ehze2Z/t6B6bpVTg9/QW
1aW/VU90R5vN4bDNhTR154/1qjT0s7ZqOaeBn5MjO1ef1fd9e7Nm5B87QGif

           "]], 
          PolygonBox[CompressedData["
1:eJwtkskuRFEQhg/33KcgoRHEC0g8g7F1625LbBHCExBiJ0F3b8SwZ0FMSwkx
7bAlEWNLRLyB70/V4r/5qs6p4VTdzNh0dqo+hNCFIrrg04ljAt3BVbe/60JY
g8uoA3scVeB1t2ucz8HDaQiNSQjP+Hrhe3zFxHw6m4+WSzk34B+07fWu4Hbu
NHD3CbsNXkClxHw5+I87W/V23oTdjT1Dvj3UHy1GZzuoGT5G5cR6OISX0AP8
iD7goWix6n8kmk9ninmF391WzCec9/eNokW4j5h9YmdRD3yCr5JYz8vwKap6
vRqc9fcV0GBqM6t5/0XNOrXZqcYAvJJaLeU4gyd9fqqZj9aTelPNL3jV82kn
2pV2qNnuol/4ILXaG+gIvo02K+3zJprEit+EMz5P9azeW70/7awBzkV7u/op
wS2p1dIdveXc62vf+pdeUqutnt/gS6+nnV7DBd+HdpqFp3y+erP+nX+5V15Z

           "]], 
          
          PolygonBox[{{1049, 247, 1053, 1051, 1052}, {1078, 370, 1081, 1054, 
           1055}, {1052, 1051, 1080, 369, 1077}, {1055, 1054, 1024, 248, 
           1050}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9450290887873929, 0.7325727219684822, 0.4295901752409179], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNlUts1VUQxv/33nNEg8ZHjLWKNgRxB30qlqhx4UYjDyGwFVip7X3QBCUx
Pjay9YFRN+KbpO1tS+ltqyYkKjG68lElEeoDLQFdYBXBhYmP35f5Gl3M/c7/
nDkzc2bmm7tyV31LrVwUxQxSQZr8NJAa8mUuikPgMfDFVBSrUXwWXAXuRB5A
PuNsEJ03ctwbR4aQp9Fbx3kTnEL6WY+B+5GbWb8MjlbC3wjyku3LzyPgeuQ2
ZK/X2qs5th7kbfztBt8E/wQvEPvf4Ncp7k2Ak+AeZMryKDJdjrj6ffZtCh8/
prDbh/zh+BTnB+A/2sP+X+BzfN/E/tYU8ehOF3IjcZxgvz3Hu4aRqqVeib29
fkerHLFrvxcZxNZIqSg2p4jvN8c74/dLfxtnTXSqKfItn2uRM6XIm2oy5Pyr
ZtuVX87uB38qRcx6z2s57g24Xn1+w+t8D4Cfat81fsa+RtwPO+1H/nKO/C4D
P0lx9hE4nKJe4+AKpBff7WBfKXLYA37I9w50joD3OG/KX59yynkXuBapsu4F
f8H3e9w9C25Arw18DLzOdjvAeo5cVnP47C5FT1yVYn0NeDFnh/F1ETiFvID+
DLhR99FZB97imBV7B2fzqgfrLazb0V8JLoDvYvtUJXTr9reCs+Po3wAedB+O
ggvILOtL2X8/BW+Our9Ul13IE5xtw94E+Lx1pCuf2tebNzsGxTJmTu1zP+6w
naZ5N6+e8lpc7PfblQPV6hXzt2G+qg9qObAB/uwaqVZ38X2B9ZXgAfvR2Vs5
7h4ETybzC7w8x3v17odY/8r6DvB2ZJH1g6od975hfa05IC50V6Lv95irbSn6
5WpwzBySXqMUfSI+fIWtCfbmPKvU//pe4HsOPJ1DT/ri2LhnjuxNcrYf/C7H
/pjvHrOtoRyx9Dse8fJ3pJOzc+XgkXh43lzV3knufMHeUznmyDvlONc95VBv
1HrW34fQ287ekzl4rvmgOk04Hs0J8UBcHkbuTYGbwM9zzJnBHLND7+tJwT1x
cDbFW0dt63v3fMvvbTgXVc+rAXO9ab5POz+H7WfU57ttT7XY5HgGzNe6YxUv
VTvVan0K3GB+N3x2xm+S/mnXax94yjn8wbXTuzTDquaZfGx1D815RtX+V4su
z7QOz4dbU9Sn5Rqdd120p9zLjvrw8Ry4EbzP9uVnmWfdJeDHKfr/bIo6TruW
4qe4P+//HnFfM0A9fsJ9vjyH3yty9NK0+6Llmosn1+e4s8pzTvbazZUDtrXo
/wfZaPPM0exRX66pxH6n+0z9dqd78W7wMsew3Prdrr9Q/bjExaU9+Zq0vx7/
Nyp/D+fw9Wr+L+/K7XHPFsVddU8t8aXlNy469jWOt9N653wuXv0LHGkd3A==

           "]], 
          PolygonBox[CompressedData["
1:eJwtlElIVWEYhs895/+DomggMo0Isdol5bVMqWjRpkhp0m3lykrvdaABonHh
tsGgVfMA9xo4pVbQIiJq1XBr0WBmJlRkNoAugobn7TuL9/Ccf/zGv7A2vSUV
BkGwDTm0gk9pIggaUQV80wfBmSgIalAnXI8ycBY9g5OsaWBtBm2Am9AnOIvq
4XyUhMc5ezQyiW+jL3ArZ+R0FhqBN7O+nfVpVAXPRiXwBOv/suZ3ZHwHjcFb
mV8Y2p26ux2t5L8CZeDj3myXDz3wSGR3y4Zf8FFvd8uGYbgRlcLN6Cr8J7Z3
GefP4ryEs7tlQwhf97a2Ez2Hp6A+7r6FpsEzvPEEWgN/Z885eCd6BB9jrJq9
+WgT/BjtiSzGT+EG1txImH8tcLO3uzrQC3gQtcXxG4JPsKaIs7ej0858ysX+
v4PHGDvP3A70GU6jjwnb0+gsp8ptPXoCDzN2IDSf5NsV1MRcEqXhe8wvZq4W
PZR98XnKYQ38BpUxtxcNwBfYsyQyHy/BrYyVh7YmC09mrAv+hlbBP2N7B9A8
/uejV3Ae+yvhIm9zBfxvhMuc1Y5qbjlc6ayWFcNquC+uZ8XkA/w+zr9i2Kt/
1vRy3n40BOe8xVo+X4Mve4tNMboI/5CPoeVUuc05s0U1p9pr8BarcebXwiXO
eiOFSuGvzmInH+Vrv7PaVczfOqsx1Zp6sgBerRpirhuVq1a82aKxXfBBb7FR
TR2Gp6L+0HySby1xfypnbepP5l/H96s2lCPlSjnwzN13Vkvyb1SxcRYb5awH
nuOsN/QGFMOTvNm2Dw0626O9/3Mme529FaoR1V5HXP+Kfxdc5y33qpHdcKG3
3lCMF8BH4n6eiw7BVd5YPqyHZ3qLtXyeDj9w1muL0FlnNsk2vREv4aXOcqE3
Jg/ujvtJNqk313nrXb0JKfius97Rm3MKPunsbPmj2v8HLbu6Dg==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9714542226835464, 0.7986355567088659, 0.5115080903189937], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNVldwlkUUzZ9vF4GhKHV8cCgWBEFQIKCQGAWp6ozAm4plgIQEgQCJhiQE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           "]], 
          PolygonBox[CompressedData["
1:eJwtlldwVUUcxu89Z1dEFA2EoI4FsFMtgKgkgEqzC76pqKhAQiQoRUO3dxHe
KHYSApJAAIeAozD6DDg2MiKCgKGozKggJkDw9813Hr65vz1nd8/uv96uYytG
TUpyudwiFNCzMZfrmOZy96NK+Cl0nAn9GFfA85nUlfFv+VxuMnwFGgi3svYo
czZozPtWntXBy9ENjCtQFfwxe5QxrwZth9uiP3m3GrWBr2LOYNbOQbfCn6KT
cAuqhl9GzfAJtBJ+JZhPoVr4PfYYz96foCXwKp71S7xGayfwrEfqbw6EJ6P+
jP9jPAl+gzm/MvdSxm/Bj6ANjI/pTPC8YNaddLcXg7+9GY2DX0CTedcX1cBf
oG7wGPSV7hNt2/moFt7JsymJz6iz1qNbEu/5KnwJcxoZFzF/JPwjWgdPQyui
bSxby0Yr4NWoP/Onoka4I+rFu1LUA36aNTeytpn3Q+GZaDTjTuhuuDzaN8vR
N/BWtAyegN6Hj/FbkrePLme/TaiEvWah3fB9qIZ3Tahc32fNpsT2HQT/lTpW
cryPuivP/uBdHRoAn5fN137t4A9QaWqflcGvs6Y4sY1kq8NoMfwQOgB/jZbA
D6Mtir9oW+nOU6PvoLt0R0ujfSxfP4jeDo5BxaJ8EuGL0I7Ee3aGi9ERuCfr
S+En0O+Mr2E8Dl6JpsPr0Y5on8v3S9EheBrPBqSeUwP/FB0LW9HP8C60DX4X
7YTXZvkkG6+B79WdsN1EdAc8VjEGz0VD4Y1oZmIbNcDfsscU9qpH38Mh2taK
0QRejxbK12g33BRse/mgfbQPNJ6BzoFbmfcP7tuAWuDnmf8v325A3eG9wXN1
5l3wXNY8kPoba+BDqddqj+PwvOhvb0d7lLus2ZJ3TL8Ej0DVcBm6Dh6JqvLO
0bvg61F53jGn2Fsc7QvVANWCR4PPNgNdDQ/jWUtiH0yBB/GsMu8cH6PahgbB
xahdcA4rl3XHufDnwbHWBb0DX6YYznuP4uAYV6zrG7fBhVn93Ig6wLdn72Xf
EsU7a/rknaMnU9c41TrlsHJ5eHBtkY/l67ro2BiFVsFnROf6GnQmPDG4NitG
FCvNmb/0DX1rNXMWpM75OfC+LF50vnMZF2Xn0ZoO8LVS3jbuq1oeHHua0xvu
Geyb3qgT3D6YtaYguIarls9TzYDz0b2gFqVwG9XPnG3YBd4WXXuU8x/BJcG+
U4/pBl8cXauUk8rNat0/dQ1fFm0D2UI5epPsEZ2r6jkfwr2Ca6FiqA/8OPoy
75h7DD6bOZWJbSLbzIi2dSF6Dr4nuhYrpmerd/E7i/M3oCNwYM3pnO/0N+P9
WbzPRPtS1yTVJvXQhcExpljTmrbqT8qhvGP+Tnh8dK1SjXwSPpj6W/pmE1wQ
7TvF2GDlanQtUQ1RLanN+pPq5Tr4guhapJ6i3rI39dl0xgPqg+hodp/D6qPR
vV81pEq5FVxrZqMh8C/RuauYqodfy/qR8l+165no2rMW/aBaybNFif13PuNh
wbEhH8gXo4N7h3rmAvjCrP+pxhepd0XHjmruzdE5qFyUzd4M3lN76z/McPis
4F6jnqXeNSLal9pTe+tMOpti6Dv4s6z/Kgb2wNOja7l6biN8KrO/bHQa3hzc
O3Sng3Bh8DvFf2d4SHSvlX9UCwqyfNKcE6ltKFuq5lyp3A32p+JvP/w/LilE
RA==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.95, 0.75], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNmnfYltWRh5/3e5+XXqSIgGLFiMaspmw0NvhA+GjSBARjELEmWTVZSywB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           "]], 
          PolygonBox[CompressedData["
1:eJwtlElsjlEUhr//++41hYo2tSNqalGR2tBKB6paKiF2taghnUgQMbQVilZi
Sm2J2CGGllhog9JSdmyVlqQInSxarRjyN+F5HYv3/997zr33O8N7T8rOfVv2
hkEQlAIHJvAT578DjERBcJ91jA254AG82AdBIvbNoAY+zP9T9o6DSfgbwLNY
EPwBp+E32JPJnmpwC56KbQ0+B35ge+js7mPgM9zpPHc9B2P4d7P+wN7Z+M/D
l4JK1ksExcadTfj2gG7W28AYvhZQCv/i7O42kMjeKtbXYnan7i7C1hVaTsot
B1sNvlaQBl8Prsbsm8vg+9kTDy2ng/AUxYAvAlPh1dg24ZsBNsDLsZ3CVw92
wC/Lhi8VVMCLsFXFLKZi+Dkwi/t7We9SrdjTzvoxyIc70AwfAivh253F+h0s
hp8AGaHVoA5eCE7CG0CZsx6pV1k6QwxHvPXyAmiGtzmr9VbQ7qymqq3uvK5v
gVCCAffgHeAivEQxwld7q/UTkAxfAQZD61EEn6ca8e1MMEe9BJ0xq5FqtcBZ
bOrBXHgPZ14SWyO4Ax/Cdim0ns1kneRMC8OENA1+1pn2pFlpVzEoFvWsAL7O
WS/WCvC73nJ/Bd7Bv2J7HVpOA/BD2LLwjbM+AF+kHDmbLzjruXov20L4Km+9
SeNMOTwdW3rMepwBv42tJrI7b8LrsS1nvx5hj3rlrJeyHXf2RvRWQjCf9XQw
EtidyfAkb9qoAwneclJuemN5zjQoLSqnQniZN+2pJ1neclAu0kgBvMlbraXh
Wng3aI0s5jfeeqxeS6ON8F/YW4lnFMThCc64YlSsR73VVj18r/p7q6U0LW3n
Onur0kS2M81Je+pxP/wRyAtNc9LeFGe1eMH9EbzPWe7a0wv/zXe+4WsBP+ET
nWkt/n+2DUjzgcU8FNmb0NvQzKrQvMCWE9ievsjeoN6iZsBG+Bln2v+nWfhg
ZN+qBf36NugMbCZqNmqGapZqpo3CP0W2Nxt8jCwH5aIz3tnM0+zTTJnsTNPS
tnIax3eYmrVE1hP1psvbbJXtrTcNSUuaESHrSm9arABX4H8BKcfADQ==
           "]]}]}}, {{}, 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{993, 994, 999, 1001, 1015, 1017, 1040, 1020, 1037, 1043, 
           1067, 1069, 1071, 1097, 1100, 1129, 1162, 1164, 1165, 1212, 1215, 
           1256, 1259, 1304, 1351, 1354, 1399, 1401, 1451, 1453, 1498, 1500, 
           1404, 1501, 1499, 1454, 1452, 1402, 1400, 1355, 1352, 1306, 1302, 
           1258, 1255, 1214, 1211, 1166, 1163, 1130, 1128, 1099, 1096, 1073, 
           1068, 1045, 1039, 1038, 1041, 1019, 1016, 1002, 1000, 998, 997}], 
          LineBox[CompressedData["
1:eJwVz7kuBFAUgOHLzNijsPTGzgsQwmAsvQewDGY6IrbOnuAVbJ0MKkQE76C1
NRq0drVP8eU/t7rnxFNTg5M5IYQFdmIh7LFNmnHaaCFCDg/REA7IsswiwwyR
oIMaqsgnj/dICJ9EzV9aqMXEKaGebppI0keKAcZJs8YGp2xxziVXPPNCmf0q
6KaSPqaZJcsRt9wz/38LdxxzyBwz9NNDkgTllPLqjyeuueCEMzZZJ8MEo4zR
Ty9d9NDAr/tr9UeLNEKMD+83CszfWqfVdNLICM2ssMQhqzySa7corbQzQYZd
9rnhD4qTNtY=
           "]]}, "0.9`"], Annotation[#, 0.9, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{995, 996, 1018, 1022, 1042, 1046, 1070, 1075, 1098, 1103, 
           1131, 1135, 1136, 1167, 1170, 1216, 1219, 1260, 1303, 1308, 1309, 
           1357, 1403, 1406, 1455, 1457, 1502, 1504, 1408, 1506, 1503, 1460, 
           1456, 1407, 1405, 1358, 1353, 1310, 1305, 1262, 1257, 1218, 1213, 
           1169, 1107, 1137, 1132, 1104, 1074, 1076, 1072, 1047, 1044, 1023, 
           1021, 1006, 1005}], 
          
          LineBox[{1190, 1199, 1240, 1246, 1286, 1288, 1337, 1341, 1385, 1387,
            1440, 1442, 1487, 1489, 1388, 1488, 1486, 1441, 1439, 1386, 1384, 
           1340, 1289, 1287, 1285, 1244, 1243, 1196, 1157, 1194, 1158, 1197, 
           1203, 1205, 1248, 1249, 1292, 1251, 1295, 1297, 1344, 1389, 1391, 
           1443, 1445, 1490, 1492, 1394, 1493, 1491, 1446, 1444, 1392, 1390, 
           1348, 1342, 1296, 1291, 1293, 1290, 1250, 1245, 1207, 1198, 1193, 
           1195, 1190}]}, "0.8`"], Annotation[#, 0.8, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{1003, 1004, 1049, 1052, 1077, 1079, 1102, 1105, 1110, 1138,
            1168, 1174, 1175, 1221, 1224, 1264, 1265, 1311, 1313, 1362, 1360, 
           1409, 1458, 1461, 1505, 1508, 1414, 1510, 1507, 1462, 1459, 1410, 
           1234, 1363, 1356, 1315, 1307, 1266, 1261, 1223, 1217, 1176, 1171, 
           1139, 1133, 1109, 1101, 1082, 1078, 1055, 1050, 1026, 1025}]}, 
         "0.7`"], Annotation[#, 0.7, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{1024, 1054, 1081, 1083, 1108, 1113, 1134, 1141, 1173, 1180,
            1220, 1227, 1263, 1270, 1314, 1320, 1359, 1365, 1412, 1417, 1465, 
           1469, 1464, 1513, 1509, 1511, 1512, 1466, 1463, 1415, 1411, 1364, 
           1318, 1316, 1312, 1269, 1226, 1225, 1181, 1177, 1172, 1140, 1112, 
           1111, 1106, 1048, 1080, 1051, 1053}]}, "0.6`"], 
        Annotation[#, 0.6, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{1084, 1116, 1144, 1149, 1179, 1184, 1222, 1232, 1267, 1272,
            1319, 1324, 1361, 1370, 1416, 1421, 1468, 1473, 1515, 1518, 1424, 
           1516, 1514, 1470, 1467, 1418, 1413, 1368, 1323, 1322, 1317, 1271, 
           1230, 1228, 1185, 1182, 1178, 1146, 1142, 1114, 1115}]}, "0.5`"], 
        Annotation[#, 0.5, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{1117, 1148, 1186, 1187, 1231, 1235, 1268, 1276, 1321, 1330,
            1369, 1372, 1420, 1425, 1472, 1477, 1519, 1522, 1429, 1520, 1517, 
           1474, 1471, 1422, 1419, 1371, 1366, 1328, 1277, 1273, 1236, 1233, 
           1229, 1143, 1183, 1145, 1147}]}, "0.4`"], 
        Annotation[#, 0.4, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{1188, 1239, 1275, 1279, 1326, 1329, 1367, 1377, 1426, 1431,
            1476, 1482, 1523, 1526, 1432, 1524, 1521, 1480, 1475, 1427, 1423, 
           1373, 1331, 1327, 1325, 1278, 1274, 1237, 1238}]}, "0.3`"], 
        Annotation[#, 0.3, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{1280, 1334, 1376, 1379, 1430, 1433, 1481, 1484, 1527, 1529,
            1479, 1528, 1525, 1483, 1478, 1375, 1428, 1378, 1374, 1332, 
           1333}]}, "0.2`"], 
        Annotation[#, 0.2, "Tooltip"]& ], {}, {}, {}, {}}}], {
    DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
     Identity, Frame -> True, FrameLabel -> {{
        FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}, {{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, {{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}}}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 300, 
     Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
     FormBox["\"(c)\"", TraditionalForm], 
     PlotRange -> {{0.032258, 1.}, {0., 1.}}, PlotRangeClipping -> True, 
     PlotRangePadding -> {
       Scaled[0.02], 
       Scaled[0.02]}, RotateLabel -> False, Ticks -> {Automatic, Automatic}}],
   FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               "\"Full batch\\nmachine \[Eta]\"", {FontFamily -> "Arial"}, 
                Background -> Automatic, StripOnInput -> False]}, {
               GraphicsBox[{{}, {}, 
                 
                 RasterBox[{{{0.2058505584687798, 0.36213919914932213`, 
                  0.5941775071374287}}, {{0.35477540485947645`, 
                  0.4283875224745764, 0.6105154169516177}}, {{
                  0.520196743049397, 0.486522817046114, 
                  0.513270924213773}}, {{0.6856180812393177, 
                  0.5446581116176515, 0.4160264314759283}}, {{
                  0.8510394194292384, 0.6027934061891892, 
                  0.3187819387380835}}, {{0.9186039548912395, 
                  0.6665098872280986, 0.3476722601628422}}, {{
                  0.9450290887873929, 0.7325727219684822, 
                  0.4295901752409179}}, {{0.9714542226835464, 
                  0.7986355567088659, 0.5115080903189937}}, {{1., 0.95, 
                  0.75}}}, {{
                    Rational[-15, 2], -150}, {
                    Rational[15, 2], 150}}], {Antialiasing -> False, 
                  AbsoluteThickness[0.1], 
                  Directive[
                   Opacity[0.3], 
                   GrayLevel[0]], 
                  LineBox[
                   NCache[{{
                    Rational[15, 2], -150}, {
                    Rational[-15, 2], -150}, {
                    Rational[-15, 2], 150}, {
                    Rational[15, 2], 150}, {
                    Rational[15, 2], -150}}, {{
                    7.5, -150}, {-7.5, -150}, {-7.5, 150}, {7.5, 150}, {
                    7.5, -150}}]]}, {
                  CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -116.66666666666666`}, {
                    Rational[
                    15, 2], -116.66666666666666`}}, {{-7.5, \
-116.66666666666666`}, {7.5, -116.66666666666666`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -83.33333333333333}, {
                    Rational[
                    15, 2], -83.33333333333333}}, {{-7.5, \
-83.33333333333333}, {7.5, -83.33333333333333}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -50.}, {
                    Rational[15, 2], -50.}}, {{-7.5, -50.}, {7.5, -50.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -16.666666666666686`}, {
                    Rational[
                    15, 2], -16.666666666666686`}}, {{-7.5, \
-16.666666666666686`}, {7.5, -16.666666666666686`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 16.666666666666657`}, {
                    Rational[15, 2], 16.666666666666657`}}, {{-7.5, 
                    16.666666666666657`}, {7.5, 16.666666666666657`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 49.99999999999997}, {
                    Rational[15, 2], 49.99999999999997}}, {{-7.5, 
                    49.99999999999997}, {7.5, 49.99999999999997}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 83.33333333333331}, {
                    Rational[15, 2], 83.33333333333331}}, {{-7.5, 
                    83.33333333333331}, {7.5, 83.33333333333331}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 116.66666666666663`}, {
                    Rational[15, 2], 116.66666666666663`}}, {{-7.5, 
                    116.66666666666663`}, {7.5, 116.66666666666663`}}]]}}}, {
                 Antialiasing -> False, 
                  StyleBox[
                   
                   LineBox[{{7.500000000000001, -150.00000000000003`}, {
                    7.500000000000001, 150.}}], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.500000000000001, -116.66666666666667`}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -116.66666666666667`}]}, {{
                    7.500000000000001, -83.33333333333334}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -83.33333333333334}]}, {{
                    7.500000000000001, -50.}, 
                    Offset[{4., 0}, {7.500000000000001, -50.}]}, {{
                    7.500000000000001, -16.666666666666675`}, 
                    Offset[{4., 0}, {
                    7.500000000000001, -16.666666666666675`}]}, {{
                    7.500000000000001, 16.666666666666647`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    16.666666666666647`}]}, {{7.500000000000001, 50.}, 
                    Offset[{4., 0}, {7.500000000000001, 50.}]}, {{
                    7.500000000000001, 83.33333333333331}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    83.33333333333331}]}, {{7.500000000000001, 
                    116.66666666666664`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    116.66666666666664`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["0.2`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -116.66666666666667`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -83.33333333333334}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.4`", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -50.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -16.666666666666675`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.6`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    16.666666666666647`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 50.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.8`", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 83.33333333333331}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    116.66666666666664`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                Scaled[0.02], PlotRange -> All, Frame -> True, 
                FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                Opacity[0], FrameTicksStyle -> Opacity[0], 
                ImageSize -> {Automatic, 300}, BaseStyle -> {}]}}, 
             GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.106563`", ",", "1.052632`"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"0", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.1`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.2`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.3`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.4`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.5`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.6`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.7`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.8`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.9`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           
           RowBox[{"LegendLabel", "\[Rule]", 
             "\"Full batch\\nmachine \[Eta]\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "300"}], ",", 
           RowBox[{"Ticks", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.1`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.2`", ",", "0.2`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.3`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.4`", ",", "0.4`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.5`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.6`", ",", "0.6`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.7`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.8`", ",", "0.8`"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0.9`", ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.745313188631404*^9, 3.745313226291748*^9}, 
   3.748787190594363*^9, 3.7523396111868343`*^9, 3.7523397056427026`*^9, {
   3.75234052552867*^9, 3.7523405513880844`*^9}, 3.7523406297466307`*^9, 
   3.7530193779778976`*^9, 3.7530194281863575`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Whole figure", "Chapter",
 CellChangeTimes->{{3.7530162545907393`*^9, 3.7530162564813614`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"complexbatchplot", "=", 
  RowBox[{"Grid", "[", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
     "ncontourplotfullextract", ",", "workcontourplotfullextract", ",", 
      "efficiencycontourplotfullextract"}], "}"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7451681103617887`*^9, 3.7451681249258623`*^9}, {
   3.745168172196594*^9, 3.7451681768379326`*^9}, {3.7453132300421233`*^9, 
   3.7453132320267086`*^9}, 3.7487873149500504`*^9, {3.7529322491397114`*^9, 
   3.7529322529368353`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{GraphicsBox[
        GraphicsComplexBox[CompressedData["
1:eJyMvX2sZdd53kcFSVteFQ4i0kU/5KHdJu4wRuFYo/SPOkMGbmNd5qPxjNKg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         "], {{{}, {
            EdgeForm[], 
            RGBColor[0.22675, 0.37375, 0.61375], 
            GraphicsGroupBox[{
              
              PolygonBox[{{59203, 1, 58807, 59599}, {59201, 58805, 58806, 
               59202}, {59600, 58808, 2, 59204}}], 
              PolygonBox[CompressedData["
1:eJwl2Hf8VfMfB/DT0N7SoklTNGhrknZaoqRFpaSUVWjvjBKlRUPTaBAtqbTT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               "]], 
              PolygonBox[CompressedData["
1:eJwk3WW0VdUaAFCkuxukpLu7pUFKurtERKQFpLtLuqW7u1tauru7mzf3eD/m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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[0.6065625, 0.516875, 0.4625], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58814, 598, 599, 600, 58813}, {58820, 1785, 1783, 
               1784, 58819}, {58822, 1786, 1787, 1788, 58821}, {58812, 597, 
               595, 596, 58811}}], 
              PolygonBox[CompressedData["
1:eJwU3HPYV+cbAPBcy7Zdy1xYtm3btralpV9atWrZtm3bWta2bPf7nD8+19n3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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[0.915625, 0.6590625, 0.33843749999999995`], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58836, 4161, 4159, 4160, 58835}, {58838, 4162, 
               4163, 4164, 58837}, {58854, 6538, 6539, 6540, 58853}, {58844, 
               5349, 5347, 5348, 58843}, {58830, 2974, 2975, 2976, 58829}, {
               58852, 6537, 6535, 6536, 58851}, {58828, 2973, 2971, 2972, 
               58827}, {58846, 5350, 5351, 5352, 58845}}], 
              PolygonBox[CompressedData["
1:eJwU3WW4VdUWAFAe0t0lIZ0iDdLd3SAC0t0d0t3dKSUt0t0t3d3d3byxf4zv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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[0.978125, 0.8153125, 0.5321874999999999], 
            GraphicsGroupBox[{
              
              PolygonBox[{{58878, 10102, 10103, 10104, 58877}, {58884, 11289, 
               11287, 11288, 58883}, {58886, 11290, 11291, 11292, 58885}, {
               58860, 7725, 7723, 7724, 58859}, {58868, 8913, 8911, 8912, 
               58867}, {58862, 7726, 7727, 7728, 58861}, {58870, 8914, 8915, 
               8916, 58869}, {58876, 10101, 10099, 10100, 58875}}], 
              PolygonBox[CompressedData["
1:eJwV22O4XccaAODT2LZt27ZtNcltmzZqGtu2rcZWGdu2bdvNfdePN/s5+9uj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               "]]}]}, {}, {
            EdgeForm[], 
            RGBColor[1., 0.95, 0.75], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwV1HtMVmUcwPHfUsxCuwH+o1hNUUssC7ESpDY024S8d1HLEjS3RDTNSiwr
0NyUankPKyu6mGitNNvQotTKRGpDs00sTdMudhWrzUt9zh+f8X6fc97zPs9z
DufyieUjp50TEcWkMPtoxCVlEWmk86BuZcTmiGEM54T+jQ3vRrzNO/yq/2ak
46MYzUl9nPWOr6OOX/QFxyIKdkTcyE101P2Y0RJRznRydDueb4ioYTUpOpvd
+yJ20Uhvfdo1T9abF62c0m2Nr/KdFaykjW4xPmltRAml7NdHOG9DxLm057Du
4NyB5pVHPqnJ/Iz/OSTid/4gR/c3/oC5zmQWufpssg/m8A//ckbnG884ZE9J
J09PNv5FiXXQyCR9lfEma/qSr+ije3Bls3WSTZbu6tx2A8yZ9mQmc2Zr34h6
tpCqu5DieBva0ln34K0C94M6snQ2xYURQymit36dnxe6XxznNd2dtb7zBm/S
Taebz6GdEd9xkDTdyfjEXPtMKRnJPedD8/qIBjom13PuFdbUk150S9bGgqaI
p1hIpk537r2uM4F7SEvWZny+45VU0Vn3N/6Xe3OCVnKTPeVWaxrGcProTs79
3lwPc4QMPdV42ZSI+5ma/NVHOd8zkUoHftCzuNj/xYVcxMxkXXy9PGIf37BV
b+eRmoiHeJht+lPm+FzBXHbopzk7J+I/oiKiWi9g7OyIcYxnvv6WyZ7Z+5jC
gWRdyfgYe89BivXNDBjhGSOfwbqRzDX2iC7s0kUc8J39tDBUj+aJsRHzeJxR
ejxZE9wbujNOD+IG176O6ynUTXR17Uu5jN16WsJeljOdMl3LT56nY/zIq3oj
1zwXcTV9eU/XUV0dsYjFrNMvJuurihjCLbygVzPY50IGUaOX88o816aWZXop
L/v8EmtYovfwca1nkgaa9Rb2uofN7KFeL+aM+3OK0yxK3n3JvTOvZ3iW9fp9
rjX/HPqxSRck8ynyHmIlA5NnhU/83ja2s1ffxpP2vJIqxui5bJphP9hIhS5l
p/fFZ3xOiX4s+W3HN/MBjybvHJb5vSUsJU/fnfz/u4c96cVduoo7PWO3cweV
+n/lqL6L
               "]], 
              PolygonBox[CompressedData["
1:eJwU3FPUXFcYANDYtu2kQWOnsW3btm3btm3bdtK4cds4aZzuedhr1sw3x7jn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               "]]}]}}}], {
        DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
         Identity, Frame -> True, FrameLabel -> {{
            FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
            FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}}, {{{0, 
              FormBox["0", TraditionalForm]}, {0.25, 
              FormBox["0.25`", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.25, 
              FormBox["0.25`", TraditionalForm]}}}}, GridLinesStyle -> 
         Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 300, 
         Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
         FormBox["\"(a)\"", TraditionalForm], 
         PlotRange -> {{0, 0.25}, {0, 1}}, PlotRangeClipping -> True, 
         PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
         Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{"1", "3", "5", "7", "\"\[GreaterEqual]9\""}, 
          "SwatchLegend", DisplayFunction -> (FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"N\"", {FontFamily -> "Arial"}, Background -> Automatic, 
                    StripOnInput -> False]}, {
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0.95, 0.75]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #5}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.9625, 0.77625, 0.48374999999999996`]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #4}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.9, 0.62, 0.29]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #3}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.50875, 0.48250000000000004`, 0.52]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}, {
                    GraphicsBox[{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.148, 0.33, 0.54]], 
                    RectangleBox[{0, 0}, {10, 10}, "RoundingRadius" -> 0]}, 
                    AspectRatio -> Full, ImageSize -> {10, 10}, 
                    PlotRangePadding -> None, ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"]}}, GridBoxAlignment -> {"Columns" -> {{Center}}}, 
                 AutoDelete -> False, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]& ), 
          InterpretationFunction :> (RowBox[{"SwatchLegend", "[", 
             RowBox[{"\"M10DefaultDensityGradient\"", ",", 
               RowBox[{"{", 
                 RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"N\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Grid", "[", 
                    RowBox[{"Reverse", "[", "#1", "]"}], "]"}], "&"}], 
                   ")"}]}]}], "]"}]& ), Editable -> True], TraditionalForm], 
        TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )], 
     TemplateBox[{GraphicsBox[
        GraphicsComplexBox[CompressedData["
1:eJx13HuUG9V9wHHTHrscIG1oSUkIgcPDDlBsniUkFCaF0BBKCoHyKIGelIcP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         "], {{{
            EdgeForm[], 
            RGBColor[0.148, 0.33, 0.54], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNnXXcFtXTh++tW1AUA1RUUBEUCztRUGwUu7u725+F3d3diK3YrYhiBwai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               "]], 
              PolygonBox[CompressedData["
1:eJwlkEtOAlEQRQu6qU2oGBeg+EVloAnCBiAkKKiJE2c60giiUaeYuABlIGxD
YR2iS/F3bmpwkvP6Vd9XVQsn57WzrJnNQApFN+vy4Stjto6fwkvObAAj/AqO
KPyGPn4H7TS+6W4NPvm3Q8aGR4ayprCIr8JHJmpUW4BeNt5cwndhLjG75byC
78Mb5zG08E2P7GvYwhvwzt08VPAS3HA3y3kHf4QfejuGe3zg0fsvPOFVyCfx
Rh0/gEkSmU18zyNLNap9hb80Mp89MpV9CA8emcrWzob4tkev6km9aQbNop1d
eOxUu1Wmsi89stSDetEOtAvtaNljRs2qHZXxf+iENh4=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.7677411263491078, 0.5735192456817951, 0.3677496254049973], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtUsdKREEQHHS3vsFw8gPMazwoGC7mgLABBPeggqBgPrpejODNiIj6D8b/
WtPFKqoPRb3u6Z6urnlN5Y259ZqUUi9RS3QipT0mOsiHxF8mpQr5KpvSTdbx
L3HN70vinU2NxCvxxfwPUcq4/i/iC/bfMr6Ha+ujPs+zIlElmnm2z7k5MTzj
IPo0V/Ne2FNHNBAz8OwpOK/cGzEe8Srco15pqcasb6I9dAySB+DefvIOXFMi
zxMfzI/GPVexbylqCuRCxjtr32fGdzxfIT+Fbu19BM8+IU/DGmfJbaFBWvLw
HcXYW3OkU3fcxQ6VeItz8hDxyd4RWJ90DpN7YX96yGVY2xJ5E/Z6m/wA378M
n6nmmDwGv8ka+Sx06B0WY88tcgv8dq1wneonYe/kYR/su/yfgPfRXrvyJvx5
hHVL/wK5K/43/Xe5+Ae6Yb/k2ynco155/A/NE1eY
               "]], 
              PolygonBox[CompressedData["
1:eJwtkTdOA0AQRVcOcwRiRUeFaUgig4QwwYAJNiCB5AI6kEimRDRGpBIwFkEc
gngvYsP7mi2e9DbNzM60lLbzW4kQQiukoGwhfCMrsI+PQ2MyhHrI4sPwijfB
AH4Ht+kQbuASz8T7zdCOj8J70t/obb95LN1pwzehlvYYT/geFMn9CRW8Cxq4
Wwe95sjLFN2B5+CN9QtM4HOxPuVcwDvhMOE5lXsKnmM9M/hQfP8BI/gJfJF7
GdbwR7imth/WVfwAVlO+XsfHYn2KOYkvmsfS+yV819y1lzdHrpyzeI95LxWj
Gz+HP+Ui5715DuXS3jE+bf5X9U+zuYjzuuL+g3KZz049LOAb5mf6g/6iGWlW
v5yf4UfmrhiafTXmUw9KeF/st+rTXwfNZ6v61TvVqFo1wxp+aj47xVNthThP
zWPevCfqh3pYNJ+RznRnB/8H8ORPAQ==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9204213381611424, 0.6710533454028558, 0.3533061482995412], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtj7kKAlEMRYNLPsLO/7AW92VwaURE0HJG1EawdEOwcSm00Y/QP9PeE16K
y8lkbpL78uMkilMikkNpNFKRX0ZkC1eoQz2Da9SlTmDF6wa8ZkVu6IJi99vc
Bn2pd+6x/2c057tHvwOr6M3RIoxQn/4CltGHfgk+ff4Eh57toGHGZgsafOav
a9hr+9uw6Xlq8KUh5xSOvb7Dgb/F3rf3zEsN9+zuUYPP/Laj5Tkt70PDmybw
DwevKHY=
               "]], 
              
              PolygonBox[{{1649, 1110, 1268, 1668}, {1638, 1429, 1428, 
               1695}, {1652, 1268, 1110, 1650}, {1674, 1428, 1426, 1673}, {
               1637, 1426, 1427, 1692}, {1672, 1269, 1427, 1633}, {1673, 1426,
                1268, 1671}, {1670, 1268, 1426, 1690}, {1633, 1427, 1429, 
               1634}, {1692, 1427, 1269, 1632}, {1617, 1110, 1108, 1615}, {
               1669, 1269, 1111, 1629}, {1629, 1111, 1109, 1628}, {1614, 1109,
                1111, 1616}, {1651, 1111, 1269, 1630}, {1648, 1108, 1110, 
               1649}}], 
              
              PolygonBox[{{1607, 948, 1611, 1640, 1641}, {1641, 1640, 1612, 
               1108, 1646}, {1644, 1643, 1613, 949, 1645}, {1647, 1109, 1610, 
               1643, 1644}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9619702919214687, 0.7749257298036717, 0.48210790495655287`], 
            GraphicsGroupBox[{
              
              PolygonBox[{{1629, 1267, 1669}, {1646, 1106, 1641}, {1649, 1266,
                1648}, {1663, 1266, 1680}, {1690, 1424, 1670}, {1641, 1106, 
               1607}, {1644, 1107, 1647}, {1668, 1266, 1649}, {1692, 1425, 
               1637}, {1682, 1267, 1667}, {1628, 1267, 1629}, {1645, 1107, 
               1644}, {1632, 1425, 1692}, {1685, 1424, 1635}}], 
              
              PolygonBox[{{1670, 1424, 1266, 1668}, {1637, 1425, 1424, 
               1690}, {1687, 1425, 1267, 1682}, {1669, 1267, 1425, 1632}, {
               1680, 1266, 1424, 1685}, {1635, 1424, 1425, 1687}}], 
              
              PolygonBox[{{1667, 1267, 1628, 1660, 1661}, {1642, 1106, 1646, 
               1657, 1658}, {1658, 1657, 1648, 1266, 1663}, {1661, 1660, 1647,
                1107, 1662}}]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.8812615861817442, 0.6211154740907704], 
            GraphicsGroupBox[{
              
              PolygonBox[{{1662, 1265, 1661}, {1658, 1264, 1642}, {1661, 1265,
                1667}, {1663, 1264, 1658}}], 
              
              PolygonBox[{{1686, 1685, 1635, 1636}, {1636, 1635, 1687, 
               1688}, {1688, 1687, 1682, 1683}, {1681, 1680, 1685, 1686}}], 
              
              PolygonBox[{{1659, 1264, 1663, 1680, 1681}, {1683, 1682, 1667, 
               1265, 1684}}]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.95, 0.75], 
            GraphicsGroupBox[{
              
              PolygonBox[{{1686, 1422, 1681}, {1684, 1423, 1683}, {1683, 1423,
                1688}, {1688, 1423, 1636}, {1681, 1422, 1659}}], 
              PolygonBox[{{1636, 1423, 1422, 1686}}]}]}}, {{}, 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[{1659, 1681, 1686, 1636, 1688, 1683, 1684}]}, "6"], 
            Annotation[#, 6, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{1642, 1658, 1663, 1680, 1685, 1635, 1687, 1682, 1667, 
               1661, 1662}]}, "5"], Annotation[#, 5, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{1607, 1641, 1646, 1657, 1648, 1649, 1668, 1670, 1690, 
               1637, 1692, 1632, 1669, 1629, 1628, 1660, 1647, 1644, 1645}]}, 
             "4"], Annotation[#, 4, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{1596, 1606, 1611, 1640, 1612, 1615, 1617, 1620, 1650, 
               1652, 1671, 1673, 1674, 1677, 1695, 1638, 1696, 1689, 1634, 
               1633, 1672, 1630, 1651, 1618, 1616, 1614, 1610, 1643, 1613, 
               1608, 1609}]}, "3"], Annotation[#, 3, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{1581, 1588, 1590, 1597, 1582, 1583, 1584, 1585, 1599, 
               1600, 1602, 1604, 1621, 1622, 1624, 1626, 1654, 1631, 1666, 
               1665, 1676, 1694, 1691, 1697, 1699, 1639, 1698, 1679, 1693, 
               1678, 1675, 1656, 1664, 1655, 1653, 1627, 1625, 1623, 1619, 
               1605, 1603, 1601, 1598, 1594, 1593, 1592, 1591, 1595, 1589, 
               1587, 1586}]}, "2"], 
            Annotation[#, 2, "Tooltip"]& ], {}, {}}}], {
        DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
         Identity, Frame -> True, FrameLabel -> {{
            FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
            FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}}, {{{0, 
              FormBox["0", TraditionalForm]}, {0.25, 
              FormBox["0.25`", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.25, 
              FormBox["0.25`", TraditionalForm]}}}}, GridLinesStyle -> 
         Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 300, 
         Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
         FormBox["\"(b)\"", TraditionalForm], PlotRange -> {{0, 0.25}, All}, 
         PlotRangeClipping -> True, 
         PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
         Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"Ratio of\\nmachines\"", {FontFamily -> "Arial"}, 
                    Background -> Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0.148, 0.33, 0.54}}, {{0.7677411263491078, 
                    0.5735192456817951, 0.3677496254049973}}, {{
                    0.9204213381611424, 0.6710533454028558, 
                    0.3533061482995412}}, {{0.9619702919214687, 
                    0.7749257298036718, 0.4821079049565529}}, {{1., 
                    0.8812615861817442, 0.6211154740907704}}, {{1., 0.95, 
                    0.75}}}, {{
                    Rational[-15, 2], -150}, {
                    Rational[15, 2], 150}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], -150}, {
                    Rational[-15, 2], -150}, {
                    Rational[-15, 2], 150}, {
                    Rational[15, 2], 150}, {
                    Rational[15, 2], -150}}, {{
                    7.5, -150}, {-7.5, -150}, {-7.5, 150}, {7.5, 150}, {
                    7.5, -150}}]]}, {
                    CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -100.}, {
                    Rational[15, 2], -100.}}, {{-7.5, -100.}, {
                    7.5, -100.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -50.000000000000014`}, {
                    Rational[
                    15, 2], -50.000000000000014`}}, {{-7.5, \
-50.000000000000014`}, {7.5, -50.000000000000014`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -2.842170943040401*^-14}, {
                    Rational[
                    15, 2], -2.842170943040401*^-14}}, {{-7.5, \
-2.842170943040401*^-14}, {7.5, -2.842170943040401*^-14}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 49.99999999999997}, {
                    Rational[15, 2], 49.99999999999997}}, {{-7.5, 
                    49.99999999999997}, {7.5, 49.99999999999997}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 99.99999999999994}, {
                    Rational[15, 2], 99.99999999999994}}, {{-7.5, 
                    99.99999999999994}, {7.5, 99.99999999999994}}]]}}}, {
                    Antialiasing -> False, 
                    StyleBox[
                    LineBox[{{7.5, -150.}, {7.5, 150.}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -100.00000000000001`}, 
                    Offset[{4., 0}, {7.5, -100.00000000000001`}]}, {{
                    7.5, -50.00000000000001}, 
                    Offset[{4., 0}, {7.5, -50.00000000000001}]}, {{
                    7.5, -1.8894276654612612`*^-14}, 
                    Offset[{4., 0}, {7.5, -1.8894276654612612`*^-14}]}, {{7.5,
                     49.999999999999986`}, 
                    Offset[{4., 0}, {7.5, 49.999999999999986`}]}, {{7.5, 
                    99.99999999999996}, 
                    Offset[{4., 0}, {7.5, 99.99999999999996}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["2", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -100.00000000000001`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["3", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -50.00000000000001}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -1.8894276654612612`*^-14}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["5", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 49.999999999999986`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 99.99999999999996}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 300}, BaseStyle -> {}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ),
           InterpretationFunction :> (RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"Blend", "[", 
                    RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                    "]"}], "&"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.`", ",", "6.016998681654317`"}], "}"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"3", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"4", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"5", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"6", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"LegendLabel", "\[Rule]", "\"Ratio of\\nmachines\""}], 
               ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", "300"}], ",", 
               RowBox[{"Ticks", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"3", ",", "3"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"5", ",", "5"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"6", ",", "6"}], "}"}]}], "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )], 
     TemplateBox[{GraphicsBox[
        GraphicsComplexBox[CompressedData["
1:eJx1m3dYVFe3xjGxl9g7KjasscZetmKJNRq7RrFrbEkssWMkWKJJrFiCJcYW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         "], {{{}, {}, {
            EdgeForm[], 
            RGBColor[
            0.2058505584687798, 0.36213919914932213`, 0.5941775071374287], 
            GraphicsGroupBox[{
              
              PolygonBox[{{1375, 867, 1478}, {1334, 744, 1280}, {1527, 930, 
               1484}, {1483, 929, 1525}, {1528, 991, 1479}, {1378, 805, 
               1428}, {1481, 868, 1433}, {1430, 806, 1379}, {1376, 744, 
               1334}, {1332, 743, 1374}, {1333, 743, 1332}}], 
              
              PolygonBox[{{1525, 929, 991, 1528}, {1484, 930, 868, 1481}, {
               1433, 868, 806, 1430}, {1428, 805, 867, 1375}, {1374, 743, 805,
                1378}, {1478, 867, 929, 1483}, {1379, 806, 744, 1376}, {1529, 
               992, 930, 1527}, {1479, 991, 992, 1529}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.35477540485947645`, 0.4283875224745764, 0.6105154169516177], 
            GraphicsGroupBox[{
              
              PolygonBox[{{1426, 804, 1377}, {1378, 803, 1374}, {1483, 927, 
               1478}, {1427, 865, 1475}, {1528, 989, 1525}, {1239, 620, 
               1188}, {1430, 866, 1433}, {1237, 619, 1274}, {1367, 742, 
               1329}, {1329, 742, 1326}, {1481, 928, 1484}, {1325, 741, 
               1327}, {1480, 927, 1521}, {1529, 990, 1479}, {1527, 990, 
               1529}, {1523, 928, 1482}, {1327, 741, 1331}, {1238, 619, 
               1237}, {1524, 989, 1432}, {1373, 803, 1423}, {1375, 865, 
               1428}, {1476, 866, 1431}, {1376, 804, 1379}, {1275, 620, 
               1239}}], 
              PolygonBox[CompressedData["
1:eJwtkLtOQlEQRU/uZf7B1kCrDVc/hIZK1GsJkU8xUcKjkhZ+Q+MLfkE66Iny
CCbq2pkpdrLOPPec47LbuM1SSkeogj4spXGeUome4V+CEwqW6IT3yDynmne4
bp6r8r6A1+gR/kTf8DzmLdAOvkG1mN+Hz9Eq89gV/Gpeq/49/ISuc5/5BrfM
d2lnAZ9G/xT94fUu8up5UG/sU00THoR/xe7hAz3tzG/UrZqhWR30Aw/NvcjT
1lyLuP8L3kRe/mbwS9yv/ZdwL/zLUwkn8/nyo9uL+D/tP4P/AUgvPRg=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[0.520196743049397, 0.486522817046114, 0.513270924213773], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtj89KAlEUxo828x6Ouxa68U1cGKJD2U4XtpZ8AyXRiNxY0EbfwigDESSi
dvUKMSPJgPZn+h3uWXz8zv3uufd8Jzg9K7ezIpJDB2jniUwxfmHoiwSYJfiF
PqgT+M3djJ4U1jnn8atwiSbUj/COuzgj0oXnKKLuwFfU4u0zfLD+T9/1aX8I
7zmf4A/hyOpr2LdZOjOxPGN4gY6p57BmmXvwhb+azHqDBd/t9ec5ab2HFevX
d1vLphlT27GIH6N3eq7goe/8H8/to3vdwkvLMNB/rH8DjyxzAy7QDfUKri2b
ZozMf4L/n4s/nw==
               "]], 
              PolygonBox[CompressedData["
1:eJwtkLFOAkEURQd35x9sl375GHuD2EmhpR8hkSgh0qCJksBfYAQTY2JoFAr4
BbOr0KAUnJv3ipucvLn3zpvJTi+Ozg9CCIcoReMYQj0JoY9e4D+GQwxn6Av+
TI0128JXeLLEMtfwglmTsxH6hyfRunTegX/Q0vvf4Fd0D5+gZ/jb/fKU8C61
LnVuUttB9+doDv/iWSXWUcA30bqqqAW3/T3a8Rju+v3KKNuI5lXmFn6gs6hY
/yV8533qn8JPzGqclXge4XffX33raJnc/+sDnvl/KKPswPOa6a96vr922sB7
LF0+8w==
               "]], 
              
              PolygonBox[{{1330, 1329, 1326, 680, 1321}, {1369, 802, 1367, 
               1329, 1330}, {1277, 679, 1325, 1327, 1328}, {1328, 1327, 1331, 
               801, 1366}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.6856180812393177, 0.5446581116176515, 0.4160264314759283], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtkb0vw2EQx4/+7u+gg4i2g5j7TzAI9TJYmGqj/0CThhIGi4rX1M5KUElN
XjpY2NDJSwgWCYnP5W745nPP3T3P3XOXnpodKnaKSAal0FgictAhUoBtAvvo
ES2oyAQJR7AHPeDLwHXystibsCvl/idUIdbNuQCP0ST2EuxTf3cAjnPnkFp5
+MH5jpw3uBy1FuEesRz5N/CEcw3/M/zhXMd/m3jNetR9J3ZPzif8IjaDrwVf
4/0VeIY2sJvqfVg/o3BE/Q9l2K/+3h93q9H/KnyJuw14SWyanGu4E7b5dqNn
6/078Rn+wvmY1Ra8Ctt8pZiDzWNQfd45dZndq74P28scPI85nKr/0/67Brej
bg0OR//2j1bM4SLxndm8srGfduz3H5a3Tdk=
               "]], 
              PolygonBox[CompressedData["
1:eJwtkctKglEURg96zmt0GURIvkwOxOwyaJKjeoogSkMHjRKxQb1EUSbUrEJq
UrPKUWYFBiUUuD72Hnw/6+z73v/s+lZhMxNCmEIRtfgsYNhAR+IUwjM8nQ2h
BA/RI3yIuvBttNhj9APXsK3hm0E78Eoylq0KX6Em/IQ+4Ut/y38GfyTzyTaA
D/ytnl/wQ7Re6tmD6z6PYpS7nGzWV/xF+J6YCnyCvuHfaCzbCP6PFqua42g7
iLXzHPl7aDVrNVX7Itnusu3DS6ifsR2167X3y6M2fBeNZdMsf95fOTni59GL
z6fZen5P/YMb+M37acd3+NTnke0cLvt9VWMRbvj9db8OvO33UM4uPAFtHEvG

               "]], 
              
              PolygonBox[{{1149, 1148, 1117, 434, 1144}, {1142, 433, 1147, 
               1145, 1146}, {1146, 1145, 1183, 555, 1178}, {1179, 556, 1186, 
               1148, 1149}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.8510394194292384, 0.6027934061891892, 0.3187819387380835], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtks0rhFEUxq/x3r9CM6HBYIv4K2QaGR8rxXJskNSskI9SFiy8ImJvdoiU
kkLZGXZs5GuMhQVLv9N9Fk+/c+45c869zzsNoxPZQsI514Fq0W/k3D4Hd7DX
O/dMnIFlivfoAVXJH+EaPEMx8QWs+FD/gJP8/rPGuXU4T57ivB8uomHiI1ik
VqVnC96icXZdwg1U4XwKrqh/Ac6Sf3E+Df/QAf0tPvRZfwHmyJP0z8E0eqKn
GWapHdIzYPfS/e0ddeSdnHfDFOoidrDJBx/Mj6R6rLdPbxmC9Zqf1ryy/OnR
HJuXkYeNcAmNUF+VT+bnJnr1IX6BM/KkKP/sva2JQMvtDbF22c5Ynpg3J5q/
DM99mH0Kd6m1MeMKvmmX7fyW5+b9Nhojvobv+t7HcC8K+3eiULOeG/gj/+07
DKISd8jBvPxv9+Ed9l1st8Ul5Xm9zf4j/4J9X4I=
               "]], 
              PolygonBox[CompressedData["
1:eJwtkssrhFEYxg9zzv9gQyhkzJaI/0GmkTFjpViOBckeuZSyYDHjErFn566U
LCTZuOzYKMxgIdZ+T+ddPF+/732/816e8zUMj6UL1c65FPLoj8cugVH0Ddeg
8Srn9lAabgvO1SaceyafhNeJJeEK+VU45+O3OpOHV1AZbuWbInzBmRLnn1AZ
TqEXcnW898GXPvZWTdW+RiPwDvqF7yyvGX/gJc4MJWLNUzGxffp9oSn4gFie
XBEdwzdWT/Nsw80h7qKdMiH2UC/F6nm/sv3UU70bbV71l1eqqdr36A3uJNZu
+8u7BZtP+82E6IF6a4YNeNbmU/8sfGv9ldesh8QebL8zuOCj19pxEJ62+1CN
OThj+0+gbrglxFk1s7xWTLkO1AV/EHs0f87hHsurhrxMmj+aqQl+DXFXzfQO
94e4m+r3wssh3q1qVuAT80fzLYa4g3aRJ0fwmo93JY+34E3z55NYCR6w/0n/
UBae9DGnmP61nPVXvXn4H60YY00=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9186039548912395, 0.6665098872280986, 0.3476722601628422], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtkkkvhEEQhntmvu8/2BKGBH/AnvgF9swY44irEeMXWELcJIwlIZY7B2JN
HCSEOOJKIkissSSWo+dN16HyVHdXvV1dXfGegY5M1DnXiMWwbODcU8S5KTgc
OpdicxPmsR5kvxa2YOv47bABy+InYIfFKHYO60X4BI6R343OJNzGcvi3cAvr
wh+BB9gc/i58NF97SfI30GyGa+j1YStYMWfXMA5nY15fWoes5+EefIG/vOkV
LpJfSfwx/Aq8xhv8wJbxP+ESVoG/AIewZ+7thwXYHzpRmEC3EL1yWGXvrYH1
1odqmLaaM3DadKTXRM4N+mXSCH0NquXMalAt7/bOn8DXrfrz8etMX/1uJbeI
syR8wq7wH0Jft+qfCXwv1BPFRa3+CJwgLs3eqPVJMerfN2er5J4H/j+Uf4Gf
s76pf8rT32kmSkIf/2372lNfOm1+NEeXFq+/vA/9ehze2Z/t6B6bpVTg9/QW
1aW/VU90R5vN4bDNhTR154/1qjT0s7ZqOaeBn5MjO1ef1fd9e7Nm5B87QGif

               "]], 
              PolygonBox[CompressedData["
1:eJwtkskuRFEQhg/33KcgoRHEC0g8g7F1625LbBHCExBiJ0F3b8SwZ0FMSwkx
7bAlEWNLRLyB70/V4r/5qs6p4VTdzNh0dqo+hNCFIrrg04ljAt3BVbe/60JY
g8uoA3scVeB1t2ucz8HDaQiNSQjP+Hrhe3zFxHw6m4+WSzk34B+07fWu4Hbu
NHD3CbsNXkClxHw5+I87W/V23oTdjT1Dvj3UHy1GZzuoGT5G5cR6OISX0AP8
iD7goWix6n8kmk9ninmF391WzCec9/eNokW4j5h9YmdRD3yCr5JYz8vwKap6
vRqc9fcV0GBqM6t5/0XNOrXZqcYAvJJaLeU4gyd9fqqZj9aTelPNL3jV82kn
2pV2qNnuol/4ILXaG+gIvo02K+3zJprEit+EMz5P9azeW70/7awBzkV7u/op
wS2p1dIdveXc62vf+pdeUqutnt/gS6+nnV7DBd+HdpqFp3y+erP+nX+5V15Z

               "]], 
              
              PolygonBox[{{1049, 247, 1053, 1051, 1052}, {1078, 370, 1081, 
               1054, 1055}, {1052, 1051, 1080, 369, 1077}, {1055, 1054, 1024, 
               248, 1050}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9450290887873929, 0.7325727219684822, 0.4295901752409179], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNlUts1VUQxv/33nNEg8ZHjLWKNgRxB30qlqhx4UYjDyGwFVip7X3QBCUx
Pjay9YFRN+KbpO1tS+ltqyYkKjG68lElEeoDLQFdYBXBhYmP35f5Gl3M/c7/
nDkzc2bmm7tyV31LrVwUxQxSQZr8NJAa8mUuikPgMfDFVBSrUXwWXAXuRB5A
PuNsEJ03ctwbR4aQp9Fbx3kTnEL6WY+B+5GbWb8MjlbC3wjyku3LzyPgeuQ2
ZK/X2qs5th7kbfztBt8E/wQvEPvf4Ncp7k2Ak+AeZMryKDJdjrj6ffZtCh8/
prDbh/zh+BTnB+A/2sP+X+BzfN/E/tYU8ehOF3IjcZxgvz3Hu4aRqqVeib29
fkerHLFrvxcZxNZIqSg2p4jvN8c74/dLfxtnTXSqKfItn2uRM6XIm2oy5Pyr
ZtuVX87uB38qRcx6z2s57g24Xn1+w+t8D4Cfat81fsa+RtwPO+1H/nKO/C4D
P0lx9hE4nKJe4+AKpBff7WBfKXLYA37I9w50joD3OG/KX59yynkXuBapsu4F
f8H3e9w9C25Arw18DLzOdjvAeo5cVnP47C5FT1yVYn0NeDFnh/F1ETiFvID+
DLhR99FZB97imBV7B2fzqgfrLazb0V8JLoDvYvtUJXTr9reCs+Po3wAedB+O
ggvILOtL2X8/BW+Our9Ul13IE5xtw94E+Lx1pCuf2tebNzsGxTJmTu1zP+6w
naZ5N6+e8lpc7PfblQPV6hXzt2G+qg9qObAB/uwaqVZ38X2B9ZXgAfvR2Vs5
7h4ETybzC7w8x3v17odY/8r6DvB2ZJH1g6od975hfa05IC50V6Lv95irbSn6
5WpwzBySXqMUfSI+fIWtCfbmPKvU//pe4HsOPJ1DT/ri2LhnjuxNcrYf/C7H
/pjvHrOtoRyx9Dse8fJ3pJOzc+XgkXh43lzV3knufMHeUznmyDvlONc95VBv
1HrW34fQ287ekzl4rvmgOk04Hs0J8UBcHkbuTYGbwM9zzJnBHLND7+tJwT1x
cDbFW0dt63v3fMvvbTgXVc+rAXO9ab5POz+H7WfU57ttT7XY5HgGzNe6YxUv
VTvVan0K3GB+N3x2xm+S/mnXax94yjn8wbXTuzTDquaZfGx1D815RtX+V4su
z7QOz4dbU9Sn5Rqdd120p9zLjvrw8Ry4EbzP9uVnmWfdJeDHKfr/bIo6TruW
4qe4P+//HnFfM0A9fsJ9vjyH3yty9NK0+6Llmosn1+e4s8pzTvbazZUDtrXo
/wfZaPPM0exRX66pxH6n+0z9dqd78W7wMsew3Prdrr9Q/bjExaU9+Zq0vx7/
Nyp/D+fw9Wr+L+/K7XHPFsVddU8t8aXlNy469jWOt9N653wuXv0LHGkd3A==

               "]], 
              PolygonBox[CompressedData["
1:eJwtlElIVWEYhs895/+DomggMo0Isdol5bVMqWjRpkhp0m3lykrvdaABonHh
tsGgVfMA9xo4pVbQIiJq1XBr0WBmJlRkNoAugobn7TuL9/Ccf/zGv7A2vSUV
BkGwDTm0gk9pIggaUQV80wfBmSgIalAnXI8ycBY9g5OsaWBtBm2Am9AnOIvq
4XyUhMc5ezQyiW+jL3ArZ+R0FhqBN7O+nfVpVAXPRiXwBOv/suZ3ZHwHjcFb
mV8Y2p26ux2t5L8CZeDj3myXDz3wSGR3y4Zf8FFvd8uGYbgRlcLN6Cr8J7Z3
GefP4ryEs7tlQwhf97a2Ez2Hp6A+7r6FpsEzvPEEWgN/Z885eCd6BB9jrJq9
+WgT/BjtiSzGT+EG1txImH8tcLO3uzrQC3gQtcXxG4JPsKaIs7ej0858ysX+
v4PHGDvP3A70GU6jjwnb0+gsp8ptPXoCDzN2IDSf5NsV1MRcEqXhe8wvZq4W
PZR98XnKYQ38BpUxtxcNwBfYsyQyHy/BrYyVh7YmC09mrAv+hlbBP2N7B9A8
/uejV3Ae+yvhIm9zBfxvhMuc1Y5qbjlc6ayWFcNquC+uZ8XkA/w+zr9i2Kt/
1vRy3n40BOe8xVo+X4Mve4tNMboI/5CPoeVUuc05s0U1p9pr8BarcebXwiXO
eiOFSuGvzmInH+Vrv7PaVczfOqsx1Zp6sgBerRpirhuVq1a82aKxXfBBb7FR
TR2Gp6L+0HySby1xfypnbepP5l/H96s2lCPlSjnwzN13Vkvyb1SxcRYb5awH
nuOsN/QGFMOTvNm2Dw0626O9/3Mme529FaoR1V5HXP+Kfxdc5y33qpHdcKG3
3lCMF8BH4n6eiw7BVd5YPqyHZ3qLtXyeDj9w1muL0FlnNsk2vREv4aXOcqE3
Jg/ujvtJNqk313nrXb0JKfius97Rm3MKPunsbPmj2v8HLbu6Dg==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9714542226835464, 0.7986355567088659, 0.5115080903189937], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNVldwlkUUzZ9vF4GhKHV8cCgWBEFQIKCQGAWp6ozAm4plgIQEgQCJhiQE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               "]], 
              PolygonBox[CompressedData["
1:eJwtlldwVUUcxu89Z1dEFA2EoI4FsFMtgKgkgEqzC76pqKhAQiQoRUO3dxHe
KHYSApJAAIeAozD6DDg2MiKCgKGozKggJkDw9813Hr65vz1nd8/uv96uYytG
TUpyudwiFNCzMZfrmOZy96NK+Cl0nAn9GFfA85nUlfFv+VxuMnwFGgi3svYo
czZozPtWntXBy9ENjCtQFfwxe5QxrwZth9uiP3m3GrWBr2LOYNbOQbfCn6KT
cAuqhl9GzfAJtBJ+JZhPoVr4PfYYz96foCXwKp71S7xGayfwrEfqbw6EJ6P+
jP9jPAl+gzm/MvdSxm/Bj6ANjI/pTPC8YNaddLcXg7+9GY2DX0CTedcX1cBf
oG7wGPSV7hNt2/moFt7JsymJz6iz1qNbEu/5KnwJcxoZFzF/JPwjWgdPQyui
bSxby0Yr4NWoP/Onoka4I+rFu1LUA36aNTeytpn3Q+GZaDTjTuhuuDzaN8vR
N/BWtAyegN6Hj/FbkrePLme/TaiEvWah3fB9qIZ3Tahc32fNpsT2HQT/lTpW
cryPuivP/uBdHRoAn5fN137t4A9QaWqflcGvs6Y4sY1kq8NoMfwQOgB/jZbA
D6Mtir9oW+nOU6PvoLt0R0ujfSxfP4jeDo5BxaJ8EuGL0I7Ee3aGi9ERuCfr
S+En0O+Mr2E8Dl6JpsPr0Y5on8v3S9EheBrPBqSeUwP/FB0LW9HP8C60DX4X
7YTXZvkkG6+B79WdsN1EdAc8VjEGz0VD4Y1oZmIbNcDfsscU9qpH38Mh2taK
0QRejxbK12g33BRse/mgfbQPNJ6BzoFbmfcP7tuAWuDnmf8v325A3eG9wXN1
5l3wXNY8kPoba+BDqddqj+PwvOhvb0d7lLus2ZJ3TL8Ej0DVcBm6Dh6JqvLO
0bvg61F53jGn2Fsc7QvVANWCR4PPNgNdDQ/jWUtiH0yBB/GsMu8cH6PahgbB
xahdcA4rl3XHufDnwbHWBb0DX6YYznuP4uAYV6zrG7fBhVn93Ig6wLdn72Xf
EsU7a/rknaMnU9c41TrlsHJ5eHBtkY/l67ro2BiFVsFnROf6GnQmPDG4NitG
FCvNmb/0DX1rNXMWpM75OfC+LF50vnMZF2Xn0ZoO8LVS3jbuq1oeHHua0xvu
Geyb3qgT3D6YtaYguIarls9TzYDz0b2gFqVwG9XPnG3YBd4WXXuU8x/BJcG+
U4/pBl8cXauUk8rNat0/dQ1fFm0D2UI5epPsEZ2r6jkfwr2Ca6FiqA/8OPoy
75h7DD6bOZWJbSLbzIi2dSF6Dr4nuhYrpmerd/E7i/M3oCNwYM3pnO/0N+P9
WbzPRPtS1yTVJvXQhcExpljTmrbqT8qhvGP+Tnh8dK1SjXwSPpj6W/pmE1wQ
7TvF2GDlanQtUQ1RLanN+pPq5Tr4guhapJ6i3rI39dl0xgPqg+hodp/D6qPR
vV81pEq5FVxrZqMh8C/RuauYqodfy/qR8l+165no2rMW/aBaybNFif13PuNh
wbEhH8gXo4N7h3rmAvjCrP+pxhepd0XHjmruzdE5qFyUzd4M3lN76z/McPis
4F6jnqXeNSLal9pTe+tMOpti6Dv4s6z/Kgb2wNOja7l6biN8KrO/bHQa3hzc
O3Sng3Bh8DvFf2d4SHSvlX9UCwqyfNKcE6ltKFuq5lyp3A32p+JvP/w/LilE
RA==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.95, 0.75], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNmnfYltWRh5/3e5+XXqSIgGLFiMaspmw0NvhA+GjSBARjELEmWTVZSywB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               "]], 
              PolygonBox[CompressedData["
1:eJwtlElsjlEUhr//++41hYo2tSNqalGR2tBKB6paKiF2taghnUgQMbQVilZi
Sm2J2CGGllhog9JSdmyVlqQInSxarRjyN+F5HYv3/997zr33O8N7T8rOfVv2
hkEQlAIHJvAT578DjERBcJ91jA254AG82AdBIvbNoAY+zP9T9o6DSfgbwLNY
EPwBp+E32JPJnmpwC56KbQ0+B35ge+js7mPgM9zpPHc9B2P4d7P+wN7Z+M/D
l4JK1ksExcadTfj2gG7W28AYvhZQCv/i7O42kMjeKtbXYnan7i7C1hVaTsot
B1sNvlaQBl8Prsbsm8vg+9kTDy2ng/AUxYAvAlPh1dg24ZsBNsDLsZ3CVw92
wC/Lhi8VVMCLsFXFLKZi+Dkwi/t7We9SrdjTzvoxyIc70AwfAivh253F+h0s
hp8AGaHVoA5eCE7CG0CZsx6pV1k6QwxHvPXyAmiGtzmr9VbQ7qymqq3uvK5v
gVCCAffgHeAivEQxwld7q/UTkAxfAQZD61EEn6ca8e1MMEe9BJ0xq5FqtcBZ
bOrBXHgPZ14SWyO4Ax/Cdim0ns1kneRMC8OENA1+1pn2pFlpVzEoFvWsAL7O
WS/WCvC73nJ/Bd7Bv2J7HVpOA/BD2LLwjbM+AF+kHDmbLzjruXov20L4Km+9
SeNMOTwdW3rMepwBv42tJrI7b8LrsS1nvx5hj3rlrJeyHXf2RvRWQjCf9XQw
EtidyfAkb9qoAwneclJuemN5zjQoLSqnQniZN+2pJ1neclAu0kgBvMlbraXh
Wng3aI0s5jfeeqxeS6ON8F/YW4lnFMThCc64YlSsR73VVj18r/p7q6U0LW3n
Onur0kS2M81Je+pxP/wRyAtNc9LeFGe1eMH9EbzPWe7a0wv/zXe+4WsBP+ET
nWkt/n+2DUjzgcU8FNmb0NvQzKrQvMCWE9ievsjeoN6iZsBG+Bln2v+nWfhg
ZN+qBf36NugMbCZqNmqGapZqpo3CP0W2Nxt8jCwH5aIz3tnM0+zTTJnsTNPS
tnIax3eYmrVE1hP1psvbbJXtrTcNSUuaESHrSm9arABX4H8BKcfADQ==
               "]]}]}}, {{}, 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{993, 994, 999, 1001, 1015, 1017, 1040, 1020, 1037, 
               1043, 1067, 1069, 1071, 1097, 1100, 1129, 1162, 1164, 1165, 
               1212, 1215, 1256, 1259, 1304, 1351, 1354, 1399, 1401, 1451, 
               1453, 1498, 1500, 1404, 1501, 1499, 1454, 1452, 1402, 1400, 
               1355, 1352, 1306, 1302, 1258, 1255, 1214, 1211, 1166, 1163, 
               1130, 1128, 1099, 1096, 1073, 1068, 1045, 1039, 1038, 1041, 
               1019, 1016, 1002, 1000, 998, 997}], 
              LineBox[CompressedData["
1:eJwVz7kuBFAUgOHLzNijsPTGzgsQwmAsvQewDGY6IrbOnuAVbJ0MKkQE76C1
NRq0drVP8eU/t7rnxFNTg5M5IYQFdmIh7LFNmnHaaCFCDg/REA7IsswiwwyR
oIMaqsgnj/dICJ9EzV9aqMXEKaGebppI0keKAcZJs8YGp2xxziVXPPNCmf0q
6KaSPqaZJcsRt9wz/38LdxxzyBwz9NNDkgTllPLqjyeuueCEMzZZJ8MEo4zR
Ty9d9NDAr/tr9UeLNEKMD+83CszfWqfVdNLICM2ssMQhqzySa7corbQzQYZd
9rnhD4qTNtY=
               "]]}, "0.9`"], Annotation[#, 0.9, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{995, 996, 1018, 1022, 1042, 1046, 1070, 1075, 1098, 
               1103, 1131, 1135, 1136, 1167, 1170, 1216, 1219, 1260, 1303, 
               1308, 1309, 1357, 1403, 1406, 1455, 1457, 1502, 1504, 1408, 
               1506, 1503, 1460, 1456, 1407, 1405, 1358, 1353, 1310, 1305, 
               1262, 1257, 1218, 1213, 1169, 1107, 1137, 1132, 1104, 1074, 
               1076, 1072, 1047, 1044, 1023, 1021, 1006, 1005}], 
              
              LineBox[{1190, 1199, 1240, 1246, 1286, 1288, 1337, 1341, 1385, 
               1387, 1440, 1442, 1487, 1489, 1388, 1488, 1486, 1441, 1439, 
               1386, 1384, 1340, 1289, 1287, 1285, 1244, 1243, 1196, 1157, 
               1194, 1158, 1197, 1203, 1205, 1248, 1249, 1292, 1251, 1295, 
               1297, 1344, 1389, 1391, 1443, 1445, 1490, 1492, 1394, 1493, 
               1491, 1446, 1444, 1392, 1390, 1348, 1342, 1296, 1291, 1293, 
               1290, 1250, 1245, 1207, 1198, 1193, 1195, 1190}]}, "0.8`"], 
            Annotation[#, 0.8, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{1003, 1004, 1049, 1052, 1077, 1079, 1102, 1105, 1110, 
               1138, 1168, 1174, 1175, 1221, 1224, 1264, 1265, 1311, 1313, 
               1362, 1360, 1409, 1458, 1461, 1505, 1508, 1414, 1510, 1507, 
               1462, 1459, 1410, 1234, 1363, 1356, 1315, 1307, 1266, 1261, 
               1223, 1217, 1176, 1171, 1139, 1133, 1109, 1101, 1082, 1078, 
               1055, 1050, 1026, 1025}]}, "0.7`"], 
            Annotation[#, 0.7, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{1024, 1054, 1081, 1083, 1108, 1113, 1134, 1141, 1173, 
               1180, 1220, 1227, 1263, 1270, 1314, 1320, 1359, 1365, 1412, 
               1417, 1465, 1469, 1464, 1513, 1509, 1511, 1512, 1466, 1463, 
               1415, 1411, 1364, 1318, 1316, 1312, 1269, 1226, 1225, 1181, 
               1177, 1172, 1140, 1112, 1111, 1106, 1048, 1080, 1051, 1053}]}, 
             "0.6`"], Annotation[#, 0.6, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{1084, 1116, 1144, 1149, 1179, 1184, 1222, 1232, 1267, 
               1272, 1319, 1324, 1361, 1370, 1416, 1421, 1468, 1473, 1515, 
               1518, 1424, 1516, 1514, 1470, 1467, 1418, 1413, 1368, 1323, 
               1322, 1317, 1271, 1230, 1228, 1185, 1182, 1178, 1146, 1142, 
               1114, 1115}]}, "0.5`"], Annotation[#, 0.5, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{1117, 1148, 1186, 1187, 1231, 1235, 1268, 1276, 1321, 
               1330, 1369, 1372, 1420, 1425, 1472, 1477, 1519, 1522, 1429, 
               1520, 1517, 1474, 1471, 1422, 1419, 1371, 1366, 1328, 1277, 
               1273, 1236, 1233, 1229, 1143, 1183, 1145, 1147}]}, "0.4`"], 
            Annotation[#, 0.4, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{1188, 1239, 1275, 1279, 1326, 1329, 1367, 1377, 1426, 
               1431, 1476, 1482, 1523, 1526, 1432, 1524, 1521, 1480, 1475, 
               1427, 1423, 1373, 1331, 1327, 1325, 1278, 1274, 1237, 1238}]}, 
             "0.3`"], Annotation[#, 0.3, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{1280, 1334, 1376, 1379, 1430, 1433, 1481, 1484, 1527, 
               1529, 1479, 1528, 1525, 1483, 1478, 1375, 1428, 1378, 1374, 
               1332, 1333}]}, "0.2`"], 
            Annotation[#, 0.2, "Tooltip"]& ], {}, {}, {}, {}}}], {
        DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
         Identity, Frame -> True, FrameLabel -> {{
            FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
            FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}}, {{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, {{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}}}, GridLinesStyle -> Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 300, 
         Method -> {"DefaultBoundaryStyle" -> Automatic}, PlotLabel -> 
         FormBox["\"(c)\"", TraditionalForm], 
         PlotRange -> {{0.032258, 1.}, {0., 1.}}, PlotRangeClipping -> True, 
         PlotRangePadding -> {
           Scaled[0.02], 
           Scaled[0.02]}, RotateLabel -> False, 
         Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"Full batch\\nmachine \[Eta]\"", {FontFamily -> "Arial"},
                     Background -> Automatic, StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0.2058505584687798, 0.36213919914932213`, 
                    0.5941775071374287}}, {{0.35477540485947645`, 
                    0.4283875224745764, 0.6105154169516177}}, {{
                    0.520196743049397, 0.486522817046114, 
                    0.513270924213773}}, {{0.6856180812393177, 
                    0.5446581116176515, 0.4160264314759283}}, {{
                    0.8510394194292384, 0.6027934061891892, 
                    0.3187819387380835}}, {{0.9186039548912395, 
                    0.6665098872280986, 0.3476722601628422}}, {{
                    0.9450290887873929, 0.7325727219684822, 
                    0.4295901752409179}}, {{0.9714542226835464, 
                    0.7986355567088659, 0.5115080903189937}}, {{1., 0.95, 
                    0.75}}}, {{
                    Rational[-15, 2], -150}, {
                    Rational[15, 2], 150}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], -150}, {
                    Rational[-15, 2], -150}, {
                    Rational[-15, 2], 150}, {
                    Rational[15, 2], 150}, {
                    Rational[15, 2], -150}}, {{
                    7.5, -150}, {-7.5, -150}, {-7.5, 150}, {7.5, 150}, {
                    7.5, -150}}]]}, {
                    CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -116.66666666666666`}, {
                    Rational[
                    15, 2], -116.66666666666666`}}, {{-7.5, \
-116.66666666666666`}, {7.5, -116.66666666666666`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -83.33333333333333}, {
                    Rational[
                    15, 2], -83.33333333333333}}, {{-7.5, \
-83.33333333333333}, {7.5, -83.33333333333333}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -50.}, {
                    Rational[15, 2], -50.}}, {{-7.5, -50.}, {7.5, -50.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -16.666666666666686`}, {
                    Rational[
                    15, 2], -16.666666666666686`}}, {{-7.5, \
-16.666666666666686`}, {7.5, -16.666666666666686`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 16.666666666666657`}, {
                    Rational[15, 2], 16.666666666666657`}}, {{-7.5, 
                    16.666666666666657`}, {7.5, 16.666666666666657`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 49.99999999999997}, {
                    Rational[15, 2], 49.99999999999997}}, {{-7.5, 
                    49.99999999999997}, {7.5, 49.99999999999997}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 83.33333333333331}, {
                    Rational[15, 2], 83.33333333333331}}, {{-7.5, 
                    83.33333333333331}, {7.5, 83.33333333333331}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 116.66666666666663`}, {
                    Rational[15, 2], 116.66666666666663`}}, {{-7.5, 
                    116.66666666666663`}, {7.5, 116.66666666666663`}}]]}}}, {
                    Antialiasing -> False, 
                    StyleBox[
                    
                    LineBox[{{7.500000000000001, -150.00000000000003`}, {
                    7.500000000000001, 150.}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.500000000000001, -116.66666666666667`}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -116.66666666666667`}]}, {{
                    7.500000000000001, -83.33333333333334}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -83.33333333333334}]}, {{
                    7.500000000000001, -50.}, 
                    Offset[{4., 0}, {7.500000000000001, -50.}]}, {{
                    7.500000000000001, -16.666666666666675`}, 
                    
                    Offset[{4., 0}, {
                    7.500000000000001, -16.666666666666675`}]}, {{
                    7.500000000000001, 16.666666666666647`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    16.666666666666647`}]}, {{7.500000000000001, 50.}, 
                    Offset[{4., 0}, {7.500000000000001, 50.}]}, {{
                    7.500000000000001, 83.33333333333331}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    83.33333333333331}]}, {{7.500000000000001, 
                    116.66666666666664`}, 
                    
                    Offset[{4., 0}, {7.500000000000001, 
                    116.66666666666664`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox["0.2`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -116.66666666666667`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -83.33333333333334}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.4`", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, -50.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    
                    Offset[{7., 0.}, {
                    7.500000000000001, -16.666666666666675`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.6`", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    16.666666666666647`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 50.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0.8`", TraditionalForm], 
                    Offset[{7., 0.}, {7.500000000000001, 83.33333333333331}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    
                    Offset[{7., 0.}, {7.500000000000001, 
                    116.66666666666664`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 300}, BaseStyle -> {}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ),
           InterpretationFunction :> (RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"Blend", "[", 
                    RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                    "]"}], "&"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.106563`", ",", "1.052632`"}], "}"}]}], "}"}], 
               ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.1`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.2`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.3`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.4`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.5`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.6`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.7`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.8`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.9`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               
               RowBox[{
                "LegendLabel", "\[Rule]", "\"Full batch\\nmachine \[Eta]\""}],
                ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", "300"}], ",", 
               RowBox[{"Ticks", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.1`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.2`", ",", "0.2`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.3`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.4`", ",", "0.4`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.5`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.6`", ",", "0.6`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.7`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.8`", ",", "0.8`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.9`", ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.7451681259572268`*^9, 3.7451681777909417`*^9, 3.7453132336206307`*^9, 
   3.7487871951033545`*^9, 3.7487873154804564`*^9, 3.752339615385169*^9, 
   3.7523397061560698`*^9, 3.7523398682571564`*^9, {3.7523405434172583`*^9, 
   3.752340554520694*^9}, 3.7523406303492327`*^9, 3.7523407089300117`*^9, 
   3.752932253796254*^9, 3.7530194468289633`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<complexbatchplot.pdf\>\"", ",", "complexbatchplot"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.745168221951959*^9, 3.74516823251581*^9}}],

Cell[BoxData["\<\"complexbatchplot.pdf\"\>"], "Output",
 CellChangeTimes->{3.7451682847243195`*^9, 3.745313313988676*^9, 
  3.748787199121038*^9, 3.7487873256745653`*^9, 3.752932262781582*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FIG 11. Fluctuations", "Title",
 CellChangeTimes->{
  3.752283603626091*^9, {3.75300848213592*^9, 3.753008484073442*^9}}],

Cell[CellGroupData[{

Cell["(a)", "Chapter",
 CellChangeTimes->{{3.7530194693782425`*^9, 3.753019470034601*^9}}],

Cell[TextData[{
 "This cell calculates the mean infimum of trajectories of the Markov machine \
by simulation and outputs the data to an appropriately named file.\n\
\[OpenCurlyQuote]m\[CloseCurlyQuote] is the number on input molecules in a \
trajectory.\n\[OpenCurlyQuote]trajectories\[CloseCurlyQuote] is the number of \
trajectories in the simulation.\nTo make the contour plot the mean infimum is \
calculated for a grid of parameter values.\n\[OpenCurlyQuote]dk\
\[CloseCurlyQuote] is the step size in the ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " parameter.\n\[OpenCurlyQuote]da\[CloseCurlyQuote] is the step size in the ",
 Cell[BoxData[
  FormBox["\[Alpha]", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " parameter."
}], "Text",
 CellChangeTimes->{{3.756037183857187*^9, 3.756037252176708*^9}, {
  3.7560373435771656`*^9, 3.7560374126312866`*^9}, {3.756038527794916*^9, 
  3.756038585206991*^9}}],

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m", "=", "100"}], ",", 
     RowBox[{"trajectories", "=", "10000"}], ",", 
     RowBox[{"dk", "=", "0.02"}], ",", 
     RowBox[{"da", "=", "0.02"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"\"\<data\\\\makovinfimumcontour-molecules\>\"", "<>", 
      RowBox[{"StringReplace", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "m", "]"}], "<>", "\"\<-trajectories\>\"", "<>", 
         RowBox[{"ToString", "[", "trajectories", "]"}], "<>", "\"\<-dk\>\"", 
         "<>", 
         RowBox[{"ToString", "[", "dk", "]"}], "<>", "\"\<-da\>\"", "<>", 
         RowBox[{"ToString", "[", "da", "]"}]}], ",", 
        RowBox[{"\"\<.\>\"", "\[Rule]", "\"\<_\>\""}]}], "]"}], "<>", 
      "\"\<.dat\>\""}], ",", "\[IndentingNewLine]", 
     RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"#", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{"1", "-", 
              RowBox[{
              "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
             ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
            "}"}]}], "}"}], "&"}], "/@", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"a", "\[Equal]", "0"}], ",", 
               RowBox[{"Print", "[", "k", "]"}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"k", ",", "a"}], "}"}], "~", "Join", "~", 
              "\[IndentingNewLine]", 
              RowBox[{"Mean", "[", 
               RowBox[{"Table", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"#", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], ",", 
                    RowBox[{"Min", "[", "#", "]"}]}], "}"}], "&"}], "@", 
                  "\[IndentingNewLine]", 
                  RowBox[{"(", 
                   RowBox[{"(*", 
                    RowBox[{
                    "Make", " ", "trajectories", " ", "start", " ", "at", " ",
                     "zero"}], "*)"}], 
                   RowBox[{
                    RowBox[{"{", "0", "}"}], "~", "Join", "~", 
                    RowBox[{"Accumulate", "[", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    "The", " ", "two", " ", "states", " ", "are", " ", 
                    "symetric", " ", "so", " ", "we", " ", "only", " ", 
                    "need", " ", "to", " ", "check", " ", "if", " ", 
                    "sucessive", " ", "inputs", " ", "are", " ", "the", " ", 
                    "same"}], "*)"}], "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Log", "[", "2", "]"}], "+", 
                    RowBox[{"Log", "[", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "\[Equal]", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}], ",", 
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"2", "a"}]}], ")"}], "2"], 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"2", "k"}]}], ")"}]}]}], ")"}]}], ",", 
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"2", "a"}]}], ")"}], "2"], 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"2", "k"}]}], ")"}]}]}], ")"}]}]}], "]"}], 
                    "]"}]}], "&"}], "/@", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    "To", " ", "calculate", " ", "the", " ", "work", " ", 
                    "we", " ", "need", " ", "all", " ", "overlapping", " ", 
                    "pairs", " ", "of", " ", "inputs"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Partition", "[", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    "To", " ", "get", " ", "the", " ", "input", " ", "I", " ",
                     "saple", " ", "1", "s", " ", "with", " ", "probability", 
                    " ", "\[Alpha]", " ", "and", " ", "then", " ", "XOR", " ",
                     "them", " ", "with", " ", "the", " ", "hidden", " ", 
                    "state"}], "*)"}], "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Mod", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "-", "a"}], ",", "a"}], "}"}], "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}]}], ",", 
                    RowBox[{"m", "+", "1"}]}], "]"}], "+", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    "This", " ", "part", " ", "does", " ", "the", " ", 
                    "hidden", " ", "state"}], "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"Mod", "[", 
                    RowBox[{
                    RowBox[{"Accumulate", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"(*", 
                    RowBox[{
                    "I", " ", "need", " ", "to", " ", "start", " ", "with", 
                    " ", "a", " ", "uniform", " ", "hidden", " ", "state"}], 
                    "*)"}], 
                    RowBox[{"RandomInteger", "[", "1", "]"}], "}"}], "~", 
                    "Join", "~", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "-", "k"}], ",", "k"}], "}"}], "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}]}], ",", "m"}], "]"}]}], 
                    "]"}], ",", "2"}], "]"}]}], ",", "2"}], "]"}], ",", 
                    "\[IndentingNewLine]", "2", ",", "1"}], "]"}]}], 
                    "\[IndentingNewLine]", "]"}]}], ")"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"{", "trajectories", "}"}]}], "]"}], "]"}]}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"k", ",", "0", ",", "1", ",", "dk"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"a", ",", "0", ",", "0.5", ",", "da"}], "}"}]}], "]"}], 
          ",", "\[IndentingNewLine]", "1"}], "]"}]}], ",", 
       "\[IndentingNewLine]", "1"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"markovfluctuations", "=", 
  RowBox[{"ListContourPlot", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<data\\\\makovinfimumcontour-molecules100-trajectories10000-dk0_05-\
da0_05.dat\>\"", "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "4"}], "}"}]}], "\[RightDoubleBracket]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", "\"\<\[Alpha]\>\""}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"#", ",", "None"}], "}"}], "&"}], "/@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"list", ",", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"list", ",", "list"}], "}"}], "]"}]}], "]"}], "/@", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0.5", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0.5", ",", "1"}], "}"}]}], "}"}]}], ")"}]}], 
      ")"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"BarLegend", "[", "\[IndentingNewLine]", 
      RowBox[{"Automatic", ",", "\[IndentingNewLine]", 
       RowBox[{"Ticks", "\[Rule]", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "}"}], "&"}], "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1.2"}], ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "0.8"}], ",", 
              RowBox[{"-", "0.6"}], ",", 
              RowBox[{"-", "0.4"}], ",", 
              RowBox[{"-", "0.2"}], ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1.2"}], ",", "\"\<\>\"", ",", 
              RowBox[{"-", "0.8"}], ",", "\"\<\>\"", ",", 
              RowBox[{"-", "0.4"}], ",", "\"\<\>\"", ",", "0"}], "}"}]}], 
           "}"}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
       "LegendLabel", "\[Rule]", "\"\<Markov\\nwork infimum \[Eta]\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"ImageSize", "\[Rule]", "350"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7452226661462326`*^9, 3.745222681179279*^9}, 
   3.7452291597305403`*^9, 3.748786913839429*^9, {3.7530197087939854`*^9, 
   3.7530197466571603`*^9}, {3.7530201874071164`*^9, 3.7530203080605946`*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[
    GraphicsComplexBox[CompressedData["
1:eJx1enk8lG/3f1QiJC0qbYo2+SiptOCUUtqjXaUo7YssJUsp2lBpkSVrEUpR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     "], {{{
        EdgeForm[], 
        RGBColor[0.148, 0.33, 0.54], 
        GraphicsGroupBox[{
          
          PolygonBox[{{1073, 424, 1036}, {1039, 424, 1075}, {1036, 424, 
           1039}}]}]}, {
        EdgeForm[], 
        RGBColor[0.2585141649873893, 0.3913967583263274, 0.6434973926072376], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxNk7suhFEQx7/zfesWCpdgbeGSuEWCSmNXwVIoeQHiAXgCPAAaPIDdRqJ2
yRISwQuoXSrFRigQl85vzH8TxezvfHNm/jNnztmepZX55TiKolkswUb4yMMh
OKz1KHwMUZRm/QA/CNyAZViNrwrLWC7WgQ2L5k9JN611HT/b5NbCHbgW/Pue
oFV4B7upN0FsHrYSd4C/HTbwPYq/EZ4H172CTyx2YT0x18F7upGu6ZtupSfr
Yz947W3Vs/0SrI09rgaeJZ57Aevkt/1nfI2sb+Ele+vwJvH+rM8xmEn5fGxO
Gc3Bapc1txfYzHcT1i8biNxXmaOd85vYQfgTfL9FMWnp2Txf1I/11SKdQel0
SOuTelvsf8FFzjCHbwG2xV77U3Vykc89Jw3T6qVIkf0+OIWdsM6nfM9ys5Fr
F4LHZZU/oBpWazr2GdmsHsU13cGecjdlG/LNKHdRd27nsLdY0n2dJp63pbxJ
ejqEuZTnVc4xHntPnbBL78rel/V6HPw8BdU8kq8o35H8plsO3sffG9T/wv4r
WelbndfEe3nTGe18u/90TfNdd2F38gtAgFpJ
           "]], 
          PolygonBox[CompressedData["
1:eJwtkDtKA2EUhe/8M6hBwQSJSAoloiJCfJDSiJDoApIluABdgboAtdEsQGwk
qQUhYsAiK7DWYGFhEQMKPrp8hzvF4f+4rzlzigdHjcNgZgsoQd3Y7CQyO0VP
8CTNdeollIE3Gbqld4kycAXdwddoEf7nXWV2RzeZ/+LGObUL9A3vUqvQ25bg
39h7N2iJ/fHg35pDfWrT1Jq8V2gK7jB/HLnHB/lL+y00A5cT52a6O+TNcSuL
BvAPWjGvqfesPXPPf+kN7bdRHl7DT808A2XxRr0Ab6CP1JO8KZMtuBb83+to
H+7HnqX8vMM93jHzG7o1oHYWeUaf8F7wXWWkrJSpstVMAZ5IPHtl8MJ8NrgX
eSzB88Gz1T/Owq+RZ8moPcLLiWd9j6rwCEOsNao=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.5143536806527692, 0.4844693446383534, 0.516705823514027], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJw1lV2IlVUUhr+z9xGTAY38Q5PC6NhMJJiFmtUM6RgROmNztEbvnFHP5F8E
ZcXMoDNoFwXiKAOiphdilkKRCopS0UVGKCqIFIWJF0N1oZLiXxfZ87JeL9b3
rm+ttddee/3sPbnjnbZ1qSiKfVCG+vnMKhVFD7ia/zXQW1AztASaB1WhRqgN
mp5CNhN8s4g1sn8bH4ugLuh16+aDs6DZ8JNS6GRThdZDH0Ad0IvoFmLTBC62
jfxViakBXAw+US6KvfAvgTXF671+hcaz9ndwhfaA7wJb+O+EWkvhU/5WQfNS
nGNuijPqLNOKiGOZ42pxXJ1G/S+wvsP8v1AD6+6DX+JrK/wguBMahN8BXiLu
AfQPEXMzdFzrkP0JvQ9/HlyKXSv27eAQ/xuRXwbvQlvg/8tRG9Vog9aCo7Af
Ajexpl81dL5VhznQWNdItVrvuLXfONfiMXAMVIG/hbytFDlVXQ6oD8BvwVeK
8Cufr6bog9ect3b3x1Mp7OrBkznyfAI8AarPvpcv1+gP8AXnTzldYz+KW3Wa
bbl6aqN7UdhnXvINlr2H8xXg8hT6tbbpNy/ZiBSx16XYU3srjzVkPUX0inwN
2r7XMuk+wm459KH79EEvdPpf8l05cvdZjly0e+9Pc/Tclhx57XJuR9ADn4PT
ylFv1X0O+Bd2g8hHIl/rmvaliLPb8dT5LE+DU12Dh8G7rBsDf8HxtjrGhO4Z
5MPAa6Xo8ZHwV+Afhf8RPAUNh/8Z/Nty6a+XojduO2ctrs1Vy6U/6rMdy5Ez
9UbNd0TN/+JX+n8ldhXNqHrftVMNO51Lxf6T+/9Kjjy2u6bdD3wUMTPq5VPg
GdYfQHYafDzFPN5Dty3Fmm5wbDlyO7octVIdGj0Pn3jev8kxIwfBHTlyuBPc
71nQTIy2n7pyzHqP43rZ8yOfP+S4Y77LcWfp7loNbvf86q59shxzfSdHf6hP
9oBNyI8o3+C1HD12FVwnHfy74OEceTqS49xfQNt916iHd6WoU8V163Mv6Z7Q
uZscp9ZsK8LHczobsufBySnu+Qo4gTgOIZ8ETrFP+da5df4B+c1x/s3gFOz2
wdeDC1LMQzXFPr22X+QYqvYzYF2T7//mFPtp3xngQvw+Av8seDNHn9wAJ/ot
0Jtw2j1wWPPhGCrguRT5OatLqBz38DDwcinmYjjynhT79+rdwG89ulU5cq04
P87Rrzp7zXqdt8HYaH7Id/J53bHl6Kt/sN/tuuhNOOQ3Qm/FhRz3y8UceVf+
3wB/yfGu/QZ+nSI/X4H/A5yp1Pc=
           "]], 
          PolygonBox[CompressedData["
1:eJwtlVtoz2EYx3+/951YJDlMIaxsRo65wDCZkeQ4Z60cmh2Zqzm0zWYOhZJZ
M2cXjlG0TWGaEiMlN4icliR2YeUQ4wKfb8978W2fvb/nPT3v93n+yes3Z5e4
KIoKUQJ67qNoexxFB1EnXMnHSsaLFQP3ROPgWagfvAStgjehIvgGc/KZm41O
wMksegbej5LgMmLKiM1DW+GuaBQ8A3UTE3OB2JrYDtTEGrmxnekpXITS4D5o
IVzAnAJCK1A5/Iqx8tjOcB2eGvZvQjPgscSsJDYLjXa2p/bORIlwG3OqiC1G
rfBv/o7gW1/UCe9iLF17o6PwVebU8O0QugLnM5bCt1Q0zltOlJtq5Qg+gerg
KrQDzg73GYGWwF0S7O66wwv+X+BtrfSwdz2aD09Ctd7eRG+zHM3VfcJ85TAR
rmJsZ2R7noR/eXtb5fMnPEdvGFkON8DjGesd8jsBrnN2N73ZYfiWch7O9wbe
iDLg6agEziJmkdZCa+BBKB1OUQ7hd8T1j+zN25Rnb3fXGlpLb6q9dYZCeA+a
FluOCuBvaBu8FXXoLVhzYWR7ToE/MD4wMo92wKe8eVFr7IYbibmou6AGeCjK
iOyNh8Ap5Oxs8P8w+F94f8Uk8/0ya6yL7Q30FvOc5V4eGu7szhuCv9fCP2O7
u3KQxP8PmFMa2xoN8krYX28wG74jz+ju6Dbcy5lXdZ8ezjwpbyrmrrc76C7y
4DVne2rvbNUo3J071MXm6Y/En0bLwvxz3t6wPNTbW/h98L/mfIa/eMv1FtTu
bU5RqI/z8m7I102UBT9hz0uR5fixM4/L6+ohx+C93ryyFO3zJrHOdAD+6q1X
KEef4NfBL+pRzbH1jLzgr1L4R4hXjQ9g/8XBP/KLaktn3hL6j2LTQr3Lf85Z
TpVbeaadmGZvuZfH5fUqNDm2ms7zVjOqHXnwOzzSWe9YgcbAx731BvWsRs1N
sN6j86kXtgZ/dkX34Wex9RZ57A9c6a22taf21ppaWz1LvavaWS9RTau278WW
G+WoBT4S/FCL6uG/od71Rqnsnxv8qXrJgVuCn/TmD+HBoV5VU6qtLqE/a/2X
xDyK7ey6g2otM9Sf5kyCK5z1Yp1BZ5npzIvyuGotJ/QHzVmt7wnmHZ0vE57o
7LdFvynz4f/3kriF
           "]], 
          
          PolygonBox[{{501, 37, 493, 491, 492}, {492, 491, 466, 15, 487}, {
           1048, 1047, 1077, 427, 1049}, {1038, 405, 1045, 1047, 1048}}]}]}, {
        EdgeForm[], 
        RGBColor[0.7739417516188205, 0.5756983791631638, 0.3641045293997988], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtlMlL1VEUx3/vXtcO8ZRXCCEKQm2yAZVaWIsCe1oOBamLKMshB4pStHpq
NkmEUfZek48WaaRQqQ2LkhaBFg2b/oIGUrAyiZYNn8M5iy+f7z2/O5x7z72/
nH3tlW0uCIJO5NEEjVE4CSNoK34dzEQF+FRYjcrxJfAuGsSPwgc2VuZog+2o
BmUx8T8Y8Rrvt29H6FcP98NjqFvygDUWr4NhVIzPhrVOx7XAIsthi9O2xA/D
jJQgGAgFwSJrPaU9Tvyx9CeeJL4SNlt+VfAe/VqIj8NXqA//yWtb4i9gAkXx
Y7AX5eF74B60Gl8LD1pcvtdZ/vXwIurCX7BcEihu5yXnNgTHAv0m8c+MP8o8
b+Fu26Oc97DTsUk4j57hv8I5+ubhv8HtaG9Ic81wGv+FT+BjMj/8iabxi/AH
37JlTTjhdeyM13pL3Yud1kxqt8FrTpLbS/F8e078PVwK6d1Iw8+iEfwMzLEz
L07RtsQfwje27peQ7kH28g6WomZ8k9P9SP6/4XdbawFeY+2NxPolT/SXeAG8
YjWSWl2n3xDxGLzl9Fx74ROrgdyLmPW5CfPRLnzUaZ2kXt2wzOn9LYTL2UOc
+SNwvd3JFXAt6/2RvXs9R9nXa/jI6joFs+wc5DyWWc5hr3PJnKlw3M7nPpzk
207iN+AalIFvgB/QAfwUbEL5+B2wHuVK7eEduTf4pNQKbcZ3eN2/nMMp2SPt
EuIDXsfLPM1wzuvbWYIjNo/M12lv87i8b6/3LO61BlKLcnkraBX+kLxx8xKL
ojT8NnjZ7vxVpzWWWvfIWfItkz7VXnOS3M7KOigdXwYXvJ5VOmdVZP1l3Ky9
02mva8hapfCErMH8jfA07Qriw/CS7eu21z3IXgbt7hTaG4rbeznpdD5515KH
+FxrNzJmEzwDK1EYXwHn7R/yEbbaf0b+Nx1Wi/Ne/xfy32iFVTZW5ujzmkOX
nK3T/+Q5+B87mqjt
           "]], 
          PolygonBox[CompressedData["
1:eJwtlUlsjlEUhr//u38tFaERqUhNRVmgWsKChJpKWjUEm0bUrFJ+ixpjJkKF
pqToTpNWYqgxpkokhpjFzMYsEcRCgoZ63pyzePK/3x3Pfe+558+as2xKeRxF
0TJIwqsQRS/hNJyBGdAvEUU5MBPdjUF16B3QHn2CtlL0RKhH32OxS6xzGe6j
x8M4KIN5MIkx7TQXrkAVbasYWwm70Nd9vRQ8QP/ktyd9w6Aj/aegEd0Aj9DX
go3VHMVyhrajkY05je5LjH1gNIxJ2pl0tnNwHjrCP8a2QgZ6frDYFGNZsDma
+wfdAkuDeTESVqAPske1x3MAvZu2Ud6/E12sPRK2fq7vqb0PwqFga2is5qTQ
VcG8zIcN6Iv8XoBmuAot8EfrQcR+0xjTKWF7lKAbodD9OInOjM27yTAUPVe4
3yn0bbgY2Z3dQTdBfWRt6rvr/Wq7hS6GWZ4vs9G/2eOXPIRWeAsb2LsGvqDb
4F0aPEM/h3yfXwCD0F3py4Q8yIeNtNXQtx82x7an9j4CN9CvWfeVeyJvpvr5
laPK1Y3BvJMH+9AVscW6SaC3ut+6wwp026TFqpg/813NmKrIclK5qZif+ZvQ
23jPuEz6BsIP9Bs/7xK4ESxnU/4+PqG3wAh0MWxGL4LshLUtQE+AdM+3ieht
scWq8x9G/wi2lt5cBrGu4buH54fOWhfbWOX8WfRaWIdeCGvQJVAemeeT0OuZ
0zNha2gt5UCln3elciW2u9F43XUXzx+9wfZ6f8wpY24RNKG/e3w68zvdN2PS
5BvfL6BtbF7Js2+6F+UsehFMQH/xeqEc+4w+Fttd686PKza/T8U7V167PzrT
UnSp+yEPC9ED8Kh/0opZAp7S9sRzVLm63d/ndNgTLMf2e35o7d7QSx7A2Nje
mN5aFr/dYbXXK+XIXnSA2M+ss5d5fZPH84KtUeA1ULUwz+uBcnYoerHXV33r
La/y+9AbXR5bjuZ4fpcHezMFnn+d0B9p/6BaCQ/lA2P+RlbTOqBrg93VcDig
fAl2dnmgWjXQ65/mFKGbg+Wycvqm3kpstUM5kBvbnT73N6i3mI3Hvb3GqtbK
oyz3UF5+j+2/QHf8FT0kWC2UB/Ii178Vw+BgNbTB63dtbHcYeQ1RLelLWx/3
XN7X+v+BasYh9BPWfew1UrWy1WuTYlSs6Z6P8rAz+j+Yd9Py
           "]], 
          
          PolygonBox[{{688, 165, 683, 681, 682}, {611, 100, 602, 600, 601}, {
           936, 935, 957, 364, 937}, {928, 342, 933, 935, 936}, {921, 357, 
           979, 981, 982}, {614, 613, 616, 105, 615}, {455, 454, 457, 28, 
           459}, {924, 923, 925, 337, 950}, {1088, 1087, 1081, 414, 1080}, {
           601, 600, 578, 78, 598}, {499, 36, 487, 485, 486}, {682, 681, 661, 
           143, 679}, {1040, 406, 1049, 1052, 1053}, {587, 85, 551, 552, 
           553}}]}]}, {
        EdgeForm[], 
        RGBColor[0.9213306425854427, 0.6733266064636069, 0.3561249920148725], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtlGtMz1EYx3//369cXhRlcy9iYxZmVom55DKtUsNardFcsryiiC155bKJ
IaaNNpnIdWUNNcUyedESjYzNvFFimUtymRkbn2fn++LZ53m+5zm/8/zOec6J
21y0drvveV4ZFmCtBPXwHmwNed5f/EwGSrFlxGUwHvuDPhsuxSLQlxuxbvTh
sBJLRz8KT2huOfyEleO/gcm2IH4SbGe9FsIOOEvft3WeE9/HfwpPEueSXwNb
VKfV26G5T2AXY/vJ6YNviZvRe+Bv4jL0l3BKyNUch8WEed5pOBKWk1dKfimM
VI7lnkGr89x6lxg7Dk/5TjetCmsjvggfwHeqpw++1f8OBG7vbB+OwBf6L/u/
HtX5CG5RfXtghdaqNPpunRoYRa3V5EyCdnjF6CXwF/YBfxRzj2mufWMrlo1f
CNeZ4a+BeVgBfgE8rH+3PTiAHcTfAXdKL9P/Wg02tpo4E2bBao0dgrGsHaK2
ebAXRqJ3wXzVafVOpu46tAVwOlaB/4/8Jt/t8zkYgU3F/8ZYCmNjYA6cgJ6K
ngjbiDeg34BnsUL8O3AOY8nkjDPy/Zv2DfiZ+Bn6gO/m23cWw+jA7dsIuA9L
Ir8CPrb+QO9Xj1qvJgbuDGwfamE+8Uz0YnhX9TfDoYFbKzxw+277nwYTdHax
cEXg+myl3Z0w1yd2P8I19wv5jfh70V/D68S16A2wSGe3CV7VvTgP03Qf7V5e
Ub7Nu6y9aoCvYDz6EPQLuqd2XxuU8xAm6HxTfNcr1jPzfXd/7B5VwRnEKegZ
MEbnbuf/U31o/TgWm2t7C3NUs/VdKrYEfxrsZN4w/Ha7h8zvxx9Ez8UfjZYN
A61la2aptoXwtu5RIyzRWWyDuwN3vwtgnr5j33sfcn31XWOWsx4O6qz7YIbe
n3SNJ+kd+Bq4tyKas1qknrTebFLvWQ9227vJ3Ftwl+qxuqLUk+N990bYW1EP
r+ns7Ax/hNxeRaN/1DvWaz2v3psIO6XbO7dK/bMR/gecxbBe
           "]], 
          PolygonBox[CompressedData["
1:eJwtlFlIlkEUhr9v5keL0FLqT9vVqzYJk1Qwi1YsvBFpwaTI6KrSiqAFghYq
IlogWi6MKLOLNKIFSiMtqGy5qKAoqJsSSwzUrItQqOflzMUDz3/mzHwzZ878
ORvrKre5KIrWQAL2+CjKjaNoHhzAKxmsJl4PNXgTXMUb4Tq+ipzx5M6CGvws
sZOR5Si3OownYS1+E9bjK+AKfhwW4avhDD7AnB/M7YE/+AZi6bHtaRN+ytve
NP8c3hL2o29ewycRixiLYTK+P+TnwC58OzmHw3m24Ou8jaVBOX6JWDNjF6BB
TuwGtEMHnPD2ba2ptS9727vOcBo/Eta/qD0526PydeYmfKu3Wqkmqs192Izv
g3v4BOYUM7cCCvHdAq+FOvwXeXl4OnzFK5gzjA/BSnwuOcvxAsjCP5DzHoZg
GLLD+lojDf+nmhLfC3/xFGIzGVsIXnehOob1fuPjyBkLSd0rdJHTytgD+IYX
0UTN5J3XPLyLnIPhdz9+h5xH5LbDXbzRWa1aoBUf7exb+uYAc/JZYzbE4KDK
Wy/pfkvwIm+uWCmeGearBhPxWM0NuZAHZaE+6mn1dknob8VUu5KwnnqoGC91
dheq2Rx8GXtYCkOqOzwkrw064DF0hXqNgFf4Ym+9pR5e4q3n6sP3q/E+YscY
a4AM1p2aML+t7yfsznR3UTjLF/xz+Ka+/ZNYr+4JemBMwmqtmvd6q0ky9Nt8
PJXxFPiIf4IZ+PRwJp0t31svqadG4X2s+RZ/B/34SG+uWKrO7+zu9Gba8MHQ
n6pXhrMeUa9kQTaUE6tibIFqHvasvXfDd92/t7ev/4ACvCxhtVBNCvFaZ29B
b2IHPiXUSzVMw3eG+uoN6i260Ds6s85+1Nnb1vgh/I2zXlRPDuKZoX7q4Wl4
Z2x3qTt9Hdt/gP4LOuEFPHPW+3oDz/Gnzv4b9Z/0RLWL7a2qJt34rTCuOZr7
MsxXTHP/A6pqo3k=
           "]], 
          PolygonBox[CompressedData["
1:eJwt0bsrhlEAx/HD+1oNbpHJJXIbzWRAoiSXUdgxCLGZyIvBX2CUd3VdFAth
UJQ3lAjJ5R+w+Jw8w7fvc37n95znnPNUjU8NTOaHEMpQgDGDCR7mQQzhKhXC
JU4xmhfCCR/I97GLY/1b7pZ3oQe/shY+lGc97yX9+F6x/ENWxCUoxRxmsYwO
35jnTd11vTVeRQY38g3z9ekQGtCId/lb3CeO9F95Wq9ZbyZZN67/I782/82f
+EKnvFCvN9l7PMM5zvCMJXMXXKNbjTq0WaOWt+Qj5rd5B9nU/33Fe2tHn14/
V8jL0YqgX8k53OEei7K0c6R1m1Ryxg94xFO8E35J/kH8F5nkPhYwr7/Cf3Z5
Ov0=
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9627983855512656, 0.7769959638781642, 0.4846749952089235], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJw1lFlIlVEQgP//PxciyxfNzMy4aqtlDy0IWUJZkm8hVBJqdF+jtKQ0Il8i
I7mGFkFEYItBD16jp6yMTA3abKO9NCnbTEKiKG39hpkehm9mzpxl5sw56ZHy
oi2B53k1iENGMAbhKPyL3EEfDHRQdPElO41JgrOQUfQs8SH7fM/rg7+JG8L/
By5DStDXwQeM7SHmHQyHPO8IegJMZGwBMWlwPWPj8K+E3dhn8XcJsTfj74Yt
SDH6CRggd4nxYSZrxfDnwkzsH/inwwzE4Z8GO1mrDf81+Ay7Af8Y4puwo/gb
4EfkHvoQvGX73nA6R+behJftbHLGJ0gH+mP4HLmK/jTQ/WTfxXA+exxDT4Xt
2GXoMfiTuE/E/4KhkJ5HztWHfR5/L8y1muTB+1ZDqeUcxnKISYY92JX4++FF
7Fb8zfCSnacdZtt9rYKnsU+ixwK1xV8AszhDM+s8RI8L6Z3K3R63+kid9iJV
6DvgAbHRa2Gtp/pRJIpdDw/JPpZvq9N7lVwkp29Oe2AC+wxbXgPwjNX2f41l
PcknDjsDDhMXb7mnwFTrnwS4Gomgr4GbTC+D/TIHvQcWWI6SazucKHWGr31d
/wvcarlIToet307BIuvnPPjd132lf+PtfqfCr0L8H6TnGMtCzwy0h6SXOqQP
7b7k3sJwvK916bV7vy79iXSiv4SFTmNKnNrifwF3YS/EX+40Z8l3IyzFnoR/
Ley3vn0FZ2CPoM+Eb+yND8Ar1g8tcDdj+cyth6WWr+QdCbQuFXADY/OIicA2
6/8LcIWtn+90TGK2wZ3WH3XS507fl3P6R8hfMdlpD0nNK+FyO38xXORrjoWS
p/Vetdy707eTIn+P1UHqkWR/VCJMc7r+FLhE/gticmCT0/UOwqXml/Ea2y8K
H1lekl+j1aTO6b8g5/8caD6SVyN8G+hf9B5WE5dNfJX8T9YPg5IH/XFO3jIM
277pTvtP+jDE3P32duQN3cY/VvrB1x6SXvLhdjunnHeuvQX5D6QG4g/b3nKG
Cjjb/kP5F/8Bfmq/ng==
           "]], 
          PolygonBox[CompressedData["
1:eJwtlElIllEUhr//u3+DllERWBiiRROlNhJINhmBm4IWFWGFtozUksqCVmET
Gg0GEUFpBS1SadVImW1CoowiG8AkGs1FmWaZQc/LOYuH//nueO695/zZpeXr
yuIoikohCU8SUZTG7xR4j/cmzBdDGgOXhSgaTdtvvmfhS2FUwtrU18HvSxiC
f7Ceton8BliOV0BOwto2B2tTXwwFeD5BNOJnIQv/7vsrpi58i8/Pha14IfyJ
LJ4VeBvtKXgmPMW7aKvk9zD04KthMLI5q/CNHl+Or70NsvBFsBsv9vOqTX1N
sCVha7bi+4PFovlV+C7/LoQDeHpsd6czpOLHgvVpjObWBNurCOrwesXk80/i
XxJ2Fp3pMV7i8enON+Hjk3ZXB+E736eCrbVQZ8Y7g51d8bbh5cH6snytOh+v
MzXg3b7fAhjAJ/j6epOpSbtDrXdeecL3Ws60BpZAAdTDOeZWw3G8F35AP/yC
W9BC3wO4g1+GpsjmaO441h8bbE6vz9HcAfgNe2Cv5+t2/BLU4jVwEf8AT/T2
8BHPI8ZciCHASdoO+X4N+Bj2SoMUSIVG2hrou6EY8WfQDj+hT7F7vK3wGt8A
xfhOxYQfiS0WxXQUr4itT3vuwxPBYlOMEZ6nfFENKc/ghM/XGavxybT14N8g
Ay/z9bTnZrwytrtWm/pGMmYEDIPh8Da2WHXfb/BpwWpF+T8dnwOzPQbFMsiY
bt/vL54drDZVo1P8jlJ8D+31gjHP/Y50V6f9PXSHV/B8r2/V2Ep8UrC1tUc6
3gI7Epbz1/CS2N5W5y/Hx8eWi8rJPsbUev1o/Bl8hte/anpmsBxULs6FecoP
ryft0YxnJi13r6tG8IeMaY7sTfW29/y+9H0bD8xp93yKg+WEcuOmcgBv9P8D
1dCFYDVW6fV0N1iOKde0x1X8bmxvoT2016dgtasa68cf+fq6v/t4lee7ckK5
dc3zU3es3C9I2ll0pvlJ+w/U++o/qwh/F1usWrMT/xzbWXSmr/hQbO+hHPuH
v/L4VKMdeIbfl2o+Ff8PrOrD4A==
           "]], 
          PolygonBox[CompressedData["
1:eJwt0D9LglEcxfHro+VuEJSYtapBIeUWtNSW0hwN7tWL6A30InwRDg0VTQVq
ZA1N/ZsiWrPQ6HPxGb6cc8/5Pff+eFbaJ/vHSQihgBlsOmxgCwfO2zSbCyFB
HmeZEKp0NmseX/qBuRxfwS+/Squo4VX/ght0dc904o4xMnxF9sc/YZ4/p5e4
QklflxXTneJu1+480t3SHvop0b/jVHdHP8z2fPuWvh/3OERb1qJ7aGLR7Kes
RJdQxqP8QvZA7zFMpnnsG0i8sUx3/YcOv0PHzhOMzH5jLu7gjh9+HWtYQENW
o/8kAC67
           "]]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.8836516112546834, 0.6255967711025313], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxdll1M1mUYxp/3/wAicVhrgvBCrW83pcyDNmu1QES2tk4qhBfxtE0Qha2D
zkTF1lZtHRTGR66tg0rAj62trZaoQDrnMvkMyMo2t4oQsCxa1737x3zXxsX1
fNxfz/3c9/95y3c3v7gnCSHcFqLQJLQJ7cJnqRCOC+8Lj+eE0C/eKu4QHxT2
CjuFOqFZOJDyvRbha0F/YVL/VoR7NB7DntnpEt7Ddgc4wNr9Oc53i5eir1+P
LmvrFtce/L6C7zrWjkdfOxZ9vYUYl3XIK4phQXxNuKjxDfEcY1ubES5oPCtO
pP+T5US8RfNqjUsSj7+LuFvIQb3wheRaxaPEeTDrXHuzZBuQb8nK2eXosV+K
vm9yZmtF/sbk95/EbXZh9wetzQlLQr8wIBwVupjbuFc6feJj4m5xj3BEeINx
rzAofIB+D3smc4J5N7YOC4eQPZzl6yjrJtfJ/oeJ770tbhVnhAahI3H7byXu
o506+5fasBoxG/vxYbwvy7eNzd5r2G0Rz4oXyUU3sZuNghzPVXGOz49k1fRq
Dtqo9V34amPcyXg/aMT3q4nrtyce0z7i6iRGO/uY9r4Tj4s3CLUaV4i3KZYn
rIeE54VNwkbWbK+aeqinVg9FX3tHXIF8JahK+dpOdG2eI+QK88FtVLNXIqwV
8uFSoQCdbcRTh60q7G8ixtV5Haik16rQW43LeD227Txp9kvxX8G8BLli9H4P
HrfFnCauUvaKyc+70WN5k56uJLa12DP516PLtoqbottqZs3sFAkvJH7XGXGe
5n8Ez9eD9PgD4mX6qYBYbGx+FuElam01l/ns3Qyev/qsu6ynz5eozUX60Prx
E3EPff6p+CvNz2j9jPhL4bTGw+KP6SPrp3WcI5e7Xse44n95NV6T8rNcC/6d
KJOPXy3H0eNZZn09unYOk70l/IjeMvNccmV3dJ/0fxOXR8+h+VkIznlZuc4j
tmLGRcian5v4zc/SN/sm18i3wvqqlJqxepolx5bDDfJ9XfyoPVTR401F/+ba
93Imel1ZvFPCZPD5FHYzfEPS5KRIHPWN+MjqTdwYPbcZ8bT2z6P7SPR8PCN+
DHnTO4uPc/BE8BxNwuY7n5gLop/3e848LJwM/q0t1N4v4o3iU+IRYTS4vJ19
Bp5lXEedW72brWnOPM94Cj/T+Mpwrpc5t8U5Hvy9sXdnKPq7MRT8TMPEYPEt
qv6+FV9O3OYI+1d4T6+Kvwlet6PYHsL+OGOr71PsnwZ9rE1K/6rFnLjvCfI3
hv4Z5lPkuRe9PuKzeQ979p4NcG+DrPVzpgFyPcj+MPPz7J9DZoJ+tL7MUV5+
tvqM7uckvk8w7kF3iLjtbbY6tPfbflNYn1k/raH2F7i/UfK4O/G38SVxjfhJ
YTvYHPw3Rw1zq117j3YF75VGxjvgWsaNsOmVCXcJ6eB+tmOzFp0m5Guwn0a+
IHitW80/Lb6U8rXRlMdYRnymt4W4VyT3uX0D1Rdz4nKtzadcNo18hhga0DFd
k7uVcpkbyBeuxpG4zL2Jy5fju4xxIXY2Y7eCN3cr+dyBjxHuze7suejf0Kf4
ntm9WU/8TR3eTvx+rNesrudgm1/IWrO7vcjaw9TJQ9F/h9hvgUHqpDvcqUtb
t99Mf/E74U96aibc6fkZfFl9Wm1OZ/kzX8/yW9R+k04hY7X7H5aAhhk=
           "]], 
          PolygonBox[CompressedData["
1:eJwtkzlolEEYhuefWUQWEYKCGJG4xlshoGJhUFAiBBQEG6MQxW2FrGwhiNip
AUVQwUJSJGJj4ZHKSrGIhaBBoolZryieEPBAMN7H8/JO8fA/M/PPN998M1Op
1nb0xBBCB5RgaQrhLd83sAR/yuAjfBye4XX62ooQmqGKr4B3wXOWJfdpbC7s
1RgcxWvwAL8C3XgdbuCTcBzvgzIJtNF+HxxzFV6DFsbWwGG8HaYYK9Pegncl
r1WCzfhsYpwvvOZX2ouT9/IaWpNjKFYn9OJnk1059eMTybkpJ+V2CjoK7/lI
8ppaWzntxhfBJ2J/hIX4RdhVeM655DW19jdYjq9PzlVzNLedfK8WzrkVb1Dj
seCaP8HvwHX8LjzHP/NfBV+nGtC+TYyewmteS66xaq2+EXw+/3Ty71qYhc+J
nrsVVuLD/DcjOOZL/At9o/hDaNJe8/nqTGYm56Bc7sFEdEzFbtEemf8z3xft
4Qd+BvrwXjiBTxb+twz3C/dprA6H8APR3g3V6ByV6zbdB7yZHD7gDfhLe2f0
v9rjJnxavr/KeTpeST4bzVmAf8/11R6n8CKfj+5IxEei967xUdVX4INwEx8S
wX0auwwXgs/oFr4x+ax1R3VXNUdzVYNL+Ivo2g2r3tFvSm9LMR/jv3NbNfyF
98NA8BoD+IboWuyD7fg/eJXvd9B7io6tPo2pRo38fv/obPL5qgbj+EGBn4Rj
+Olo15paO+X3o5qW8D3Ra2vOfnxeyW93EFbj/wFkRpgE
           "]]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.95, 0.75], 
        GraphicsGroupBox[{
          PolygonBox[{{242, 222, 221}, {221, 200, 220}}]}]}}, {{}, 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[{11, 32, 53, 74, 95, 116, 137, 158, 179, 200}], 
          LineBox[{231, 230, 229, 228, 227, 226, 225, 224, 223, 222}], 
          LineBox[{211, 212, 213, 214, 215, 216, 217, 218, 219, 220}], 
          LineBox[{431, 410, 389, 368, 347, 326, 305, 284, 263, 242}]}, "0"], 
        Annotation[#, 0, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{458, 463, 490, 503, 531, 541, 566, 577, 599, 610, 624, 633,
            650, 657, 674, 680, 701, 708, 707, 704, 729, 732, 731, 730, 728, 
           727, 726, 724, 721, 756}], 
          
          LineBox[{461, 480, 496, 522, 535, 555, 556, 561, 573, 591, 606, 619,
            630, 645, 656, 671, 672, 675, 684, 703, 712, 733, 734, 735, 736, 
           738, 746, 767, 768, 769, 770, 771, 772, 774, 776, 778, 782}], 
          LineBox[{471, 509, 510}], 
          LineBox[{474, 450}], 
          
          LineBox[{785, 754, 758, 760, 761, 762, 763, 764, 765, 766, 794, 799,
            800, 801, 802, 804, 826, 834, 856, 862, 863, 866, 882, 893, 909, 
           917, 931, 943, 964, 975, 977, 978, 998, 1013, 1044, 1059, 1083}], 
          LineBox[{1067, 1027, 1071}], 
          
          LineBox[{1085, 1074, 1051, 1034, 1002, 990, 970, 956, 941, 927, 914,
            903, 891, 879, 865, 858, 837, 827, 830, 831, 809, 803, 805, 806, 
           807, 808, 810, 812, 815, 780}], 
          LineBox[{1095, 1021}]}, 
         RowBox[{"-", "0.2`"}]], Annotation[#, -0.2, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{456, 460, 488, 500, 530, 539, 565, 574, 594, 605, 622, 627,
            646, 654, 673, 676, 698, 702, 700, 699, 697, 696, 725, 723, 720, 
           755}], 
          
          LineBox[{462, 482, 498, 525, 537, 560, 572, 590, 592, 597, 609, 623,
            632, 648, 649, 652, 659, 677, 685, 705, 706, 709, 714, 737, 739, 
           740, 741, 743, 745, 748, 750, 773, 775, 777, 781}], 
          LineBox[{516, 477, 444, 449}], 
          LineBox[{548, 547, 513, 508, 470}], 
          
          LineBox[{779, 814, 811, 813, 840, 838, 836, 835, 833, 841, 860, 867,
            885, 894, 908, 916, 930, 942, 962, 973, 992, 1004, 1037, 1054, 
           1076, 1086}], 
          LineBox[{980, 1066, 1094, 1020}], 
          LineBox[{1028, 985, 1031, 1026, 1070}], 
          
          LineBox[{1082, 1056, 1042, 1008, 996, 974, 971, 969, 960, 940, 929, 
           913, 906, 890, 888, 887, 880, 861, 854, 832, 829, 828, 823, 798, 
           797, 796, 795, 793, 791, 789, 787, 759, 757, 753, 784}]}, 
         RowBox[{"-", "0.4`"}]], Annotation[#, -0.4, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{446, 845, 843, 842, 839, 844, 864, 868, 889, 897, 911, 918,
            934, 944, 963, 972, 995, 1007, 1041, 1055, 1080, 1088}], 
          
          LineBox[{455, 459, 484, 497, 527, 536, 563, 569, 593, 603, 620, 625,
            643, 647, 669, 670, 694, 695, 693, 692, 691, 722}], 
          LineBox[{587, 553, 515, 518, 473, 476, 443, 448}], 
          LineBox[{615, 614, 585, 583, 550, 546, 512, 507, 469}], 
          
          LineBox[{752, 751, 749, 747, 744, 742, 717, 713, 711, 710, 688, 682,
            679, 678, 660, 655, 653, 651, 634, 626, 611, 601, 598, 596, 576, 
           564, 538, 529, 499, 486, 465}], 
          
          LineBox[{818, 783, 786, 788, 790, 792, 821, 822, 824, 825, 852, 855,
            857, 859, 877, 883, 884, 886, 904, 912, 928, 936, 937, 939, 959, 
           968, 994, 1003, 1040, 1053, 1079}], 
          LineBox[{921, 982, 1017, 1023, 1063, 1065, 1093, 1019}], 
          LineBox[{950, 924, 952, 949, 987, 984, 1030, 1025, 1069}]}, 
         RowBox[{"-", "0.6`"}]], Annotation[#, -0.6, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{447, 442, 475, 472, 517, 514, 552, 551, 588, 586, 617, 
           639}], 
          
          LineBox[{464, 485, 487, 492, 501, 532, 540, 568, 578, 600, 602, 604,
            612, 628, 629, 631, 635, 658, 661, 681, 683, 686, 687, 689, 690, 
           715, 716, 718, 719}], 
          
          LineBox[{663, 662, 637, 636, 616, 613, 584, 582, 549, 545, 511, 506,
            468}], 
          
          LineBox[{665, 638, 667, 664, 666, 668, 640, 642, 644, 641, 621, 618,
            595, 589, 567, 562, 533, 526, 494, 483, 457, 454}], 
          
          LineBox[{816, 871, 869, 870, 896, 895, 892, 898, 915, 919, 938, 945,
            966, 976, 999, 1009, 1046, 1057, 1081, 1087}], 
          
          LineBox[{846, 899, 920, 922, 946, 947, 979, 981, 1016, 1022, 1062, 
           1064, 1092, 1018}], 
          
          LineBox[{848, 817, 819, 820, 849, 850, 851, 853, 875, 876, 878, 881,
            902, 905, 907, 910, 926, 932, 933, 935, 957, 967, 993, 1000, 1038,
            1048, 1049, 1052, 1078}], 
          
          LineBox[{873, 847, 874, 872, 901, 900, 925, 923, 951, 948, 986, 983,
            1029, 1024, 1068}]}, 
         RowBox[{"-", "0.8`"}]], Annotation[#, -0.8, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{451, 445, 478, 479, 519, 520, 521, 523, 554, 558, 559, 557,
            528, 524, 489, 481, 453, 452}], 
          
          LineBox[{466, 491, 493, 495, 502, 534, 542, 570, 571, 575, 580, 607,
            608, 581, 579, 544, 543, 505, 504, 467}], 
          
          LineBox[{1072, 1033, 1032, 989, 988, 953, 954, 955, 958, 961, 965, 
           991, 997, 1035, 1043, 1045, 1047, 1077}], 
          
          LineBox[{1089, 1084, 1058, 1050, 1012, 1001, 1005, 1006, 1010, 1011,
            1014, 1015, 1060, 1061, 1090, 1091}]}, 
         RowBox[{"-", "1"}]], Annotation[#, -1, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[{1073, 1036, 1039, 1075}]}, 
         RowBox[{"-", "1.2`"}]], 
        Annotation[#, -1.2, "Tooltip"]& ], {}, {}}}], {
    DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
     Identity, Frame -> True, FrameLabel -> {{
        FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, None}, {{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, None}}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 350, 
     Method -> {"DefaultBoundaryStyle" -> Automatic}, 
     PlotRange -> {{0, 1}, {0, 1}}, PlotRangeClipping -> True, 
     PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               "\"Markov\\nwork infimum \[Eta]\"", {FontFamily -> "Arial"}, 
                Background -> Automatic, StripOnInput -> False]}, {
               GraphicsBox[{{}, {}, 
                 
                 RasterBox[{{{0.148, 0.33, 0.54}}, {{0.2585141649873893, 
                  0.3913967583263274, 0.6434973926072376}}, {{
                  0.5143536806527692, 0.4844693446383534, 
                  0.516705823514027}}, {{0.7739417516188205, 
                  0.5756983791631638, 0.3641045293997988}}, {{
                  0.9213306425854427, 0.6733266064636069, 
                  0.3561249920148725}}, {{0.9627983855512656, 
                  0.776995963878164, 0.48467499520892343`}}, {{1., 
                  0.8836516112546834, 0.6255967711025313}}}, {{
                    Rational[-15, 2], -175}, {
                    Rational[15, 2], 175}}], {Antialiasing -> False, 
                  AbsoluteThickness[0.1], 
                  Directive[
                   Opacity[0.3], 
                   GrayLevel[0]], 
                  LineBox[
                   NCache[{{
                    Rational[15, 2], -175}, {
                    Rational[-15, 2], -175}, {
                    Rational[-15, 2], 175}, {
                    Rational[15, 2], 175}, {
                    Rational[15, 2], -175}}, {{
                    7.5, -175}, {-7.5, -175}, {-7.5, 175}, {7.5, 175}, {
                    7.5, -175}}]]}, {
                  CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -125.}, {
                    Rational[15, 2], -125.}}, {{-7.5, -125.}, {
                    7.5, -125.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -75.00000000000003}, {
                    Rational[
                    15, 2], -75.00000000000003}}, {{-7.5, \
-75.00000000000003}, {7.5, -75.00000000000003}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -25.}, {
                    Rational[15, 2], -25.}}, {{-7.5, -25.}, {7.5, -25.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 24.99999999999997}, {
                    Rational[15, 2], 24.99999999999997}}, {{-7.5, 
                    24.99999999999997}, {7.5, 24.99999999999997}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 74.99999999999996}, {
                    Rational[15, 2], 74.99999999999996}}, {{-7.5, 
                    74.99999999999996}, {7.5, 74.99999999999996}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 124.99999999999997`}, {
                    Rational[15, 2], 124.99999999999997`}}, {{-7.5, 
                    124.99999999999997`}, {7.5, 124.99999999999997`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 175.}, {
                    Rational[15, 2], 175.}}, {{-7.5, 175.}, {7.5, 
                    175.}}]]}}}, {Antialiasing -> False, 
                  StyleBox[
                   
                   LineBox[{{7.5, -175.00000000000003`}, {7.5, 
                    175.00000000000003`}}], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -125.00000000000004`}, 
                    Offset[{4., 0}, {7.5, -125.00000000000004`}]}, {{
                    7.5, -75.00000000000003}, 
                    Offset[{4., 0}, {7.5, -75.00000000000003}]}, {{
                    7.5, -25.00000000000001}, 
                    Offset[{4., 0}, {7.5, -25.00000000000001}]}, {{7.5, 
                    24.99999999999996}, 
                    Offset[{4., 0}, {7.5, 24.99999999999996}]}, {{7.5, 
                    74.99999999999997}, 
                    Offset[{4., 0}, {7.5, 74.99999999999997}]}, {{7.5, 
                    124.99999999999997`}, 
                    Offset[{4., 0}, {7.5, 124.99999999999997`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "1.2`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -125.00000000000004`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -75.00000000000003}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "0.8`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -25.00000000000001}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 24.99999999999996}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "0.4`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 74.99999999999997}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 124.99999999999997`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                Scaled[0.02], PlotRange -> All, Frame -> True, 
                FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                Opacity[0], FrameTicksStyle -> Opacity[0], 
                ImageSize -> {Automatic, 350}, BaseStyle -> {}]}}, 
             GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "1.2057564850155764`"}], ",", "0.`"}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "1.2`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "GrayLevel[0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "1.`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "GrayLevel[0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.8`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "GrayLevel[0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.6`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "GrayLevel[0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.4`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "GrayLevel[0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.2`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "GrayLevel[0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], "GrayLevel[0]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           
           RowBox[{"LegendLabel", "\[Rule]", 
             "\"Markov\\nwork infimum \[Eta]\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "350"}], ",", 
           RowBox[{"Ticks", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1.2`"}], ",", 
                    RowBox[{"-", "1.2`"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "0.8`"}], ",", 
                    RowBox[{"-", "0.8`"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "0.6`"}], ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "0.4`"}], ",", 
                    RowBox[{"-", "0.4`"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "0.2`"}], ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.7452226859295683`*^9, {3.745229145963211*^9, 3.7452291603553553`*^9}, 
   3.7487869155099072`*^9, {3.7530197095438375`*^9, 3.7530197147631483`*^9}, 
   3.7530199642740674`*^9, {3.753020242944259*^9, 3.753020276104062*^9}, 
   3.7530203731456223`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["(b)", "Chapter",
 CellChangeTimes->{{3.7530194739570785`*^9, 3.753019474582093*^9}}],

Cell["Compile \[OpenCurlyQuote]batchmeaninfimumcontour.c\[CloseCurlyQuote]", \
"Text",
 CellChangeTimes->{{3.7558742983873234`*^9, 3.7558743053565836`*^9}, {
  3.7558743383446693`*^9, 3.755874439099127*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Run", "[", 
  "\"\<START /B gcc c\\\\functions.c c\\\\batchmeaninfimumcontour.c -o \
c\\\\batchmeaninfimumcontour\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7530206849606085`*^9, 3.753020686132405*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7530206879763036`*^9, 3.753025286647188*^9, 
  3.7530254069412255`*^9}]
}, Open  ]],

Cell["\<\
Create a function that runs \[OpenCurlyQuote]batchmeaninfimumcontour.exe\
\[CloseCurlyQuote] for a set of inputs and sends the output to an \
appropriately named .dat file\
\>", "Text",
 CellChangeTimes->{{3.756038637009347*^9, 3.7560386450414248`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"calculatebatchmeaninfimumcontour", "[", 
   RowBox[{
   "asteps_", ",", "ksteps_", ",", "molecules_", ",", "trajectories_", ",", 
    "maxk_"}], "]"}], ":=", 
  RowBox[{"Run", "[", 
   RowBox[{"\"\<START /B c\\\\batchmeaninfimumcontour \>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "molecules", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "trajectories", "]"}], "<>", "\"\< \>\"", "<>", 
    RowBox[{"ToString", "[", "maxk", "]"}], "<>", 
    "\"\< > data\\\\batchmeaninfimumcontour-asteps\>\"", "<>", 
    RowBox[{"ToString", "[", "asteps", "]"}], "<>", "\"\<-ksteps\>\"", "<>", 
    RowBox[{"ToString", "[", "ksteps", "]"}], "<>", "\"\<-molecules\>\"", "<>", 
    RowBox[{"ToString", "[", "molecules", "]"}], "<>", 
    "\"\<-trajectories\>\"", "<>", 
    RowBox[{"ToString", "[", "trajectories", "]"}], "<>", "\"\<-maxk\>\"", "<>", 
    RowBox[{"ToString", "[", "maxk", "]"}], "<>", "\"\<.dat\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.7530206256259317`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"calculatebatchmeaninfimumcontour", "[", 
  RowBox[{"10", ",", "10", ",", "100", ",", "100000", ",", "1"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.753020703587391*^9, 3.753020709713022*^9}, {
  3.753020910172021*^9, 3.753020920845023*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.753020710384941*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"batchfluctuations", "=", 
  RowBox[{"ListContourPlot", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<data\\\\batchmeaninfimumcontour-asteps10-ksteps10-molecules100-\
trajectories100000-maxk0.08.dat\>\"", "]"}], "~", "Join", "~", 
     RowBox[{
     "Import", "[", 
      "\"\<data\\\\batchmeaninfimumcontour-asteps10-ksteps10-molecules100-\
trajectories100000-maxk1..dat\>\"", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", "\"\<\[Alpha]\>\""}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"RotateLabel", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"#", ",", "None"}], "}"}], "&"}], "/@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"list", ",", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"list", ",", "list"}], "}"}], "]"}]}], "]"}], "/@", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0.5", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0.5", ",", "1"}], "}"}]}], "}"}]}], ")"}]}], 
      ")"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"BarLegend", "[", "\[IndentingNewLine]", 
      RowBox[{"Automatic", ",", "\[IndentingNewLine]", 
       RowBox[{"Ticks", "\[Rule]", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "}"}], "&"}], "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1.2"}], ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "0.8"}], ",", 
              RowBox[{"-", "0.6"}], ",", 
              RowBox[{"-", "0.4"}], ",", 
              RowBox[{"-", "0.2"}], ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1.2"}], ",", "\"\<\>\"", ",", 
              RowBox[{"-", "0.8"}], ",", "\"\<\>\"", ",", 
              RowBox[{"-", "0.4"}], ",", "\"\<\>\"", ",", "0"}], "}"}]}], 
           "}"}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
       "LegendLabel", "\[Rule]", 
        "\"\<Binary batch\\nwork infimum \[Eta]\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"ImageSize", "\[Rule]", "350"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7452227013219013`*^9, 3.7452227318876543`*^9}, 
   3.748786922550595*^9, 3.7530197492668095`*^9, {3.7530202906058097`*^9, 
   3.7530203213432145`*^9}, {3.7530207602965007`*^9, 3.753020804082436*^9}}],

Cell[BoxData[
 TemplateBox[{GraphicsBox[
    GraphicsComplexBox[CompressedData["
1:eJyFmnk8ldv3xyXcJhSqawqhVDdUKg0sRfOorkZdRRpVIklp5KYkFAoVKpkJ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     "], {{{
        EdgeForm[], 
        RGBColor[0.148, 0.33, 0.54], 
        GraphicsGroupBox[{
          
          PolygonBox[{{402, 52, 362}, {348, 49, 360}, {613, 53, 541}, {392, 
           50, 366}, {416, 53, 613}, {371, 51, 395}, {366, 50, 350}, {407, 53,
            416}, {541, 53, 375}, {327, 54, 544}, {351, 50, 392}, {350, 50, 
           358}, {377, 54, 410}, {355, 49, 348}, {620, 54, 377}, {386, 49, 
           367}, {370, 51, 361}, {544, 54, 620}, {360, 49, 386}, {365, 52, 
           374}}], 
          
          PolygonBox[{{358, 50, 52, 365}, {395, 51, 53, 407}, {374, 52, 54, 
           327}, {410, 54, 52, 402}, {361, 51, 49, 355}, {367, 49, 51, 371}, {
           375, 53, 51, 370}, {362, 52, 50, 351}}]}]}, {
        EdgeForm[], 
        RGBColor[
        0.4268649206471011, 0.45372249607406107`, 0.5681369156579342], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtkLtKQ1EQRedc/yJCNCoIQoiFhQgWguCtLHwQYiMkkhBEAwrGwsIuGm1s
bExCxO+xsrAR/IRgZxHBtZkpNnudx8yZs0v1zt55ZmYraAYNWbzg7/gzGsAf
+E8ye4Qv4Q24BFfwBTQHF/AimoeXk9eodoy30APcwYvoGp5wZxe+g4/wTzSE
v/Gp+f0m/IpG8Ffmb+itMr7PugfXok4z36MTzlbxVvK19nsxt+ZvR7+++Xyn
sa//DWJfM9VZV/BbfE3/hDeT91X/Kv6GuvAsPW6S/0v/24GX4Cv8LGqb+K/5
fp48X802wg/jLb15gRbhbvK+6r8NNyLzNr4eOSvvg8ghzzxf5ab8jiNbZZzH
HWX2Z95/i9qnuKO7/35cOWE=
           "]], 
          PolygonBox[CompressedData["
1:eJwtkc8ug0EUR2cm9p5AtCWxEhYW0sRCImEtRIjQEFItbYMoYsVC6+umlSBK
U/FQNt7B1kbi/HLv4uQ7883M/Tf5vfpqLYUQJmEEtmMI43zzsI8fRfMJOMU3
YBbPwTx+CAVf7+BVqMAulBx5C9pQhplgOZTrm+QD/A2e8Bxcej3L7G+yvsf7
8I5PRculnHP4OZxBBh045kwnWAzFWoxWu3oo4tdwBa/QV/2cydhrwifrae9f
Na6rVu9f/wp+R3d78Ahjye4qxgG+Eq125b/BB8lrhy+8BO1gPa3hL5x5hiF8
wE+0u+qhyv5StPjq4Q8uPL76P4k2c81Db1LzGWQeU7GHyWbbgi7e4F/dZ6bZ
Lfj7KeYvbCU7+wCj+B37t36n4T33/I311k2fr2rULP4BISk8CQ==
           "]], 
          
          PolygonBox[{{393, 392, 366, 48, 356}, {417, 416, 613, 139, 615}, {
           384, 47, 360, 386, 387}, {617, 140, 620, 377, 378}}]}]}, {
        EdgeForm[], 
        RGBColor[0.6551622078021736, 0.5339547695151409, 0.433930203720128], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtkb1KQ2EMhs+XLnaQDk4d6x+UVhd166BUdK64tG4OLqLSQfAPiqidtOBm
tYIoutd7cOgtiIPegN6Cz0syhOdNTpIvySltH2zsW5ZlVSyHreJcwGvYSR7f
go/4fXQTjrB79AM8hqfYDdbDv4TnsEJNBd2CA/whOs8Dpag5Il7Af0d/E2tE
T/VuYz30K1yIPupXxebRm8n7Kt6ExZhzFo7F/IuwjJ2hp+GP+Vt6s0HeHHoZ
jhO/kjavUW0d3sY8T/Ajdu/Du9CKTZnvPmN+I82gWV6S77hD/A19gp40z1N+
0vfYUbvKV/wT7prn/6G/ks//m/ymuu063DO/9yFcw7roFfP76s4TOc9Tfs28
Xn10j3rsqP/8HH3Urxb5S3EzzaD5/gFLbTls
           "]], 
          PolygonBox[CompressedData["
1:eJw10t8r3mEYx/Hv924HzjgeEdam5sdqVn5tsTZxMMrPIQ1hw9MeaxzwWCas
6KFEeFjE/2MnUyT7I3ZGIe9P1+Xg1XPd9/e5f1zXfRUOJdu+hiiK6vAIfxic
4ACH+B9H0Trzs5hg/AWfkcQkPmCZbxns+hqtPcM5allfgwq8wD/mLrGNHdyx
7hYNfHuLN3iNK+au0UzchDn8wAVSzM+gkPWd6EATmoPt0eBn1vqZOrsIxfoN
lsscLhm/YrxE/AuNxO+ZexfbnXS3Y+Kj2HJW7vvY8/+vBLuT7pZPXIBvxJOY
wjSeopT/lqM0tpyV+1+c4lOwvbTnBvEUvmMM48FqoFqoBqrFEhb9DJ21HPve
mCeu9/dYRBZxPXNlxM/xkvg39rGJLQxiACtYRStrWtCLPjwJViv1wEywnJRb
GmtYwE+/k+6WwITvqb0/ohtVqPYzN/0/iYc3wWPkIoNdr/mx30l3G8YIRoO9
/RpukMc4N9ib6e3SwXJXDdSbKeZmPWfl3hNbLVSTfuICvR2eoUTfg/Wy1rd7
DVSLbORgEAPec+q9El9bqV6KrSf0nuqp9WA5V/kZOmvc31Z3SvmaSu959f50
sNzU48XBaqLalOmdveZpr1HG5/StE124B+CcZ4s=
           "]], 
          
          PolygonBox[{{376, 121, 419, 539, 540}, {357, 356, 359, 46, 389}, {
           585, 584, 595, 133, 525}, {724, 723, 672, 154, 593}, {342, 341, 
           354, 45, 337}, {728, 727, 735, 177, 668}, {577, 134, 607, 590, 
           591}, {677, 142, 497, 627, 628}, {736, 178, 673, 732, 733}, {665, 
           153, 669, 717, 718}, {624, 623, 252, 141, 674}, {340, 46, 359, 343,
            344}, {349, 45, 354, 384, 385}, {543, 542, 495, 122, 422}}]}]}, {
        EdgeForm[], 
        RGBColor[
        0.8834594949572463, 0.6141870429562207, 0.29972349178232166`], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJxFlF1oz1EYx885TFMrEv3Na/Oy/WkpCcMmV27WiqXFhQsyltiLzEsyL9mK
mIW1yTTNrMhbSklJk1YulBTN2kpLqSUthHLj83i+5eLb5znnPL/n97yc369g
Z11lbQoh7EIT0NYYwjy4BRbBJWg1aonONlgLT6N6VBn/nxfJdzF6wroEPoKF
yZ+ZDO+gbuxx9tvl0wpXoNnYG2AnPh3YFbAcdWK/gBvRAeyVsFX7Z5M/b3Fu
w+d69nLyZ8ynHRagPdhD+PxGTdjL2XuPHmBHir+p3CzH66rrPpzI2UPsSfAz
zKBR1CP/engUtWEvgrmq5Yfqt9ys1oz6aX36xfqGxcd/u961Da5hfQq7GR5L
3uey5LlazkdgFhYGj3uX9UV4GBaj49jfidORPOcR2KI4Fi9Ped5L3q9/MaLX
b30YYv+Q4li8t5yVYQ/CWXAmWopWKU/L9w1npdivYE703DZFvytWl/VyVH2b
Ej1GVnGKWc+xeuAMNBd7qu0Rt9rqjd53q+UDe1+D5/EN9XK2Hr6D4zAffUHT
dIczsA/txp7Ps8PYNdgLkueSr3mUKJes7pPdmWtWn/K3+VSrV+ei99p63pR8
fjbHPtgsH/O9itZhX4CXdCftbu5gvRZ7H5yuXnxCT232sB8uVPxGWBH9eyqH
JzU7m+GA4r+GJ/Ree38OZ/ux/2Bf0Vy6YKPiN8Azqsvqy8W/wb47WJN81j3s
d+m7GIQHVeOt5PfJZvHR7qf6vzf5t2o1nocvVeMzuFkzrYI/g886L3rNVvuY
3SHNy/49VfJfFv3dlkN38u/Qcn4M64LfPavzL70phO8=
           "]], 
          PolygonBox[CompressedData["
1:eJwtlEtIVVEUhs/eNuitmdA781VXa2CU9vBmpVQo9PCSQdlEodIor0ZFENqD
RkHUoIkRFBU6cRpE4CAowaAHkRDRpCZBiIhFVBeq72etwcf59zr77LX22v8+
JR3ZTHdMkmQfzICjDNqgABbA2pAkS4gvgw3oSTiJ7oRP6HLm3EL3QyV6FbFi
SEElTBNfCsvhJzwgto1nHQygj2heYjmU6xRsRafhNnpusG9XQiH6ADn2e42q
9RvxxZ5jEiqI9fG8CWXoD57vHjyMVqNq1R60lws+1h4uowfhProeHvH+RrBa
t8A59LNgWrFRdH+0XMp5Hj2H2BrVAXvRw7AZvVo9RtdCDdTDdvU2WO1V0IYe
D5Zb+3/rczT3N+M/UIBe4ecxE93r9WyCa+pPsFwpyMFGasry7NV89D+ef6GB
eY1wN1gu5byInvCzWARfYUewXMrZorX9PFSzas95Lp1Bka+pteu0rnsg5XvW
3juooR1a4RA0QxPMg/mQhh7Wugp70Dm+OY2+ArWMx7xeeeQ5+nCwvctD8lJj
tLlZ33sNnElszbTnbPWcyl3ON2Xao/YF34OdZZf6FKzn6n0Tuhk+wgl/H9C7
YVewnqq3P/xs1MMpeOX+kQff+Rpaq0/egRH3uzzyRH6EY4nlKKG+Btjpnpf3
e6J5Wet1RvNMlX9/SV6P1rtueS7aGegsqmE9PPZ+yTNP0UPBvKpYBn3d/aqa
2tH5wbwgT8vbIdrd0Z35xfgL48+Qn4c38yxHtfdUvZ1NbBYshCLIMLdF5wgv
4Q4MwGt4A6PwwmN6dzDY3Zfn1qFLo/17jsOg/kXRvKs7ezbamXT5fdS/YBze
e07l/g/M5HfN
           "]], 
          PolygonBox[CompressedData["
1:eJwt0LsuBEAUxvFhKUhcCpfCur2AXue6Cp1HkNhuV0gUChKbUAlCZDchWZHo
CC9BQkGDhMojiILW7yRT/PN9883MOXNmfHl1qdqaUupDO9Yt1nCFC+u/lpS6
+S5MxZ6snw7KR/hJOooxfMpvZee0o5BSJ3rRgy/Znb02/iP7On3FG05QlzXo
PR7wrWZTdslXEA99wTOaudc7fcIjztCQLdIadrAQXrZHf9Rb4Yv8PF/CDX8k
28xzx/y7cVc2S+fiLIrODmECw/EH9DT3O8i9avls3NnP8xzTgajLl+g0ZvIs
MdMGDu1d0201t+I/+bLsl/8HRGAwjw==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9338269619987729, 0.7045674049969324, 0.3948635821961961], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtks8rhFEYhe/32VEjMrO3tVHWShGLKTXNn4D1TA1JFkMmlJKosbDzY2Fh
lFKSf0FhQUmSkpSUKIo0ntM9i9Nz7r3vnPu+d77usXKxlIYQ+lALWmCxCevw
FzXwV7CIDvHX8A3t4J/huWtUu4Hq+GF45pw1OIfW8TXY5X2d17zfC5/QNn4f
tiUhZPHt8ML5W/DPPTRhFk3iM8qkLqce0LQzq3CE/XH8B3wIMfPedaovsD/q
u3Rngd9M4QfTOKfuuoU/sBMNJPE+3ZuHy5oZPwsz7uEOzXt/Jo33Kb+V81O/
zyrsZ92BH4I9rlfejefV3CW/yXsSc5X/6PnV2yX8RHv41zS+u/IX0ziDZsnB
ZojvoPc4cKayv1hP6K3gC+td/BFccY76rbomn8Qz1RzD7yR+AxX8kv9TfTsV
fxsNeOLe1OM/+DlUUQ==
           "]], 
          PolygonBox[CompressedData["
1:eJwt1EtI1FEUx/H7v5llTTAzarYoSMgkyYUulILatKuomKA2tdHWtQwqypXt
NK3cJZSWZjZC9o6sLEcyEjOKHjstkibtob1D+/64Z/Fhruf+77n/e+75W1xz
ILXfO+d2IAdH+aOJ3zYcZLx4nnOLUIBCxIi1M9eMOsY/+f2BWOTcEuQjiSIs
wyRzn/ABE+hkzVnLP+FDTHNjGMcK1ixHIZbiK7EvlkO5eliTxgV04DrPXMNt
3MF7nnmHj8i68IyebWfuPC6jG9uwHbXM1WAXdqOSWAVWoUTPEzvnwpl19qyd
X7FJH2qks+hM3YzLWLMGVajGVZtXTY8x/s7vjJ1JZ1PNYlYz1e41XqFN+/hQ
A9UijgTGiY0hzl0kkEdsYRRyKneJvbtqqFpu0jritZhzIUfc1mitJ0eEN+R8
i83E9vFcEn8wjW92x7rrYuZX2hnL7I6LLKa5anJUYR3Wq5eIncAZtNod6C5e
4CW6cNHuRHdznzX3cBKnMJ93y0EuFmAvsT1IIIkZ1kxjFnPYSGwDVqMUjcQa
bA/t1YO09Yx6pxMdSGFnFPbU3hkM4jixejuDztKHu7iJW0bjK+jFEdYctnfQ
u7Ta2dO29wAeWY4+61n17gP02zukbE/tPYynGMVzlJNzrQ9n1tk94wi/GP9G
rmqGv4z/4QnjIWzBVh/20F4ZDEbhznX3+sb1rWft25nCZxdyKneFvg3LoVz9
eOjDM1PWI+qVUqt9nnJaD6uXu3AJh3z436Fv6IYPPaBeGMEzDOGx1WjAzjxq
34S+DfV83HpCvdFrtT+NFjtTxmo2bDVQLdST6s0We1Y90Wh7jtie2vs/dkKw
fg==
           "]], 
          PolygonBox[CompressedData["
1:eJwtz7ErhGEcwPHnXt0pA9GLjNaLdDcQKbujrhtY7pb7AxhIipVBSa4YbIzk
/AlEURhYlEk4ZptJ+cgzfPr+3t9z97y9g/XFykISQkjJcuPhmgNOPd/rY5yf
NNMWQsK8eY5plpz16wi75hUdYpgJxtlgz9mWjmVCGGWKHrtEA90yqQWK5MhS
ps9Zp77rG13mXn1hO97d0HMuOOGYL787dNYyFymwSsMur+2+JcezuWn3o6/h
/32p/7b0g474vlktMcOA3y7blbVKjR327TZ1jXUe4t0VveWOT47svt3TNJ9x
xeXft8Q7Uv0FGe0vYA==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[0.9702961771992638, 0.7957404429981594, 0.5079181493177176], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtk7dOA1EQRXfXJJOTSBIFBQ0lDSU5R8Ef8AHQ0/AFdPQ05CBAZJGxwQgj
gkAghES2ySKJWHFGb4qrc553d3Z23nNWc2tji2NZVh1xkQPbsmrhDtwl5fgx
bOemHnwSOqzj8TxYQ5LwSOgj1fga9JBS3A9DeGYSv4UXMJmE8/sMKcaX4RjX
JvAHOM+6Ep+GV6QKP4c3es8QXGBdIv3AelKAj8Cg9IRfQzeJwhPgK8/04u/w
lwzjf3CJDOCfcFa/cQKe8kwD/ghfYIS49KR1FmET1/LxftvMQmaSA5+kJ/wZ
/nDfEL4Jp7S+vCeKYXvwU/ybDOJex9SV+tJvAIaRS+1P+lyF5zBUvlHmZZu9
u4VnXPPiidQO6Kxkrhc6z0v4pj1ILy+6L7I/WVyLxdNgConBM8WptYFHw1jb
7F2Y3Osy75J3fsv+kw9yJ3sr306+9Lvk++70XN3DQ1KBb8NtnY8PnrEuxMdt
s5bfO2Gy1vHAOT0PS9KjzjAVZrOOw3PhJinDV+Rskmg8BqZz3zqeIdRzsiXn
UGfe5phaUjMNvkG3zJ7s65yPYLdj9vcEX9F96XDMu6UHS2rrGfPDMdZFeBcc
1ZkHYajOMAGG6P/IBXv07PU55nmpswdv9P8VgP/mDIN/
           "]], 
          PolygonBox[CompressedData["
1:eJwtlN1Pz1Ecx7/n+6VfKpGGsrnowljmYbnQsolSnh+GTTdc4Jp/IFdsGRfY
zCU3jIoRjaVGJAxjYczMY9KPilnlMfJ67/O5eO28z/mez+ec83n4Fm3fvXFX
HEXRZhgDD0MUrWVcDXfQTbAUXQlX0AOwHn0JejDsZb4OvQY+ol/4d/l4gn7m
3zfAKfQwDMEoRNgfYlyGrIZj6HLWFsNMmAWNsZ0lnyfRpbAQymAR3At2ts7o
Qs9nbR7MgbnwjrWV/p4P6EHGLMiEr/CYPV0QJ1GUQA7cZv0W5KJf6U6RxeA1
+jksj8znW3Sf+8pQPOAEaxWMS6ARPR5y/MwfihvzFYyroEX2wWKj+39Gn3f/
VXAcnehu8Av9G5o9XjrjQrA9VZ6fI+j7PpePR+h/2P6FUSWZ99wMFgvdvxV9
PZitbDrQ3YxjIQVpqPP8Kwab9N3jrfu/D5Yj5SoLsmO7Q6XHS7bDjOMgWyPz
AsiNLCb56LzEYq2Yd2N/VDlH10M7egGUQDHMhg5o4NtZ1Rx6H+z1nCv306AQ
tsI2vZ0zRoLVTKnXhGpjyGuxGCZGdqcidA3ftsBUKIDLXj+Kp3JzLdjbFYNO
z4lyU+J3PR1bPpu1H90GrapzOAztwWpdOWxD93g+1C9p9EH2HIAWuOo2sq2F
PfDJ+1P90B+sB8rcRrY3YoudYvgT/cbvq5p7iq5n7Qyk5ctjpFhNgnzYCTs8
BjV+Zq33ZLnnQLmog/3uQ76a4CL0Qx8MwBeYTH47VVuqAfQQa4O+R3tH4I/3
oHoxkz2pxGpWtZuCjNhyqFxOV0/hawLMUPxjqwXVxHed67WrmvsGD7zfFPO7
wf4x1R4P9WJesNqUzyno3thypxy+ZH4uWC+r3xpUv4m9RW8qTGytwvOpf9l/
nDen8w==
           "]], 
          PolygonBox[CompressedData["
1:eJwt0MsKAVEcx/G/GYwUiXkBr+QRPAB7GwuKjccgg41L5JKNWVhY2I9LSopC
LhtRfE/O4tPvf85/zmVOMp1NZQwRiSEAyydik1HSI1fo8EEbPVQZ38iurvNk
AUWYpogBj3pGL0It+DJeosXwZfz3VHvvEMQRG6wR5twE6SfjrHXVvUgLIZzU
2cztyTocuGgwZ5NjTFBGCTnU6PXJOZrUC/KND0YYoqL2ojcl73rNgHzgiQvO
OKh3oHdVtX6zrb67+ocf7PMzfg==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.8916492556792146, 0.6405923543985275], 
        GraphicsGroupBox[{
          PolygonBox[CompressedData["
1:eJwtk81LlFEUxt/3voIuqkVtzF27IJCgjdCif0GNyAgLw11RK91FLlwIbgLd
u1RxY2kzfozjjAaNTDH4ES40NcuPUUuKlBKVfofzLB5+z73vvefce859rz15
0fg8RFFUjxKUR4toGq1pbhutogpUGUdRWd7mZhnfs/UwRaBefBe8ysZlfHXi
sebRFPqs+JYnp3kbZ1EGleRL+rZL3Ga4BeuI+wp/hh9CDfi+2PfP68zvUBrN
oUesb4c18Iq8zTWhNnwrTLP/Lv4NnISf0LhYlJ+TH0PDWj8KqxXH4t1AHfhb
8IBvj/Fl2M24B38bfmf8EP8VbqAH+GWY4dsA/j1cYdyC3wme94PulFGdc7Hf
r6hzZXX3nGo7o3rmRBufsOeZ9ZKYFbH31Hp7ST26AF+qd6+D57TYKdVhQvky
8jZXDn6uweB1szr1o6rEc16Gp8F7Ugi+ztbvwT3VZx/+DJ7nIHh9i8oRMX4K
jljzL/h97OCbquE3eB48l+W8mPibSuC23swOzAY/1wSs1fu5GXydrV/AH+oM
dpYpvT2703X19A78o/P9hlvBe/Qj9poM6MxL6uk67FTfR+Ca3uoX+Fc58vBX
8F6+VeyU6p5WPa0WBfbchx9j73NJ/1FJ80V4HPwdnMD/KX6cow==
           "]], 
          PolygonBox[CompressedData["
1:eJwtkk9r00EQhnc3gRysHnqo1VtvgiBCoRR66GdQKaUUKXpV9BOIHjwIXoR6
71GPaTVJ/yRpq0ICCoIYRIQ2aqMmTbEtWm2o4vM6c3j5Pfvb2Zl3dmfo6s2L
N1IIYQRl0U4M4QrfGdSF19AEPInq8CaagqfRJ/hVtD39ewu/9LXOPIcrJH8M
P0RF+GO0s4pvwu1otS6jb/C9ZLF30Fn4s8dr/wv8zuurxmt41f1dQiX4gZ9X
zTK87fnV0we4FS2Xcm7Bx4i57vXOwPPRcl1AG3BfhprwezQADyeL1Zke+4F/
a3yeob/s5aLdo+60qRxAI1iOE8Q+YT0LP0KL8Bu0Dq+iI/gXKsNVdAD/RCse
X4V7yfZU8xDuoAJcQ/lkqnm/LXjQ/cvDSbg/Y14b7i3r8UX0Hd5Hi/Ay2oWX
k9WW5/vJPGu9hApwPZn3CvqtXpKxPMv76YzdnTycgjPcj19byAILxJSC9dBW
v/y7Bt9G51h/TdaLPMqrepB33dlx+E+0WJ3JsX8+2Vp+78JP/T01I2W4m6xX
9fgjWQ/qRR724HF/X83QLfiFz6/eRG/z/058vjTbc9FmRTXy8Ji/rzyMyr/P
m2awA/8DOTeERQ==
           "]]}]}, {
        EdgeForm[], 
        RGBColor[1., 0.95, 0.75], 
        GraphicsGroupBox[{
          PolygonBox[{{207, 205, 187}, {207, 188, 205}}]}]}}, {{}, 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[{81, 83, 85, 87, 89, 91, 93, 95, 97, 199, 201, 203, 205}], 
          LineBox[{108, 128, 148, 168, 188}], 
          LineBox[{107, 127, 147, 167, 187}], 
          LineBox[{217, 215, 213, 211, 209, 207}]}, "0"], 
        Annotation[#, 0, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[{224, 263, 220, 233}], 
          LineBox[{230, 222, 260, 259}], 
          
          LineBox[{427, 415, 432, 436, 444, 448, 456, 460, 468, 479, 482, 483,
            486, 487, 490, 491, 475, 743, 516, 751, 750, 748, 756, 754, 752, 
           701, 694, 648, 555, 563, 506, 515}], 
          
          LineBox[{477, 478, 433, 439, 447, 451, 459, 463, 471, 480, 481, 484,
            485, 488, 489, 492, 493, 741, 688, 746, 681, 745, 690, 753, 693, 
           696, 691, 644, 560, 558, 501, 512}], 
          
          LineBox[{519, 509, 568, 571, 651, 698, 702, 757, 705, 760, 712, 764,
            722, 771, 781, 791, 792, 793, 794}], 
          LineBox[{538, 606, 531}], 
          LineBox[{612, 600, 536}], 
          
          LineBox[{790, 780, 782, 734, 786, 776, 766, 768, 761, 762, 758, 759,
            708, 700, 656, 637, 575, 552, 523}]}, 
         RowBox[{"-", "0.2`"}]], Annotation[#, -0.2, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{256, 306, 293, 285, 278, 273, 265, 245, 241, 237, 232, 227,
            223, 221, 266, 332}], 
          
          LineBox[{258, 311, 298, 289, 280, 275, 269, 247, 243, 239, 235, 229,
            225, 219, 270, 262}], 
          
          LineBox[{424, 339, 391, 401, 414, 431, 438, 443, 450, 455, 462, 467,
            473, 676, 683, 740, 680, 744, 689, 692, 639, 643, 559, 557, 500, 
           511}], 
          LineBox[{535, 599, 611}], 
          
          LineBox[{739, 785, 773, 775, 765, 767, 720, 715, 588, 707, 532, 699,
            655, 636, 574, 551, 522}], 
          
          LineBox[{335, 429, 426, 399, 406, 435, 441, 446, 453, 458, 465, 470,
            421, 679, 687, 742, 749, 747, 755, 695, 634, 647, 554, 562, 505, 
           514}], 
          
          LineBox[{518, 508, 567, 570, 650, 697, 653, 704, 660, 711, 716, 763,
            721, 770, 731, 779, 789}], 
          LineBox[{530, 605, 537}]}, 
         RowBox[{"-", "0.4`"}]], Annotation[#, -0.4, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{331, 333, 267, 271, 226, 231, 236, 240, 244, 264, 272, 277,
            284, 292, 305, 316, 323, 255, 326, 498}], 
          
          LineBox[{334, 428, 425, 398, 405, 434, 440, 445, 452, 457, 464, 469,
            420, 678, 686, 503, 626, 685, 524, 640, 632, 561, 504, 513}], 
          
          LineBox[{502, 382, 330, 250, 319, 310, 297, 288, 279, 274, 268, 246,
            242, 238, 234, 228, 276, 251, 336, 261}], 
          
          LineBox[{510, 499, 556, 630, 638, 631, 684, 622, 496, 682, 675, 472,
            466, 461, 454, 449, 442, 437, 430, 413, 400, 390, 338, 423}], 
          
          LineBox[{521, 550, 573, 635, 646, 642, 661, 706, 587, 714, 594, 725,
            729, 774, 772, 784, 738}], 
          LineBox[{533, 526, 586, 598, 610}], 
          LineBox[{534, 578, 592, 604, 529}], 
          
          LineBox[{517, 507, 566, 569, 645, 581, 658, 703, 659, 710, 666, 719,
            726, 769, 730, 778, 788}]}, 
         RowBox[{"-", "0.6`"}]], Annotation[#, -0.6, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{787, 777, 668, 728, 671, 718, 665, 709, 664, 589, 652, 580,
            579, 564, 520, 576, 525, 585, 597, 609}], 
          
          LineBox[{528, 603, 591, 577, 582, 565, 572, 583, 641, 654, 649, 667,
            713, 593, 724, 663, 733, 736, 783, 737}], 
          
          LineBox[{283, 291, 304, 315, 322, 254, 325, 540, 376, 545, 474, 257,
            549, 547, 629, 621, 674, 624, 616, 418, 409, 397, 373, 369, 388, 
           385, 349, 345, 346, 299, 307, 320, 337, 342, 302, 283}], 
          LineBox[{287, 313, 344, 340, 300, 294, 281, 347, 383, 389, 357, 394,
            353, 364, 404, 412, 379, 618, 628, 677, 625, 633, 548, 553, 494, 
           476, 546, 422, 543, 381, 329, 249, 318, 309, 296, 287}]}, 
         RowBox[{"-", "0.8`"}]], Annotation[#, -0.8, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          LineBox[{527, 602, 590, 607, 657, 672, 723, 662, 732, 673}], 
          LineBox[{735, 727, 670, 717, 669, 601, 595, 584, 596, 608}], 
          
          LineBox[{290, 282, 301, 341, 354, 384, 387, 368, 372, 396, 408, 417,
            615, 623, 252, 614, 419, 539, 324, 253, 321, 314, 303, 290}], 
          
          LineBox[{497, 619, 495, 542, 380, 328, 248, 317, 308, 295, 286, 312,
            343, 359, 356, 393, 352, 363, 403, 411, 378, 617, 627, 497}]}, 
         RowBox[{"-", "1"}]], Annotation[#, -1, "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Directive[
           GrayLevel[0], 
           Opacity[0.5], 
           CapForm["Butt"]], 
          
          LineBox[{544, 327, 374, 365, 358, 350, 366, 392, 351, 362, 402, 410,
            377, 620, 544}], 
          
          LineBox[{348, 355, 361, 370, 375, 541, 613, 416, 407, 395, 371, 367,
            386, 360, 348}]}, 
         RowBox[{"-", "1.2`"}]], 
        Annotation[#, -1.2, "Tooltip"]& ], {}, {}}}], {
    DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
     Identity, Frame -> True, FrameLabel -> {{
        FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
        FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, None}, {{{0, 
          FormBox["0", TraditionalForm]}, {0.5, 
          FormBox["0.5`", TraditionalForm]}, {1, 
          FormBox["1", TraditionalForm]}}, None}}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 350, 
     Method -> {"DefaultBoundaryStyle" -> Automatic}, 
     PlotRange -> {{0, 1}, {0, 1}}, PlotRangeClipping -> True, 
     PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               StyleBox[
               "\"Binary batch\\nwork infimum \[Eta]\"", {
                FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
                False]}, {
               GraphicsBox[{{}, {}, 
                 
                 RasterBox[{{{0.148, 0.33, 0.54}}, {{0.4268649206471011, 
                  0.45372249607406107`, 0.5681369156579342}}, {{
                  0.6551622078021736, 0.5339547695151409, 
                  0.433930203720128}}, {{0.8834594949572463, 
                  0.6141870429562207, 0.29972349178232166`}}, {{
                  0.9338269619987729, 0.7045674049969324, 
                  0.3948635821961961}}, {{0.9702961771992638, 
                  0.7957404429981594, 0.5079181493177175}}, {{1., 
                  0.8916492556792146, 0.6405923543985275}}}, {{
                    Rational[-15, 2], -175}, {
                    Rational[15, 2], 175}}], {Antialiasing -> False, 
                  AbsoluteThickness[0.1], 
                  Directive[
                   Opacity[0.3], 
                   GrayLevel[0]], 
                  LineBox[
                   NCache[{{
                    Rational[15, 2], -175}, {
                    Rational[-15, 2], -175}, {
                    Rational[-15, 2], 175}, {
                    Rational[15, 2], 175}, {
                    Rational[15, 2], -175}}, {{
                    7.5, -175}, {-7.5, -175}, {-7.5, 175}, {7.5, 175}, {
                    7.5, -175}}]]}, {
                  CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -125.}, {
                    Rational[15, 2], -125.}}, {{-7.5, -125.}, {
                    7.5, -125.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -75.}, {
                    Rational[15, 2], -75.}}, {{-7.5, -75.}, {7.5, -75.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -25.}, {
                    Rational[15, 2], -25.}}, {{-7.5, -25.}, {7.5, -25.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 25.}, {
                    Rational[15, 2], 25.}}, {{-7.5, 25.}, {7.5, 25.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 75.}, {
                    Rational[15, 2], 75.}}, {{-7.5, 75.}, {7.5, 75.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 125.}, {
                    Rational[15, 2], 125.}}, {{-7.5, 125.}, {7.5, 125.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 175.}, {
                    Rational[15, 2], 175.}}, {{-7.5, 175.}, {7.5, 
                    175.}}]]}}}, {Antialiasing -> False, 
                  StyleBox[
                   LineBox[{{7.5, -175.}, {7.5, 175.}}], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -125.00000000000001`}, 
                    Offset[{4., 0}, {7.5, -125.00000000000001`}]}, {{
                    7.5, -74.99999999999999}, 
                    Offset[{4., 0}, {7.5, -74.99999999999999}]}, {{
                    7.5, -25.00000000000001}, 
                    Offset[{4., 0}, {7.5, -25.00000000000001}]}, {{7.5, 
                    24.99999999999999}, 
                    Offset[{4., 0}, {7.5, 24.99999999999999}]}, {{7.5, 
                    74.99999999999999}, 
                    Offset[{4., 0}, {7.5, 74.99999999999999}]}, {{7.5, 125.}, 
                    Offset[{4., 0}, {7.5, 125.}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "1.2`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -125.00000000000001`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -74.99999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "0.8`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -25.00000000000001}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 24.99999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "0.4`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 74.99999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 125.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                   Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                Scaled[0.02], PlotRange -> All, Frame -> True, 
                FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                Opacity[0], FrameTicksStyle -> Opacity[0], 
                ImageSize -> {Automatic, 350}, BaseStyle -> {}]}}, 
             GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
           Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "1.3710193577`"}], ",", "0.`"}], "}"}]}], 
             "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "1.2`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "1.`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.8`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.6`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.4`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.2`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           
           RowBox[{"LegendLabel", "\[Rule]", 
             "\"Binary batch\\nwork infimum \[Eta]\""}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "350"}], ",", 
           RowBox[{"Ticks", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1.2`"}], ",", 
                    RowBox[{"-", "1.2`"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "0.8`"}], ",", 
                    RowBox[{"-", "0.8`"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "0.6`"}], ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "0.4`"}], ",", 
                    RowBox[{"-", "0.4`"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "0.2`"}], ",", "\"\""}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.7452227326533947`*^9, 3.7452291506043315`*^9, {3.748786924240083*^9, 
   3.7487869309399004`*^9}, 3.7530203222339325`*^9, {3.753020765484537*^9, 
   3.7530208046137266`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Whole figure", "Chapter",
 CellChangeTimes->{{3.7530194789107285`*^9, 3.753019483036162*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fluctuationsplot", "=", 
  RowBox[{"Grid", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "markovfluctuations", "}"}], ",", 
     RowBox[{"{", "batchfluctuations", "}"}]}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.745222746561143*^9, 3.745222759375001*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{GraphicsBox[
        GraphicsComplexBox[CompressedData["
1:eJx1enk8lG/3f1QiJC0qbYo2+SiptOCUUtqjXaUo7YssJUsp2lBpkSVrEUpR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         "], {{{
            EdgeForm[], 
            RGBColor[0.148, 0.33, 0.54], 
            GraphicsGroupBox[{
              
              PolygonBox[{{1073, 424, 1036}, {1039, 424, 1075}, {1036, 424, 
               1039}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.2585141649873893, 0.3913967583263274, 0.6434973926072376], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxNk7suhFEQx7/zfesWCpdgbeGSuEWCSmNXwVIoeQHiAXgCPAAaPIDdRqJ2
yRISwQuoXSrFRigQl85vzH8TxezvfHNm/jNnztmepZX55TiKolkswUb4yMMh
OKz1KHwMUZRm/QA/CNyAZViNrwrLWC7WgQ2L5k9JN611HT/b5NbCHbgW/Pue
oFV4B7upN0FsHrYSd4C/HTbwPYq/EZ4H172CTyx2YT0x18F7upGu6ZtupSfr
Yz947W3Vs/0SrI09rgaeJZ57Aevkt/1nfI2sb+Ele+vwJvH+rM8xmEn5fGxO
Gc3Bapc1txfYzHcT1i8biNxXmaOd85vYQfgTfL9FMWnp2Txf1I/11SKdQel0
SOuTelvsf8FFzjCHbwG2xV77U3Vykc89Jw3T6qVIkf0+OIWdsM6nfM9ys5Fr
F4LHZZU/oBpWazr2GdmsHsU13cGecjdlG/LNKHdRd27nsLdY0n2dJp63pbxJ
ejqEuZTnVc4xHntPnbBL78rel/V6HPw8BdU8kq8o35H8plsO3sffG9T/wv4r
WelbndfEe3nTGe18u/90TfNdd2F38gtAgFpJ
               "]], 
              PolygonBox[CompressedData["
1:eJwtkDtKA2EUhe/8M6hBwQSJSAoloiJCfJDSiJDoApIluABdgboAtdEsQGwk
qQUhYsAiK7DWYGFhEQMKPrp8hzvF4f+4rzlzigdHjcNgZgsoQd3Y7CQyO0VP
8CTNdeollIE3Gbqld4kycAXdwddoEf7nXWV2RzeZ/+LGObUL9A3vUqvQ25bg
39h7N2iJ/fHg35pDfWrT1Jq8V2gK7jB/HLnHB/lL+y00A5cT52a6O+TNcSuL
BvAPWjGvqfesPXPPf+kN7bdRHl7DT808A2XxRr0Ab6CP1JO8KZMtuBb83+to
H+7HnqX8vMM93jHzG7o1oHYWeUaf8F7wXWWkrJSpstVMAZ5IPHtl8MJ8NrgX
eSzB88Gz1T/Owq+RZ8moPcLLiWd9j6rwCEOsNao=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.5143536806527692, 0.4844693446383534, 0.516705823514027], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJw1lV2IlVUUhr+z9xGTAY38Q5PC6NhMJJiFmtUM6RgROmNztEbvnFHP5F8E
ZcXMoDNoFwXiKAOiphdilkKRCopS0UVGKCqIFIWJF0N1oZLiXxfZ87JeL9b3
rm+ttddee/3sPbnjnbZ1qSiKfVCG+vnMKhVFD7ia/zXQW1AztASaB1WhRqgN
mp5CNhN8s4g1sn8bH4ugLuh16+aDs6DZ8JNS6GRThdZDH0Ad0IvoFmLTBC62
jfxViakBXAw+US6KvfAvgTXF671+hcaz9ndwhfaA7wJb+O+EWkvhU/5WQfNS
nGNuijPqLNOKiGOZ42pxXJ1G/S+wvsP8v1AD6+6DX+JrK/wguBMahN8BXiLu
AfQPEXMzdFzrkP0JvQ9/HlyKXSv27eAQ/xuRXwbvQlvg/8tRG9Vog9aCo7Af
Ajexpl81dL5VhznQWNdItVrvuLXfONfiMXAMVIG/hbytFDlVXQ6oD8BvwVeK
8Cufr6bog9ect3b3x1Mp7OrBkznyfAI8AarPvpcv1+gP8AXnTzldYz+KW3Wa
bbl6aqN7UdhnXvINlr2H8xXg8hT6tbbpNy/ZiBSx16XYU3srjzVkPUX0inwN
2r7XMuk+wm459KH79EEvdPpf8l05cvdZjly0e+9Pc/Tclhx57XJuR9ADn4PT
ylFv1X0O+Bd2g8hHIl/rmvaliLPb8dT5LE+DU12Dh8G7rBsDf8HxtjrGhO4Z
5MPAa6Xo8ZHwV+Afhf8RPAUNh/8Z/Nty6a+XojduO2ctrs1Vy6U/6rMdy5Ez
9UbNd0TN/+JX+n8ldhXNqHrftVMNO51Lxf6T+/9Kjjy2u6bdD3wUMTPq5VPg
GdYfQHYafDzFPN5Dty3Fmm5wbDlyO7octVIdGj0Pn3jev8kxIwfBHTlyuBPc
71nQTIy2n7pyzHqP43rZ8yOfP+S4Y77LcWfp7loNbvf86q59shxzfSdHf6hP
9oBNyI8o3+C1HD12FVwnHfy74OEceTqS49xfQNt916iHd6WoU8V163Mv6Z7Q
uZscp9ZsK8LHczobsufBySnu+Qo4gTgOIZ8ETrFP+da5df4B+c1x/s3gFOz2
wdeDC1LMQzXFPr22X+QYqvYzYF2T7//mFPtp3xngQvw+Av8seDNHn9wAJ/ot
0Jtw2j1wWPPhGCrguRT5OatLqBz38DDwcinmYjjynhT79+rdwG89ulU5cq04
P87Rrzp7zXqdt8HYaH7Id/J53bHl6Kt/sN/tuuhNOOQ3Qm/FhRz3y8UceVf+
3wB/yfGu/QZ+nSI/X4H/A5yp1Pc=
               "]], 
              PolygonBox[CompressedData["
1:eJwtlVtoz2EYx3+/951YJDlMIaxsRo65wDCZkeQ4Z60cmh2Zqzm0zWYOhZJZ
M2cXjlG0TWGaEiMlN4icliR2YeUQ4wKfb8978W2fvb/nPT3v93n+yes3Z5e4
KIoKUQJ67qNoexxFB1EnXMnHSsaLFQP3ROPgWagfvAStgjehIvgGc/KZm41O
wMksegbej5LgMmLKiM1DW+GuaBQ8A3UTE3OB2JrYDtTEGrmxnekpXITS4D5o
IVzAnAJCK1A5/Iqx8tjOcB2eGvZvQjPgscSsJDYLjXa2p/bORIlwG3OqiC1G
rfBv/o7gW1/UCe9iLF17o6PwVebU8O0QugLnM5bCt1Q0zltOlJtq5Qg+gerg
KrQDzg73GYGWwF0S7O66wwv+X+BtrfSwdz2aD09Ctd7eRG+zHM3VfcJ85TAR
rmJsZ2R7noR/eXtb5fMnPEdvGFkON8DjGesd8jsBrnN2N73ZYfiWch7O9wbe
iDLg6agEziJmkdZCa+BBKB1OUQ7hd8T1j+zN25Rnb3fXGlpLb6q9dYZCeA+a
FluOCuBvaBu8FXXoLVhzYWR7ToE/MD4wMo92wKe8eVFr7IYbibmou6AGeCjK
iOyNh8Ap5Oxs8P8w+F94f8Uk8/0ya6yL7Q30FvOc5V4eGu7szhuCv9fCP2O7
u3KQxP8PmFMa2xoN8krYX28wG74jz+ju6Dbcy5lXdZ8ezjwpbyrmrrc76C7y
4DVne2rvbNUo3J071MXm6Y/En0bLwvxz3t6wPNTbW/h98L/mfIa/eMv1FtTu
bU5RqI/z8m7I102UBT9hz0uR5fixM4/L6+ohx+C93ryyFO3zJrHOdAD+6q1X
KEef4NfBL+pRzbH1jLzgr1L4R4hXjQ9g/8XBP/KLaktn3hL6j2LTQr3Lf85Z
TpVbeaadmGZvuZfH5fUqNDm2ms7zVjOqHXnwOzzSWe9YgcbAx731BvWsRs1N
sN6j86kXtgZ/dkX34Wex9RZ57A9c6a22taf21ppaWz1LvavaWS9RTau278WW
G+WoBT4S/FCL6uG/od71Rqnsnxv8qXrJgVuCn/TmD+HBoV5VU6qtLqE/a/2X
xDyK7ey6g2otM9Sf5kyCK5z1Yp1BZ5npzIvyuGotJ/QHzVmt7wnmHZ0vE57o
7LdFvynz4f/3kriF
               "]], 
              
              PolygonBox[{{501, 37, 493, 491, 492}, {492, 491, 466, 15, 
               487}, {1048, 1047, 1077, 427, 1049}, {1038, 405, 1045, 1047, 
               1048}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.7739417516188205, 0.5756983791631638, 0.3641045293997988], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtlMlL1VEUx3/vXtcO8ZRXCCEKQm2yAZVaWIsCe1oOBamLKMshB4pStHpq
NkmEUfZek48WaaRQqQ2LkhaBFg2b/oIGUrAyiZYNn8M5iy+f7z2/O5x7z72/
nH3tlW0uCIJO5NEEjVE4CSNoK34dzEQF+FRYjcrxJfAuGsSPwgc2VuZog+2o
BmUx8T8Y8Rrvt29H6FcP98NjqFvygDUWr4NhVIzPhrVOx7XAIsthi9O2xA/D
jJQgGAgFwSJrPaU9Tvyx9CeeJL4SNlt+VfAe/VqIj8NXqA//yWtb4i9gAkXx
Y7AX5eF74B60Gl8LD1pcvtdZ/vXwIurCX7BcEihu5yXnNgTHAv0m8c+MP8o8
b+Fu26Oc97DTsUk4j57hv8I5+ubhv8HtaG9Ic81wGv+FT+BjMj/8iabxi/AH
37JlTTjhdeyM13pL3Yud1kxqt8FrTpLbS/F8e078PVwK6d1Iw8+iEfwMzLEz
L07RtsQfwje27peQ7kH28g6WomZ8k9P9SP6/4XdbawFeY+2NxPolT/SXeAG8
YjWSWl2n3xDxGLzl9Fx74ROrgdyLmPW5CfPRLnzUaZ2kXt2wzOn9LYTL2UOc
+SNwvd3JFXAt6/2RvXs9R9nXa/jI6joFs+wc5DyWWc5hr3PJnKlw3M7nPpzk
207iN+AalIFvgB/QAfwUbEL5+B2wHuVK7eEduTf4pNQKbcZ3eN2/nMMp2SPt
EuIDXsfLPM1wzuvbWYIjNo/M12lv87i8b6/3LO61BlKLcnkraBX+kLxx8xKL
ojT8NnjZ7vxVpzWWWvfIWfItkz7VXnOS3M7KOigdXwYXvJ5VOmdVZP1l3Ky9
02mva8hapfCErMH8jfA07Qriw/CS7eu21z3IXgbt7hTaG4rbeznpdD5515KH
+FxrNzJmEzwDK1EYXwHn7R/yEbbaf0b+Nx1Wi/Ne/xfy32iFVTZW5ujzmkOX
nK3T/+Q5+B87mqjt
               "]], 
              PolygonBox[CompressedData["
1:eJwtlUlsjlEUhr//u38tFaERqUhNRVmgWsKChJpKWjUEm0bUrFJ+ixpjJkKF
pqToTpNWYqgxpkokhpjFzMYsEcRCgoZ63pyzePK/3x3Pfe+558+as2xKeRxF
0TJIwqsQRS/hNJyBGdAvEUU5MBPdjUF16B3QHn2CtlL0RKhH32OxS6xzGe6j
x8M4KIN5MIkx7TQXrkAVbasYWwm70Nd9vRQ8QP/ktyd9w6Aj/aegEd0Aj9DX
go3VHMVyhrajkY05je5LjH1gNIxJ2pl0tnNwHjrCP8a2QgZ6frDYFGNZsDma
+wfdAkuDeTESVqAPske1x3MAvZu2Ud6/E12sPRK2fq7vqb0PwqFga2is5qTQ
VcG8zIcN6Iv8XoBmuAot8EfrQcR+0xjTKWF7lKAbodD9OInOjM27yTAUPVe4
3yn0bbgY2Z3dQTdBfWRt6rvr/Wq7hS6GWZ4vs9G/2eOXPIRWeAsb2LsGvqDb
4F0aPEM/h3yfXwCD0F3py4Q8yIeNtNXQtx82x7an9j4CN9CvWfeVeyJvpvr5
laPK1Y3BvJMH+9AVscW6SaC3ut+6wwp026TFqpg/813NmKrIclK5qZif+ZvQ
23jPuEz6BsIP9Bs/7xK4ESxnU/4+PqG3wAh0MWxGL4LshLUtQE+AdM+3ieht
scWq8x9G/wi2lt5cBrGu4buH54fOWhfbWOX8WfRaWIdeCGvQJVAemeeT0OuZ
0zNha2gt5UCln3elciW2u9F43XUXzx+9wfZ6f8wpY24RNKG/e3w68zvdN2PS
5BvfL6BtbF7Js2+6F+UsehFMQH/xeqEc+4w+Fttd686PKza/T8U7V167PzrT
UnSp+yEPC9ED8Kh/0opZAp7S9sRzVLm63d/ndNgTLMf2e35o7d7QSx7A2Nje
mN5aFr/dYbXXK+XIXnSA2M+ss5d5fZPH84KtUeA1ULUwz+uBcnYoerHXV33r
La/y+9AbXR5bjuZ4fpcHezMFnn+d0B9p/6BaCQ/lA2P+RlbTOqBrg93VcDig
fAl2dnmgWjXQ65/mFKGbg+Wycvqm3kpstUM5kBvbnT73N6i3mI3Hvb3GqtbK
oyz3UF5+j+2/QHf8FT0kWC2UB/Ii178Vw+BgNbTB63dtbHcYeQ1RLelLWx/3
XN7X+v+BasYh9BPWfew1UrWy1WuTYlSs6Z6P8rAz+j+Yd9Py
               "]], 
              
              PolygonBox[{{688, 165, 683, 681, 682}, {611, 100, 602, 600, 
               601}, {936, 935, 957, 364, 937}, {928, 342, 933, 935, 936}, {
               921, 357, 979, 981, 982}, {614, 613, 616, 105, 615}, {455, 454,
                457, 28, 459}, {924, 923, 925, 337, 950}, {1088, 1087, 1081, 
               414, 1080}, {601, 600, 578, 78, 598}, {499, 36, 487, 485, 
               486}, {682, 681, 661, 143, 679}, {1040, 406, 1049, 1052, 
               1053}, {587, 85, 551, 552, 553}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9213306425854427, 0.6733266064636069, 0.3561249920148725], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtlGtMz1EYx3//369cXhRlcy9iYxZmVom55DKtUsNardFcsryiiC155bKJ
IaaNNpnIdWUNNcUyedESjYzNvFFimUtymRkbn2fn++LZ53m+5zm/8/zOec6J
21y0drvveV4ZFmCtBPXwHmwNed5f/EwGSrFlxGUwHvuDPhsuxSLQlxuxbvTh
sBJLRz8KT2huOfyEleO/gcm2IH4SbGe9FsIOOEvft3WeE9/HfwpPEueSXwNb
VKfV26G5T2AXY/vJ6YNviZvRe+Bv4jL0l3BKyNUch8WEed5pOBKWk1dKfimM
VI7lnkGr89x6lxg7Dk/5TjetCmsjvggfwHeqpw++1f8OBG7vbB+OwBf6L/u/
HtX5CG5RfXtghdaqNPpunRoYRa3V5EyCdnjF6CXwF/YBfxRzj2mufWMrlo1f
CNeZ4a+BeVgBfgE8rH+3PTiAHcTfAXdKL9P/Wg02tpo4E2bBao0dgrGsHaK2
ebAXRqJ3wXzVafVOpu46tAVwOlaB/4/8Jt/t8zkYgU3F/8ZYCmNjYA6cgJ6K
ngjbiDeg34BnsUL8O3AOY8nkjDPy/Zv2DfiZ+Bn6gO/m23cWw+jA7dsIuA9L
Ir8CPrb+QO9Xj1qvJgbuDGwfamE+8Uz0YnhX9TfDoYFbKzxw+277nwYTdHax
cEXg+myl3Z0w1yd2P8I19wv5jfh70V/D68S16A2wSGe3CV7VvTgP03Qf7V5e
Ub7Nu6y9aoCvYDz6EPQLuqd2XxuU8xAm6HxTfNcr1jPzfXd/7B5VwRnEKegZ
MEbnbuf/U31o/TgWm2t7C3NUs/VdKrYEfxrsZN4w/Ha7h8zvxx9Ez8UfjZYN
A61la2aptoXwtu5RIyzRWWyDuwN3vwtgnr5j33sfcn31XWOWsx4O6qz7YIbe
n3SNJ+kd+Bq4tyKas1qknrTebFLvWQ9227vJ3Ftwl+qxuqLUk+N990bYW1EP
r+ns7Ax/hNxeRaN/1DvWaz2v3psIO6XbO7dK/bMR/gecxbBe
               "]], 
              PolygonBox[CompressedData["
1:eJwtlFlIlkEUhr9v5keL0FLqT9vVqzYJk1Qwi1YsvBFpwaTI6KrSiqAFghYq
IlogWi6MKLOLNKIFSiMtqGy5qKAoqJsSSwzUrItQqOflzMUDz3/mzHwzZ878
ORvrKre5KIrWQAL2+CjKjaNoHhzAKxmsJl4PNXgTXMUb4Tq+ipzx5M6CGvws
sZOR5Si3OownYS1+E9bjK+AKfhwW4avhDD7AnB/M7YE/+AZi6bHtaRN+ytve
NP8c3hL2o29ewycRixiLYTK+P+TnwC58OzmHw3m24Ou8jaVBOX6JWDNjF6BB
TuwGtEMHnPD2ba2ptS9727vOcBo/Eta/qD0526PydeYmfKu3Wqkmqs192Izv
g3v4BOYUM7cCCvHdAq+FOvwXeXl4OnzFK5gzjA/BSnwuOcvxAsjCP5DzHoZg
GLLD+lojDf+nmhLfC3/xFGIzGVsIXnehOob1fuPjyBkLSd0rdJHTytgD+IYX
0UTN5J3XPLyLnIPhdz9+h5xH5LbDXbzRWa1aoBUf7exb+uYAc/JZYzbE4KDK
Wy/pfkvwIm+uWCmeGearBhPxWM0NuZAHZaE+6mn1dknob8VUu5KwnnqoGC91
dheq2Rx8GXtYCkOqOzwkrw064DF0hXqNgFf4Ym+9pR5e4q3n6sP3q/E+YscY
a4AM1p2aML+t7yfsznR3UTjLF/xz+Ka+/ZNYr+4JemBMwmqtmvd6q0ky9Nt8
PJXxFPiIf4IZ+PRwJp0t31svqadG4X2s+RZ/B/34SG+uWKrO7+zu9Gba8MHQ
n6pXhrMeUa9kQTaUE6tibIFqHvasvXfDd92/t7ev/4ACvCxhtVBNCvFaZ29B
b2IHPiXUSzVMw3eG+uoN6i260Ds6s85+1Nnb1vgh/I2zXlRPDuKZoX7q4Wl4
Z2x3qTt9Hdt/gP4LOuEFPHPW+3oDz/Gnzv4b9Z/0RLWL7a2qJt34rTCuOZr7
MsxXTHP/A6pqo3k=
               "]], 
              PolygonBox[CompressedData["
1:eJwt0bsrhlEAx/HD+1oNbpHJJXIbzWRAoiSXUdgxCLGZyIvBX2CUd3VdFAth
UJQ3lAjJ5R+w+Jw8w7fvc37n95znnPNUjU8NTOaHEMpQgDGDCR7mQQzhKhXC
JU4xmhfCCR/I97GLY/1b7pZ3oQe/shY+lGc97yX9+F6x/ENWxCUoxRxmsYwO
35jnTd11vTVeRQY38g3z9ekQGtCId/lb3CeO9F95Wq9ZbyZZN67/I782/82f
+EKnvFCvN9l7PMM5zvCMJXMXXKNbjTq0WaOWt+Qj5rd5B9nU/33Fe2tHn14/
V8jL0YqgX8k53OEei7K0c6R1m1Ryxg94xFO8E35J/kH8F5nkPhYwr7/Cf3Z5
Ov0=
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9627983855512656, 0.7769959638781642, 0.4846749952089235], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJw1lFlIlVEQgP//PxciyxfNzMy4aqtlDy0IWUJZkm8hVBJqdF+jtKQ0Il8i
I7mGFkFEYItBD16jp6yMTA3abKO9NCnbTEKiKG39hpkehm9mzpxl5sw56ZHy
oi2B53k1iENGMAbhKPyL3EEfDHRQdPElO41JgrOQUfQs8SH7fM/rg7+JG8L/
By5DStDXwQeM7SHmHQyHPO8IegJMZGwBMWlwPWPj8K+E3dhn8XcJsTfj74Yt
SDH6CRggd4nxYSZrxfDnwkzsH/inwwzE4Z8GO1mrDf81+Ay7Af8Y4puwo/gb
4EfkHvoQvGX73nA6R+behJftbHLGJ0gH+mP4HLmK/jTQ/WTfxXA+exxDT4Xt
2GXoMfiTuE/E/4KhkJ5HztWHfR5/L8y1muTB+1ZDqeUcxnKISYY92JX4++FF
7Fb8zfCSnacdZtt9rYKnsU+ixwK1xV8AszhDM+s8RI8L6Z3K3R63+kid9iJV
6DvgAbHRa2Gtp/pRJIpdDw/JPpZvq9N7lVwkp29Oe2AC+wxbXgPwjNX2f41l
PcknDjsDDhMXb7mnwFTrnwS4Gomgr4GbTC+D/TIHvQcWWI6SazucKHWGr31d
/wvcarlIToet307BIuvnPPjd132lf+PtfqfCr0L8H6TnGMtCzwy0h6SXOqQP
7b7k3sJwvK916bV7vy79iXSiv4SFTmNKnNrifwF3YS/EX+40Z8l3IyzFnoR/
Ley3vn0FZ2CPoM+Eb+yND8Ar1g8tcDdj+cyth6WWr+QdCbQuFXADY/OIicA2
6/8LcIWtn+90TGK2wZ3WH3XS507fl3P6R8hfMdlpD0nNK+FyO38xXORrjoWS
p/Vetdy707eTIn+P1UHqkWR/VCJMc7r+FLhE/gticmCT0/UOwqXml/Ea2y8K
H1lekl+j1aTO6b8g5/8caD6SVyN8G+hf9B5WE5dNfJX8T9YPg5IH/XFO3jIM
277pTvtP+jDE3P32duQN3cY/VvrB1x6SXvLhdjunnHeuvQX5D6QG4g/b3nKG
Cjjb/kP5F/8Bfmq/ng==
               "]], 
              PolygonBox[CompressedData["
1:eJwtlElIllEUhr//u3+DllERWBiiRROlNhJINhmBm4IWFWGFtozUksqCVmET
Gg0GEUFpBS1SadVImW1CoowiG8AkGs1FmWaZQc/LOYuH//nueO695/zZpeXr
yuIoikohCU8SUZTG7xR4j/cmzBdDGgOXhSgaTdtvvmfhS2FUwtrU18HvSxiC
f7Ceton8BliOV0BOwto2B2tTXwwFeD5BNOJnIQv/7vsrpi58i8/Pha14IfyJ
LJ4VeBvtKXgmPMW7aKvk9zD04KthMLI5q/CNHl+Or70NsvBFsBsv9vOqTX1N
sCVha7bi+4PFovlV+C7/LoQDeHpsd6czpOLHgvVpjObWBNurCOrwesXk80/i
XxJ2Fp3pMV7i8enON+Hjk3ZXB+E736eCrbVQZ8Y7g51d8bbh5cH6snytOh+v
MzXg3b7fAhjAJ/j6epOpSbtDrXdeecL3Ws60BpZAAdTDOeZWw3G8F35AP/yC
W9BC3wO4g1+GpsjmaO441h8bbE6vz9HcAfgNe2Cv5+t2/BLU4jVwEf8AT/T2
8BHPI8ZciCHASdoO+X4N+Bj2SoMUSIVG2hrou6EY8WfQDj+hT7F7vK3wGt8A
xfhOxYQfiS0WxXQUr4itT3vuwxPBYlOMEZ6nfFENKc/ghM/XGavxybT14N8g
Ay/z9bTnZrwytrtWm/pGMmYEDIPh8Da2WHXfb/BpwWpF+T8dnwOzPQbFMsiY
bt/vL54drDZVo1P8jlJ8D+31gjHP/Y50V6f9PXSHV/B8r2/V2Ep8UrC1tUc6
3gI7Epbz1/CS2N5W5y/Hx8eWi8rJPsbUev1o/Bl8hte/anpmsBxULs6FecoP
ryft0YxnJi13r6tG8IeMaY7sTfW29/y+9H0bD8xp93yKg+WEcuOmcgBv9P8D
1dCFYDVW6fV0N1iOKde0x1X8bmxvoT2016dgtasa68cf+fq6v/t4lee7ckK5
dc3zU3es3C9I2ll0pvlJ+w/U++o/qwh/F1usWrMT/xzbWXSmr/hQbO+hHPuH
v/L4VKMdeIbfl2o+Ff8PrOrD4A==
               "]], 
              PolygonBox[CompressedData["
1:eJwt0D9LglEcxfHro+VuEJSYtapBIeUWtNSW0hwN7tWL6A30InwRDg0VTQVq
ZA1N/ZsiWrPQ6HPxGb6cc8/5Pff+eFbaJ/vHSQihgBlsOmxgCwfO2zSbCyFB
HmeZEKp0NmseX/qBuRxfwS+/Squo4VX/ght0dc904o4xMnxF9sc/YZ4/p5e4
QklflxXTneJu1+480t3SHvop0b/jVHdHP8z2fPuWvh/3OERb1qJ7aGLR7Kes
RJdQxqP8QvZA7zFMpnnsG0i8sUx3/YcOv0PHzhOMzH5jLu7gjh9+HWtYQENW
o/8kAC67
               "]]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.8836516112546834, 0.6255967711025313], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxdll1M1mUYxp/3/wAicVhrgvBCrW83pcyDNmu1QES2tk4qhBfxtE0Qha2D
zkTF1lZtHRTGR66tg0rAj62trZaoQDrnMvkMyMo2t4oQsCxa1737x3zXxsX1
fNxfz/3c9/95y3c3v7gnCSHcFqLQJLQJ7cJnqRCOC+8Lj+eE0C/eKu4QHxT2
CjuFOqFZOJDyvRbha0F/YVL/VoR7NB7DntnpEt7Ddgc4wNr9Oc53i5eir1+P
LmvrFtce/L6C7zrWjkdfOxZ9vYUYl3XIK4phQXxNuKjxDfEcY1ubES5oPCtO
pP+T5US8RfNqjUsSj7+LuFvIQb3wheRaxaPEeTDrXHuzZBuQb8nK2eXosV+K
vm9yZmtF/sbk95/EbXZh9wetzQlLQr8wIBwVupjbuFc6feJj4m5xj3BEeINx
rzAofIB+D3smc4J5N7YOC4eQPZzl6yjrJtfJ/oeJ770tbhVnhAahI3H7byXu
o506+5fasBoxG/vxYbwvy7eNzd5r2G0Rz4oXyUU3sZuNghzPVXGOz49k1fRq
Dtqo9V34amPcyXg/aMT3q4nrtyce0z7i6iRGO/uY9r4Tj4s3CLUaV4i3KZYn
rIeE54VNwkbWbK+aeqinVg9FX3tHXIF8JahK+dpOdG2eI+QK88FtVLNXIqwV
8uFSoQCdbcRTh60q7G8ixtV5Haik16rQW43LeD227Txp9kvxX8G8BLli9H4P
HrfFnCauUvaKyc+70WN5k56uJLa12DP516PLtoqbottqZs3sFAkvJH7XGXGe
5n8Ez9eD9PgD4mX6qYBYbGx+FuElam01l/ns3Qyev/qsu6ynz5eozUX60Prx
E3EPff6p+CvNz2j9jPhL4bTGw+KP6SPrp3WcI5e7Xse44n95NV6T8rNcC/6d
KJOPXy3H0eNZZn09unYOk70l/IjeMvNccmV3dJ/0fxOXR8+h+VkIznlZuc4j
tmLGRcian5v4zc/SN/sm18i3wvqqlJqxepolx5bDDfJ9XfyoPVTR401F/+ba
93Imel1ZvFPCZPD5FHYzfEPS5KRIHPWN+MjqTdwYPbcZ8bT2z6P7SPR8PCN+
DHnTO4uPc/BE8BxNwuY7n5gLop/3e848LJwM/q0t1N4v4o3iU+IRYTS4vJ19
Bp5lXEedW72brWnOPM94Cj/T+Mpwrpc5t8U5Hvy9sXdnKPq7MRT8TMPEYPEt
qv6+FV9O3OYI+1d4T6+Kvwlet6PYHsL+OGOr71PsnwZ9rE1K/6rFnLjvCfI3
hv4Z5lPkuRe9PuKzeQ979p4NcG+DrPVzpgFyPcj+MPPz7J9DZoJ+tL7MUV5+
tvqM7uckvk8w7kF3iLjtbbY6tPfbflNYn1k/raH2F7i/UfK4O/G38SVxjfhJ
YTvYHPw3Rw1zq117j3YF75VGxjvgWsaNsOmVCXcJ6eB+tmOzFp0m5Guwn0a+
IHitW80/Lb6U8rXRlMdYRnymt4W4VyT3uX0D1Rdz4nKtzadcNo18hhga0DFd
k7uVcpkbyBeuxpG4zL2Jy5fju4xxIXY2Y7eCN3cr+dyBjxHuze7suejf0Kf4
ntm9WU/8TR3eTvx+rNesrudgm1/IWrO7vcjaw9TJQ9F/h9hvgUHqpDvcqUtb
t99Mf/E74U96aibc6fkZfFl9Wm1OZ/kzX8/yW9R+k04hY7X7H5aAhhk=
               "]], 
              PolygonBox[CompressedData["
1:eJwtkzlolEEYhuefWUQWEYKCGJG4xlshoGJhUFAiBBQEG6MQxW2FrGwhiNip
AUVQwUJSJGJj4ZHKSrGIhaBBoolZryieEPBAMN7H8/JO8fA/M/PPN998M1Op
1nb0xBBCB5RgaQrhLd83sAR/yuAjfBye4XX62ooQmqGKr4B3wXOWJfdpbC7s
1RgcxWvwAL8C3XgdbuCTcBzvgzIJtNF+HxxzFV6DFsbWwGG8HaYYK9Pegncl
r1WCzfhsYpwvvOZX2ouT9/IaWpNjKFYn9OJnk1059eMTybkpJ+V2CjoK7/lI
8ppaWzntxhfBJ2J/hIX4RdhVeM655DW19jdYjq9PzlVzNLedfK8WzrkVb1Dj
seCaP8HvwHX8LjzHP/NfBV+nGtC+TYyewmteS66xaq2+EXw+/3Ty71qYhc+J
nrsVVuLD/DcjOOZL/At9o/hDaNJe8/nqTGYm56Bc7sFEdEzFbtEemf8z3xft
4Qd+BvrwXjiBTxb+twz3C/dprA6H8APR3g3V6ByV6zbdB7yZHD7gDfhLe2f0
v9rjJnxavr/KeTpeST4bzVmAf8/11R6n8CKfj+5IxEei967xUdVX4INwEx8S
wX0auwwXgs/oFr4x+ax1R3VXNUdzVYNL+Ivo2g2r3tFvSm9LMR/jv3NbNfyF
98NA8BoD+IboWuyD7fg/eJXvd9B7io6tPo2pRo38fv/obPL5qgbj+EGBn4Rj
+Olo15paO+X3o5qW8D3Ra2vOfnxeyW93EFbj/wFkRpgE
               "]]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.95, 0.75], 
            GraphicsGroupBox[{
              PolygonBox[{{242, 222, 221}, {221, 200, 220}}]}]}}, {{}, 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[{11, 32, 53, 74, 95, 116, 137, 158, 179, 200}], 
              LineBox[{231, 230, 229, 228, 227, 226, 225, 224, 223, 222}], 
              LineBox[{211, 212, 213, 214, 215, 216, 217, 218, 219, 220}], 
              LineBox[{431, 410, 389, 368, 347, 326, 305, 284, 263, 242}]}, 
             "0"], Annotation[#, 0, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{458, 463, 490, 503, 531, 541, 566, 577, 599, 610, 624, 
               633, 650, 657, 674, 680, 701, 708, 707, 704, 729, 732, 731, 
               730, 728, 727, 726, 724, 721, 756}], 
              
              LineBox[{461, 480, 496, 522, 535, 555, 556, 561, 573, 591, 606, 
               619, 630, 645, 656, 671, 672, 675, 684, 703, 712, 733, 734, 
               735, 736, 738, 746, 767, 768, 769, 770, 771, 772, 774, 776, 
               778, 782}], 
              LineBox[{471, 509, 510}], 
              LineBox[{474, 450}], 
              
              LineBox[{785, 754, 758, 760, 761, 762, 763, 764, 765, 766, 794, 
               799, 800, 801, 802, 804, 826, 834, 856, 862, 863, 866, 882, 
               893, 909, 917, 931, 943, 964, 975, 977, 978, 998, 1013, 1044, 
               1059, 1083}], 
              LineBox[{1067, 1027, 1071}], 
              
              LineBox[{1085, 1074, 1051, 1034, 1002, 990, 970, 956, 941, 927, 
               914, 903, 891, 879, 865, 858, 837, 827, 830, 831, 809, 803, 
               805, 806, 807, 808, 810, 812, 815, 780}], 
              LineBox[{1095, 1021}]}, 
             RowBox[{"-", "0.2`"}]], Annotation[#, -0.2, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[{456, 460, 488, 500, 530, 539, 565, 574, 594, 605, 622, 
               627, 646, 654, 673, 676, 698, 702, 700, 699, 697, 696, 725, 
               723, 720, 755}], 
              
              LineBox[{462, 482, 498, 525, 537, 560, 572, 590, 592, 597, 609, 
               623, 632, 648, 649, 652, 659, 677, 685, 705, 706, 709, 714, 
               737, 739, 740, 741, 743, 745, 748, 750, 773, 775, 777, 781}], 
              LineBox[{516, 477, 444, 449}], 
              LineBox[{548, 547, 513, 508, 470}], 
              
              LineBox[{779, 814, 811, 813, 840, 838, 836, 835, 833, 841, 860, 
               867, 885, 894, 908, 916, 930, 942, 962, 973, 992, 1004, 1037, 
               1054, 1076, 1086}], 
              LineBox[{980, 1066, 1094, 1020}], 
              LineBox[{1028, 985, 1031, 1026, 1070}], 
              
              LineBox[{1082, 1056, 1042, 1008, 996, 974, 971, 969, 960, 940, 
               929, 913, 906, 890, 888, 887, 880, 861, 854, 832, 829, 828, 
               823, 798, 797, 796, 795, 793, 791, 789, 787, 759, 757, 753, 
               784}]}, 
             RowBox[{"-", "0.4`"}]], Annotation[#, -0.4, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{446, 845, 843, 842, 839, 844, 864, 868, 889, 897, 911, 
               918, 934, 944, 963, 972, 995, 1007, 1041, 1055, 1080, 1088}], 
              
              LineBox[{455, 459, 484, 497, 527, 536, 563, 569, 593, 603, 620, 
               625, 643, 647, 669, 670, 694, 695, 693, 692, 691, 722}], 
              LineBox[{587, 553, 515, 518, 473, 476, 443, 448}], 
              LineBox[{615, 614, 585, 583, 550, 546, 512, 507, 469}], 
              
              LineBox[{752, 751, 749, 747, 744, 742, 717, 713, 711, 710, 688, 
               682, 679, 678, 660, 655, 653, 651, 634, 626, 611, 601, 598, 
               596, 576, 564, 538, 529, 499, 486, 465}], 
              
              LineBox[{818, 783, 786, 788, 790, 792, 821, 822, 824, 825, 852, 
               855, 857, 859, 877, 883, 884, 886, 904, 912, 928, 936, 937, 
               939, 959, 968, 994, 1003, 1040, 1053, 1079}], 
              LineBox[{921, 982, 1017, 1023, 1063, 1065, 1093, 1019}], 
              LineBox[{950, 924, 952, 949, 987, 984, 1030, 1025, 1069}]}, 
             RowBox[{"-", "0.6`"}]], Annotation[#, -0.6, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{447, 442, 475, 472, 517, 514, 552, 551, 588, 586, 617, 
               639}], 
              
              LineBox[{464, 485, 487, 492, 501, 532, 540, 568, 578, 600, 602, 
               604, 612, 628, 629, 631, 635, 658, 661, 681, 683, 686, 687, 
               689, 690, 715, 716, 718, 719}], 
              
              LineBox[{663, 662, 637, 636, 616, 613, 584, 582, 549, 545, 511, 
               506, 468}], 
              
              LineBox[{665, 638, 667, 664, 666, 668, 640, 642, 644, 641, 621, 
               618, 595, 589, 567, 562, 533, 526, 494, 483, 457, 454}], 
              
              LineBox[{816, 871, 869, 870, 896, 895, 892, 898, 915, 919, 938, 
               945, 966, 976, 999, 1009, 1046, 1057, 1081, 1087}], 
              
              LineBox[{846, 899, 920, 922, 946, 947, 979, 981, 1016, 1022, 
               1062, 1064, 1092, 1018}], 
              
              LineBox[{848, 817, 819, 820, 849, 850, 851, 853, 875, 876, 878, 
               881, 902, 905, 907, 910, 926, 932, 933, 935, 957, 967, 993, 
               1000, 1038, 1048, 1049, 1052, 1078}], 
              
              LineBox[{873, 847, 874, 872, 901, 900, 925, 923, 951, 948, 986, 
               983, 1029, 1024, 1068}]}, 
             RowBox[{"-", "0.8`"}]], Annotation[#, -0.8, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{451, 445, 478, 479, 519, 520, 521, 523, 554, 558, 559, 
               557, 528, 524, 489, 481, 453, 452}], 
              
              LineBox[{466, 491, 493, 495, 502, 534, 542, 570, 571, 575, 580, 
               607, 608, 581, 579, 544, 543, 505, 504, 467}], 
              
              LineBox[{1072, 1033, 1032, 989, 988, 953, 954, 955, 958, 961, 
               965, 991, 997, 1035, 1043, 1045, 1047, 1077}], 
              
              LineBox[{1089, 1084, 1058, 1050, 1012, 1001, 1005, 1006, 1010, 
               1011, 1014, 1015, 1060, 1061, 1090, 1091}]}, 
             RowBox[{"-", "1"}]], Annotation[#, -1, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[{1073, 1036, 1039, 1075}]}, 
             RowBox[{"-", "1.2`"}]], 
            Annotation[#, -1.2, "Tooltip"]& ], {}, {}}}], {
        DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
         Identity, Frame -> True, FrameLabel -> {{
            FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
            FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, None}, {{{0, 
              FormBox["0", TraditionalForm]}, {0.5, 
              FormBox["0.5`", TraditionalForm]}, {1, 
              FormBox["1", TraditionalForm]}}, None}}, GridLinesStyle -> 
         Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 350, 
         Method -> {"DefaultBoundaryStyle" -> Automatic}, 
         PlotRange -> {{0, 1}, {0, 1}}, PlotRangeClipping -> True, 
         PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
         Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"Markov\\nwork infimum \[Eta]\"", {
                    FontFamily -> "Arial"}, Background -> Automatic, 
                    StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0.148, 0.33, 0.54}}, {{0.2585141649873893, 
                    0.3913967583263274, 0.6434973926072376}}, {{
                    0.5143536806527692, 0.4844693446383534, 
                    0.516705823514027}}, {{0.7739417516188205, 
                    0.5756983791631638, 0.3641045293997988}}, {{
                    0.9213306425854427, 0.6733266064636069, 
                    0.3561249920148725}}, {{0.9627983855512656, 
                    0.776995963878164, 0.48467499520892343`}}, {{1., 
                    0.8836516112546834, 0.6255967711025313}}}, {{
                    Rational[-15, 2], -175}, {
                    Rational[15, 2], 175}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], -175}, {
                    Rational[-15, 2], -175}, {
                    Rational[-15, 2], 175}, {
                    Rational[15, 2], 175}, {
                    Rational[15, 2], -175}}, {{
                    7.5, -175}, {-7.5, -175}, {-7.5, 175}, {7.5, 175}, {
                    7.5, -175}}]]}, {
                    CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -125.}, {
                    Rational[15, 2], -125.}}, {{-7.5, -125.}, {
                    7.5, -125.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -75.00000000000003}, {
                    Rational[
                    15, 2], -75.00000000000003}}, {{-7.5, \
-75.00000000000003}, {7.5, -75.00000000000003}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -25.}, {
                    Rational[15, 2], -25.}}, {{-7.5, -25.}, {7.5, -25.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 24.99999999999997}, {
                    Rational[15, 2], 24.99999999999997}}, {{-7.5, 
                    24.99999999999997}, {7.5, 24.99999999999997}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 74.99999999999996}, {
                    Rational[15, 2], 74.99999999999996}}, {{-7.5, 
                    74.99999999999996}, {7.5, 74.99999999999996}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 124.99999999999997`}, {
                    Rational[15, 2], 124.99999999999997`}}, {{-7.5, 
                    124.99999999999997`}, {7.5, 124.99999999999997`}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 175.}, {
                    Rational[15, 2], 175.}}, {{-7.5, 175.}, {7.5, 
                    175.}}]]}}}, {Antialiasing -> False, 
                    StyleBox[
                    
                    LineBox[{{7.5, -175.00000000000003`}, {7.5, 
                    175.00000000000003`}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -125.00000000000004`}, 
                    Offset[{4., 0}, {7.5, -125.00000000000004`}]}, {{
                    7.5, -75.00000000000003}, 
                    Offset[{4., 0}, {7.5, -75.00000000000003}]}, {{
                    7.5, -25.00000000000001}, 
                    Offset[{4., 0}, {7.5, -25.00000000000001}]}, {{7.5, 
                    24.99999999999996}, 
                    Offset[{4., 0}, {7.5, 24.99999999999996}]}, {{7.5, 
                    74.99999999999997}, 
                    Offset[{4., 0}, {7.5, 74.99999999999997}]}, {{7.5, 
                    124.99999999999997`}, 
                    Offset[{4., 0}, {7.5, 124.99999999999997`}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "1.2`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -125.00000000000004`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -75.00000000000003}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "0.8`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -25.00000000000001}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 24.99999999999996}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "0.4`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 74.99999999999997}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 124.99999999999997`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 350}, BaseStyle -> {}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ),
           InterpretationFunction :> (RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"Blend", "[", 
                    RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                    "]"}], "&"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1.2057564850155764`"}], ",", "0.`"}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1.2`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1.`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.8`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.6`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.4`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.2`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               
               RowBox[{
                "LegendLabel", "\[Rule]", 
                 "\"Markov\\nwork infimum \[Eta]\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", "350"}], ",", 
               RowBox[{"Ticks", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1.2`"}], ",", 
                    RowBox[{"-", "1.2`"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.8`"}], ",", 
                    RowBox[{"-", "0.8`"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.6`"}], ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.4`"}], ",", 
                    RowBox[{"-", "0.4`"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.2`"}], ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]},
    {
     TemplateBox[{GraphicsBox[
        GraphicsComplexBox[CompressedData["
1:eJyFmnk8ldv3xyXcJhSqawqhVDdUKg0sRfOorkZdRRpVIklp5KYkFAoVKpkJ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         "], {{{
            EdgeForm[], 
            RGBColor[0.148, 0.33, 0.54], 
            GraphicsGroupBox[{
              
              PolygonBox[{{402, 52, 362}, {348, 49, 360}, {613, 53, 541}, {
               392, 50, 366}, {416, 53, 613}, {371, 51, 395}, {366, 50, 
               350}, {407, 53, 416}, {541, 53, 375}, {327, 54, 544}, {351, 50,
                392}, {350, 50, 358}, {377, 54, 410}, {355, 49, 348}, {620, 
               54, 377}, {386, 49, 367}, {370, 51, 361}, {544, 54, 620}, {360,
                49, 386}, {365, 52, 374}}], 
              
              PolygonBox[{{358, 50, 52, 365}, {395, 51, 53, 407}, {374, 52, 
               54, 327}, {410, 54, 52, 402}, {361, 51, 49, 355}, {367, 49, 51,
                371}, {375, 53, 51, 370}, {362, 52, 50, 351}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.4268649206471011, 0.45372249607406107`, 0.5681369156579342], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtkLtKQ1EQRedc/yJCNCoIQoiFhQgWguCtLHwQYiMkkhBEAwrGwsIuGm1s
bExCxO+xsrAR/IRgZxHBtZkpNnudx8yZs0v1zt55ZmYraAYNWbzg7/gzGsAf
+E8ye4Qv4Q24BFfwBTQHF/AimoeXk9eodoy30APcwYvoGp5wZxe+g4/wTzSE
v/Gp+f0m/IpG8Ffmb+itMr7PugfXok4z36MTzlbxVvK19nsxt+ZvR7+++Xyn
sa//DWJfM9VZV/BbfE3/hDeT91X/Kv6GuvAsPW6S/0v/24GX4Cv8LGqb+K/5
fp48X802wg/jLb15gRbhbvK+6r8NNyLzNr4eOSvvg8ghzzxf5ab8jiNbZZzH
HWX2Z95/i9qnuKO7/35cOWE=
               "]], 
              PolygonBox[CompressedData["
1:eJwtkc8ug0EUR2cm9p5AtCWxEhYW0sRCImEtRIjQEFItbYMoYsVC6+umlSBK
U/FQNt7B1kbi/HLv4uQ7883M/Tf5vfpqLYUQJmEEtmMI43zzsI8fRfMJOMU3
YBbPwTx+CAVf7+BVqMAulBx5C9pQhplgOZTrm+QD/A2e8Bxcej3L7G+yvsf7
8I5PRculnHP4OZxBBh045kwnWAzFWoxWu3oo4tdwBa/QV/2cydhrwifrae9f
Na6rVu9f/wp+R3d78Ahjye4qxgG+Eq125b/BB8lrhy+8BO1gPa3hL5x5hiF8
wE+0u+qhyv5StPjq4Q8uPL76P4k2c81Db1LzGWQeU7GHyWbbgi7e4F/dZ6bZ
Lfj7KeYvbCU7+wCj+B37t36n4T33/I311k2fr2rULP4BISk8CQ==
               "]], 
              
              PolygonBox[{{393, 392, 366, 48, 356}, {417, 416, 613, 139, 
               615}, {384, 47, 360, 386, 387}, {617, 140, 620, 377, 
               378}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.6551622078021736, 0.5339547695151409, 0.433930203720128], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtkb1KQ2EMhs+XLnaQDk4d6x+UVhd166BUdK64tG4OLqLSQfAPiqidtOBm
tYIoutd7cOgtiIPegN6Cz0syhOdNTpIvySltH2zsW5ZlVSyHreJcwGvYSR7f
go/4fXQTjrB79AM8hqfYDdbDv4TnsEJNBd2CA/whOs8Dpag5Il7Af0d/E2tE
T/VuYz30K1yIPupXxebRm8n7Kt6ExZhzFo7F/IuwjJ2hp+GP+Vt6s0HeHHoZ
jhO/kjavUW0d3sY8T/Ajdu/Du9CKTZnvPmN+I82gWV6S77hD/A19gp40z1N+
0vfYUbvKV/wT7prn/6G/ks//m/ymuu063DO/9yFcw7roFfP76s4TOc9Tfs28
Xn10j3rsqP/8HH3Urxb5S3EzzaD5/gFLbTls
               "]], 
              PolygonBox[CompressedData["
1:eJw10t8r3mEYx/Hv924HzjgeEdam5sdqVn5tsTZxMMrPIQ1hw9MeaxzwWCas
6KFEeFjE/2MnUyT7I3ZGIe9P1+Xg1XPd9/e5f1zXfRUOJdu+hiiK6vAIfxic
4ACH+B9H0Trzs5hg/AWfkcQkPmCZbxns+hqtPcM5allfgwq8wD/mLrGNHdyx
7hYNfHuLN3iNK+au0UzchDn8wAVSzM+gkPWd6EATmoPt0eBn1vqZOrsIxfoN
lsscLhm/YrxE/AuNxO+ZexfbnXS3Y+Kj2HJW7vvY8/+vBLuT7pZPXIBvxJOY
wjSeopT/lqM0tpyV+1+c4lOwvbTnBvEUvmMM48FqoFqoBqrFEhb9DJ21HPve
mCeu9/dYRBZxPXNlxM/xkvg39rGJLQxiACtYRStrWtCLPjwJViv1wEywnJRb
GmtYwE+/k+6WwITvqb0/ohtVqPYzN/0/iYc3wWPkIoNdr/mx30l3G8YIRoO9
/RpukMc4N9ib6e3SwXJXDdSbKeZmPWfl3hNbLVSTfuICvR2eoUTfg/Wy1rd7
DVSLbORgEAPec+q9El9bqV6KrSf0nuqp9WA5V/kZOmvc31Z3SvmaSu959f50
sNzU48XBaqLalOmdveZpr1HG5/StE124B+CcZ4s=
               "]], 
              
              PolygonBox[{{376, 121, 419, 539, 540}, {357, 356, 359, 46, 
               389}, {585, 584, 595, 133, 525}, {724, 723, 672, 154, 593}, {
               342, 341, 354, 45, 337}, {728, 727, 735, 177, 668}, {577, 134, 
               607, 590, 591}, {677, 142, 497, 627, 628}, {736, 178, 673, 732,
                733}, {665, 153, 669, 717, 718}, {624, 623, 252, 141, 674}, {
               340, 46, 359, 343, 344}, {349, 45, 354, 384, 385}, {543, 542, 
               495, 122, 422}}]}]}, {
            EdgeForm[], 
            RGBColor[
            0.8834594949572463, 0.6141870429562207, 0.29972349178232166`], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJxFlF1oz1EYx885TFMrEv3Na/Oy/WkpCcMmV27WiqXFhQsyltiLzEsyL9mK
mIW1yTTNrMhbSklJk1YulBTN2kpLqSUthHLj83i+5eLb5znnPL/n97yc369g
Z11lbQoh7EIT0NYYwjy4BRbBJWg1aonONlgLT6N6VBn/nxfJdzF6wroEPoKF
yZ+ZDO+gbuxx9tvl0wpXoNnYG2AnPh3YFbAcdWK/gBvRAeyVsFX7Z5M/b3Fu
w+d69nLyZ8ynHRagPdhD+PxGTdjL2XuPHmBHir+p3CzH66rrPpzI2UPsSfAz
zKBR1CP/engUtWEvgrmq5Yfqt9ys1oz6aX36xfqGxcd/u961Da5hfQq7GR5L
3uey5LlazkdgFhYGj3uX9UV4GBaj49jfidORPOcR2KI4Fi9Ped5L3q9/MaLX
b30YYv+Q4li8t5yVYQ/CWXAmWopWKU/L9w1npdivYE703DZFvytWl/VyVH2b
Ej1GVnGKWc+xeuAMNBd7qu0Rt9rqjd53q+UDe1+D5/EN9XK2Hr6D4zAffUHT
dIczsA/txp7Ps8PYNdgLkueSr3mUKJes7pPdmWtWn/K3+VSrV+ei99p63pR8
fjbHPtgsH/O9itZhX4CXdCftbu5gvRZ7H5yuXnxCT232sB8uVPxGWBH9eyqH
JzU7m+GA4r+GJ/Ree38OZ/ux/2Bf0Vy6YKPiN8Azqsvqy8W/wb47WJN81j3s
d+m7GIQHVeOt5PfJZvHR7qf6vzf5t2o1nocvVeMzuFkzrYI/g886L3rNVvuY
3SHNy/49VfJfFv3dlkN38u/Qcn4M64LfPavzL70phO8=
               "]], 
              PolygonBox[CompressedData["
1:eJwtlEtIVVEUhs/eNuitmdA781VXa2CU9vBmpVQo9PCSQdlEodIor0ZFENqD
RkHUoIkRFBU6cRpE4CAowaAHkRDRpCZBiIhFVBeq72etwcf59zr77LX22v8+
JR3ZTHdMkmQfzICjDNqgABbA2pAkS4gvgw3oSTiJ7oRP6HLm3EL3QyV6FbFi
SEElTBNfCsvhJzwgto1nHQygj2heYjmU6xRsRafhNnpusG9XQiH6ADn2e42q
9RvxxZ5jEiqI9fG8CWXoD57vHjyMVqNq1R60lws+1h4uowfhProeHvH+RrBa
t8A59LNgWrFRdH+0XMp5Hj2H2BrVAXvRw7AZvVo9RtdCDdTDdvU2WO1V0IYe
D5Zb+3/rczT3N+M/UIBe4ecxE93r9WyCa+pPsFwpyMFGasry7NV89D+ef6GB
eY1wN1gu5byInvCzWARfYUewXMrZorX9PFSzas95Lp1Bka+pteu0rnsg5XvW
3juooR1a4RA0QxPMg/mQhh7Wugp70Dm+OY2+ArWMx7xeeeQ5+nCwvctD8lJj
tLlZ33sNnElszbTnbPWcyl3ON2Xao/YF34OdZZf6FKzn6n0Tuhk+wgl/H9C7
YVewnqq3P/xs1MMpeOX+kQff+Rpaq0/egRH3uzzyRH6EY4nlKKG+Btjpnpf3
e6J5Wet1RvNMlX9/SV6P1rtueS7aGegsqmE9PPZ+yTNP0UPBvKpYBn3d/aqa
2tH5wbwgT8vbIdrd0Z35xfgL48+Qn4c38yxHtfdUvZ1NbBYshCLIMLdF5wgv
4Q4MwGt4A6PwwmN6dzDY3Zfn1qFLo/17jsOg/kXRvKs7ezbamXT5fdS/YBze
e07l/g/M5HfN
               "]], 
              PolygonBox[CompressedData["
1:eJwt0LsuBEAUxvFhKUhcCpfCur2AXue6Cp1HkNhuV0gUChKbUAlCZDchWZHo
CC9BQkGDhMojiILW7yRT/PN9883MOXNmfHl1qdqaUupDO9Yt1nCFC+u/lpS6
+S5MxZ6snw7KR/hJOooxfMpvZee0o5BSJ3rRgy/Znb02/iP7On3FG05QlzXo
PR7wrWZTdslXEA99wTOaudc7fcIjztCQLdIadrAQXrZHf9Rb4Yv8PF/CDX8k
28xzx/y7cVc2S+fiLIrODmECw/EH9DT3O8i9avls3NnP8xzTgajLl+g0ZvIs
MdMGDu1d0201t+I/+bLsl/8HRGAwjw==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9338269619987729, 0.7045674049969324, 0.3948635821961961], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtks8rhFEYhe/32VEjMrO3tVHWShGLKTXNn4D1TA1JFkMmlJKosbDzY2Fh
lFKSf0FhQUmSkpSUKIo0ntM9i9Nz7r3vnPu+d77usXKxlIYQ+lALWmCxCevw
FzXwV7CIDvHX8A3t4J/huWtUu4Hq+GF45pw1OIfW8TXY5X2d17zfC5/QNn4f
tiUhZPHt8ML5W/DPPTRhFk3iM8qkLqce0LQzq3CE/XH8B3wIMfPedaovsD/q
u3Rngd9M4QfTOKfuuoU/sBMNJPE+3ZuHy5oZPwsz7uEOzXt/Jo33Kb+V81O/
zyrsZ92BH4I9rlfejefV3CW/yXsSc5X/6PnV2yX8RHv41zS+u/IX0ziDZsnB
ZojvoPc4cKayv1hP6K3gC+td/BFccY76rbomn8Qz1RzD7yR+AxX8kv9TfTsV
fxsNeOLe1OM/+DlUUQ==
               "]], 
              PolygonBox[CompressedData["
1:eJwt1EtI1FEUx/H7v5llTTAzarYoSMgkyYUulILatKuomKA2tdHWtQwqypXt
NK3cJZSWZjZC9o6sLEcyEjOKHjstkibtob1D+/64Z/Fhruf+77n/e+75W1xz
ILXfO+d2IAdH+aOJ3zYcZLx4nnOLUIBCxIi1M9eMOsY/+f2BWOTcEuQjiSIs
wyRzn/ABE+hkzVnLP+FDTHNjGMcK1ixHIZbiK7EvlkO5eliTxgV04DrPXMNt
3MF7nnmHj8i68IyebWfuPC6jG9uwHbXM1WAXdqOSWAVWoUTPEzvnwpl19qyd
X7FJH2qks+hM3YzLWLMGVajGVZtXTY8x/s7vjJ1JZ1PNYlYz1e41XqFN+/hQ
A9UijgTGiY0hzl0kkEdsYRRyKneJvbtqqFpu0jritZhzIUfc1mitJ0eEN+R8
i83E9vFcEn8wjW92x7rrYuZX2hnL7I6LLKa5anJUYR3Wq5eIncAZtNod6C5e
4CW6cNHuRHdznzX3cBKnMJ93y0EuFmAvsT1IIIkZ1kxjFnPYSGwDVqMUjcQa
bA/t1YO09Yx6pxMdSGFnFPbU3hkM4jixejuDztKHu7iJW0bjK+jFEdYctnfQ
u7Ta2dO29wAeWY4+61n17gP02zukbE/tPYynGMVzlJNzrQ9n1tk94wi/GP9G
rmqGv4z/4QnjIWzBVh/20F4ZDEbhznX3+sb1rWft25nCZxdyKneFvg3LoVz9
eOjDM1PWI+qVUqt9nnJaD6uXu3AJh3z436Fv6IYPPaBeGMEzDOGx1WjAzjxq
34S+DfV83HpCvdFrtT+NFjtTxmo2bDVQLdST6s0We1Y90Wh7jtie2vs/dkKw
fg==
               "]], 
              PolygonBox[CompressedData["
1:eJwtz7ErhGEcwPHnXt0pA9GLjNaLdDcQKbujrhtY7pb7AxhIipVBSa4YbIzk
/AlEURhYlEk4ZptJ+cgzfPr+3t9z97y9g/XFykISQkjJcuPhmgNOPd/rY5yf
NNMWQsK8eY5plpz16wi75hUdYpgJxtlgz9mWjmVCGGWKHrtEA90yqQWK5MhS
ps9Zp77rG13mXn1hO97d0HMuOOGYL787dNYyFymwSsMur+2+JcezuWn3o6/h
/32p/7b0g474vlktMcOA3y7blbVKjR327TZ1jXUe4t0VveWOT47svt3TNJ9x
xeXft8Q7Uv0FGe0vYA==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[
            0.9702961771992638, 0.7957404429981594, 0.5079181493177176], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtk7dOA1EQRXfXJJOTSBIFBQ0lDSU5R8Ef8AHQ0/AFdPQ05CBAZJGxwQgj
gkAghES2ySKJWHFGb4qrc553d3Z23nNWc2tji2NZVh1xkQPbsmrhDtwl5fgx
bOemHnwSOqzj8TxYQ5LwSOgj1fga9JBS3A9DeGYSv4UXMJmE8/sMKcaX4RjX
JvAHOM+6Ep+GV6QKP4c3es8QXGBdIv3AelKAj8Cg9IRfQzeJwhPgK8/04u/w
lwzjf3CJDOCfcFa/cQKe8kwD/ghfYIS49KR1FmET1/LxftvMQmaSA5+kJ/wZ
/nDfEL4Jp7S+vCeKYXvwU/ybDOJex9SV+tJvAIaRS+1P+lyF5zBUvlHmZZu9
u4VnXPPiidQO6Kxkrhc6z0v4pj1ILy+6L7I/WVyLxdNgConBM8WptYFHw1jb
7F2Y3Osy75J3fsv+kw9yJ3sr306+9Lvk++70XN3DQ1KBb8NtnY8PnrEuxMdt
s5bfO2Gy1vHAOT0PS9KjzjAVZrOOw3PhJinDV+Rskmg8BqZz3zqeIdRzsiXn
UGfe5phaUjMNvkG3zJ7s65yPYLdj9vcEX9F96XDMu6UHS2rrGfPDMdZFeBcc
1ZkHYajOMAGG6P/IBXv07PU55nmpswdv9P8VgP/mDIN/
               "]], 
              PolygonBox[CompressedData["
1:eJwtlN1Pz1Ecx7/n+6VfKpGGsrnowljmYbnQsolSnh+GTTdc4Jp/IFdsGRfY
zCU3jIoRjaVGJAxjYczMY9KPilnlMfJ67/O5eO28z/mez+ec83n4Fm3fvXFX
HEXRZhgDD0MUrWVcDXfQTbAUXQlX0AOwHn0JejDsZb4OvQY+ol/4d/l4gn7m
3zfAKfQwDMEoRNgfYlyGrIZj6HLWFsNMmAWNsZ0lnyfRpbAQymAR3At2ts7o
Qs9nbR7MgbnwjrWV/p4P6EHGLMiEr/CYPV0QJ1GUQA7cZv0W5KJf6U6RxeA1
+jksj8znW3Sf+8pQPOAEaxWMS6ARPR5y/MwfihvzFYyroEX2wWKj+39Gn3f/
VXAcnehu8Av9G5o9XjrjQrA9VZ6fI+j7PpePR+h/2P6FUSWZ99wMFgvdvxV9
PZitbDrQ3YxjIQVpqPP8Kwab9N3jrfu/D5Yj5SoLsmO7Q6XHS7bDjOMgWyPz
AsiNLCb56LzEYq2Yd2N/VDlH10M7egGUQDHMhg5o4NtZ1Rx6H+z1nCv306AQ
tsI2vZ0zRoLVTKnXhGpjyGuxGCZGdqcidA3ftsBUKIDLXj+Kp3JzLdjbFYNO
z4lyU+J3PR1bPpu1H90GrapzOAztwWpdOWxD93g+1C9p9EH2HIAWuOo2sq2F
PfDJ+1P90B+sB8rcRrY3YoudYvgT/cbvq5p7iq5n7Qyk5ctjpFhNgnzYCTs8
BjV+Zq33ZLnnQLmog/3uQ76a4CL0Qx8MwBeYTH47VVuqAfQQa4O+R3tH4I/3
oHoxkz2pxGpWtZuCjNhyqFxOV0/hawLMUPxjqwXVxHed67WrmvsGD7zfFPO7
wf4x1R4P9WJesNqUzyno3thypxy+ZH4uWC+r3xpUv4m9RW8qTGytwvOpf9l/
nDen8w==
               "]], 
              PolygonBox[CompressedData["
1:eJwt0MsKAVEcx/G/GYwUiXkBr+QRPAB7GwuKjccgg41L5JKNWVhY2I9LSopC
LhtRfE/O4tPvf85/zmVOMp1NZQwRiSEAyydik1HSI1fo8EEbPVQZ38iurvNk
AUWYpogBj3pGL0It+DJeosXwZfz3VHvvEMQRG6wR5twE6SfjrHXVvUgLIZzU
2cztyTocuGgwZ5NjTFBGCTnU6PXJOZrUC/KND0YYoqL2ojcl73rNgHzgiQvO
OKh3oHdVtX6zrb67+ocf7PMzfg==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.8916492556792146, 0.6405923543985275], 
            GraphicsGroupBox[{
              PolygonBox[CompressedData["
1:eJwtk81LlFEUxt/3voIuqkVtzF27IJCgjdCif0GNyAgLw11RK91FLlwIbgLd
u1RxY2kzfozjjAaNTDH4ES40NcuPUUuKlBKVfofzLB5+z73vvefce859rz15
0fg8RFFUjxKUR4toGq1pbhutogpUGUdRWd7mZhnfs/UwRaBefBe8ysZlfHXi
sebRFPqs+JYnp3kbZ1EGleRL+rZL3Ga4BeuI+wp/hh9CDfi+2PfP68zvUBrN
oUesb4c18Iq8zTWhNnwrTLP/Lv4NnISf0LhYlJ+TH0PDWj8KqxXH4t1AHfhb
8IBvj/Fl2M24B38bfmf8EP8VbqAH+GWY4dsA/j1cYdyC3wme94PulFGdc7Hf
r6hzZXX3nGo7o3rmRBufsOeZ9ZKYFbH31Hp7ST26AF+qd6+D57TYKdVhQvky
8jZXDn6uweB1szr1o6rEc16Gp8F7Ugi+ztbvwT3VZx/+DJ7nIHh9i8oRMX4K
jljzL/h97OCbquE3eB48l+W8mPibSuC23swOzAY/1wSs1fu5GXydrV/AH+oM
dpYpvT2703X19A78o/P9hlvBe/Qj9poM6MxL6uk67FTfR+Ca3uoX+Fc58vBX
8F6+VeyU6p5WPa0WBfbchx9j73NJ/1FJ80V4HPwdnMD/KX6cow==
               "]], 
              PolygonBox[CompressedData["
1:eJwtkk9r00EQhnc3gRysHnqo1VtvgiBCoRR66GdQKaUUKXpV9BOIHjwIXoR6
71GPaTVJ/yRpq0ICCoIYRIQ2aqMmTbEtWm2o4vM6c3j5Pfvb2Zl3dmfo6s2L
N1IIYQRl0U4M4QrfGdSF19AEPInq8CaagqfRJ/hVtD39ewu/9LXOPIcrJH8M
P0RF+GO0s4pvwu1otS6jb/C9ZLF30Fn4s8dr/wv8zuurxmt41f1dQiX4gZ9X
zTK87fnV0we4FS2Xcm7Bx4i57vXOwPPRcl1AG3BfhprwezQADyeL1Zke+4F/
a3yeob/s5aLdo+60qRxAI1iOE8Q+YT0LP0KL8Bu0Dq+iI/gXKsNVdAD/RCse
X4V7yfZU8xDuoAJcQ/lkqnm/LXjQ/cvDSbg/Y14b7i3r8UX0Hd5Hi/Ay2oWX
k9WW5/vJPGu9hApwPZn3CvqtXpKxPMv76YzdnTycgjPcj19byAILxJSC9dBW
v/y7Bt9G51h/TdaLPMqrepB33dlx+E+0WJ3JsX8+2Vp+78JP/T01I2W4m6xX
9fgjWQ/qRR724HF/X83QLfiFz6/eRG/z/058vjTbc9FmRTXy8Ji/rzyMyr/P
m2awA/8DOTeERQ==
               "]]}]}, {
            EdgeForm[], 
            RGBColor[1., 0.95, 0.75], 
            GraphicsGroupBox[{
              PolygonBox[{{207, 205, 187}, {207, 188, 205}}]}]}}, {{}, 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{81, 83, 85, 87, 89, 91, 93, 95, 97, 199, 201, 203, 
               205}], 
              LineBox[{108, 128, 148, 168, 188}], 
              LineBox[{107, 127, 147, 167, 187}], 
              LineBox[{217, 215, 213, 211, 209, 207}]}, "0"], 
            Annotation[#, 0, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[{224, 263, 220, 233}], 
              LineBox[{230, 222, 260, 259}], 
              
              LineBox[{427, 415, 432, 436, 444, 448, 456, 460, 468, 479, 482, 
               483, 486, 487, 490, 491, 475, 743, 516, 751, 750, 748, 756, 
               754, 752, 701, 694, 648, 555, 563, 506, 515}], 
              
              LineBox[{477, 478, 433, 439, 447, 451, 459, 463, 471, 480, 481, 
               484, 485, 488, 489, 492, 493, 741, 688, 746, 681, 745, 690, 
               753, 693, 696, 691, 644, 560, 558, 501, 512}], 
              
              LineBox[{519, 509, 568, 571, 651, 698, 702, 757, 705, 760, 712, 
               764, 722, 771, 781, 791, 792, 793, 794}], 
              LineBox[{538, 606, 531}], 
              LineBox[{612, 600, 536}], 
              
              LineBox[{790, 780, 782, 734, 786, 776, 766, 768, 761, 762, 758, 
               759, 708, 700, 656, 637, 575, 552, 523}]}, 
             RowBox[{"-", "0.2`"}]], Annotation[#, -0.2, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{256, 306, 293, 285, 278, 273, 265, 245, 241, 237, 232, 
               227, 223, 221, 266, 332}], 
              
              LineBox[{258, 311, 298, 289, 280, 275, 269, 247, 243, 239, 235, 
               229, 225, 219, 270, 262}], 
              
              LineBox[{424, 339, 391, 401, 414, 431, 438, 443, 450, 455, 462, 
               467, 473, 676, 683, 740, 680, 744, 689, 692, 639, 643, 559, 
               557, 500, 511}], 
              LineBox[{535, 599, 611}], 
              
              LineBox[{739, 785, 773, 775, 765, 767, 720, 715, 588, 707, 532, 
               699, 655, 636, 574, 551, 522}], 
              
              LineBox[{335, 429, 426, 399, 406, 435, 441, 446, 453, 458, 465, 
               470, 421, 679, 687, 742, 749, 747, 755, 695, 634, 647, 554, 
               562, 505, 514}], 
              
              LineBox[{518, 508, 567, 570, 650, 697, 653, 704, 660, 711, 716, 
               763, 721, 770, 731, 779, 789}], 
              LineBox[{530, 605, 537}]}, 
             RowBox[{"-", "0.4`"}]], Annotation[#, -0.4, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{331, 333, 267, 271, 226, 231, 236, 240, 244, 264, 272, 
               277, 284, 292, 305, 316, 323, 255, 326, 498}], 
              
              LineBox[{334, 428, 425, 398, 405, 434, 440, 445, 452, 457, 464, 
               469, 420, 678, 686, 503, 626, 685, 524, 640, 632, 561, 504, 
               513}], 
              
              LineBox[{502, 382, 330, 250, 319, 310, 297, 288, 279, 274, 268, 
               246, 242, 238, 234, 228, 276, 251, 336, 261}], 
              
              LineBox[{510, 499, 556, 630, 638, 631, 684, 622, 496, 682, 675, 
               472, 466, 461, 454, 449, 442, 437, 430, 413, 400, 390, 338, 
               423}], 
              
              LineBox[{521, 550, 573, 635, 646, 642, 661, 706, 587, 714, 594, 
               725, 729, 774, 772, 784, 738}], 
              LineBox[{533, 526, 586, 598, 610}], 
              LineBox[{534, 578, 592, 604, 529}], 
              
              LineBox[{517, 507, 566, 569, 645, 581, 658, 703, 659, 710, 666, 
               719, 726, 769, 730, 778, 788}]}, 
             RowBox[{"-", "0.6`"}]], Annotation[#, -0.6, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{787, 777, 668, 728, 671, 718, 665, 709, 664, 589, 652, 
               580, 579, 564, 520, 576, 525, 585, 597, 609}], 
              
              LineBox[{528, 603, 591, 577, 582, 565, 572, 583, 641, 654, 649, 
               667, 713, 593, 724, 663, 733, 736, 783, 737}], 
              LineBox[{283, 291, 304, 315, 322, 254, 325, 540, 376, 545, 474, 
               257, 549, 547, 629, 621, 674, 624, 616, 418, 409, 397, 373, 
               369, 388, 385, 349, 345, 346, 299, 307, 320, 337, 342, 302, 
               283}], 
              
              LineBox[{287, 313, 344, 340, 300, 294, 281, 347, 383, 389, 357, 
               394, 353, 364, 404, 412, 379, 618, 628, 677, 625, 633, 548, 
               553, 494, 476, 546, 422, 543, 381, 329, 249, 318, 309, 296, 
               287}]}, 
             RowBox[{"-", "0.8`"}]], Annotation[#, -0.8, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              LineBox[{527, 602, 590, 607, 657, 672, 723, 662, 732, 673}], 
              LineBox[{735, 727, 670, 717, 669, 601, 595, 584, 596, 608}], 
              
              LineBox[{290, 282, 301, 341, 354, 384, 387, 368, 372, 396, 408, 
               417, 615, 623, 252, 614, 419, 539, 324, 253, 321, 314, 303, 
               290}], 
              
              LineBox[{497, 619, 495, 542, 380, 328, 248, 317, 308, 295, 286, 
               312, 343, 359, 356, 393, 352, 363, 403, 411, 378, 617, 627, 
               497}]}, 
             RowBox[{"-", "1"}]], Annotation[#, -1, "Tooltip"]& ], 
           TagBox[
            TooltipBox[{
              Directive[
               GrayLevel[0], 
               Opacity[0.5], 
               CapForm["Butt"]], 
              
              LineBox[{544, 327, 374, 365, 358, 350, 366, 392, 351, 362, 402, 
               410, 377, 620, 544}], 
              
              LineBox[{348, 355, 361, 370, 375, 541, 613, 416, 407, 395, 371, 
               367, 386, 360, 348}]}, 
             RowBox[{"-", "1.2`"}]], 
            Annotation[#, -1.2, "Tooltip"]& ], {}, {}}}], {
        DisplayFunction -> Identity, AspectRatio -> 1, DisplayFunction :> 
         Identity, Frame -> True, FrameLabel -> {{
            FormBox["\"\[Alpha]\"", TraditionalForm], None}, {
            FormBox["\"k\"", TraditionalForm], None}}, FrameTicks -> {{{{0, 
              FormBox[
               GraphicsBox[{
                 Thickness[0.08984725965858043], 
                 StyleBox[{
                   
                   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKA0GG5Qc5ixS3vlHXdcBxhft8XrFMkXfIT0NCJYp
OUyfwF9ldtvQofr+j1vGvxUcVrzw0PtfaOwgUjmp5CyLvMPXnbe6/l41cWhR
YFc9EyLlcEe6JtEo1NTBxBgExOD84LeXP85IFILz/Z94XjIV5na4BeI/NXHQ
+KTychYnq8MNoU+O58uMHa78PnZ9XuRf+5kg8NMQqv6PfcGa7tsZCgZwPsz9
ML7/xYkx/x5rOaSC3J/2x/5J4sJrJvnqDtIbxeYzKTA7JIQEqS/IVHG4zntb
LPUbp0OnjeeutCAFB7A9ksIO24OtIv63y8PdD+O/acvtNrotCefXgMIjW95B
GBQOLQqQ8ApTdJgBCi9vFQf3NUeXM3QoOdT+tio4x6EOD98HEeLbLzpoOaCH
/978mrczVRUcGliO9htOR/DFp17hzGDShvMz8j+0nryi7vBl38et6WHyDlPa
W6Mu16g6VIDcs1oWYq+GosNrkHt/S0DclaYA9w+MH60aIXNORhDO743o9mc0
4IHYM1UJHj4Xroa90Z+tCuGbcUDM+awO57/I0v42PVYbzoe5H8YHWxtsAOfX
g8JjhqFDg3gta6YblwM4fs4bOZw9AwQ+vA4TgktUptebwONjyf19fHOYEekJ
xm8FpbcSSTgf5v8t5j8OpVSZOMjvWrAvVU/eQeMt7z6Dm0aQ9Cut4PB5Q0D2
rO2G8PA83LY8/FSSAUb4AwB3WkWc
                    "]]}, 
                  Thickness[0.08984725965858043], StripOnInput -> False]}, {
                ImageSize -> {11.130709838107098`, 25.902864259028643`}, 
                 BaselinePosition -> Scaled[0.31538730769230766`], 
                 ImageSize -> {12., 26.}, 
                 PlotRange -> {{0., 11.129999999999999`}, {0., 25.9}}, 
                 AspectRatio -> Automatic}], TraditionalForm]}, {0.5, 
              FormBox[
               GraphicsBox[{
                 Thickness[0.038925652004671074`], 
                 StyleBox[{
                   
                   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKA0GG5Qc5ixS3vlHXdcBxhft8XrFMkXfIT0NCJYp
OUyfwF9ldtvQofr+j1vGvxUcVrzw0PtfaOwgUjmp5CyLvMPXnbe6/l41cWhR
YFc9EyLlcEe6JtEo1NTBxBgExOD84LeXP85IFILz/Z94XjIV5na4BeI/NXHQ
+KTychYnq8MNoU+O58uMHa78PnZ9XuRf+5kg8NMQqv6PfcGa7tsZCgZwPsz9
ML7/xYkx/x5rOaSC3J/2x/5J4sJrJvnqDtIbxeYzKTA7JIQEqS/IVHG4zntb
LPUbp0OnjeeutCAFB7A9ksIO24OtIv63y8PdD+O/acvtNrotCefXgMIjW95B
GBQOLQqQ8ApTdJgBCi9vFQf3NUeXM3QoOdT+tio4x6EOD98HEeLbLzpoOaCH
/978mrczVRUcGliO9htOR/DFp17hzGDShvMz8j+0nryi7vBl38et6WHyDlPa
W6Mu16g6VIDcs1oWYq+GosNrkHt/S0DclaYA9w+MH60aIXNORhDO743o9mc0
4IHYM1UJHj4Xroa90Z+tCuGbcUDM+awO57/I0v42PVYbzoe5H8YHWxtsAOfX
g8JjhqFDg3gta6YblwM4fs4bOZw9AwQ+vA4TgktUptebwONjyf19fHOYEekJ
xm8FpbcSSTgf5v8t5j8OpVSZOMjvWrAvVU/eQeMt7z6Dm0aQ9Cut4PB5Q0D2
rO2G8PA83LY8/FSSAUb4AwB3WkWc
                    "]], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}}, {{{13.756299999999996`, 9.153129999999999}, {
                    13.756299999999996`, 9.72969}, {13.278100000000002`, 
                    10.1266}, {12.8016, 10.1266}, {12.2266, 10.1266}, {
                    11.8281, 9.649999999999999}, {11.8281, 9.17344}, {11.8281,
                     8.596879999999999}, {12.3047, 8.200000000000001}, {
                    12.782799999999998`, 8.200000000000001}, {
                    13.357799999999997`, 8.200000000000001}, {
                    13.756299999999996`, 8.67656}, {13.756299999999996`, 
                    9.153129999999999}}}], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}}}, CompressedData["
1:eJx1lAtIFFEUhkeTJEpLS4wEH227bunuzuw8hEo4RpaYprhUIlFstWpm2UOR
bCEsTEhNDR+lIUXEFig9MJUgoRZLWyPtIaYFYkYR9tIQ6WVz7zhnQOjA5fLN
3Jlzzn//eyP25KU55jEM4yWPBHl4y2N57csF2aMx4OmVI9cIKv+eKhi5xJkg
qds3tnGbBK6PCeaZIyz4pdyscWQLyMMhTrvVwSO3xkw/3HfWCmWJn3yEABY+
5ERN1b/lYFm5/KDVjEzzPOfhcHPZcPYSK3jcG1r2d/IQ0rRrtWfECrfNh656
OXnIypSjjUc+Z8tfVV8pIj8449rx5Lyk5C0SgCzPNMRAenB7P+MvItNZ0pgh
kSrCxK3UAw2+Gn+fw4tIv9MSMp37JIg7Nfr4wjpRyRMqwZj9yoDwVYDY4+nX
xWRR6e+OAPl3g355tgrIaj8q/yE691thMHAi7tkjQdF3kMN6qT6XOcxPda3+
P0+S+gs1dhN9jnJgGDvd9DRR4yGyb+8FZMuaG0v7NpqRW/TyBxUmZCcRKsME
W4gfrml8jPTXqbHxs18n28MpeuSZIJj6iYPoiLAfuW0meE3yllhhhsRJC/qH
9hnOgsDLsVdAfkPeB4nI6n6L6++n1dktyLSuWiNy972OivmpkchUb2+94pOf
IrQERvtnmXVQV7W4SDohQqG7Lf5iRQSwRIdWATY3d7mYjnBYuElf4D3EI6v+
VpnmFTnQDYzamPKVs+tZ6Hu1fdzSqIce4usvLKwgvq7SQ7FPVyUXzEFNaUnG
C6ce6kn+KI3p+TioMTmWveMcJPdX7/zr1jiUHjgDMvVRgFE5F+UcSESfYiP+
X2XFfywyrTdnVvfJSGS6XwMG5JH43XENdh3ub7ttbfpMaRikkLre8cjUd99E
ZPU+oXUm6WDuffMPoiHU6g==
                    "]]}, 
                  Thickness[0.038925652004671074`], StripOnInput -> False]}, {
                ImageSize -> {25.688338729763384`, 25.902864259028643`}, 
                 BaselinePosition -> Scaled[0.31538730769230766`], 
                 ImageSize -> {26., 26.}, 
                 PlotRange -> {{0., 25.69}, {0., 25.9}}, AspectRatio -> 
                 Automatic}], TraditionalForm]}, {1, 
              FormBox[
               GraphicsBox[{
                 Thickness[0.08984725965858043], 
                 StyleBox[{
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
                    0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI5IGYC4m4bz11pTooO6WkgoOAA44dzirUb5ys6rPj2
suKMgAKcfwYEfCTh/APd+5pMlCUd1grp8KXfQ/Ah6pTh/FvSNYlGT03gfAYQ
CDB16Ivo9mcUkHS4A5IPNXUwMQaCz+Jw/qyZQHBTxOHrzltdf1NNHHYEW0X8
VxdwAAnPlDRx4HLk85qRye7QF1yiMp3fxGECyLwPbHA+2FtqCH6UaoTMuT+s
Dl4n2G1ns5o4BDzxvGR6mdVh+gT+KrPfxnB+j9crFpOPCD44fNqMHf6DwH4u
OP8gyD/Ngg4GWiuFLywxhvhng4hDyVbR36flTOB8WHjA+B8WrVc4+0LRYSfI
P+0iqOGZzA3ny2wUm8+0gA2DD4svjU8qL2e9FHNwntAslFaFiD+YPACxUrly

                    "]]}, 
                  Thickness[0.08984725965858043], StripOnInput -> False]}, {
                ImageSize -> {11.130709838107098`, 25.902864259028643`}, 
                 BaselinePosition -> Scaled[0.31538730769230766`], 
                 ImageSize -> {12., 26.}, 
                 PlotRange -> {{0., 11.129999999999999`}, {0., 25.9}}, 
                 AspectRatio -> Automatic}], TraditionalForm]}}, None}, {{{0, 
              FormBox[
               GraphicsBox[{
                 Thickness[0.08984725965858043], 
                 StyleBox[{
                   
                   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKA0GG5Qc5ixS3vlHXdcBxhft8XrFMkXfIT0NCJYp
OUyfwF9ldtvQofr+j1vGvxUcVrzw0PtfaOwgUjmp5CyLvMPXnbe6/l41cWhR
YFc9EyLlcEe6JtEo1NTBxBgExOD84LeXP85IFILz/Z94XjIV5na4BeI/NXHQ
+KTychYnq8MNoU+O58uMHa78PnZ9XuRf+5kg8NMQqv6PfcGa7tsZCgZwPsz9
ML7/xYkx/x5rOaSC3J/2x/5J4sJrJvnqDtIbxeYzKTA7JIQEqS/IVHG4zntb
LPUbp0OnjeeutCAFB7A9ksIO24OtIv63y8PdD+O/acvtNrotCefXgMIjW95B
GBQOLQqQ8ApTdJgBCi9vFQf3NUeXM3QoOdT+tio4x6EOD98HEeLbLzpoOaCH
/978mrczVRUcGliO9htOR/DFp17hzGDShvMz8j+0nryi7vBl38et6WHyDlPa
W6Mu16g6VIDcs1oWYq+GosNrkHt/S0DclaYA9w+MH60aIXNORhDO743o9mc0
4IHYM1UJHj4Xroa90Z+tCuGbcUDM+awO57/I0v42PVYbzoe5H8YHWxtsAOfX
g8JjhqFDg3gta6YblwM4fs4bOZw9AwQ+vA4TgktUptebwONjyf19fHOYEekJ
xm8FpbcSSTgf5v8t5j8OpVSZOMjvWrAvVU/eQeMt7z6Dm0aQ9Cut4PB5Q0D2
rO2G8PA83LY8/FSSAUb4AwB3WkWc
                    "]]}, 
                  Thickness[0.08984725965858043], StripOnInput -> False]}, {
                ImageSize -> {11.130709838107098`, 25.902864259028643`}, 
                 BaselinePosition -> Scaled[0.31538730769230766`], 
                 ImageSize -> {12., 26.}, 
                 PlotRange -> {{0., 11.129999999999999`}, {0., 25.9}}, 
                 AspectRatio -> Automatic}], TraditionalForm]}, {0.5, 
              FormBox[
               GraphicsBox[{
                 Thickness[0.038925652004671074`], 
                 StyleBox[{
                   
                   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{1, 4, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJJKA0GG5Qc5ixS3vlHXdcBxhft8XrFMkXfIT0NCJYp
OUyfwF9ldtvQofr+j1vGvxUcVrzw0PtfaOwgUjmp5CyLvMPXnbe6/l41cWhR
YFc9EyLlcEe6JtEo1NTBxBgExOD84LeXP85IFILz/Z94XjIV5na4BeI/NXHQ
+KTychYnq8MNoU+O58uMHa78PnZ9XuRf+5kg8NMQqv6PfcGa7tsZCgZwPsz9
ML7/xYkx/x5rOaSC3J/2x/5J4sJrJvnqDtIbxeYzKTA7JIQEqS/IVHG4zntb
LPUbp0OnjeeutCAFB7A9ksIO24OtIv63y8PdD+O/acvtNrotCefXgMIjW95B
GBQOLQqQ8ApTdJgBCi9vFQf3NUeXM3QoOdT+tio4x6EOD98HEeLbLzpoOaCH
/978mrczVRUcGliO9htOR/DFp17hzGDShvMz8j+0nryi7vBl38et6WHyDlPa
W6Mu16g6VIDcs1oWYq+GosNrkHt/S0DclaYA9w+MH60aIXNORhDO743o9mc0
4IHYM1UJHj4Xroa90Z+tCuGbcUDM+awO57/I0v42PVYbzoe5H8YHWxtsAOfX
g8JjhqFDg3gta6YblwM4fs4bOZw9AwQ+vA4TgktUptebwONjyf19fHOYEekJ
xm8FpbcSSTgf5v8t5j8OpVSZOMjvWrAvVU/eQeMt7z6Dm0aQ9Cut4PB5Q0D2
rO2G8PA83LY8/FSSAUb4AwB3WkWc
                    "]], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}}, {{{13.756299999999996`, 9.153129999999999}, {
                    13.756299999999996`, 9.72969}, {13.278100000000002`, 
                    10.1266}, {12.8016, 10.1266}, {12.2266, 10.1266}, {
                    11.8281, 9.649999999999999}, {11.8281, 9.17344}, {11.8281,
                     8.596879999999999}, {12.3047, 8.200000000000001}, {
                    12.782799999999998`, 8.200000000000001}, {
                    13.357799999999997`, 8.200000000000001}, {
                    13.756299999999996`, 8.67656}, {13.756299999999996`, 
                    9.153129999999999}}}], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {1, 3, 3}}}, CompressedData["
1:eJx1lAtIFFEUhkeTJEpLS4wEH227bunuzuw8hEo4RpaYprhUIlFstWpm2UOR
bCEsTEhNDR+lIUXEFig9MJUgoRZLWyPtIaYFYkYR9tIQ6WVz7zhnQOjA5fLN
3Jlzzn//eyP25KU55jEM4yWPBHl4y2N57csF2aMx4OmVI9cIKv+eKhi5xJkg
qds3tnGbBK6PCeaZIyz4pdyscWQLyMMhTrvVwSO3xkw/3HfWCmWJn3yEABY+
5ERN1b/lYFm5/KDVjEzzPOfhcHPZcPYSK3jcG1r2d/IQ0rRrtWfECrfNh656
OXnIypSjjUc+Z8tfVV8pIj8449rx5Lyk5C0SgCzPNMRAenB7P+MvItNZ0pgh
kSrCxK3UAw2+Gn+fw4tIv9MSMp37JIg7Nfr4wjpRyRMqwZj9yoDwVYDY4+nX
xWRR6e+OAPl3g355tgrIaj8q/yE691thMHAi7tkjQdF3kMN6qT6XOcxPda3+
P0+S+gs1dhN9jnJgGDvd9DRR4yGyb+8FZMuaG0v7NpqRW/TyBxUmZCcRKsME
W4gfrml8jPTXqbHxs18n28MpeuSZIJj6iYPoiLAfuW0meE3yllhhhsRJC/qH
9hnOgsDLsVdAfkPeB4nI6n6L6++n1dktyLSuWiNy972OivmpkchUb2+94pOf
IrQERvtnmXVQV7W4SDohQqG7Lf5iRQSwRIdWATY3d7mYjnBYuElf4D3EI6v+
VpnmFTnQDYzamPKVs+tZ6Hu1fdzSqIce4usvLKwgvq7SQ7FPVyUXzEFNaUnG
C6ce6kn+KI3p+TioMTmWveMcJPdX7/zr1jiUHjgDMvVRgFE5F+UcSESfYiP+
X2XFfywyrTdnVvfJSGS6XwMG5JH43XENdh3ub7ttbfpMaRikkLre8cjUd99E
ZPU+oXUm6WDuffMPoiHU6g==
                    "]]}, 
                  Thickness[0.038925652004671074`], StripOnInput -> False]}, {
                ImageSize -> {25.688338729763384`, 25.902864259028643`}, 
                 BaselinePosition -> Scaled[0.31538730769230766`], 
                 ImageSize -> {26., 26.}, 
                 PlotRange -> {{0., 25.69}, {0., 25.9}}, AspectRatio -> 
                 Automatic}], TraditionalForm]}, {1, 
              FormBox[
               GraphicsBox[{
                 Thickness[0.08984725965858043], 
                 StyleBox[{
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
                    0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGI5IGYC4m4bz11pTooO6WkgoOAA44dzirUb5ys6rPj2
suKMgAKcfwYEfCTh/APd+5pMlCUd1grp8KXfQ/Ah6pTh/FvSNYlGT03gfAYQ
CDB16Ivo9mcUkHS4A5IPNXUwMQaCz+Jw/qyZQHBTxOHrzltdf1NNHHYEW0X8
VxdwAAnPlDRx4HLk85qRye7QF1yiMp3fxGECyLwPbHA+2FtqCH6UaoTMuT+s
Dl4n2G1ns5o4BDzxvGR6mdVh+gT+KrPfxnB+j9crFpOPCD44fNqMHf6DwH4u
OP8gyD/Ngg4GWiuFLywxhvhng4hDyVbR36flTOB8WHjA+B8WrVc4+0LRYSfI
P+0iqOGZzA3ny2wUm8+0gA2DD4svjU8qL2e9FHNwntAslFaFiD+YPACxUrly

                    "]]}, 
                  Thickness[0.08984725965858043], StripOnInput -> False]}, {
                ImageSize -> {11.130709838107098`, 25.902864259028643`}, 
                 BaselinePosition -> Scaled[0.31538730769230766`], 
                 ImageSize -> {12., 26.}, 
                 PlotRange -> {{0., 11.129999999999999`}, {0., 25.9}}, 
                 AspectRatio -> Automatic}], TraditionalForm]}}, None}}, 
         GridLinesStyle -> Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 350, 
         Method -> {"DefaultBoundaryStyle" -> Automatic}, 
         PlotRange -> {{0, 1}, {0, 1}}, PlotRangeClipping -> True, 
         PlotRangePadding -> {Automatic, Automatic}, RotateLabel -> False, 
         Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   StyleBox[
                   "\"Binary batch\\nwork infimum \[Eta]\"", {
                    FontFamily -> "Arial"}, Background -> Automatic, 
                    StripOnInput -> False]}, {
                   GraphicsBox[{{}, {}, 
                    
                    RasterBox[{{{0.148, 0.33, 0.54}}, {{0.4268649206471011, 
                    0.45372249607406107`, 0.5681369156579342}}, {{
                    0.6551622078021736, 0.5339547695151409, 
                    0.433930203720128}}, {{0.8834594949572463, 
                    0.6141870429562207, 0.29972349178232166`}}, {{
                    0.9338269619987729, 0.7045674049969324, 
                    0.3948635821961961}}, {{0.9702961771992638, 
                    0.7957404429981594, 0.5079181493177175}}, {{1., 
                    0.8916492556792146, 0.6405923543985275}}}, {{
                    Rational[-15, 2], -175}, {
                    Rational[15, 2], 175}}], {Antialiasing -> False, 
                    AbsoluteThickness[0.1], 
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]], 
                    LineBox[
                    NCache[{{
                    Rational[15, 2], -175}, {
                    Rational[-15, 2], -175}, {
                    Rational[-15, 2], 175}, {
                    Rational[15, 2], 175}, {
                    Rational[15, 2], -175}}, {{
                    7.5, -175}, {-7.5, -175}, {-7.5, 175}, {7.5, 175}, {
                    7.5, -175}}]]}, {
                    CapForm[None], {{
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -125.}, {
                    Rational[15, 2], -125.}}, {{-7.5, -125.}, {
                    7.5, -125.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -75.}, {
                    Rational[15, 2], -75.}}, {{-7.5, -75.}, {7.5, -75.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], -25.}, {
                    Rational[15, 2], -25.}}, {{-7.5, -25.}, {7.5, -25.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 25.}, {
                    Rational[15, 2], 25.}}, {{-7.5, 25.}, {7.5, 25.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 75.}, {
                    Rational[15, 2], 75.}}, {{-7.5, 75.}, {7.5, 75.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 125.}, {
                    Rational[15, 2], 125.}}, {{-7.5, 125.}, {7.5, 125.}}]]}, {
                    Directive[
                    GrayLevel[0], 
                    Opacity[0.5], 
                    CapForm["Butt"]], 
                    CapForm["Butt"], 
                    LineBox[
                    NCache[{{
                    Rational[-15, 2], 175.}, {
                    Rational[15, 2], 175.}}, {{-7.5, 175.}, {7.5, 
                    175.}}]]}}}, {Antialiasing -> False, 
                    StyleBox[
                    LineBox[{{7.5, -175.}, {7.5, 175.}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[
                    LineBox[{{{7.5, -125.00000000000001`}, 
                    Offset[{4., 0}, {7.5, -125.00000000000001`}]}, {{
                    7.5, -74.99999999999999}, 
                    Offset[{4., 0}, {7.5, -74.99999999999999}]}, {{
                    7.5, -25.00000000000001}, 
                    Offset[{4., 0}, {7.5, -25.00000000000001}]}, {{7.5, 
                    24.99999999999999}, 
                    Offset[{4., 0}, {7.5, 24.99999999999999}]}, {{7.5, 
                    74.99999999999999}, 
                    Offset[{4., 0}, {7.5, 74.99999999999999}]}, {{7.5, 125.}, 
                    Offset[{4., 0}, {7.5, 125.}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                    StyleBox[
                    StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "1.2`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -125.00000000000001`}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -74.99999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "0.8`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, -25.00000000000001}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 24.99999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    RowBox[{"-", "0.4`"}], TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 74.99999999999999}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["\"\"", TraditionalForm], 
                    Offset[{7., 0.}, {7.5, 125.}], 
                    ImageScaled[{0, 0.5}], Automatic, {1, 0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False]}, {}}, {
                    Directive[
                    Opacity[1]]}, StripOnInput -> False], "GraphicsLabel", 
                    StripOnInput -> False]}, "GraphicsTicks", StripOnInput -> 
                    False], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    Opacity[0.3], 
                    GrayLevel[0]], StripOnInput -> False]}}, PlotRangePadding -> 
                    Scaled[0.02], PlotRange -> All, Frame -> True, 
                    FrameTicks -> {{False, False}, {True, False}}, FrameStyle -> 
                    Opacity[0], FrameTicksStyle -> Opacity[0], 
                    ImageSize -> {Automatic, 350}, BaseStyle -> {}]}}, 
                 GridBoxAlignment -> {"Columns" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]}, "BarLegend", DisplayFunction -> (#& ),
           InterpretationFunction :> (RowBox[{"BarLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"Blend", "[", 
                    RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                    "]"}], "&"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1.3710193577`"}], ",", "0.`"}], "}"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1.2`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1.`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.8`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.6`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.4`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.2`"}], ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0.`", ",", 
                    RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                    Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                    Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               
               RowBox[{
                "LegendLabel", "\[Rule]", 
                 "\"Binary batch\\nwork infimum \[Eta]\""}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}], ",", 
               RowBox[{"LegendMarkerSize", "\[Rule]", "350"}], ",", 
               RowBox[{"Ticks", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1.2`"}], ",", 
                    RowBox[{"-", "1.2`"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.8`"}], ",", 
                    RowBox[{"-", "0.8`"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.6`"}], ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.4`"}], ",", 
                    RowBox[{"-", "0.4`"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "0.2`"}], ",", "\"\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], ",", 
               RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
               RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
               RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], 
             "]"}]& )], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.74522276003131*^9, {3.7452291529014544`*^9, 3.7452291639807453`*^9}, 
   3.7487869485256634`*^9, 3.7530207939250603`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<fluctuationsplot.pdf\>\"", ",", "fluctuationsplot"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.745222786159165*^9, 3.7452227915035105`*^9}}],

Cell[BoxData["\<\"fluctuationsplot.pdf\"\>"], "Output",
 CellChangeTimes->{3.745222794003725*^9, 3.745229174935051*^9, 
  3.748786977817571*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1520, 805},
WindowMargins->{{-8, Automatic}, {Automatic, 0}},
Magnification:>1.5 Inherited,
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    StyleData["Text"], FontColor -> RGBColor[0.5, 0, 0.5]]}, Visible -> False,
   FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 92, 2, 45, "Input"],
Cell[653, 24, 135, 1, 45, "Text"],
Cell[791, 27, 104, 2, 45, "Input"],
Cell[CellGroupData[{
Cell[920, 33, 160, 2, 150, "Title"],
Cell[1083, 37, 144, 1, 45, "Text"],
Cell[CellGroupData[{
Cell[1252, 42, 309, 6, 45, "Input"],
Cell[1564, 50, 221, 4, 45, "Output"]
}, Open  ]],
Cell[1800, 57, 251, 5, 45, "Text"],
Cell[2054, 64, 794, 15, 104, "Input"],
Cell[CellGroupData[{
Cell[2873, 83, 227, 4, 45, "Input"],
Cell[3103, 89, 121, 2, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3261, 96, 3866, 86, 423, "Input"],
Cell[7130, 184, 309394, 5378, 564, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[316561, 5567, 196, 4, 45, "Input"],
Cell[316760, 5573, 147, 2, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[316956, 5581, 204, 3, 150, "Title"],
Cell[CellGroupData[{
Cell[317185, 5588, 92, 1, 108, "Chapter"],
Cell[317280, 5591, 281, 5, 45, "Text"],
Cell[317564, 5598, 1843, 63, 82, "Input"],
Cell[319410, 5663, 375, 9, 74, "Text"],
Cell[319788, 5674, 1475, 38, 162, "Input"],
Cell[321266, 5714, 118, 1, 45, "Text"],
Cell[321387, 5717, 172, 3, 45, "Input"],
Cell[321562, 5722, 121, 1, 45, "Text"],
Cell[CellGroupData[{
Cell[321708, 5727, 253, 5, 45, "Input"],
Cell[321964, 5734, 156, 2, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[322157, 5741, 4598, 95, 481, "Input"],
Cell[326758, 5838, 134709, 2429, 550, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[461516, 8273, 92, 1, 108, "Chapter"],
Cell[461611, 8276, 184, 3, 45, "Text"],
Cell[CellGroupData[{
Cell[461820, 8283, 230, 4, 45, "Input"],
Cell[462053, 8289, 96, 1, 45, "Output"]
}, Open  ]],
Cell[462164, 8293, 289, 6, 45, "Text"],
Cell[462456, 8301, 1120, 20, 162, "Input"],
Cell[CellGroupData[{
Cell[463601, 8325, 258, 5, 45, "Input"],
Cell[463862, 8332, 70, 1, 45, "Output"]
}, Open  ]],
Cell[463947, 8336, 340, 9, 45, "Text"],
Cell[CellGroupData[{
Cell[464312, 8349, 4076, 95, 539, "Input"],
Cell[468391, 8446, 142860, 2558, 550, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[611300, 11010, 92, 1, 108, "Chapter"],
Cell[611395, 11013, 197, 2, 45, "Text"],
Cell[CellGroupData[{
Cell[611617, 11019, 208, 4, 45, "Input"],
Cell[611828, 11025, 96, 1, 45, "Output"]
}, Open  ]],
Cell[611939, 11029, 303, 6, 45, "Text"],
Cell[612245, 11037, 935, 16, 133, "Input"],
Cell[613183, 11055, 119, 2, 45, "Input"],
Cell[CellGroupData[{
Cell[613327, 11061, 183, 3, 45, "Input"],
Cell[613513, 11066, 72, 1, 45, "Output"]
}, Open  ]],
Cell[613600, 11070, 485, 10, 74, "Text"],
Cell[614088, 11082, 1207, 30, 162, "Input"],
Cell[CellGroupData[{
Cell[615320, 11116, 209, 4, 45, "Input"],
Cell[615532, 11122, 145, 2, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[615714, 11129, 3429, 77, 481, "Input"],
Cell[619146, 11208, 45102, 878, 558, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[664297, 12092, 90, 1, 108, "Chapter"],
Cell[664390, 12095, 214, 3, 45, "Text"],
Cell[CellGroupData[{
Cell[664629, 12102, 295, 5, 45, "Input"],
Cell[664927, 12109, 121, 2, 45, "Output"]
}, Open  ]],
Cell[665063, 12114, 321, 6, 45, "Text"],
Cell[665387, 12122, 1081, 18, 133, "Input"],
Cell[CellGroupData[{
Cell[666493, 12144, 237, 4, 45, "Input"],
Cell[666733, 12150, 72, 1, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[666842, 12156, 2985, 65, 510, "Input"],
Cell[669830, 12223, 323279, 5465, 510, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[993158, 17694, 101, 1, 108, "Chapter"],
Cell[CellGroupData[{
Cell[993284, 17699, 783, 17, 133, "Input"],
Cell[994070, 17718, 648951, 11335, 1094, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1643058, 29058, 296, 6, 45, "Input"],
Cell[1643357, 29066, 263, 3, 45, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1643681, 29076, 188, 3, 150, "Title"],
Cell[CellGroupData[{
Cell[1643894, 29083, 90, 1, 108, "Chapter"],
Cell[1643987, 29086, 199, 2, 45, "Text"],
Cell[CellGroupData[{
Cell[1644211, 29092, 216, 4, 45, "Input"],
Cell[1644430, 29098, 96, 1, 45, "Output"]
}, Open  ]],
Cell[1644541, 29102, 329, 6, 45, "Text"],
Cell[1644873, 29110, 801, 15, 133, "Input"],
Cell[CellGroupData[{
Cell[1645699, 29129, 223, 4, 45, "Input"],
Cell[1645925, 29135, 70, 1, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1646032, 29141, 2765, 62, 510, "Input"],
Cell[1648800, 29205, 307742, 5097, 495, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1956591, 34308, 90, 1, 108, "Chapter"],
Cell[1956684, 34311, 206, 3, 45, "Text"],
Cell[CellGroupData[{
Cell[1956915, 34318, 224, 4, 45, "Input"],
Cell[1957142, 34324, 94, 1, 45, "Output"]
}, Open  ]],
Cell[1957251, 34328, 358, 7, 45, "Text"],
Cell[1957612, 34337, 786, 14, 133, "Input"],
Cell[CellGroupData[{
Cell[1958423, 34355, 176, 3, 45, "Input"],
Cell[1958602, 34360, 72, 1, 45, "Output"]
}, Open  ]],
Cell[1958689, 34364, 530, 11, 74, "Text"],
Cell[1959222, 34377, 1305, 32, 162, "Input"],
Cell[CellGroupData[{
Cell[1960552, 34413, 211, 4, 45, "Input"],
Cell[1960766, 34419, 264, 6, 57, "Message"],
Cell[1961033, 34427, 297, 7, 35, "Message"],
Cell[1961333, 34436, 262, 6, 57, "Message"],
Cell[1961598, 34444, 299, 7, 35, "Message"],
Cell[1961900, 34453, 264, 6, 57, "Message"],
Cell[1962167, 34461, 342, 7, 35, "Message"],
Cell[1962512, 34470, 299, 7, 35, "Message"],
Cell[1962814, 34479, 344, 7, 35, "Message"],
Cell[1963161, 34488, 136, 2, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1963334, 34495, 2964, 69, 452, "Input"],
Cell[1966301, 34566, 55913, 1044, 550, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2022263, 35616, 92, 1, 108, "Chapter"],
Cell[2022358, 35619, 203, 3, 45, "Text"],
Cell[CellGroupData[{
Cell[2022586, 35626, 217, 4, 45, "Input"],
Cell[2022806, 35632, 94, 1, 45, "Output"]
}, Open  ]],
Cell[2022915, 35636, 381, 7, 45, "Text"],
Cell[2023299, 35645, 1127, 20, 162, "Input"],
Cell[CellGroupData[{
Cell[2024451, 35669, 195, 3, 45, "Input"],
Cell[2024649, 35674, 72, 1, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2024758, 35680, 2962, 69, 452, "Input"],
Cell[2027723, 35751, 75628, 1453, 550, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2103400, 37210, 101, 1, 108, "Chapter"],
Cell[CellGroupData[{
Cell[2103526, 37215, 525, 11, 45, "Input"],
Cell[2104054, 37228, 441510, 7596, 551, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2545601, 44829, 192, 4, 45, "Input"],
Cell[2545796, 44835, 192, 2, 45, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2546049, 44844, 127, 2, 150, "Title"],
Cell[CellGroupData[{
Cell[2546201, 44850, 90, 1, 108, "Chapter"],
Cell[2546294, 44853, 961, 19, 188, "Text"],
Cell[2547258, 44874, 8141, 182, 1048, "Input"],
Cell[CellGroupData[{
Cell[2555424, 45060, 3289, 82, 394, "Input"],
Cell[2558716, 45144, 62874, 1227, 626, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2621639, 46377, 90, 1, 108, "Chapter"],
Cell[2621732, 46380, 207, 3, 45, "Text"],
Cell[CellGroupData[{
Cell[2621964, 46387, 228, 4, 45, "Input"],
Cell[2622195, 46393, 121, 2, 45, "Output"]
}, Open  ]],
Cell[2622331, 46398, 263, 5, 45, "Text"],
Cell[2622597, 46405, 1164, 21, 162, "Input"],
Cell[CellGroupData[{
Cell[2623786, 46430, 265, 5, 45, "Input"],
Cell[2624054, 46437, 70, 1, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2624161, 46443, 3342, 83, 423, "Input"],
Cell[2627506, 46528, 54319, 1086, 939, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2681874, 47620, 99, 1, 162, "Chapter"],
Cell[CellGroupData[{
Cell[2681998, 47625, 295, 7, 67, "Input"],
Cell[2682296, 47634, 132754, 2547, 1855, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2815087, 50186, 195, 4, 100, "Input"],
Cell[2815285, 50192, 144, 2, 100, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

